# This software module was originally developed by
#
# Nokia
#
# in the course of development of ISO/IEC 23090-4 for reference purposes
# and its performance may not have been optimized. This software module
# is an implementation of one or more tools as specified by the ISO/IEC
# 23090-4 standard. ISO/IEC gives you a royalty-free, worldwide,
# non-exclusive, copyright license to copy, distribute, and make
# derivative works of this software module or modifications thereof for
# use in implementations or products claiming conformance to ISO/IEC
# standards incorporating ISO/IEC 23090-4 reference software and which
# satisfy any specified conformance criteria of that standard.
#
# Those intending to use this software module in products are advised that
# its use may infringe existing patents and that the license in the
# previous paragraph grants no licenses under such patents. ISO/IEC and
# the developers of this software module have no liability for use of this
# software module or modifications thereof.
#
# Copyright is not released for products that do not conform to an ISO/IEC
# standard.
#
# Nokia retains full right to modify and use the code for its own
# purpose, assign or donate the code to a third party without consent of
# and without accounting to third parties, and to inhibit third parties
# from using the code for products that do not conform to MPEG-related
# ISO/IEC International Standards.
#
# This copyright notice must be included in all copies or derivative
# works.
#
# Copyright (c) ISO/IEC 2024.

import bmcans

class RansEntropyCoder:
    """Proxy class to an actual entropy coder class.
    """
    def __init__(self):
        self.encoder = bmcans.BufferedRansEncoder()
        self.decoder = bmcans.RansDecoder()

    #################
    # encode  to stream
    #const std::vector<int32_t> &symbols, 
    #const std::vector<int32_t> &indexes,
    #const std::vector<std::vector<int32_t>> &cdfs,
    #const std::vector<int32_t> &cdfs_sizes,
    #const std::vector<int32_t> &offsets) {
 
    def encode_with_indexes(self, symbols, indexes, cdfs, cdf_sizes, offsets, oor_bypass=False):
        return self.encoder.encode_with_indexes(
          symbols, indexes, cdfs, cdf_sizes, offsets, oor_bypass)

    # return bytes
    def flush(self):
        return self.encoder.flush()

    #################
    # decode from a bitstream

    def set_stream(self, bitstream):
        return self.decoder.set_stream(bitstream)

    def decode_stream(self, indexes, cdfs, cdfs_sizes, offsets, oor_bypass=False):
        return self.decoder.decode_stream(indexes, cdfs, cdfs_sizes, offsets, oor_bypass)



