/***************************************************************************
This software module was originally developed by

Fraunhofer IIS

in the course of development of ISO/IEC 23090-4 for reference purposes and
its performance may not have been optimized.  This software module is an
implementation of one or more tools as specified by the ISO/IEC 23090-4
standard.  ISO/IEC gives you a royalty-free, worldwide, non-exclusive,
copyright license to copy, distribute, and make derivative works of this
software module or modifications thereof for use in implementations or
products claiming conformance to ISO/IEC standards incorporating ISO/IEC
23090-4 reference software and which satisfy any specified conformance
criteria of that standard.

Those intending to use this software module in products are advised that its
use may infringe existing patents and that the license in the previous
paragraph grants no licenses under such patents.  ISO/IEC and the developers
of this software module have no liability for use of this software module or
modifications thereof.

Copyright is not released for products that do not conform to an ISO/IEC
standard.

Fraunhofer IIS retains full right to
modify and use the code for its own purpose, assign or donate the code to
a third party without consent of and without accounting to third parties,
and to inhibit third parties from using the code for products that do not
conform to MPEG-related ISO/IEC International Standards.

This copyright notice must be included in all copies or derivative works.

Copyright (c) ISO/IEC 2022.
***************************************************************************/

#ifndef MPEGI_GEOMETRY_ENCODING_WRAPPER
#define MPEGI_GEOMETRY_ENCODING_WRAPPER

#ifdef _MSC_VER
#define EXPORT_PREFIX __declspec(dllexport)
#else
#define EXPORT_PREFIX
#endif

#ifdef __cplusplus
extern "C"
{
#endif

    EXPORT_PREFIX void* gewCreateInstance();

    EXPORT_PREFIX void gewAddVertexList(
        void* instance, int ver_count, float* x, float* y, float* z);

    EXPORT_PREFIX void gewAddTriangleList(void* instance, int tri_count, int* v1_index,
        int* v2_index, int* v3_index, int shr_mat_count, int* mat_index);

    EXPORT_PREFIX void gewAddAcousticMaterial(void* instance, int mat_count, int mat_index,
        int freq_count, float* freqs, float* c1, float* c2, float* c3, float* c4);

    EXPORT_PREFIX void gewSetEncoderOptions(void* instance, float quant_step, float vertex_tol,
        float triangle_tol, float mat_qnt_step, int tri_rm_nomat);

    EXPORT_PREFIX int gewGetRequiredBufferSize(void* instance);

    EXPORT_PREFIX int gewEncodeToBuffer(
        void* instance, int buffer_size, unsigned char* buffer_data);

    EXPORT_PREFIX void gewDestroyInstance(void* instance);

    EXPORT_PREFIX void gewEnableAutomatedTextDump(void* instance, char* file_prefix);

#ifdef __cplusplus
}
#endif

#endif /* MPEGI_GEOMETRY_ENCODING_WRAPPER */
