"""Efficient Directivity Coding."""
from typing import List

class Cover:
    """Frequency dependant covering on the surface of a unit sphere."""

    frequency: float
    gains: List[float]
    def __init__(self, *, freq: float, gains: List[float]) -> None:
        """Construct a cover.

        :param freq: The frequency that this cover coressponds to.
        :param gains: A list of coefficients in dB ranging between -128
            and 127. The list is flattened and should represent all
            points across the sphere.
        """
        ...

def encode(covers: List[Cover], *, deg_step: float, db_step: float) -> bytes:
    """Encode directivity data to bytes.

    :param covers: A list of Covers that consitute Directivity data to
        encode.
    :param deg_step: The spherical resolution in degrees, ranging
        between 2 and 90.
    :param db_step: The decibel resolution, ranging between 0.5 and 3.0.
    :return: The encoded directivity in bytes.
    """
    ...
