# This software module was originally developed by
#
# Koninklijke Philips N.V.
#
# in the course of development of ISO/IEC 23090-4 for reference purposes
# and its performance may not have been optimized. This software module
# is an implementation of one or more tools as specified by the ISO/IEC
# 23090-4 standard. ISO/IEC gives you a royalty-free, worldwide,
# non-exclusive, copyright license to copy, distribute, and make
# derivative works of this software module or modifications thereof for
# use in implementations or products claiming conformance to ISO/IEC
# standards incorporating ISO/IEC 23090-4 reference software and which
# satisfy any specified conformance criteria of that standard.
#
# Those intending to use this software module in products are advised that
# its use may infringe existing patents and that the license in the
# previous paragraph grants no licenses under such patents. ISO/IEC and
# the developers of this software module have no liability for use of this
# software module or modifications thereof.
#
# Copyright is not released for products that do not conform to an ISO/IEC
# standard.
#
# Koninklijke Philips N.V. retains full right to modify and use the code for its own
# purpose, assign or donate the code to a third party without consent of
# and without accounting to third parties, and to inhibit third parties
# from using the code for products that do not conform to MPEG-related
# ISO/IEC International Standards.
#
# This copyright notice must be included in all copies or derivative
# works.
#
# Copyright (c) ISO/IEC 2022.


# Script to generate the reverb test vectors needed by the renderer unit tests.
#
# Usage
# Either mofify lines 51 and 53 to point to your SceneAudioContent and renderer
# source code folders respectively, or call from the command line using
#     genAllTestBitstreams('/path/to/MPEG_repository/SceneAudioContent','path/to/base/renderer')
#
from genAirflowTestBitstreams import runEncoder as airflowEncoder
from genReverbTestBitstreams import runEncoder as reverbEncoder
import sys

if __name__ == "__main__":

    if len(sys.argv) == 1:
        # This should be where you have the MPEG SceneAudioContent repository checked out to
        srcBasePath = ""
        # this is the path to the renderer source code root directory.
        rendererBasePath = ""
    if len(sys.argv) >= 2:
        srcBasePath = sys.argv[1]
    if len(sys.argv) == 3:
        rendererBasePath = sys.argv[2]
    airflowEncoder(srcBasePath, rendererBasePath)
    reverbEncoder(srcBasePath, rendererBasePath)
