# This software module was originally developed by
#
# Fraunhofer IIS
#
# in the course of development of ISO/IEC 23090-4 for reference purposes
# and its performance may not have been optimized. This software module
# is an implementation of one or more tools as specified by the ISO/IEC
# 23090-4 standard. ISO/IEC gives you a royalty-free, worldwide,
# non-exclusive, copyright license to copy, distribute, and make
# derivative works of this software module or modifications thereof for
# use in implementations or products claiming conformance to ISO/IEC
# standards incorporating ISO/IEC 23090-4 reference software and which
# satisfy any specified conformance criteria of that standard.
#
# Those intending to use this software module in products are advised that
# its use may infringe existing patents and that the license in the
# previous paragraph grants no licenses under such patents. ISO/IEC and
# the developers of this software module have no liability for use of this
# software module or modifications thereof.
#
# Copyright is not released for products that do not conform to an ISO/IEC
# standard.
#
# Fraunhofer IIS retains full right to modify and use the code for its own
# purpose, assign or donate the code to a third party without consent of
# and without accounting to third parties, and to inhibit third parties
# from using the code for products that do not conform to MPEG-related
# ISO/IEC International Standards.
#
# This copyright notice must be included in all copies or derivative
# works.
#
# Copyright (c) ISO/IEC 2022.

"""Bitstream tokens to be used as part of a syntax.

These tokens are to be used with the bitstream composer. Simply
construct tokens and put them into a list and there you have your
bitstream syntax!
"""

from ._assign import Add as Add
from ._assign import Lookup as Lookup
from ._assign import Value as Value
from ._assign import Assign as Assign
from ._blob import Blob as Blob
from ._comment import Comment as Comment
from ._comment import NewLine as NewLine
from ._conditional import Conditional as Conditional
from ._cstring import CString as CString
from ._escaped_unsigned_integer import EscapedUnsignedInteger as EscapedUnsignedInteger
from ._flag import Flag as Flag
from ._floatpoint import Float32 as Float32
from ._function import Function as Function
from ._generator import TokenGenerator as TokenGenerator
from ._generic_codebook import CodebookConfig as CodebookConfig
from ._generic_codebook import CodebookSymbol as CodebookSymbol
from ._label import Label as Label
from ._markers import EndMarker as EndMarker
from ._markers import StartMarker as StartMarker
from ._packed_voxel_coord import PackedVoxelCoord as PackedVoxelCoord
from ._quantized_float import QuantizedFloat as QuantizedFloat
from ._repeat import Repeat as Repeat
from ._repeatWithIndex import repeatWithIndex as repeatWithIndex
from ._signed_integer import SignedInteger as SignedInteger
from ._switch import Switch as Switch
from ._switch import SwitchCase as SwitchCase
from ._token import CommentToken as CommentToken
from ._token import Token as Token
from ._unsigned_integer import UnsignedInteger as UnsignedInteger
from ._util import flatten_tokens as flatten_tokens
from ._util import readCodeword as readCodeWord
from ._while import While as While
from ._writeID import writeID as writeID
from ._writeCountOrIndex import writeCountOrIndex as writeCountOrIndex
from ._writeDuration import writeDuration as writeDuration
from ._writeFrequency import writeFrequency as writeFrequency
from ._writeDistance import writeDistance as writeDistance
from ._writeGain import writeGain as writeGain
from ._writePosition import writePosition as writePosition
from ._writeOrientation import writeOrientation as writeOrientation
from ._writeValueFromLUT import writeValueFromLUT as writeValueFromLUT
from ._writeTolerance import writeTolerance as writeTolerance
