# This software module was originally developed by
#
# Fraunhofer IIS
#
# in the course of development of ISO/IEC 23090-4 for reference purposes
# and its performance may not have been optimized. This software module
# is an implementation of one or more tools as specified by the ISO/IEC
# 23090-4 standard. ISO/IEC gives you a royalty-free, worldwide,
# non-exclusive, copyright license to copy, distribute, and make
# derivative works of this software module or modifications thereof for
# use in implementations or products claiming conformance to ISO/IEC
# standards incorporating ISO/IEC 23090-4 reference software and which
# satisfy any specified conformance criteria of that standard.
#
# Those intending to use this software module in products are advised that
# its use may infringe existing patents and that the license in the
# previous paragraph grants no licenses under such patents. ISO/IEC and
# the developers of this software module have no liability for use of this
# software module or modifications thereof.
#
# Copyright is not released for products that do not conform to an ISO/IEC
# standard.
#
# Fraunhofer IIS retains full right to modify and use the code for its own
# purpose, assign or donate the code to a third party without consent of
# and without accounting to third parties, and to inhibit third parties
# from using the code for products that do not conform to MPEG-related
# ISO/IEC International Standards.
#
# This copyright notice must be included in all copies or derivative
# works.
#
# Copyright (c) ISO/IEC 2022.
from .anchor import Anchor
from .channelsource import ChannelSource, Loudspeaker
from .conditions import ListenerProximityCondition
from .directivity import Directivity
from .environments import AcousticEnvironment, AcousticParameters
from .informedsource import InformedSource
from .hoasource import HoaGroup, HoaSource
from .material import Material
from .mesh import Mesh, MeshFace
from .objectsource import ObjectSource, InputLayout
from .portal import Portal
from .primitives import Box, Sphere, Cylinder
from .scene import AudioScene
from .stream import AudioStream
from .transform import Transform
from .update import Update, Modification
from .acoustTuningParameters import AcousticTuningParameters
from .airflowsource import AirflowSource
from .airflowgenerator import AirflowGenerator
from .headphoneEQ import HeadphoneEQ
from .granularsound import GranularSound
