# This software module was originally developed by
#
# Nokia
#
# in the course of development of ISO/IEC 23090-4 for reference purposes
# and its performance may not have been optimized. This software module
# is an implementation of one or more tools as specified by the ISO/IEC
# 23090-4 standard. ISO/IEC gives you a royalty-free, worldwide,
# non-exclusive, copyright license to copy, distribute, and make
# derivative works of this software module or modifications thereof for
# use in implementations or products claiming conformance to ISO/IEC
# standards incorporating ISO/IEC 23090-4 reference software and which
# satisfy any specified conformance criteria of that standard.
#
# Those intending to use this software module in products are advised that
# its use may infringe existing patents and that the license in the
# previous paragraph grants no licenses under such patents. ISO/IEC and
# the developers of this software module have no liability for use of this
# software module or modifications thereof.
#
# Copyright is not released for products that do not conform to an ISO/IEC
# standard.
#
# Nokia retains full right to modify and use the code for its own
# purpose, assign or donate the code to a third party without consent of
# and without accounting to third parties, and to inhibit third parties
# from using the code for products that do not conform to MPEG-related
# ISO/IEC International Standards.
#
# This copyright notice must be included in all copies or derivative
# works.
#
# Copyright (c) ISO/IEC 2022.
# All reverb related constants are here

default_reverb_minimum_distance = 1.0
default_ae_default_gain = 0.5
default_fade_in_distance = 0.1
default_fade_in_distance_fallback_mode = 1.0
default_reverb_distance_gain_drop_db = 1.5
default_fade_in_enabled = True
default_headtracking_enabled = False

default_ae_distance_gain_drop_db = 4.0
default_ae_minimum_distance = 1.0
default_ae_delay_density = 1.5
default_ae_delay_delayMinMs = 38.19
default_use_long_range_mode = False
default_is_small_scene = True
default_is_hi_prec_gain = True
default_ar_config_present = True

default_multi_room_control_present = True

# lsdf related constants
lsdf_speed_of_sound = 343.0
lsdf_override_lsdf_ddr = True
lsdf_theoretical_rdr_to_actual_rdr = -11.0
lsdf_rdr_to_actual_rdr = -4.0
lsdf_rdr_to_ddr_db = -41


debug_enable_visualization = False  # Enable to import matplotlib visual debug plotting

# Defines los check tolerance for distance from hit point to target vertex when to conclude a hit
los_check_dist_atol = 0.05

# Defines the percentage of how many rays passed is needed to conclude a los to target vertices from a point (0.5 = 50% of the rays)
pla_los_ratio_threshold = 0.5

# Defines percentage of how many vertices of a mesh needs to be inside an AE to consider it to be inside it
pla_ae_mesh_inside_percentage = 50

pla_los_area_grid_height_m = 2

# Defines los grid extension in x, z plane around ae which has portal(s) outside
pla_outside_los_area_extension = 10

pla_los_area_voxel_side_cm = 25
pla_outside_los_area_voxel_side_cm = 50
