# MPEG-I Renderer Command Line Interface

For build instructions see `README.md` in the root directory.


## Using the binary

The built binary can be found in the `apps/cli` directory in the build folder.
You can call the binary from the command line with the following parameters,
where everything in brackets is optional:

```
renderer-cli -scene /path/to/eif.xml -out output.wav [-sofa /path/to/custom/hrirs.sofa] [-traj /path/to/recorded/osc_from_unity.osc] [-runtime 30] [-conf /path/to/config.conf] [-lst-pos 0 1.5 -1 90 0 -12] [-ir-src-pos 2 -4.4 23.12 0 0 0]
```

If `-runtime` is not given, it renders until all AudioStreams are played exactly once.

OSC messages from a OSC recording are executed before the next audio block
after their arrival time (this might differ slightly from the real-time behavior).

If `-ir-src-pos` is given, the CLI generates a binaural room impulse response
with emitter and listener (`-lst-pos`) at the given positions
and saves it in the output wav file.
All other audio sources in the scene EIF are disabled.
The positions are parsed as `x y z yaw pitch roll`.
Trajectories and runtimes should not be used together with the IR generator,
but HRIRs and Configs (e.g. to control the amount of late reverb)
are loaded like in normal mode.
