# Max/MSP External for the MPEG-I renderer

## Setup in Max/MSP

The first and only argument of the Object configures the number of audio inputs
(signal inlets) into the renderer.

You can send Max/MSP messages to any inlet,
whereas the order of the audio signal inlets define the aepInputChannel connected to that signal.

Binaural output can be read from the two signal outlets.
The message outlet provides status messages.


### Supported messages

The following input messages are supported:

<table>
	<th>Name</th><th>Purpose</th><th>Arguments</th><th>Used in the AEP?</th></tr>
	<tr>
		<td><strong>loadScene</strong></td>
		<td>Load a new scene (currently looks for the EIF file with the “.xml” extension in the same folder where the Max External is stored)</td>
		<td>1. string: scene name</td>
		<td>Yes</td>
	</tr>
	<tr>
		<td><strong>setMaxDelay</strong></td>
		<td>Informs the renderer about the maximum delay, currently a noop</td>
		<td>1. int: delay in samples</td>
		<td>Yes</td>
	</tr>
	<tr>
		<td><strong>triggerUpdate</strong></td>
		<td>Triggers a predefined EIF update by its integer index</td>
		<td>1. int: update index like in EIF<br>2.-22. float: optional values for placeholders (e.g. argument 2 corresponds to EIF placeholder $0)</td>
		<td>Yes</td>
	</tr>
	<tr>
		<td><strong>triggerUpdateString</strong></td>
		<td>Triggers a predefined EIF update by its string ID</td>
		<td>1. string: update ID like in EIF<br>2.-22. float: optional values for placeholders (e.g. argument 2 corresponds to EIF placeholder $0)</td>
		<td>No</td>
	</tr>
	<tr>
		<td><strong>loadHRIRSet</strong></td>
		<td>Load a new HRIR set</td>
		<td>1. string: absolute path to SOFA file</td>
		<td>No</td>
	</tr>
	<tr>
		<td><strong>userPose</strong></td>
		<td>Sets the complete listener position (in right-handed OpenGL coordinates)</td>
		<td>1. float: x [m] in WCS  (virtual world coords)<br>2. float: y [m] in WCS<br>3. float: z [m] in WCS<br>4. float: yaw [°] in WCS<br>5. float: pitch [°] in WCS<br>6. float: roll [°] in WCS<br>7. float: x [m] in RCS  (real world coords)<br>8. float: y [m] in RCS<br>9. float: z [m] in RCS<br>10. float: yaw [°] in RCS<br>11. float: pitch [°] in RCS<br>12. float: roll [°] in RCS<br>13. int: teleport (1 = true) </td>
		<td>Yes</td>
	</tr>
	<tr>
		<td><strong>position</strong></td>
		<td>Sets the position of an entity in the scene (in right-handed OpenGL coordinates). The special ID "listener" changes the listener position (same functionality as userPose above)</td>
		<td>1. string: ID like in EIF<br>2. float: x [m]<br>3. float: y [m]<br>4. float: z [m]<br>5. int: teleport (1 = true)</td>
		<td>No</td>
	</tr>
	<tr>
		<td><strong>orientation</strong></td>
		<td>Sets the orientation of an entity in the scene (in right-handed OpenGL coordinates). The special ID "listener" changes the listener position (same functionality as userPose above)</td>
		<td>1. string: ID like in EIF<br>2. float: yaw [°]<br>3. float: pitch [°]<br>4. float: roll [°] </td>
		<td>No</td>
	</tr>
	<tr>
		<td><strong>gain</strong></td>
		<td>Sets the gain of an entity in the scene</td>
		<td>1. string: ID like in EIF<br>2. float: gain [dB]</td>
		<td>No</td>
	</tr>
</table>
