#pragma once
//--------------------------------------------------------------------------------------------------
namespace c74 { namespace max {
#ifdef __cplusplus
    extern "C" {
#endif
      	void* outlet_int(void*, long long);
#ifdef __cplusplus
    }
#endif
} }
//--------------------------------------------------------------------------------------------------
template<
    typename T,
    template<typename> class Detail
    >
class notify
{
protected:
    Detail<T> _detail { };
    T _threshold;

public:
    template<typename... Args>
    notify(T threshold, Args&&... args)
        : _detail(std::forward<Args>(args)...)
        , _threshold(threshold)
    {
    }

    void operator()(T avg)
    {
        _detail(avg);
    }

    T get_threshold() const { return _threshold; }
};

template<typename T>
struct maxmsp
{
    maxmsp(void *outlet) : _outlet(outlet) { }
    void operator()(T avg)
    {
        c74::max::outlet_int(_outlet, avg.count());
    }

protected:
    void *_outlet;
};

template<typename T>
using notify_maxmsp = notify<T, maxmsp>;
