
# - Find FFTW
# Find the native FFTW includes and library
#
#  FFTW_INCLUDES    - where to find fftw3.h
#  FFTW_LIBRARIES   - List of libraries when using FFTW.
#  FFTW_FOUND       - True if FFTW found.

if (FFTW_INCLUDES)
  # Already in cache, be silent
  set (FFTW_FIND_QUIETLY TRUE)
endif (FFTW_INCLUDES)

# also look in FFTW_PATH if it's provided
if (FFTW_PATH)
	find_path (FFTW_INCLUDES fftw3.h PATHS ${FFTW_PATH})
	find_library (FFTW_LIBRARIES NAMES "fftw3f" "libfftw3f-3" PATHS ${FFTW_PATH})
else (FFTW_PATH)
	find_path (FFTW_INCLUDES fftw3.h)
	find_library (FFTW_LIBRARIES NAMES "fftw3f" "libfftw3f-3")
endif (FFTW_PATH)

# handle the QUIETLY and REQUIRED arguments and set FFTW_FOUND to TRUE if
# all listed variables are TRUE
include (FindPackageHandleStandardArgs)
find_package_handle_standard_args (FFTW DEFAULT_MSG FFTW_LIBRARIES FFTW_INCLUDES)

mark_as_advanced (FFTW_LIBRARIES FFTW_INCLUDES)