if (MKL_INCLUDE_DIRS AND MKL_LIBRARIES)
  set (MKL_FIND_QUIETLY TRUE)
endif()

if(WIN32)
    set(ProgramFilesx86 "ProgramFiles(x86)")
    set(INTEL_MKL_ROOT_PATHS
        ${INTEL_MKL_ROOT}
        $ENV{${ProgramFilesx86}}/IntelSWTools/compilers_and_libraries/windows/mkl
        $ENV{${ProgramFilesx86}}/Intel/oneAPI/mkl/latest
        )
    find_path(MKL_ROOT include/mkl.h PATHS ${INTEL_MKL_ROOT_PATHS})
    find_path(MKL_INCLUDE_DIR
              NAMES mkl.h
              HINTS ${MKL_ROOT}/include
              PATH_SUFFIXES mkl)
    find_library(MKL_INTEL_LP64_LIBRARY
                 NAMES "mkl_intel_lp64.lib"
                 PATHS ${MKL_ROOT}/lib
                       ${MKL_ROOT}/lib/intel64
                       ${MKL_ROOT}/lib/intel64_win)
    find_library(MKL_SEQUENTIAL_LIBRARY
                 NAMES "mkl_sequential.lib"
                 PATHS ${MKL_ROOT}/lib
                       ${MKL_ROOT}/lib/intel64
                       ${MKL_ROOT}/lib/intel64_win)
    find_library(MKL_CORE_LIBRARY
                 NAMES "mkl_core.lib"
                 PATHS ${MKL_ROOT}/lib
                       ${MKL_ROOT}/lib/intel64
                       ${MKL_ROOT}/lib/intel64_win)
    set(MKL_LIBRARIES ${MKL_INTEL_LP64_LIBRARY} ${MKL_SEQUENTIAL_LIBRARY} ${MKL_CORE_LIBRARY})
else()
    find_path(MKL_INCLUDE_DIR NAMES mkl.h PATHS $ENV{MKL_ROOT}/include PATH_SUFFIXES mkl)
    find_library(MKL_SINGLE_DYNAMIC_LIBRARY NAMES "mkl_rt" PATHS $ENV{MKL_ROOT}/lib/intel64)
    set(MKL_LIBRARIES ${MKL_SINGLE_DYNAMIC_LIBRARY})
endif()

if (MKL_INCLUDE_DIR AND MKL_LIBRARIES)
    set(MKL_INCLUDE_DIRS ${MKL_INCLUDE_DIR})
else()
    set(MKL_INCLUDE_DIRS "")
    set(MKL_LIBRARIES "")
endif()

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(MKL DEFAULT_MSG MKL_LIBRARIES MKL_INCLUDE_DIRS)

MARK_AS_ADVANCED(MKL_INCLUDE_DIRS MKL_LIBRARIES)
