if(APPLE)
    if(NETCDF_USE_STATIC_LIBRARIES)
        set(HDF5_USE_STATIC_LIBRARIES TRUE CACHE BOOL "HDF5 statically linked")
        set(CURL_USE_STATIC_LIBS TRUE CACHE BOOL "CURL statically linked")
        list(PREPEND CMAKE_FIND_LIBRARY_SUFFIXES ".a")
    endif()

    find_package(HDF5 REQUIRED COMPONENTS C HL)
    find_package(CURL REQUIRED COMPONENTS HTTP)
    find_package(LibXml2 REQUIRED)

    set(NETCDF_ROOT_DIR ${CMAKE_PREFIX_PATH} CACHE PATH "NetCDF root directory")
    find_path(NETCDF_INCLUDE_DIR NAMES "netcdf.h" PATHS ${NETCDF_ROOT_DIR} REQUIRED)
    find_library(NETCDF_LIBRARY NAMES "netcdf" REQUIRED)
    cmake_path(GET NETCDF_LIBRARY PARENT_PATH NETCDF_LIBRARY_DIR)
    find_file(NETCDF_SETTINGS_FILEPATH "libnetcdf.settings" PATHS ${NETCDF_LIBRARY_DIR} NO_CACHE REQUIRED)
    unset(NETCDF_LIBRARY_DIR)
    file(READ ${NETCDF_SETTINGS_FILEPATH} NETCDF_SETTINGS_STRING)
    unset(NETCDF_SETTINGS_FILEPATH)
    string(REGEX MATCH "NetCDF Version:[\t ]*([0-9\.]+)" NETCDF_VERSION_STRING ${NETCDF_SETTINGS_STRING})
    unset(NETCDF_SETTINGS_STRING)
    string(REGEX REPLACE "NetCDF Version:[\t ]*([0-9\.]+)" "\\1" NETCDF_VERSION_STRING ${NETCDF_VERSION_STRING})
    set(NETCDF_VERSION ${NETCDF_VERSION_STRING} CACHE STRING "NetCDF version")
    unset(NETCDF_VERSION_STRING)
    mark_as_advanced(NETCDF_LIBRARY NETCDF_INCLUDE_DIR NETCDF_VERSION)

    include(FindPackageHandleStandardArgs)
    find_package_handle_standard_args(NetCDF
        REQUIRED_VARS NETCDF_LIBRARY NETCDF_INCLUDE_DIR
        VERSION_VAR NETCDF_VERSION
    )

    add_library(NetCDF::NetCDF STATIC IMPORTED)
    set_target_properties(NetCDF::NetCDF PROPERTIES
        IMPORTED_LINK_INTERFACE_LANGUAGES C
        IMPORTED_LOCATION ${NETCDF_LIBRARY}
        INTERFACE_LINK_LIBRARIES "HDF5::HDF5;hdf5::hdf5_hl;CURL::libcurl;LibXml2::LibXml2"
        INTERFACE_SYSTEM_INCLUDE_DIRECTORIES ${NETCDF_INCLUDE_DIR}
        VERSION ${NETCDF_VERSION}
    )
endif()
