# http://blog.audio-tk.com/2015/09/01/sorting-source-files-and-projects-in-folders-with-cmake-and-visual-studioxcode/
function(SourceGroupByFolder target)
  set(last_dir "")
  set(files "")
  # Accessing the SOURCES property is not allowed on interface libraries:
  get_target_property(library_type ${target} TYPE)
  if (library_type STREQUAL "INTERFACE_LIBRARY")
    get_target_property(sources ${target} INTERFACE_SOURCES)
  else()
    get_target_property(sources ${target} SOURCES)
  endif()
  foreach(file ${sources})
    if(IS_ABSOLUTE "${file}")
        file(RELATIVE_PATH relative_file "${CMAKE_CURRENT_SOURCE_DIR}" ${file})
    else()
        set(relative_file "${file}")
    endif()
    get_filename_component(dir "${relative_file}" PATH)
    if(NOT "${dir}" STREQUAL "${last_dir}")
      if(files)
        source_group("${last_dir}" FILES ${files})
      endif()
      set(files "")
    endif()
    set(files ${files} "${file}")
    set(last_dir "${dir}")
  endforeach()
  if(files)
    source_group("${last_dir}" FILES ${files})
  endif()
endfunction()

