include (CheckCCompilerFlag)

# checks for SIMD instruction set availability
# currently, only the ones with special memory alignment requirements are checked 

foreach (FLAG "-mavx" "/arch:AVX")
  unset (SIMD_AVX CACHE)
  check_c_compiler_flag (${FLAG} SIMD_AVX)
  if (SIMD_AVX)
    break()
  endif ()
endforeach ()

foreach (FLAG "-mavx2" "/arch:AVX2")
  unset (SIMD_AVX2 CACHE)
  check_c_compiler_flag (${FLAG} SIMD_AVX2)
  if (SIMD_AVX2)
    break()
  endif ()
endforeach ()

unset (SIMD_KCVI CACHE)
check_c_compiler_flag ("-march=knl" SIMD_KCVI)

foreach (FLAG "-march=skylake-avx512" "/arch:AVX512")
  unset (SIMD_AVX512 CACHE)
  check_c_compiler_flag (${FLAG} SIMD_AVX512)
  if (SIMD_AVX512)
    break()
  endif ()
endforeach ()
