/***************************************************************************
This software module was originally developed by

Nokia Technologies Ltd.

in the course of development of ISO/IEC 23090-4 for reference purposes and
its performance may not have been optimized.  This software module is an
implementation of one or more tools as specified by the ISO/IEC 23090-4
standard.  ISO/IEC gives you a royalty-free, worldwide, non-exclusive,
copyright license to copy, distribute, and make derivative works of this
software module or modifications thereof for use in implementations or
products claiming conformance to ISO/IEC standards incorporating ISO/IEC
23090-4 reference software and which satisfy any specified conformance
criteria of that standard.

Those intending to use this software module in products are advised that its
use may infringe existing patents and that the license in the previous
paragraph grants no licenses under such patents.  ISO/IEC and the developers
of this software module have no liability for use of this software module or
modifications thereof.

Copyright is not released for products that do not conform to an ISO/IEC
standard.

Nokia Technologies Ltd. retains full right to
modify and use the code for its own purpose, assign or donate the code to
a third party without consent of and without accounting to third parties,
and to inhibit third parties from using the code for products that do not
conform to MPEG-related ISO/IEC International Standards.

This copyright notice must be included in all copies or derivative works.

Copyright (c) ISO/IEC 2022.
***************************************************************************/

#ifndef MPEGI_REVERB_CONSTANTS
#define MPEGI_REVERB_CONSTANTS

namespace MPEGI {

static const float DEFAULT_REVERB_FADE_IN_DISTANCE{ 0.1f };
static const float DEFAULT_REVERB_EIF_PREDELAY_FACTOR{ 4.0f };
static const float DEFAULT_REVERB_AR_PREDELAY_FACTOR{ 1.0f };
static const float DEFAULT_REVERB_PREDELAY_OFFSET{ 0.0f };
// Distance doubling reduces reverb level by distanceGainDropDb.
// In a default acoustic environment the value is separate from other AEs.
static const float DEFAULT_REVERB_DISTANCE_GAIN_DROP_DB{ 1.5f };
static const float DEFAULT_REVERB_MINIMUM_DISTANCE{ 1.0f };
static const float DEFAULT_REVERB_GAIN{ 1.0f };

static const float DEFAULT_REVERB_GAIN_IN_DEFAULT_AE{ 1.0f };
static const float DEFAULT_REVERB_PREDELAY_FACTOR_IN_DEFAULT_AE{ 1.0f };
static const float DEFAULT_REVERB_DELAY_RATIO_IN_DEFAULT_AE{ 8.78f };
static const float DEFAULT_REVERB_DELAY_MINIMUM_MS_IN_DEFAULT_AE{ 38.19f };
static const float DEFAULT_REVERB_DISTANCE_GAIN_DROP_DB_IN_DEFAULT_AE{ 6.0f };
static const float DEFAULT_REVERB_MINIMUM_DISTANCE_IN_DEFAULT_AE{ 5.0f };

static const float DEFAULT_REVERB_SPEED_OF_SOUND{ 343.0f };
static const float DEFAULT_REVERB_RDR_THEORETICAL_TO_RDR_ACTUAL{ -8.0f };
static const float DEFAULT_REVERB_RDR_LSDF_TO_RDR_ACTUAL{ -8.0f };
static const bool DEFAULT_REVERB_LSDF_RDR_OVERRIDE{ false };

static const int MAX_NUM_BOUNDED_AES_BEFORE_DROPPING_DEFAULT{ 3 };

static const int ACOUSTIC_ENVIRONMENT_BITSTREAM_ID_UNDEFINED{ -1 };
// Threshold above which distance gain changes are smoothed
static const float DISTANCE_GAIN_SMOOTHING_THRESHOLD{ 0.25f };

static const unsigned REVERB_DEFAULT_NUMBER_OF_DELAY_LINE_LOOPS{ 15 };
static const unsigned REVERB_MIN_NUMBER_OF_LOUDSPEAKERS{ 15 };

// Duration for second order reverb to come into full effect
static const float SECOND_ORDER_REVERB_FADE_SECONDS{ 1.f };

// Threshold to enable unrestricted second order reverb.
static const int SECOND_ORDER_REVERB_DELAY_LINES{ 15 };

static const float SOR_FILTER_B[] = { 0.9728, -1.9276, 0.9549 }; // 24dB100Hz
static const float SOR_FILTER_A[] = { 1.0000, -1.9263, 0.9290 }; // 24dB100Hz
static const float DEFAULT_REVERB_SOR_GAIN = 0.5f;
static const float DEFAULT_REVERB_NO_LOS_COEFF = 0.1f;

static const bool DEFAULT_REVERB_SOR_UNRESTRICTED = false;

} // namespace MPEGI

#endif
