/***************************************************************************
This software module was originally developed by

Koninklijke Philips N.V.

in the course of development of ISO/IEC 23090-4 for reference purposes and
its performance may not have been optimized.  This software module is an
implementation of one or more tools as specified by the ISO/IEC 23090-4
standard.  ISO/IEC gives you a royalty-free, worldwide, non-exclusive,
copyright license to copy, distribute, and make derivative works of this
software module or modifications thereof for use in implementations or
products claiming conformance to ISO/IEC standards incorporating ISO/IEC
23090-4 reference software and which satisfy any specified conformance
criteria of that standard.

Those intending to use this software module in products are advised that its
use may infringe existing patents and that the license in the previous
paragraph grants no licenses under such patents.  ISO/IEC and the developers
of this software module have no liability for use of this software module or
modifications thereof.

Copyright is not released for products that do not conform to an ISO/IEC
standard.

Koninklijke Philips N.V. retains full right to
modify and use the code for its own purpose, assign or donate the code to
a third party without consent of and without accounting to third parties,
and to inhibit third parties from using the code for products that do not
conform to MPEG-related ISO/IEC International Standards.

This copyright notice must be included in all copies or derivative works.

Copyright (c) ISO/IEC 2022.
***************************************************************************/

#pragma once

#include <EAR/BaseTypes.h>
#include <array>
#include <memory>
#include <optional>
#include <utility>
#include <vector>

namespace MPEGI {

template <typename T> using VecSharedPtr = std::vector<std::shared_ptr<T>>;

struct ReverbParameters
{
    ReverbParameters(unsigned int _id, unsigned int _freqGridIdx, float _parOffset,
        unsigned int _delayLineCount, std::vector<float>& _t60, std::vector<float>& _dsr)
        : id(_id)
        , freqGridIdx(_freqGridIdx)
        , parOffset(_parOffset)
        , delayLineCount(_delayLineCount)
        , t60(_t60)
        , dsr(_dsr)
    {}

    const unsigned int id;
    const unsigned int freqGridIdx;
    const float parOffset;
    const unsigned int delayLineCount;
    const std::vector<float> t60;
    const std::vector<float> dsr;
};

} // namespace MPEGI