This page contains the rendered in-code documentation of the MPEG-I Renderer.


### Renderer Stages

The source code for the renderer stages can be found in `stages`.

When the renderer is started,
the active stages (and their order!) are selected
with the `RenderStages` configuration value.

A typical renderer pipeline could look something like this:

[Room Assignment](@ref MPEGI::RoomAssignmentStage) 
→ [Reverb](@ref MPEGI::ReverbStage)
→ [Portals](@ref MPEGI::PortalStage)
→ [Early Reflections](@ref MPEGI::EarlyReflectionStage)
→ [Discover SESS](@ref MPEGI::DiscoverSessStage)
→ [Occlusion](@ref MPEGI::OcclusionStage)
→ [Diffraction](@ref MPEGI::DiffractionStage)
→ [Simple Culling](@ref MPEGI::SimpleCullingStage)
→ [Heterogeneous Extent](@ref MPEGI::HeterogeneousStage)
→ [Directivity](@ref MPEGI::DirectivityStage)
→ [Distance](@ref MPEGI::DistanceStage)
→ [EQ](@ref MPEGI::EqStage)
→ [Fade](@ref MPEGI::FadeStage)
→ [Single-Point HOA](@ref MPEGI::SphoaStage)
→ [Homogeneous Extent](@ref MPEGI::HomogeneousExtentStage)
→ [Panner](@ref MPEGI::PannerStage)
→ [Multi-Point HOA](@ref MPEGI::MphoaStage)
→ [Binaural Spatializer](@ref MPEGI::BinauralSpatializer)

There are two alternative stages for early reflections:
[EarlyReflectionStage](@ref MPEGI::EarlyReflectionStage) and
[LCEarlyReflectionStage](@ref MPEGI::LCEarlyReflectionStage).

The [SimpleCullingStage](@ref MPEGI::SimpleCullingStage)
could be used in different positions in the pipeline.
