import mcode


def test_encode_mesh() -> None:
    """Basic integration test for mesh coding."""
    v1 = mcode.mesh.Vertex(x=0.0, y=0.0, z=0.0)
    v2 = mcode.mesh.Vertex(x=0.0, y=1.0, z=0.0)
    v3 = mcode.mesh.Vertex(x=1.0, y=0.0, z=0.0)
    face = mcode.mesh.Face(mat_idx=None, v1=0, v2=1, v3=2)

    m = mcode.mesh.Mesh(vertices=[v1, v2, v3], faces=[face])

    blob = mcode.mesh.encode(
        m,
        vertex_qnt_step=0.001,
        vertex_tolerance=0.0,
        face_tolerance=0.0,
        remove_faces_without_mats=False,
    )

    assert len(blob) != 0
    assert isinstance(blob, bytes)
