#!/bin/bash

set -e

if [ -z "$1" ]; then
    findPaths=(".")
else
    findPaths=(${1//;/ })
fi

for p in ${findPaths[@]}; do
    cd $p
    files=$(find . -regextype posix-egrep -regex '.*\.(c|cpp|h|hpp)$' |
        grep -v \
            -e '/external/' \
            -e '/vendor/' \
            -e '/lsdf-parser/' \
            -e '/spatializers/LoudspeakerSpatializer/trol/' \
            -e 'fabian_fixdef.h' \
            -e 'apps/max-external/src/detector' \
            -e 'sadie_ku100_fixdef.h' \
            -e '/build.*/'
    )

    for f in $files; do
        if [ "$2" == "fix" ]; then
            echo "checking (fix) $p/$f"
            clang-format-11 -style=file -i $f
        else
            echo "checking $p/$f"
            diff $f <(clang-format-11 -style=file $f)
        fi
    done

    cd - >/dev/null
done
