/***************************************************************************
This software module was originally developed by

Nokia Technologies Ltd.

in the course of development of ISO/IEC 23090-4 for reference purposes and
its performance may not have been optimized.  This software module is an
implementation of one or more tools as specified by the ISO/IEC 23090-4
standard.  ISO/IEC gives you a royalty-free, worldwide, non-exclusive,
copyright license to copy, distribute, and make derivative works of this
software module or modifications thereof for use in implementations or
products claiming conformance to ISO/IEC standards incorporating ISO/IEC
23090-4 reference software and which satisfy any specified conformance
criteria of that standard.

Those intending to use this software module in products are advised that its
use may infringe existing patents and that the license in the previous
paragraph grants no licenses under such patents.  ISO/IEC and the developers
of this software module have no liability for use of this software module or
modifications thereof.

Copyright is not released for products that do not conform to an ISO/IEC
standard.

Nokia Technologies Ltd. retains full right to
modify and use the code for its own purpose, assign or donate the code to
a third party without consent of and without accounting to third parties,
and to inhibit third parties from using the code for products that do not
conform to MPEG-related ISO/IEC International Standards.

This copyright notice must be included in all copies or derivative works.

Copyright (c) ISO/IEC 2022.
***************************************************************************/

#ifndef MPEGI_RENDERSTAGES_MPHOASTAGE_HPP
#define MPEGI_RENDERSTAGES_MPHOASTAGE_HPP

#include "MPEGI/Renderer/MphoaBaseStage.h"

#include <mpegcore/EsdConverter.hpp>

namespace EAR {

class HOASource;
class Listener;

} // namespace EAR

namespace MPEGI {

//class MphoaPayload;
//class StreamBuffer;

//! ...
/*! 
 * Inputs: 
 * - 
 *  
 * Outputs: 
 * - 
 *  
 * How it works: 
 * - 
 * 
 * Stages order:
 * - Required before: ?
 * - Required after: ?
 *  
 * Config options: 
 * -
 * 
 */
class MphoaStage : public MphoaBaseStage
{
public:
    MphoaStage();
    ~MphoaStage();

    std::unique_ptr<RenderStage::DspData> update(RenderList& renderList) override;
    void processBlock(DspContext ctx) override;

private:
    void initializeStageAdditional(const Bitstream& bitstream, RenderItemStore* itemStore,
        const StreamManager* streamManager, const SceneState* state, size_t translatorCount,
        const std::vector<size_t>& groupSourceCounts);

    void initializeEsdConversion(std::vector<std::unique_ptr<EAR::HOASource>> const& hoaSources,
        StreamManager const& streamManager, SceneState const& state);

    void feedInputToHoaTranslator(mpegcore::HoaTranslator& hoaTranslator,
        std::vector<std::shared_ptr<MPEGI::StreamBuffer>> const& inputBuffers);

    mpegcore::EsdConverter esdConverter;
};

} // namespace MPEGI

#endif // MPEGI_RENDERSTAGES_MPHOASTAGE_HPP
