# subroutines 

This directory contains a set of data structures and algorithms that are essential for the core functionality of MPEG-I Renderer.

## Algorithms

Implementations of algorithms that are essential to MPEG-I Renderer are included:

* vector base amplitude panning
* late reverberation
* higher-order ambisonics rendering
* SOFA file decoding
* prime number generation
* graphic equalizer filtering

## Data structures

General data structures for audio processing in MPEG-I Renderer are included:

* audio buffer
* ring buffer
* delay line

## Building

The contents of this directory are not intended to be built as a library of their own, instead they are intended to be included as a CMake subdirectory. Refer to the README.md of MPEG-I Renderer for build requirements. The contained data structures and algorithms are included as a subdirectory of MPEG-I Renderer for the purpose of code reusability.

