/***************************************************************************
This software module was originally developed by

Nokia Technologies Ltd.

in the course of development of ISO/IEC 23090-4 for reference purposes and
its performance may not have been optimized.  This software module is an
implementation of one or more tools as specified by the ISO/IEC 23090-4
standard.  ISO/IEC gives you a royalty-free, worldwide, non-exclusive,
copyright license to copy, distribute, and make derivative works of this
software module or modifications thereof for use in implementations or
products claiming conformance to ISO/IEC standards incorporating ISO/IEC
23090-4 reference software and which satisfy any specified conformance
criteria of that standard.

Those intending to use this software module in products are advised that its
use may infringe existing patents and that the license in the previous
paragraph grants no licenses under such patents.  ISO/IEC and the developers
of this software module have no liability for use of this software module or
modifications thereof.

Copyright is not released for products that do not conform to an ISO/IEC
standard.

Nokia Technologies Ltd. retains full right to
modify and use the code for its own purpose, assign or donate the code to
a third party without consent of and without accounting to third parties,
and to inhibit third parties from using the code for products that do not
conform to MPEG-related ISO/IEC International Standards.

This copyright notice must be included in all copies or derivative works.

Copyright (c) ISO/IEC 2022.
***************************************************************************/

#ifndef MPEGCORE_FRONTEND_DELAYLINE_HPP
#define MPEGCORE_FRONTEND_DELAYLINE_HPP

#include <cstddef>
#include <vector>

namespace mpegcore {
namespace frontend {

class DelayLine
{
public:
    DelayLine() = default;
    DelayLine(std::size_t size, std::size_t delay);

    float getDelayedSample(float newSample) noexcept;
    void setDelay(std::size_t delay) noexcept;

private:
    std::vector<float> m_data;
    std::size_t m_dataIndex{ 0 };
    std::size_t m_delayedDataIndex{ 0 };
};

} // namespace frontend
} // namespace mpegcore

#endif // MPEGCORE_FRONTEND_DELAYLINE_HPP
