/***************************************************************************
This software module was originally developed by

Nokia Technologies Ltd.

in the course of development of ISO/IEC 23090-4 for reference purposes and
its performance may not have been optimized.  This software module is an
implementation of one or more tools as specified by the ISO/IEC 23090-4
standard.  ISO/IEC gives you a royalty-free, worldwide, non-exclusive,
copyright license to copy, distribute, and make derivative works of this
software module or modifications thereof for use in implementations or
products claiming conformance to ISO/IEC standards incorporating ISO/IEC
23090-4 reference software and which satisfy any specified conformance
criteria of that standard.

Those intending to use this software module in products are advised that its
use may infringe existing patents and that the license in the previous
paragraph grants no licenses under such patents.  ISO/IEC and the developers
of this software module have no liability for use of this software module or
modifications thereof.

Copyright is not released for products that do not conform to an ISO/IEC
standard.

Nokia Technologies Ltd. retains full right to
modify and use the code for its own purpose, assign or donate the code to
a third party without consent of and without accounting to third parties,
and to inhibit third parties from using the code for products that do not
conform to MPEG-related ISO/IEC International Standards.

This copyright notice must be included in all copies or derivative works.

Copyright (c) ISO/IEC 2022.
***************************************************************************/

#ifndef MPEGCORE_DECMTX_H

#define MPEGCORE_DECMTX_H

#include <../src/ambi_bin/ambi_bin_internal.h>

static const unsigned int DECMTX_FIRST[HYBRID_BANDS * NUM_EARS * (SH_ORDER_FIRST + 1)
    * (SH_ORDER_FIRST + 1)][2] = { { 0x3f8b6da6, 0x00000000 }, { 0x3c9bc563, 0x00000000 },
    { 0x3b9a42af, 0x00000000 }, { 0x3abf25ad, 0x00000000 }, { 0x3f8b04e8, 0x00000000 },
    { 0xbd3652f2, 0x00000000 }, { 0x3baf6119, 0x00000000 }, { 0x3b857821, 0x00000000 },
    { 0x3f88f7e7, 0xbb8435a4 }, { 0x3d33dea8, 0x3e3a7cdb }, { 0x3c901f87, 0x3c587ba5 },
    { 0x3b674161, 0x3c4f93c5 }, { 0x3f8480cd, 0xbad79686 }, { 0xbd975895, 0xbe9faf49 },
    { 0x3c925d16, 0x3c83dac4 }, { 0x3be4e383, 0x3cb73b1a }, { 0x3f825985, 0x3b3387b7 },
    { 0x3da15880, 0x3eb80017 }, { 0x3d03fd81, 0xbaa2d230 }, { 0x3c1e2eab, 0x3c9e4662 },
    { 0x3f7635f1, 0x3c109228 }, { 0xbdd104b4, 0xbef83103 }, { 0x3d03973f, 0x3b9af415 },
    { 0x3c6c9339, 0x3d10478d }, { 0x3f736247, 0x3c9cc20a }, { 0x3ddadb6e, 0x3ef53942 },
    { 0x3cf94e32, 0xbc935cc8 }, { 0x3c5cba3a, 0x3c9d38d8 }, { 0x3f65eadd, 0x3ccb2017 },
    { 0xbdf7b401, 0xbf11d34d }, { 0x3d0066ea, 0xbc1f3678 }, { 0x3c9c294a, 0x3d1d1789 },
    { 0x3f55a0b7, 0x3da370f5 }, { 0x3e15bd5d, 0x3f244f1f }, { 0x3bee060d, 0xbd156801 },
    { 0x3c5acaa4, 0x3c802669 }, { 0x3f4ea5bb, 0x3dac5a98 }, { 0xbe155d10, 0xbf2cfb19 },
    { 0x3c38ce4b, 0xbce06887 }, { 0x3ca2fe17, 0x3d24a454 }, { 0x3f4224dc, 0x3df689bc },
    { 0x3e3766d5, 0x3f381028 }, { 0xbc679cd9, 0xbd139399 }, { 0x3c2614bb, 0x3c6ff546 },
    { 0x3f3f9eaa, 0x3e01c6c9 }, { 0xbe31709b, 0xbf3aa234 }, { 0xbc1d08f1, 0xbce4f5bf },
    { 0x3c94e1f4, 0x3d29971e }, { 0x3f24d321, 0x3e657fb9 }, { 0x3e4298f1, 0x3f46e28b },
    { 0xbd2609c2, 0xbc8eae4e }, { 0x3b773ad2, 0x3c90add9 }, { 0x3f24e4f1, 0x3e6f2a44 },
    { 0xbe39ad8f, 0xbf45fc23 }, { 0xbd15ceae, 0xbc1e68b8 }, { 0x3c05386e, 0x3d3588b4 },
    { 0x3f1e6cb0, 0x3ea4f9f2 }, { 0x3e3fa7a8, 0x3f529d3e }, { 0xbd4843e3, 0x3aed19f6 },
    { 0x39b214c8, 0x3cb88926 }, { 0x3f1d9c33, 0x3eaa82c2 }, { 0xbe358ef4, 0xbf517b4c },
    { 0xbd38427f, 0x3c126039 }, { 0xb892d69a, 0x3d5e6cea }, { 0x3f1ded31, 0x3ed10655 },
    { 0x3e658e70, 0x3f53677e }, { 0xbd33e026, 0x3ce68645 }, { 0xbb88b69a, 0x3cfc3b69 },
    { 0x3f1b6bd2, 0x3ed7980c }, { 0xbe581593, 0xbf528ef4 }, { 0xbd2cd7d1, 0x3d0a2b65 },
    { 0x3a019d18, 0x3d8df3df }, { 0x3f07f745, 0x3f02081b }, { 0x3e0784e7, 0x3f458b28 },
    { 0xbcffc172, 0x3d179630 }, { 0xbc1760c8, 0x3d335624 }, { 0x3f0365a8, 0x3f04d98e },
    { 0xbdeb201a, 0xbf44cff6 }, { 0xbd0703b0, 0x3d2ded82 }, { 0xbbc7e665, 0x3d9af9ce },
    { 0x3ed5b722, 0x3f27d30d }, { 0xbc6eead8, 0x3f49b737 }, { 0xbcadd018, 0x3d225ece },
    { 0xbc418086, 0x3d7780ee }, { 0x3ec4d996, 0x3f2b8f7a }, { 0x3d40e1f5, 0xbf486253 },
    { 0xbcebda00, 0x3d43796e }, { 0xbc718444, 0x3db396a6 }, { 0x3e7c2902, 0x3f3900f7 },
    { 0xbe0a1f36, 0x3f41d519 }, { 0xbc77be68, 0x3cc43c57 }, { 0xbc47f890, 0x3d84e9d0 },
    { 0x3e51ae17, 0x3f3e3d0e }, { 0x3e3a05ed, 0xbf402db8 }, { 0xbcca2523, 0x3d1c70c4 },
    { 0xbce96b3e, 0x3dade3e0 }, { 0x3d4f3714, 0x3f3facf5 }, { 0xbe92a289, 0x3f332468 },
    { 0xbd01d780, 0x39395b6c }, { 0xbc8c5e88, 0x3d77d64b }, { 0xb99e40d0, 0x3f4593ca },
    { 0x3eb1c51c, 0xbf31d320 }, { 0xbd06044b, 0x3c64954b }, { 0xbd509864, 0x3d9f7fc6 },
    { 0x3db593e3, 0x3f38a510 }, { 0xbe9e10a7, 0x3f30e4ca }, { 0xbcabc3fd, 0xbc46b2bb },
    { 0xbc245997, 0x3d4ecc1b }, { 0x3d25a60e, 0x3f42933f }, { 0x3ebdee4c, 0xbf2f3c04 },
    { 0xbc91c209, 0x3ba6cde1 }, { 0xbd4532a8, 0x3d589c08 }, { 0x3dd435dd, 0x3f330bde },
    { 0xbea6d3d0, 0x3f2dc9bb }, { 0xbc6b1b8e, 0xbbbc0c0b }, { 0xbbde31dc, 0x3d4bcee9 },
    { 0x3d6c2bb2, 0x3f3e5379 }, { 0x3ec45bc1, 0xbf2aab8e }, { 0xbbdbb0a7, 0x3b552291 },
    { 0xbd3d7834, 0x3d333357 }, { 0x3de69d38, 0x3f3854f1 }, { 0xbeae8f67, 0x3f2f03d7 },
    { 0xbbc8403b, 0x3ce94afd }, { 0xbbf781f2, 0x3d565a85 }, { 0x3d859eef, 0x3f44fd7a },
    { 0x3ece1c3e, 0xbf2d410b }, { 0x3ba69161, 0x3d0ba697 }, { 0xbd3c9d1a, 0x3d2114a5 },
    { 0x3dd41331, 0x3f36fb44 }, { 0xbe9f2832, 0x3f2a83cd }, { 0xbbebaf77, 0x3cfec46b },
    { 0xbc27901a, 0x3d6e78b2 }, { 0x3d61def6, 0x3f4266d1 }, { 0x3ec03f0d, 0xbf2a289a },
    { 0x3c0861a4, 0x3c7937c2 }, { 0xbd3342b0, 0x3d201caf }, { 0x3dc5cef0, 0x3f387082 },
    { 0xbe96973f, 0x3f2caf09 }, { 0xbbea276e, 0x3d148f3f }, { 0xbc8036a6, 0x3d81daff },
    { 0x3d4268ee, 0x3f4515bd }, { 0x3eb7690f, 0xbf2d7eb8 }, { 0x3c4457cb, 0x3b95919c },
    { 0xbd38bace, 0x3d3aa0c5 }, { 0x3dad27e7, 0x3f2ece3c }, { 0xbe89eff1, 0x3f2b2602 },
    { 0xbbf3229e, 0x3d01bd0b }, { 0xbcb777a6, 0x3d63af9c }, { 0x3d1ad9f4, 0x3f408ed5 },
    { 0x3ea7d046, 0xbf2d0f54 }, { 0x3c6f1999, 0x3c5e00cf }, { 0xbd3c8f53, 0x3d77499b },
    { 0x3d9c249a, 0x3f279166 }, { 0xbe7efe0c, 0x3f2aea57 }, { 0xbbd5832e, 0x3cbae22e },
    { 0xbce6c29a, 0x3d64c1f8 }, { 0x3d04b024, 0x3f404cdc }, { 0x3e9eb66b, 0xbf2f9cfa },
    { 0x3c8908fb, 0x3cec0829 }, { 0xbd50ef1e, 0x3d8979f4 }, { 0x3d939280, 0x3f28b935 },
    { 0xbe677de1, 0x3f2bd58f }, { 0xbb9d446e, 0x3cbb5dd5 }, { 0xbd0f60bb, 0x3d88e181 },
    { 0x3ce4c298, 0x3f443323 }, { 0x3e97dcb6, 0xbf345110 }, { 0x3c8bbdb7, 0x3d19ee53 },
    { 0xbd73c518, 0x3d93164f }, { 0x3d8ec864, 0x3f2e5d9b }, { 0xbe5850dc, 0x3f30a927 },
    { 0xbb71f042, 0x3d00f407 }, { 0xbd343d5b, 0x3da6635a }, { 0x3cbfd9e2, 0x3f483b67 },
    { 0x3e910e76, 0xbf39d531 }, { 0x3c88a702, 0x3d209b2e }, { 0xbd8f04ac, 0x3dab2636 },
    { 0x3d8cfa8b, 0x3f35bc56 }, { 0xbe4f530b, 0x3f389a8d }, { 0xbb86535b, 0x3d4209a6 },
    { 0xbd64e620, 0x3dc0a3ea }, { 0x3c953596, 0x3f48b0b1 }, { 0x3e891c92, 0xbf3db63b },
    { 0x3c8afd63, 0x3d298f43 }, { 0xbda3e0db, 0x3dd1ed11 }, { 0x3d90e5e4, 0x3f3f475d },
    { 0xbe4cb8cf, 0x3f4466ba }, { 0xbbdba7e8, 0x3d82da27 }, { 0xbd9269f3, 0x3ddf0e8a },
    { 0x3c6fb9c8, 0x3f4bc9f1 }, { 0x3e85b87b, 0xbf4502b2 }, { 0x3c98724f, 0x3d31b034 },
    { 0xbdbfa5f2, 0x3dfdeef4 }, { 0x3d948551, 0x3f433452 }, { 0xbe46e073, 0x3f4ac09e },
    { 0xbc38be05, 0x3d95478f }, { 0xbdb6fbe3, 0x3dfb8628 }, { 0x3c41a8a8, 0x3f4bf4d7 },
    { 0x3e81906a, 0xbf4913a7 }, { 0x3ca56d53, 0x3d4cf6f4 }, { 0xbddc8762, 0x3e1565f6 },
    { 0x3d9a9fae, 0x3f4407fa }, { 0xbe3bcca2, 0x3f49e4e7 }, { 0xbc7c76b6, 0x3d9a91a9 },
    { 0xbddfe7fa, 0x3e0aee58 }, { 0x3c18b1f0, 0x3f4a8a80 }, { 0x3e7aa4e6, 0xbf496813 },
    { 0x3ca9d64d, 0x3d816b06 }, { 0xbdf891b0, 0x3e2cc276 }, { 0x3d9cb496, 0x3f40ed08 },
    { 0xbe2d0564, 0x3f46c988 }, { 0xbc8bcc80, 0x3da58b59 }, { 0xbe01e5c8, 0x3e141dc1 },
    { 0x3ba6cbd8, 0x3f476eeb }, { 0x3e6fc30c, 0xbf48d6d8 }, { 0x3ca56281, 0x3da3e49f },
    { 0xbe06e9cb, 0x3e41e354 }, { 0x3d957328, 0x3f399ffd }, { 0xbe1d6823, 0x3f43c493 },
    { 0xbc8c0ae5, 0x3dbf726a }, { 0xbe0bbf0e, 0x3e182ea7 }, { 0xbaa94d00, 0x3f43aee3 },
    { 0x3e62d6ad, 0xbf48a738 }, { 0x3ca1b1ae, 0x3db6a7ea }, { 0xbe0d95d9, 0x3e52048b },
    { 0x3d85dcea, 0x3f343bc8 }, { 0xbe10f719, 0x3f40bc1d }, { 0xbc7f9c78, 0x3de0c907 },
    { 0xbe0d9c03, 0x3e1f1439 }, { 0xbbfb1710, 0x3f412e9d }, { 0x3e55eadf, 0xbf483bfb },
    { 0x3c9cb6f1, 0x3dc4c42f }, { 0xbe120f07, 0x3e5a8e56 }, { 0x3d6b5cf4, 0x3f33ac01 },
    { 0xbe07f418, 0x3f409ecc }, { 0xbc4eabcc, 0x3dfd7a5e }, { 0xbe0e4c89, 0x3e25a8e6 },
    { 0xbc7be4a8, 0x3f4189c9 }, { 0x3e4a9043, 0xbf49165a }, { 0x3c8b8f74, 0x3de3c318 },
    { 0xbe10d55c, 0x3e5ef31a }, { 0x3d45ad52, 0x3f340be9 }, { 0xbdfd0697, 0x3f424ee9 },
    { 0xbc05c28f, 0x3e0943a8 }, { 0xbe0b688f, 0x3e27cf73 }, { 0xbcbf8b26, 0x3f42a7e4 },
    { 0x3e3fb99d, 0xbf4a4440 }, { 0x3c459ac2, 0x3e081185 }, { 0xbe08d81c, 0x3e5b2518 },
    { 0x3d1de14d, 0x3f32e24c }, { 0xbde89e3f, 0x3f430452 }, { 0xbb76d510, 0x3e133fc4 },
    { 0xbe029c02, 0x3e20f3ad }, { 0xbcfa484a, 0x3f438745 }, { 0x3e353954, 0xbf4b2ff5 },
    { 0x3bc5ce70, 0x3e1e3df4 }, { 0xbdf90c7c, 0x3e506095 }, { 0x3cf7d09c, 0x3f31d6aa },
    { 0xbdd44c63, 0x3f42c7ca }, { 0xba6e11e0, 0x3e1faaf4 }, { 0xbdec3635, 0x3e12b60b },
    { 0xbd1372e1, 0x3f4419e7 }, { 0x3e2abb35, 0xbf4bee79 }, { 0xb9bd7460, 0x3e31788d },
    { 0xbdde1980, 0x3e41979f }, { 0x3cc4dbaa, 0x3f312333 }, { 0xbdbe00a6, 0x3f41bd10 },
    { 0xba936738, 0x3e2be33f }, { 0xbdceb359, 0x3dfb9c66 }, { 0xbd265cb1, 0x3f43a1c9 },
    { 0x3e1e9a18, 0xbf4b6d59 }, { 0xbbe6c00a, 0x3e40a9a5 }, { 0xbdc31408, 0x3e32f87b },
    { 0x3ca06dca, 0x3f2ffcbe }, { 0xbda747ad, 0x3f40af0b }, { 0xbb69f598, 0x3e387d7b },
    { 0xbdaff912, 0x3dcc50c7 }, { 0xbd383cf9, 0x3f42b283 }, { 0x3e13f89c, 0xbf4aaeff },
    { 0xbc524fe0, 0x3e5214c3 }, { 0xbda98046, 0x3e2699d5 }, { 0x3c7b5798, 0x3f2eca57 },
    { 0xbd90b441, 0x3f3fcb5a }, { 0xbbb69d6d, 0x3e401785 }, { 0xbd941334, 0x3d9de14b },
    { 0xbd4c3014, 0x3f41e2f4 }, { 0x3e0ab981, 0xbf4a7a2c }, { 0xbc924e32, 0x3e647cbf },
    { 0xbd927cd8, 0x3e1e4a72 }, { 0x3c2d4f34, 0x3f2f46ea }, { 0xbd79b76e, 0x3f40036a },
    { 0xbbc0db03, 0x3e42b4f4 }, { 0xbd7b6493, 0x3d665db3 }, { 0xbd61fbc0, 0x3f423c77 },
    { 0x3e01a4c3, 0xbf4bbec1 }, { 0xbcb904a1, 0x3e743ee5 }, { 0xbd8085a1, 0x3e1bd23e },
    { 0x3b9bd2b0, 0x3f3088ad }, { 0xbd57fe44, 0x3f40631e }, { 0xbb76a3b4, 0x3e41b3d0 },
    { 0xbd56449e, 0x3d1f7888 }, { 0xbd722a5c, 0x3f40bf8e }, { 0x3def59ce, 0xbf4b3b49 },
    { 0xbcda80ff, 0x3e7e8eeb }, { 0xbd6265f3, 0x3e175320 }, { 0xbac80380, 0x3f34bf0b },
    { 0xbd4182da, 0x3f43356b }, { 0x382bff00, 0x3e3ce2fc }, { 0xbd3bcb06, 0x3d00ba63 },
    { 0xbd7b68b9, 0x3f3ebe97 }, { 0x3ddfce26, 0xbf4a5555 }, { 0xbcef756a, 0x3e800e0b },
    { 0xbd45fe6d, 0x3e0b854f }, { 0xbbff7928, 0x3f3d8b86 }, { 0xbd38e7f1, 0x3f4a1727 },
    { 0x3bb3ddf2, 0x3e3a6fed }, { 0xbd2ba9c5, 0x3ce20429 }, { 0xbd820aff, 0x3f3ec802 },
    { 0x3dd7cfee, 0xbf4bd412 }, { 0xbcffdfd4, 0x3e7e89c3 }, { 0xbd2de0aa, 0x3e020eb4 },
    { 0xbc807aee, 0x3f494b6b }, { 0xbd3a882f, 0x3f52f7b7 }, { 0x3c6681cb, 0x3e3125ce },
    { 0xbd215b03, 0x3d008776 }, { 0xbd866eae, 0x3f416e37 }, { 0x3dd46bf2, 0xbf4f92c7 },
    { 0xbd0d35ac, 0x3e7e87c4 }, { 0xbd18c6e3, 0x3df1ee34 }, { 0xbcc8425e, 0x3f51d641 },
    { 0xbd42060a, 0x3f594e5a }, { 0x3cd2650e, 0x3e1768e5 }, { 0xbd1cc98d, 0x3d24087e },
    { 0xbd8bb1d2, 0x3f4714fd }, { 0x3dd4bcb2, 0xbf54d5dd }, { 0xbd2308db, 0x3e829839 },
    { 0xbd0426f8, 0x3de48e5f }, { 0xbd06c308, 0x3f50c215 }, { 0xbd4c51e6, 0x3f569719 },
    { 0x3d231ae0, 0x3dc9b93b }, { 0xbd1aeca7, 0x3d57ff71 }, { 0xbd8f7dac, 0x3f4d653e },
    { 0x3dd681ba, 0xbf591ad0 }, { 0xbd411063, 0x3e86a993 }, { 0xbcddbf94, 0x3dd5ea8b },
    { 0xbd1ec79e, 0x3f46f809 }, { 0xbd5b421f, 0x3f4b15d7 }, { 0x3d5bbace, 0x3d358881 },
    { 0xbd162bda, 0x3d8a1b9e }, { 0xbd8f20da, 0x3f520ecf }, { 0x3ddad00c, 0xbf5b2b59 },
    { 0xbd616c3c, 0x3e869aaf }, { 0xbcb50810, 0x3dbf84c8 }, { 0xbd24f784, 0x3f3af578 },
    { 0xbd7332a9, 0x3f3d7178 }, { 0x3d85d657, 0x3c012412 }, { 0xbd0de354, 0x3d994d4f },
    { 0xbd88a45c, 0x3f53a9fa }, { 0x3de4a87a, 0xbf5a143c }, { 0xbd7e95fe, 0x3e7c9a44 },
    { 0xbc98cb50, 0x3dacd77a }, { 0xbd1e5887, 0x3f30a9df }, { 0xbd8aab8e, 0x3f32d04d },
    { 0x3d9c2913, 0xbc344fb4 }, { 0xbd062f52, 0x3d936aa7 }, { 0xbd7b9465, 0x3f538ef7 },
    { 0x3df2cf1f, 0xbf571664 }, { 0xbd8ca146, 0x3e607e87 }, { 0xbc882468, 0x3da22ca8 },
    { 0xbd13c74c, 0x3f291f92 }, { 0xbd9e7eb8, 0x3f2c1f3f }, { 0x3db48dbc, 0xbcbff8af },
    { 0xbd014e20, 0x3d83f594 }, { 0xbd634cd2, 0x3f53ffb8 }, { 0x3e01e320, 0xbf5409c0 },
    { 0xbd9b8d37, 0x3e48386c }, { 0xbc7a23a0, 0x3d9807d2 }, { 0xbd0b6b86, 0x3f252d4f },
    { 0xbdb2ced5, 0x3f2913d9 }, { 0x3dd0816c, 0xbd111baa }, { 0xbcf71fa9, 0x3d743d85 },
    { 0xbd4d4719, 0x3f582657 }, { 0x3e0cebc8, 0xbf54124a }, { 0xbdae3962, 0x3e3b1fc7 },
    { 0xbc74ed5c, 0x3d8062e6 }, { 0xbd05defa, 0x3f227360 }, { 0xbdc5f887, 0x3f270c1c },
    { 0x3dedfe1b, 0xbd46851c }, { 0xbcdf0586, 0x3d61829c }, { 0xbd374e3c, 0x3f5b9efc },
    { 0x3e15de10, 0xbf5342a4 }, { 0xbdbfb2a3, 0x3e2eebb9 }, { 0xbc85fc40, 0x3d39c90b },
    { 0xbd03d686, 0x3f232ef4 }, { 0xbddbc010, 0x3f28c629 }, { 0x3e0794ee, 0xbd7c6612 },
    { 0xbcbc0421, 0x3d3f52dd }, { 0xbd261fa6, 0x3f607d19 }, { 0x3e1d2420, 0xbf541861 },
    { 0xbdcdd6eb, 0x3e204296 }, { 0xbca0effe, 0x3cdcbee5 }, { 0xbd042ae5, 0x3f268cb9 },
    { 0xbdf2d5b4, 0x3f2d8e23 }, { 0x3e190470, 0xbd99f847 }, { 0xbc8a4a45, 0x3d04bebe },
    { 0xbd1ca9fd, 0x3f67d30b }, { 0x3e243a00, 0xbf57c118 }, { 0xbdd83272, 0x3e124d98 },
    { 0xbcc8ea9d, 0x3c476338 }, { 0xbd081a47, 0x3f2d307a }, { 0xbe0586f4, 0x3f35d890 },
    { 0x3e2adbdc, 0xbdb6c82d }, { 0xbc0e317b, 0x3c8997aa }, { 0xbd1a732b, 0x3f715fb6 },
    { 0x3e2ba5f0, 0xbf5dd23f }, { 0xbddddfa8, 0x3e082d32 }, { 0xbcf990e1, 0xba81105f },
    { 0xbd10247d, 0x3f37cc58 }, { 0xbe144134, 0x3f420e99 }, { 0x3e3cc72b, 0xbdd68179 },
    { 0x3aa9cabc, 0x39df477c }, { 0xbd1e5716, 0x3f7c5d0d }, { 0x3e32dc17, 0xbf65ee3d },
    { 0xbddcea17, 0x3dfae835 }, { 0xbd17f642, 0xbc25a366 }, { 0xbd06df07, 0x3f3fa4f6 },
    { 0xbe1de028, 0x3f4ac4d4 }, { 0x3e48879e, 0xbdd7a66b }, { 0x3c6824bc, 0xb9d61438 },
    { 0xbd1365bd, 0x3f80ebd3 }, { 0x3e3b8b72, 0xbf69b066 }, { 0xbdd6c3fa, 0x3df54ccd },
    { 0xbd323cab, 0xbce16807 }, { 0xbd145bc4, 0x3f3d63b5 }, { 0xbe2189bf, 0x3f48693f },
    { 0x3e3d3535, 0xbdebcb69 }, { 0x3ce922d8, 0x39710a44 }, { 0xbd16cb8d, 0x3f76325a },
    { 0x3e308350, 0xbf60b942 }, { 0xbdb302cd, 0x3db82244 }, { 0xbd47c6c5, 0xbcffa625 },
    { 0xbd1d6348, 0x3f30a48b }, { 0xbe196c20, 0x3f3a72e5 }, { 0x3e202933, 0xbdebf517 },
    { 0x3d1b78d6, 0x3b1e81fb }, { 0xbd1078e4, 0x3f5fa04b }, { 0x3e1fc2e4, 0xbf4dcb06 },
    { 0xbd840be2, 0x3d92b693 }, { 0xbd530c28, 0xbc60bca4 }, { 0xbd18e9ff, 0x3f23cdd7 },
    { 0xbe0d3aa1, 0x3f2bf255 }, { 0x3e024dac, 0xbdcb2822 }, { 0x3d353f0e, 0x3c76a609 },
    { 0xbd02e491, 0x3f4c7df0 }, { 0x3e149e0c, 0xbf3ea69e }, { 0xbd3ccb42, 0x3d848b76 },
    { 0xbd61f1e1, 0x3b9d53c3 }, { 0xbd118b59, 0x3f1c52c0 }, { 0xbe01d6ba, 0x3f228217 },
    { 0x3dd4d978, 0xbd9771eb }, { 0x3d51d167, 0x3cdd610f }, { 0xbcef4cab, 0x3f3fd5fb },
    { 0x3e0ea027, 0xbf35ed9e }, { 0xbd08bcd8, 0x3d858929 }, { 0xbd7c9690, 0x3cc8641f },
    { 0xbd136012, 0x3f1a211e }, { 0xbdf20ec5, 0x3f1f26e5 }, { 0x3dafb0be, 0xbd467c5e },
    { 0x3d7bb61a, 0x3d1e9344 }, { 0xbce67afb, 0x3f385433 }, { 0x3e093dd1, 0xbf3149d8 },
    { 0xbcc95a69, 0x3d9135a5 }, { 0xbd9151ed, 0x3d22e8d0 }, { 0xbd281758, 0x3f1b3e68 },
    { 0xbde4ae7b, 0x3f200156 }, { 0x3d9201df, 0xbcff13b9 }, { 0x3d9e130f, 0x3d416b69 },
    { 0xbcf587ae, 0x3f352b79 }, { 0x3e01d2ea, 0xbf2fb4d0 }, { 0xbc9829fa, 0x3da0af66 },
    { 0xbda99360, 0x3d502bcc }, { 0xbd4e21db, 0x3f1e4a44 }, { 0xbdda83cb, 0x3f2274d4 },
    { 0x3d7018e1, 0xbcd5351f }, { 0x3dc93c22, 0x3d6a57c6 }, { 0xbd0e2dd1, 0x3f35e41e },
    { 0x3df15f35, 0xbf314124 }, { 0xbc6c9d13, 0x3da6cafe }, { 0xbdc5a7e3, 0x3d5dda86 },
    { 0xbd75a9bf, 0x3f22455f }, { 0xbdd32673, 0x3f2535b2 }, { 0x3d401897, 0xbcfd26df },
    { 0x3dfa776c, 0x3d928e1c }, { 0xbd216ea4, 0x3f37d114 }, { 0x3de29b78, 0xbf3388d9 },
    { 0xbc3be24f, 0x3da9033e }, { 0xbde27273, 0x3d4cc479 }, { 0xbd8aef8f, 0x3f28a217 },
    { 0xbdd17ac9, 0x3f2ac53b }, { 0x3d0fd9fd, 0xbd27346f }, { 0x3e18c360, 0x3dbfc808 },
    { 0xbd2f5e70, 0x3f3ad730 }, { 0x3dda527c, 0xbf364a49 }, { 0xbc07751f, 0x3dadd80f },
    { 0xbe00dc1b, 0x3d21d79b }, { 0xbd9a1b6d, 0x3f3309c1 }, { 0xbdd4a625, 0x3f3426ea },
    { 0x3cb25a03, 0xbd5aad25 }, { 0x3e39d729, 0x3e0019f7 }, { 0xbd3d7ec9, 0x3f41f4fc },
    { 0x3dd88dfb, 0xbf3c0b2d }, { 0xbb831e3b, 0x3db41961 }, { 0xbe14d821, 0x3cce1238 },
    { 0xbda81fbc, 0x3f3efc8d }, { 0xbdd60e5a, 0x3f3e992c }, { 0x3bbfd118, 0xbd8c9e44 },
    { 0x3e606410, 0x3e2a2d89 }, { 0xbd4d2e58, 0x3f4d28e3 }, { 0x3ddd6f4e, 0xbf4519e1 },
    { 0x3abcd1c8, 0x3db66420 }, { 0xbe2d9edd, 0x3bbf60f8 }, { 0xbdb11725, 0x3f46ca13 },
    { 0xbdcf752a, 0x3f444e22 }, { 0xbc43f331, 0xbdb0e711 }, { 0x3e8314ce, 0x3e586bc7 },
    { 0xbd596703, 0x3f57a417 }, { 0x3de2a44c, 0xbf4cd7ba }, { 0x3c11a9da, 0x3dafbb56 },
    { 0xbe47ba1b, 0xbc8bffc1 }, { 0xbdb2aa0a, 0x3f45f647 }, { 0xbdbdd94b, 0x3f4169ec },
    { 0xbcedfa4d, 0xbdd5f0cc }, { 0x3e90e2b6, 0x3e7f699a }, { 0xbd5d2a80, 0x3f5c03f1 },
    { 0x3de16715, 0xbf4dbca1 }, { 0x3c98d85c, 0x3d9ef4a5 }, { 0xbe5dfeda, 0xbd1e5766 },
    { 0xbdab3656, 0x3f3d9ad8 }, { 0xbda36663, 0x3f37b83e }, { 0xbd2dbaeb, 0xbdf44820 },
    { 0x3e97424e, 0x3e8db76d }, { 0xbd52bc04, 0x3f57a171 }, { 0x3dda4006, 0xbf45f600 },
    { 0x3cecdc78, 0x3d82f582 }, { 0xbe6afde5, 0xbd657c5f }, { 0xbda1ab1a, 0x3f32f056 },
    { 0xbd848395, 0x3f2c0eb4 }, { 0xbd50668e, 0xbe032eed }, { 0x3e97f3ab, 0x3e96320e },
    { 0xbd420966, 0x3f4bf6de }, { 0x3dce81bc, 0xbf381184 }, { 0x3d1a8ebc, 0x3d37d0ec },
    { 0xbe6d4742, 0xbd80355d }, { 0xbd9a2411, 0x3f2988da }, { 0xbd4a3b31, 0x3f226148 },
    { 0xbd61f7f6, 0xbe060bce }, { 0x3e95c884, 0x3e9a7fd2 }, { 0xbd31b1f6, 0x3f3da808 },
    { 0x3dc46e34, 0xbf28faae }, { 0x3d34e264, 0x3cdcf35c }, { 0xbe689db9, 0xbd6f1e85 },
    { 0xbd97a5f5, 0x3f208e4b }, { 0xbd140e40, 0x3f1a6139 }, { 0xbd616688, 0xbdff1749 },
    { 0x3e904b1d, 0x3e96d9fb }, { 0xbd2a4d38, 0x3f2edc75 }, { 0x3dbc6c4c, 0xbf1b49ce },
    { 0x3d44c99d, 0x3c594cc6 }, { 0xbe60814b, 0xbd2b825f }, { 0xbd90d579, 0x3f1d42ba },
    { 0xbccff4c0, 0x3f177fca }, { 0xbd5c452d, 0xbdee37a6 }, { 0x3e8bfc94, 0x3e97f7dc },
    { 0xbd20253a, 0x3f228dcc }, { 0x3dbaa896, 0xbf11a0a1 }, { 0x3d48aafc, 0x3b44f1c8 },
    { 0xbe563a2c, 0xbce980f0 }, { 0xbd868289, 0x3f1f94f4 }, { 0xbc814046, 0x3f19f30e },
    { 0xbd5566bd, 0xbde1cb5a }, { 0x3e891a6e, 0x3e9edafe }, { 0xbd19daec, 0x3f1a45bb },
    { 0x3dbd9ec2, 0xbf0c85aa }, { 0x3d431a54, 0xbb73b13c }, { 0xbe4bb271, 0xbc965087 },
    { 0xbd78ff65, 0x3f2345bc }, { 0xbbe69fa0, 0x3f1eecc0 }, { 0xbd4522a4, 0xbdd6fb5d },
    { 0x3e850daa, 0x3ea382ff }, { 0xbd20bc08, 0x3f14ada6 }, { 0x3dc32e9a, 0xbf09ef20 },
    { 0x3d379d8d, 0xbc039e45 }, { 0xbe41c98b, 0xbb84495a }, { 0xbd643f07, 0x3f2b4616 },
    { 0x39f63c00, 0x3f28c44c }, { 0xbd2e8ada, 0xbdd1c623 }, { 0x3e81db56, 0x3ea97380 },
    { 0xbd32db88, 0x3f125b1d }, { 0x3dccfb32, 0xbf0a7e7a }, { 0x3d261245, 0xbc360a76 },
    { 0xbe38dbd0, 0x3c4530c9 }, { 0xbd4e4c03, 0x3f38891d }, { 0x3bd42ae8, 0x3f37c411 },
    { 0xbd0cd688, 0xbdcb7419 }, { 0x3e7fbfa4, 0x3eb0d142 }, { 0xbd4e9f5e, 0x3f13f88e },
    { 0x3ddc6b42, 0xbf0f2aac }, { 0x3d10d10f, 0xbc8aabc2 }, { 0xbe32bc7c, 0x3ceac433 },
    { 0xbd3734f3, 0x3f4c5c90 }, { 0x3c2cd918, 0x3f4ce401 }, { 0xbcbc90ce, 0xbdc282c8 },
    { 0x3e803643, 0x3ebb40b4 }, { 0xbd7282ba, 0x3f1b11f9 }, { 0x3df20aad, 0xbf193046 },
    { 0x3cee8452, 0xbce4ea59 }, { 0xbe315735, 0x3d2e8aa8 }, { 0xbd1f1d40, 0x3f64d8d7 },
    { 0x3c4f96dc, 0x3f66f84a }, { 0xbbf878e4, 0xbdb157c1 }, { 0x3e82fe2e, 0x3ec8b676 },
    { 0xbd90ed07, 0x3f2aa6dc }, { 0x3e07a72a, 0xbf2aa1e0 }, { 0x3cacf6fa, 0xbd3d9c5b },
    { 0xbe384324, 0x3d5751ec }, { 0xbd07fb54, 0x3f7aef57 }, { 0x3c574a9c, 0x3f7fcc6f },
    { 0x3c4f9da0, 0xbd8ec00e }, { 0x3e870b75, 0x3ed520fe }, { 0xbdaf7c1f, 0x3f46e60c },
    { 0x3e1b6182, 0xbf4591af }, { 0x3c275bda, 0xbd9b5adc }, { 0xbe4da1cc, 0x3d693a94 },
    { 0xbceb351a, 0x3f80f90b }, { 0x3c410114, 0x3f8451c7 }, { 0x3d0e820a, 0xbd3378e2 },
    { 0x3e8805e8, 0x3ed63e69 }, { 0xbdc34544, 0x3f622bc2 }, { 0x3e2902a3, 0xbf5cfd1d },
    { 0xbb84e5b1, 0xbde90ea3 }, { 0xbe6b72b4, 0x3d42c48a }, { 0xbcce5564, 0x3f75bd3a },
    { 0x3c1e68bc, 0x3f7962d4 }, { 0x3d52f157, 0xbc9307ff }, { 0x3e8321a0, 0x3ecad24e },
    { 0xbdad4df3, 0x3f5aaa9b }, { 0x3e19e5ae, 0xbf52f88e }, { 0xbc8235ca, 0xbe125734 },
    { 0xbe73c5be, 0x3c85b197 }, { 0xbcc52386, 0x3f5fd21f }, { 0x3c0f76f8, 0x3f5ecdf2 },
    { 0x3d726e0e, 0xbb936f99 }, { 0x3e78c3eb, 0x3ebb102d }, { 0xbd860022, 0x3f3d5dca },
    { 0x3df7eef9, 0xbf34abe5 }, { 0xbca1b711, 0xbe1c62b5 }, { 0xbe68954a, 0xbc6c4532 },
    { 0xbce0e270, 0x3f4a5604 }, { 0x3c1f8f28, 0x3f4669e8 }, { 0x3d726e61, 0xbc80ddf7 },
    { 0x3e6eb6c2, 0x3eab54f7 }, { 0xbd5e13d2, 0x3f27a785 }, { 0x3dd0bb9e, 0xbf1f3551 },
    { 0xbcab0b87, 0xbe0e651c }, { 0xbe629afb, 0xbcd10e72 }, { 0xbd0d78d8, 0x3f3b7306 },
    { 0x3c3ae776, 0x3f3651f6 }, { 0x3d5e09ec, 0xbd3e36c5 }, { 0x3e6b3430, 0x3e9edeb7 },
    { 0xbd55212b, 0x3f1e2861 }, { 0x3dc3b346, 0xbf16cb36 }, { 0xbcbf60bc, 0xbdf252c7 },
    { 0xbe67aee9, 0xbcb18f3d }, { 0xbd2b5658, 0x3f34d75d }, { 0x3c491836, 0x3f2f3b40 },
    { 0x3d3e6732, 0xbda91bc4 }, { 0x3e6d084f, 0x3e9832ec }, { 0xbd625f0c, 0x3f1c8ddd },
    { 0x3dc81f72, 0xbf16ceeb }, { 0xbcde91b8, 0xbddbbe90 }, { 0xbe71e24a, 0xbc35b25f },
    { 0xbd445ef7, 0x3f38a305 }, { 0x3c56b654, 0x3f326373 }, { 0x3d19bba3, 0xbde7b559 },
    { 0x3e73f232, 0x3e9938ae }, { 0xbd7e498e, 0x3f1f8bc9 }, { 0x3dd7cf3e, 0xbf1c9023 },
    { 0xbd00667a, 0xbde2c325 }, { 0xbe7beb42, 0x3af49d88 }, { 0xbd5a205f, 0x3f486ecb },
    { 0x3c7c8584, 0x3f4164f8 }, { 0x3cd88a29, 0xbe0ba07b }, { 0x3e80ab9a, 0x3ea58182 },
    { 0xbd9169e1, 0x3f26d6f1 }, { 0x3dee9df9, 0xbf278a8a }, { 0xbd0a4188, 0xbe04a0ec },
    { 0xbe81e815, 0x3c3ec251 }, { 0xbd6c6e0a, 0x3f5d3656 }, { 0x3c9c976c, 0x3f560f61 },
    { 0x3c0dd490, 0xbe1daacd }, { 0x3e86f88f, 0x3ebb0e75 }, { 0xbda108a9, 0x3f306cc7 },
    { 0x3e00b8ca, 0xbf345edc }, { 0xbcf282dc, 0xbe1d9f9b }, { 0xbe820d3c, 0x3c3f0bb7 },
    { 0xbd700720, 0x3f662f58 }, { 0x3cb4a498, 0x3f5f52ef }, { 0xbc812719, 0xbe22fd2a },
    { 0x3e84abec, 0x3ecc14a4 }, { 0xbda256c4, 0x3f336d5f }, { 0x3dfe21d5, 0xbf388c36 },
    { 0xbc89c46c, 0xbe1f1799 }, { 0xbe71c6ee, 0xbaae4b80 }, { 0xbd5fec7c, 0x3f5bd221 },
    { 0x3cb87226, 0x3f546182 }, { 0xbd0c9cd4, 0xbe162118 }, { 0x3e72a11a, 0x3ecd04a4 },
    { 0xbd957ace, 0x3f2b9d1d }, { 0x3de5ae62, 0xbf2f96ff }, { 0xbb9dfe40, 0xbe003bfc },
    { 0xbe54b6ba, 0xbc9f1eee }, { 0xbd48f9fa, 0x3f494c60 }, { 0x3ca23a88, 0x3f407175 },
    { 0xbd245551, 0xbdf9b142 }, { 0x3e5852f5, 0x3ec12c7c }, { 0xbd86f122, 0x3f23e6bb },
    { 0x3dcd7af2, 0xbf262947 }, { 0x3b148918, 0xbdc4023f }, { 0xbe41a130, 0xbd15e442 },
    { 0xbd343694, 0x3f3943e5 }, { 0x3c8e0ab4, 0x3f2eba79 }, { 0xbd158f0f, 0xbdc8bee6 },
    { 0x3e43abb0, 0x3eb319e7 }, { 0xbd7e3aec, 0x3f21b1a7 }, { 0x3dbf35e8, 0xbf22f486 },
    { 0x3b8bfbd4, 0xbd98a32c }, { 0xbe3bf748, 0xbd52e53a }, { 0xbd263105, 0x3f2dceb6 },
    { 0x3c89b082, 0x3f21ba23 }, { 0xbce73f40, 0xbda1a463 }, { 0x3e367cf0, 0x3ea7a349 },
    { 0xbd7c05be, 0x3f238774 }, { 0x3db9606a, 0xbf246d58 }, { 0x3accb670, 0xbd6898ba },
    { 0xbe4011db, 0xbd81f9a0 }, { 0xbd1f0560, 0x3f26536d }, { 0x3c935175, 0x3f18d6b1 },
    { 0xbc963273, 0xbd7f8ce7 }, { 0x3e30dc4c, 0x3ea17749 }, { 0xbd7dcd58, 0x3f27d136 },
    { 0x3db8e75e, 0xbf280d3f }, { 0xbb782557, 0xbd2cafe2 }, { 0xbe4bd1a6, 0xbd9ad5c0 },
    { 0xbd1e310a, 0x3f22e787 }, { 0x3cabe68e, 0x3f141ab8 }, { 0xbc0dbe12, 0xbd42055c },
    { 0x3e31d7bb, 0x3ea1d0ad }, { 0xbd7f09b2, 0x3f2e805d }, { 0x3dbc590e, 0xbf2d2fda },
    { 0xbc205044, 0xbd004f82 }, { 0xbe5f351c, 0xbdb7002b }, { 0xbd23f467, 0x3f22bd39 },
    { 0x3cd47f76, 0x3f12dbfc }, { 0xb94e4210, 0xbd0726ef }, { 0x3e368380, 0x3ea5f47a },
    { 0xbd803840, 0x3f37d526 }, { 0x3dc39570, 0xbf343a5a }, { 0xbc772ce0, 0xbcbe699b },
    { 0xbe7bfeba, 0xbdd2ee8e }, { 0xbd2d5af9, 0x3f242ebb }, { 0x3d022f54, 0x3f13c989 },
    { 0x3bc6d8ca, 0xbcb89fff }, { 0x3e39882d, 0x3ea7ebca }, { 0xbd8372b6, 0x3f43dd89 },
    { 0x3dcfa071, 0xbf3e5782 }, { 0xbca3d09e, 0xbc8a64a1 }, { 0xbe9173d8, 0xbde58b8e },
    { 0xbd312dfe, 0x3f250906 }, { 0x3d1362d2, 0x3f146c48 }, { 0x3c1f9a54, 0xbca1dcbc },
    { 0x3e356fad, 0x3ea2fb18 }, { 0xbd89b525, 0x3f50acdf }, { 0x3de16dc6, 0xbf4b90a0 },
    { 0xbcd839ba, 0xbc430fb4 }, { 0xbea73b53, 0xbde5e3cd }, { 0xbd282049, 0x3f24b1b7 },
    { 0x3d1652f2, 0x3f1369a2 }, { 0x3c3d6f6b, 0xbcc043c4 }, { 0x3e29f1fc, 0x3e98d153 },
    { 0xbd903802, 0x3f5bbc04 }, { 0x3df6d8b2, 0xbf5a8dd7 }, { 0xbd109e26, 0xbc16ca3c },
    { 0xbeb9750e, 0xbdd6bde6 }, { 0xbd152d55, 0x3f23f698 }, { 0x3d0d774b, 0x3f114d35 },
    { 0x3c4c29af, 0xbce87cba }, { 0x3e1b92ef, 0x3e8e326f }, { 0xbd954e3e, 0x3f64b57b },
    { 0x3e05907d, 0xbf69fa6b }, { 0xbd3b0527, 0xbc099960 }, { 0xbec40ec6, 0xbdc64689 },
    { 0xbcfa99ea, 0x3f22f983 }, { 0x3cfe14be, 0x3f0e86ad }, { 0x3c54fa22, 0xbcfe4273 },
    { 0x3e0d8161, 0x3e86039c }, { 0xbd9698a6, 0x3f6c5959 }, { 0x3e0c12b4, 0xbf787367 },
    { 0xbd69048c, 0xbc12847e }, { 0xbec6741a, 0xbdc75b5d }, { 0xbcce1f5a, 0x3f22643b },
    { 0x3ce4f8ea, 0x3f0c1ac4 }, { 0x3c5ec173, 0xbcf6f3a0 }, { 0x3e022992, 0x3e815246 },
    { 0xbd94864d, 0x3f72ded5 }, { 0x3e0da566, 0xbf824520 }, { 0xbd892e72, 0xbc39c252 },
    { 0xbec35eba, 0xbdde6ec2 }, { 0xbcae0cc4, 0x3f2266bf }, { 0x3cd73159, 0x3f0a7a80 },
    { 0x3c6b18cb, 0xbcd0449c }, { 0x3df3f9f1, 0x3e7d051b }, { 0xbd9450cc, 0x3f794521 },
    { 0x3e0d0ff5, 0xbf87b8b5 }, { 0xbd9965c9, 0xbc70ffb6 }, { 0xbebf51a5, 0xbdfeeb30 },
    { 0xbc9ae0f8, 0x3f23c3ac }, { 0x3cd57d32, 0x3f0a182f }, { 0x3c7bd194, 0xbc896ced },
    { 0x3de9e5fd, 0x3e7b14e3 }, { 0xbd984762, 0x3f80ad9a }, { 0x3e0cc71c, 0xbf8df218 },
    { 0xbda8a5be, 0xbc954dba }, { 0xbebce5e8, 0xbe1254db }, { 0xbc8f744c, 0x3f230444 },
    { 0x3cd9bb49, 0x3f07d8e9 }, { 0x3c857071, 0xbbabed36 }, { 0x3de0336f, 0x3e772ad0 },
    { 0xbd9e5109, 0x3f8305ea }, { 0x3e0aa0ec, 0xbf92518d }, { 0xbdb52748, 0xbcb12897 },
    { 0xbeb85c00, 0xbe2311c7 }, { 0xbc8de43c, 0x3f22d7e6 }, { 0x3ce97a81, 0x3f061246 },
    { 0x3c8c6f98, 0x3b4f4dfb }, { 0x3dda628d, 0x3e766bda }, { 0xbdaabf6e, 0x3f858022 },
    { 0x3e084b27, 0xbf9708dc }, { 0xbdc18455, 0xbcca2efe }, { 0xbeb35623, 0xbe32c971 },
    { 0xbc94a982, 0x3f22db24 }, { 0x3cfa3d52, 0x3f049c1a }, { 0x3c8fb440, 0x3bc4e1d6 },
    { 0x3dd72cc6, 0x3e74aff5 }, { 0xbdbe58e8, 0x3f88aa0a }, { 0x3e077b24, 0xbf9c899b },
    { 0xbdd02d96, 0xbcc9ce77 }, { 0xbeb0a96e, 0xbe3c56eb }, { 0xbc99b974, 0x3f21117c },
    { 0x3d00cb9f, 0x3f021d1c }, { 0x3c8a6cfc, 0x3b160bb2 }, { 0x3dd2ec57, 0x3e700966 },
    { 0xbdcf9ff6, 0x3f8b11ca }, { 0x3e08370a, 0xbfa10de8 }, { 0xbdde2d05, 0xbca81e6a },
    { 0xbeaf11dd, 0xbe40390e }, { 0xbc98d2d2, 0x3f1d7655 }, { 0x3cfe3724, 0x3efd5af1 },
    { 0x3c746144, 0xbc126508 }, { 0x3dcb5600, 0x3e68f0b4 }, { 0xbdddd7ee, 0x3f8c8c6c },
    { 0x3e09c19e, 0xbfa45ef4 }, { 0xbde88d5f, 0xbc659a76 }, { 0xbeacff49, 0xbe3d2905 },
    { 0xbc927dc3, 0x3f174f62 }, { 0x3cf2cd17, 0x3ef37a19 }, { 0x3c3db4a8, 0xbccd87e3 },
    { 0x3dbe5099, 0x3e5c408e }, { 0xbdebcae4, 0x3f8c55c4 }, { 0x3e0bc548, 0xbfa5dc81 },
    { 0xbdec6abd, 0xbba6e452 }, { 0xbea87074, 0xbe2d1b0c }, { 0xbc85d3a2, 0x3f0e64fc },
    { 0x3cdfeba5, 0x3ee5868a }, { 0x3bf72a32, 0xbd23f9d1 }, { 0x3dac6f56, 0x3e4a88a4 },
    { 0xbdf5e396, 0x3f8997f6 }, { 0x3e0d4faf, 0xbfa482fe }, { 0xbde805c4, 0x3b9877ae },
    { 0xbe9fce2f, 0xbe13a48a }, { 0xbc65e6f6, 0x3f01dc7b }, { 0x3cc5180c, 0x3ed1b772 },
    { 0x3b6ac532, 0xbd50d87d }, { 0x3d95e22e, 0x3e33c64e }, { 0xbdf742ee, 0x3f829610 },
    { 0x3e0b78e6, 0xbf9def20 }, { 0xbdda397c, 0x3c58d559 }, { 0xbe913fdd, 0xbde67f36 },
    { 0xbc36b3b4, 0x3ede42b4 }, { 0x3ca34849, 0x3eb45120 }, { 0x39f06f80, 0xbd5d37d0 },
    { 0x3d7311c0, 0x3e15dd38 }, { 0xbde7a8a0, 0x3f663049 }, { 0x3e00186d, 0xbf8c6e23 },
    { 0xbdbe091f, 0x3ca04fc9 }, { 0xbe720fcb, 0xbd988ae9 }, { 0xbc00ef59, 0x3eaa73da },
    { 0x3c72b347, 0x3e8b21bd }, { 0xbaa34892, 0xbd4420a7 }, { 0x3d303dbc, 0x3ddee1ea },
    { 0xbdc06b77, 0x3f33e133 }, { 0x3dd0facc, 0xbf5d21d0 }, { 0xbd92998e, 0x3cb38cbd },
    { 0xbe321e74, 0xbd1780ac }, { 0xbb936d84, 0x3e58d698 }, { 0x3c14aca4, 0x3e323996 },
    { 0xbacd2f30, 0xbd0e4771 }, { 0x3cd44269, 0x3d8956d7 }, { 0xbd81f8b4, 0x3ee6752d },
    { 0x3d8a3e13, 0xbf0e5607 }, { 0xbd399b09, 0x3c8d4672 }, { 0xbdd654b3, 0xbc3ba362 },
    { 0xbad4fcfc, 0x3dc7f252 }, { 0x3b82643d, 0x3da6a868 }, { 0xba7a2ee7, 0xbca549b4 },
    { 0x3c3ae5a8, 0x3cf63127 }, { 0xbcf4911b, 0x3e51b879 }, { 0x3cf917a1, 0xbe80a0ec },
    { 0xbca69fe4, 0x3bc0c1d7 }, { 0xbd34b375, 0xbb1fdfe5 }, { 0xb91b6d70, 0x3d03fc23 },
    { 0x3a96cc55, 0x3cf05d19 }, { 0xb9861e2a, 0xbc33e6f0 }, { 0x3b7b7bdf, 0x3c17e56f },
    { 0xbc14a11d, 0x3d806637 }, { 0x3c016300, 0xbd92d12a }, { 0xbbbad34a, 0xbb3e9d6e },
    { 0xbc4303d4, 0xba256646 }, { 0x39c82430, 0x3c42b648 }, { 0x392a3a0a, 0x3c6e59ca },
    { 0xb87fb560, 0xbbecb50e }, { 0x3ada7f27, 0x3b7771b4 }, { 0xbb10302f, 0x3cb9072b },
    { 0x3af25843, 0xbcb38059 }, { 0xba90a27c, 0xbbf0e286 }, { 0xbb4cbb57, 0xbb1f5ece },
    { 0x3989f068, 0x3bcbcbc9 }, { 0x39022e76, 0x3c006d88 }, { 0xb8e40eac, 0xbb6f9b5d },
    { 0x3a17782b, 0x3b319179 }, { 0xba301cd7, 0x3c38fcc4 }, { 0x3a304a1b, 0xbc341b1a },
    { 0xb9818676, 0xbbc68270 }, { 0xba699f25, 0xbb54fcfe }, { 0x38cb7fb4, 0x3b38e3aa },
    { 0x387a512f, 0x3b573fc7 }, { 0xb8bfa680, 0xbacfff17 }, { 0x39151137, 0x3a8fd379 },
    { 0xb98a741a, 0x3ba7d7da }, { 0x399add05, 0xbbaa36cf }, { 0xb870fff0, 0xbb1f3ed9 },
    { 0xb96dea56, 0xbac8bfce }, { 0x37b17cf0, 0x3a81b308 }, { 0x379c296a, 0x3a7960d1 },
    { 0xb81efe40, 0xb9dc7519 }, { 0x37ebc678, 0x39999df4 }, { 0xb8f5b2f7, 0x3af94b1b },
    { 0x390e84dd, 0xbb09c9e4 }, { 0xb7ec1602, 0xba0f336f }, { 0xb890f5b9, 0xba10fd3f },
    { 0x36977946, 0x3a0b4f15 }, { 0x37122581, 0x39ef89a7 }, { 0xb78c8e1a, 0xb8f4f12f },
    { 0x37200e3c, 0x3901e13e }, { 0xb8be871e, 0x3a9fb688 }, { 0x38ca6b14, 0xbabc486f },
    { 0xb7cbdabb, 0xb8f08201 }, { 0xb8464bae, 0xb9a79a47 }, { 0x36cbd83a, 0x3a0175b0 },
    { 0x370352b5, 0x39dd9f81 }, { 0xb743a011, 0xb8cbc910 }, { 0x3706d8c9, 0x38e35259 },
    { 0xb8a69b72, 0x3a93769e }, { 0x38c1924c, 0xbaaec67e }, { 0xb780a299, 0xb8b59d65 },
    { 0xb8345fe3, 0xb99201f9 }, { 0x36e414cc, 0x39f0af13 }, { 0x36f90da8, 0x39cd30b4 },
    { 0xb70ffc80, 0xb8bf56a8 }, { 0x36ebe614, 0x38d1659e }, { 0xb895d630, 0x3a887e6d },
    { 0x38b49009, 0xbaa24599 }, { 0xb73908ff, 0xb8a05a17 }, { 0xb81ee676, 0xb98484df },
    { 0x36e61081, 0x39e0ad52 }, { 0x36e84a6a, 0x39bf0689 }, { 0xb6dd7f86, 0xb8b41837 },
    { 0x36d0a78d, 0x38c3b5fe }, { 0xb88aaada, 0x3a7e658e }, { 0x38a6a249, 0xba978fb6 },
    { 0xb717587e, 0xb88eb883 }, { 0xb80ce9fa, 0xb973349d }, { 0x36e1fc32, 0x39d32375 },
    { 0x36dad608, 0x39b37505 }, { 0xb6b1f3c0, 0xb8a9f2eb }, { 0x36bbb0ed, 0x38b883f7 },
    { 0xb8820238, 0x3a6ec52d }, { 0x389b4a97, 0xba8eb6ad }, { 0xb705cdc1, 0xb87fefc2 },
    { 0xb7fc0595, 0xb9613e5d }, { 0x36de8e5f, 0x39c81af5 }, { 0x36daaa69, 0x39aa3a22 },
    { 0xb696b808, 0xb8a187d1 }, { 0x36ae5b15, 0x38af7472 }, { 0xb875265f, 0x3a6210b0 },
    { 0x3894ab68, 0xba877433 }, { 0xb6f8a309, 0xb86891c4 }, { 0xb7e1ff05, 0xb95282c7 },
    { 0x36d9daf9, 0x39bf865a }, { 0x36d959aa, 0x39a2e5ac }, { 0xb685722a, 0xb89b4cc5 },
    { 0x36a48205, 0x38a87282 }, { 0xb86a339f, 0x3a585a33 }, { 0x388f032c, 0xba818859 },
    { 0xb6ea55f6, 0xb85713ac }, { 0xb7cea173, 0xb9466b75 }, { 0x36d35c89, 0x39b8dc4c },
    { 0x36cdb0be, 0x399d23ec }, { 0xb671113b, 0xb89691b9 }, { 0x369ae8fc, 0x38a32fd9 },
    { 0xb862fe74, 0x3a50f37d }, { 0x38883908, 0xba79a547 }, { 0xb6dc4983, 0xb849ff92 },
    { 0xb7c27c9a, 0xb93cd114 }, { 0x36cd4317, 0x39b3bc34 }, { 0x36c4bcbb, 0x39990f94 },
    { 0xb6604ed0, 0xb892d43f }, { 0x369464b8, 0x389f6347 }, { 0xb85d55d2, 0x3a4b1877 },
    { 0x388331f3, 0xba72e212 }, { 0xb6d178f3, 0xb83faf0b }, { 0xb7ba3758, 0xb935cd39 },
    { 0x36c96ac8, 0x39b02d6c }, { 0x36c6ec7c, 0x39962d0a }, { 0xb65ad32b, 0xb88ff8de },
    { 0x36926800, 0x389d0a76 }, { 0xb8588192, 0x3a470021 }, { 0x3881a0e8, 0xba6e3b10 },
    { 0xb6ccd247, 0xb8379659 }, { 0xb7b310bd, 0xb9313604 }, { 0x36c8254f, 0x39ae1bf6 },
    { 0x36cbfe9e, 0x39946274 }, { 0xb65a0e23, 0xb88e2dcc }, { 0x36917516, 0x389ba87d },
    { 0xb8557e17, 0x3a44e1cc }, { 0x3881975f, 0xba6b596e }, { 0xb6caee48, 0xb832599f },
    { 0xb7ad65c5, 0xb92e3dd5 }, { 0x36911bcb, 0x39780f44 }, { 0x3656c075, 0x39154999 },
    { 0xb6205762, 0xb8380f36 }, { 0x35b76ea5, 0x38286de1 }, { 0xb823e3a0, 0x3a164416 },
    { 0x37db0be3, 0xb9c31a16 }, { 0xb60d7bf2, 0xb865a169 }, { 0xb74f889d, 0xb8750e0d } };

static const unsigned int DECMTX_SECOND[HYBRID_BANDS * NUM_EARS * (SH_ORDER_SECOND + 1)
    * (SH_ORDER_SECOND + 1)][2] = { { 0x3f8b6909, 0x0 }, { 0x3cce1bdf, 0x0 }, { 0x3bcffb62, 0x0 },
    { 0x3b01fe5c, 0x0 }, { 0x398d3ef8, 0x0 }, { 0x3a0dbdbc, 0x0 }, { 0x38f7e24c, 0x0 },
    { 0xb884770a, 0x0 }, { 0xba6a0aa6, 0x0 }, { 0x3f8b0b94, 0x0 }, { 0xbd1d2571, 0x0 },
    { 0x3be4ff92, 0x0 }, { 0x3b96a208, 0x0 }, { 0xba05bfce, 0x0 }, { 0xba8469d5, 0x0 },
    { 0x38de5162, 0x0 }, { 0x39c39657, 0x0 }, { 0xb9720fde, 0x0 }, { 0x3f880e9e, 0xbad33390 },
    { 0x3d54d8e7, 0x3e5ca277 }, { 0x3cc185c6, 0x3c9298b5 }, { 0x3ba1de92, 0x3c8fe59d },
    { 0xba0ba6fa, 0x3a21ddcb }, { 0x3a15c151, 0xbb13b19f }, { 0x3ba8a6af, 0xbc2fb515 },
    { 0x3a6287f7, 0xbabdb584 }, { 0x3b698000, 0xbb2d9f08 }, { 0x3f8597b1, 0x3a35e351 },
    { 0xbd876890, 0xbe8f030d }, { 0x3cc4e9db, 0x3cab59dd }, { 0x3c0a255f, 0x3ce09f4d },
    { 0x3aad6821, 0xbaa85114 }, { 0xba31d5b4, 0x3b38307d }, { 0x3ba557ec, 0xbc2b4057 },
    { 0x3ab32115, 0xbab5b1df }, { 0x3b87af33, 0xbb15960a }, { 0x3f8070ed, 0x3c05305e },
    { 0x3db15670, 0x3eca0fbf }, { 0x3d302d64, 0xba8d1943 }, { 0x3c5b75d3, 0x3ce05d72 },
    { 0xbb54dea7, 0x3af8bc87 }, { 0xbb2ddc37, 0xbbe298a2 }, { 0x3bc43925, 0xbcc7329a },
    { 0x3ad85011, 0xbbb08a8d }, { 0x3c66fb6b, 0xbba62149 }, { 0x3f79efe7, 0x3c68dcb1 },
    { 0xbdc20950, 0xbee6be58 }, { 0x3d32732c, 0x3ba3e7ba }, { 0x3c967d30, 0x3d33b0ef },
    { 0x3b969e26, 0xbb2d6692 }, { 0x3b6e7fcc, 0x3bea5061 }, { 0x3bc7c448, 0xbcc05206 },
    { 0x3ad9c421, 0xbbb5d039 }, { 0x3c6e78dd, 0xbb8f380c }, { 0x3f6f2a7e, 0x3cd28c52 },
    { 0x3de75ebe, 0x3f017df8 }, { 0x3d269040, 0xbcbc0bd9 }, { 0x3c992aae, 0x3ce539d6 },
    { 0xbba32b8c, 0x3b39755f }, { 0xbbf4726b, 0xbbecfe53 }, { 0x3baf59ff, 0xbcfb2c37 },
    { 0x39ce989e, 0xbc11a5a3 }, { 0x3cbbb5f6, 0xbbd725fa }, { 0x3f695d17, 0x3d027bc2 },
    { 0xbdebf878, 0xbf0b1fb6 }, { 0x3d2d8268, 0xbc74c906 }, { 0x3cc99bae, 0x3d441010 },
    { 0x3beedffb, 0xbb6c1e37 }, { 0x3c0960cc, 0x3bd73534 }, { 0x3bbac749, 0xbcf39361 },
    { 0xb981a2dd, 0xbc141323 }, { 0x3cbdb365, 0xbbb4a618 }, { 0x3f52aeee, 0x3db1585c },
    { 0x3e18306a, 0x3f26dedb }, { 0x3c289a7b, 0xbd41afd9 }, { 0x3c9ac9da, 0x3cca273c },
    { 0xbc1d0879, 0x3b8aae5e }, { 0xbc25ba29, 0xbb16b120 }, { 0x3b368830, 0xbd0e065c },
    { 0xbba5a690, 0xbc474cc4 }, { 0x3d2f2fda, 0xbbf9b894 }, { 0x3f4fbe68, 0x3dbd0dbf },
    { 0xbe130591, 0xbf2a5f19 }, { 0x3c6e17f2, 0xbd1e5810 }, { 0x3cd1cfce, 0x3d4b7fa2 },
    { 0x3c47112f, 0xbbb03174 }, { 0x3c2a81b8, 0x3ab3bf07 }, { 0x3b66a32b, 0xbd0c7d93 },
    { 0xbbdd2866, 0xbc3dd7bb }, { 0x3d324142, 0xbbc18264 }, { 0x3f406eb5, 0x3e013c3d },
    { 0x3e37ec72, 0x3f3881b8 }, { 0xbc9531d3, 0xbd3ffc41 }, { 0x3c7587ad, 0x3cc50d6c },
    { 0xbc473033, 0x3bca644b }, { 0xbbfa1120, 0xbaf462c9 }, { 0x3b7a1a57, 0xbcf73b49 },
    { 0xbc101874, 0xbc3c751d }, { 0x3d6e9a2b, 0xbc2694ee }, { 0x3f3ebb9a, 0x3e0835ae },
    { 0xbe30d9bc, 0xbf3a1866 }, { 0xbc5e6ee7, 0xbd1f53f9 }, { 0x3cbc0c75, 0x3d50874a },
    { 0x3c793cbb, 0xbbcbe69c }, { 0x3bffd0bf, 0x3a98a22b }, { 0x3b9183aa, 0xbcf75326 },
    { 0xbc2f326b, 0xbc2dee90 }, { 0x3d738f90, 0xbc05d910 }, { 0x3f232d44, 0x3e6925cf },
    { 0x3e41dbdf, 0x3f4605ee }, { 0xbd5c1680, 0xbcb3a306 }, { 0x3bc1f493, 0x3ce7e4c8 },
    { 0xbc842b42, 0x3bd7e2e3 }, { 0xbbc1d4b4, 0xbbf07f04 }, { 0x3c9c8665, 0xbca59839 },
    { 0xbc4b3739, 0xbc25c685 }, { 0x3db1395d, 0xbc2636e6 }, { 0x3f215cb2, 0x3e705b13 },
    { 0xbe3a29bc, 0xbf46b28e }, { 0xbd49809e, 0xbc6887a9 }, { 0x3c248732, 0x3d5f8985 },
    { 0x3cb37f9b, 0xbbb3a22e }, { 0x3bce533e, 0x3c006f42 }, { 0x3ca102b7, 0xbca34842 },
    { 0xbc82df33, 0xbc11c673 }, { 0x3db4b9ce, 0xbbe66294 }, { 0x3f1b05ec, 0x3ea56447 },
    { 0x3e3f0b67, 0x3f51baff }, { 0xbd845b78, 0x3b780beb }, { 0x3a0c577a, 0x3d117ac9 },
    { 0xbcaa4b27, 0x3bfdc661 }, { 0xbbf21dbc, 0xbc666064 }, { 0x3d1b64ba, 0xbc876b30 },
    { 0xbc85b20e, 0xbc14bead }, { 0x3dee0114, 0xbc3cae7d }, { 0x3f1854dd, 0x3ea92f99 },
    { 0xbe35c905, 0xbf52150a }, { 0xbd76248c, 0x3c2c900c }, { 0xb90119a7, 0x3d88a943 },
    { 0x3cec540c, 0xbbbb9c5b }, { 0x3c122d56, 0x3c8072b1 }, { 0x3d1dc4b1, 0xbc850094 },
    { 0xbcaa7477, 0xbbbad1bc }, { 0x3df28065, 0xbbfba6da }, { 0x3f163e83, 0x3ecef1be },
    { 0x3e651b20, 0x3f52c8e1 }, { 0xbd6b5943, 0x3d1c5834 }, { 0xbb933008, 0x3d3f9dbc },
    { 0xbccc0791, 0x3c3cbd9a }, { 0xbcaa0424, 0xbcc1a47f }, { 0x3d99589d, 0xbcc2bcaa },
    { 0xbca480ee, 0xba22facb }, { 0x3e2633d0, 0xbcf597b4 }, { 0x3f12b9ca, 0x3ed449c0 },
    { 0xbe57b617, 0xbf5282ab }, { 0xbd63d530, 0x3d309d22 }, { 0xb97ced24, 0x3dada3d3 },
    { 0x3d1c2295, 0xbc1442fb }, { 0x3ccbdc59, 0x3cd01167 }, { 0x3d984b93, 0xbcbcc687 },
    { 0xbcb664bb, 0x3ba75a8f }, { 0x3e2907df, 0xbccb067f }, { 0x3ef71b0a, 0x3efcef1b },
    { 0x3e075bf2, 0x3f451f43 }, { 0xbd247ca9, 0x3d468191 }, { 0xbc35cbb4, 0x3d793829 },
    { 0xbcf7bfc5, 0x3c50a3ea }, { 0xbd1da620, 0xbc89b4aa }, { 0x3dd7e685, 0xbd3f5b94 },
    { 0xbc4ba968, 0x3b1b27cd }, { 0x3e50e9e7, 0xbd2ae27f }, { 0x3eeddc09, 0x3f00cc2e },
    { 0xbde9c7e4, 0xbf43fbe4 }, { 0xbd2c7ed5, 0x3d5ae4ab }, { 0xbc0acd61, 0x3dbd0aea },
    { 0x3d453760, 0xbc290a43 }, { 0x3d3370f3, 0x3c9c1f39 }, { 0x3dd5a6b0, 0xbd2f5714 },
    { 0xbc4befcb, 0x3bdd83c1 }, { 0x3e54c113, 0xbd0cb382 }, { 0x3eb4433e, 0x3f1d644a },
    { 0xbc70b546, 0x3f4956e8 }, { 0xbcdb0e86, 0x3d4c86c5 }, { 0xbc6baf20, 0x3d9f1e38 },
    { 0xbd15a32a, 0x3c8b51c9 }, { 0xbd33a643, 0x3b8293f0 }, { 0x3e07bb94, 0xbd92ea89 },
    { 0xbc3f4575, 0xbb192e02 }, { 0x3e8c32d4, 0xbd6e4f36 }, { 0x3ea46019, 0x3f204694 },
    { 0x3d3f1f22, 0xbf470ac9 }, { 0xbd0e531c, 0x3d6bf468 }, { 0xbc94a988, 0x3dd61e21 },
    { 0x3d7d55d1, 0xbc74ee39 }, { 0x3d5e5d21, 0x39f7ba6c }, { 0x3e095708, 0xbd7f82fd },
    { 0xbc4f5115, 0xbb207c83 }, { 0x3e8ef572, 0xbd3dc5f9 }, { 0x3e3f1400, 0x3f27c2a7 },
    { 0xbe09c7cb, 0x3f41bce9 }, { 0xbc991c43, 0x3cf591f3 }, { 0xbc7fcb57, 0x3da24e7e },
    { 0xbd1b064a, 0x3c56fda6 }, { 0xbccb6a49, 0x3b32e4e8 }, { 0x3e0d9e79, 0xbd98d113 },
    { 0xbc60b02d, 0xbb8f4f86 }, { 0x3e9e0638, 0xbd8814fd }, { 0x3e17f7bc, 0x3f2b9499 },
    { 0x3e392738, 0xbf3efc49 }, { 0xbcea1395, 0x3d343562 }, { 0xbd05dca4, 0x3dcae6a4 },
    { 0x3d861b2a, 0xbc314e39 }, { 0x3d265e13, 0xbace2264 }, { 0x3e161631, 0xbd7fe1d1 },
    { 0xbc9e5b76, 0xbb9408f0 }, { 0x3ea3a332, 0xbd49ab0e }, { 0x3c3d46f8, 0x3f28d9cb },
    { 0xbe926435, 0x3f32dbc0 }, { 0xbd1705ed, 0x3ac3a3ec }, { 0xbcb654af, 0x3d9392cd },
    { 0xbd42ff18, 0x3b434a9d }, { 0xbcd240e1, 0xbcd565bb }, { 0x3e132ea3, 0xbd5a65ee },
    { 0xbca2181e, 0xbbb3eb9e }, { 0x3eaadf8f, 0xbd231265 }, { 0xbd0f7117, 0x3f2d2bdc },
    { 0x3eb05621, 0xbf3062ba }, { 0xbd1be8ef, 0x3c73b701 }, { 0xbd6872ee, 0x3db6b5a2 },
    { 0x3d9e4719, 0x3bf2ebed }, { 0x3d210d32, 0x3cca53c5 }, { 0x3e208184, 0xbd31be74 },
    { 0xbce5c753, 0xbbb54c51 }, { 0x3eb23586, 0xbcaa8381 }, { 0x3e3175d0, 0x3f23af4b },
    { 0xbe8e0cc5, 0x3f337630 }, { 0xbcf4e504, 0x3a1eaee4 }, { 0xbc572bb6, 0x3d9a70fb },
    { 0xbd3a9ebb, 0xbb12b67f }, { 0xbccfd6f7, 0xbca4585d }, { 0x3ddb647d, 0xbcc529c4 },
    { 0xbc949264, 0xbb6dc1c9 }, { 0x3e8f8371, 0x3c7bb4e3 }, { 0x3e0de691, 0x3f2d3f8d },
    { 0x3eabc66a, 0xbf32d577 }, { 0xbd064358, 0x3c5c7fa2 }, { 0xbd4b15ad, 0x3db69399 },
    { 0x3d912193, 0x3c967252 }, { 0x3d217c7b, 0x3cad3d5e }, { 0x3de79473, 0xbc729547 },
    { 0xbce5e2a7, 0xbaa53ed1 }, { 0x3e93f64a, 0x3d0a16c2 }, { 0x3e61824d, 0x3f204197 },
    { 0xbe8d80a0, 0x3f32192d }, { 0xbccc7faf, 0x3bdab306 }, { 0xbb4d2966, 0x3d9f3c72 },
    { 0xbd2da2b1, 0x3a349402 }, { 0xbcd7990d, 0xbc3910c7 }, { 0x3db36adb, 0xbbbf745c },
    { 0xbc48ce7f, 0x3af3bcff }, { 0x3e680f23, 0x3cd55f04 }, { 0x3e40db9b, 0x3f2af620 },
    { 0x3eaa40f2, 0xbf314a57 }, { 0xbd060f5d, 0x3c30544e }, { 0xbd270aac, 0x3db46174 },
    { 0x3d808703, 0x3c82be89 }, { 0x3d24beb3, 0x3c819242 }, { 0x3db1e04a, 0xbb018ba5 },
    { 0xbc9b69fb, 0x3c0afcd2 }, { 0x3e6f26e3, 0x3d321441 }, { 0x3e825d2b, 0x3f256542 },
    { 0xbe8f9de3, 0x3f346b05 }, { 0x39726762, 0x3d331265 }, { 0xba5b247f, 0x3da86b8e },
    { 0xbd22eda9, 0x3b87d35e }, { 0xbd176160, 0x3c6d3c72 }, { 0x3da5f384, 0x3c3865c8 },
    { 0xbb98dde8, 0x3c5e8f61 }, { 0x3e481790, 0x3d04b721 }, { 0x3e612149, 0x3f320932 },
    { 0x3eb007de, 0xbf353c76 }, { 0xbc505063, 0x3d3e576a }, { 0xbd1e2662, 0x3db52ae1 },
    { 0x3d6a11a5, 0x3c65f71a }, { 0x3d584e82, 0xbc26436c }, { 0x3d9e05a1, 0x3c355e14 },
    { 0xbc923161, 0x3c5dab9d }, { 0x3e50f309, 0x3d3e2397 }, { 0x3e834705, 0x3f256f6d },
    { 0xbe8425be, 0x3f2f2765 }, { 0xbbecf772, 0x3d1e4a4a }, { 0x38971620, 0x3db41f1d },
    { 0xbd17b1f3, 0x3c6877fe }, { 0xbcfb500c, 0x3c3550ae }, { 0x3d81a6b8, 0x3c69330a },
    { 0xbafe32c6, 0x3c94871a }, { 0x3e2b2910, 0x3d08da6e }, { 0x3e634541, 0x3f31951a },
    { 0x3ea4a839, 0xbf310cdf }, { 0xbcc05267, 0x3cd9dc6b }, { 0xbd0be808, 0x3db7c27f },
    { 0x3d57ae18, 0x3b9dec82 }, { 0x3d2dfaad, 0xbab15772 }, { 0x3d72dd18, 0x3c2a6be1 },
    { 0xbc649297, 0x3c757268 }, { 0x3e35665a, 0x3d3e79e8 }, { 0x3e8583ef, 0x3f280141 },
    { 0xbe7d0f36, 0x3f302441 }, { 0xbc1061a0, 0x3d19be91 }, { 0xbb643a56, 0x3dc23df3 },
    { 0xbd16af17, 0x3cca1709 }, { 0xbd0431a0, 0x3c6aad76 }, { 0x3d4112af, 0x3c39ab69 },
    { 0xbb3039c8, 0x3c97dcf5 }, { 0x3e19dd66, 0x3d13b9b4 }, { 0x3e69b1bf, 0x3f34b56b },
    { 0x3e9e6f79, 0xbf339e56 }, { 0xbcda4363, 0x3c93aa75 }, { 0xbd10dcbf, 0x3dca12f3 },
    { 0x3d5795c0, 0xbbed6268 }, { 0x3d283fcb, 0xba0a3f56 }, { 0x3d31b2b7, 0x3c0dae74 },
    { 0xbc459688, 0x3c9e7c96 }, { 0x3e249aaa, 0x3d58b471 }, { 0x3e7ebaf7, 0x3f212ccc },
    { 0xbe6a79b6, 0x3f2c377a }, { 0xbc2d6dc6, 0x3d0450a4 }, { 0xbc281fac, 0x3db8cff9 },
    { 0xbd145ae7, 0x3d01df3f }, { 0xbd0fac49, 0x3c99bedc }, { 0x3d080999, 0x3be646cd },
    { 0xbb293a74, 0x3c8bf2fb }, { 0x3e04d52f, 0x3d1303f1 }, { 0x3e614022, 0x3f302bdf },
    { 0x3e9480ed, 0xbf32becd }, { 0xbcc9790c, 0x3ccbe85f }, { 0xbd0e9205, 0x3dde2958 },
    { 0x3d58a5ed, 0xbcaaf096 }, { 0x3d3202df, 0xbc064e81 }, { 0x3cf6aaf8, 0x3c2214b8 },
    { 0xbc237b39, 0x3cbb7843 }, { 0x3e0f3a1a, 0x3d681916 }, { 0x3e775948, 0x3f1c0c80 },
    { 0xbe582634, 0x3f2a3047 }, { 0xbc0f8a7d, 0x3cc018e1 }, { 0xbc518529, 0x3db8e9a4 },
    { 0xbd15d231, 0x3d1d7132 }, { 0xbd1da65b, 0x3c8a3c5a }, { 0x3cce8e39, 0x3bacc2b7 },
    { 0xbb096d30, 0x3c810f00 }, { 0x3de6f95f, 0x3d207e97 }, { 0x3e5feb73, 0x3f2f5d63 },
    { 0x3e8e8818, 0xbf358b96 }, { 0xbc9d59b8, 0x3d0d7ea8 }, { 0xbd1d6780, 0x3dea2f14 },
    { 0x3d5aed6d, 0xbd00dbc9 }, { 0x3d41f8e2, 0xbc41719d }, { 0x3caf9717, 0x3c434073 },
    { 0xbc2625ad, 0x3ca830af }, { 0x3dfed751, 0x3d7508b7 }, { 0x3e76f7d9, 0x3f1d7834 },
    { 0xbe4549b9, 0x3f2a5dd8 }, { 0xbbc269ca, 0x3ccecfdb }, { 0xbc44b135, 0x3dcdedce },
    { 0xbd17f38c, 0x3d4295cd }, { 0xbd26378b, 0x3c909fc8 }, { 0x3ca1ac37, 0x3bc2a45f },
    { 0xbae74cb8, 0x3c83e250 }, { 0x3dd0ec78, 0x3d383e31 }, { 0x3e629c8e, 0x3f33b80a },
    { 0x3e8964e2, 0xbf3963e8 }, { 0xbc8971cd, 0x3d314fb1 }, { 0xbd315d7b, 0x3dfc3877 },
    { 0x3d5f2c84, 0xbd2da4eb }, { 0x3d4ba301, 0xbc6e65ce }, { 0x3c669fd5, 0x3c29308a },
    { 0xbc2eb929, 0x3c922adb }, { 0x3debc9f1, 0x3d803b06 }, { 0x3e7a1b6b, 0x3f22e9cb },
    { 0xbe3a4d2b, 0x3f2eb3b2 }, { 0xbb83f875, 0x3d0e356f }, { 0xbc27d01c, 0x3deefa73 },
    { 0xbd1bdb0c, 0x3d7971c5 }, { 0xbd307c10, 0x3cb14249 }, { 0x3c7e3159, 0x3c006b1d },
    { 0xbaa9edc4, 0x3c903f5a }, { 0x3dc1d957, 0x3d474b8c }, { 0x3e62eaa9, 0x3f388bd7 },
    { 0x3e843387, 0xbf3dab27 }, { 0xbc7becb3, 0x3d46b9c6 }, { 0xbd35e815, 0x3e0e5063 },
    { 0x3d64aec9, 0xbd691aea }, { 0x3d53cbec, 0xbc81370c }, { 0x3c09b2fc, 0x3c070cdf },
    { 0xbc23e163, 0x3c8441a7 }, { 0x3ddb14e4, 0x3d84d7b7 }, { 0x3e7e4376, 0x3f29d917 },
    { 0xbe3612d8, 0x3f363058 }, { 0xba96b771, 0x3d523b84 }, { 0xbc2a3894, 0x3e086003 },
    { 0xbd203a81, 0x3da23f06 }, { 0xbd40317b, 0x3ceb3c82 }, { 0x3c51a02f, 0x3c374910 },
    { 0xba520c72, 0x3c9e84c0 }, { 0x3db602f3, 0x3d4bf1da }, { 0x3e5d0c49, 0x3f3a446c },
    { 0x3e7ce3df, 0xbf3fdaa1 }, { 0xbc3c02c0, 0x3d673898 }, { 0xbd2aa405, 0x3e227cac },
    { 0x3d676c7f, 0xbd99835d }, { 0x3d5d49b9, 0xbc95e5ca }, { 0x3b9ed147, 0x3c031e1b },
    { 0xbc1ad671, 0x3c6292d9 }, { 0x3dc8127f, 0x3d851751 }, { 0x3e839ba9, 0x3f32e869 },
    { 0xbe35c67e, 0x3f415d72 }, { 0x3af91686, 0x3d8a63a5 }, { 0xbc606b62, 0x3e1abc65 },
    { 0xbd28077f, 0x3dd42b91 }, { 0xbd52fd57, 0x3d088914 }, { 0x3c25165e, 0x3c5497b7 },
    { 0xb9084376, 0x3cb1c1ea }, { 0x3db07805, 0x3d579acd }, { 0x3e5aa906, 0x3f3e4aeb },
    { 0x3e788765, 0xbf45b769 }, { 0xbbee80e1, 0x3d819e01 }, { 0xbd291051, 0x3e3830e6 },
    { 0x3d6f6147, 0xbdc9055a }, { 0x3d687b7f, 0xbca016f3 }, { 0x3ae388c6, 0x3bcff070 },
    { 0xbc1b643f, 0x3c269e8d }, { 0x3dbc0aa1, 0x3d86b429 }, { 0x3e84a585, 0x3f372d8e },
    { 0xbe300281, 0x3f46c2ea }, { 0x3b4b5f8a, 0x3d9e6dc1 }, { 0xbca49100, 0x3e29bf6c },
    { 0xbd2b1b81, 0x3e04d00b }, { 0xbd5c7467, 0x3d18acc3 }, { 0x3bcfed69, 0x3c34aeb2 },
    { 0x3a78535a, 0x3ccd553d }, { 0x3daa7db0, 0x3d5e6ec3 }, { 0x3e53dbd6, 0x3f3f7ca0 },
    { 0x3e711d01, 0xbf489759 }, { 0xbb42f201, 0x3d93aa4c }, { 0xbd2c9632, 0x3e4b6d4a },
    { 0x3d7574bd, 0xbdfd8571 }, { 0x3d6c3b4b, 0xbcb98b26 }, { 0xbaab1246, 0x3b5bcfd0 },
    { 0xbc116b72, 0x3c087626 }, { 0x3db076bc, 0x3d841d09 }, { 0x3e83600a, 0x3f38cb81 },
    { 0xbe248c5e, 0x3f454c0f }, { 0x3b8693a6, 0x3da42a68 }, { 0xbce7d6b2, 0x3e33fcba },
    { 0xbd28b6c1, 0x3e1a49de }, { 0xbd5e8999, 0x3d1c9d7f }, { 0x3b59d347, 0x3bc9bafe },
    { 0x3a8b6afe, 0x3cd5406f }, { 0x3da3a769, 0x3d547efe }, { 0x3e4b32c8, 0x3f3fb74f },
    { 0x3e672787, 0xbf479367 }, { 0x3b54d72e, 0x3dad67b4 }, { 0xbd34c7e4, 0x3e5ca49c },
    { 0x3d79200f, 0xbe15922d }, { 0x3d6ab9ae, 0xbcc124d3 }, { 0xbb763a90, 0x39dddafe },
    { 0xbbeff8fc, 0x3c3496db }, { 0x3da60cac, 0x3d790216 }, { 0x3e7d2aac, 0x3f375180 },
    { 0xbe1739b1, 0x3f418b50 }, { 0x3bff8588, 0x3daff11f }, { 0xbd135825, 0x3e3680ab },
    { 0xbd24c674, 0x3e280f52 }, { 0xbd5bf2d6, 0x3d210c14 }, { 0x3b20c82a, 0x3b42ee20 },
    { 0x39265100, 0x3cc84a86 }, { 0x3d9975d8, 0x3d34f23f }, { 0x3e3e1e30, 0x3f3e74a1 },
    { 0x3e5cf81c, 0xbf45c9f9 }, { 0x3c3db214, 0x3dd083d0 }, { 0xbd3d2a7f, 0x3e68e991 },
    { 0x3d7cc645, 0xbe26862b }, { 0x3d66cdc3, 0xbccddc1b }, { 0xbba70360, 0xbb560c78 },
    { 0xbbd45e2e, 0x3c86bed9 }, { 0x3d9c4ffc, 0x3d54aa3b }, { 0x3e6c23da, 0x3f325c7e },
    { 0xbe0ba413, 0x3f3d989a }, { 0x3c56da72, 0x3dc87536 }, { 0xbd29897b, 0x3e325818 },
    { 0xbd1e5184, 0x3e2f1941 }, { 0xbd52d961, 0x3d284906 }, { 0x3b3a5793, 0x3b204f25 },
    { 0xb907311c, 0x3ccba3a8 }, { 0x3d8be474, 0x3cfdbf1d }, { 0x3e2e8f51, 0x3f3c434f },
    { 0x3e53e5e9, 0xbf44fc5e }, { 0x3c9e195b, 0x3de568a8 }, { 0xbd43923d, 0x3e6f1c7c },
    { 0x3d7edaa3, 0xbe31ab31 }, { 0x3d5e1748, 0xbcdad549 }, { 0xbbbf5768, 0xbc3cc409 },
    { 0xbbe27ca6, 0x3ca46bf2 }, { 0x3d948c48, 0x3d231d22 }, { 0x3e5b8e2e, 0x3f2e83ee },
    { 0xbe0500d9, 0x3f3a16ea }, { 0x3ca33e89, 0x3de961aa }, { 0xbd306d44, 0x3e315abf },
    { 0xbd15fb64, 0x3e322998 }, { 0xbd46ddd9, 0x3d2aa18c }, { 0x3b57f910, 0x3ae62ee3 },
    { 0xba22a963, 0x3cdb9030 }, { 0x3d809a92, 0x3c80ba36 }, { 0x3e215169, 0x3f3b40d5 },
    { 0x3e4ce904, 0xbf43d8f4 }, { 0x3ce0fef9, 0x3df5ae32 }, { 0xbd4c9909, 0x3e703706 },
    { 0x3d7ae145, 0xbe374500 }, { 0x3d52e71d, 0xbcdb1c2f }, { 0xbba331c5, 0xbca7e718 },
    { 0xbbfe1a68, 0x3cc7c29f }, { 0x3d8e5a73, 0x3cdf2f3f }, { 0x3e50ae5e, 0x3f2ec084 },
    { 0xbe017ec8, 0x3f39cf13 }, { 0x3ce51f8a, 0x3e04c26f }, { 0xbd3ea2fe, 0x3e31a5a5 },
    { 0xbd0f8b0d, 0x3e337a89 }, { 0xbd3db448, 0x3d28c1cd }, { 0x3b2e739a, 0xbb279c08 },
    { 0xbaf6b176, 0x3cef7be0 }, { 0x3d789f3c, 0x3a729cee }, { 0x3e14af52, 0x3f3c6abe },
    { 0x3e47e636, 0xbf440dea }, { 0x3d18c347, 0x3e0c0c50 }, { 0xbd4fc32a, 0x3e7120b1 },
    { 0x3d754673, 0xbe3917a3 }, { 0x3d4ae0fc, 0xbce0e191 }, { 0xbacc1c5a, 0xbcce2f7d },
    { 0xbc127b2b, 0x3d0a7bc6 }, { 0x3d888ac0, 0x3c4d66c0 }, { 0x3e44d0c7, 0x3f2f8e20 },
    { 0xbdf94050, 0x3f3b840c }, { 0x3d136ae2, 0x3e13a1a8 }, { 0xbd4cf11f, 0x3e3051c4 },
    { 0xbd0af7e7, 0x3e3077f1 }, { 0xbd34018e, 0x3d3417e5 }, { 0x3aa3c901, 0xbc3493f4 },
    { 0xbb6803f8, 0x3d082e8e }, { 0x3d7517ca, 0xbc7606ad }, { 0x3e06944b, 0x3f3d76c4 },
    { 0x3e428ffa, 0xbf450307 }, { 0x3d3f9d74, 0x3e22d8fe }, { 0xbd523538, 0x3e6dd5ce },
    { 0x3d703179, 0xbe358505 }, { 0x3d4422a4, 0xbd077ba4 }, { 0x3b3afca9, 0xbcde5baf },
    { 0xbc308bc4, 0x3d3e8c59 }, { 0x3d840c9c, 0xbb959e69 }, { 0x3e379736, 0x3f2e60b0 },
    { 0xbdf1443f, 0x3f3c5d4c }, { 0x3d395dc6, 0x3e21f91b }, { 0xbd55223e, 0x3e299eca },
    { 0xbd0933ca, 0x3e24e623 }, { 0xbd314ad0, 0x3d42b3fd }, { 0x3a3a15c3, 0xbca1c757 },
    { 0xbb8b9f5e, 0x3d285d32 }, { 0x3d6c28ee, 0xbd01a851 }, { 0x3df481e9, 0x3f3d61ab },
    { 0x3e3f570a, 0xbf46360e }, { 0x3d651090, 0x3e38b46c }, { 0xbd564680, 0x3e672d8b },
    { 0x3d6b5e5d, 0xbe2ad188 }, { 0x3d42d6a0, 0xbd26f0ad }, { 0x3bd3262d, 0xbcf2ddf2 },
    { 0xbc5c545f, 0x3d6e4d89 }, { 0x3d802ac7, 0xbcac5a27 }, { 0x3e2c5ee6, 0x3f2cabd3 },
    { 0xbdeccd24, 0x3f3c59f2 }, { 0x3d63a6be, 0x3e31eb50 }, { 0xbd5bc5fa, 0x3e201915 },
    { 0xbd090166, 0x3e128aa0 }, { 0xbd32961a, 0x3d53c57c }, { 0x3aedbc5a, 0xbcd10f70 },
    { 0xbb914d34, 0x3d53ed85 }, { 0x3d5ee3f1, 0xbd3e92a9 }, { 0x3de2a97d, 0x3f3c7c41 },
    { 0x3e3e01eb, 0xbf4780d4 }, { 0x3d825804, 0x3e4b95b4 }, { 0xbd5fc30e, 0x3e5ee2a0 },
    { 0x3d651f30, 0xbe1a26db }, { 0x3d43edf2, 0xbd4d81df }, { 0x3c1acedd, 0xbd095b9b },
    { 0xbc8526bc, 0x3d8dad0c }, { 0x3d78e0b3, 0xbd0f0b42 }, { 0x3e21e487, 0x3f2afe32 },
    { 0xbde37c17, 0x3f3ba25b }, { 0x3d811edd, 0x3e40c247 }, { 0xbd65072c, 0x3e145aad },
    { 0xbd071b52, 0x3df60e81 }, { 0xbd29dc8a, 0x3d77c812 }, { 0x3b784a9d, 0xbce15b0b },
    { 0xbb9b8742, 0x3d7f327b }, { 0x3d5167e3, 0xbd747418 }, { 0x3dd0c295, 0x3f3a9c72 },
    { 0x3e38a922, 0xbf47bdef }, { 0x3d8b75b5, 0x3e5a53e7 }, { 0xbd6a3c41, 0x3e571346 },
    { 0x3d5a320b, 0xbe053150 }, { 0x3d3dcc63, 0xbd824768 }, { 0x3c4f7114, 0xbd141df6 },
    { 0xbc99219a, 0x3da2b215 }, { 0x3d6ec66e, 0xbd383cd6 }, { 0x3e19aaeb, 0x3f2898c7 },
    { 0xbdd93525, 0x3f3ab65e }, { 0x3d8c1fdd, 0x3e50b99e }, { 0xbd6f4c60, 0x3e08b2c5 },
    { 0xbd021813, 0x3dc305a6 }, { 0xbd1e6af8, 0x3d9a2021 }, { 0x3bc78ee6, 0xbcd06bc4 },
    { 0xbbb43219, 0x3d93a437 }, { 0x3d433b0c, 0xbd8c8110 }, { 0x3dc37c2c, 0x3f3829ac },
    { 0x3e32fc82, 0xbf4790f8 }, { 0x3d93916b, 0x3e6cff68 }, { 0xbd7244a4, 0x3e50ed08 },
    { 0x3d4caa09, 0xbddcc06b }, { 0x3d39e987, 0xbda7af96 }, { 0x3c8d479b, 0xbd0cf6de },
    { 0xbcb05228, 0x3db44e1a }, { 0x3d601a9d, 0xbd4f5d39 }, { 0x3e14c8c1, 0x3f25bfd3 },
    { 0xbdcda498, 0x3f3a0f7e }, { 0x3d92df9c, 0x3e5e7d41 }, { 0xbd79cfc0, 0x3dfb6402 },
    { 0xbcf3f279, 0x3d911e7e }, { 0xbd13d845, 0x3db79586 }, { 0x3c0fa8e6, 0xbcb40829 },
    { 0xbc050d89, 0x3da0c6fb }, { 0x3d35e4dd, 0xbd96cb4f }, { 0x3dbc952c, 0x3f360f90 },
    { 0x3e2d4003, 0xbf47717f }, { 0x3d99b5d4, 0x3e815ab4 }, { 0xbd761ffb, 0x3e4d5088 },
    { 0x3d3e979b, 0xbdb0181a }, { 0x3d37c458, 0xbdcbaca1 }, { 0x3cbc6e2d, 0xbcef7b79 },
    { 0xbcc4fce6, 0x3dc324a2 }, { 0x3d4f7fe4, 0xbd55412f }, { 0x3e13f8d1, 0x3f240815 },
    { 0xbdbe0032, 0x3f3ada04 }, { 0x3d948ed6, 0x3e6b855f }, { 0xbd831bc4, 0x3de498b3 },
    { 0xbcded4c0, 0x3d4cd515 }, { 0xbd095e6a, 0x3dd1d643 }, { 0x3c499bf2, 0xbc9cfaa3 },
    { 0xbc5f5222, 0x3da7bb3b }, { 0x3d2de389, 0xbd9d3190 }, { 0x3dba7ca2, 0x3f35926a },
    { 0x3e24d2bc, 0xbf48423a }, { 0x3d982385, 0x3e8c6b0f }, { 0xbd786980, 0x3e4cea4e },
    { 0x3d30a694, 0xbd8aed8d }, { 0x3d329cdc, 0xbdecb96a }, { 0x3ce842f3, 0xbcc679c1 },
    { 0xbcd5c470, 0x3dd242ce }, { 0x3d42420a, 0xbd511080 }, { 0x3e16084a, 0x3f22ec9f },
    { 0xbda87d87, 0x3f3c1c6b }, { 0x3d90f5b4, 0x3e768f11 }, { 0xbd86a725, 0x3dcc4cbb },
    { 0xbcc43af7, 0x3d082f19 }, { 0xbd02c9a0, 0x3de61fc0 }, { 0x3c8628cd, 0xbc8b0b45 },
    { 0xbcb4f8b4, 0x3da80942 }, { 0x3d2a46db, 0xbda12eb3 }, { 0x3db71481, 0x3f33fb8e },
    { 0x3e1825f2, 0xbf4701f8 }, { 0x3d93f5e2, 0x3e944378 }, { 0xbd7bda56, 0x3e494e34 },
    { 0x3d1f8f5d, 0xbd52f7d7 }, { 0x3d2d018f, 0xbe02872f }, { 0x3cf8a5c6, 0xbc9fabc3 },
    { 0xbcddd359, 0x3ddc028d }, { 0x3d34d552, 0xbd4b94b4 }, { 0x3e2076f6, 0x3f24b498 },
    { 0xbd9109af, 0x3f3fe5d2 }, { 0x3d833078, 0x3e808cc5 }, { 0xbd7f91b3, 0x3db86901 },
    { 0xbca41874, 0x3cab8801 }, { 0xbd0c3bd2, 0x3de824aa }, { 0x3cba750a, 0xbc436407 },
    { 0xbd0914eb, 0x3dabb01c }, { 0x3d2bca60, 0xbda44563 }, { 0x3dba1519, 0x3f31e6c3 },
    { 0x3e0ba9a3, 0xbf45ccb1 }, { 0x3d918054, 0x3e977d3c }, { 0xbd844dbb, 0x3e40198c },
    { 0x3d0c0424, 0xbd19d220 }, { 0x3d2fe5f0, 0xbe041ee0 }, { 0x3d018e28, 0xbc863ea3 },
    { 0xbcef7955, 0x3ddbb513 }, { 0x3d29746a, 0xbd4cc8e1 }, { 0x3e3770d8, 0x3f2a6255 },
    { 0xbd5ecee0, 0x3f47c2b8 }, { 0x3d4f28a6, 0x3e888550 }, { 0xbd5a3e8f, 0x3da4f7c5 },
    { 0xbc683501, 0x3c4764db }, { 0xbd29e811, 0x3de32466 }, { 0x3d06a207, 0x3a83075e },
    { 0xbd4c8cf9, 0x3dace227 }, { 0x3d34f517, 0xbda9b632 }, { 0x3dc42926, 0x3f31f51c },
    { 0x3dfb3af2, 0xbf474253 }, { 0x3d8f41e6, 0x3e98aa29 }, { 0xbd8d34b4, 0x3e3a3c1e },
    { 0x3cee88ec, 0xbcedd992 }, { 0x3d3ee492, 0xbe00b6fd }, { 0x3d0ea282, 0xbc62da44 },
    { 0xbd09062d, 0x3dd748c0 }, { 0x3d22d741, 0xbd4fee28 }, { 0x3e59504c, 0x3f3265fb },
    { 0xbcdebccf, 0x3f51bbdd }, { 0x3cd23d87, 0x3e8dd3af }, { 0xbd0aa96f, 0x3d9b07d7 },
    { 0xbba5cec2, 0x3bfbe1df }, { 0xbd5d2f23, 0x3dd06e56 }, { 0x3d367d75, 0x3ca47482 },
    { 0xbd920cd9, 0x3da247ae }, { 0x3d42debb, 0xbdae007d }, { 0x3dd7382d, 0x3f351c2f },
    { 0x3dd3a128, 0xbf4b303c }, { 0x3d8a08b6, 0x3e986c2e }, { 0xbd979458, 0x3e35ab2b },
    { 0x3cbb463d, 0xbccc9f83 }, { 0x3d5bb842, 0xbded722d }, { 0x3d290067, 0xbbd2b9d4 },
    { 0xbd23c53f, 0x3dd269ce }, { 0x3d1e4b57, 0xbd5539ae }, { 0x3e7d0b06, 0x3f383050 },
    { 0x3c30bff0, 0x3f585ef2 }, { 0xbc3057bc, 0x3e884e42 }, { 0xbc0ccc5d, 0x3d92ee4f },
    { 0x3bf8499f, 0x3c100353 }, { 0xbd8eb269, 0x3db409ab }, { 0x3d51a0e8, 0x3d1affd9 },
    { 0xbdbe0f04, 0x3d89cb64 }, { 0x3d48f6a1, 0xbdac11d5 }, { 0x3df106cd, 0x3f3b13a4 },
    { 0x3d9ece3c, 0xbf51165d }, { 0x3d817bc0, 0x3e98e4b5 }, { 0xbd9d6ef7, 0x3e3496cb },
    { 0x3c7b9cdf, 0xbccda787 }, { 0x3d82ff00, 0xbdd1785a }, { 0x3d4ecd9f, 0x3c308fa7 },
    { 0xbd4267af, 0x3dcbc3f3 }, { 0x3d161bfc, 0xbd5a808b }, { 0x3e8af7b5, 0x3f3642e7 },
    { 0x3d61fffd, 0x3f551630 }, { 0xbd5bded5, 0x3e655185 }, { 0x3c8fe05e, 0x3d8c6523 },
    { 0x3cb1bd08, 0x3c68fff9 }, { 0xbdb1af48, 0x3d836f99 }, { 0x3d48e1e2, 0x3d3e0174 },
    { 0xbdde2b8c, 0x3d55ca47 }, { 0x3d3cbec1, 0xbd9ce99a }, { 0x3e0599a2, 0x3f41bfe5 },
    { 0x3d3c64b4, 0xbf564ea0 }, { 0x3d6cce7a, 0x3e96eb5b }, { 0xbda05b1c, 0x3e331f07 },
    { 0x3bda2861, 0xbce2da0b }, { 0x3d9cf1db, 0xbda7f8cc }, { 0x3d6d83ad, 0x3d035370 },
    { 0xbd5b9cf3, 0x3dc21407 }, { 0x3d076871, 0xbd62f7d8 }, { 0x3e8ec80c, 0x3f2d2935 },
    { 0x3dc62649, 0x3f480ba0 }, { 0xbdbb08fa, 0x3e2de4b4 }, { 0x3d1df333, 0x3d8c9466 },
    { 0x3d072c76, 0x3caec943 }, { 0xbdd197b3, 0x3d107969 }, { 0x3d2b2ef4, 0x3d4b4651 },
    { 0xbdea2e09, 0x3d1f8d44 }, { 0x3d1afdff, 0xbd84a179 }, { 0x3e100c90, 0x3f46cfb9 },
    { 0x3c302079, 0xbf5950de }, { 0x3d538008, 0x3e8fbc46 }, { 0xbda599ec, 0x3e2cc09f },
    { 0xbb0922fd, 0xbd0311fb }, { 0x3db88994, 0xbd6d74a7 }, { 0x3d752f35, 0x3d4718dd },
    { 0xbd700cd1, 0x3db65664 }, { 0x3ce5904b, 0xbd6b981f }, { 0x3e8c7998, 0x3f226c16 },
    { 0x3e04bbea, 0x3f384578 }, { 0xbdec7d6c, 0x3e026ebc }, { 0x3d485e6e, 0x3d88d3c2 },
    { 0x3d1fa159, 0x3ce42263 }, { 0xbdeb1fa6, 0x3c2a84c1 }, { 0x3d093832, 0x3d57db4b },
    { 0xbde69f88, 0x3cef0b4c }, { 0x3cde25dd, 0xbd5e52cf }, { 0x3e1688ca, 0x3f48e461 },
    { 0xbccc346c, 0xbf58a63b }, { 0x3d3051bd, 0x3e821d60 }, { 0xbdabb3df, 0x3e24f2c6 },
    { 0xbc113663, 0xbd19c251 }, { 0x3dd2df75, 0xbd02db67 }, { 0x3d6725ac, 0x3d65c51f },
    { 0xbd821a11, 0x3dada67c }, { 0x3cb24f2e, 0xbd6bc2e9 }, { 0x3e881cf9, 0x3f19a627 },
    { 0x3e1dc5ce, 0x3f2b632d }, { 0xbe03968e, 0x3dcc2c0e }, { 0x3d4b084c, 0x3d7132de },
    { 0x3d240f01, 0x3d04ade8 }, { 0xbdfe3156, 0xbbbe6133 }, { 0x3ccc1e51, 0x3d628d80 },
    { 0xbddc31f0, 0x3cb4c77b }, { 0x3c8965de, 0xbd4320d4 }, { 0x3e19d8fb, 0x3f48c81c },
    { 0xbd70709e, 0xbf5598a2 }, { 0x3cfc8ed4, 0x3e6403a5 }, { 0xbdaf4c45, 0x3e1decb5 },
    { 0xbc4c30c1, 0xbd2cbbd1 }, { 0x3de93f3a, 0xbc03a024 }, { 0x3d50998a, 0x3d799522 },
    { 0xbd8bb3ca, 0x3daa3cb9 }, { 0x3c6c4c3b, 0xbd6e5440 }, { 0x3e84920a, 0x3f138975 },
    { 0x3e317ffa, 0x3f2294eb }, { 0xbe0ca99c, 0x3da3da59 }, { 0x3d3cf949, 0x3d3fae9d },
    { 0x3d1cec51, 0x3d0f1a44 }, { 0xbe0826d9, 0xbc8fc6fe }, { 0x3c854702, 0x3d68c170 },
    { 0xbdd0a46d, 0x3c8e0f01 }, { 0x3befdde6, 0xbd33d3a1 }, { 0x3e1ba100, 0x3f4862f8 },
    { 0xbdb7d76d, 0xbf524abc }, { 0x3c9266b0, 0x3e4baf18 }, { 0xbdb0d986, 0x3e16125a },
    { 0xbc5bdbbd, 0xbd34edc9 }, { 0x3dff1f1c, 0x3c6e1314 }, { 0x3d3c13fd, 0x3d93a3b8 },
    { 0xbd9207c8, 0x3dad107c }, { 0x3bcb9706, 0xbd7ae71b }, { 0x3e82b458, 0x3f10c1b6 },
    { 0x3e439e16, 0x3f1d6726 }, { 0xbe1794ce, 0x3d84ae18 }, { 0x3d2cec99, 0x3d129ff3 },
    { 0x3d0f1f85, 0x3d1156f1 }, { 0xbe12bc99, 0xbcece0e0 }, { 0x3c00c4d6, 0x3d6f2a29 },
    { 0xbdc421ee, 0x3c916c21 }, { 0xbb24d17c, 0xbd30af32 }, { 0x3e1e2d5e, 0x3f4b09d4 },
    { 0xbdf545c7, 0xbf523578 }, { 0x3bed1e08, 0x3e3fcfbf }, { 0xbdb6081b, 0x3e09db5f },
    { 0xbc453dd7, 0xbd305e9d }, { 0x3e0bd606, 0x3d11ceac }, { 0x3d2736a6, 0x3db02d6d },
    { 0xbd97c53f, 0x3db29fbc }, { 0xbac7b8bc, 0xbd893186 }, { 0x3e81506f, 0x3f0f2764 },
    { 0x3e53c3ff, 0x3f19259d }, { 0xbe242ef4, 0x3d4d8f10 }, { 0x3d19f69d, 0x3cc69d14 },
    { 0x3cfa6cc0, 0x3d0a8ba4 }, { 0xbe1d1dea, 0xbd223fc6 }, { 0xb60dc000, 0x3d72d768 },
    { 0xbdb5fc2b, 0x3cadac0c }, { 0xbc469a0e, 0xbd36d36d }, { 0x3e1f18ac, 0x3f4d128d },
    { 0xbe16461f, 0xbf519649 }, { 0xbb257506, 0x3e34903c }, { 0xbdbb6288, 0x3defbb33 },
    { 0xbc0eae8b, 0xbd2223ab }, { 0x3e15edc1, 0x3d52e2c0 }, { 0x3d09e45e, 0x3dbf66bb },
    { 0xbd9d1721, 0x3db6690b }, { 0xbc0c2e22, 0xbd941d40 }, { 0x3e828ad4, 0x3f10c727 },
    { 0x3e659726, 0x3f183b29 }, { 0xbe339fbc, 0x3d162453 }, { 0x3cf80f1b, 0x3c1bd3d7 },
    { 0x3cd47e1b, 0x3cefd514 }, { 0xbe2a3440, 0xbd4c6148 }, { 0xbbf282e6, 0x3d74a717 },
    { 0xbda86c02, 0x3cd472ce }, { 0xbcb399db, 0xbd47f9e5 }, { 0x3e21724d, 0x3f507199 },
    { 0xbe3000b6, 0xbf52f488 }, { 0xbc5972f2, 0x3e2552df }, { 0xbdc1d85b, 0x3dc44eb2 },
    { 0xbb977f2e, 0xbd08a194 }, { 0x3e203348, 0x3d804f26 }, { 0x3cce8a97, 0x3dc14b1b },
    { 0xbda406aa, 0x3dba5b2a }, { 0xbc7e2a8b, 0xbda2d577 }, { 0x3e85b767, 0x3f14c3fb },
    { 0x3e791d36, 0x3f1a138e }, { 0xbe44c2a7, 0x3cc17869 }, { 0x3ca20c8b, 0xbc300ed1 },
    { 0x3ca6a9cb, 0x3cb1ac67 }, { 0xbe399736, 0xbd77d799 }, { 0xbc794f23, 0x3d722f9d },
    { 0xbd98099f, 0x3cfec7b1 }, { 0xbd0412e2, 0xbd5e43da }, { 0x3e261d49, 0x3f56219b },
    { 0xbe4939fe, 0xbf56f77a }, { 0xbcd2faa2, 0x3e152776 }, { 0xbdc8c479, 0x3d99add2 },
    { 0xb9ba8f90, 0xbccbce6f }, { 0x3e2ce12e, 0x3d98c53f }, { 0x3c830155, 0x3dbf15a6 },
    { 0xbda92e29, 0x3dc2440a }, { 0xbcbbf685, 0xbdb74034 }, { 0x3e8b541d, 0x3f1b8105 },
    { 0x3e880792, 0x3f1f1689 }, { 0xbe5a22cc, 0x3c40aa0b }, { 0x3c09157b, 0xbd0b2159 },
    { 0x3c72ef0a, 0x3c676312 }, { 0xbe4a64ff, 0xbd919758 }, { 0xbccbc05c, 0x3d6b073d },
    { 0xbd82d571, 0x3d146dc0 }, { 0xbd306d7d, 0xbd736b61 }, { 0x3e2c86f2, 0x3f5de623 },
    { 0xbe622888, 0xbf5d12f0 }, { 0xbd21b8e6, 0x3e094f55 }, { 0xbdd3f675, 0x3d5d8fdb },
    { 0x3b82cd3c, 0xbc830537 }, { 0x3e39c54e, 0x3db119fb }, { 0x3bacd156, 0x3dbc1fe1 },
    { 0xbdaa2ebf, 0x3dce2d26 }, { 0xbcf5dc28, 0xbdce9c4a }, { 0x3e94f245, 0x3f257e66 },
    { 0x3e96e8f3, 0x3f27363d }, { 0xbe75db50, 0xba4fd001 }, { 0xbb43cff9, 0xbd771c2e },
    { 0x3c282208, 0x3c14ddf9 }, { 0xbe5c1595, 0xbdac4345 }, { 0xbd1c526a, 0x3d5a365d },
    { 0xbd4ad224, 0x3d26253a }, { 0xbd60978d, 0xbd811e90 }, { 0x3e359469, 0x3f670d20 },
    { 0xbe7c7080, 0xbf64e94b }, { 0xbd679af3, 0x3dfb55d2 }, { 0xbde5694a, 0x3d0e03f7 },
    { 0x3c08c39f, 0xbc1f92e5 }, { 0x3e446dde, 0x3dc8d97d }, { 0xbbffa1e6, 0x3dafca22 },
    { 0xbda78be7, 0x3ddc8903 }, { 0xbd127e2e, 0xbde3e6b6 }, { 0x3e98acba, 0x3f2d86df },
    { 0x3e9ef697, 0x3f2d42b8 }, { 0xbe87d90d, 0x3b4cffe5 }, { 0xbc4d903e, 0xbd92d544 },
    { 0x3bded001, 0x3c5875fb }, { 0xbe636711, 0xbdb3078a }, { 0xbd686a84, 0x3d334376 },
    { 0xbcf9bd8b, 0x3d4394b0 }, { 0xbd853fec, 0xbd71c480 }, { 0x3e3abc61, 0x3f6b03cd },
    { 0xbe87bafa, 0xbf69675e }, { 0xbd835d2a, 0x3dfbb59d }, { 0xbe027e3d, 0x3c19ef93 },
    { 0x3c424d41, 0xbc07494a }, { 0x3e48bfe0, 0x3dc38eee }, { 0xbcb72c6d, 0x3d992e30 },
    { 0xbda25bd4, 0x3dd85953 }, { 0xbd0aa63d, 0xbdeae0b1 }, { 0x3e9af634, 0x3f2bdcd9 },
    { 0x3ea48350, 0x3f28ad5e }, { 0xbe8b7820, 0xbcb83268 }, { 0xbc722416, 0xbd9205bc },
    { 0x3b41556e, 0x3cd4dd8b }, { 0xbe56cdfc, 0xbdb94ac2 }, { 0xbd932cc9, 0x3c7b514b },
    { 0xbbb70ff0, 0x3d6eede3 }, { 0xbd8a5e24, 0xbd346931 }, { 0x3e42554e, 0x3f5f8e40 },
    { 0xbe8b6c43, 0xbf5f8623 }, { 0xbd99d904, 0x3db89226 }, { 0xbe0970c9, 0xbc60a92e },
    { 0x3c3c22f4, 0xbc94dc2d }, { 0x3e3bd369, 0x3dc9ebb6 }, { 0xbd1b0787, 0x3d37951c },
    { 0xbd8a5be8, 0x3dbf09b7 }, { 0xbcda422d, 0xbdda3d55 }, { 0x3e953a4d, 0x3f1fe689 },
    { 0x3e9e6310, 0x3f1b5387 }, { 0xbe8419ff, 0xbd2fb3bf }, { 0xbb0c0489, 0xbd35ca38 },
    { 0xbb15be0e, 0x3d25bc94 }, { 0xbe3c45b6, 0xbdada2ee }, { 0xbda8d889, 0xbc8e59aa },
    { 0x3c91af38, 0x3d7b66c3 }, { 0xbd7f11de, 0xbcd55dff }, { 0x3e3e18ce, 0x3f4af63c },
    { 0xbe83ead5, 0xbf4b1b8c }, { 0xbda96648, 0x3d95fd27 }, { 0xbe0cfa46, 0xbc46156f },
    { 0x3bdf7290, 0xbd1bd4a3 }, { 0x3e26043c, 0x3dbeaa81 }, { 0xbd56ba03, 0x3c650233 },
    { 0xbd5e5869, 0x3da1893a }, { 0xbc78b8da, 0xbdaed5d8 }, { 0x3e8c8ff4, 0x3f125976 },
    { 0x3e95f89e, 0x3f0f8c96 }, { 0xbe6fe09f, 0xbd4601db }, { 0x3ca64f5a, 0xba8079bc },
    { 0xbc38d3bc, 0x3d570dc4 }, { 0xbe210b06, 0xbd921bcd }, { 0xbdc0e3ca, 0xbd3aa537 },
    { 0x3d036799, 0x3d7ca0fc }, { 0xbd52e56c, 0xbc54edce }, { 0x3e3882d6, 0x3f3af6db },
    { 0xbe757022, 0xbf39e62e }, { 0xbdbd7746, 0x3d954461 }, { 0xbe098a4c, 0x3ba99a6a },
    { 0x3befccf7, 0xbd6c57e4 }, { 0x3e1107ac, 0x3da3b469 }, { 0xbd8ad206, 0xbc7b476a },
    { 0xbd2bca84, 0x3d869e6c }, { 0xbb99bcb0, 0xbd8075e7 }, { 0x3e85f0bd, 0x3f085486 },
    { 0x3e91843c, 0x3f0a0dbd }, { 0xbe5623f7, 0xbd36f7e6 }, { 0x3cc6e017, 0x3cdadbc9 },
    { 0xbc9eedb6, 0x3d7e5696 }, { 0xbe09a459, 0xbd5a8994 }, { 0xbdd4bee3, 0xbd8a9a13 },
    { 0x3d1783f8, 0x3d816212 }, { 0xbd2e9618, 0xbc03a1c9 }, { 0x3e34b61a, 0x3f31a6c2 },
    { 0xbe692929, 0xbf2efa94 }, { 0xbdd8c596, 0x3da26368 }, { 0xbde1964e, 0x3d12781e },
    { 0x3c95dd9e, 0xbd8f7199 }, { 0x3e00355d, 0x3d7c2d18 }, { 0xbdb33ad3, 0xbd286acd },
    { 0xbcfd1b70, 0x3d5559cf }, { 0x3b9f794a, 0xbd4177a5 }, { 0x3e83f5c4, 0x3f042d37 },
    { 0x3e925297, 0x3f09de4c }, { 0xbe3ca8c4, 0xbd0c6127 }, { 0x3c795eec, 0x3d2b3850 },
    { 0xbcccd1b5, 0x3d8db572 }, { 0xbdebbd90, 0xbd08efa9 }, { 0xbde45ac4, 0xbdb1f8f3 },
    { 0x3d0afae5, 0x3d81a59b }, { 0xbd10d062, 0xbbdf0e1f }, { 0x3e2f20ca, 0x3f2b6786 },
    { 0xbe6410a5, 0xbf290e81 }, { 0xbdff8845, 0x3dab8b6e }, { 0xbdb52ada, 0x3d7a0850 },
    { 0x3cf2a29e, 0xbd9c7bcb }, { 0x3de036ce, 0x3d2c0838 }, { 0xbdde7131, 0xbd79d6c9 },
    { 0xbca04fce, 0x3d2c161c }, { 0x3c1cb95f, 0xbd2dae80 }, { 0x3e876e49, 0x3f04ad8f },
    { 0x3e965bbb, 0x3f0be70a }, { 0xbe26b641, 0xbcc2a4ac }, { 0x3a730c66, 0x3d3d4806 },
    { 0xbcf4d68a, 0x3d9290c8 }, { 0xbdca1d5c, 0xbc7fd0d7 }, { 0xbdef1b0f, 0xbdd54c67 },
    { 0x3cdf1f9f, 0x3d787bbb }, { 0xbceed40b, 0xbbf00654 }, { 0x3e2d00b8, 0x3f26fd04 },
    { 0xbe652e84, 0xbf279d70 }, { 0xbe1256d6, 0x3da847f5 }, { 0xbd9e03b8, 0x3da2c9d6 },
    { 0x3d193aee, 0xbda2cf84 }, { 0x3dc16b25, 0x3cc6256f }, { 0xbe02e7d8, 0xbda011e3 },
    { 0xbc3207b6, 0x3d13ef57 }, { 0x3c308272, 0xbd390f0b }, { 0x3e90c1de, 0x3f07517b },
    { 0x3e9a9057, 0x3f0e5ee8 }, { 0xbe178bab, 0xbc9d4e0a }, { 0xbbecbdd3, 0x3d4532b4 },
    { 0xbd0d5dde, 0x3d8ed454 }, { 0xbdb16d96, 0xbb818170 }, { 0xbdf39504, 0xbdf496a5 },
    { 0x3c96f9fa, 0x3d59619f }, { 0xbcbfab14, 0xbc00cb84 }, { 0x3e37b21c, 0x3f25122a },
    { 0xbe6a4b06, 0xbf29f70c }, { 0xbe1c2d33, 0x3d980545 }, { 0xbd9d8171, 0x3db65f7b },
    { 0x3d337032, 0xbd9fdc4e }, { 0x3dab63c1, 0x3c355a66 }, { 0xbe11382e, 0xbdc28142 },
    { 0xbbdb83e8, 0x3d09a189 }, { 0x3c2d8941, 0xbd51e8fd }, { 0x3e9d9560, 0x3f0a9431 },
    { 0x3e9ea1cb, 0x3f109e51 }, { 0xbe1202eb, 0xbcb2c865 }, { 0xbb0a2317, 0x3d5dde9f },
    { 0xbd2093e7, 0x3d84ef19 }, { 0xbda06130, 0x3abeff43 }, { 0xbdf0c824, 0xbe06e860 },
    { 0x3bfe6a10, 0x3d258ac1 }, { 0xbc8aa70d, 0xbbe5c2b8 }, { 0x3e47fe6d, 0x3f24229f },
    { 0xbe6eca9d, 0xbf2da539 }, { 0xbe1c3fca, 0x3d8b9e27 }, { 0xbdabb3fe, 0x3db89e19 },
    { 0x3d4bd347, 0xbd948f2b }, { 0x3d9cf5a1, 0x3acb8532 }, { 0xbe18d5db, 0xbddcd49b },
    { 0xbbdb6f72, 0x3d08f494 }, { 0x3c1d6634, 0xbd6bdbd1 }, { 0x3eace64b, 0x3f0ffeec },
    { 0x3ea4f82e, 0x3f14ff1c }, { 0xbe154e4c, 0xbcfc5755 }, { 0x3c87e498, 0x3d8dc75f },
    { 0xbd3347bf, 0x3d7361cb }, { 0xbd947c95, 0x3b924e77 }, { 0xbded2e67, 0xbe129d0b },
    { 0xbb8bd186, 0x3cbe178b }, { 0xbc192992, 0xbb86cbe4 }, { 0x3e575d5d, 0x3f2444a3 },
    { 0xbe742481, 0xbf3248d9 }, { 0xbe1a06f5, 0x3d88b3dd }, { 0xbdbf9df7, 0x3daeac51 },
    { 0x3d62910b, 0xbd84087c }, { 0x3d9133a4, 0xbbd05417 }, { 0xbe1d461f, 0xbded3c29 },
    { 0xbc18b77d, 0x3d0e156a }, { 0x3c096083, 0xbd81f830 }, { 0x3ebf62c1, 0x3f194bf6 },
    { 0x3eae63ed, 0x3f1c80ea }, { 0xbe1e4271, 0xbd2dd620 }, { 0x3d3325f1, 0x3dbf2c9a },
    { 0xbd41ee2f, 0x3d5e167e }, { 0xbd8eed70, 0x3bf375ca }, { 0xbdee3b6c, 0xbe1f6ac3 },
    { 0xbc7b6f18, 0x3b0cd045 }, { 0x393c7b80, 0x3b039681 }, { 0x3e698b56, 0x3f27f7fd },
    { 0xbe7ef864, 0xbf3a4f70 }, { 0xbe1b9761, 0x3d87fc63 }, { 0xbdd46cec, 0x3da1200e },
    { 0x3d782715, 0xbd64d48c }, { 0x3d89c456, 0xbc5bf51d }, { 0xbe22552e, 0xbdfaa084 },
    { 0xbc709f87, 0x3d12f2ed }, { 0x3bfc4bf2, 0xbd9020d8 }, { 0x3ed22854, 0x3f2414a2 },
    { 0x3eb8aedd, 0x3f254439 }, { 0xbe28c18d, 0xbd5a4f62 }, { 0x3d9be97c, 0x3e007fb3 },
    { 0xbd444815, 0x3d4ae4ca }, { 0xbd8fef89, 0x3c2b6ff5 }, { 0xbdf393de, 0xbe2bb278 },
    { 0xbcc36c3c, 0xbcb62eab }, { 0x3c4c06a2, 0x3c4e40c7 }, { 0x3e810819, 0x3f2f3e06 },
    { 0xbe879ad6, 0xbf4606d1 }, { 0xbe1f8059, 0x3d827138 }, { 0xbde796db, 0x3d911b36 },
    { 0x3d84e0be, 0xbd3d126a }, { 0x3d88e351, 0xbca6e5c2 }, { 0xbe26b797, 0xbe03b161 },
    { 0xbcb8beed, 0x3d125db4 }, { 0x3c069a54, 0xbda1ebc9 }, { 0x3edf812c, 0x3f2ad29d },
    { 0x3ebe63d5, 0x3f2af9ef }, { 0xbe313721, 0xbd7220c2 }, { 0x3de0d050, 0x3e24b67a },
    { 0xbd34e706, 0x3d38d6e4 }, { 0xbd94cd40, 0x3c4cd57f }, { 0xbdf3b5e7, 0xbe32f4ca },
    { 0xbcef6df8, 0xbd42b834 }, { 0x3cd93fef, 0x3cda7321 }, { 0x3e8e663f, 0x3f363ddd },
    { 0xbe8e9d1b, 0xbf50c193 }, { 0xbe1fd804, 0x3d69b7f3 }, { 0xbdeff9d3, 0x3d7b60fa },
    { 0x3d87371b, 0xbd0fab6a }, { 0x3d8c8ed6, 0xbce04c88 }, { 0xbe268178, 0xbe06de20 },
    { 0xbd0008b1, 0x3d04da05 }, { 0x3c32ee44, 0xbdb09710 }, { 0x3ee2d882, 0x3f297855 },
    { 0x3ebc1e4e, 0x3f2a29ba }, { 0xbe352602, 0xbd69ca69 }, { 0x3e0cd588, 0x3e4512a0 },
    { 0xbd135d41, 0x3d288c8f }, { 0xbd9bb4c2, 0x3c484978 }, { 0xbde3b3ef, 0xbe30f5d5 },
    { 0xbcfc12fe, 0xbd8d3f0c }, { 0x3d20c042, 0x3d237fa5 }, { 0x3e98a1fc, 0x3f3825af },
    { 0xbe9121b3, 0xbf54f607 }, { 0xbe1ca48a, 0x3d32cb39 }, { 0xbde3dbba, 0x3d504d9e },
    { 0x3d7cd8f3, 0xbcbf1484 }, { 0x3d8f746b, 0xbd03c118 }, { 0xbe2081ac, 0xbe041da6 },
    { 0xbd2176cb, 0x3cc5ab22 }, { 0x3c85843b, 0xbdb3dd69 }, { 0x3edc95a5, 0x3f20ec41 },
    { 0x3eb3a2b6, 0x3f23c1a5 }, { 0xbe34ae5f, 0xbd4af98a }, { 0x3e21f807, 0x3e607041 },
    { 0xbcc7adf6, 0x3d20740e }, { 0xbda2db7b, 0x3c2a6b10 }, { 0xbdc6b683, 0xbe27a28e },
    { 0xbcf15d43, 0xbda9dda3 }, { 0x3d482997, 0x3d4be574 }, { 0x3e9d126e, 0x3f32dde5 },
    { 0xbe8def25, 0xbf4ff90e }, { 0xbe174fa4, 0x3ccdff96 }, { 0xbdc9691b, 0x3d1d8961 },
    { 0x3d51d1aa, 0xbc4f7d39 }, { 0x3d909d8c, 0xbd041554 }, { 0xbe139761, 0xbdf3e98e },
    { 0xbd39853a, 0x3c3c6b7f }, { 0x3cb8f70b, 0xbdad5ce0 }, { 0x3ed1f697, 0x3f15bafe },
    { 0x3ea95485, 0x3f1b8f59 }, { 0xbe3245c8, 0xbd2809b2 }, { 0x3e2fa8bc, 0x3e74478b },
    { 0xbc4034bb, 0x3d242f99 }, { 0xbdab51a7, 0x3bfc7ad1 }, { 0xbda9ec5a, 0xbe1cbe97 },
    { 0xbcdaccda, 0xbdb74f4a }, { 0x3d64cf12, 0x3d6603c6 }, { 0x3e9bd1a5, 0x3f2829a3 },
    { 0xbe8603ac, 0xbf435f3a }, { 0xbe114da2, 0x3bcbb531 }, { 0xbda47c19, 0x3d0651b8 },
    { 0x3d16936f, 0xbbcbcfd9 }, { 0x3d929f12, 0xbce382a3 }, { 0xbdfe3acb, 0xbdd22479 },
    { 0xbd4477bd, 0xbb32648c }, { 0x3ce20397, 0xbda038f2 }, { 0x3ec6c070, 0x3f0b95b7 },
    { 0x3ea10314, 0x3f14744b }, { 0xbe2f34a5, 0xbd0b29bd }, { 0x3e38466f, 0x3e80d4d4 },
    { 0x3a260116, 0x3d3303a0 }, { 0xbdb684d1, 0x3b9660ca }, { 0xbd95b327, 0xbe131a2f },
    { 0xbcc111e4, 0xbdb97276 }, { 0x3d7a84a9, 0x3d74247f }, { 0x3e96c790, 0x3f1baf90 },
    { 0xbe78d364, 0xbf3442a6 }, { 0xbe0f7765, 0xbc0e745c }, { 0xbd800a06, 0x3d0fba6a },
    { 0x3cb1ebdf, 0xbb9a9bfd }, { 0x3d9624d0, 0xbcb1f122 }, { 0xbdcfb4d0, 0xbdabfa8a },
    { 0xbd45bfd1, 0xbc77ae0b }, { 0x3cf8dd4c, 0xbd903cb5 }, { 0x3eba7dd6, 0x3f0270d6 },
    { 0x3e996fd4, 0x3f0e27d4 }, { 0xbe2b2669, 0xbcd62a37 }, { 0x3e34caeb, 0x3e802770 },
    { 0x3c3b35c6, 0x3d45ce21 }, { 0xbdc288f4, 0x3b3e7891 }, { 0xbd8a53fd, 0xbe08f3dc },
    { 0xbc96c8d3, 0xbdb0ba8e }, { 0x3d8174f9, 0x3d6ed9a2 }, { 0x3e8e0398, 0x3f0f4ffc },
    { 0xbe65766a, 0xbf2597e7 }, { 0xbe0fd6cd, 0xbc824b07 }, { 0xbd2cfd5e, 0x3d3f8b21 },
    { 0x3c09828a, 0xbc0b9368 }, { 0x3d99c6c2, 0xbc899c98 }, { 0xbda59447, 0xbd8b3ed8 },
    { 0xbd4748ba, 0xbcc2e622 }, { 0x3cfbdde7, 0xbd7dfbe7 }, { 0x3eb30cfd, 0x3efc9af1 },
    { 0x3e94d9ba, 0x3f0b4ddf }, { 0xbe2b4727, 0xbcbe8ca7 }, { 0x3e39f5e9, 0x3e84a585 },
    { 0x3cb8b945, 0x3d68adce }, { 0xbdd1f834, 0x3b4875fa }, { 0xbd89008c, 0xbe020b80 },
    { 0xbc82d874, 0xbdab66da }, { 0x3d875502, 0x3d723c26 }, { 0x3e84fe22, 0x3f0580ab },
    { 0xbe55ae55, 0xbf1a61aa }, { 0xbe0fc158, 0xbc63639c }, { 0xbcf5abbe, 0x3d604368 },
    { 0xbaefdde2, 0xbc75929a }, { 0x3da11492, 0xbc555c39 }, { 0xbd85c372, 0xbd656da0 },
    { 0xbd41b03b, 0xbcdb73fa }, { 0x3cf18235, 0xbd675a69 }, { 0x3eb110be, 0x3efdc5ad },
    { 0x3e94fadd, 0x3f0c4efe }, { 0xbe2fccf9, 0xbcc6ca8e }, { 0x3e46acec, 0x3e8e0114 },
    { 0x3d100531, 0x3d8efe97 }, { 0xbde6ee5b, 0x3b357e57 }, { 0xbd9027cc, 0xbdfeedce },
    { 0xbc7cf0fd, 0xbdab67eb }, { 0x3d8dbd68, 0x3d79ffce }, { 0x3e7bfd45, 0x3efe94db },
    { 0xbe4c2ddc, 0xbf133d10 }, { 0xbe1194c1, 0xbc0b6dde }, { 0xbcc1f512, 0x3d7e1abf },
    { 0xbc235f29, 0xbcc2e65d }, { 0x3dabd25f, 0xbc19ca6f }, { 0xbd6080d7, 0xbd44cfbb },
    { 0xbd39f2f7, 0xbcd518c7 }, { 0x3ce408ad, 0xbd59ae5f }, { 0x3eb15595, 0x3f00d660 },
    { 0x3e990cd5, 0x3f0e8d30 }, { 0xbe3576e1, 0xbccec340 }, { 0x3e4d3b87, 0x3e95831f },
    { 0x3d428e2e, 0x3dae047a }, { 0xbdfe855c, 0x3a6fcc50 }, { 0xbd99b646, 0xbdfd6f5d },
    { 0xbc49c5cb, 0xbda7b091 }, { 0x3d8e7383, 0x3d7602c9 }, { 0x3e6f5a95, 0x3ef5f349 },
    { 0xbe48a3bc, 0xbf0e4c16 }, { 0xbe18e2eb, 0xbbbfb267 }, { 0xbc8072b3, 0x3d98ff18 },
    { 0xbc8e5a52, 0xbd10e162 }, { 0x3db75da3, 0xbb936114 }, { 0xbd47d06c, 0xbd2b0189 },
    { 0xbd3b7184, 0xbccca558 }, { 0x3cdbbfa7, 0xbd48f46c }, { 0x3eb74eaf, 0x3f067d64 },
    { 0x3ea354dd, 0x3f13c34a }, { 0xbe3f14b1, 0xbce9e27e }, { 0x3e52ec5e, 0x3e9f35a1 },
    { 0x3d778a22, 0x3dd41d6e }, { 0xbe0e4388, 0xbb30508c }, { 0xbda802e3, 0xbe01788b },
    { 0xbc05053c, 0xbda504b3 }, { 0x3d8c5757, 0x3d6ee76a }, { 0x3e6458fe, 0x3ef214cf },
    { 0xbe4b2b76, 0xbf0c24cc }, { 0xbe288b63, 0xbb461d16 }, { 0xbc221c62, 0x3db85498 },
    { 0xbcc2efbf, 0xbd465e69 }, { 0x3dc64c8d, 0x3b24f307 }, { 0xbd3fdb59, 0xbd10215d },
    { 0xbd407b8c, 0xbcb6ffba }, { 0x3cd0aa60, 0xbd3d1407 }, { 0x3ec3e5e0, 0x3f10322f },
    { 0x3eb48141, 0x3f1cb130 }, { 0xbe4d00a4, 0xbd014e88 }, { 0x3e563e85, 0x3eabcbae },
    { 0x3d952e05, 0x3e009789 }, { 0xbe20f83a, 0xbbf9e23c }, { 0xbdbe0db4, 0xbe07af9c },
    { 0xba94eb42, 0xbd9e4e65 }, { 0x3d868dd5, 0x3d61eb68 }, { 0x3e5fd833, 0x3ef4884c },
    { 0xbe54901a, 0xbf0d71e6 }, { 0xbe3e9de3, 0xba6c4220 }, { 0xbbf50d30, 0x3ddbe5c7 },
    { 0xbcee9f59, 0xbd7fa2c6 }, { 0x3ddb5672, 0x3c504481 }, { 0xbd433be8, 0xbcef7fe0 },
    { 0xbd49b57b, 0xbc9d3490 }, { 0x3cc1c9ae, 0xbd343495 }, { 0x3ed8c074, 0x3f1ed95e },
    { 0x3ece2b4b, 0x3f2a2eb0 }, { 0xbe609991, 0xbd0aa8ba }, { 0x3e5895a1, 0x3ebcbb3c },
    { 0x3dabdb62, 0x3e1b9883 }, { 0xbe37c7c1, 0xbc6f7732 }, { 0xbddf0a00, 0xbe11fde4 },
    { 0x3c0fe177, 0xbd92c0a1 }, { 0x3d7787fc, 0x3d4e53c2 }, { 0x3e679098, 0x3eff5abb },
    { 0xbe68134e, 0xbf137114 }, { 0xbe5c41ff, 0xba972850 }, { 0xbc484928, 0x3dffdc44 },
    { 0xbd061969, 0xbd9dbff3 }, { 0x3df98fc9, 0x3ce1036c }, { 0xbd52b73a, 0xbccde734 },
    { 0xbd4ea9cb, 0xbc7a5f8b }, { 0x3cb22056, 0xbd307be7 }, { 0x3ef462b1, 0x3f30df20 },
    { 0x3eef2757, 0x3f3b7c65 }, { 0xbe75518d, 0xbd09da38 }, { 0x3e592a77, 0x3ed14fdc },
    { 0x3dbcaeab, 0x3e3b7a49 }, { 0xbe50b732, 0xbcc63772 }, { 0xbe053362, 0xbe1fb37c },
    { 0x3cb4279c, 0xbd7c9a41 }, { 0x3d553452, 0x3d357090 }, { 0x3e81ac24, 0x3f0b67a7 },
    { 0xbe8517c2, 0xbf200580 }, { 0xbe82afdc, 0xbbaf4d6c }, { 0xbce27e76, 0x3e12d1b9 },
    { 0xbd0be257, 0xbdbf81b4 }, { 0x3e134807, 0x3d4ab192 }, { 0xbd794e4b, 0xbcc7556e },
    { 0xbd478795, 0xbc1aa890 }, { 0x3c9ec0b2, 0xbd360041 }, { 0x3f07e806, 0x3f40d66f },
    { 0x3f08bfda, 0x3f4be8d2 }, { 0xbe7fa421, 0xbcdbfbb6 }, { 0x3e52a804, 0x3ee43b6d },
    { 0x3dbfa05f, 0x3e5c1397 }, { 0xbe65b540, 0xbd128ced }, { 0xbe1aded2, 0xbe2beeaa },
    { 0x3d1fe480, 0xbd32ab70 }, { 0x3d241235, 0x3d1685d6 }, { 0x3ea01b4d, 0x3f200584 },
    { 0xbea0bbd5, 0xbf34ef02 }, { 0xbe9ec85a, 0xbc8dea83 }, { 0xbd6f5c1a, 0x3e2878dc },
    { 0xbd005979, 0xbde730e5 }, { 0x3e3470db, 0x3dabef18 }, { 0xbda79231, 0xbd03d00e },
    { 0xbd2a3b37, 0x3ab33a36 }, { 0x3c849c06, 0xbd40ea74 }, { 0x3f0e2db6, 0x3f44b0e8 },
    { 0x3f1300bb, 0x3f50d363 }, { 0xbe70c06d, 0xbc315c16 }, { 0x3e3bb406, 0x3ee90760 },
    { 0x3da9f6a6, 0x3e6ffdda }, { 0xbe6aa539, 0xbd3a98f0 }, { 0xbe24060c, 0xbe2b6ea4 },
    { 0x3d676bad, 0xbc876ee5 }, { 0x3ccc42a8, 0x3cde2406 }, { 0x3ec74b52, 0x3f31f9b1 },
    { 0xbebe5997, 0xbf45ff5e }, { 0xbeb4a677, 0xbd2e2da0 }, { 0xbdcbe9cb, 0x3e344e60 },
    { 0xbc9df24b, 0xbe018077 }, { 0x3e536799, 0x3dfda70d }, { 0xbde66ea1, 0xbd5aa31c },
    { 0xbcc465b7, 0x3c8eb1ca }, { 0x3c38c3e6, 0xbd30676f }, { 0x3f0984ae, 0x3f398a98 },
    { 0x3f10ba60, 0x3f443120 }, { 0xbe47fe23, 0x3c13a8ea }, { 0x3e1b5d82, 0x3eddd1a5 },
    { 0x3d80970e, 0x3e6e3cad }, { 0xbe583a68, 0xbd4dd8df }, { 0xbe1c11a8, 0xbe19d103 },
    { 0x3d87d578, 0x3c3c3a9b }, { 0x3c303e84, 0x3c99e2cd }, { 0x3ed61d0f, 0x3f278a98 },
    { 0xbec3d8b5, 0xbf391cf7 }, { 0xbeaa412a, 0xbd9f3578 }, { 0xbdf9a873, 0x3e1a2e7e },
    { 0x3a80f770, 0xbdf14496 }, { 0x3e4af30a, 0x3e0d36eb }, { 0xbe00b089, 0xbd9e75e0 },
    { 0xb8f2c6b0, 0x3ce1a9ae }, { 0x3bbfe8e1, 0xbce2ee73 }, { 0x3efe3d67, 0x3f26fe9c },
    { 0x3f07706e, 0x3f2ebc36 }, { 0xbe193a22, 0x3ca40226 }, { 0x3dfc224e, 0x3ece5e86 },
    { 0x3d2c20a2, 0x3e5e9cf0 }, { 0xbe39f7ca, 0xbd4d920b }, { 0xbe0bfdf5, 0xbe00b718 },
    { 0x3d886948, 0x3cf76e79 }, { 0x3b065d7c, 0x3c79c22c }, { 0x3ecb30c3, 0x3f0e0077 },
    { 0xbeb69d8b, 0xbf1c5677 }, { 0xbe8b45b5, 0xbdd48e34 }, { 0xbdea8abf, 0x3de8b279 },
    { 0x3c87447a, 0xbdc7646a }, { 0x3e2494fc, 0x3df56656 }, { 0xbde6a481, 0xbdbc1b96 },
    { 0x3c645c32, 0x3cdc4995 }, { 0x3b13c368, 0xbc6e1ba7 }, { 0x3eead15d, 0x3f13e62f },
    { 0x3efd11fd, 0x3f1a6869 }, { 0xbdecd669, 0x3c13eacc }, { 0x3dccd26b, 0x3ec1b823 },
    { 0x3cd6899d, 0x3e4d6ff1 }, { 0xbe1e7507, 0xbd4d9e45 }, { 0xbdf41126, 0xbdd5a7c1 },
    { 0x3d74f650, 0x3d0501c6 }, { 0xba5d829d, 0x3c87db23 }, { 0x3ebd076e, 0x3efb7cd9 },
    { 0xbeabfa86, 0xbf0924cb }, { 0xbe5ced39, 0xbdd716a8 }, { 0xbdc9b13e, 0x3dc778a5 },
    { 0x3cc07e13, 0xbdb02b8e }, { 0x3e02f2f2, 0x3dc16554 }, { 0xbdcaacbe, 0xbdcea450 },
    { 0x3c853c03, 0x3ccb11eb }, { 0xb9bf8ae0, 0xbc13e34e }, { 0x3edf439d, 0x3f056f78 },
    { 0x3ef3c4fe, 0x3f0bd9d3 }, { 0xbdc6d9e4, 0xbcb61b56 }, { 0x3daaab04, 0x3eba8d3f },
    { 0x3c77b855, 0x3e3fe144 }, { 0xbe0c1289, 0xbd61bab2 }, { 0xbdd5e93d, 0xbdba8d8a },
    { 0x3d444924, 0x3c870d7e }, { 0xba06f22a, 0x3cb245ee }, { 0x3eb4f6a6, 0x3ef13a78 },
    { 0xbeaa1ee3, 0xbf01a873 }, { 0xbe36fa80, 0xbdbe6156 }, { 0xbdb287be, 0x3dc83f7b },
    { 0x3cda2ff0, 0xbdaaed3f }, { 0x3ddf41b8, 0x3d9f3d66 }, { 0xbdbab4fc, 0xbdd5412c },
    { 0x3c53b41f, 0x3cd9494d }, { 0xbb8557c5, 0xbc0492d8 }, { 0x3edc8b74, 0x3efaf607 },
    { 0x3ef347bb, 0x3f034aa2 }, { 0xbdb39e35, 0xbd80f1cf }, { 0x3d950d00, 0x3ebb6860 },
    { 0x3bfa1367, 0x3e38a4e3 }, { 0xbe00b729, 0xbd857cc6 }, { 0xbdc204e9, 0xbdac97b6 },
    { 0x3cf80d76, 0xbc556c80 }, { 0x3aab8e13, 0x3ceac380 }, { 0x3eb2774b, 0x3ef3955b },
    { 0xbeaf26f0, 0xbf00d768 }, { 0xbe27d93f, 0xbda9e9c6 }, { 0xbda577e9, 0x3dd5c30b },
    { 0x3ce2efc0, 0xbdb21068 }, { 0x3dd0f83f, 0x3d97d289 }, { 0xbdae5296, 0xbdced097 },
    { 0x3c19740b, 0x3cfc8d49 }, { 0xbc1d527a, 0xbc11130a }, { 0x3ee378ba, 0x3efa9881 },
    { 0x3efce323, 0x3f01d487 }, { 0xbdb07bda, 0xbdd23b94 }, { 0x3d88a720, 0x3ec6ca3e },
    { 0x3afbda3a, 0x3e3bb31b }, { 0xbdf61001, 0xbda16d1a }, { 0xbdbb205f, 0xbda3d2f3 },
    { 0x3bbc1796, 0xbd558944 }, { 0x3b3e5011, 0x3d0ff34a }, { 0x3eb394b2, 0x3efcf250 },
    { 0xbeb8f021, 0xbf03a368 }, { 0xbe2d206f, 0xbda91c90 }, { 0xbd9d2efa, 0x3de84c35 },
    { 0x3ce45bf0, 0xbdc2e89a }, { 0x3dd4cdcc, 0x3da9008f }, { 0xbda5e0ad, 0xbdc29585 },
    { 0x3bec4bbe, 0x3d13b4fa }, { 0xbc82b9aa, 0xbc1838e5 }, { 0x3ef4ccf1, 0x3f05184d },
    { 0x3f0981a7, 0x3f08af00 }, { 0xbdbe354d, 0xbe12858f }, { 0x3d8cb340, 0x3ee01373 },
    { 0xbb3b1f1d, 0x3e4c14ea }, { 0xbdf52442, 0xbdca5787 }, { 0xbdc45c30, 0xbda4d05a },
    { 0xbceaf63f, 0xbdcf8531 }, { 0x3b0313ce, 0x3d2b7d73 }, { 0x3eb95785, 0x3f0627e2 },
    { 0xbec70683, 0xbf093a78 }, { 0xbe44890f, 0xbdc24f01 }, { 0xbd9dd878, 0x3df9a7f9 },
    { 0x3ceab5b0, 0xbdd7f310 }, { 0x3de82882, 0x3dd1c84b }, { 0xbda65dbc, 0xbdb55bd5 },
    { 0x3ba2d029, 0x3d21690c }, { 0xbcb7b1e7, 0xbc1a9b82 }, { 0x3f0430bc, 0x3f101c7a },
    { 0x3f1767f8, 0x3f1340ca }, { 0xbdd2539a, 0xbe3c7c3c }, { 0x3da58bb5, 0x3f0018a2 },
    { 0xbc045292, 0x3e62e445 }, { 0xbdf06b8a, 0xbdff43c6 }, { 0xbdd32396, 0xbdb0415b },
    { 0xbd9489f0, 0xbe1ebc1a }, { 0xbb7827fe, 0x3d4e02ef }, { 0x3ec2dd47, 0x3f0e2747 },
    { 0xbed7abdf, 0xbf0ee984 }, { 0xbe630936, 0xbdedb414 }, { 0xbdaf1280, 0x3e0055a3 },
    { 0x3d03cdf2, 0xbde36287 }, { 0x3dfdb57b, 0x3e0368a0 }, { 0xbdb34ceb, 0xbdaa72ef },
    { 0xbb2c4684, 0x3d10f465 }, { 0xbceeaa4f, 0xbc4790b1 }, { 0x3f0689f9, 0x3f13a3d3 },
    { 0x3f1e1f01, 0x3f15c2e0 }, { 0xbddaa10b, 0xbe5d68c8 }, { 0x3dc3c97d, 0x3f08bcd3 },
    { 0xbc6a9bb0, 0x3e6d774b }, { 0xbdd6318f, 0xbe13e767 }, { 0xbdd3b22b, 0xbdbe354c },
    { 0xbddfd579, 0xbe41ae59 }, { 0xbc4c77f8, 0x3d7843e9 }, { 0x3ec74dd3, 0x3f0ec17c },
    { 0xbee16a6c, 0xbf0de218 }, { 0xbe6af7a5, 0xbe01a359 }, { 0xbdc979ad, 0x3df26647 },
    { 0x3d1c3884, 0xbdd3bcfe }, { 0x3df52255, 0x3e0e64ce }, { 0xbdc33f07, 0xbda6bf7c },
    { 0xbc81f5c8, 0x3cbca0ec }, { 0xbd17991b, 0xbcb26a6c }, { 0x3efccc1e, 0x3f0a70d6 },
    { 0x3f18d4e2, 0x3f0a86ee }, { 0xbdcde0ea, 0xbe6bf363 }, { 0x3dd104b7, 0x3f05a6cf },
    { 0xbc9bf266, 0x3e629e16 }, { 0xbdaa2200, 0xbe1661f1 }, { 0xbdc24a76, 0xbdc9c515 },
    { 0xbdf4f356, 0xbe3f16cb }, { 0xbca19157, 0x3d91ce04 }, { 0x3ec302c5, 0x3f073227 },
    { 0xbedcb8b9, 0xbf04a2ee }, { 0xbe4ccec7, 0xbddb9c54 }, { 0xbde3a9b4, 0x3dd3e6f2 },
    { 0x3d33a2f2, 0xbdb04fcb }, { 0x3dc5add9, 0x3df7e670 }, { 0xbdc318e3, 0xbda7802d },
    { 0xbcc5e000, 0x3c7d9336 }, { 0xbd2a9ba4, 0xbd014afe }, { 0x3ee48ebd, 0x3ef659e8 },
    { 0x3f0ef56e, 0x3ef1fa67 }, { 0xbdbddf7b, 0xbe6a79ea }, { 0x3dc10218, 0x3efb37cf },
    { 0xbcb52335, 0x3e4ce06d }, { 0xbd8004d3, 0xbe0c1222 }, { 0xbdb1f277, 0xbdd22fda },
    { 0xbddd3104, 0xbe25a893 }, { 0xbcdb35c3, 0x3d9e7a28 }, { 0x3ec0fe0f, 0x3f0146f6 },
    { 0xbed5f92a, 0xbef820b6 }, { 0xbe23b8c3, 0xbd9d9277 }, { 0xbdfe33bc, 0x3db7f247 },
    { 0x3d47c0eb, 0xbd8ecd14 }, { 0x3d9338aa, 0x3dc16dc9 }, { 0xbdb50ee2, 0xbda772c9 },
    { 0xbcc69da6, 0x3c8cea6a }, { 0xbd32bef2, 0xbd16ba92 }, { 0x3ecfabbb, 0x3edcf058 },
    { 0x3f06bfd2, 0x3ed2e030 }, { 0xbdb528f5, 0xbe5db93d }, { 0x3da3697f, 0x3eecde64 },
    { 0xbcc76ae5, 0x3e38992e }, { 0xbd46b0ae, 0xbdf9e7a3 }, { 0xbda85ef4, 0xbdd33eef },
    { 0xbdb4b684, 0xbe08a821 }, { 0xbd07a578, 0x3da6f088 }, { 0x3ec484ef, 0x3f001c48 },
    { 0xbed5682c, 0xbef0c708 }, { 0xbe004096, 0xbd4afc00 }, { 0xbe0cd454, 0x3da9b758 },
    { 0x3d59593e, 0xbd6e47a9 }, { 0x3d5d1d90, 0x3d9503f4 }, { 0xbda756b3, 0xbdad8478 },
    { 0xbcb0256e, 0x3cc11353 }, { 0xbd3caad2, 0xbd1cf7cb }, { 0x3ec06096, 0x3ecd2f58 },
    { 0x3f015c4d, 0x3ebc26c6 }, { 0xbdaf8ff5, 0xbe461270 }, { 0x3d8409c7, 0x3ee31177 },
    { 0xbcd91f32, 0x3e29711d }, { 0xbd2272ec, 0xbdd6fdc9 }, { 0xbda38bf7, 0xbdcd8584 },
    { 0xbd8b3b5f, 0xbddcd0ee }, { 0xbd1bca39, 0x3db0ae4a }, { 0x3ec9d418, 0x3f01d4a2 },
    { 0xbeda755f, 0xbef0e615 }, { 0xbdcdd3bb, 0xbcf23b31 }, { 0xbe1aaeb1, 0x3da650e9 },
    { 0x3d6b6ae0, 0xbd50b111 }, { 0x3d2d6d44, 0x3d6bd9e5 }, { 0xbda1df79, 0xbdbc2b5b },
    { 0xbc9b75cb, 0x3cfb52dd }, { 0xbd4926ab, 0xbd15400b }, { 0x3eb4acbb, 0x3ec6a669 },
    { 0x3efc80ae, 0x3ead3bce }, { 0xbda86013, 0xbe23c20d }, { 0x3d578d8e, 0x3edf267a },
    { 0xbce91cba, 0x3e2030e3 }, { 0xbd07c74c, 0xbdae7744 }, { 0xbda0ef32, 0xbdc4ee9b },
    { 0xbd4af2b5, 0xbdac0d4a }, { 0xbd28749b, 0x3dbf7362 }, { 0x3ecf2458, 0x3f051a94 },
    { 0xbee35d2f, 0xbef52b71 }, { 0xbdad3b0f, 0xbc99e687 }, { 0xbe2a1b97, 0x3da42d46 },
    { 0x3d822d5a, 0xbd3f35d9 }, { 0x3d0edb9a, 0x3d3eedc5 }, { 0xbda5714c, 0xbdce2884 },
    { 0xbc8d577d, 0x3d130791 }, { 0xbd5391be, 0xbd018f35 }, { 0x3eab5802, 0x3ec8da1e },
    { 0x3efa8988, 0x3ea64805 }, { 0xbd9d97c2, 0xbdf55036 }, { 0x3d474dd5, 0x3ee14659 },
    { 0xbcea2687, 0x3e1eec7e }, { 0xbce205b7, 0xbd828a60 }, { 0xbd9d773e, 0xbdba9c22 },
    { 0xbd0782f7, 0xbd7bbf01 }, { 0xbd309700, 0x3dd012f1 }, { 0x3ed5e032, 0x3f0a095e },
    { 0xbeef0be2, 0xbefcb0de }, { 0xbd93db8d, 0xbc826d2e }, { 0xbe3dc48f, 0x3da2927a },
    { 0x3d93bf4e, 0xbd39d4f8 }, { 0x3cf52413, 0x3d197555 }, { 0xbdb0531c, 0xbde18050 },
    { 0xbc892011, 0x3d1c75ab }, { 0xbd5c45e1, 0xbcbe474b }, { 0x3ea44942, 0x3ed03d36 },
    { 0x3efc0901, 0x3ea61d38 }, { 0xbd8d6a60, 0xbda0245b }, { 0x3d59004a, 0x3ee5f60e },
    { 0xbcd5479f, 0x3e25ed82 }, { 0xbcb63d8b, 0xbd2e4f10 }, { 0xbd96ab7f, 0xbdaff366 },
    { 0xbc96591a, 0xbd2946cc }, { 0xbd3998f7, 0x3dd6eff1 }, { 0x3edf531c, 0x3f113fdd },
    { 0xbefc8999, 0xbf03e86b }, { 0xbd74386a, 0xbc98545a }, { 0xbe5696c2, 0x3da83fcd },
    { 0x3dabed74, 0xbd4657ee }, { 0x3cd137f7, 0x3cec9eab }, { 0xbdc32394, 0xbdf9a069 },
    { 0xbc8ed4df, 0x3d1af3b8 }, { 0xbd65734e, 0xbc0da5d0 }, { 0x3ea10fa1, 0x3ed7956d },
    { 0x3eff4108, 0x3ea9c226 }, { 0xbd771b56, 0xbd33049d }, { 0x3d77c832, 0x3ee7537a },
    { 0xbcadb630, 0x3e322620 }, { 0xbc99d868, 0xbccfacb0 }, { 0xbd8c8617, 0xbda70a0e },
    { 0xbbe297c2, 0xbce2c5c6 }, { 0xbd4949e5, 0x3dc84255 }, { 0x3eeb4382, 0x3f1b59a8 },
    { 0xbf060455, 0xbf0be36e }, { 0xbd454c3a, 0xbcc60c43 }, { 0xbe71a933, 0x3dbc319b },
    { 0x3dcbeec4, 0xbd6f541e }, { 0x3cba7a97, 0x3cba68bc }, { 0xbdde0f78, 0xbe0cff64 },
    { 0xbc8f598b, 0x3d1b8d38 }, { 0xbd7835e9, 0x3c4abde2 }, { 0x3ea19da0, 0x3eda53bd },
    { 0x3f004b11, 0x3eac2778 }, { 0xbd5f5b22, 0xbcbb4d2e }, { 0x3d825705, 0x3ee23779 },
    { 0xbc7e24ce, 0x3e3ce85a }, { 0xbc99c4b6, 0xbc764fb0 }, { 0xbd82e500, 0xbda1a057 },
    { 0xba8155b7, 0xbcbdcd35 }, { 0xbd5d7287, 0x3da6e8a2 }, { 0x3ef6c554, 0x3f275513 },
    { 0xbf0ea829, 0xbf15d956 }, { 0xbd26dd73, 0xbcecf229 }, { 0xbe837b07, 0x3ddb15bf },
    { 0x3df1b697, 0xbd9ec405 }, { 0x3cc79404, 0x3caaf970 }, { 0xbdfe35a8, 0xbe20b4ed },
    { 0xbc6f6166, 0x3d30bc21 }, { 0xbd8fd4c1, 0x3d0b0ae4 }, { 0x3ea4b7c7, 0x3ed86ae0 },
    { 0x3efe4d96, 0x3eaadba0 }, { 0xbd565c98, 0xbc6769d2 }, { 0x3d760e76, 0x3ed970d7 },
    { 0xbc2c4568, 0x3e40f67b }, { 0xbcb11ca2, 0xbc366fdc }, { 0xbd790b43, 0xbd9f85bf },
    { 0x39d7f4c0, 0xbcc608cb }, { 0xbd6e6c3a, 0x3d828a4b }, { 0x3f002416, 0x3f328c62 },
    { 0xbf17ac08, 0xbf205713 }, { 0xbd2afc69, 0xbcf67faa }, { 0xbe8831fe, 0x3df67384 },
    { 0x3e0b6371, 0xbdd1783a }, { 0x3d009224, 0x3cbbb952 }, { 0xbe0f341a, 0xbe359c4d },
    { 0xbc07f708, 0x3d593317 }, { 0xbdaf7ad0, 0x3d3c8b25 }, { 0x3ea8e7c2, 0x3ed4d44f },
    { 0x3ef9fd1f, 0x3ea7049c }, { 0xbd571554, 0xbc3f6e85 }, { 0x3d586ae8, 0x3ed16068 },
    { 0xbbf30454, 0x3e3e5420 }, { 0xbccc3eb4, 0xbc29c29c }, { 0xbd73c0f6, 0xbd9f344e },
    { 0x3836f8c0, 0xbccf75e7 }, { 0xbd791115, 0x3d4e00ed }, { 0x3f047ad3, 0x3f3b8ed0 },
    { 0xbf20ef84, 0xbf2a42a1 }, { 0xbd5adfb1, 0xbcd0105d }, { 0xbe88213e, 0x3e013c1b },
    { 0x3e1b08b0, 0xbdffe773 }, { 0x3d2a6762, 0x3cd218dc }, { 0xbe1d53c7, 0xbe48b934 },
    { 0xb90df2c0, 0x3d82cf34 }, { 0xbdd51666, 0x3d37cb6c }, { 0x3eac5eaf, 0x3ed18ebf },
    { 0x3ef482d8, 0x3ea20bea }, { 0xbd5be0cb, 0xbc403522 }, { 0x3d3d83f0, 0x3ecb4e5f },
    { 0xbbc39250, 0x3e376257 }, { 0xbcdc566c, 0xbc2979a3 }, { 0xbd710cf6, 0xbd9f0ceb },
    { 0xba7734d6, 0xbcc957f4 }, { 0xbd7f8545, 0x3d2c3c85 }, { 0x3f090ad5, 0x3f422a71 },
    { 0xbf2a230c, 0xbf32ad83 }, { 0xbd9a4606, 0xbc758442 }, { 0xbe872d8c, 0x3df5f77c },
    { 0x3e282f60, 0xbe0dda38 }, { 0x3d565702, 0x3cd7760f }, { 0xbe299ea6, 0xbe56c64e },
    { 0x3c189b4a, 0x3d97e79e }, { 0xbdf8ce4a, 0x3d0db8c8 }, { 0x3eae8d47, 0x3ecfe271 },
    { 0x3eeff0f4, 0x3e9dd98e }, { 0xbd662045, 0xbc327190 }, { 0x3d2d29a8, 0x3ec7dd8f },
    { 0xbbb8a40f, 0x3e2faef3 }, { 0xbcdef6b5, 0xbc20980e }, { 0xbd6d9a84, 0xbd9e6a12 },
    { 0xbae25a6a, 0xbcb2af38 }, { 0xbd81efc8, 0x3d1c3b8a }, { 0x3f0da15e, 0x3f46b96d },
    { 0xbf320e80, 0xbf38ff04 }, { 0xbdcac750, 0xbb4f60e8 }, { 0xbe88be01, 0x3dd8616f },
    { 0x3e33005a, 0xbe1176f3 }, { 0x3d7efa5c, 0x3cc57a75 }, { 0xbe35223e, 0xbe5f1239 },
    { 0x3c924ae4, 0x3da8a8d6 }, { 0xbe0ad62d, 0x3cb804c6 }, { 0x3eaff428, 0x3ecf58a4 },
    { 0x3eed8018, 0x3e9aabbc }, { 0xbd7365a8, 0xbbe7f484 }, { 0x3d1f9968, 0x3ec63edf },
    { 0xbbdab268, 0x3e29204d }, { 0xbcd2f86f, 0xbc010fde }, { 0xbd691501, 0xbd9c6b94 },
    { 0xbacb1066, 0xbc8c186f }, { 0xbd838640, 0x3d17a454 }, { 0x3f11e7da, 0x3f4af653 },
    { 0xbf394724, 0xbf3eb5f0 }, { 0xbdf49dbe, 0x3c0c994d }, { 0xbe8ccd0e, 0x3dbd7991 },
    { 0x3e3cf51a, 0xbe105fbe }, { 0x3d8f1031, 0x3ca3d36c }, { 0xbe401495, 0xbe64029a },
    { 0x3cbf0768, 0x3db3b737 }, { 0xbe161c42, 0x3c568226 }, { 0x3eb1b168, 0x3ed0fd3b },
    { 0x3eedb09d, 0x3e98e7de }, { 0xbd7d1996, 0x39b9d290 }, { 0x3d13aef6, 0x3ec71e7f },
    { 0xbc10d002, 0x3e24879f }, { 0xbcb4404a, 0xbb81b32a }, { 0xbd63618a, 0xbd993f9d },
    { 0xb9f8f590, 0xbc333fef }, { 0xbd8508e3, 0x3d1d3ecd }, { 0x3f16e82d, 0x3f505937 },
    { 0xbf41d2c5, 0xbf45c677 }, { 0xbe0e04d7, 0x3ca2de26 }, { 0xbe93df77, 0x3dab6cae },
    { 0x3e48f790, 0xbe0e0304 }, { 0x3d99dd5b, 0x3c69ae2f }, { 0xbe4b6248, 0xbe688205 },
    { 0x3cd6bf42, 0x3dbd6b53 }, { 0xbe20166e, 0x3bb94f46 }, { 0x3eb07707, 0x3ed06041 },
    { 0x3eeb0f70, 0x3e9508a1 }, { 0xbd777663, 0x3c2fb3c0 }, { 0x3d059cd9, 0x3ec608c6 },
    { 0xbc3f1f66, 0x3e1e12e2 }, { 0xbc7ba210, 0x3af29968 }, { 0xbd53e102, 0xbd91eaef },
    { 0x3a907f7e, 0xbb8f9778 }, { 0xbd8390ff, 0x3d286616 }, { 0x3f1978bd, 0x3f529767 },
    { 0xbf4820de, 0xbf4a8bfe }, { 0xbe202772, 0x3cecd364 }, { 0xbe9a5a5c, 0x3da4ab28 },
    { 0x3e5428b9, 0xbe086cd4 }, { 0x3d9e5f1f, 0x3bf88f52 }, { 0xbe53662b, 0xbe68a70b },
    { 0x3cdfc641, 0x3dc557d7 }, { 0xbe268abe, 0xba9be368 }, { 0x3eafb397, 0x3ed0cbfd },
    { 0x3ee930a4, 0x3e9183b1 }, { 0xbd6b5338, 0x3c9c754a }, { 0x3cf52355, 0x3ec69cb6 },
    { 0xbc75ce54, 0x3e185d7a }, { 0xbc0933cc, 0x3bf08654 }, { 0xbd38fa37, 0xbd8ac74a },
    { 0x3b21a0b5, 0xba9d6347 }, { 0xbd7ff879, 0x3d3cf28b }, { 0x3f1bad1d, 0x3f53f45b },
    { 0xbf4f4e63, 0xbf500bc6 }, { 0xbe349527, 0x3d1419e4 }, { 0xbea2001c, 0x3db39953 },
    { 0x3e6383cd, 0xbe0030db }, { 0x3da3172e, 0x3b42ce8a }, { 0xbe5b0fac, 0xbe66f107 },
    { 0x3ce6cd9e, 0x3dd16441 }, { 0xbe2dcb66, 0xbc1c1985 }, { 0x3eb091f6, 0x3ed07748 },
    { 0x3ee7f52b, 0x3e8dbed8 }, { 0xbd5befb4, 0x3cb22de2 }, { 0x3cd2defb, 0x3ec709dc },
    { 0xbc9b9f41, 0x3e13d83a }, { 0xbae7077f, 0x3c39f74e }, { 0xbd13fe4a, 0xbd85c0ea },
    { 0x3b5614f5, 0xbb4ff858 }, { 0xbd76bc92, 0x3d525617 }, { 0x3f1d472c, 0x3f561163 },
    { 0xbf576c9c, 0xbf574eb6 }, { 0xbe4af75c, 0x3d3096eb }, { 0xbea9aa21, 0x3ddf5c99 },
    { 0x3e7647a1, 0xbdf5e028 }, { 0x3da7248a, 0xb9be683c }, { 0xbe62c298, 0xbe65aacc },
    { 0x3ced0afc, 0x3de7ee51 }, { 0xbe37e289, 0xbc896070 }, { 0x3eb1493a, 0x3ecd65b3 },
    { 0x3ee4347a, 0x3e88b623 }, { 0xbd415375, 0x3c855c8a }, { 0x3caad3ac, 0x3ec475b8 },
    { 0xbcb2289a, 0x3e0fd55e }, { 0x3b6fc15a, 0x3c54fb47 }, { 0xbcce5400, 0xbd8317bf },
    { 0x3b1c4103, 0xbc32238e }, { 0xbd6c806c, 0x3d62bd3c }, { 0x3f1d4172, 0x3f567527 },
    { 0xbf5df6fd, 0xbf5dcdbc }, { 0xbe600526, 0x3d44bace }, { 0xbeafc1e5, 0x3e0c1168 },
    { 0x3e84050b, 0xbdf36d72 }, { 0x3da930c5, 0xbb642630 }, { 0xbe674082, 0xbe630f0a },
    { 0x3cf9763b, 0x3e04ad0f }, { 0xbe433657, 0xbcc1874c }, { 0x3eb18001, 0x3ec78b3e },
    { 0x3edde3df, 0x3e831be4 }, { 0xbd1ad7c2, 0x3b06c052 }, { 0x3c79e502, 0x3ebe9cff },
    { 0xbcb48f87, 0x3e0c6887 }, { 0x3bab4b40, 0x3c2da05f }, { 0xbc68fdde, 0xbd853c5a },
    { 0xb9c96d68, 0xbcc5140e }, { 0xbd634d66, 0x3d6c9a05 }, { 0x3f1c13e8, 0x3f54e914 },
    { 0xbf62765b, 0xbf62a0e1 }, { 0xbe71d630, 0x3d4a73db }, { 0xbeb4423c, 0x3e2e2366 },
    { 0x3e8aa4e0, 0xbdf76afd }, { 0x3dae99fc, 0xbb9033c2 }, { 0xbe668967, 0xbe5d850d },
    { 0x3d08fd02, 0x3e19a9ab }, { 0xbe514fe7, 0xbd05a338 }, { 0x3eb00d12, 0x3ebd29c9 },
    { 0x3ed46a13, 0x3e78dec9 }, { 0xbcda55e7, 0xbc9152c9 }, { 0x3bfd88f6, 0x3eb41fce },
    { 0xbca6dfed, 0x3e07f480 }, { 0x3b1e2b3d, 0x3b852496 }, { 0xbb8ce5db, 0xbd8bc9e2 },
    { 0xbb8d8699, 0xbd239d6f }, { 0xbd5b6b75, 0x3d6d1620 }, { 0x3f18e80d, 0x3f50fd9a },
    { 0xbf633cce, 0xbf64e13c }, { 0xbe7c9b0b, 0x3d4b0c22 }, { 0xbeb5b127, 0x3e57a822 },
    { 0x3e8cd1af, 0xbe0058cb }, { 0x3db6c4f0, 0xbb365c14 }, { 0xbe5fce09, 0xbe53c44d },
    { 0x3d15540b, 0x3e2f23e6 }, { 0xbe60f07a, 0xbd34d0ed }, { 0x3eaad856, 0x3eaea0f6 },
    { 0x3ec7463d, 0x3e67f467 }, { 0xbc7c7f01, 0xbd14e778 }, { 0x3927ec00, 0x3ea5d00d },
    { 0xbc912417, 0x3e0114b8 }, { 0xbb8351dd, 0xbb9f9d70 }, { 0x3b692d4a, 0xbd90d809 },
    { 0xbc01759e, 0xbd59eb28 }, { 0xbd54d9c0, 0x3d63b56c }, { 0x3f1363f1, 0x3f4a23d1 },
    { 0xbf5ec694, 0xbf62e9c4 }, { 0xbe7f2418, 0x3d4d0db7 }, { 0xbeb3e29a, 0x3e7ea392 },
    { 0x3e89d95e, 0xbe059d93 }, { 0x3dbf029f, 0x3a8ffa15 }, { 0xbe544794, 0xbe4656ac },
    { 0x3d1ef13c, 0x3e3f030f }, { 0xbe6c8035, 0xbd64f986 }, { 0x3e9f7d18, 0x3e9bfdac },
    { 0x3eb5026e, 0x3e5165ba }, { 0xbc16b93e, 0xbd4e36da }, { 0xbbb62d5e, 0x3e9453ed },
    { 0xbc6bdd4b, 0x3ded213e }, { 0xbc445cd7, 0xbc6ae9c7 }, { 0x3bf94f14, 0xbd8ccd4d },
    { 0xbc22605a, 0xbd7486dd }, { 0xbd4e36f2, 0x3d4cfc31 }, { 0x3f09daa6, 0x3f3e60d1 },
    { 0xbf52e21a, 0xbf597d76 }, { 0xbe773fcb, 0x3d59a235 }, { 0xbeab962d, 0x3e8999dd },
    { 0x3e806be1, 0xbe08aeb5 }, { 0x3dc342e8, 0x3be5496c }, { 0xbe41879d, 0xbe345088 },
    { 0x3d21641d, 0x3e427141 }, { 0xbe6ea425, 0xbd83765e }, { 0x3e8b0200, 0x3e833689 },
    { 0x3e9a2f43, 0x3e317e75 }, { 0xbbe99ee9, 0xbd6618cf }, { 0xbc10048c, 0x3e7a8c53 },
    { 0xbc2960b7, 0x3dcca398 }, { 0xbc8fe3c4, 0xbcacc6a0 }, { 0x3c0b597f, 0xbd788b64 },
    { 0xbc2480b8, 0xbd678f09 }, { 0xbd3e9f4f, 0x3d28d89f }, { 0x3eee5c2a, 0x3f27689a },
    { 0xbf3927d4, 0xbf4194c8 }, { 0xbe5df8d8, 0x3d6a85e9 }, { 0xbe959554, 0x3e83a18c },
    { 0x3e5a2fa8, 0xbe029392 }, { 0x3db53c6f, 0x3c3794ec }, { 0xbe22e958, 0xbe193682 },
    { 0x3d157d4a, 0x3e31bf1e }, { 0xbe5e9788, 0xbd83aa4e }, { 0x3e58ef78, 0x3e45dbc2 },
    { 0x3e6bd748, 0x3e065639 }, { 0xbc017106, 0xbd52e4ba }, { 0xbc1aec49, 0x3e3e4e0d },
    { 0xbbe1c2ea, 0x3d9d9f16 }, { 0xbc92e2cc, 0xbcb63299 }, { 0x3c038bb3, 0xbd3efe5a },
    { 0xbbf8b10e, 0xbd3645e6 }, { 0xbd1ba9d2, 0x3cf6d8da }, { 0x3eb57ace, 0x3f0318d1 },
    { 0xbf10621e, 0xbf190abe }, { 0xbe2f8449, 0x3d656614 }, { 0xbe63e0a8, 0x3e5a72cc },
    { 0x3e21cbc4, 0xbddbfb75 }, { 0x3d8f3b1c, 0x3c3bd973 }, { 0xbdf1e265, 0xbde9bda3 },
    { 0x3ce9cce8, 0x3e0ca036 }, { 0xbe37304d, 0xbd5f593f }, { 0x3e0c9beb, 0x3df76d59 },
    { 0x3e15a975, 0x3da83b68 }, { 0xbc10794a, 0xbd1c6f11 }, { 0xbbeba5a0, 0x3defeb85 },
    { 0xbb838b72, 0x3d48064b }, { 0xbc5ae328, 0xbc8e6e8b }, { 0x3bf5ab3c, 0xbcea9724 },
    { 0xbb8b1f86, 0xbce65e36 }, { 0xbccb041a, 0x3c9872f0 }, { 0x3e62b672, 0x3ea85486 },
    { 0xbeb8b89a, 0xbec5e7f0 }, { 0xbde47992, 0x3d382847 }, { 0xbe0e3f68, 0x3e1197ef },
    { 0x3dc1488e, 0xbd955eb5 }, { 0x3d33e4d8, 0x3c04c297 }, { 0xbd90b184, 0xbd946769 },
    { 0x3c976f7a, 0x3db486f7 }, { 0xbdf35759, 0xbd18a4b8 }, { 0x3d85b37a, 0x3d60f245 },
    { 0x3d891bd2, 0x3d194589 }, { 0xbc10b50d, 0xbcaefe3c }, { 0xbb4b09da, 0x3d5972c6 },
    { 0xbad42b28, 0x3cb54cdb }, { 0xbbef59d2, 0xbc1cc515 }, { 0x3bd8db4a, 0xbc38113f },
    { 0xbae68fdc, 0xbc56eaf7 }, { 0xbc367bd6, 0x3c0ac5b5 }, { 0x3dccbec3, 0x3e170dec },
    { 0xbe27917f, 0xbe32bb04 }, { 0xbd5c6827, 0x3cd46aad }, { 0xbd81fa37, 0x3d82a3b7 },
    { 0x3d1f1899, 0xbd0af2ea }, { 0x3ca6fdbe, 0x3b968fe8 }, { 0xbce050ee, 0xbd09db3d },
    { 0x3c229114, 0x3d2311b8 }, { 0xbd5e54ec, 0xbc94b778 }, { 0x3cc28710, 0x3c8f1958 },
    { 0x3cb4c933, 0x3c53ce63 }, { 0xbc0429c2, 0xbc24c805 }, { 0xb949392e, 0x3c84c48b },
    { 0xba1637a4, 0x3bdb4f2a }, { 0xbb6c2e91, 0xbb865fc8 }, { 0x3bae696a, 0xba8cc0d1 },
    { 0xba3b81f9, 0xbb9ca905 }, { 0xbb5ab430, 0x3b2c3eb0 }, { 0x3cfde090, 0x3d2a2ab2 },
    { 0xbd48be4a, 0xbd44f683 }, { 0xbcab435b, 0x3c34474f }, { 0xbcabb403, 0x3c862c64 },
    { 0x3c15b345, 0xbc1d9237 }, { 0x3c01a5d4, 0x3b1deb0f }, { 0xbb3698e3, 0xbc3770ff },
    { 0x3b950e04, 0x3c3f6675 }, { 0xbc7acc70, 0xbbc42b6e }, { 0x3c2d5b7b, 0x3b98d30e },
    { 0x3c0df635, 0x3bf5141e }, { 0xbbcbe5b6, 0xbbaf6f80 }, { 0x3abcd433, 0x3bb2f27e },
    { 0xba02f8df, 0x3ae8cece }, { 0xbb3de327, 0xbb2f34db }, { 0x3b7411f9, 0x3b0242aa },
    { 0xb9d7d936, 0xbb1056eb }, { 0xbab21eeb, 0x3a8c53df }, { 0x3c5186de, 0x3c21a598 },
    { 0xbc8ff30f, 0xbc2e4192 }, { 0xbc5c9769, 0x3b96b240 }, { 0xbbf818b2, 0x3a352cf4 },
    { 0x3af050d4, 0xbb174f0a }, { 0x3bab1b79, 0x3a7f57c6 }, { 0x3ba547a2, 0xbb724715 },
    { 0x3b0497f8, 0x3b654b7a }, { 0xbb41d859, 0xbb24dd14 }, { 0x3ba48e13, 0x3afdd0ce },
    { 0x3b9f8533, 0x3b8da596 }, { 0xbb721a60, 0xbb2f9fc4 }, { 0x3a683044, 0x3b4657e2 },
    { 0xb8936bdf, 0x3a630cb8 }, { 0xbb0db9c1, 0xbad75508 }, { 0x3aec880f, 0x3ab0beda },
    { 0xba1f5f07, 0xba4d6b7b }, { 0xba814e53, 0x39f5f5a6 }, { 0x3beb9010, 0x3b70e722 },
    { 0xbc1676e0, 0xbb71559e }, { 0xbc06bbfc, 0x3af3b538 }, { 0xbb7ba763, 0xbab7ecf8 },
    { 0x3a55df3f, 0xba07e711 }, { 0x3b6f2e6a, 0xb8991650 }, { 0x3b816c8d, 0xbb097482 },
    { 0x3aa07870, 0x3a2eef76 }, { 0xba1ab408, 0xbab0c89d }, { 0x3b164c64, 0x3a5a096c },
    { 0x3af6c2fb, 0x3ae290b0 }, { 0xbada798b, 0xbaa26644 }, { 0x39d231be, 0x3aafd3c2 },
    { 0x3675c66c, 0x39eb440d }, { 0xba814580, 0xba32cb4c }, { 0x3a3d027f, 0x3a252f9a },
    { 0xb9b48244, 0xb95bae30 }, { 0xba028248, 0x3960d506 }, { 0x3b402ccd, 0x3b168348 },
    { 0xbb7400d4, 0xbb131dae }, { 0xbb6dd7a2, 0x3a72b662 }, { 0xbb01491b, 0xba532442 },
    { 0x3a0c512a, 0xb907e7be }, { 0x3aef1f44, 0xb97295d7 }, { 0x3ad5c704, 0xbaa08dc8 },
    { 0x3a21bd1e, 0x38945e72 }, { 0xb9879e58, 0xba49a966 }, { 0x3a4f1969, 0x39b75b4e },
    { 0x3a232fe2, 0x39d1cd0e }, { 0xba00974f, 0xb9cb647d }, { 0x38cdf931, 0x39de457a },
    { 0x3792168a, 0x394b2d6c }, { 0xb9662c6c, 0xb937c0e8 }, { 0x393480bc, 0x390cb924 },
    { 0xb8aa0c3d, 0xb7e40732 }, { 0xb95210b8, 0x3878a98b }, { 0x3a670b8f, 0x3aa857d1 },
    { 0xba9b7a8a, 0xbaa9420a }, { 0xba8c87f5, 0x39add704 }, { 0xba552304, 0xb9ade228 },
    { 0x39bccaec, 0xb73d1e42 }, { 0x3a14de30, 0xb889d734 }, { 0x39b9404d, 0xba16d73f },
    { 0x393857f0, 0x381f054a }, { 0xb920a59c, 0xb9c0a84b }, { 0x39d94430, 0x39516f2f },
    { 0x39d5be22, 0x391b771b }, { 0xb90b7078, 0xb91033e3 }, { 0x380b1b80, 0x39564592 },
    { 0x37a9fae0, 0x38eea1b4 }, { 0xb8735d2e, 0xb89420fa }, { 0x369087c1, 0xb5b68c0c },
    { 0xb7c1cc8d, 0xb69934af }, { 0xb90f2194, 0x37544204 }, { 0x3a0174ae, 0x3a8513e3 },
    { 0xba2a4f8a, 0xba8f3d1a }, { 0xb9dfa7e0, 0x38cb0c65 }, { 0xb9fba40b, 0xb949f95c },
    { 0x39a0b51f, 0x37d3b5ab }, { 0x39753a27, 0xb746ac1a }, { 0xb7529b33, 0xb9c8dc46 },
    { 0x384469d8, 0x383fc98a }, { 0xb91a7d9e, 0xb9827141 }, { 0x39cf8e20, 0x3944525e },
    { 0x39ccbc76, 0x390f69d6 }, { 0xb8dab325, 0xb8f8e212 }, { 0x380701a4, 0x392fca4c },
    { 0x379d5b3c, 0x38b44598 }, { 0xb83201f4, 0xb8678a67 }, { 0xb71c314e, 0xb70fa9f6 },
    { 0xb76c1c91, 0xb72fbc84 }, { 0xb9011ad0, 0x36d161ca }, { 0x39f05c2b, 0x3a7a2966 },
    { 0xba1db8e5, 0xba8911e1 }, { 0xb9ac8ccf, 0x38293dbe }, { 0xb9dfdf1c, 0xb9328897 },
    { 0x398bf10e, 0x37caf8ce }, { 0x392fcb8a, 0x37d93656 }, { 0xb87c9806, 0xb9b6dfb3 },
    { 0x380d2ab3, 0x38802201 }, { 0xb91485a5, 0xb96b5a22 }, { 0x39c2c7d5, 0x3938576c },
    { 0x39bfaa03, 0x3908fee3 }, { 0xb8c83f9a, 0xb8e72792 }, { 0x380ca3d9, 0x3915c91f },
    { 0x379c1f4b, 0x38905bda }, { 0xb81a6f3e, 0xb843aecf }, { 0xb72f6d30, 0xb725465d },
    { 0xb743c2af, 0xb755ae76 }, { 0xb8e64f3d, 0x366e470a }, { 0x39e2c527, 0x3a6a2afd },
    { 0xba136d9f, 0xba806000 }, { 0xb98fc98d, 0x378f9960 }, { 0xb9c915a3, 0xb91f4484 },
    { 0x3970942e, 0x37be176b }, { 0x390c9c75, 0x381e2464 }, { 0xb88f2087, 0xb9a6ecab },
    { 0x37eac308, 0x388f9b27 }, { 0xb90ad825, 0xb9546f66 }, { 0x39b6b582, 0x392d3b6e },
    { 0x39b33a01, 0x39031f6e }, { 0xb8bae748, 0xb8d830a7 }, { 0x3811a676, 0x3903e909 },
    { 0x379a9526, 0x3873f1a9 }, { 0xb80c00d2, 0xb82cdf0b }, { 0xb7294604, 0xb7360df2 },
    { 0xb739c73a, 0xb754383f }, { 0xb8d01bdc, 0x360be4f2 }, { 0x39d5c0d0, 0x3a5c4148 },
    { 0xba0a5044, 0xba70d036 }, { 0xb97b62af, 0x36dd6988 }, { 0xb9b53edb, 0xb90fe8fe },
    { 0x39522ea5, 0x37b41d6b }, { 0x38eea370, 0x3829a152 }, { 0xb8906c88, 0xb999c167 },
    { 0x37cae2d1, 0x3895f9ea }, { 0xb902943d, 0xb9413c6a }, { 0x39ac54f3, 0x39239685 },
    { 0x39a87a4b, 0x38fbfb02 }, { 0xb8b02e37, 0xb8cb0f50 }, { 0x3814c3fa, 0x38ee62b9 },
    { 0x37979035, 0x3855d62e }, { 0xb801f221, 0xb81d5ca9 }, { 0xb71d240a, 0xb742e112 },
    { 0xb737d232, 0xb744a999 }, { 0xb8be9134, 0x35a9eb5a }, { 0x39c9be92, 0x3a50394d },
    { 0xba02bc31, 0xba636cd7 }, { 0xb9628c83, 0x3615561c }, { 0xb9a469fc, 0xb904ac1e },
    { 0x393b04d4, 0x37ab6402 }, { 0x38d28bf3, 0x38299bb4 }, { 0xb88df1ad, 0xb98f30f1 },
    { 0x37b425f6, 0x3897a9b6 }, { 0xb8f755e3, 0xb93175a0 }, { 0x39a3c9d1, 0x391bcab6 },
    { 0x399fa2bf, 0x38f3107a }, { 0xb8a7eaf4, 0xb8c04341 }, { 0x3816891f, 0x38dba899 },
    { 0x37941793, 0x3840bc81 }, { 0xb7f5ef3d, 0xb8121ba1 }, { 0xb710d4a5, 0xb74d474f },
    { 0xb738f53d, 0xb73287a7 }, { 0xb8b1242f, 0x355f4798 }, { 0x39bf8266, 0x3a4600ad },
    { 0xb9f8db89, 0xba58a0f0 }, { 0xb950f038, 0x3509a120 }, { 0xb9966964, 0xb8f8b764 },
    { 0x392949d8, 0x37a3dc67 }, { 0x38bea91f, 0x382699bd }, { 0xb88a9080, 0xb986da8c },
    { 0x37a3e0fe, 0x3897208e }, { 0xb8ec5c8f, 0xb924ab32 }, { 0x399d1506, 0x3915f231 },
    { 0x39988fed, 0x38eb5013 }, { 0xb8a1d3b9, 0xb8b7b859 }, { 0x3816bd29, 0x38cd7206 },
    { 0x3790ff28, 0x3831a176 }, { 0xb7eb8d59, 0xb8098a2c }, { 0xb7075060, 0xb7578ef4 },
    { 0xb73abe6a, 0xb722f90d }, { 0xb8a742e5, 0x352e171c }, { 0x39b76b3f, 0x3a3dfca0 },
    { 0xb9ee6486, 0xba4fde54 }, { 0xb94416d0, 0xb4ec0460 }, { 0xb98b1bb5, 0xb8eb7f7e },
    { 0x391bb3cc, 0x379f882a }, { 0x38b02ca9, 0x382222a3 }, { 0xb8874e58, 0xb9807b5d },
    { 0x3797fc76, 0x3895cea5 }, { 0xb8e4afa0, 0xb91ad44d }, { 0x3997e752, 0x3911868f },
    { 0x399300ff, 0x38e532cf }, { 0xb89d0e43, 0xb8b075ee }, { 0x381583f7, 0x38c25776 },
    { 0x378ebacb, 0x3826adb6 }, { 0xb7e26fc6, 0xb80347e9 }, { 0xb6ff7145, 0xb75fa629 },
    { 0xb73c21a4, 0xb716e0bc }, { 0xb89ff96a, 0x3530e364 }, { 0x39b106a7, 0x3a37f7a7 },
    { 0xb9e62eb3, 0xba48c1c4 }, { 0xb93a1af0, 0xb53b74d0 }, { 0xb9820c83, 0xb8e0a2b5 },
    { 0x39115a55, 0x379e986e }, { 0x38a579b3, 0x381d3c63 }, { 0xb8848774, 0xb9776253 },
    { 0x378f330f, 0x389444ca }, { 0xb8df6d7a, 0xb9138a36 }, { 0x3993ed60, 0x390dfbed },
    { 0x398efd7a, 0x38e156ff }, { 0xb899359a, 0xb8aae08d }, { 0x38143336, 0x38ba421e },
    { 0x378d1227, 0x381ed670 }, { 0xb7da1ef9, 0xb7fcfafb }, { 0xb6f0e82e, 0xb765db9c },
    { 0xb73eb560, 0xb70d2aa4 }, { 0xb89abce5, 0x3551a01e }, { 0x39abae5f, 0x3a335a81 },
    { 0xb9e0a8b7, 0xba438871 }, { 0xb9324767, 0xb40fc3c0 }, { 0xb975ae0b, 0xb8d8e99b },
    { 0x390994c8, 0x379e619e }, { 0x389db5f1, 0x3818c25a }, { 0xb8827c22, 0xb9706be9 },
    { 0x378a164f, 0x3893329f }, { 0xb8db9766, 0xb90e2daf }, { 0x39911698, 0x390b6ae3 },
    { 0x398c3cc8, 0x38de9bcc }, { 0xb896a208, 0xb8a7462e }, { 0x38138b46, 0x38b48d9a },
    { 0x378c0bfb, 0x38195e46 }, { 0xb7d1e0c1, 0xb7f4a343 }, { 0xb6e0203c, 0xb76ee3ba },
    { 0xb74257eb, 0xb7041387 }, { 0xb8976d31, 0x357ce256 }, { 0x39a808e8, 0x3a301871 },
    { 0xb9dcc786, 0xba4014c4 }, { 0xb92cdd3e, 0x34fc2c00 }, { 0xb96a76b8, 0xb8d3c672 },
    { 0x3903e456, 0x37a01bae }, { 0x3897d46b, 0x3814477d }, { 0xb8814786, 0xb96bd266 },
    { 0x3786dc64, 0x3892d3a7 }, { 0xb8d9450c, 0xb90a417f }, { 0x398f823c, 0x390a20a9 },
    { 0x398a7525, 0x38dcec8a }, { 0xb895633e, 0xb8a4ed8e }, { 0x3813d6a1, 0x38b04322 },
    { 0x378b3493, 0x3815e6c8 }, { 0xb7cb8c8f, 0xb7ee6b35 }, { 0xb6d2e64e, 0xb7790e65 },
    { 0xb745bf28, 0xb6f9abdd }, { 0xb895b40c, 0x359c1ca2 }, { 0x39a63b19, 0x3a2e4453 },
    { 0xb9da4be3, 0xba3e3459 }, { 0xb929b202, 0x358d9e38 }, { 0xb962437b, 0xb8d13748 },
    { 0x38ffe140, 0x37a2dfc4 }, { 0x3893b405, 0x38114d12 }, { 0xb880b399, 0xb969335d },
    { 0x3784f144, 0x38931f65 }, { 0xb8d85759, 0xb9078da0 }, { 0x394be6d1, 0x38c5ebd6 },
    { 0x39313e35, 0x388c5e69 }, { 0xb852a456, 0xb8592134 }, { 0x37b17409, 0x386ed167 },
    { 0x3755456c, 0x37c34197 }, { 0xb780862a, 0xb7a18fc2 }, { 0xb6dbc62e, 0xb74f97a7 },
    { 0xb6f92f61, 0xb68e9c49 }, { 0xb8538af9, 0x349aab13 }, { 0x396b15a6, 0x39f326d1 },
    { 0xb97620d2, 0xb9d95746 }, { 0xb8d8551e, 0xb79198c7 }, { 0xb90e9cf8, 0xb847d20e },
    { 0x389b42ad, 0x37a12c4e }, { 0x3834e96e, 0x3780b7e8 }, { 0xb81eee63, 0xb9151de6 },
    { 0x37166e6b, 0x38311802 }, { 0xb89d90f7, 0xb8b76b4a } };

static const unsigned int DECMTX_THIRD[HYBRID_BANDS * NUM_EARS * (SH_ORDER_THIRD + 1)
    * (SH_ORDER_THIRD + 1)][2] = { { 0x3f8b669d, 0x0 }, { 0x3ce413a6, 0x0 }, { 0x3be78ed0, 0x0 },
    { 0x3b1439f3, 0x0 }, { 0x39d749d9, 0x0 }, { 0x3a580e89, 0x0 }, { 0x393e366d, 0x0 },
    { 0xb8c7e889, 0x0 }, { 0xbab34f6a, 0x0 }, { 0x38e2647d, 0x0 }, { 0xb918a385, 0x0 },
    { 0xb8e63b1b, 0x0 }, { 0xb858fa89, 0x0 }, { 0xb940804f, 0x0 }, { 0x396c3db4, 0x0 },
    { 0xb8bee5c8, 0x0 }, { 0x3f8b0e13, 0x0 }, { 0xbd121592, 0x0 }, { 0x3bfc7368, 0x0 },
    { 0x3b9fa7bb, 0x0 }, { 0xba2e243a, 0x0 }, { 0xbaac41cc, 0x0 }, { 0x392c9058, 0x0 },
    { 0x3a04ac72, 0x0 }, { 0xb9eea928, 0x0 }, { 0xb93703ca, 0x0 }, { 0x38da3dc0, 0x0 },
    { 0x38352d32, 0x0 }, { 0xb7ee0d68, 0x0 }, { 0xb940819c, 0x0 }, { 0x3964d72d, 0x0 },
    { 0x38071ead, 0x0 }, { 0x3f87a3b3, 0xbad2115c }, { 0x3d620467, 0x3e69edb3 },
    { 0x3cd84092, 0x3ca23102 }, { 0x3bb8af07, 0x3ca18a32 }, { 0xba478a0a, 0x3a69234d },
    { 0x3a5bb6a7, 0xbb585c6d }, { 0x3c010b0c, 0xbc8670b4 }, { 0x3aaf556a, 0xbb111c11 },
    { 0x3bb34bab, 0xbb848fc1 }, { 0x393a1243, 0x397696b4 }, { 0xb83975cd, 0xb8d1ee42 },
    { 0xb982e27e, 0x39382c32 }, { 0xbafab9a1, 0x3aa08b5c }, { 0xb9a02cc5, 0xb8bb783e },
    { 0x38aea22f, 0x399dbe22 }, { 0xb7c70081, 0xb897001a }, { 0x3f85f597, 0x3a3798ce },
    { 0xbd813c1c, 0xbe88696f }, { 0x3cdc6fa7, 0x3cbb995d }, { 0x3c1624fa, 0x3cf3090f },
    { 0x3aec44a8, 0xbae3bf07 }, { 0xba686caf, 0x3b71db3d }, { 0x3bfea83d, 0xbc83e142 },
    { 0x3b0599a8, 0xbb0c1fc1 }, { 0x3bce3aaa, 0xbb68da37 }, { 0xb96ef8ac, 0xb96704d2 },
    { 0xb831a827, 0x382f9a47 }, { 0x39583b33, 0xb990412e }, { 0xbaf50cdf, 0x3ab18177 },
    { 0xb9b57c7c, 0xb872d980 }, { 0x380f3e7f, 0x3949c104 }, { 0x38b2d2e7, 0x38869ada },
    { 0x3f7f50dc, 0x3c0462c1 }, { 0x3db7053a, 0x3ed0128b }, { 0x3d44a0da, 0xbad8e343 },
    { 0x3c7d00dc, 0x3cfc7ae3 }, { 0xbb961721, 0x3b2f6301 }, { 0xbb755bb4, 0xbc21daa4 },
    { 0x3c15cb3b, 0xbd17f0af }, { 0x3b2516ec, 0xbc06efa6 }, { 0x3cb089ff, 0xbbfcbcbb },
    { 0x3a5b12cf, 0x3a36cf1e }, { 0x38313e5e, 0xb97740bd }, { 0xb8a83bff, 0x3b16020e },
    { 0xbb867272, 0x3be62927 }, { 0xbad8cea5, 0x3974399d }, { 0x3a90c2e8, 0xb71c662f },
    { 0x39aef966, 0xb87c5d9c }, { 0x3f7af742, 0x3c69a782 }, { 0xbdbceba3, 0xbee0814f },
    { 0x3d4846fd, 0x3b92a654 }, { 0x3ca8c55b, 0x3d42e335 }, { 0x3bcd2aa6, 0xbb6c3093 },
    { 0x3ba2563e, 0x3c1c70cf }, { 0x3c19c27b, 0xbd144b36 }, { 0x3b27af80, 0xbc0b94f0 },
    { 0x3cb719ab, 0xbbde6ccf }, { 0xba66f2b3, 0xba2dc194 }, { 0xb837063d, 0x38a9db1d },
    { 0x375e6745, 0xbb28fe0d }, { 0xbb7bd11e, 0x3be5f160 }, { 0xbafc33fd, 0x39cd2260 },
    { 0x3a826b5a, 0xb96c8345 }, { 0x39bae465, 0x391bfb5c }, { 0x3f6d853c, 0x3cd13f96 },
    { 0x3dea8425, 0x3f037283 }, { 0x3d399b71, 0xbcd5c3dd }, { 0x3cb115c1, 0x3d008b3c },
    { 0xbbe1729d, 0x3b810471 }, { 0xbc2b382e, 0xbc279dd8 }, { 0x3c05eedb, 0xbd3f6f10 },
    { 0x3a12cc65, 0xbc5e669e }, { 0x3d0f464f, 0xbc234d44 }, { 0x3a766e45, 0x3aafa9a3 },
    { 0x39aa62a5, 0xb9b8f4bf }, { 0x3aff7b6d, 0x3b9ad1a8 }, { 0xbb420d99, 0x3c337010 },
    { 0xbb285eab, 0x3ac55f8e }, { 0x3a974a5b, 0xb9be69fa }, { 0x3a10f77b, 0xb91ddaec },
    { 0x3f6a1057, 0x3d02d873 }, { 0xbde777e1, 0xbf08e77f }, { 0x3d4201f7, 0xbc94fa85 },
    { 0x3ce3b2d4, 0x3d530d59 }, { 0x3c254767, 0xbba26d1b }, { 0x3c3ba4eb, 0x3c10be16 },
    { 0x3c0f66ff, 0xbd3b9594 }, { 0xb9a592e1, 0xbc637189 }, { 0x3d11c33f, 0xbc0c3320 },
    { 0xba6f3572, 0xbaa1c248 }, { 0xb9e682da, 0x389dbeb4 }, { 0xbb06677b, 0xbba1b980 },
    { 0xbb3bfebc, 0x3c31c7aa }, { 0xbb425b6f, 0x3af73fca }, { 0x3a61e338, 0xba240314 },
    { 0x3a03c4aa, 0x39c07408 }, { 0x3f515821, 0x3db05558 }, { 0x3e16f9ac, 0x3f2764c9 },
    { 0x3c3fb3a4, 0xbd5ab21e }, { 0x3cb3eb62, 0x3ce0243e }, { 0xbc573109, 0x3bbdb619 },
    { 0xbc65c22c, 0xbb55de61 }, { 0x3b8c6c99, 0xbd58ad56 }, { 0xbc006bcf, 0xbc97be8d },
    { 0x3d85cbd3, 0xbc3cfb38 }, { 0x3ac40cb7, 0x3b669a15 }, { 0x3a29d610, 0xba8fc545 },
    { 0x3bfb9656, 0x3ba0f9e2 }, { 0xbaa5f994, 0x3c831c37 }, { 0xbb310bd2, 0x3b91abc8 },
    { 0x3b055fdb, 0xbaf9b91c }, { 0x3a7fa227, 0xb6bc2787 }, { 0x3f4f62aa, 0x3dbca61c },
    { 0xbe1096f1, 0xbf299c39 }, { 0x3c8356c4, 0xbd38077d }, { 0x3cec9782, 0x3d5674af },
    { 0x3c8a7e86, 0xbbf57b34 }, { 0x3c6ae219, 0x3aecaa8d }, { 0x3baf659a, 0xbd57459f },
    { 0xbc271026, 0xbc91c343 }, { 0x3d8862f7, 0xbc15f6bb }, { 0xbaa1c42f, 0xbb5c7463 },
    { 0xba87a265, 0x3a8a20cd }, { 0xbbf1fe59, 0xbba3851d }, { 0xbaad8b27, 0x3c85407f },
    { 0xbb533c8e, 0x3baa1fc8 }, { 0x3abdef1b, 0xbaf3494e }, { 0x3a6a6fee, 0x3a06414a },
    { 0x3f3f21bd, 0x3e006762 }, { 0x3e35cc57, 0x3f388f5a }, { 0xbca410ee, 0xbd5a5d5b },
    { 0x3c8f3f01, 0x3cd75f9d }, { 0xbc87f14c, 0x3c0bb041 }, { 0xbc2ca5d6, 0xbb2c8e5a },
    { 0x3bbf8e06, 0xbd3c9156 }, { 0xbc5e1fca, 0xbc8f26f6 }, { 0x3db62324, 0xbc7c640e },
    { 0x3ade3527, 0x3bac0fd3 }, { 0x39cda509, 0xbabdd26e }, { 0x3c156f9a, 0x3b527106 },
    { 0x3aa5e5de, 0x3ca61df3 }, { 0xbaf24de8, 0x3bd0317d }, { 0x3a5f92e9, 0xbb7021ae },
    { 0x3aba7856, 0xb95fc6ba }, { 0x3f3d982e, 0x3e075ab6 }, { 0xbe2e8369, 0xbf39ea1f },
    { 0xbc7b635f, 0xbd39e92c }, { 0x3cd1b6d4, 0x3d58c96a }, { 0x3cadc2cf, 0xbc0ce27a },
    { 0x3c30be90, 0x3acb4753 }, { 0x3bdd26e3, 0xbd3ca14b }, { 0xbc846f69, 0xbc853d9d },
    { 0x3db99b4a, 0xbc4dec88 }, { 0xbaa8ceee, 0xbba71c15 }, { 0xba6aabf3, 0x3ae8bb4f },
    { 0xbc0d1230, 0xbb61c379 }, { 0x3a9f5067, 0x3ca93da0 }, { 0xbb23c577, 0x3bf1550f },
    { 0x3973380c, 0xbb5c18cb }, { 0x3a13501f, 0x3a4fbb63 }, { 0x3f20e69a, 0x3e65e9d0 },
    { 0x3e3f9927, 0x3f45e505 }, { 0xbd738cdd, 0xbcd58547 }, { 0x3bdc88ab, 0x3cf536ec },
    { 0xbcb3523e, 0x3c16067b }, { 0xbc054ec7, 0xbc25836a }, { 0x3ced2aef, 0xbcfab96a },
    { 0xbc9bdf9a, 0xbc7976c5 }, { 0x3e064922, 0xbc798161 }, { 0x3aaa5112, 0x3c1f4299 },
    { 0x3a5e6f7c, 0xbabdc356 }, { 0x3c11616a, 0x3b2b4d61 }, { 0x3bf73b5d, 0x3ccfdfda },
    { 0xb7b0eb70, 0x3c14c7fd }, { 0xbad4d111, 0xbb92505c }, { 0x3a6597f4, 0xb99fda3a },
    { 0x3f1ee3fc, 0x3e6ca814 }, { 0xbe38068a, 0xbf46a715 }, { 0xbd60357c, 0xbc96c9eb },
    { 0x3c350d70, 0x3d6412ac }, { 0x3cfaf07c, 0xbbf5f27a }, { 0x3c0eeed2, 0x3c31da3c },
    { 0x3cf32b94, 0xbcf6c6a1 }, { 0xbcc3cde0, 0xbc5dc837 }, { 0x3e08740c, 0xbc3036b3 },
    { 0xba077379, 0xbc1ec82d }, { 0xba840ff0, 0x3b4bedf0 }, { 0xbc04d8c1, 0xbb380d74 },
    { 0x3be60731, 0x3cd4d3bf }, { 0xba8602a7, 0x3c30f0eb }, { 0xbb1ebf1f, 0xbb70728b },
    { 0x39d82e10, 0x3b219e36 }, { 0x3f174bd8, 0x3ea16a63 }, { 0x3e3d5c37, 0x3f5198e2 },
    { 0xbd921462, 0x3adcaeb4 }, { 0x384ac397, 0x3d171a6e }, { 0xbce72187, 0x3c30d45e },
    { 0xbc25760f, 0xbc9e3a38 }, { 0x3d68f87c, 0xbccb213d }, { 0xbcca9c59, 0xbc5b544d },
    { 0x3e327ab4, 0xbc8c7e72 }, { 0x3a9555e7, 0x3c672bbf }, { 0x3abf2d7d, 0xbb388f51 },
    { 0x3bdb9050, 0x3b09f969 }, { 0x3c67d105, 0x3cee0878 }, { 0x3b082a55, 0x3c3c12f5 },
    { 0xbb9b20b5, 0xbbb474b9 }, { 0x3a0e38ac, 0x3a58ae92 }, { 0x3f14818d, 0x3ea4f0fa },
    { 0xbe34316e, 0xbf51dffe }, { 0xbd8862f2, 0x3c06809c }, { 0xb9e39745, 0x3d89d55a },
    { 0x3d24f0fd, 0xbbff40aa }, { 0x3c4b3ff6, 0x3cb1f90c }, { 0x3d6bf8f1, 0xbcc6d178 },
    { 0xbcfcd166, 0xbc0f42ce }, { 0x3e3549ad, 0xbc3dff3f }, { 0xb91c5c8c, 0xbc6ae0e1 },
    { 0xb9838fef, 0x3ba98aa3 }, { 0xbbaf17b6, 0xbb15fccd }, { 0x3c580c67, 0x3cf823cb },
    { 0x3a93aaf1, 0x3c67af85 }, { 0xbbb31ca2, 0xbb8678bb }, { 0x39bb165b, 0x3b5f88e4 },
    { 0x3f0fbeff, 0x3ec600db }, { 0x3e65f46d, 0x3f523cb5 }, { 0xbd82be12, 0x3d1db88d },
    { 0xbbdfa825, 0x3d42a57b }, { 0xbd0a68d6, 0x3c82fbe7 }, { 0xbce90f0f, 0xbd055ccb },
    { 0x3de1308a, 0xbd0f378f }, { 0xbcf27128, 0xba2706e6 }, { 0x3e74451f, 0xbd34203c },
    { 0x3b0f8d9d, 0x3cb62c3a }, { 0xba99cc9a, 0xbb9c40b3 }, { 0xbb212b97, 0x3c0fe592 },
    { 0x3cee3cd2, 0x3cc88ea0 }, { 0x3c0b099d, 0x3c5a0323 }, { 0xbc435156, 0xba1adf22 },
    { 0x3a785352, 0x3b298630 }, { 0x3f0c4530, 0x3ecaf19c }, { 0xbe58bccb, 0xbf51b08b },
    { 0xbd7d8d0c, 0x3d306369 }, { 0xbb3559c4, 0x3dad08a2 }, { 0x3d59b39c, 0xbc4ad2ad },
    { 0x3d0d5e97, 0x3d0fc4a8 }, { 0x3ddf8e61, 0xbd0a511c }, { 0xbd056c0a, 0x3bec9ae2 },
    { 0x3e77ec03, 0xbd15366c }, { 0xba80c95c, 0xbcba9d95 }, { 0x3b8b549a, 0x3bcdcaca },
    { 0x3ba01029, 0xbc1ff808 }, { 0x3ce6c515, 0x3cde6f9b }, { 0x3c11326b, 0x3c8a1786 },
    { 0xbc44b2b0, 0x3a92da15 }, { 0xba651d94, 0x3bd31d26 }, { 0x3ee6a241, 0x3eec27e4 },
    { 0x3e094c38, 0x3f4395d6 }, { 0xbd361f08, 0x3d49e1ce }, { 0xbc768691, 0x3d7be2a1 },
    { 0xbd2994ae, 0x3c90b98c }, { 0xbd5990a0, 0xbcbe2908 }, { 0x3e1aad78, 0xbd8908a8 },
    { 0xbc91eff1, 0x3b65e6f8 }, { 0x3e95c207, 0xbd748f1a }, { 0x3a87bb29, 0x3d018b47 },
    { 0xbb296746, 0xbb26bbd7 }, { 0xbba8d527, 0x3cfb0dd0 }, { 0x3cec15e3, 0x3c45e6e6 },
    { 0x3c5fe0a1, 0x3c0cf037 }, { 0xbc47ec1e, 0x3c134864 }, { 0x3a58e934, 0x3bbf3324 },
    { 0x3eddce98, 0x3ef020d5 }, { 0xbdee14d7, 0xbf42045a }, { 0xbd3dbc50, 0x3d5c3e9a },
    { 0xbc505d12, 0x3dbcc67b }, { 0x3d8927da, 0xbc68b0c1 }, { 0x3d7881ed, 0x3cd81e2e },
    { 0x3e18ed19, 0xbd7b20c4 }, { 0xbc91ef7a, 0x3c1ca392 }, { 0x3e983289, 0xbd49b888 },
    { 0x39f1185a, 0xbd04ae07 }, { 0x3bcbea38, 0x3b40ad91 }, { 0x3c05b262, 0xbd04e904 },
    { 0x3ce64aeb, 0x3c850846 }, { 0x3c706a13, 0x3c3942de }, { 0xbc56e381, 0x3c307e18 },
    { 0xba78f8ea, 0x3c46ba40 }, { 0x3ea307b8, 0x3f0e58d1 }, { 0xbc951110, 0x3f45f25a },
    { 0xbceef1f2, 0x3d4c0d5e }, { 0xbc925e50, 0x3d9e6b2e }, { 0xbd4f86ae, 0x3cc145e3 },
    { 0xbd7931fb, 0x3bb53356 }, { 0x3e3c746b, 0xbdcbfa2f }, { 0xbc84c9d4, 0xbb54aa73 },
    { 0x3ec2a821, 0xbda56f94 }, { 0xbb85f417, 0x3d62f636 }, { 0xba960ff1, 0xb9e81dad },
    { 0x3c559ddf, 0x3d86ea5b }, { 0x3cc32776, 0x3b9152b6 }, { 0x3c534966, 0x3b4cd115 },
    { 0xbb945953, 0x3ca3108a }, { 0x3b132bf6, 0x3c42fb58 }, { 0x3e945312, 0x3f10a001 },
    { 0x3d4712f4, 0xbf42e443 }, { 0xbd189ede, 0x3d6818e9 }, { 0xbcb0a93f, 0x3dd3dbec },
    { 0x3daf56a1, 0xbca97c83 }, { 0x3d99e339, 0x3a2be42a }, { 0x3e3e40b0, 0xbdb0fabc },
    { 0xbc8f9690, 0xbb5e5550 }, { 0x3ec608c0, 0xbd83711f }, { 0x3be2ceed, 0xbd68e9a6 },
    { 0x3b7a50dc, 0x3966e3f8 }, { 0xbbe12122, 0xbd8f2d2f }, { 0x3ccdb465, 0x3c46e9f2 },
    { 0x3c50761d, 0x3bb8774d }, { 0xbbd11263, 0x3cc92d8d }, { 0xba6156b1, 0x3cb2d87d },
    { 0x3e2916b0, 0x3f147bbe }, { 0xbe14e915, 0x3f3cb884 }, { 0xbca169cd, 0x3cedf306 },
    { 0xbc91a442, 0x3d9dc17b }, { 0xbd571801, 0x3c9487d8 }, { 0xbd0d0855, 0x3b77ffa3 },
    { 0x3e4064f5, 0xbdcfb540 }, { 0xbc9825a6, 0xbbc32239 }, { 0x3ed6b096, 0xbdb8d471 },
    { 0xbc0469e7, 0x3db5b225 }, { 0x3b6277bc, 0xbb52f750 }, { 0x3d29e5a5, 0x3d981867 },
    { 0x3c6984df, 0x3b6f70ec }, { 0x3c1abcc9, 0x3b4fab6d }, { 0x3b58461b, 0x3c9d06c0 },
    { 0x3b4871c7, 0x3c938bae }, { 0x3e0614b1, 0x3f175870 }, { 0x3e421353, 0xbf38ac03 },
    { 0xbcf5db94, 0x3d2ce0b7 }, { 0xbd0ccad9, 0x3dc36d1b }, { 0x3db7e5a8, 0xbc73d9fe },
    { 0x3d642e02, 0xbb0d5ed0 }, { 0x3e4b443a, 0xbdad2d87 }, { 0xbcd6f3b9, 0xbbc82ec8 },
    { 0x3edd9d7b, 0xbd889c89 }, { 0x3c52bfc6, 0xbdbcc43f }, { 0xba9c3c63, 0x3b79b97c },
    { 0xbd0fbf33, 0xbdad6f34 }, { 0x3ca50f91, 0x3c3a4161 }, { 0x3c09da2e, 0x3bf23e07 },
    { 0x3b66ba2f, 0x3cd84742 }, { 0xba60e334, 0x3d05719c }, { 0x3c2866a3, 0x3f136d54 },
    { 0xbe96635d, 0x3f2b6f60 }, { 0xbd14de09, 0x39cc4846 }, { 0xbcc18409, 0x3d8b5f21 },
    { 0xbd855937, 0x3b824930 }, { 0xbd0fb6f5, 0xbd112159 }, { 0x3e4532a2, 0xbd9284e5 },
    { 0xbcd89b36, 0xbbf1773c }, { 0x3ee50313, 0xbd5b0759 }, { 0xbc289cd0, 0x3e087759 },
    { 0x3ae89c1b, 0xbc3b3741 }, { 0x3d323079, 0x3d977b9a }, { 0x3bb78747, 0x3c244f6b },
    { 0x3c0b5fd4, 0x3be0d9d1 }, { 0x3af4eac4, 0x3c8fbf37 }, { 0x3b816ca7, 0x3cd925c3 },
    { 0xbcfafd88, 0x3f168991 }, { 0x3eb29c5f, 0xbf27652b }, { 0xbd1b5d84, 0x3c56c47a },
    { 0xbd67fc64, 0x3da9b38c }, { 0x3dd601e2, 0x3c232ff2 }, { 0x3d59c7a9, 0x3d0950d1 },
    { 0x3e56490e, 0xbd6ce339 }, { 0xbd19ac0a, 0xbbf1b8ff }, { 0x3eedd9b4, 0xbce2a2ab },
    { 0x3c81f098, 0xbe0ed467 }, { 0xba723b1c, 0x3c5c6a96 }, { 0xbd2588f1, 0xbdb4e063 },
    { 0x3c41611d, 0x3c6f5866 }, { 0x3bbc1d73, 0x3c5badb3 }, { 0x3b198b0a, 0x3cda0c7c },
    { 0xbb89c4a5, 0x3d3d1d56 }, { 0x3da3685b, 0x3f0ea39f }, { 0xbe8ec548, 0x3f2c1903 },
    { 0xbd19102c, 0xb9fc08ad }, { 0xbc8b3b8d, 0x3d939a1f }, { 0xbd817b54, 0x3b408283 },
    { 0xbd1c5c31, 0xbcce8f7a }, { 0x3e3fe2df, 0xbd5334fe }, { 0xbcca8627, 0xbb34b173 },
    { 0x3edbb5b0, 0xbc9e774c }, { 0xbc3c0ed4, 0x3e082f8e }, { 0xb9b5259b, 0xbbbb49b0 },
    { 0x3d141436, 0x3da5039e }, { 0x3c43579a, 0x3bfe45c6 }, { 0x3c223cb4, 0x3bfb7d8c },
    { 0x3b63f997, 0x3c794711 }, { 0x3b86e91f, 0x3cdbf3c4 }, { 0x3d39ef9a, 0x3f14d028 },
    { 0x3eac3f03, 0xbf2a7afa }, { 0xbd310262, 0x3bee3328 }, { 0xbd4abc89, 0x3daceabd },
    { 0x3dd37bde, 0x3c73b56e }, { 0x3d7c1d0b, 0x3ccdd9b4 }, { 0x3e49ac3f, 0xbd19950b },
    { 0xbd1b4d2d, 0x3a4e67f6 }, { 0x3ee3de99, 0x3c103ff0 }, { 0x3c8a72ef, 0xbe0da9c0 },
    { 0x3ab8ea59, 0x3c192762 }, { 0xbd0029cc, 0xbdbd650a }, { 0x3c5df8e2, 0x3c0de5b7 },
    { 0x3c0b9da2, 0x3c788f47 }, { 0x3bfda6c4, 0x3cd1863d }, { 0xbb8fa395, 0x3d3f8975 },
    { 0x3ddce027, 0x3f0c033c }, { 0xbe8f980f, 0x3f2a8d3b }, { 0xbd1edd2b, 0x3b828096 },
    { 0xbc10840a, 0x3d9f40e2 }, { 0xbd833845, 0x3c29fb18 }, { 0xbd1ebfa7, 0xbc9228a8 },
    { 0x3e40361f, 0xbd0acbbf }, { 0xbca121f3, 0x3b7f60d7 }, { 0x3ece4e5c, 0xbba997fe },
    { 0xbb79cbef, 0x3dfc344b }, { 0xbaeab22e, 0x3ab153a6 }, { 0x3d0908e5, 0x3da67583 },
    { 0x3c98164a, 0x3c1d6947 }, { 0x3c41dd8c, 0x3bd1d4bd }, { 0x3a3223e0, 0x3c4ff26f },
    { 0x3be54a9e, 0x3ccdf8f9 }, { 0x3d981884, 0x3f121a7c }, { 0x3ead4a98, 0xbf292c47 },
    { 0xbd4e0ad3, 0x38cc1b1d }, { 0xbd3258ea, 0x3db6ec82 }, { 0x3dce6871, 0x3c465473 },
    { 0x3d82fa53, 0x3cbbca17 }, { 0x3e42d87b, 0xbcb55c50 }, { 0xbce037f3, 0x3c370afc },
    { 0x3ed76ddd, 0x3cda27a6 }, { 0x3c0f396f, 0xbe03ea0d }, { 0x3b6adba0, 0x3ac8a72f },
    { 0xbcf8a902, 0xbdb1b5be }, { 0x3c8fd68e, 0x3c271464 }, { 0x3c6061dc, 0x3c5f47c6 },
    { 0x3bc53128, 0x3cbbddb0 }, { 0xba6ad308, 0x3d382fe7 }, { 0x3e12d86d, 0x3f0fbc07 },
    { 0xbe8fb415, 0x3f2d142c }, { 0xbc80d6f7, 0x3d16c89c }, { 0xbbefc69a, 0x3db2d196 },
    { 0xbd87124e, 0x3c802ace }, { 0xbd48bbcb, 0x3cb56957 }, { 0x3e4c9f7a, 0xbc7124f4 },
    { 0xbc3272e2, 0x3c974a71 }, { 0x3eccf00a, 0x3c342ae6 }, { 0xba5066eb, 0x3df07425 },
    { 0xbb9c5da4, 0x3c11ea74 }, { 0x3cdcb091, 0x3db6c5c3 }, { 0x3cdb245a, 0x3bf1c3fc },
    { 0x3c3e1b59, 0x3bbdbb4c }, { 0x3c40a420, 0x3c82b485 }, { 0x3c0d39a2, 0x3cccdc95 },
    { 0x3dd660a9, 0x3f16f96c }, { 0x3eb176bb, 0xbf2d4101 }, { 0xbd0a0e79, 0x3cf8c467 },
    { 0xbd2c4c9a, 0x3dc870a8 }, { 0x3dcfe0a3, 0x3c51840b }, { 0x3d9ee9ba, 0xbc90be6a },
    { 0x3e4f279b, 0xbacc2d76 }, { 0xbcce8e10, 0x3c9bee8f }, { 0x3ed9071a, 0x3d34dcc1 },
    { 0x3bace83e, 0xbdfb9602 }, { 0x3bdd94dc, 0x39e7955e }, { 0xbcd56046, 0xbdbac78f },
    { 0x3ce0a33e, 0x3c2ac9d5 }, { 0x3c3f9963, 0x3c134cf1 }, { 0x3c8bc210, 0x3cd16490 },
    { 0x3ab77ae3, 0x3d3d0fa0 }, { 0x3e21a61e, 0x3f1049c4 }, { 0xbe874a34, 0x3f27c8c7 },
    { 0xbcc5c525, 0x3d0d4cbb }, { 0xbc00a328, 0x3dcdb098 }, { 0xbd89a196, 0x3cdde9d5 },
    { 0xbd357031, 0x3c5a1cd6 }, { 0x3e38e419, 0xbb52c1c2 }, { 0xbc04222c, 0x3cc026c5 },
    { 0x3ec238d3, 0x3cb1ddcb }, { 0x3af44c5e, 0x3de27334 }, { 0xbbaf7239, 0x3c4db080 },
    { 0x3cd4ceaf, 0x3db04998 }, { 0x3cacf6eb, 0x3bee2391 }, { 0x3c04a63b, 0x3b1cfad8 },
    { 0x3c0e74bb, 0x3c82e87b }, { 0x3c55c043, 0x3cb47106 }, { 0x3df85325, 0x3f170052 },
    { 0x3ea859f7, 0xbf28c296 }, { 0xbd3596bc, 0x3c89d830 }, { 0xbd2734cb, 0x3ddc8f59 },
    { 0x3dd02a22, 0x3ba72ed6 }, { 0x3d858ea4, 0x3b3f2fce }, { 0x3e3e274d, 0x3c0c7990 },
    { 0xbca43117, 0x3cabc9f3 }, { 0x3ecf7df7, 0x3d5ddbef }, { 0x3b5e2a62, 0xbdedbf6b },
    { 0x3bd3b5cb, 0xbb891ae2 }, { 0xbce73905, 0xbdadf019 }, { 0x3cb645f3, 0x3c59cd6e },
    { 0x3c11ed37, 0x3b92e544 }, { 0x3c142afc, 0x3cd68b44 }, { 0x3bc95c1d, 0x3d31429a },
    { 0x3e2c2c46, 0x3f136275 }, { 0xbe83e595, 0x3f285095 }, { 0xbcf1211e, 0x3d09a5fb },
    { 0xbc56fe19, 0x3de9873b }, { 0xbd9546ad, 0x3d17df3c }, { 0xbd4552bd, 0x3ca8b7d8 },
    { 0x3e24b4bb, 0xbb06d15b }, { 0xbc1c598d, 0x3cca7042 }, { 0x3ebede7d, 0x3cfe9d22 },
    { 0x3b288077, 0x3ddf9fa5 }, { 0xbbcdc1f0, 0x3c569359 }, { 0x3cbab73d, 0x3daa3bf4 },
    { 0x3c96f73c, 0x3b8dc1f3 }, { 0x3bae0442, 0xb9ad6212 }, { 0x3c22e33c, 0x3c55ef5a },
    { 0x3c90d86f, 0x3c8c524a }, { 0x3e0b9e58, 0x3f1a0552 }, { 0x3ea356c1, 0xbf2af85b },
    { 0xbd4f0f2c, 0x3c573e89 }, { 0xbd3eaf65, 0x3dfbe112 }, { 0x3de09a59, 0xbbd74863 },
    { 0x3d82d8d6, 0x3b833038 }, { 0x3e2cfc73, 0x3c49b773 }, { 0xbc8fb206, 0x3cda0752 },
    { 0x3eccf136, 0x3d8b60ff }, { 0x3ba3ef61, 0xbded5089 }, { 0x3bfb2c23, 0xbbf623fc },
    { 0xbcd04f50, 0xbdaa3508 }, { 0x3c9d9fe0, 0x3c43c971 }, { 0x3c099f3e, 0x3b53a850 },
    { 0x3bf4a184, 0x3cd05429 }, { 0x3c350e16, 0x3d1ea62a }, { 0x3e2a97ac, 0x3f0e9e0e },
    { 0xbe7a8fa5, 0x3f23fa2b }, { 0xbd06261b, 0x3ce5349a }, { 0xbca5a53f, 0x3de860da },
    { 0xbd9b7127, 0x3d262e5e }, { 0xbd529b55, 0x3cdab159 }, { 0x3e0c6a49, 0xbb661557 },
    { 0xbc09c75d, 0x3cc099df }, { 0x3eb13a4f, 0x3d0a7ae0 }, { 0x3b1412c4, 0x3dd7f3ed },
    { 0xbbe911cc, 0x3c4636c2 }, { 0x3c96464c, 0x3d99f7f7 }, { 0x3c88e6db, 0x3a3c5830 },
    { 0x3b96c61a, 0xbae0cc91 }, { 0x3c281e20, 0x3c1c8b3c }, { 0x3c999aa1, 0x3c3bfc90 },
    { 0x3e0eeec3, 0x3f16e3ac }, { 0x3e9c3213, 0xbf29b8e6 }, { 0xbd4d22d2, 0x3ca30065 },
    { 0xbd4cf730, 0x3e08d06e }, { 0x3dedf056, 0xbcb0288e }, { 0x3d89c051, 0xbc0301b6 },
    { 0x3e18968c, 0x3c85c103 }, { 0xbc5693a3, 0x3cf6f5b9 }, { 0x3ec01eb1, 0x3d9ac369 },
    { 0x3bf62414, 0xbde9cb61 }, { 0x3c1f3e9b, 0xbc05e7b4 }, { 0xbca16b69, 0xbda24a9f },
    { 0x3c987036, 0x3c0eea3c }, { 0x3c16c452, 0x3b162dfe }, { 0x3c1c62d7, 0x3cb10a1d },
    { 0x3c831e68, 0x3d0553bf }, { 0x3e2f09f3, 0x3f0b27cc }, { 0xbe6b2bc7, 0x3f21f49f },
    { 0xbcedca77, 0x3c7ed89a }, { 0xbcb3f342, 0x3deb49c7 }, { 0xbda06ab4, 0x3d3cd11c },
    { 0xbd5312c3, 0x3cc84b13 }, { 0x3dfb31e0, 0xbb899e7e }, { 0xbbdb990d, 0x3cadad11 },
    { 0x3ea4d121, 0x3d1ff560 }, { 0xb964db4a, 0x3dd5984f }, { 0xbbff16e9, 0x3c28d040 },
    { 0x3c5c8c03, 0x3d8da939 }, { 0x3c89ee67, 0x3aaea389 }, { 0x3b92ab0b, 0xbb1802ba },
    { 0x3c1c3716, 0x3c34c7dc }, { 0x3ca07ccb, 0x3c090ff0 }, { 0x3e174792, 0x3f17b1fa },
    { 0x3e982ddb, 0xbf2c3a32 }, { 0xbd2ed50a, 0x3cc583ce }, { 0xbd61b2f9, 0x3e10d824 },
    { 0x3df80648, 0xbd011d22 }, { 0x3d8e8513, 0xbc859890 }, { 0x3e0ca858, 0x3c9c8b3c },
    { 0xbc3d4934, 0x3cdce8fb }, { 0x3eb62edc, 0x3da54a3b }, { 0x3c2fcad5, 0xbdee4731 },
    { 0x3c2db7de, 0xbbb4b227 }, { 0xbc6587b4, 0xbd9d337e }, { 0x3ca27be5, 0x3c1fadd7 },
    { 0x3c09f567, 0x3a89b732 }, { 0x3c309fc3, 0x3ca42a31 }, { 0x3c9c1941, 0x3ce6655f },
    { 0x3e37d95c, 0x3f0d6fc2 }, { 0xbe5e7e07, 0x3f21d101 }, { 0xbcc737d7, 0x3c8679a7 },
    { 0xbc9eb4ca, 0x3e012673 }, { 0xbda3b208, 0x3d69984a }, { 0xbd516bcb, 0x3cd1b843 },
    { 0x3de856b1, 0xb7c5cd34 }, { 0xbbac5df9, 0x3cb04bdd }, { 0x3e9e27a1, 0x3d3f99be },
    { 0xbb2c47b9, 0x3dd69baf }, { 0xbc053995, 0x3c1c8088 }, { 0x3c323434, 0x3d898fe0 },
    { 0x3c9177cf, 0x3b703ef6 }, { 0x3b8a66b9, 0xbafc782e }, { 0x3c24a6be, 0x3c4c7606 },
    { 0x3cab4240, 0x3be0b76f }, { 0x3e200e34, 0x3f1d66cb }, { 0x3e96af61, 0xbf2f542e },
    { 0xbd18e4b9, 0x3cfd5f49 }, { 0xbd72f7b8, 0x3e1e12d7 }, { 0x3dffe4bf, 0xbd2e5c03 },
    { 0x3d908d81, 0xbcaf5110 }, { 0x3e02facb, 0x3c9ec74a }, { 0xbc3c4ba3, 0x3cce5237 },
    { 0x3eb12642, 0x3daee21d }, { 0x3c55c591, 0xbdf47694 }, { 0x3c2f08c4, 0xbb881f80 },
    { 0xbc2f7d50, 0xbd98f5cd }, { 0x3cab4670, 0x3c389e83 }, { 0x3be9cf68, 0x39e5150a },
    { 0x3c3c14c9, 0x3c9acbd4 }, { 0x3caf0c84, 0x3ccbc1bd }, { 0x3e40412b, 0x3f1315b6 },
    { 0xbe5ca971, 0x3f2558da }, { 0xbcb06b83, 0x3cd7c364 }, { 0xbc74388d, 0x3e152ded },
    { 0xbda86e20, 0x3d98bdf3 }, { 0xbd578530, 0x3d045668 }, { 0x3ddc6cec, 0x3bbeb66d },
    { 0xbb684776, 0x3cc220f9 }, { 0x3e9bdb0c, 0x3d577b2e }, { 0xbb8093e8, 0x3dd8835c },
    { 0xbc094578, 0x3c20da7d }, { 0x3c1d8d7c, 0x3d8e237f }, { 0x3c9c9917, 0x3bc41bec },
    { 0x3b80a3b3, 0xbaefee5c }, { 0x3c31bd44, 0x3c43fb88 }, { 0x3cb5df2a, 0x3ba58c70 },
    { 0x3e238e00, 0x3f232b44 }, { 0x3e96c395, 0xbf3287a0 }, { 0xbd02a986, 0x3d10b7b8 },
    { 0xbd6c8370, 0x3e326b87 }, { 0x3e03b300, 0xbd77b0f6 }, { 0x3d92cd9c, 0xbcc6a8e0 },
    { 0x3df6b798, 0x3ca0d3ac }, { 0xbc23c899, 0x3cc706c0 }, { 0x3eadbbca, 0x3db77fa7 },
    { 0x3c6a3ebe, 0xbdf5a448 }, { 0x3c2993a3, 0xbb5f587e }, { 0xbc0ca05c, 0xbd97cade },
    { 0x3cae76c8, 0x3c5326f6 }, { 0x3bd29d4a, 0xb9570b68 }, { 0x3c311ff8, 0x3c9544dd },
    { 0x3cc0d483, 0x3cb3b929 }, { 0x3e4753a3, 0x3f19aca9 }, { 0xbe64456b, 0x3f2b999b },
    { 0xbc80f7cc, 0x3d31267a }, { 0xbc47ade0, 0x3e2d30c3 }, { 0xbdaeea58, 0x3dc69bb1 },
    { 0xbd66b088, 0x3d372a0b }, { 0x3dd874e5, 0x3c44c33e }, { 0xbb074408, 0x3cd4e04a },
    { 0x3e9bcd8e, 0x3d66cf09 }, { 0xbb744ecd, 0x3dda0ae7 }, { 0xbc124de2, 0x3c25e34e },
    { 0x3c06c7bf, 0x3d972545 }, { 0x3caf760a, 0x3bf17583 }, { 0x3b6f9ab6, 0xbb35d501 },
    { 0x3c4597b8, 0x3c3016ad }, { 0x3cbf4895, 0x3ae92138 }, { 0x3e20d72f, 0x3f25b5ab },
    { 0x3e971e83, 0xbf33779c }, { 0xbcb192d2, 0x3d2edd2c }, { 0xbd543dfd, 0x3e495deb },
    { 0x3e0610f8, 0xbdab8089 }, { 0x3d954c7f, 0xbcfb8e30 }, { 0x3dead040, 0x3cb532d0 },
    { 0xbc125bd7, 0x3cbc4d82 }, { 0x3ea8471e, 0x3dbc10df }, { 0x3c690f9f, 0xbdef7516 },
    { 0x3c22718e, 0xbafb1152 }, { 0xbbd82b1b, 0xbd981ad1 }, { 0x3caa8cc4, 0x3c5e01a0 },
    { 0x3bc891f5, 0xba957de2 }, { 0x3c282536, 0x3c9a7bb0 }, { 0x3cd1494e, 0x3c956b69 },
    { 0x3e5219ed, 0x3f21c690 }, { 0xbe7266e5, 0x3f3540fa }, { 0xbbe7366a, 0x3d6e20d3 },
    { 0xbc5c1961, 0x3e48a335 }, { 0xbdbb0468, 0x3dfdfd9e }, { 0xbd77b427, 0x3d609e4e },
    { 0x3dd66d02, 0x3c7c5436 }, { 0xb8e5e9ed, 0x3ced1976 }, { 0x3e9fa49e, 0x3d80674a },
    { 0xbb3f055a, 0x3de1357d }, { 0xbc189ba0, 0x3c1cd7c3 }, { 0x3bf2b4b5, 0x3d9ecea2 },
    { 0x3cb9bc9b, 0x3bfd7e51 }, { 0x3b8cbe0e, 0xbb83d87e }, { 0x3c578129, 0x3c3a03c9 },
    { 0x3cca74fa, 0xbb5872f9 }, { 0x3e2035a8, 0x3f29b9f9 }, { 0x3e9c0487, 0xbf37cab8 },
    { 0xbc36c1cb, 0x3d4b6c28 }, { 0xbd4d7a3d, 0x3e640d4c }, { 0x3e0bdf65, 0xbde2d16b },
    { 0x3d973e51, 0xbd15bd8d }, { 0x3de0242d, 0x3cbc7198 }, { 0xbc1230dd, 0x3ca78c77 },
    { 0x3ea6ad44, 0x3dc325a2 }, { 0x3c69871e, 0xbdee7265 }, { 0x3c1a4968, 0x3a0b52a7 },
    { 0xbbbcba2d, 0xbd9a1a5f }, { 0x3c99be44, 0x3c534fe6 }, { 0x3bb010d9, 0xbb89761e },
    { 0x3c261b25, 0x3cae99fd }, { 0x3ce58536, 0x3c5d826f }, { 0x3e55eda8, 0x3f2531e4 },
    { 0xbe7bd312, 0x3f3972b9 }, { 0xb961de67, 0x3d8c2c11 }, { 0xbc978745, 0x3e603d1c },
    { 0xbdc30e9a, 0x3e198ef3 }, { 0xbd7c2c22, 0x3d814f0f }, { 0x3dca6da9, 0x3c79d1df },
    { 0x3b63472b, 0x3d097f7c }, { 0x3ea0bbf9, 0x3d8aa063 }, { 0xbac48f43, 0x3de27f79 },
    { 0xbc1f5004, 0x3c21946c }, { 0x3bfc21d7, 0x3d9d7dfb }, { 0x3ca68181, 0x3bbfef86 },
    { 0x3bc48301, 0xbb6d8ae0 }, { 0x3c612410, 0x3c4fe901 }, { 0x3cd08b85, 0xbc26c512 },
    { 0x3e19f655, 0x3f2ad80f }, { 0x3e9fd84c, 0xbf392eb2 }, { 0xbaeeaa98, 0x3d75dc87 },
    { 0xbd5303e2, 0x3e7bf645 }, { 0x3e113337, 0xbe0cd944 }, { 0x3d9516bf, 0xbd330bc8 },
    { 0x3dd0da3f, 0x3caf9b0d }, { 0xbbfe0daf, 0x3ca44ef2 }, { 0x3ea43fa9, 0x3dc51176 },
    { 0x3c59124e, 0xbde99ae2 }, { 0x3c1bfb6b, 0x3aaf80a9 }, { 0xbbbeff04, 0xbd974d51 },
    { 0x3c7e8d2b, 0x3c3414ce }, { 0x3bb5ee95, 0xbbdb9ca4 }, { 0x3c331bb1, 0x3cc32aa1 },
    { 0x3cfbf07a, 0x3be34550 }, { 0x3e51a041, 0x3f25cb42 }, { 0xbe801bae, 0x3f37c11e },
    { 0x3bd26d72, 0x3d94f397 }, { 0xbcd0786c, 0x3e71bf64 }, { 0xbdc1f41a, 0x3e2c7b2c },
    { 0xbd7058fb, 0x3d8ae5ae }, { 0x3dc07d6e, 0x3c34d2a1 }, { 0x3bbd6227, 0x3d146745 },
    { 0x3ea05e21, 0x3d8be701 }, { 0x3a96fc9c, 0x3dd8d057 }, { 0xbc1ce2eb, 0x3c2b0555 },
    { 0x3c10fdbe, 0x3d92861e }, { 0x3c887161, 0x3b94096c }, { 0x3be2d7ba, 0xbb73145a },
    { 0x3c543764, 0x3c6d8c4e }, { 0x3cd547c0, 0xbc8ac404 }, { 0x3e1078a2, 0x3f2b452b },
    { 0x3ea20658, 0xbf36b79c }, { 0x3c2c837a, 0x3d948986 }, { 0xbd5d723d, 0x3e883733 },
    { 0x3e138574, 0xbe224efd }, { 0x3d8e04ed, 0xbd47dd69 }, { 0x3dc5579a, 0x3c98504b },
    { 0xbb8d33ca, 0x3cc6ebce }, { 0x3ea2921b, 0x3dc0bbbb }, { 0x3c2b756f, 0xbddd493f },
    { 0x3c1f991f, 0x397fda74 }, { 0xbbd4508d, 0xbd8e57eb }, { 0x3c501f22, 0x3c309846 },
    { 0x3be6b13b, 0xbbcf7940 }, { 0x3c38a8d7, 0x3ce00a15 }, { 0x3d0813df, 0xb817448c },
    { 0x3e43e8a3, 0x3f23bec1 }, { 0xbe82bdb5, 0x3f33e219 }, { 0x3c93d7d7, 0x3da517e2 },
    { 0xbcfdbd2d, 0x3e78d899 }, { 0xbdb92b1e, 0x3e378f47 }, { 0xbd59e9a3, 0x3d9638f9 },
    { 0x3dc009a0, 0x3c0a5472 }, { 0x3bbd8c59, 0x3d151078 }, { 0x3e9d58a9, 0x3d7de888 },
    { 0x3ba6263a, 0x3dc6866c }, { 0xbc135e2f, 0x3c326617 }, { 0x3c37222f, 0x3d856abb },
    { 0x3c65e071, 0x3bce72cc }, { 0x3bcb742f, 0xbbac9d1b }, { 0x3c3c4877, 0x3c877fdc },
    { 0x3cd0d061, 0xbcb3660a }, { 0x3dffe1df, 0x3f2a8d0d }, { 0x3ea5eb09, 0xbf333f93 },
    { 0x3cd615fe, 0x3db7c83d }, { 0xbd6511d9, 0x3e8e9472 }, { 0x3e12d10f, 0xbe321ea6 },
    { 0x3d85ccb0, 0xbd6670ca }, { 0x3dbf456a, 0x3c7975f6 }, { 0xbb03c457, 0x3d01abfb },
    { 0x3e9fd964, 0x3daf3b7d }, { 0x3bb5b4e8, 0xbdcb6011 }, { 0x3c233089, 0xbb3b2de1 },
    { 0xbc0ea9c2, 0xbd83867f }, { 0x3c2cd98a, 0x3c41e5a5 }, { 0x3bf7a03c, 0xbbbb49a8 },
    { 0x3c3ab7ff, 0x3cfe2262 }, { 0x3d0f5e80, 0xbbc39e05 }, { 0x3e2d10d5, 0x3f1f1102 },
    { 0xbe8736ae, 0x3f2f2997 }, { 0x3d045637, 0x3dc26831 }, { 0xbd09bee8, 0x3e77826f },
    { 0xbda946c7, 0x3e3c42f0 }, { 0xbd3c4a1c, 0x3da2ab35 }, { 0x3dc30762, 0x3c179585 },
    { 0x3bce69c2, 0x3d1a892a }, { 0x3e9790e3, 0x3d456a22 }, { 0x3c1d39e1, 0x3dae06c0 },
    { 0xbc11e6a8, 0x3c4c2b3f }, { 0x3c76c53a, 0x3d73f565 }, { 0x3c42c74e, 0x3c1f0a2f },
    { 0x3b9f03b2, 0xbbe5ff7c }, { 0x3c2abae7, 0x3c9648ab }, { 0x3cbf61c1, 0xbccb2332 },
    { 0x3dd1e90c, 0x3f289eeb }, { 0x3eacd91b, 0xbf30dda9 }, { 0x3d21d2f6, 0x3dd2ccd0 },
    { 0xbd65c8cb, 0x3e912370 }, { 0x3e0f19ca, 0xbe3d2545 }, { 0x3d765fb8, 0xbd80ed55 },
    { 0x3dbad0d1, 0x3beb831a }, { 0xbafc524e, 0x3d15960b }, { 0x3e9d065b, 0x3d94041e },
    { 0xb9c91b66, 0xbdb7d302 }, { 0x3c265bdd, 0xbbc648dd }, { 0xbc5a2c6f, 0xbd6c1684 },
    { 0x3c0079d7, 0x3c44f127 }, { 0x3bccb2c3, 0xbc05a7df }, { 0x3c388aa0, 0x3d09a283 },
    { 0x3d13089d, 0xbc1c2bf8 }, { 0x3e13efe2, 0x3f1b6ce8 }, { 0xbe8d9b25, 0x3f2a5434 },
    { 0x3d48b264, 0x3de79a3c }, { 0xbd05442e, 0x3e7847e5 }, { 0xbd96495d, 0x3e3e5acc },
    { 0xbd1c530c, 0x3dad684f }, { 0x3dc9faec, 0x3c209c96 }, { 0x3bd3ca94, 0x3d27e1b1 },
    { 0x3e938bf2, 0x3d01bd66 }, { 0x3c673db9, 0x3d94357d }, { 0xbc161828, 0x3c74d326 },
    { 0x3ca21b43, 0x3d5b6f1d }, { 0x3c204ff4, 0x3c583547 }, { 0x3b80ead5, 0xbc10eb73 },
    { 0x3c1ddb33, 0x3ca86287 }, { 0x3caf1b39, 0xbcd82cff }, { 0x3da377d9, 0x3f2717b1 },
    { 0x3eb492ad, 0xbf2e70c5 }, { 0x3d5abbd2, 0x3deaf67f }, { 0xbd637865, 0x3e923550 },
    { 0x3e07ebcf, 0xbe422f5b }, { 0x3d5e25d1, 0xbd8a3f54 }, { 0x3dbe87e0, 0xbaf7e614 },
    { 0xbb0a72c0, 0x3d2b121c }, { 0x3e9bddcd, 0x3d6fdc4c }, { 0xbbd10a78, 0xbda29006 },
    { 0x3c2e0d2e, 0xbc24f393 }, { 0xbc9845fb, 0xbd4b6f35 }, { 0x3bb47f82, 0x3c470821 },
    { 0x3b8a42ed, 0xbc4bc458 }, { 0x3c34a041, 0x3d15f30c }, { 0x3d11a0eb, 0xbc39bb77 },
    { 0x3dfa39e9, 0x3f1b2b6a }, { 0xbe966e4c, 0x3f286260 }, { 0x3d8c1e21, 0x3e06fbce },
    { 0xbd06f65f, 0x3e7b49be }, { 0xbd84889b, 0x3e3f3a04 }, { 0xbd00c260, 0x3db6cdd9 },
    { 0x3dd221ee, 0x3be16be0 }, { 0x3bb7dfa3, 0x3d3d8aca }, { 0x3e938605, 0x3c7e43d9 },
    { 0x3c9c0e6c, 0x3d7e3a8d }, { 0xbc1d76ac, 0x3c9909c3 }, { 0x3cc9fa24, 0x3d440925 },
    { 0x3be84a87, 0x3c78192c }, { 0x3b4fc0a0, 0xbc375dde }, { 0x3c1b0550, 0x3cc429c7 },
    { 0x3c9ebaeb, 0xbce2008b }, { 0x3d6817a0, 0x3f277588 }, { 0x3ebd286f, 0xbf2cfb6f },
    { 0x3d8fd0c5, 0x3e094d64 }, { 0xbd5b861a, 0x3e9316f9 }, { 0x3dfe5f17, 0xbe441367 },
    { 0x3d4e2bc7, 0xbd979671 }, { 0x3dcd0588, 0xbbb9bdea }, { 0xbaf6510e, 0x3d59ff9f },
    { 0x3e9b80f8, 0x3d31e0bc }, { 0xbc53adb4, 0xbd8cd3f1 }, { 0x3c43b3aa, 0xbc8b4456 },
    { 0xbcc05686, 0xbd3140d0 }, { 0x3b93af98, 0x3c5be10b }, { 0x3b263c72, 0xbc75a743 },
    { 0x3c3e2065, 0x3d23b7bb }, { 0x3d0c5160, 0xbc486478 }, { 0x3dc39ef3, 0x3f1b7282 },
    { 0xbea0374d, 0x3f27fce0 }, { 0x3db099ac, 0x3e19cf27 }, { 0xbd042874, 0x3e7b05b9 },
    { 0xbd62d675, 0x3e3ccbbd }, { 0xbcd8d2a0, 0x3dc708c5 }, { 0x3dd700fb, 0xb97a4cc8 },
    { 0x3b947283, 0x3d5c415a }, { 0x3e942ac1, 0xbb03f460 }, { 0x3cc98f72, 0x3d587d8e },
    { 0xbc265d21, 0x3cc48587 }, { 0x3cf55b6c, 0x3d2baeff }, { 0x3b816174, 0x3c68b27e },
    { 0x3b243e9d, 0xbc4bd504 }, { 0x3c28bc42, 0x3cd68d95 }, { 0x3c8756e1, 0xbce15f68 },
    { 0x3d02ae85, 0x3f27d5cf }, { 0x3ec5f417, 0xbf2bcdc7 }, { 0x3dae44c7, 0x3e230113 },
    { 0xbd522aea, 0x3e9142ba }, { 0x3de98045, 0xbe41529e }, { 0x3d457572, 0xbdaf5423 },
    { 0x3ddd096f, 0xbbc5b8af }, { 0xbaf01cd6, 0x3d8cdc9d }, { 0x3e9a2cdb, 0x3cd18ee6 },
    { 0xbca31677, 0xbd6fb52f }, { 0x3c5ec4b4, 0xbcd56d4b }, { 0xbceb7a4c, 0xbd1cd145 },
    { 0x3b9204cd, 0x3c7bbde9 }, { 0x3a8bfb2d, 0xbc80f94e }, { 0x3c59496e, 0x3d27c904 },
    { 0x3d02149b, 0xbc4aedba }, { 0x3d87e7d8, 0x3f19ec68 }, { 0xbea8f6f3, 0x3f26e1fe },
    { 0x3dd4d90d, 0x3e28ec58 }, { 0xbce201cd, 0x3e72b985 }, { 0xbd3517df, 0x3e32106e },
    { 0xbcc68563, 0x3ddc7352 }, { 0x3ddd0882, 0xbc14b04c }, { 0x3bb0b6df, 0x3d84ae44 },
    { 0x3e92ce41, 0xbc988b63 }, { 0x3cf12799, 0x3d33cb36 }, { 0xbc32ea3e, 0x3cfce22d },
    { 0x3d0a3f55, 0x3d0f5066 }, { 0x3acc43e9, 0x3c43a928 }, { 0x3aec23f1, 0xbc42e2e1 },
    { 0x3c3d1eeb, 0x3ce58064 }, { 0x3c4ac336, 0xbccc3cb8 }, { 0x3c17ea4c, 0x3f279065 },
    { 0x3ece329e, 0xbf2a9c7f }, { 0x3dc95748, 0x3e3b4d71 }, { 0xbd414b04, 0x3e8cc06e },
    { 0x3dd21686, 0xbe37f5d6 }, { 0x3d42e874, 0xbdcddd7b }, { 0x3dea8cf6, 0xbbf7f479 },
    { 0xbb0fd1df, 0x3daba425 }, { 0x3e982df9, 0x3c132f3d }, { 0xbcd36a82, 0xbd4adc3d },
    { 0x3c78e8f7, 0xbd0d7dab }, { 0xbd096dc1, 0xbd08607e }, { 0x3b847400, 0x3c870e54 },
    { 0xba50e2f6, 0xbc811fb5 }, { 0x3c8169e7, 0x3d25187e }, { 0x3ce79d5c, 0xbc31f5ea },
    { 0x3d276371, 0x3f17e6f8 }, { 0xbeb04e55, 0x3f252e74 }, { 0x3dfad910, 0x3e379156 },
    { 0xbca4b1f8, 0x3e646cde }, { 0xbd061cb7, 0x3e21251a }, { 0xbcc03d21, 0x3df2d16f },
    { 0x3dea37b9, 0xbc7d5b18 }, { 0x3bf51950, 0x3da07354 }, { 0x3e8fa545, 0xbcff4ae4 },
    { 0x3d079fc6, 0x3d15e4e1 }, { 0xbc3df88d, 0x3d1e0608 }, { 0x3d14ab0d, 0x3ce05ea1 },
    { 0x3a953eb6, 0x3c3504f4 }, { 0x3a23e964, 0xbc296544 }, { 0x3c563216, 0x3cf200ba },
    { 0x3bfb3bdb, 0xbcaae640 }, { 0xbc1332c4, 0x3f26e7ee }, { 0x3ed58303, 0xbf2951b2 },
    { 0x3ddffed3, 0x3e51b395 }, { 0xbd2c5796, 0x3e863bbd }, { 0x3dba9163, 0xbe297817 },
    { 0x3d456b2c, 0xbdef2b30 }, { 0x3df7e5ce, 0xbc405fd2 }, { 0xbb21af05, 0x3dca1509 },
    { 0x3e95ae7b, 0xbb91659e }, { 0xbcf7bb38, 0xbd2f2095 }, { 0x3c88dbe4, 0xbd2f8756 },
    { 0xbd192adf, 0xbce2070b }, { 0x3b73b9f1, 0x3c8350b9 }, { 0xbb5dbcd4, 0xbc7a6b93 },
    { 0x3c9a175d, 0x3d1cf763 }, { 0x3cc647ac, 0xbc0815f1 }, { 0x3ca230eb, 0x3f163962 },
    { 0xbeb4ec48, 0x3f22eda8 }, { 0x3e0b706b, 0x3e480d42 }, { 0xbc41d35b, 0x3e508d63 },
    { 0xbcb3ffff, 0x3e0c1abe }, { 0xbcb044de, 0x3e055076 }, { 0x3df8ac72, 0xbc84b4f2 },
    { 0x3c17cc52, 0x3dbb5ebc }, { 0x3e8a8783, 0xbd29e65b }, { 0x3d123ade, 0x3cfd9188 },
    { 0xbc436fa6, 0x3d3bb1e8 }, { 0x3d1e8df7, 0x3cbefbc6 }, { 0x3ad0290d, 0x3c318d6e },
    { 0xba8bf8cc, 0xbc037be9 }, { 0x3c7ae55f, 0x3ce79912 }, { 0x3b2beb12, 0xbc8569c9 },
    { 0xbcc09129, 0x3f259f12 }, { 0x3ed93698, 0xbf2755eb }, { 0x3dec0ace, 0x3e664298 },
    { 0xbd131f1f, 0x3e7c5356 }, { 0x3da3cbc6, 0xbe18ba79 }, { 0x3d47c8ea, 0xbe082d98 },
    { 0x3e018fb8, 0xbc718de6 }, { 0xbb30d2be, 0x3de5ad8d }, { 0x3e91305c, 0xbc6e9b14 },
    { 0xbd0742fd, 0xbd1b7104 }, { 0x3c931dd8, 0xbd4f2edd }, { 0xbd222d8a, 0xbcc6ad5e },
    { 0x3b8a8c05, 0x3c6d5736 }, { 0xbbcf05bc, 0xbc5fd3ea }, { 0x3cb162fc, 0x3d0a66f2 },
    { 0x3ca3fd36, 0xbbb50124 }, { 0x3bf98c31, 0x3f1424a7 }, { 0xbeb6c9be, 0x3f208e77 },
    { 0x3e144eca, 0x3e5be5e4 }, { 0xbb330d3a, 0x3e3a815c }, { 0xbc4e4782, 0x3dec2112 },
    { 0xbcadfcdf, 0x3e16c45e }, { 0x3e031223, 0xbc467f2b }, { 0x3c267511, 0x3dd48723 },
    { 0x3e83d949, 0xbd41426c }, { 0x3d15caa7, 0x3cdd8825 }, { 0xbc48acee, 0x3d55d456 },
    { 0x3d269e13, 0x3cbe3d13 }, { 0x3b088164, 0x3c223dde }, { 0xbb20ed8b, 0xbb9abe1e },
    { 0x3c985a4f, 0x3cca477c }, { 0xbb1d1433, 0xbc3cc8f1 }, { 0xbcf25ad2, 0x3f23cb6b },
    { 0x3eda951f, 0xbf25689f }, { 0x3df51610, 0x3e7eccfd }, { 0xbce75150, 0x3e6b4c65 },
    { 0x3d8ea383, 0xbe079cc8 }, { 0x3d587ddf, 0xbe1d3625 }, { 0x3e086d45, 0xbc5421a9 },
    { 0xbb893595, 0x3dfd22cb }, { 0x3e8b0027, 0xbca2b4d2 }, { 0xbd0ba45c, 0xbd0dd0c0 },
    { 0x3c9f65c5, 0xbd67d0b2 }, { 0xbd24afa0, 0xbcc059c4 }, { 0x3bccfdf5, 0x3c515e19 },
    { 0xbc0824c0, 0xbc2ecf30 }, { 0x3ccc416e, 0x3ce9a42c }, { 0x3c7fa4a8, 0xbb274ba3 },
    { 0x3b6bb3fa, 0x3f11cdcc }, { 0xbeb74f9b, 0x3f1e8ff3 }, { 0x3e184905, 0x3e6db9fe },
    { 0x3bdb90ad, 0x3e2407ac }, { 0xbb8aafc6, 0x3dc2cbdf }, { 0xbcbfdb79, 0x3e28bbfd },
    { 0x3e0a25f1, 0xbc0498b2 }, { 0x3bf78dc8, 0x3de69fc3 }, { 0x3e7a97d4, 0xbd4abf1e },
    { 0x3d15f6b1, 0x3ccb236c }, { 0xbc4fb243, 0x3d636061 }, { 0x3d2d4ab3, 0x3ccf9db5 },
    { 0x3b1c0a9d, 0x3c06077c }, { 0xbb3d1424, 0xbab4d77a }, { 0x3caec0e8, 0x3ca815bb },
    { 0xbbe3fb0f, 0xbbf2f96a }, { 0xbce4e5d8, 0x3f221c8d }, { 0x3edaef50, 0xbf23dd52 },
    { 0x3dfe02b2, 0x3e8c81ac }, { 0xbc9cf823, 0x3e5c2c73 }, { 0x3d771cf7, 0xbdefa012 },
    { 0x3d72324e, 0xbe321bda }, { 0x3e10eca3, 0xbc035f16 }, { 0xbbdbf6f6, 0x3e092727 },
    { 0x3e844af2, 0xbcad227e }, { 0xbd0c1289, 0xbd06f60b }, { 0x3caf1aa1, 0xbd775e9c },
    { 0xbd2572a7, 0xbcc965b3 }, { 0x3c1a42a6, 0x3c439018 }, { 0xbc0d0c9f, 0xbbcee2ff },
    { 0x3ce0af42, 0x3cc9f8f5 }, { 0x3c3cb2da, 0x37ea85cc }, { 0x3b992fe8, 0x3f10909a },
    { 0xbeb735cf, 0x3f1e2045 }, { 0x3e17eb24, 0x3e7eb8e9 }, { 0x3c7806f3, 0x3e0e603b },
    { 0x3bae19de, 0x3d9f4371 }, { 0xbce405c9, 0x3e39ab10 }, { 0x3e1253b5, 0xbbcd6cb1 },
    { 0x399fdb4a, 0x3df2ed59 }, { 0x3e71de2e, 0xbd51988c }, { 0x3d177a14, 0x3cc62e32 },
    { 0xbc66f067, 0x3d646226 }, { 0x3d35e978, 0x3cf34305 }, { 0x3aff099a, 0x3baa89ed },
    { 0xbb0bda12, 0x3b04fafc }, { 0x3cbf99a9, 0x3c8dfdee }, { 0xbc2f0cb6, 0xbb942018 },
    { 0xbcbea570, 0x3f218c0d }, { 0x3eda7817, 0xbf23a304 }, { 0x3dfff966, 0x3e99d3d8 },
    { 0xbc2b58ab, 0x3e510be9 }, { 0x3d53a76d, 0xbdd6cce8 }, { 0x3d85f910, 0xbe45d48a },
    { 0x3e184e47, 0xbb8135f8 }, { 0xbc290a00, 0x3e14a5c1 }, { 0x3e7dce3e, 0xbca6df4f },
    { 0xbd0b1db2, 0xbd070e7b }, { 0x3cc559ae, 0xbd8084f5 }, { 0xbd2b1f08, 0xbce9eed1 },
    { 0x3c3e779c, 0x3c32218a }, { 0xbbed7aad, 0xba8e7af0 }, { 0x3cf1537b, 0x3cb859f0 },
    { 0x3c062a86, 0x3ac8cf7a }, { 0x3beee1bf, 0x3f104b7c }, { 0xbeb52613, 0x3f1e6167 },
    { 0x3e15f7c6, 0x3e85887d }, { 0x3cbe63e6, 0x3df3a010 }, { 0x3c8afc6d, 0x3d8157ec },
    { 0xbd0a490c, 0x3e48cf6b }, { 0x3e182e53, 0xbba54a89 }, { 0xbc43034b, 0x3df7913d },
    { 0x3e6ca311, 0xbd5ab667 }, { 0x3d1a9150, 0x3cc83395 }, { 0xbc8b5548, 0x3d5a5907 },
    { 0x3d3f5ff8, 0x3d110e1e }, { 0x3b21547e, 0x3aa142ea }, { 0xba09df52, 0x3bc06e48 },
    { 0x3cc6f2a5, 0x3c839ac0 }, { 0xbc5e5350, 0xbb52fe59 }, { 0xbca301f0, 0x3f202e3b },
    { 0x3ed63fc9, 0xbf224920 }, { 0x3dfd4e17, 0x3ea22000 }, { 0xbb3bdb06, 0x3e43c74e },
    { 0x3d28d600, 0xbdbd5bfe }, { 0x3d905578, 0xbe56642b }, { 0x3e197ed2, 0x3a78fcbc },
    { 0xbc78e79e, 0x3e1cb0f4 }, { 0x3e72a52c, 0xbca1c69e }, { 0xbd08874e, 0xbd0785be },
    { 0x3ce00692, 0xbd803d10 }, { 0xbd320590, 0xbd0b8300 }, { 0x3c590737, 0x3c03ee18 },
    { 0xbb9c1972, 0x3b9fedf4 }, { 0x3cfbf71b, 0x3cb08ca2 }, { 0x3b98d37d, 0x3b0f6c78 },
    { 0x3c9621d3, 0x3f1286b3 }, { 0xbeb385c4, 0x3f219be1 }, { 0x3e11df2b, 0x3e89cfe0 },
    { 0x3d1528d6, 0x3dd2e56e }, { 0x3d029e12, 0x3d5a5d44 }, { 0xbd2c5667, 0x3e505f11 },
    { 0x3e233b8c, 0xba9f856b }, { 0xbcee1757, 0x3dfdf9bf }, { 0x3e6cb89e, 0xbd630f86 },
    { 0x3d21ab2e, 0x3ccdc320 }, { 0xbcbce925, 0x3d481b09 }, { 0x3d496c85, 0x3d348651 },
    { 0x3b4a167c, 0xba36f4e0 }, { 0x3b569b65, 0x3c318bc2 }, { 0x3cbd07cc, 0x3c9e0440 },
    { 0xbc8334aa, 0xbb468c53 }, { 0xbc6521dc, 0x3f1eb324 }, { 0x3ed19bc6, 0xbf213c2f },
    { 0x3df84b45, 0x3ea4c459 }, { 0x3b058c66, 0x3e33cd8d }, { 0x3cead8bb, 0xbda5139f },
    { 0x3d9aa23d, 0xbe5cf7c8 }, { 0x3e1ce0bb, 0x3b480e7f }, { 0xbcc87be4, 0x3e1ec227 },
    { 0x3e6a22a1, 0xbcaae636 }, { 0xbd07e34e, 0xbd0583ae }, { 0x3d00a2ea, 0xbd714a66 },
    { 0xbd396097, 0xbd24e02c }, { 0x3c5506e7, 0x3bac0c3b }, { 0xbb3935f8, 0x3c068954 },
    { 0x3d00da71, 0x3cbc8362 }, { 0x3a98b0ef, 0x3b02dc5a }, { 0x3d2eeb29, 0x3f1899d7 },
    { 0xbeb23080, 0x3f28ffed }, { 0x3e0a3184, 0x3e8ec317 }, { 0x3d620015, 0x3db6f53e },
    { 0x3d590b36, 0x3d4587f3 }, { 0xbd67014d, 0x3e55957c }, { 0x3e364c5c, 0x3c4dcefb },
    { 0xbd59b43d, 0x3e005059 }, { 0x3e6f8751, 0xbd72fbce }, { 0x3d2ea659, 0x3cd3b41f },
    { 0xbd0619c7, 0x3d2a98c6 }, { 0x3d5bbb1a, 0x3d6ddc74 }, { 0x3bd32a1b, 0x39909989 },
    { 0x3c0ed900, 0x3c948a3c }, { 0x3caeeff3, 0x3cca635a }, { 0xbc9fbfb3, 0xbb64051d },
    { 0xbb5cce44, 0x3f1f4871 }, { 0x3ece1d2d, 0xbf22d820 }, { 0x3dee38ba, 0x3ea55438 },
    { 0x3bbdb014, 0x3e297c4d }, { 0x3c7d4fba, 0xbd987db5 }, { 0x3dabf72b, 0xbe5e2936 },
    { 0x3e254786, 0x3bad03c8 }, { 0xbd1a12df, 0x3e1d19ad }, { 0x3e651783, 0xbcbd438a },
    { 0xbd0a7016, 0xbd01f859 }, { 0x3d1829ef, 0xbd59b9a9 }, { 0xbd46b67f, 0xbd46a78d },
    { 0x3c521eb9, 0x3b164e4a }, { 0xbac1b80c, 0x3c1a5de3 }, { 0x3d05de0b, 0x3cda0fd9 },
    { 0xba99f997, 0x3a348c26 }, { 0x3da1b503, 0x3f21b181 }, { 0xbeadeb8b, 0x3f32db2a },
    { 0x3df59d81, 0x3e8f7bd5 }, { 0x3da5c4a4, 0x3da697ee }, { 0x3da26de7, 0x3d4f82be },
    { 0xbd9bfb85, 0x3e514e61 }, { 0x3e4a8879, 0x3d0b84bc }, { 0xbdab6321, 0x3df63dfa },
    { 0x3e709a2d, 0xbd863301 }, { 0x3d3f897a, 0x3cd7c57f }, { 0xbd3c1b1e, 0x3cfdd14f },
    { 0x3d76b9ec, 0x3d9e245f }, { 0x3c51d912, 0x3b755a9b }, { 0x3c5f41cb, 0x3cd62471 },
    { 0x3ca1b0f2, 0x3d02d8d2 }, { 0xbcc16927, 0xbb8ad5ce }, { 0x3c50b356, 0x3f22a9c2 },
    { 0x3eca23bc, 0xbf277e7e }, { 0x3de0f633, 0x3ea3cbda }, { 0x3c23ae24, 0x3e2333e7 },
    { 0x38152be0, 0xbd9520a1 }, { 0x3dc5bb91, 0xbe57ab14 }, { 0x3e3299eb, 0x3c61ee3a },
    { 0xbd5bfb71, 0x3e19fb5a }, { 0x3e60d5ec, 0xbcda498c }, { 0xbd0ed1e3, 0xbcf6c212 },
    { 0x3d38e203, 0xbd3ee43e }, { 0xbd59043b, 0xbd7b48e6 }, { 0x3c6bc678, 0x3a4c55f2 },
    { 0xba0cf8bc, 0x3c26bc9b }, { 0x3d0c2374, 0x3d03ec2c }, { 0xbb581d2c, 0xba93e96f },
    { 0x3df2511c, 0x3f28ba63 }, { 0xbea21b7f, 0x3f3b3a12 }, { 0x3dc17b27, 0x3e8779b0 },
    { 0x3ddd64d1, 0x3da0cbbb }, { 0x3dd7ce30, 0x3d6ea646 }, { 0xbdcc0d3d, 0x3e3dc46e },
    { 0x3e53666b, 0x3d60ffb0 }, { 0xbdec869e, 0x3dd9f301 }, { 0x3e694344, 0xbd95769d },
    { 0x3d4a3a27, 0x3cd865d5 }, { 0xbd73ce2f, 0x3c979ffa }, { 0x3d876611, 0x3dc91ee7 },
    { 0x3ca26b09, 0x3bc6561a }, { 0x3c7d548f, 0x3d06a21f }, { 0x3ca497de, 0x3d210137 },
    { 0xbce86562, 0xbbcddb4d }, { 0x3d089fbb, 0x3f28e2e8 }, { 0x3ec3662a, 0xbf2ec317 },
    { 0x3dd3ad55, 0x3ea1a359 }, { 0x3c84b7f0, 0x3e217123 }, { 0xbc8dda52, 0xbd9a1508 },
    { 0x3de99182, 0xbe4a4c3f }, { 0x3e43878a, 0x3d067f7f }, { 0xbd8fa4b0, 0x3e16721d },
    { 0x3e5a4e47, 0xbcfddb6f }, { 0xbd1211a2, 0xbce27987 }, { 0x3d606a8b, 0xbd234e79 },
    { 0xbd6d393a, 0xbda2c26c }, { 0x3ca2b6dd, 0x3b36e480 }, { 0x38ec6b40, 0x3c4b8da0 },
    { 0x3d134bc1, 0x3d1e8f78 }, { 0xbbb5b6c6, 0xbb39303a }, { 0x3e19836c, 0x3f283c3e },
    { 0xbe8b4ab9, 0x3f3c8bb4 }, { 0x3d701545, 0x3e622003 }, { 0x3e08e841, 0x3da712c7 },
    { 0x3e00a868, 0x3d8748e8 }, { 0xbdfbea7f, 0x3e133722 }, { 0x3e475845, 0x3d84f923 },
    { 0xbe12402f, 0x3db3cbc4 }, { 0x3e56e1db, 0xbd9e9564 }, { 0x3d46d470, 0x3cd07f09 },
    { 0xbd8fc167, 0x3bd4cfaa }, { 0x3d883275, 0x3de83b96 }, { 0x3cc5c0c8, 0x3b9c5e1f },
    { 0x3c7843d2, 0x3d116a02 }, { 0x3cb3b0d0, 0x3d4134bb }, { 0xbd01a87c, 0xbc12fa0e },
    { 0x3d5e98fd, 0x3f301b79 }, { 0x3eb847a2, 0xbf361b70 }, { 0x3dc386c9, 0x3e9bbdcd },
    { 0x3cc39102, 0x3e210d98 }, { 0xbd103d20, 0xbda18337 }, { 0x3e099fda, 0xbe30dc09 },
    { 0x3e52f2a4, 0x3d62f943 }, { 0xbdae9fee, 0x3e124927 }, { 0x3e517c54, 0xbd131cb6 },
    { 0xbd0fe3c7, 0xbcc7f262 }, { 0x3d83fd03, 0xbd06ef4e }, { 0xbd7f8436, 0xbdca4be1 },
    { 0x3cdca35e, 0x3bd9a6eb }, { 0x39eb085c, 0x3c813970 }, { 0x3d1d1593, 0x3d3d930f },
    { 0xbc0e4d14, 0xbb7e4864 }, { 0x3e2a8453, 0x3f2092f2 }, { 0xbe5ac01d, 0x3f35bee5 },
    { 0x3cccbeea, 0x3e26f570 }, { 0x3e1cf7e9, 0x3db4faa9 }, { 0x3e0a6402, 0x3d91c733 },
    { 0xbe111754, 0x3dbc55d5 }, { 0x3e2d0329, 0x3d8cce1e }, { 0xbe232b94, 0x3d91c410 },
    { 0x3e3af3f3, 0xbda0421a }, { 0x3d36eee2, 0x3cbd3325 }, { 0xbd9aa720, 0xbad7a4c6 },
    { 0x3d778ee4, 0x3df476c9 }, { 0x3ce41b1d, 0x3b35bfdf }, { 0x3c6908f4, 0x3d0cb399 },
    { 0x3ccb3913, 0x3d604b92 }, { 0xbd02e2e8, 0xbc30f87f }, { 0x3d9368a6, 0x3f361e7c },
    { 0x3ea8e885, 0xbf3b9b5b }, { 0x3dac4271, 0x3e90f3f2 }, { 0x3d01e9db, 0x3e205c32 },
    { 0xbd4f750e, 0xbda6164f }, { 0x3e1e00b1, 0xbe0f0ea8 }, { 0x3e599bb8, 0x3d953bb8 },
    { 0xbdcdf0d4, 0x3e0c8c3c }, { 0x3e45bce9, 0xbd29d11d }, { 0xbd07ecbe, 0xbcab63bb },
    { 0x3d9378b0, 0xbcdb56b1 }, { 0xbd849e99, 0xbdef125b }, { 0x3d031a3c, 0x3c09124d },
    { 0xb9a69eb6, 0x3c9a0fc6 }, { 0x3d2fe682, 0x3d6088fb }, { 0xbc4ebd97, 0xbb8fccd9 },
    { 0x3e2d28c5, 0x3f171689 }, { 0xbe23092f, 0x3f2b89c2 }, { 0x3b919868, 0x3de8e007 },
    { 0x3e25dd5a, 0x3dbd2c37 }, { 0x3e0bed7e, 0x3d937445 }, { 0xbe1e3fb6, 0x3d3e9ef8 },
    { 0x3e116b43, 0x3d94a902 }, { 0xbe2aac27, 0x3d7429bd }, { 0x3e1eb4b4, 0xbda0d5fd },
    { 0x3d21b60c, 0x3ca64a29 }, { 0xbd9bb779, 0xbb970804 }, { 0x3d540624, 0x3df2c69c },
    { 0x3d0a55de, 0x3b323787 }, { 0x3c559963, 0x3cfe7116 }, { 0x3cee1ef7, 0x3d76d941 },
    { 0xbcff007e, 0xbc41a48c }, { 0x3daa8a92, 0x3f394496 }, { 0x3e966f10, 0xbf3e06f7 },
    { 0x3d8d8cc1, 0x3e80fd7a }, { 0x3d254586, 0x3e226d0d }, { 0xbd810b84, 0xbda72109 },
    { 0x3e2f12e9, 0xbdd0b2ff }, { 0x3e53288f, 0x3da33079 }, { 0xbdee3be3, 0x3e06f8e0 },
    { 0x3e3676be, 0xbd4042b4 }, { 0xbcf50f94, 0xbc92367a }, { 0x3d9ddc22, 0xbcc03109 },
    { 0xbd81ba0b, 0xbe0433ff }, { 0x3d0da3a8, 0x3be366bc }, { 0xbacc9ab4, 0x3cad57f1 },
    { 0x3d4a5ebe, 0x3d842560 }, { 0xbc83393b, 0xbba08072 }, { 0x3e26b595, 0x3f0f7ed6 },
    { 0xbdf0dccc, 0x3f229d70 }, { 0xbbb43338, 0x3da395c8 }, { 0x3e24c04f, 0x3db79bc7 },
    { 0x3e0ac72d, 0x3d8da317 }, { 0xbe25fc91, 0x3c59e7c8 }, { 0x3deff7b6, 0x3d9f1107 },
    { 0xbe2e5daf, 0x3d565c55 }, { 0x3e081429, 0xbda69169 }, { 0x3d0c7e16, 0x3c8c6af0 },
    { 0xbd97bf20, 0xbb6b4e0c }, { 0x3d346a27, 0x3dee9920 }, { 0x3d27750d, 0x3ba8b54c },
    { 0x3c39eb6c, 0x3cd71afe }, { 0x3d0eaf06, 0x3d80af4f }, { 0xbcfc4ddc, 0xbc4d19b7 },
    { 0x3db1e5d6, 0x3f3a1ea8 }, { 0x3e820ece, 0xbf3e83a5 }, { 0x3d5bc963, 0x3e5e5ff9 },
    { 0x3d4f3e06, 0x3e242b08 }, { 0xbd97acc8, 0xbda3e688 }, { 0x3e3c7c40, 0xbd851239 },
    { 0x3e43623f, 0x3daaae7d }, { 0xbe06673d, 0x3e0368a7 }, { 0x3e23f948, 0xbd65118f },
    { 0xbcd6cd27, 0xbc5b80c7 }, { 0x3da4a6ac, 0xbcc4d55d }, { 0xbd6f043a, 0xbe0c417a },
    { 0x3d1b0fd3, 0x3be83e56 }, { 0xbaef16b1, 0x3cc023d6 }, { 0x3d65fc92, 0x3d956be1 },
    { 0xbc9987e0, 0xbbab33cc }, { 0x3e1de845, 0x3f0a555a }, { 0xbdb366ce, 0x3f1c9bc0 },
    { 0xbc319261, 0x3d66250d }, { 0x3e20ee42, 0x3da986c2 }, { 0x3e09dfdc, 0x3d830712 },
    { 0xbe2b57f3, 0xbc45b660 }, { 0x3dc3826e, 0x3da9c2d7 }, { 0xbe314e4f, 0x3d452fca },
    { 0x3dec415f, 0xbdb18d37 }, { 0x3cf3540b, 0x3c5f6ad5 }, { 0xbd940d23, 0xb9a09c2c },
    { 0x3d18e581, 0x3dece26d }, { 0x3d41299e, 0x3c266c55 }, { 0x3c1e7a12, 0x3caabddd },
    { 0x3d28ad24, 0x3d82f192 }, { 0xbcff25e6, 0xbc5387f1 }, { 0x3db46fb2, 0x3f3a576b },
    { 0x3e5abc32, 0xbf3e7aca }, { 0x3d396ff3, 0x3e4056e9 }, { 0x3d7bf464, 0x3e20cb75 },
    { 0xbdae979f, 0xbd9acbc3 }, { 0x3e4966ca, 0xbcfc9019 }, { 0x3e3363a2, 0x3dc1ea6c },
    { 0xbe126c02, 0x3e032b47 }, { 0x3e0ef33e, 0xbd8c8989 }, { 0xbcb7fe45, 0xbbeccd4f },
    { 0x3dab1c2c, 0xbce13d92 }, { 0xbd4e41b9, 0xbe130666 }, { 0x3d37d39c, 0x3c69ddf6 },
    { 0xb9b55e24, 0x3cd8bfd1 }, { 0x3d7ede99, 0x3da293b7 }, { 0xbcb01bca, 0xbb942650 },
    { 0x3e14b047, 0x3f082acb }, { 0xbd8824f9, 0x3f19e05c }, { 0xbc7c20c8, 0x3d197073 },
    { 0x3e20232a, 0x3d9ca1e7 }, { 0x3e09be64, 0x3d6a4eb4 }, { 0xbe310b66, 0xbd0e6f3f },
    { 0x3d9f34e9, 0x3db3b89f }, { 0xbe332389, 0x3d4b8331 }, { 0x3dccb3c9, 0xbdc27ef7 },
    { 0x3cd05f09, 0x3c1dc24c }, { 0xbd9290af, 0x3bb00b8a }, { 0x3cf9061b, 0x3deca0aa },
    { 0x3d559b2d, 0x3c8a1902 }, { 0x3c162d6c, 0x3c88f1a7 }, { 0x3d435853, 0x3d8694a4 },
    { 0xbd02e5ff, 0xbc4c4162 }, { 0x3db5b172, 0x3f3d1da7 }, { 0x3e395bf4, 0xbf409f58 },
    { 0x3d3c0457, 0x3e2e2b2a }, { 0x3d913689, 0x3e1852e0 }, { 0xbdc80782, 0xbd8a5369 },
    { 0x3e57ed0b, 0x3a1bca46 }, { 0x3e27bc0a, 0x3de21bba }, { 0xbe1e6122, 0x3e05ccd2 },
    { 0x3df76990, 0xbdabf97f }, { 0xbc972901, 0xba965210 }, { 0x3db29c1e, 0xbd07413f },
    { 0xbd28c8d0, 0xbe186d72 }, { 0x3d5e9b38, 0x3cd99b8a }, { 0x3a7529bc, 0x3cee16fc },
    { 0x3d8f926c, 0x3daeee4a }, { 0xbccc0653, 0xbb3a30e4 }, { 0x3e08eda0, 0x3f0714a1 },
    { 0xbd4ae52d, 0x3f180f04 }, { 0xbca22e19, 0x3c9cde86 }, { 0x3e20808e, 0x3d8db6c5 },
    { 0x3e0a44ce, 0x3d423188 }, { 0xbe367397, 0xbd677991 }, { 0x3d7de70f, 0x3db859d5 },
    { 0xbe33e5b4, 0x3d5e82e6 }, { 0x3dafae27, 0xbdd8b167 }, { 0x3cae283b, 0x3bb37ad4 },
    { 0xbd911308, 0x3c47a7cb }, { 0x3cb94ea8, 0x3de8b9b6 }, { 0x3d62356b, 0x3cc27b05 },
    { 0x3c1a9882, 0x3c55aa0a }, { 0x3d5c7634, 0x3d8af60e }, { 0xbd04fd29, 0xbc366dc8 },
    { 0x3dadbeac, 0x3f3f4645 }, { 0x3e1d56e3, 0xbf41a54f }, { 0x3d3f65d6, 0x3e2115af },
    { 0x3d9f3604, 0x3e0c8b50 }, { 0xbde02db7, 0xbd654b07 }, { 0x3e625eff, 0x3ce4f4ec },
    { 0x3e179e6f, 0x3df526c8 }, { 0xbe2b1849, 0x3e07f62e }, { 0x3dd1d943, 0xbdcc5276 },
    { 0xbc64906b, 0x3b5e1385 }, { 0x3db68029, 0xbd230e6b }, { 0xbd0192e0, 0xbe18c37c },
    { 0x3d787bf1, 0x3d1a7b9d }, { 0x39a9db91, 0x3ceed812 }, { 0x3da3adc7, 0x3db77243 },
    { 0xbce4fd6b, 0xba107e8a }, { 0x3df80cb6, 0x3f092613 }, { 0xbd15baf2, 0x3f198370 },
    { 0xbcbd9756, 0x37ff3ac8 }, { 0x3e21f6ac, 0x3d74c95d }, { 0x3e0d90b0, 0x3d07feb3 },
    { 0xbe3e491e, 0xbda0225c }, { 0x3d45ea64, 0x3dbaafd4 }, { 0xbe374790, 0x3d796fbb },
    { 0x3d968599, 0xbdf90caa }, { 0x3c8b894f, 0x3a1f0ed9 }, { 0xbd90aadf, 0x3ca27498 },
    { 0x3c6f0351, 0x3de55fe8 }, { 0x3d6a3945, 0x3d001a35 }, { 0x3c161b33, 0x3c13d586 },
    { 0x3d7ced9a, 0x3d93b173 }, { 0xbd091acc, 0xbc0e059d }, { 0x3d9edf54, 0x3f42d0b1 },
    { 0x3e066a0c, 0xbf445296 }, { 0x3d2af616, 0x3e130fb4 }, { 0x3dade4ff, 0x3dff5a23 },
    { 0xbdf7c0e1, 0xbd24a1ef }, { 0x3e6a7f72, 0x3d4a9823 }, { 0x3e01da36, 0x3df91541 },
    { 0xbe3aadc8, 0x3e0a3bd5 }, { 0x3daec616, 0xbdf86e47 }, { 0xbc1a8ada, 0x3c0d7498 },
    { 0x3db89b12, 0xbd446b10 }, { 0xbcb45554, 0xbe180ff6 }, { 0x3d7dbe59, 0x3d4111bb },
    { 0xbafda8ef, 0x3cdafbd1 }, { 0x3dbbe9f1, 0x3dbe68df }, { 0xbcfd38fd, 0x3b15a852 },
    { 0x3ddbe675, 0x3f0d9408 }, { 0xbcd7376e, 0x3f1da96f }, { 0xbcbeefa8, 0xbc9e27af },
    { 0x3e254be1, 0x3d3d1b00 }, { 0x3e12f6ae, 0x3c54b65c }, { 0xbe471002, 0xbdcebb1b },
    { 0x3d0df7cf, 0x3db9831b }, { 0xbe3b65b0, 0x3d8c995b }, { 0x3d7f53a1, 0xbe10dd39 },
    { 0x3c4ea8b1, 0xbb982051 }, { 0xbd8fbff0, 0x3cec01f9 }, { 0x3badca56, 0x3de0619e },
    { 0x3d6cfe0d, 0x3d2420ac }, { 0x3be3d38d, 0x3b5dc3a2 }, { 0x3d92be94, 0x3d9f4633 },
    { 0xbd0ac3ad, 0xbb91680a }, { 0x3d910016, 0x3f4862bb }, { 0x3de0bb72, 0xbf49dec7 },
    { 0x3d0ceb5c, 0x3e0290d8 }, { 0x3dc58b78, 0x3de5bd8a }, { 0xbe0900df, 0xbca336eb },
    { 0x3e7288a0, 0x3d8dc8b0 }, { 0x3dd474e4, 0x3df50deb }, { 0xbe493d24, 0x3e0f00b6 },
    { 0x3d8b1774, 0xbe196d5f }, { 0xbbacfc37, 0x3c784d19 }, { 0x3dbb2733, 0xbd6b3545 },
    { 0xbc1ed867, 0xbe150e58 }, { 0x3d78ddfe, 0x3d764490 }, { 0xbb9246ce, 0x3cbe4a2a },
    { 0x3dd2e663, 0x3dc4f060 }, { 0xbd0a2086, 0x3bc3e479 }, { 0x3dc51cdd, 0x3f14cd88 },
    { 0xbc7e1efa, 0x3f24f1a0 }, { 0xbca9a994, 0xbd158a36 }, { 0x3e2f7b7c, 0x3cff7bb9 },
    { 0x3e1af03f, 0xbc3346b8 }, { 0xbe504462, 0xbdffb2f6 }, { 0x3c95455c, 0x3db485f9 },
    { 0xbe3e86f7, 0x3d9ed984 }, { 0x3d59e118, 0xbe277202 }, { 0x3c0f6da4, 0xbc1e8d6b },
    { 0xbd8e28c2, 0x3d208169 }, { 0xbbb9f894, 0x3dd90326 }, { 0x3d69fcbc, 0x3d521f0b },
    { 0x3af11b89, 0xbba43ea3 }, { 0x3da92d8c, 0x3dab8eb6 }, { 0xbd054107, 0x3a2399f4 },
    { 0x3d85ca2c, 0x3f4f8306 }, { 0x3db361df, 0xbf51b76a }, { 0x3cf25f73, 0x3deb1dad },
    { 0x3de70e69, 0x3dcdb6fc }, { 0xbe1868b9, 0x3b813391 }, { 0x3e793865, 0x3db5da93 },
    { 0x3da41a44, 0x3dee9a8b }, { 0xbe5440b9, 0x3e177dbc }, { 0x3d4e1c4d, 0xbe3a3117 },
    { 0xbb089338, 0x3caebcd1 }, { 0x3dbca565, 0xbd8a183e }, { 0x3bba83ea, 0xbe0d5296 },
    { 0x3d6f7d6b, 0x3d9f94d4 }, { 0xbc03534f, 0x3c9bdaa1 }, { 0x3de6c53f, 0x3dc9a5c8 },
    { 0xbd1359c5, 0x3c372d08 }, { 0x3dbdf149, 0x3f1f3c89 }, { 0x39969170, 0x3f2fcbf2 },
    { 0xbc75406e, 0xbd5cedca }, { 0x3e474ef7, 0x3c911b44 }, { 0x3e25b5a3, 0xbd1c9368 },
    { 0xbe57a0a9, 0xbe1c61a9 }, { 0xbb83d077, 0x3da78530 }, { 0xbe3fcac3, 0x3db281ac },
    { 0x3d42add1, 0xbe3ef779 }, { 0x3bad5b08, 0xbc715938 }, { 0xbd8a1a92, 0x3d5159ad },
    { 0xbc9334ee, 0x3dcc5013 }, { 0x3d5d6b73, 0x3d873d55 }, { 0xbbfbec27, 0xbc9221f3 },
    { 0x3dbeca1b, 0x3db97974 }, { 0xbcef2bff, 0x3bd95538 }, { 0x3d7da3b3, 0x3f5764cd },
    { 0x3d7ff3b2, 0xbf5b5d9a }, { 0x3cca9592, 0x3dd7387c }, { 0x3e0dfcbb, 0x3dc20e67 },
    { 0xbe2a3799, 0x3ceaf446 }, { 0x3e7b392d, 0x3de2aacc }, { 0x3d5b440e, 0x3ddda666 },
    { 0xbe5cb292, 0x3e245544 }, { 0x3d005dbf, 0xbe5cb1a0 }, { 0xb9e66c14, 0x3cd1cdad },
    { 0x3dbc7bf4, 0xbd9f8e0f }, { 0x3cb96b45, 0xbdfeacbe }, { 0x3d5dd708, 0x3dc67ce2 },
    { 0xbc6f65bb, 0x3c517e21 }, { 0x3df5ad23, 0x3dcd3cee }, { 0xbd1494f9, 0x3c926cd9 },
    { 0x3dbe530a, 0x3f275d6a }, { 0x3c702dba, 0x3f381685 }, { 0xbbc479bc, 0xbd453e9e },
    { 0x3e6a4d90, 0x3ca3e99e }, { 0x3e28e52b, 0xbd6d80f6 }, { 0xbe58b970, 0xbe23a00a },
    { 0xbd0c4615, 0x3d8b709b }, { 0xbe353e75, 0x3dcd1704 }, { 0x3d4c98e5, 0xbe490b69 },
    { 0x3b68d750, 0xbc92eef6 }, { 0xbd7d4038, 0x3d840963 }, { 0xbd0af152, 0x3daebf97 },
    { 0x3d42da6e, 0x3d9fdcd7 }, { 0xbcb8fb46, 0xbcfdb93b }, { 0x3dca0882, 0x3dbb7b14 },
    { 0xbcafc20a, 0x3c4bcfa6 }, { 0x3d7e12f4, 0x3f58e5b3 }, { 0x3d26c3ae, 0xbf6243c8 },
    { 0x3cd75a0e, 0x3de68a92 }, { 0x3e2d99c1, 0x3dc077fa }, { 0xbe36e5ba, 0x3d5b54b7 },
    { 0x3e756d08, 0x3dea5804 }, { 0x3cdc9f7a, 0x3dc34bc6 }, { 0xbe6229e7, 0x3e2a0ded },
    { 0x3c909011, 0xbe7616c7 }, { 0xbaf81caa, 0x3ccf29a9 }, { 0x3db39c58, 0xbdafc202 },
    { 0x3d3048b3, 0xbdd0738a }, { 0x3d414798, 0x3de78931 }, { 0xbceff0cd, 0x396f37b4 },
    { 0x3dfa45c0, 0x3dbf6d2e }, { 0xbd07c944, 0x3cc5e579 }, { 0x3daefae9, 0x3f23e8a2 },
    { 0x3d303ab8, 0x3f36b5f8 }, { 0x3b77c8a8, 0xbd72e377 }, { 0x3e8a6c7f, 0x3cc3ac8f },
    { 0x3e26bb56, 0xbd915c18 }, { 0xbe40fccf, 0xbe2ce659 }, { 0xbd93932d, 0x3cf7bae2 },
    { 0xbe20cac5, 0x3de0bb4d }, { 0x3d2c5d8f, 0xbe4b2be7 }, { 0x3b8f14d7, 0xbc81fc02 },
    { 0xbd5a94c3, 0x3d9af8b2 }, { 0xbd37e492, 0x3d6ad0a6 }, { 0x3d11c127, 0x3da5f802 },
    { 0xbd13e24d, 0xbd3431ac }, { 0x3dc13741, 0x3da9de1c }, { 0xbc3cc7d4, 0x3c8adbf5 },
    { 0x3d870801, 0x3f4bcc92 }, { 0xbab05620, 0xbf5af87d }, { 0x3c9c4cf4, 0x3dafbab8 },
    { 0x3e649424, 0x3dc8633e }, { 0xbe39e7e4, 0x3d8dcb92 }, { 0x3e567784, 0x3e0253a3 },
    { 0xbbfcb69f, 0x3d55930a }, { 0xbe58c6a4, 0x3e207355 }, { 0x3b8d8ae9, 0xbe7cd121 },
    { 0xbbaadf8a, 0x3cb048a5 }, { 0x3da59b74, 0xbdb5291f }, { 0x3d6303f5, 0xbd810ad5 },
    { 0x3d16d646, 0x3df6d018 }, { 0xbd3f3702, 0xbc897999 }, { 0x3ddecba1, 0x3da3cbff },
    { 0xbcc7c0cf, 0x3ce3f044 }, { 0x3d9399c0, 0x3f158ded }, { 0x3d85c37f, 0x3f2bd48d },
    { 0x3c4a03e8, 0xbd731814 }, { 0x3e90b24e, 0x3cd8bbe6 }, { 0x3e1cbc4c, 0xbd89ac07 },
    { 0xbe1f71ca, 0xbe221083 }, { 0xbdcb47f3, 0xbc090d46 }, { 0xbe011ac3, 0x3de7ab26 },
    { 0x3cf26bc8, 0xbe40ae80 }, { 0x3bcd1a64, 0xbc41d388 }, { 0xbd327271, 0x3da12cea },
    { 0xbd57ef93, 0x3ce0fe4d }, { 0x3cbee91e, 0x3d9d2c1e }, { 0xbd3fa7bb, 0xbd4b33cb },
    { 0x3daae7f5, 0x3d8c780d }, { 0xbb8e7b69, 0x3c94400b }, { 0x3d92da11, 0x3f365b66 },
    { 0xbd06f1d1, 0xbf485e77 }, { 0x3b77df27, 0x3d8ea954 }, { 0x3e84c4a9, 0x3de32a6b },
    { 0xbe2d7b94, 0x3d7dcef3 }, { 0x3e30daaa, 0x3df6c2ea }, { 0xbd1e16ae, 0x3c35323d },
    { 0xbe3e902e, 0x3e14fc62 }, { 0xb9cb7218, 0xbe67c1e2 }, { 0xbb9c4856, 0x3c8b393a },
    { 0x3d91cd38, 0xbdb10168 }, { 0x3d772b62, 0xbcd5afe6 }, { 0x3cd8c89b, 0x3df64778 },
    { 0xbd7b9efb, 0xbcc24fa9 }, { 0x3dae0c71, 0x3d80c8e3 }, { 0xbc5fb448, 0x3cee1376 },
    { 0x3d79c0a6, 0x3f068c33 }, { 0x3da53299, 0x3f208304 }, { 0x3c802683, 0xbd22dffa },
    { 0x3e91c801, 0x3d104e87 }, { 0x3e13cb81, 0xbd551e4c }, { 0xbe037c7f, 0xbe070f6e },
    { 0xbdf298ee, 0xbd2b62c0 }, { 0xbdc28f43, 0x3dea90ed }, { 0x3c9ccc1a, 0xbe32b10a },
    { 0x3c0f9c5e, 0xbbd7195f }, { 0xbd13cefa, 0x3d9fefbb }, { 0xbd75a6a1, 0xb9b29ec0 },
    { 0x3c61fa46, 0x3d91f7cc }, { 0xbd6656b8, 0xbd442a7e }, { 0x3d93773c, 0x3d5eaafe },
    { 0x3a07d200, 0x3c80c701 }, { 0x3d8f26d7, 0x3f23efa4 }, { 0xbd5288c3, 0xbf39a64e },
    { 0xbc78d4cc, 0x3d8d5d3e }, { 0x3e8fd650, 0x3dfb538d }, { 0xbe210c7e, 0x3d323001 },
    { 0x3e1453ad, 0x3dcc14ab }, { 0xbd789abc, 0xbcb88d86 }, { 0xbe23d0bf, 0x3e0e9a89 },
    { 0xbbadf80e, 0xbe530b3e }, { 0xbb477379, 0x3c2c10d4 }, { 0x3d801170, 0xbdabe6d8 },
    { 0x3d7cff72, 0x3b83e26a }, { 0x3c882fd8, 0x3de97b38 }, { 0xbd94a53a, 0xbcb8b359 },
    { 0x3d8482fb, 0x3d428ada }, { 0xbbd54f71, 0x3ce83c96 }, { 0x3d46d4dc, 0x3ef8313b },
    { 0x3db68c6b, 0x3f198896 }, { 0x3c50bc1e, 0xbc460edf }, { 0x3e949528, 0x3d334708 },
    { 0x3e0e6462, 0xbd1e2b4f }, { 0xbde119e1, 0xbdcc9bb0 }, { 0xbe051fb1, 0xbd8f246e },
    { 0xbd8fc419, 0x3dec59ed }, { 0x3c1af66b, 0xbe278f3f }, { 0x3c23c835, 0xba864df5 },
    { 0xbcf50580, 0x3d9e76a8 }, { 0xbd8860df, 0xbcccedaf }, { 0x3bb57ab5, 0x3d889ab7 },
    { 0xbd81982b, 0xbd2a660f }, { 0x3d826fac, 0x3d2a4aa2 }, { 0x3b88aa1a, 0x3c593bcb },
    { 0x3d85670c, 0x3f176cad }, { 0xbd7fb6d4, 0xbf3116c7 }, { 0xbd14c24e, 0x3d9fdfb5 },
    { 0x3e97986b, 0x3e07ae82 }, { 0xbe1b347d, 0x3cb425e0 }, { 0x3e04c97d, 0x3d914f69 },
    { 0xbd9c2392, 0xbd4f974a }, { 0xbe0c5483, 0x3e081ff6 }, { 0xbc17e75f, 0xbe455e85 },
    { 0xbb01954b, 0x3b90bfe3 }, { 0x3d627281, 0xbda2dc40 }, { 0x3d8073ed, 0x3ce62933 },
    { 0x3c1f33a7, 0x3dd42698 }, { 0xbda4b6af, 0xbc9aa2f9 }, { 0x3d4e2f20, 0x3d0c48b1 },
    { 0xbb519352, 0x3cd6055b }, { 0x3d1c23b3, 0x3eed975a }, { 0x3dc274ae, 0x3f176d83 },
    { 0x3aed2718, 0x3c61a395 }, { 0x3e9a7656, 0x3d488f26 }, { 0x3e0dde85, 0xbcf76da9 },
    { 0xbdcbe9c3, 0xbd8cb04d }, { 0xbe0b8ac2, 0xbdc5a745 }, { 0xbd546c33, 0x3dec2e7e },
    { 0x3a58c514, 0xbe21b889 }, { 0x3c1fa62e, 0x3b432432 }, { 0xbcc97b20, 0x3d9c9286 },
    { 0xbd92cadf, 0xbd3e4889 }, { 0xbaadeee8, 0x3d7e2a14 }, { 0xbd89515f, 0xbd0939e1 },
    { 0x3d68b1ff, 0x3cfb989e }, { 0x3bec0351, 0x3c3b0cee }, { 0x3d643464, 0x3f0fc42f },
    { 0xbd8954ba, 0xbf2c86ac }, { 0xbd63124d, 0x3dbc871a }, { 0x3e9d85c4, 0x3e0cc06a },
    { 0xbe1a8b1c, 0x3bc2afee }, { 0x3dfd1f9f, 0x3d2c67a4 }, { 0xbdaee693, 0xbd912909 },
    { 0xbdec484b, 0x3dff1f2e }, { 0xbc597d82, 0xbe3cb4b4 }, { 0xb9d31a53, 0xb92b864e },
    { 0x3d440472, 0xbd96541a }, { 0x3d81fe59, 0x3d43072a }, { 0x3bb8bbce, 0x3dbd28c9 },
    { 0xbdab553e, 0xbc7474a6 }, { 0x3d2700e2, 0x3cbbb716 }, { 0xbb263fa5, 0x3ccbf850 },
    { 0x3cfc03e2, 0x3eea4391 }, { 0x3dcdb9f3, 0x3f18c75b }, { 0xbc55ba18, 0x3cf8496d },
    { 0x3ea22f32, 0x3d416e96 }, { 0x3e0ee39e, 0xbcfd6f89 }, { 0xbdc0e727, 0xbd34d1ac },
    { 0xbe0d01e5, 0xbdfcb956 }, { 0xbd2598df, 0x3de8b029 }, { 0xbbeb106c, 0xbe20bed8 },
    { 0x3bffbd31, 0x3b9042d2 }, { 0xbca61b29, 0x3d99b033 }, { 0xbd97c6b1, 0xbd8438b9 },
    { 0xbbceb748, 0x3d6a070c }, { 0xbd8a9a63, 0xbcd1916c }, { 0x3d4c5d04, 0x3cb3f68d },
    { 0x3c2e1c11, 0x3c36af2f }, { 0x3d370e56, 0x3f0c518f }, { 0xbd8f08ef, 0xbf2ae83c },
    { 0xbd946f35, 0x3dd6cc70 }, { 0x3ea295ba, 0x3e0e5990 }, { 0xbe1dafc2, 0xbb41b364 },
    { 0x3df9014c, 0x3c9d2070 }, { 0xbdbcb586, 0xbdaea157 }, { 0xbdc32520, 0x3de957c9 },
    { 0xbc8fec46, 0xbe38e4c4 }, { 0x3afb01dd, 0xbb1997ee }, { 0x3d2505ff, 0xbd88a103 },
    { 0x3d82df15, 0x3d814523 }, { 0x3b60bfc4, 0x3daa2e06 }, { 0xbda9fb8a, 0xbc42645c },
    { 0x3d0c09f9, 0x3c6921f6 }, { 0xbb5b7299, 0x3cc99f53 }, { 0x3d04af78, 0x3eea709f },
    { 0x3ddeda18, 0x3f1b7d06 }, { 0xbcf03659, 0x3d0efffd }, { 0x3eabf51d, 0x3d2b68cb },
    { 0x3e100881, 0xbd20a151 }, { 0xbdbaecb7, 0xbce89f0b }, { 0xbe0c653b, 0xbe1adbff },
    { 0xbd1889a8, 0x3ddfb289 }, { 0xbc2f0e2c, 0xbe227107 }, { 0x3bb2607c, 0x3b482859 },
    { 0xbc92ca65, 0x3d946387 }, { 0xbd9702a3, 0xbda29783 }, { 0xbbf36dcf, 0x3d5705d9 },
    { 0xbd89048d, 0xbca18386 }, { 0x3d29e910, 0x3c81b09d }, { 0x3c7a7195, 0x3c47109a },
    { 0x3d0790ed, 0x3f0c6c4f }, { 0xbd954301, 0xbf2c7599 }, { 0xbdb2a5f3, 0x3ddd2437 },
    { 0x3ea892c2, 0x3e0bd706 }, { 0xbe22fb68, 0xbb22d06c }, { 0x3df56f65, 0x3b9ecd47 },
    { 0xbdc81629, 0xbdcf1763 }, { 0xbda1b711, 0x3dd461c1 }, { 0xbcc02faa, 0xbe3a2442 },
    { 0x3ba28724, 0xbb245dde }, { 0x3d0b1ad3, 0xbd7cdb54 }, { 0x3d82bf29, 0x3d99b32e },
    { 0x3ad4053d, 0x3d9b1dbb }, { 0xbda418f1, 0xbc12ff20 }, { 0x3cf3da31, 0x3c0c09b2 },
    { 0xbb813bdf, 0x3cd4371a }, { 0x3d3b6dce, 0x3eeafa56 }, { 0x3df3dbc3, 0x3f1e4b80 },
    { 0xbd45a97d, 0x3d0458ec }, { 0x3eb8692f, 0x3d17e60b }, { 0x3e1073b6, 0xbd55aa44 },
    { 0xbdb88ab8, 0xbc8e269d }, { 0xbe0cc6a1, 0xbe357c0c }, { 0xbd343954, 0x3dd1eecb },
    { 0xbb8edc9e, 0xbe2419d6 }, { 0x3b6de9ed, 0xba0d1f51 }, { 0xbc8edf99, 0x3d8de798 },
    { 0xbd93eb60, 0xbdbbb777 }, { 0xbb88bd2e, 0x3d44e6ea }, { 0xbd85f939, 0xbc843476 },
    { 0x3cfa45d9, 0x3c36cb17 }, { 0x3cb452ff, 0x3c723318 }, { 0x3cba62b6, 0x3f0da435 },
    { 0xbd95332e, 0xbf2f7105 }, { 0xbdc8cfc7, 0x3dd87562 }, { 0x3eac9b60, 0x3e06dd21 },
    { 0xbe25e6d5, 0x3baaf6f5 }, { 0x3def06f4, 0xbbbac8b1 }, { 0xbdd0f0e0, 0xbdf110ab },
    { 0xbd886329, 0x3dc4df1d }, { 0xbcf40b0c, 0xbe3cbeb3 }, { 0x3c016837, 0xba6fd78a },
    { 0x3cf13c5e, 0xbd710b3d }, { 0x3d823f55, 0x3dace443 }, { 0xba565362, 0x3d8ba9b8 },
    { 0xbd9c356e, 0xbb98f75e }, { 0x3cd778b9, 0x3b89a082 }, { 0xbb49c150, 0x3ce7ac4c },
    { 0x3d958a4e, 0x3eeca3f4 }, { 0x3e05f872, 0x3f2308fc }, { 0xbd98d16f, 0x3cebddbb },
    { 0x3eca9cef, 0x3d11ac13 }, { 0x3e12158e, 0xbd89bef4 }, { 0xbdbb7ad5, 0xbbbfa32c },
    { 0xbe10f3b5, 0xbe4f0649 }, { 0xbd7ead81, 0x3dc10ec5 }, { 0x3c611b3c, 0xbe26bec3 },
    { 0x3b485d24, 0xbbb09ed8 }, { 0xbc991943, 0x3d87e224 }, { 0xbd9398cc, 0xbdd54f25 },
    { 0x3b31dcea, 0x3d314e8b }, { 0xbd8128db, 0xbc6599ae }, { 0x3c883cc1, 0x3bcbd7fc },
    { 0x3cfdbe42, 0x3c9a91eb }, { 0x3c72e45c, 0x3f0f59a5 }, { 0xbd8ed2dc, 0xbf33d6be },
    { 0xbdd7eb66, 0x3dd5d586 }, { 0x3eaed606, 0x3e016072 }, { 0xbe267ef4, 0x3c8e0e06 },
    { 0x3de9495f, 0xbc6b8b08 }, { 0xbdda62a7, 0xbe07edc2 }, { 0xbd6f7e7c, 0x3dbb3323 },
    { 0xbd13a58b, 0xbe404f0d }, { 0x3c2950e5, 0x3b19b1ae }, { 0x3cdbb40f, 0xbd6bd030 },
    { 0x3d82eebc, 0x3dc0cb7f }, { 0xbb807d80, 0x3d7a39b7 }, { 0xbd9412d1, 0x3a98d785 },
    { 0x3cb6b3ef, 0xb94633b8 }, { 0xba3e5711, 0x3d01442a }, { 0x3de35e08, 0x3ef04f92 },
    { 0x3e137f18, 0x3f2a7a51 }, { 0xbde0292e, 0x3cd8a132 }, { 0x3ee502fb, 0x3d1730c4 },
    { 0x3e16661d, 0xbdac0d49 }, { 0xbdc5a22e, 0x3c109897 }, { 0xbe192a93, 0xbe690e19 },
    { 0xbdb8016c, 0x3dae41d1 }, { 0x3d2825d5, 0xbe2a2b0b }, { 0x3ba1024d, 0xbc1c3fd9 },
    { 0xbcb6dff0, 0x3d82c3e9 }, { 0xbd9758b2, 0xbdf117e7 }, { 0x3c38459a, 0x3d1984ef },
    { 0xbd750ecf, 0xbc3f7090 }, { 0x3ab7f44f, 0xb94e439a }, { 0x3d2c3b26, 0x3cc8e137 },
    { 0x3c2f2e75, 0x3f13b0a2 }, { 0xbd877ba2, 0xbf3bbc7f }, { 0xbdeb1ade, 0x3dd78531 },
    { 0x3eb3cf79, 0x3dfb518d }, { 0xbe28b59e, 0x3d044cf4 }, { 0x3de9c3b5, 0xbcbbfe8d },
    { 0xbde88552, 0xbe1832b6 }, { 0xbd670869, 0x3db65b36 }, { 0xbd2b7030, 0xbe488039 },
    { 0x3c4632c8, 0x3bd24748 }, { 0x3cdbc4a4, 0xbd698856 }, { 0x3d84c40a, 0x3dd784ee },
    { 0xbbdc7a32, 0x3d627a90 }, { 0xbd8d2bc9, 0x3bfa7734 }, { 0x3c8bb40e, 0xbbb189ce },
    { 0x3b34b2c2, 0x3d1362c6 }, { 0x3e1d4ebc, 0x3ef19260 }, { 0x3e233929, 0x3f320ec4 },
    { 0xbe14e77a, 0x3cd546b4 }, { 0x3f021fe7, 0x3d23bd25 }, { 0x3e1f6a3b, 0xbdcda181 },
    { 0xbdd903d7, 0x3cddb713 }, { 0xbe2528f4, 0xbe80cb4d }, { 0xbdf62604, 0x3d9762f4 },
    { 0x3d97e0be, 0xbe2a24d6 }, { 0x3c33331c, 0xbc402f4e }, { 0xbcf796a4, 0x3d76caf4 },
    { 0xbd9b16bb, 0xbe066462 }, { 0x3ca6e99c, 0x3cf47074 }, { 0xbd6a20ae, 0xbc064d38 },
    { 0xbc49ccfe, 0xbc08876e }, { 0x3d5f2b15, 0x3cfeddf9 }, { 0x3c118aaa, 0x3f1a5775 },
    { 0xbd8055f9, 0xbf47427f }, { 0xbe03e034, 0x3dd9c262 }, { 0x3ebd3bad, 0x3df32bf4 },
    { 0xbe2f34ea, 0x3d4c7bdb }, { 0x3df12313, 0xbd092755 }, { 0xbdfa7bed, 0xbe2c24ec },
    { 0xbd77f254, 0x3db27308 }, { 0xbd3f36c7, 0xbe55f598 }, { 0x3c531399, 0x3c2b67da },
    { 0x3cf345f8, 0xbd646e32 }, { 0x3d86b970, 0x3deef9c1 }, { 0xbbff02ca, 0x3d49375f },
    { 0xbd842d2f, 0x3c5f6665 }, { 0x3c217a7d, 0xbc43c4f3 }, { 0x3befdcc9, 0x3d29bc56 },
    { 0x3e47ad4b, 0x3ee8986e }, { 0x3e316394, 0x3f3495df }, { 0xbe307f7f, 0x3ced1a82 },
    { 0x3f103e28, 0x3d2dd02e }, { 0x3e2aca45, 0xbde84788 }, { 0xbdf10a74, 0x3d479bdf },
    { 0xbe30b394, 0xbe897337 }, { 0xbe162564, 0x3d758b17 }, { 0x3de16533, 0xbe20ebff },
    { 0x3cab4321, 0xbc3b70e6 }, { 0xbd2cadd6, 0x3d5e73d8 }, { 0xbd977226, 0xbe10549e },
    { 0x3cf84d1a, 0x3ca8824c }, { 0xbd600bae, 0xbb802eb3 }, { 0xbcb75215, 0xbc8daafa },
    { 0x3d8785f7, 0x3d19d5f5 }, { 0x3c11d59d, 0x3f1f0e0a }, { 0xbd6e3d1e, 0xbf51c90b },
    { 0xbe148265, 0x3dd7bc38 }, { 0x3ec85bb1, 0x3de58bfb }, { 0xbe377c3e, 0x3d8c5b54 },
    { 0x3dfb4dfc, 0xbd428c62 }, { 0xbe04856a, 0xbe404b8a }, { 0xbd8e0e00, 0x3da94fa0 },
    { 0xbd46805a, 0xbe6280ae }, { 0x3c45d11e, 0x3c57a88e }, { 0x3d114050, 0xbd56a03b },
    { 0x3d86171c, 0x3e0051b5 }, { 0xbbd37ff9, 0x3d255793 }, { 0xbd688299, 0x3c94cc8c },
    { 0x3a01a686, 0xbca2d943 }, { 0x3c561b3b, 0x3d3e2b82 }, { 0x3e69220a, 0x3ed22943 },
    { 0x3e387a3d, 0x3f2ed94a }, { 0xbe3bde1c, 0x3d10ba26 }, { 0x3f185ba8, 0x3d2d0206 },
    { 0x3e34ca21, 0xbdf43862 }, { 0xbe021bf7, 0x3d92d82c }, { 0xbe355190, 0xbe8bea75 },
    { 0xbe282c40, 0x3d377196 }, { 0x3e1198bc, 0xbe0ce1f7 }, { 0x3d05a0a4, 0xbc10ebcc },
    { 0xbd63788f, 0x3d3fd523 }, { 0xbd8b871d, 0xbe1382b8 }, { 0x3d224e27, 0x3c3305ec },
    { 0xbd4f2dac, 0x3916e280 }, { 0xbcdbbd84, 0xbcca1e71 }, { 0x3d960182, 0x3d2bf131 },
    { 0x3c371fac, 0x3f1d9bef }, { 0xbd59d2f8, 0xbf558106 }, { 0xbe242b02, 0x3dd28fd6 },
    { 0x3ed0bdd1, 0x3dd1022d }, { 0xbe3de061, 0x3daed452 }, { 0x3e007f9b, 0xbd7d051e },
    { 0xbe076c65, 0xbe4c2889 }, { 0xbda7b958, 0x3d9626f6 }, { 0xbd3c4f04, 0xbe66afdd },
    { 0x3c161423, 0x3c65633d }, { 0x3d32baa9, 0xbd39bc7f }, { 0x3d7e647f, 0x3e0517e8 },
    { 0xbb6eea32, 0x3cf8d27f }, { 0xbd36fff8, 0x3caa77f3 }, { 0xbc24eeb9, 0xbce333ff },
    { 0x3c9de148, 0x3d49dac6 }, { 0x3e806f93, 0x3eb38010 }, { 0x3e392a3d, 0x3f223d84 },
    { 0xbe396674, 0x3d396c0d }, { 0x3f19caf0, 0x3d29c2fe }, { 0x3e3d4f69, 0xbded3f24 },
    { 0xbe07a8e0, 0x3dbe89ed }, { 0xbe316a47, 0xbe87b160 }, { 0xbe30b385, 0x3cf8c2bd },
    { 0x3e2ba056, 0xbde35ccb }, { 0x3d34287e, 0xbba8a68b }, { 0xbd8c601b, 0x3d21d8ea },
    { 0xbd760eab, 0xbe10833d }, { 0x3d41db25, 0x3b155ac4 }, { 0xbd3c079f, 0x3b584ea5 },
    { 0xbcd5699e, 0xbcf223b8 }, { 0x3d97aa7a, 0x3d302321 }, { 0x3c50484a, 0x3f14d8dc },
    { 0xbd48467f, 0xbf501a63 }, { 0xbe2dc341, 0x3dcbc853 }, { 0x3ed1bdd0, 0x3db42bca },
    { 0xbe40c19c, 0x3dc70b35 }, { 0x3dfe4837, 0xbd97e013 }, { 0xbe0538d9, 0xbe4bfaf4 },
    { 0xbdc2e96f, 0x3d75d52a }, { 0xbd29a16c, 0xbe60bc5c }, { 0x3b8811ee, 0x3c5b699b },
    { 0x3d5a4d29, 0xbd1035b6 }, { 0x3d601170, 0x3e0429da }, { 0xba196bd2, 0x3ca3c232 },
    { 0xbcf64d26, 0x3cb1f28c }, { 0xbc9ab27a, 0xbd06ea28 }, { 0x3cc70e09, 0x3d487829 },
    { 0x3e87b3f1, 0x3e94cb10 }, { 0x3e374d5d, 0x3f1340a3 }, { 0xbe2f4e01, 0x3d6abb6e },
    { 0x3f179ac4, 0x3d2566a1 }, { 0x3e46d745, 0xbdd97082 }, { 0xbe0add6c, 0x3de570a9 },
    { 0xbe283107, 0xbe7e55e7 }, { 0xbe334c1f, 0x3c934cec }, { 0x3e3db6c3, 0xbdaa43f2 },
    { 0x3d5dce5a, 0xba80aef6 }, { 0xbda573c7, 0x3d0a1973 }, { 0xbd55f036, 0xbe0abb2d },
    { 0x3d578246, 0xbb9dadb0 }, { 0xbd2dfa21, 0x3bbfbbe0 }, { 0xbcb45fc6, 0xbd06274f },
    { 0x3d8fee73, 0x3d2a109f }, { 0x3c8cb57b, 0x3f07635f }, { 0xbd440406, 0xbf42fb99 },
    { 0xbe301ebf, 0x3dc0c539 }, { 0x3ecb7ff1, 0x3d985204 }, { 0xbe4071f0, 0x3dc96dc0 },
    { 0x3df99730, 0xbdac71a0 }, { 0xbdfca02f, 0xbe437fb8 }, { 0xbddc836e, 0x3d3b4950 },
    { 0xbd0e6287, 0xbe529bfb }, { 0xbaeca7cc, 0x3c42d9bb }, { 0x3d834441, 0xbccc2348 },
    { 0x3d367990, 0x3df9aa23 }, { 0x3b67b7ca, 0x3c22b2df }, { 0xbc8594d3, 0x3caa7a7a },
    { 0xbcca0588, 0xbd0b1a3e }, { 0x3cdc9203, 0x3d399d08 }, { 0x3e8bf48b, 0x3e74cb60 },
    { 0x3e36eb6a, 0x3f055191 }, { 0xbe245b01, 0x3d89d41c }, { 0x3f1470d9, 0x3d2160f4 },
    { 0x3e52fe39, 0xbdbfc9c5 }, { 0xbe0f1e54, 0x3e03eac9 }, { 0xbe1d55db, 0xbe6aca23 },
    { 0xbe3357d6, 0x3c063b54 }, { 0x3e493d4c, 0xbd6d90ad }, { 0x3d806db4, 0x3b58cfdc },
    { 0xbdbe1f1e, 0x3cf3f89a }, { 0xbd3cb7b9, 0xbe042850 }, { 0x3d61ada7, 0xbc3eba3c },
    { 0xbd27027e, 0x3c09d931 }, { 0xbc8347f5, 0xbd0e7229 }, { 0x3d82b37c, 0x3d1fd14f },
    { 0x3cb72947, 0x3ef3bd68 }, { 0xbd4fb3d4, 0xbf328c50 }, { 0xbe30f2b1, 0x3db75ad4 },
    { 0x3ec15891, 0x3d824994 }, { 0xbe3f596b, 0x3db7f8b8 }, { 0x3dfa3fd3, 0xbdb939dc },
    { 0xbdec366f, 0xbe34e695 }, { 0xbdf392b4, 0x3d0de692 }, { 0xbce3e840, 0xbe41da68 },
    { 0xbbf47df8, 0x3c1cdd47 }, { 0x3d9a0a3c, 0xbc863e06 }, { 0x3d0b0af0, 0x3de4adaa },
    { 0x3c083c23, 0x3adb9216 }, { 0xbbc4b1e2, 0x3c9bba00 }, { 0xbce5e495, 0xbd00da81 },
    { 0x3cd95e3c, 0x3d23ab73 }, { 0x3e892438, 0x3e49ab53 }, { 0x3e34a98c, 0x3ef1345a },
    { 0xbe183111, 0x3d9b97e5 }, { 0x3f0f7009, 0x3d1369b0 }, { 0x3e5e90a1, 0xbda47ea9 },
    { 0xbe142ac8, 0x3e13e555 }, { 0xbe124c1e, 0xbe587cf9 }, { 0xbe2e8b1f, 0x39ca77e0 },
    { 0x3e49f77a, 0xbd1a689c }, { 0x3d8c9d95, 0x3c057f86 }, { 0xbdd4cc8a, 0x3cdb1561 },
    { 0xbd2bc33f, 0xbdf9830b }, { 0x3d5b69a2, 0xbc9e3880 }, { 0xbd243a43, 0x3c416033 },
    { 0xbbf2beee, 0xbd162fd2 }, { 0x3d612ad2, 0x3d13d762 }, { 0x3cfc6097, 0x3edc7f37 },
    { 0xbd6781e6, 0xbf2163bb }, { 0xbe3556bb, 0x3db03b21 }, { 0x3eb4c56a, 0x3d6d9d30 },
    { 0xbe3d8162, 0x3d968bb5 }, { 0x3e006e3b, 0xbdc00e00 }, { 0xbddc3dc0, 0xbe217e0f },
    { 0xbe034961, 0x3ce54d07 }, { 0xbc9e1930, 0xbe2fe4bd }, { 0xbc458e03, 0x3bed2234 },
    { 0x3daed374, 0xbc29b73c }, { 0x3cca54e6, 0x3dca7524 }, { 0x3c53f8c9, 0xbb9eb828 },
    { 0xb90230d4, 0x3c8668ec }, { 0xbcf3c7d6, 0xbcddec78 }, { 0x3cbedcdf, 0x3d0934d9 },
    { 0x3e8bbd96, 0x3e2815bf }, { 0x3e37e87d, 0x3edc9f05 }, { 0xbe145bc3, 0x3dadc806 },
    { 0x3f0e4757, 0x3d1fd531 }, { 0x3e6f0932, 0xbd81e688 }, { 0xbe1d70c7, 0x3e252996 },
    { 0xbe0feff9, 0xbe489cf0 }, { 0xbe2e242a, 0xbbf0e514 }, { 0x3e51189b, 0xbc9ca4a1 },
    { 0x3d98d86a, 0x3c56bcc5 }, { 0xbdecd9f6, 0x3ccc7dfa }, { 0xbd2656a0, 0xbdebca7b },
    { 0x3d55ccaf, 0xbce38101 }, { 0xbd2f09b3, 0x3c69447a }, { 0xba783b48, 0xbd20bf9c },
    { 0x3d421c21, 0x3d06070f }, { 0x3d08dec6, 0x3ecba90a }, { 0xbd7f73f4, 0xbf13590b },
    { 0xbe3a2537, 0x3dac1fed }, { 0x3ea8c2b9, 0x3d568ac9 }, { 0xbe3c1893, 0x3d672792 },
    { 0x3e07124f, 0xbdc22f01 }, { 0xbdc8df03, 0xbe0f5aec }, { 0xbe0b4c33, 0x3cd0f37a },
    { 0xbc87a72c, 0xbe237abb }, { 0xbc6fdee8, 0x3b9aae7b }, { 0x3dc2339e, 0xbbf97201 },
    { 0x3c97e416, 0x3dae2c51 }, { 0x3c876c73, 0xbc258fc4 }, { 0x3b373759, 0x3c71551d },
    { 0xbce5c63f, 0xbcb202c7 }, { 0x3c96ac02, 0x3ce2f714 }, { 0x3e951f3b, 0x3e0e944d },
    { 0x3e444212, 0x3ecc9a9f }, { 0xbe17c77a, 0x3dc40b79 }, { 0x3f10ec78, 0x3d419fa4 },
    { 0x3e83b65f, 0xbd358322 }, { 0xbe2b4f1a, 0x3e36ca4e }, { 0xbe153f56, 0xbe3ca54c },
    { 0xbe339641, 0xbc6dc32c }, { 0x3e5c1e8d, 0xbb030375 }, { 0x3da73aa3, 0x3c98cb30 },
    { 0xbe03943c, 0x3cc378b1 }, { 0xbd2a9ba9, 0xbde04859 }, { 0x3d554ab1, 0xbd181010 },
    { 0xbd4590fc, 0x3c87b50c }, { 0x3b813d37, 0xbd2e35c4 }, { 0x3d2295bf, 0x3cf08470 },
    { 0x3d064ca0, 0x3ec25793 }, { 0xbd8f1be6, 0xbf095bb9 }, { 0xbe4054e2, 0x3da8394a },
    { 0x3e9fd9da, 0x3d470b39 }, { 0xbe3d3c88, 0x3d239826 }, { 0x3e10a22c, 0xbdbb4021 },
    { 0xbdb9e620, 0xbe001033 }, { 0xbe124f54, 0x3cd84e8b }, { 0xbc91ff6b, 0xbe1ccb85 },
    { 0xbc807acf, 0x3b1ec508 }, { 0x3dd4ea0d, 0xbbe4696f }, { 0x3c786a58, 0x3d940272 },
    { 0x3c9de24a, 0xbc648431 }, { 0x3b657204, 0x3c6406d7 }, { 0xbcc4f1dd, 0xbc80233e },
    { 0x3c52728b, 0x3cbb2924 }, { 0x3e9e04cd, 0x3df19ecf }, { 0x3e55cade, 0x3ebdcd35 },
    { 0xbe192d31, 0x3de18409 }, { 0x3f13d012, 0x3d6d2f30 }, { 0x3e9262f5, 0xbcc7b513 },
    { 0xbe3a996c, 0x3e47507d }, { 0xbe1c1986, 0xbe345529 }, { 0xbe396f48, 0xbca3ad60 },
    { 0x3e5ffdb5, 0x3c66642c }, { 0x3db2f919, 0x3ccf4a0e }, { 0xbe0ff711, 0x3cbecc1e },
    { 0xbd338186, 0xbdd3d2a7 }, { 0x3d50f504, 0xbd41d0a5 }, { 0xbd5e589c, 0x3ca4ae79 },
    { 0x3c292205, 0xbd3beca6 }, { 0x3cefd0a0, 0x3cd23e22 }, { 0x3d13b916, 0x3ebd4700 },
    { 0xbda74653, 0xbf0126c0 }, { 0xbe4c7930, 0x3d9aadec }, { 0x3e997087, 0x3d46f7a5 },
    { 0xbe41103b, 0x3cb79713 }, { 0x3e1c8317, 0xbda869ed }, { 0xbdb6b304, 0xbdde66f2 },
    { 0xbe1a0ab0, 0x3ceaa873 }, { 0xbc95261c, 0xbe1734f8 }, { 0xbc86f35a, 0x3a1d12b8 },
    { 0x3de538e2, 0xbbe0888e }, { 0x3c4bbb26, 0x3d703c20 }, { 0x3cae2902, 0xbc85e667 },
    { 0x3b3bf408, 0x3c4fdafd }, { 0xbca2e368, 0xbc0b4728 }, { 0x3bf7cb86, 0x3c97ddc6 },
    { 0x3ea9ac1e, 0x3dcc65f0 }, { 0x3e7011fb, 0x3eb0a3ab }, { 0xbe1e1e92, 0x3e072524 },
    { 0x3f1a19df, 0x3d97c8bc }, { 0x3ea5e941, 0xbb463220 }, { 0xbe4de51c, 0x3e5974ca },
    { 0xbe283281, 0xbe3057fa }, { 0xbe441602, 0xbcc7ae87 }, { 0x3e6146f3, 0x3cfb0675 },
    { 0x3dbdf0e9, 0x3d083733 }, { 0xbe1cd178, 0x3cc18b36 }, { 0xbd42c3b6, 0xbdc64c9d },
    { 0x3d4e4fdc, 0xbd72dac1 }, { 0xbd7c489f, 0x3cc6564c }, { 0x3c8da9dc, 0xbd4e6e36 },
    { 0x3c844388, 0x3cb20b09 }, { 0x3d228f4c, 0x3ebe86de }, { 0xbdc3d784, 0xbef752e6 },
    { 0xbe5d9035, 0x3d7c5356 }, { 0x3e944790, 0x3d4e1424 }, { 0xbe46625f, 0x3bbb12ce },
    { 0x3e2aa6b6, 0xbd87afdb }, { 0xbdbe7d17, 0xbdb7603c }, { 0xbe24a6e8, 0x3d07e3bd },
    { 0xbca3a42d, 0xbe14fe85 }, { 0xbc869f89, 0xb9dd31b0 }, { 0x3df2f8a2, 0xbc093af9 },
    { 0x3c2d4f6d, 0x3d2c87ba }, { 0x3cb52f8c, 0xbc9729a7 }, { 0x3a5cb5d8, 0x3c3a27b2 },
    { 0xbc7684f5, 0x3a47b56c }, { 0x3b34696a, 0x3c7470b3 }, { 0x3eb685f3, 0x3dadc107 },
    { 0x3e89120e, 0x3ea50da2 }, { 0xbe255863, 0x3e2a3575 }, { 0x3f24aa95, 0x3dcbd12c },
    { 0x3ebf3fee, 0x3cab363a }, { 0xbe640beb, 0x3e6fdb5c }, { 0xbe3b2123, 0xbe302327 },
    { 0xbe53166d, 0xbcdbbca4 }, { 0x3e5ed130, 0x3d49f56c }, { 0x3dc70220, 0x3d30c68c },
    { 0xbe29ecd8, 0x3ccd219c }, { 0xbd5b7f33, 0xbdb7d39c }, { 0x3d464acf, 0xbd97832c },
    { 0xbd918f76, 0x3cef2aab }, { 0x3cd6479a, 0xbd663221 }, { 0xba3287c6, 0x3c8cce79 },
    { 0x3d39ae4a, 0x3ec87fb8 }, { 0xbde408d2, 0xbef36b10 }, { 0xbe700677, 0x3d1265f3 },
    { 0x3e92113f, 0x3d50d098 }, { 0xbe4dfe36, 0xbc09e796 }, { 0x3e3a2eca, 0xbd2dfea4 },
    { 0xbdce0f06, 0xbd8793fb }, { 0xbe317ae4, 0x3d230ed6 }, { 0xbcbe74b5, 0xbe16a56d },
    { 0xbc82fc04, 0xbacb3174 }, { 0x3dfed0ab, 0xbc414621 }, { 0x3c25a6ee, 0x3cbafaf8 },
    { 0x3cc69976, 0xbcaccdb6 }, { 0xbb4f0203, 0x3c19e0e2 }, { 0xbc2cbcdf, 0x3c4b2c52 },
    { 0xba9d5125, 0x3c40be02 }, { 0x3ec606b3, 0x3d928d55 }, { 0x3e9f7b36, 0x3e9960cd },
    { 0xbe2fb00d, 0x3e599985 }, { 0x3f34cb37, 0x3e0df026 }, { 0x3ee0df25, 0x3d492bb7 },
    { 0xbe7bd64b, 0x3e876ec1 }, { 0xbe55d774, 0xbe2e4964 }, { 0xbe6625b8, 0xbcd95ebb },
    { 0x3e57518d, 0x3d9502ab }, { 0x3dccd336, 0x3d65176d }, { 0xbe378b34, 0x3cdfe04a },
    { 0xbd80fce8, 0xbda88023 }, { 0x3d3669d2, 0xbdc08903 }, { 0xbdab9cb7, 0x3d0e506c },
    { 0x3d17ef5c, 0xbd81886e }, { 0xbcbb0bb8, 0x3c3d8245 }, { 0x3d4da9e3, 0x3edaa3d2 },
    { 0xbe0535aa, 0xbef8b69b }, { 0xbe814931, 0x3c00ae97 }, { 0x3e957bda, 0x3d4a129e },
    { 0xbe5ceefa, 0xbc94dd95 }, { 0x3e4bd936, 0xbc96f28d }, { 0xbde3d5f8, 0xbd56d24d },
    { 0xbe42835f, 0x3d40d2a7 }, { 0xbcf3ae39, 0xbe1e4e83 }, { 0xbc721503, 0xbb7f329c },
    { 0x3e065bb0, 0xbc936f37 }, { 0x3c48a313, 0x3b6a5c6f }, { 0x3ce4c220, 0xbc97ddf2 },
    { 0xbc1bce09, 0x3be25c4e }, { 0xbba1f677, 0x3cdd636f }, { 0xbb98a69c, 0x3c065493 },
    { 0x3ed82486, 0x3d621566 }, { 0x3ebb1178, 0x3e890613 }, { 0xbe386aaa, 0x3e896e21 },
    { 0x3f4950d6, 0x3e46b17c }, { 0x3f04b7cf, 0x3daec6ce }, { 0xbe88ab3f, 0x3e99b039 },
    { 0xbe78b8f3, 0xbe23f26a }, { 0xbe76e4fc, 0xbcb9e60d }, { 0x3e45a79c, 0x3dd5b2e9 },
    { 0x3dcb1e95, 0x3d946975 }, { 0xbe42fa29, 0x3cf46b32 }, { 0xbd9c2f6b, 0xbd941644 },
    { 0x3d196a5d, 0xbdf5a2b7 }, { 0xbdcd8f8f, 0x3d22ef63 }, { 0x3d4d4a6b, 0xbd904ebc },
    { 0xbd50a8af, 0x3b20e1bf }, { 0x3d5ba145, 0x3ef6c06d }, { 0xbe2019c6, 0xbf06a6dd },
    { 0xbe8cce84, 0xbc96ce01 }, { 0x3ea1bc30, 0x3d43850d }, { 0xbe7844cf, 0xbcbf3ad2 },
    { 0x3e621a1b, 0x3c1004cb }, { 0xbdff0927, 0xbd4ce2c2 }, { 0xbe5cc2fc, 0x3d62a859 },
    { 0xbd287da4, 0xbe2ade29 }, { 0xbc4a8a5a, 0xbbe06d67 }, { 0x3e113902, 0xbcec6e88 },
    { 0x3c92b0d6, 0xbc48e237 }, { 0x3d0472dd, 0xbc0506ae }, { 0xbc957719, 0x3b676cbf },
    { 0x3b8b7711, 0x3d411140 }, { 0xbc0be019, 0x3c063fe3 }, { 0x3ee7dd15, 0x3cd89047 },
    { 0x3ed79cb4, 0x3e5bdb46 }, { 0xbe341012, 0x3ea738a0 }, { 0x3f5bea6a, 0x3e873efd },
    { 0x3f17ebe1, 0x3e05c825 }, { 0xbe8db432, 0x3ea8ea10 }, { 0xbe8e12b2, 0xbe07db8d },
    { 0xbe7864ef, 0xbc6c05ae }, { 0x3e232490, 0x3e169fb2 }, { 0x3dbabe81, 0x3dbe82f3 },
    { 0xbe45f0ec, 0x3d035b90 }, { 0xbdbbcbed, 0xbd64a1d3 }, { 0x3ccb521b, 0xbe17d2b5 },
    { 0xbdeffa68, 0x3d2e80a8 }, { 0x3d842c54, 0xbd99dc78 }, { 0xbda69992, 0xbc42b950 },
    { 0x3d684b14, 0x3f119dd2 }, { 0xbe48c049, 0xbf1aec47 }, { 0xbe99bb57, 0xbd380eec },
    { 0x3ebc807f, 0x3d4d09fb }, { 0xbe922f83, 0xbcaf6647 }, { 0x3e7dd76c, 0x3d530a26 },
    { 0xbe128fb8, 0xbd7ca25b }, { 0xbe80a5d0, 0x3d8bb622 }, { 0xbd7edac4, 0xbe3becab },
    { 0xbc0006d8, 0xbc4cc394 }, { 0x3e2332cd, 0xbd3ba33c }, { 0x3cded5f5, 0xbcb16486 },
    { 0x3d0f8dfd, 0x3c45197d }, { 0xbd065e2e, 0xbb7235c8 }, { 0x3ca913ef, 0x3d9d2f73 },
    { 0xbc5d69ee, 0x3c81e2fc }, { 0x3ee9782d, 0xbc88be32 }, { 0x3ee9c018, 0x3e0dc2d1 },
    { 0xbe16c0e5, 0x3ebbe9e1 }, { 0x3f5f9ddd, 0x3ea8e90b }, { 0x3f1fd6c3, 0x3e32ccec },
    { 0xbe85e507, 0x3eaaf0e1 }, { 0xbe95db31, 0xbda86c2a }, { 0xbe5b8366, 0xbb31bed4 },
    { 0x3dd99f0a, 0x3e46ba22 }, { 0x3d9484eb, 0x3de57170 }, { 0xbe372abb, 0x3d06af08 },
    { 0xbdd2693b, 0xbd01952c }, { 0x3bce6f0f, 0xbe2c2db9 }, { 0xbdfd5fa0, 0x3d27ffc0 },
    { 0x3d9c1e35, 0xbd955ea4 }, { 0xbdd47c9f, 0xbceae656 }, { 0x3d77f0cd, 0x3f27abc4 },
    { 0xbe775fb7, 0xbf2e5b86 }, { 0xbe9731df, 0xbd9010c6 }, { 0x3edb6899, 0x3d657f66 },
    { 0xbea68bec, 0xbc012704 }, { 0x3e84786a, 0x3ddee4de }, { 0xbe1ea8ed, 0xbdbb9f52 },
    { 0xbe8c43ee, 0x3dab1a4e }, { 0xbdb5b5f7, 0xbe43a5f9 }, { 0x3a91b280, 0xbcbcd065 },
    { 0x3e2fe474, 0xbd8489d3 }, { 0x3d1b709f, 0xbc87b499 }, { 0x3cf7cc23, 0x3d2d0c8d },
    { 0xbd5b9657, 0xbc95be3a }, { 0x3d313655, 0x3de4a353 }, { 0xbc8db612, 0x3d029b95 },
    { 0x3edd2c96, 0xbd67065d }, { 0x3ee9e3b6, 0x3d83437d }, { 0xbdd34d7e, 0x3ebcaf07 },
    { 0x3f4fdbf2, 0x3eb9da10 }, { 0x3f1718c7, 0x3e4c2f9c }, { 0xbe622d79, 0x3e9abae8 },
    { 0xbe8eb4d6, 0xbcb01c7f }, { 0xbe25e99e, 0x3c27ea14 }, { 0x3d4c6970, 0x3e69e918 },
    { 0x3d43f14f, 0x3df65041 }, { 0xbe174247, 0x3cfe7164 }, { 0xbdd221ab, 0xbc0c638e },
    { 0xbc3c7b04, 0xbe2d26e6 }, { 0xbdead21d, 0x3d1043e6 }, { 0x3da3a40a, 0xbd800267 },
    { 0xbdde8362, 0xbd22f376 }, { 0x3d80ea8b, 0x3f25081a }, { 0xbe81d30c, 0xbf289db1 },
    { 0xbe63bc75, 0xbda50de0 }, { 0x3edd397b, 0x3d6877ba }, { 0xbea058a8, 0x3c75d082 },
    { 0x3e603f6f, 0x3e13aa80 }, { 0xbe08a9ab, 0xbe0342b8 }, { 0xbe7ad645, 0x3db1f07b },
    { 0xbdcbb50d, 0xbe31235a }, { 0x3c51d6cb, 0xbd0682fe }, { 0x3e1ba66f, 0xbd920d0d },
    { 0x3d29f2f4, 0x3bd2aa28 }, { 0x3c8a59be, 0x3d841a2c }, { 0xbd860b4a, 0xbd0bb3bb },
    { 0x3d6a4066, 0x3dfe9227 }, { 0xbc702be4, 0x3d436c1e }, { 0x3ecdf28e, 0xbd9fbe62 },
    { 0x3eddeb36, 0x3c85e29f }, { 0xbd81e35b, 0x3ead1ae2 }, { 0x3f387033, 0x3eb8c897 },
    { 0x3f061ea2, 0x3e4e82f4 }, { 0xbe339135, 0x3e828b97 }, { 0xbe7d82d2, 0x3cf30181 },
    { 0xbde26e4e, 0x3c9a43d0 }, { 0x3c218c64, 0x3e7b7a35 }, { 0x3cd89e11, 0x3df0fa1d },
    { 0xbde99aa8, 0x3cd8ef4e }, { 0xbdbd0be1, 0x3ba4d36f }, { 0xbcb27a9f, 0xbe1fabcd },
    { 0xbdc6b2d7, 0x3cef9d69 }, { 0x3d9c8ffc, 0xbd492531 }, { 0xbdcbd296, 0xbd298617 },
    { 0x3d86dc72, 0x3f10b0b8 }, { 0xbe6dfe22, 0xbf141fc5 }, { 0xbe0c8e2e, 0xbd858c82 },
    { 0x3ec785e3, 0x3d4e68fd }, { 0xbe894b19, 0x3d045df7 }, { 0x3e252005, 0x3e09c27b },
    { 0xbdc53064, 0xbe253025 }, { 0xbe453139, 0x3da4a63b }, { 0xbdb3bbf5, 0xbe1b94a4 },
    { 0x3ca3a5ae, 0xbd106631 }, { 0x3de9a318, 0xbd84f77d }, { 0x3d184622, 0x3cf1a04e },
    { 0x3beb3106, 0x3d87242a }, { 0xbd7bdee5, 0xbd378444 }, { 0x3d5cca21, 0x3de0c873 },
    { 0xbc07fbab, 0x3d5db67b }, { 0x3ec13933, 0xbdb46f17 }, { 0x3ecfbeed, 0xbc332e3d },
    { 0xbd1e3c43, 0x3e95e963 }, { 0x3f2505e5, 0x3eadedf1 }, { 0x3eeced2c, 0x3e434555 },
    { 0xbe12152f, 0x3e57fd66 }, { 0xbe581ab9, 0x3d7c904a }, { 0xbda28237, 0x3c7027d0 },
    { 0xbc1336c6, 0x3e805110 }, { 0x3c544c72, 0x3de10ed4 }, { 0xbdb6086d, 0x3ca16063 },
    { 0xbda01271, 0x3c1a75a9 }, { 0xbcb72338, 0xbe0c9b6f }, { 0xbd9fb2a5, 0x3cc099c9 },
    { 0x3d8a5ccd, 0xbd1db7cf }, { 0xbdae78e3, 0xbd12cd8b }, { 0x3d91fb26, 0x3f00dd9f },
    { 0xbe581f38, 0xbf05ce9f }, { 0xbdb62362, 0xbd2a78e5 }, { 0x3eb3bea9, 0x3d4a736d },
    { 0xbe6efa92, 0x3d0c437e }, { 0x3dfaf478, 0x3dd7b938 }, { 0xbd97ef17, 0xbe3d80e1 },
    { 0xbe21378f, 0x3da0ca0e }, { 0xbd8fde47, 0xbe134776 }, { 0x3cb2a72d, 0xbd09be14 },
    { 0x3dadb8cc, 0xbd730b74 }, { 0x3d0b07f7, 0x3d365a76 }, { 0x3ba2c40d, 0x3d6b6e5a },
    { 0xbd6585a8, 0xbd48d4d8 }, { 0x3d324e13, 0x3db9eb81 }, { 0xbb782515, 0x3d54f03d },
    { 0x3ebbee79, 0xbdc8c7fa }, { 0x3ec4c5ac, 0xbd0105cf }, { 0xbd1453d7, 0x3e7cf29e },
    { 0x3f1a552e, 0x3ea10b4d }, { 0x3ed89d9c, 0x3e347b74 }, { 0xbe05bfcc, 0x3e31db2c },
    { 0xbe346915, 0x3d9e02b6 }, { 0xbd98077a, 0xbb8e7444 }, { 0xbc22dc54, 0x3e828b4d },
    { 0x3bbec8ee, 0x3dd24373 }, { 0xbd9ba844, 0x3c35ce74 }, { 0xbd835c31, 0x3c17931b },
    { 0xbc63b229, 0xbdf33129 }, { 0xbd78ab82, 0x3c93524d }, { 0x3d6075d4, 0xbd0c6682 },
    { 0xbd928f22, 0xbcdf36d6 }, { 0x3da0863b, 0x3ef505c8 }, { 0xbe4cfec1, 0xbf005a5a },
    { 0xbd938800, 0xbce465ee }, { 0x3ea82b06, 0x3d581c9d }, { 0xbe5bfad8, 0x3ce9891d },
    { 0x3dd56d11, 0x3dac80b2 }, { 0xbd890648, 0xbe479681 }, { 0xbe15e566, 0x3db2a9a4 },
    { 0xbd683b84, 0xbe15e89a }, { 0x3cb3ed65, 0xbcff0fc6 }, { 0x3d8eee58, 0xbd6e2a99 },
    { 0x3d0195cd, 0x3d55bdc6 }, { 0x3bde0682, 0x3d42d654 }, { 0xbd5a2d4a, 0xbd40962a },
    { 0x3d0a423e, 0x3da38c64 }, { 0xbab6d201, 0x3d418dc3 }, { 0x3ec006e4, 0xbdddaa28 },
    { 0x3ebd55c0, 0xbd3db887 }, { 0xbd7ca544, 0x3e51cc92 }, { 0x3f1864ad, 0x3e9557c6 },
    { 0x3ecebbb9, 0x3e26c25c }, { 0xbe0c06b0, 0x3e0fdfeb }, { 0xbe169e4d, 0x3dae4ddc },
    { 0xbdc09265, 0xbd0acd45 }, { 0x3b8478e6, 0x3e87d7bc }, { 0x3ad1694f, 0x3dc923f1 },
    { 0xbd94ab16, 0x3b3211d1 }, { 0xbd5591ea, 0x3c1017f2 }, { 0x3af82bb2, 0xbdce963e },
    { 0xbd36c694, 0x3c6b8b50 }, { 0x3d176a76, 0xbd130cc2 }, { 0xbd73424f, 0xbc959c0d },
    { 0x3db4fc0d, 0x3ef3a021 }, { 0xbe4d436f, 0xbf0082ed }, { 0xbd97605a, 0xbcc89638 },
    { 0x3ea26a68, 0x3d649037 }, { 0xbe55fb6a, 0x3cabefb1 }, { 0x3dcd5cd0, 0x3da047cd },
    { 0xbd896d36, 0xbe4a10ab }, { 0xbe1ce2cf, 0x3dd6c2b0 }, { 0xbd49dc8d, 0xbe20bbff },
    { 0x3caf702a, 0xbcedddf3 }, { 0x3d872c12, 0xbd75cc66 }, { 0x3ceb3aab, 0x3d5e76be },
    { 0x3c28203d, 0x3d27c16e }, { 0xbd510298, 0xbd2e0fb9 }, { 0x3cd8478b, 0x3d9e7997 },
    { 0xba328874, 0x3d2cc027 }, { 0x3ecbf8ec, 0xbdf0ecd6 }, { 0x3eb900dc, 0xbd58ea9d },
    { 0xbdf71df3, 0x3e3539dd }, { 0x3f1f25df, 0x3e8c59bb }, { 0x3ecdf2ce, 0x3e1dd0e4 },
    { 0xbe224596, 0x3de89554 }, { 0xbe029906, 0x3dbfa785 }, { 0xbe0d4e01, 0xbd88c784 },
    { 0x3ce4e5b9, 0x3e905c88 }, { 0xbb254b23, 0x3dc7cec8 }, { 0xbd98af64, 0xbb35b1f4 },
    { 0xbd38a240, 0x3c46277e }, { 0x3cb7cb27, 0xbda97cfc }, { 0xbce8058e, 0x3c604fa0 },
    { 0x3c68aba8, 0xbd28bc51 }, { 0xbd4fcc43, 0xbc4665b0 }, { 0x3dcb56dd, 0x3ef817bd },
    { 0xbe589247, 0xbf03bf19 }, { 0xbdb59e59, 0xbd060bcc }, { 0x3ea0547a, 0x3d686dc5 },
    { 0xbe5b7cf4, 0x3c612562 }, { 0x3ddd5544, 0x3db2504a }, { 0xbd9359b2, 0xbe483cdf },
    { 0xbe2d4900, 0x3e01d38e }, { 0xbd454007, 0xbe30854c }, { 0x3ca42d6c, 0xbce45c95 },
    { 0x3d9048d1, 0xbd8078ee }, { 0x3cd00595, 0x3d5a0127 }, { 0x3c695662, 0x3d1fb8ee },
    { 0xbd47414d, 0xbd176465 }, { 0x3cae8089, 0x3da698b7 }, { 0xbaaed486, 0x3d19a678 },
    { 0x3edde9aa, 0xbe02bd35 }, { 0x3ebb482c, 0xbd6429a8 }, { 0xbe5495ca, 0x3e2c0ecd },
    { 0x3f2e0724, 0x3e87bbb9 }, { 0x3ed95d17, 0x3e1ad8ee }, { 0xbe4d7e58, 0x3db8dadf },
    { 0xbdf655b9, 0x3dd72a39 }, { 0xbe477663, 0xbdc55c56 }, { 0x3d5893af, 0x3e9db151 },
    { 0xbb56b7ba, 0x3dd10c7f }, { 0xbdab39ae, 0xbb9eb5db }, { 0xbd290a99, 0x3ca6ba0b },
    { 0x3d40332b, 0xbd815276 }, { 0xbc6e0378, 0x3c7f8d9c }, { 0xbc1c0c8a, 0xbd42412e },
    { 0xbd47c471, 0xbc341178 }, { 0x3de52892, 0x3f00a803 }, { 0xbe6e64a6, 0xbf091543 },
    { 0xbdeedbf8, 0xbd5d00c8 }, { 0x3ea3503d, 0x3d54180f }, { 0xbe6e45a7, 0x3c4625a9 },
    { 0x3e0402bf, 0x3de449eb }, { 0xbda3335a, 0xbe437636 }, { 0xbe43ce1e, 0x3e143ed3 },
    { 0xbd58e9e5, 0xbe434398 }, { 0x3c908f8b, 0xbce18d0c }, { 0x3da648b8, 0xbd8062f9 },
    { 0x3cac1946, 0x3d4fefbe }, { 0x3c9fe7fc, 0x3d28370a }, { 0xbd3c0e38, 0xbcf58d62 },
    { 0x3c8eb655, 0x3db8e46e }, { 0xbb5b3568, 0x3d0e41b3 }, { 0x3eebe919, 0xbe0830e4 },
    { 0x3ec0a0ea, 0xbd6e7e7a }, { 0xbe9ce474, 0x3e2f635c }, { 0x3f3f7330, 0x3e85b722 },
    { 0x3eeb9d62, 0x3e184e27 }, { 0xbe86c077, 0x3d83067c }, { 0xbdefeac1, 0x3e0091dd },
    { 0xbe7a9f0b, 0xbdeb4efa }, { 0x3da1bf25, 0x3ead194a }, { 0x3b9feec9, 0x3ddf836a },
    { 0xbdd72da8, 0xbc012230 }, { 0xbd13b9ac, 0x3cf079c7 }, { 0x3da13207, 0xbd0eea05 },
    { 0xbc03881b, 0x3c9da413 }, { 0xbd02d6ca, 0xbd504b76 }, { 0xbd454a63, 0xbc6d43b9 },
    { 0x3e02d9ec, 0x3f0572ff }, { 0xbe837c1c, 0xbf0e3760 }, { 0xbe1dccd3, 0xbdac8ed9 },
    { 0x3ea9bb8a, 0x3d11f5da }, { 0xbe84b410, 0x3cad7380 }, { 0x3e23aa37, 0x3e144465 },
    { 0xbdb34116, 0xbe3d6cc3 }, { 0xbe58a3bf, 0x3e150e44 }, { 0xbd819d2c, 0xbe581506 },
    { 0x3c6727b4, 0xbccf5279 }, { 0x3dbff1b0, 0xbd5a6bfd }, { 0x3c81bae3, 0x3d492a2b },
    { 0x3cdf5005, 0x3d2b9017 }, { 0xbd2f8159, 0xbca65681 }, { 0x3c5723bd, 0x3dc87267 },
    { 0xbbf2a97c, 0x3d148e1a }, { 0x3ee495f8, 0xbe0fe638 }, { 0x3eb84180, 0xbd7c7395 },
    { 0xbec8f021, 0x3e243b66 }, { 0x3f45881e, 0x3e817b22 }, { 0x3ef013ca, 0x3e0e5ca4 },
    { 0xbea20385, 0x3d10c504 }, { 0xbdeaf485, 0x3e118d9c }, { 0xbe8a9598, 0xbde500fd },
    { 0x3ddf5dbf, 0x3eb43388 }, { 0x3c923f3f, 0x3de36c3f }, { 0xbe01d38c, 0xbc7cd843 },
    { 0xbce1af10, 0x3d09334f }, { 0x3ddac2eb, 0xbadb23a4 }, { 0xbc075151, 0x3cbca843 },
    { 0xbd31d193, 0xbd43ca34 }, { 0xbd2c47e5, 0xbc8fa16c }, { 0x3e0e7bd1, 0x3f0557a6 },
    { 0xbe85a791, 0xbf0e2e35 }, { 0xbe321235, 0xbdd29df9 }, { 0x3eaab069, 0x3c41d270 },
    { 0xbe8b31ea, 0x3d12df4c }, { 0x3e38100b, 0x3e25a809 }, { 0xbdb48514, 0xbe380277 },
    { 0xbe54c612, 0x3dfc440c }, { 0xbd9796df, 0xbe66aa50 }, { 0x3c3a97d6, 0xbc89dce4 },
    { 0x3dc4bff4, 0xbd0c1564 }, { 0x3c4edbb9, 0x3d4d6da6 }, { 0x3d0b0034, 0x3d036ed9 },
    { 0xbd289b61, 0xbc26a4be }, { 0x3c0f8f61, 0x3dbc906d }, { 0xbc563b05, 0x3d2542be },
    { 0x3ecb44df, 0xbe181659 }, { 0x3e9a737e, 0xbd8ee0c9 }, { 0xbedad149, 0x3e05ad2c },
    { 0x3f388d90, 0x3e72ff37 }, { 0x3eded6c6, 0x3dfd8ab4 }, { 0xbead08df, 0x3c86ddda },
    { 0xbde341d9, 0x3e116274 }, { 0xbe8bae48, 0xbdc5d286 }, { 0x3e0a8e8d, 0x3eb062f4 },
    { 0x3cd84517, 0x3dd9c45b }, { 0xbe06915b, 0xbcb124e4 }, { 0xbcac0024, 0x3d051cad },
    { 0x3deafda5, 0x3ca4fd99 }, { 0xbc90ed7b, 0x3cb750e6 }, { 0xbd134979, 0xbd0d56bd },
    { 0xbcebc048, 0xbc6bed52 }, { 0x3dfbf50d, 0x3f00746f }, { 0xbe6992d7, 0xbf0905fb },
    { 0xbe27e7e6, 0xbdbb2a5b }, { 0x3ea4f50d, 0xba87f8b4 }, { 0xbe848476, 0x3d3f007a },
    { 0x3e34ac4f, 0x3e158c36 }, { 0xbd9f3a4e, 0xbe356c52 }, { 0xbe2f0398, 0x3dd26c4d },
    { 0xbd9e5044, 0xbe6401de }, { 0x3c3798b6, 0xbc0ed956 }, { 0x3da8e1ab, 0xbca8bad0 },
    { 0x3c699aaf, 0x3d508230 }, { 0x3d0e9856, 0x3c432270 }, { 0xbd1fccf0, 0xbb9c9893 },
    { 0x3be647ef, 0x3d95b7eb }, { 0xbc8871c3, 0x3d3411d8 }, { 0x3eae77ed, 0xbe1c2dfb },
    { 0x3e7152ab, 0xbda93ed9 }, { 0xbed55df6, 0x3dd86b76 }, { 0x3f25161c, 0x3e64aa79 },
    { 0x3ec423e4, 0x3de07b5b }, { 0xbea771b8, 0x3c5685b8 }, { 0xbdd2eca9, 0x3e0951de },
    { 0xbe83d1cf, 0xbda51621 }, { 0x3e13a388, 0x3ea9c234 }, { 0x3cdc5d7a, 0x3dcb8e82 },
    { 0xbdfb0cc4, 0xbccb88e2 }, { 0xbc8d319e, 0x3cf97f44 }, { 0x3dda16b9, 0x3cd5eade },
    { 0xbd01221b, 0x3c909d4e }, { 0xbcb41b58, 0xbc9deffa }, { 0xbc79746d, 0xbc109809 },
    { 0x3dc0fd26, 0x3efc355d }, { 0xbe3edbf5, 0xbf061caa }, { 0xbe12efc2, 0xbd88b0e5 },
    { 0x3ea039f0, 0xba951fe0 }, { 0xbe73bedb, 0x3d6508c5 }, { 0x3e279fa9, 0x3df23631 },
    { 0xbd873c2c, 0xbe3638db }, { 0xbe049eaf, 0x3dc9d75c }, { 0xbd978199, 0xbe5ea935 },
    { 0x3c4d76bf, 0xbb97a2b9 }, { 0x3d84035a, 0xbc89d360 }, { 0x3c974c1a, 0x3d49ea07 },
    { 0x3d039d04, 0xbba2fbfa }, { 0xbd102790, 0xbb93d088 }, { 0x3c03c478, 0x3d6114dc },
    { 0xbc8c0f18, 0x3d489269 }, { 0x3e97fe27, 0xbe1d5cae }, { 0x3e417b98, 0xbdc76c7d },
    { 0xbec54640, 0x3dc619b7 }, { 0x3f1593fc, 0x3e61ad61 }, { 0x3eacb2a9, 0x3dd062bf },
    { 0xbe9994aa, 0x3c9c2dd0 }, { 0xbdc02217, 0x3e0133de }, { 0xbe72318b, 0xbd87cc13 },
    { 0x3e12df69, 0x3ea6e3d3 }, { 0x3cbc18cb, 0x3dc0874f }, { 0xbde16730, 0xbcd43bb0 },
    { 0xbc75ef3c, 0x3cf07896 }, { 0x3dbca6df, 0x3cb4ee25 }, { 0xbd339463, 0x3c4be7ae },
    { 0xbc2065e8, 0xbc011e32 }, { 0xbb88bc0d, 0xbb3b078c }, { 0x3d9479dc, 0x3f00bbab },
    { 0xbe220e33, 0xbf072757 }, { 0xbdfbfcaa, 0xbd329550 }, { 0x3e9e9c7f, 0x3bcc9c13 },
    { 0xbe644238, 0x3d827ee1 }, { 0x3e19d2e4, 0x3dbfcbbd }, { 0xbd753729, 0xbe3b0c4a },
    { 0xbdcb67d9, 0x3dd922cb }, { 0xbd8ac695, 0xbe5eb97f }, { 0x3c6323df, 0xbb4e135e },
    { 0x3d4beba4, 0xbc990dbe }, { 0x3cb95a58, 0x3d441540 }, { 0x3ced24dd, 0xbc5bb112 },
    { 0xbd0437ba, 0xbbce82e3 }, { 0x3c159664, 0x3d32cf46 }, { 0xbc81ae6b, 0x3d5ece97 },
    { 0x3e88359e, 0xbe1ec730 }, { 0x3e2138c2, 0xbde4c496 }, { 0xbeb160a8, 0x3dcd5483 },
    { 0x3f0b2f87, 0x3e6cd5b7 }, { 0x3e9b7ecd, 0x3dca830d }, { 0xbe8a33d0, 0x3cda2430 },
    { 0xbdb1326c, 0x3df7b010 }, { 0xbe5c9a18, 0xbd5c266e }, { 0x3e104e03, 0x3ea7bd10 },
    { 0x3ca236ec, 0x3dbd7485 }, { 0xbdc8c677, 0xbccd6e2b }, { 0xbc68cecb, 0x3cebb771 },
    { 0x3d9dbea1, 0x3c616286 }, { 0xbd58a7fb, 0x3c03df63 }, { 0xba3b5953, 0x3a3d3450 },
    { 0x3b9e87f2, 0x3b52621b }, { 0x3d73febf, 0x3f064ff1 }, { 0xbe1122e1, 0xbf0a36fe },
    { 0xbdd97553, 0xbcc68131 }, { 0x3e9ef4f5, 0x3c6c67d8 }, { 0xbe5d230f, 0x3d9264d8 },
    { 0x3e0e0d9c, 0x3d98788a }, { 0xbd710b5a, 0xbe456b9a }, { 0xbda4bee6, 0x3df0f788 },
    { 0xbd797a85, 0xbe62f0b6 }, { 0x3c6b8406, 0xbb7b1efb }, { 0x3d208884, 0xbcb7edcc },
    { 0x3cd81463, 0x3d4963eb }, { 0x3cd281d5, 0xbc73322f }, { 0xbd028c6f, 0xbc072416 },
    { 0x3c14340b, 0x3d19a998 }, { 0xbc5d3588, 0x3d74fa7d }, { 0x3e7b930f, 0xbe20c50f },
    { 0x3e09006f, 0xbdf7bb41 }, { 0xbe9d5b67, 0x3de0ed84 }, { 0x3f04653e, 0x3e825e11 },
    { 0x3e90222e, 0x3dcb1f75 }, { 0xbe75e300, 0x3d075488 }, { 0xbdaa0805, 0x3df1dffa },
    { 0xbe49bee0, 0xbd2f7fe1 }, { 0x3e11b4ba, 0x3eaafcf5 }, { 0x3ca36de9, 0x3dc368ef },
    { 0xbdb18251, 0xbcb2bc23 }, { 0xbc6c2556, 0x3ce6ec6f }, { 0x3d824009, 0x3b94b4d0 },
    { 0xbd74a5b7, 0x3b908af6 }, { 0x3badaba4, 0x3c10c9a2 }, { 0x3c4d7a57, 0x3c1fd78b },
    { 0x3d50f246, 0x3f0cc243 }, { 0xbe04fedf, 0xbf0e2db8 }, { 0xbdc23540, 0xbc17355d },
    { 0x3ea1b4da, 0x3c9f2eca }, { 0xbe5d239b, 0x3da8534b }, { 0x3e04f01f, 0x3d711312 },
    { 0xbd747d03, 0xbe55299a }, { 0xbd8ec848, 0x3e04ab6a }, { 0xbd5f4b25, 0xbe68fed3 },
    { 0x3c5eebb5, 0xbbe1b236 }, { 0x3d001ed1, 0xbcd9669c }, { 0x3cf05da9, 0x3d58e886 },
    { 0x3cb87116, 0xbc509744 }, { 0xbd064fad, 0xbc1da449 }, { 0x3c00ebca, 0x3d0ab115 },
    { 0xbc210f97, 0x3d87ef0a }, { 0x3e727497, 0xbe20777f }, { 0x3df34dfc, 0xbdfdbec1 },
    { 0xbe8cabb1, 0x3df44d44 }, { 0x3f005ae2, 0x3e913739 }, { 0x3e8bdd63, 0x3dd28d2f },
    { 0xbe5be75e, 0x3d1d831c }, { 0xbdad33ab, 0x3ded5704 }, { 0xbe3a1c56, 0xbd02460c },
    { 0x3e191a46, 0x3eb147cb }, { 0x3cc7db19, 0x3dd053c0 }, { 0xbd9e92dc, 0xbc8b756f },
    { 0xbc7ee5ae, 0x3ce045ee }, { 0x3d5a25e9, 0xbb449ef3 }, { 0xbd849a1c, 0x3aba8503 },
    { 0x3c116cee, 0x3c82929e }, { 0x3c8e6fbb, 0x3c804ed6 }, { 0x3d345099, 0x3f13d228 },
    { 0xbdf6c27c, 0xbf1331e4 }, { 0xbdb6b26b, 0x3b5516d8 }, { 0x3ea83ea9, 0x3cb06ea0 },
    { 0xbe64aa92, 0x3dc5ddc1 }, { 0x3dff3926, 0x3d3805f4 }, { 0xbd78e31b, 0xbe690f25 },
    { 0xbd84745e, 0x3e10263f }, { 0xbd432eea, 0xbe6fb46a }, { 0x3c3069e4, 0xbc4e11bf },
    { 0x3cd08011, 0xbcfa2f25 }, { 0x3d02e5ef, 0x3d71a644 }, { 0x3ca00d92, 0xbc211d9f },
    { 0xbd0d5b8e, 0xbc2b4d3c }, { 0x3bc96521, 0x3d015b78 }, { 0xbb9006da, 0x3d9acb53 },
    { 0x3e724549, 0xbe1e9bb8 }, { 0x3de9f0fc, 0xbdfa1e50 }, { 0xbe7f4e26, 0x3e023428 },
    { 0x3efce98d, 0x3e9f40af }, { 0x3e8f2180, 0x3ddd7d63 }, { 0xbe49328c, 0x3d328be7 },
    { 0xbdbb7feb, 0x3de8e8ca }, { 0xbe2bb289, 0xbcaab1f4 }, { 0x3e20f6f5, 0x3eb934be },
    { 0x3d067b94, 0x3de255ea }, { 0xbd9109c7, 0xbc380fb4 }, { 0xbc99d709, 0x3cd2e2ce },
    { 0x3d3b04c0, 0xbbff81d6 }, { 0xbd8c44ff, 0xbaa44016 }, { 0x3c48cbdb, 0x3cb49c6e },
    { 0x3c8a8796, 0x3ca4930d }, { 0x3d20561b, 0x3f1bf7f4 }, { 0xbdea7d97, 0xbf199fe1 },
    { 0xbdb34919, 0x3c737f90 }, { 0x3eb42886, 0x3cb89421 }, { 0xbe757690, 0x3de8e83a },
    { 0x3dfc7a4e, 0x3cf9b4a5 }, { 0xbd7cb56d, 0xbe80b956 }, { 0xbd81cb85, 0x3e1a3690 },
    { 0xbd1ab5ba, 0xbe75813e }, { 0x3b9bacf8, 0xbcb0f86b }, { 0x3cb18750, 0xbd0cc756 },
    { 0x3d0fc672, 0x3d8ba42a }, { 0x3c8ce91c, 0xbbfeeeb0 }, { 0xbd1ae773, 0xbc328355 },
    { 0x3b782bb9, 0x3cf04e05 }, { 0x3b57cff7, 0x3db484ec }, { 0x3e7760a7, 0xbe1fad16 },
    { 0x3dfc3a68, 0xbdfd1a66 }, { 0xbe6b37cd, 0x3e081ff5 }, { 0x3efb606c, 0x3ea708af },
    { 0x3e9828c6, 0x3de4d85e }, { 0xbe3cedba, 0x3d4a9efb }, { 0xbdd0b2cb, 0x3de19707 },
    { 0xbe1cc01b, 0xbc572acc }, { 0x3e207588, 0x3ebf6d9f }, { 0x3d2f1511, 0x3df598f1 },
    { 0xbd867918, 0xbbb423fc }, { 0xbcc32da2, 0x3cbbdc78 }, { 0x3d24a816, 0xbc235bc7 },
    { 0xbd8f75f5, 0xbb6eb982 }, { 0x3c86f24b, 0x3cd019e3 }, { 0x3c0e3d0d, 0x3cb612cc },
    { 0x3d1f93fe, 0x3f262ac4 }, { 0xbdeed431, 0xbf21f615 }, { 0xbdb240ee, 0x3cc19fae },
    { 0x3ec522cd, 0x3ccffa08 }, { 0xbe880701, 0x3e056eb2 }, { 0x3dfeda7b, 0x3c907d39 },
    { 0xbd82d59b, 0xbe8f41ba }, { 0xbd83cc5b, 0x3e237b1d }, { 0xbcc07ce3, 0xbe79b6f8 },
    { 0xbba2545f, 0xbd081fef }, { 0x3ca5402a, 0xbd1fcd60 }, { 0x3d20833b, 0x3da5fd51 },
    { 0x3c75e0f2, 0xbbd3b771 }, { 0xbd33da39, 0xbc33f9d3 }, { 0x3afd4899, 0x3ce4198e },
    { 0x3c4e49b1, 0x3dd2f355 }, { 0x3e7d2315, 0xbe25a151 }, { 0x3e12c889, 0xbe0a9893 },
    { 0xbe592daf, 0x3e09f2d8 }, { 0x3ef9d9df, 0x3ea45531 }, { 0x3ea1e324, 0x3de0ab90 },
    { 0xbe30ab7d, 0x3d5ee8ed }, { 0xbde446b1, 0x3dd3670f }, { 0xbe0d429a, 0xbc402970 },
    { 0x3e13a3a1, 0x3ec0db1c }, { 0x3d4b055f, 0x3e013130 }, { 0xbd744538, 0xbacc2eb8 },
    { 0xbcee5d0c, 0x3c9e7582 }, { 0x3d124845, 0xbc1efda9 }, { 0xbd8c0ebf, 0xbbaffd11 },
    { 0x3ca1f88e, 0x3cc9b5ea }, { 0xbbadb417, 0x3cbd1443 }, { 0x3d39af3c, 0x3f323d7d },
    { 0xbe06552b, 0xbf2bf2fd }, { 0xbdac407c, 0x3cd4a796 }, { 0x3ed716d7, 0x3d04f9df },
    { 0xbe97dd0c, 0x3e0f03b6 }, { 0x3dfe1a05, 0x3c395e20 }, { 0xbd8cc0f3, 0xbe9e1019 },
    { 0xbd84e4e8, 0x3e2bc189 }, { 0xbbfe3f28, 0xbe7dc002 }, { 0xbc898853, 0xbd360af7 },
    { 0x3ca86bb4, 0xbd3b0187 }, { 0x3d336ed7, 0x3dc51808 }, { 0x3c434058, 0xbbb454ad },
    { 0xbd59ee49, 0xbc2dc6ee }, { 0x3b40eedc, 0x3ce860a2 }, { 0x3ca3a9dd, 0x3dec09ed },
    { 0x3e80dbcd, 0xbe2e3859 }, { 0x3e2a937e, 0xbe2082e8 }, { 0xbe45753b, 0x3e07a6cd },
    { 0x3ef7ac7d, 0x3e99b3df }, { 0x3ea7fe32, 0x3dcf1a2c }, { 0xbe1f8e3e, 0x3d654159 },
    { 0xbdf148ba, 0x3dbfaebf }, { 0xbdfd3970, 0xbc7a07bf }, { 0x3dfd9bae, 0x3ebe5f5e },
    { 0x3d4dd2a2, 0x3e0200e9 }, { 0xbd54e893, 0xba434045 }, { 0xbd062f2e, 0x3c81c5b5 },
    { 0x3cf93305, 0xbc042636 }, { 0xbd8407a9, 0xbbbd8356 }, { 0x3caac4cd, 0x3cafe0cc },
    { 0xbc9e56fa, 0x3ccafcdb }, { 0x3d667d09, 0x3f3e7c2a }, { 0xbe1ffb3e, 0xbf3720dc },
    { 0xbd9ede85, 0x3c99e831 }, { 0x3ee4e83b, 0x3d2a8b83 }, { 0xbea57794, 0x3e0d28a0 },
    { 0x3df2c15b, 0x3c77a3b3 }, { 0xbd9b481d, 0xbeaa8a48 }, { 0xbd81224d, 0x3e30597e },
    { 0x3afc5071, 0xbe834786 }, { 0xbcd8b494, 0xbd4f6daa }, { 0x3cae3bf9, 0xbd5c24bd },
    { 0x3d437a19, 0x3de3b27d }, { 0x3c05068f, 0xbb54bd1f }, { 0xbd8401e7, 0xbc198960 },
    { 0x3bf48829, 0x3cfbc836 }, { 0x3cad0afd, 0x3df4d3a4 }, { 0x3e82dba1, 0xbe368514 },
    { 0x3e3d6362, 0xbe39b1c1 }, { 0xbe3049c1, 0x3e03470b }, { 0x3ef516b2, 0x3e8da2e2 },
    { 0x3ea9eee7, 0x3db55f1c }, { 0xbe0b23dc, 0x3d5c7481 }, { 0xbdf8ad67, 0x3dac2603 },
    { 0xbde347c6, 0xbca6095a }, { 0x3dd39697, 0x3ebb3e70 }, { 0x3d3c8baf, 0x3dfdde75 },
    { 0xbd31f4e9, 0xbb293b15 }, { 0xbd0ce228, 0x3c567ccf }, { 0x3cbdb480, 0xbbbd9028 },
    { 0xbd7534c1, 0xbb9f1f27 }, { 0x3ca73d0b, 0x3c9b9c88 }, { 0xbcf16a59, 0x3ce44244 },
    { 0x3d8569cc, 0x3f4a2219 }, { 0xbe3bb1c4, 0xbf4337a9 }, { 0xbd8c2def, 0x3b36f896 },
    { 0x3eed1f0e, 0x3d495540 }, { 0xbead624f, 0x3e031999 }, { 0x3ddd055e, 0x3cdff096 },
    { 0xbdab68dd, 0xbeb309ad }, { 0xbd7125a5, 0x3e30516f }, { 0x3a8e0b26, 0xbe8b4dcb },
    { 0xbcfaf280, 0xbd4da86f }, { 0x3ca8763b, 0xbd7ab793 }, { 0x3d4ed9eb, 0x3dfb8bd4 },
    { 0x3b906b93, 0x3a11bcfc }, { 0xbd9b110a, 0xbbecd4c6 }, { 0x3c58fd1f, 0x3d09b3a5 },
    { 0x3c85f30c, 0x3ded2f6e }, { 0x3e84eb45, 0xbe3b9226 }, { 0x3e48716b, 0xbe4ffab2 },
    { 0xbe1d95c9, 0x3dfb3dff }, { 0x3ef15e97, 0x3e83c27a }, { 0x3ea87f6e, 0x3d9988b2 },
    { 0xbdef9f25, 0x3d498b7d }, { 0xbdfc7735, 0x3d9a7212 }, { 0xbdcd515b, 0xbcc7ebe9 },
    { 0x3db3fd4f, 0x3eb8b4ed }, { 0x3d248300, 0x3df4bf84 }, { 0xbd11818b, 0xbbb3e391 },
    { 0xbd0b4bd7, 0x3c3411e8 }, { 0x3c6f0d86, 0xbb3fe1f3 }, { 0xbd611b56, 0xbb5f7fd6 },
    { 0x3c9f4248, 0x3c922a81 }, { 0xbd1021b1, 0x3d004ad6 }, { 0x3d82bf07, 0x3f55265b },
    { 0xbe4f1f74, 0xbf4f812b }, { 0xbd668e90, 0xbc8d6229 }, { 0x3ef043a9, 0x3d4eb26b },
    { 0xbeae9f5b, 0x3df3c1da }, { 0x3dbe71e4, 0x3d36aaec }, { 0xbdba2254, 0xbeb70b96 },
    { 0xbd5a98b4, 0x3e2f0848 }, { 0xbc29e963, 0xbe95ac37 }, { 0xbcee6b1b, 0xbd38e750 },
    { 0x3c946540, 0xbd89cdea }, { 0x3d55a489, 0x3e04a13b }, { 0x38d1f970, 0x3ba1086c },
    { 0xbdae026e, 0xbb8a8903 }, { 0x3c964312, 0x3d16beae }, { 0x3c1f4601, 0x3dde57b7 },
    { 0x3e86f5d6, 0xbe3d8a20 }, { 0x3e4d1011, 0xbe611419 }, { 0xbe107742, 0x3df22f58 },
    { 0x3eed60af, 0x3e7bf72d }, { 0x3ea5e0d9, 0x3d828173 }, { 0xbdd1192c, 0x3d339e1c },
    { 0xbdff6cde, 0x3d8c2bd7 }, { 0xbdbc9e84, 0xbcdc78a5 }, { 0x3da3411c, 0x3eb7df4a },
    { 0x3d0f864f, 0x3ded42dc }, { 0xbcf028db, 0xbc08b4cf }, { 0xbd051db2, 0x3c11e7a5 },
    { 0x3bac7a0c, 0x392c85c6 }, { 0xbd4dc918, 0xbaf485ee }, { 0x3c9b627d, 0x3c95114b },
    { 0xbd17e28e, 0x3d0cebd8 }, { 0x3d580d88, 0x3f5ecc27 }, { 0xbe570e01, 0xbf5a3f44 },
    { 0xbd2e5c59, 0xbd0d56c8 }, { 0x3ef075ba, 0x3d38094d }, { 0xbeab2863, 0x3dedba24 },
    { 0x3d9a3caa, 0x3d7b5654 }, { 0xbdc6b601, 0xbeb8fd8b }, { 0xbd434639, 0x3e2feff0 },
    { 0xbcdc1d3b, 0xbe9f8314 }, { 0xbcc26818, 0xbd21044f }, { 0x3c68398e, 0xbd93032e },
    { 0x3d5a320c, 0x3e07f209 }, { 0xbb9b0a29, 0x3c14d132 }, { 0xbdbbb557, 0xbabef1ce },
    { 0x3ca984f7, 0x3d238d9e }, { 0x3b976f99, 0x3dd08084 }, { 0x3e879c78, 0xbe3e697c },
    { 0x3e4bbe23, 0xbe6e14c2 }, { 0xbe08e603, 0x3ded795b }, { 0x3eea0380, 0x3e77e389 },
    { 0x3ea361b5, 0x3d69f13c }, { 0xbdbade16, 0x3d1c53e5 }, { 0xbe00e689, 0x3d8198b9 },
    { 0xbdaf3575, 0xbce43535 }, { 0x3d9facfb, 0x3eb8f31b }, { 0x3d0094f9, 0x3de97b02 },
    { 0xbcc97e85, 0xbc34830f }, { 0xbcfe581f, 0x3be1f255 }, { 0xbba24822, 0x3b47813d },
    { 0xbd3bf1a3, 0xba1f6a22 }, { 0x3c9e6cac, 0x3ca72d3d }, { 0xbd154286, 0x3d14e308 },
    { 0x3d1f1547, 0x3f67fd1b }, { 0xbe5885af, 0xbf637943 }, { 0xbcf119cd, 0xbd320373 },
    { 0x3ef08956, 0x3d142699 }, { 0xbea7a502, 0x3def99b7 }, { 0x3d6dc05d, 0x3d93dd39 },
    { 0xbdd559e9, 0xbebc56b7 }, { 0xbd2c55b7, 0x3e35c159 }, { 0xbd2a53e4, 0xbea77d5c },
    { 0xbc8b83e1, 0xbd12323f }, { 0x3c210cda, 0xbd98d9fe }, { 0x3d615d64, 0x3e0b235e },
    { 0xbc124ff8, 0x3c435b47 }, { 0xbdc6cbc1, 0x3944ed6c }, { 0x3ca1c9da, 0x3d2c0104 },
    { 0x3ae9dcfb, 0x3dc7215d }, { 0x3e87a1d9, 0xbe3eea59 }, { 0x3e4661d5, 0xbe7930ac },
    { 0xbe06a7ae, 0x3dea2add }, { 0x3ee941fa, 0x3e7a2340 }, { 0x3ea1db2b, 0x3d6148fb },
    { 0xbdab1ad1, 0x3cfe6690 }, { 0xbe03229d, 0x3d721926 }, { 0xbda33959, 0xbce3886f },
    { 0x3da77c75, 0x3ebc7eb2 }, { 0x3cf18973, 0x3dea0974 }, { 0xbca8105a, 0xbc5d5998 },
    { 0xbcf9e620, 0x3ba277c1 }, { 0xbc80b272, 0x3bbbc065 }, { 0xbd2c4144, 0x38c6d2dc },
    { 0x3ca42a9f, 0x3ccc351e }, { 0xbd0cca20, 0x3d1a58d9 }, { 0x3ccc523f, 0x3f72e659 },
    { 0xbe584e31, 0xbf6d5d98 }, { 0xbc8ee372, 0xbd30bbae }, { 0x3ef17e10, 0x3cbe968e },
    { 0xbea757c8, 0x3df910dd }, { 0x3d2dffc9, 0x3d9e6dbe }, { 0xbde8258d, 0xbec2dcbc },
    { 0xbd1889c4, 0x3e425a32 }, { 0xbd58d891, 0xbeae7134 }, { 0xbc1cac93, 0xbd0e6664 },
    { 0x3bcc0ddc, 0xbd9e304e }, { 0x3d6b36f0, 0x3e10d8cb }, { 0xbc4d37b4, 0x3c4e8079 },
    { 0xbdd040c0, 0x3addeff0 }, { 0x3c8c48d1, 0x3d2dfb31 }, { 0x38071e70, 0x3dc366a5 },
    { 0x3e8492fd, 0xbe3b260c }, { 0x3e39b263, 0xbe7e8b38 }, { 0xbe049f09, 0x3ddeb30d },
    { 0x3ee6716a, 0x3e7c0c75 }, { 0x3e9df26b, 0x3d612cfb }, { 0xbd9db546, 0x3cadca21 },
    { 0xbe041f66, 0x3d5ad1f0 }, { 0xbd94cd57, 0xbce0e4d5 }, { 0x3db37252, 0x3ebe2f7d },
    { 0x3cec369d, 0x3de90722 }, { 0xbc858129, 0xbc7c98e3 }, { 0xbcf2edcc, 0x3b16a2e5 },
    { 0xbccf0fcd, 0x3c063699 }, { 0xbd1c2bc5, 0x3a07ae48 }, { 0x3ca3296a, 0x3cfc5628 },
    { 0xbcfa3c5a, 0x3d1bc607 }, { 0x3c5bdc48, 0x3f7ae2fe }, { 0xbe5405b1, 0xbf738152 },
    { 0xbbc7039e, 0xbd1039f3 }, { 0x3eedc7b3, 0x3bb43fda }, { 0xbea7bb51, 0x3e01683b },
    { 0x3ce5d3ce, 0x3d9e428d }, { 0xbdfb4242, 0xbec86639 }, { 0xbd0647d4, 0x3e524dca },
    { 0xbd7007eb, 0xbeb0d146 }, { 0xba870d92, 0xbd119370 }, { 0x3b80fcc7, 0xbda17f20 },
    { 0x3d6fcea6, 0x3e16327d }, { 0xbc81af73, 0x3c2c8112 }, { 0xbdd18cb0, 0x3b6d093d },
    { 0x3c65935f, 0x3d2801b3 }, { 0xbae2b262, 0x3dc109ba }, { 0x3e81dd00, 0xbe367fa7 },
    { 0x3e2c14b4, 0xbe80d50d }, { 0xbe04a971, 0x3dcd5cfa }, { 0x3ee6215f, 0x3e8076dc },
    { 0x3e9a543a, 0x3d6891cb }, { 0xbd9560d2, 0x3c22d9be }, { 0xbe03d5b9, 0x3d379142 },
    { 0xbd8c6ced, 0xbcf8e69a }, { 0x3dc56c7a, 0x3ebfdd8b }, { 0x3cf2548a, 0x3de863e4 },
    { 0xbc606b73, 0xbc8f6d6b }, { 0xbce64eac, 0xbad86869 }, { 0xbd018306, 0x3c2a8306 },
    { 0xbd0d830c, 0x39c97534 }, { 0x3c9947af, 0x3d142763 }, { 0xbcd0dc06, 0x3d1e3e49 },
    { 0x3c12cae2, 0x3f81e529 }, { 0xbe4d651b, 0xbf797329 }, { 0x3bb062b6, 0xbcd3ca00 },
    { 0x3ee6b9c0, 0xbc8fd35e }, { 0xbeab61b2, 0x3e096e04 }, { 0x3c78adc7, 0x3d9df325 },
    { 0xbe0b0210, 0xbeceeb59 }, { 0xbce9bda4, 0x3e69a7f9 }, { 0xbd66ccb8, 0xbeb06d2b },
    { 0x3c16cc5e, 0xbd1a94e8 }, { 0x3b810b74, 0xbda4ff37 }, { 0x3d703e92, 0x3e1bdfe1 },
    { 0xbc9c90d4, 0x3bdf0a94 }, { 0xbdcac627, 0x3bc50aef }, { 0x3c386194, 0x3d2306f9 },
    { 0xbba9143b, 0x3dc3f4a6 }, { 0x3e7c3643, 0xbe338e6f }, { 0x3e1df6fd, 0xbe81e346 },
    { 0xbe06f514, 0x3db50eb2 }, { 0x3ee75b85, 0x3e82b050 }, { 0x3e970218, 0x3d7544f2 },
    { 0xbd91db1b, 0xbaf589ba }, { 0xbe0131ae, 0x3d0ab28c }, { 0xbd8c846c, 0xbd1e798c },
    { 0x3dd80953, 0x3ec058b4 }, { 0x3cfcaf19, 0x3de711a3 }, { 0xbc56ebae, 0xbca5e274 },
    { 0xbcd639fe, 0xbbd39b5a }, { 0xbd0c0c0c, 0x3c4c1cdf }, { 0xbcfd5ccb, 0xba0fd134 },
    { 0x3c87acc8, 0x3d230f7e }, { 0xbca8198d, 0x3d1e8ce8 }, { 0x3c780916, 0x3f870a61 },
    { 0xbe4875ca, 0xbf7ffc3c }, { 0x3c96d81a, 0xbc6ddccc }, { 0x3edf1b65, 0xbd065e26 },
    { 0xbeb1b394, 0x3e115404 }, { 0x3b925d58, 0x3d9c6814 }, { 0xbe1d65d7, 0xbed5c617 },
    { 0xbcd5c69a, 0x3e84b40d }, { 0xbd467efd, 0xbeafc70b }, { 0x3c953de6, 0xbd27a8c3 },
    { 0x3ba34994, 0xbda8a9fd }, { 0x3d72721f, 0x3e223efc }, { 0xbcc43799, 0x3aaffb95 },
    { 0xbdc0b136, 0x3bc84bf2 }, { 0x3c2248ff, 0x3d21c32b }, { 0xbc16803e, 0x3dccd398 },
    { 0x3e71a46c, 0xbe30ac3a }, { 0x3e104c7b, 0xbe81247e }, { 0xbe0b1ed5, 0x3d917a3f },
    { 0x3ee6b92e, 0x3e82102e }, { 0x3e926dba, 0x3d7f5975 }, { 0xbd9316d8, 0xbc5b2077 },
    { 0xbdf99d2d, 0x3cab5806 }, { 0xbd94a91f, 0xbd5392b3 }, { 0x3de5786a, 0x3ebcf8fa },
    { 0x3d04d806, 0x3de1fac9 }, { 0xbc712e82, 0xbcbe9cf5 }, { 0xbcc62ddd, 0xbc38caef },
    { 0xbd05a6a8, 0x3c69a06c }, { 0xbcdf6202, 0xbb36801e }, { 0x3c5a8ff7, 0x3d24227c },
    { 0xbc85cbba, 0x3d1ca8c9 }, { 0x3cf21b4b, 0x3f8afe0c }, { 0xbe43bea9, 0xbf828967 },
    { 0x3d0d9070, 0xbb1b34aa }, { 0x3ed5d274, 0xbd1b61a2 }, { 0xbeb73add, 0x3e168dbf },
    { 0xbb5f1bc8, 0x3d98a929 }, { 0xbe2f99f7, 0xbed956a8 }, { 0xbcda0f9c, 0x3e9660d7 },
    { 0xbd2071ce, 0xbeafa1ff }, { 0x3cc8e4ca, 0xbd2d799e }, { 0x3bb91baa, 0xbdabf9cc },
    { 0x3d76eef6, 0x3e27115b }, { 0xbcfe70ac, 0xbba46698 }, { 0xbdb3ca1a, 0x3ada6786 },
    { 0x3c296fc4, 0x3d20175e }, { 0xbc512cf5, 0x3dd959bb }, { 0x3e669366, 0xbe2d70f1 },
    { 0x3e0510db, 0xbe7deab8 }, { 0xbe1106e6, 0x3d51375a }, { 0x3ee33849, 0x3e7c20b0 },
    { 0x3e8cc065, 0x3d825033 }, { 0xbd9a1924, 0xbcafbd50 }, { 0xbdf0a202, 0x3be479dc },
    { 0xbda50a87, 0xbd8a7ff1 }, { 0x3de92c94, 0x3eb582f0 }, { 0x3d0b6316, 0x3dd8f67e },
    { 0xbc9a4e78, 0xbcd713c6 }, { 0xbcb60766, 0xbc7b0119 }, { 0xbce286ee, 0x3c7857a6 },
    { 0xbcc54d43, 0xbbd111de }, { 0x3c1efa4c, 0x3d120e61 }, { 0xbc5b43c3, 0x3d191327 },
    { 0x3d544f1c, 0x3f8dafd7 }, { 0xbe3f98c0, 0xbf842cf0 }, { 0x3d567c26, 0x3b968bed },
    { 0x3ecb64b3, 0xbd12a5df }, { 0xbeb9d091, 0x3e1665d2 }, { 0xbc10ccda, 0x3d9424e0 },
    { 0xbe3f0964, 0xbed85656 }, { 0xbcf2e53f, 0x3ea8a175 }, { 0xbcea7a41, 0xbeafd6d3 },
    { 0x3cdfc5cb, 0xbd1bb34c }, { 0x3bce2732, 0xbdb09640 }, { 0x3d7dc7a1, 0x3e286b60 },
    { 0xbd208d5a, 0xbc2cde55 }, { 0xbda4f227, 0xbc0be671 }, { 0x3c388a9d, 0x3d200d3c },
    { 0xbc8b99af, 0x3de875d3 }, { 0x3e595c51, 0xbe295406 }, { 0x3df566e1, 0xbe771d4b },
    { 0xbe15a5ef, 0x3d0a4e18 }, { 0x3edab24a, 0x3e6cf3d6 }, { 0x3e855f8e, 0x3d8249d1 },
    { 0xbda4f70e, 0xbcc24d0d }, { 0xbde66490, 0xbba71b76 }, { 0xbdb888ff, 0xbda950d7 },
    { 0x3ddf03be, 0x3eaa275a }, { 0x3d0cde4b, 0x3dcc459f }, { 0xbcc7488c, 0xbce8d941 },
    { 0xbca5226e, 0xbc90765c }, { 0xbca9acd6, 0x3c70710c }, { 0xbcb11391, 0xbc2b6cf8 },
    { 0x3bd96a14, 0x3ce14274 }, { 0xbc3ebbc0, 0x3d11ad88 }, { 0x3da19562, 0x3f8ec700 },
    { 0xbe3de92d, 0xbf83f4b4 }, { 0x3d8c72d0, 0x3bd38d0b }, { 0x3ec07f82, 0xbce32f4c },
    { 0xbeb7d41c, 0x3e0b3b7c }, { 0xbc45d3de, 0x3d8b41e8 }, { 0xbe4a0f85, 0xbed356a6 },
    { 0xbd05468b, 0x3eb87711 }, { 0xbc897ad5, 0xbeae8430 }, { 0x3cd18f52, 0xbcdbc6f5 },
    { 0x3bdbe480, 0xbdb4ca7d }, { 0x3d81bfa7, 0x3e25179a }, { 0xbd3ced0f, 0xbc64b9bb },
    { 0xbd95c6ff, 0xbcb5f0a9 }, { 0x3c2f3b63, 0x3d22837e }, { 0xbcbc0ee0, 0x3df418d9 },
    { 0x3e49120a, 0xbe220955 }, { 0x3de0806e, 0xbe6d5491 }, { 0xbe15e99d, 0x3cc62fff },
    { 0x3eccb708, 0x3e592fc6 }, { 0x3e77effd, 0x3d7dc951 }, { 0xbdaf032f, 0xbca87ab7 },
    { 0xbdd996d2, 0xbc4a597e }, { 0xbdc6a313, 0xbdbc3729 }, { 0x3dc939e1, 0x3e9c4247 },
    { 0x3d06628b, 0x3dbd2ceb }, { 0xbcef139c, 0xbcecd744 }, { 0xbc930634, 0xbc9354df },
    { 0xbc60f309, 0x3c4cbcb4 }, { 0xbca059c4, 0xbc65cfb1 }, { 0x3b9f46e7, 0x3c923c1f },
    { 0xbc2a866e, 0x3d077b2b }, { 0x3dd31367, 0x3f8d7c86 }, { 0xbe3ca6c4, 0xbf8113ab },
    { 0x3da2ceca, 0x3b8c153e }, { 0x3eb4d5ea, 0xbc9a7dc9 }, { 0xbeb15769, 0x3defe718 },
    { 0xbc5cd9a0, 0x3d7d7349 }, { 0xbe4e1a3b, 0xbecbbfeb }, { 0xbd068437, 0x3ec1a6a3 },
    { 0xbbc6ae1c, 0xbeaa5b0a }, { 0x3ca5f6e6, 0xbc5249c8 }, { 0x3bd4ec7b, 0xbdb81da7 },
    { 0x3d827c5e, 0x3e1d1e0f }, { 0xbd51b8bb, 0xbc687480 }, { 0xbd88599f, 0xbd0ce24e },
    { 0x3c018503, 0x3d25efe7 }, { 0xbcf3d4a2, 0x3df4f005 }, { 0x3e34fedc, 0xbe158222 },
    { 0x3dcacf36, 0xbe5dd42f }, { 0xbe100112, 0x3cb546b7 }, { 0x3eb8b584, 0x3e40f2cf },
    { 0x3e5f3628, 0x3d6edd8a }, { 0xbdb3c51a, 0xbc596187 }, { 0xbdc5afd0, 0xbc758adb },
    { 0xbdc9d1a6, 0xbdbe8954 }, { 0x3dab7dc4, 0x3e8b9baf }, { 0x3cf0b919, 0x3dab1b6c },
    { 0xbd0418d4, 0xbce1d0eb }, { 0xbc76de08, 0xbc892d20 }, { 0xbbeea281, 0x3c155d74 },
    { 0xbc892079, 0xbc850eec }, { 0x3b8d5425, 0x3c05727e }, { 0xbc17a3ef, 0x3cf32e33 },
    { 0x3df2e273, 0x3f878b14 }, { 0xbe37931d, 0xbf74acef }, { 0x3daa41be, 0x3ae7f9ac },
    { 0x3ea510fc, 0xbbe789e4 }, { 0xbea4ee93, 0x3dc2c8be }, { 0xbc690fa1, 0x3d67332f },
    { 0xbe493819, 0xbebed5fd }, { 0xbceaad9c, 0x3ebf8e1a }, { 0x3b1df39c, 0xbea36e23 },
    { 0x3c557f50, 0x3ab81718 }, { 0x3bcb2da1, 0xbdb8f3f1 }, { 0x3d7fc0c4, 0x3e0ed063 },
    { 0xbd5b01a4, 0xbc567b2c }, { 0xbd75f793, 0xbd2f0a6f }, { 0x3b5d8223, 0x3d2d0ccf },
    { 0xbd113cd3, 0x3de88d3e }, { 0x3e192e50, 0xbe00e4b5 }, { 0x3db00f14, 0xbe4252e9 },
    { 0xbe011741, 0x3cbb92f4 }, { 0x3e9c3028, 0x3e214c4d }, { 0x3e3c8300, 0x3d525bc5 },
    { 0xbdaaeb14, 0xbba7d872 }, { 0xbda7f05d, 0xbc72d358 }, { 0xbdba11f0, 0xbdac3787 },
    { 0x3d88438e, 0x3e6bc980 }, { 0x3cc8ecb1, 0x3d924330 }, { 0xbd01f20c, 0xbcc67383 },
    { 0xbc425bdb, 0xbc6c8a24 }, { 0xbb1a7e52, 0x3bb9a06f }, { 0xbc558b99, 0xbc871950 },
    { 0x3b9febb8, 0x3a6c7499 }, { 0xbc0006c5, 0x3cce2ed0 }, { 0x3df4d1b2, 0x3f70762c },
    { 0xbe264a45, 0xbf5761e3 }, { 0x3d9c802b, 0x3aef8eb4 }, { 0x3e8b3908, 0x3c04063e },
    { 0xbe8e3b4a, 0x3d8e1127 }, { 0xbc7885cc, 0x3d408ecd }, { 0xbe373795, 0xbea576f0 },
    { 0xbcaa0ea8, 0x3eaca844 }, { 0x3bf01978, 0xbe943a48 }, { 0x3bb1a2cb, 0x3c73d92c },
    { 0x3bb7f6a5, 0xbdaca920 }, { 0x3d6b241a, 0x3deed9d4 }, { 0xbd4ec2cd, 0xbc567b3a },
    { 0xbd51059a, 0xbd3b0300 }, { 0xbaa5312f, 0x3d2963d1 }, { 0xbd143f49, 0x3dc934a2 },
    { 0x3de72298, 0xbdc87aba }, { 0x3d892919, 0xbe1823fd }, { 0xbdce7ef8, 0x3cbc9f32 },
    { 0x3e6ca6a1, 0x3df29480 }, { 0x3e0e4c6e, 0x3d259d9b }, { 0xbd8e6bc2, 0x3accddbf },
    { 0xbd7c69bb, 0xbc5ce8f8 }, { 0xbd95ae0f, 0xbd871044 }, { 0x3d4247e3, 0x3e337ada },
    { 0x3c95251d, 0x3d5fb6fc }, { 0xbcdb3dc6, 0xbc9dc9c1 }, { 0xbc095832, 0xbc3bf68f },
    { 0xb9189b74, 0x3b4453e7 }, { 0xbc0cbe3a, 0xbc68db68 }, { 0x3bb6dd62, 0xbb2816ae },
    { 0xbbbc5ff9, 0x3c9e196f }, { 0x3dd3043f, 0x3f3ccdf4 }, { 0xbe0587b8, 0xbf27fa61 },
    { 0x3d7824a1, 0x3b75c4cc }, { 0x3e508253, 0x3cacf57c }, { 0xbe59f0a6, 0x3d2e4196 },
    { 0xbc6f74b4, 0x3d00dac2 }, { 0xbe163b8e, 0xbe7e007e }, { 0xbc4c58e8, 0x3e88e1c6 },
    { 0x3c0d9a04, 0xbe70c2c9 }, { 0xba3a70f8, 0x3cbfcf39 }, { 0x3b874f44, 0xbd8b90e2 },
    { 0x3d424d34, 0x3db11369 }, { 0xbd2648d3, 0xbc6321a9 }, { 0xbd209519, 0xbd2c9a93 },
    { 0xbb898deb, 0x3d107fd4 }, { 0xbcf89eb4, 0x3d97bedb }, { 0x3d916b27, 0xbd82c004 },
    { 0x3d2ebc7b, 0xbdc44142 }, { 0xbd8b3cf2, 0x3ca0737d }, { 0x3e148ffd, 0x3d9768c6 },
    { 0x3db11af2, 0x3cd61841 }, { 0xbd421fae, 0x3b8b55f7 }, { 0xbd183eaa, 0xbc407071 },
    { 0xbd464929, 0xbd2cead9 }, { 0x3ce8d1f0, 0x3de21e0a }, { 0x3c38f16e, 0x3d0cb375 },
    { 0xbc94e62b, 0xbc523aa1 }, { 0xbb94a451, 0xbc03b10f }, { 0xb99b68c0, 0x3b0c7f74 },
    { 0xbb8203ca, 0xbc203ad0 }, { 0x3b9978df, 0xbb37bdee }, { 0xbb5fa97c, 0x3c4bf036 },
    { 0x3d8de640, 0x3ef264de }, { 0xbdad4ba0, 0xbed660c8 }, { 0x3d251cd3, 0x3b8e1e0a },
    { 0x3e012b0e, 0x3cbc73a8 }, { 0xbe085546, 0x3cacc648 }, { 0xbc47288c, 0x3c6e3322 },
    { 0xbdce9a5e, 0xbe1f5577 }, { 0xbbcdb2df, 0x3e3269df }, { 0x3bc701d4, 0xbe1ef69e },
    { 0xbb6f253e, 0x3cb8b71c }, { 0x3b1843d7, 0xbd36f4d3 }, { 0x3d06b32f, 0x3d56ad01 },
    { 0xbccfeaee, 0xbc527011 }, { 0xbcce5ee0, 0xbd02d5e4 }, { 0xbb8c6d6d, 0x3cbee8b8 },
    { 0xbca1a8a7, 0x3d36b451 }, { 0x3d0b4f03, 0xbd00de9a }, { 0x3c9e3881, 0xbd359d38 },
    { 0xbd0fb31e, 0x3c62c2d6 }, { 0x3d8668ae, 0x3d0742ca }, { 0x3d1d1664, 0x3c40cd47 },
    { 0xbcc13d66, 0x3b6eb111 }, { 0xbc638ef8, 0xbc1feca3 }, { 0xbcc1b430, 0xbc9d85a6 },
    { 0x3c4ad0ac, 0x3d499a16 }, { 0x3ba76d5b, 0x3c792fe9 }, { 0xbc121e14, 0xbbc9a623 },
    { 0xba72f308, 0xbb9a8cf3 }, { 0xbaaf5b6c, 0x3b2daa4b }, { 0xb9891041, 0xbb961b2c },
    { 0x3b23db75, 0xbac394dc }, { 0xbacd181d, 0x3bbf9748 }, { 0x3cf223ad, 0x3e5a4795 },
    { 0xbd13aa1f, 0xbe41c0df }, { 0x3caf623f, 0x3aa6c9e1 }, { 0x3d6867d8, 0x3c5913fc },
    { 0xbd6aa4e9, 0x3c1b5d0b }, { 0xbc11647b, 0x3b78a975 }, { 0xbd55b4a1, 0xbd8aeb0e },
    { 0xbb3c5fcf, 0x3da6a45b }, { 0x3af8387e, 0xbd8f0737 }, { 0xbb3efad8, 0x3c5d7d19 },
    { 0x3a709a22, 0xbcabb5c2 }, { 0x3c8ba472, 0x3cb4434a }, { 0xbc1cfb39, 0xbc09cf5e },
    { 0xbc3e9df8, 0xbc98127d }, { 0xbb2023d7, 0x3c28416d }, { 0xbc103472, 0x3c993064 },
    { 0x3c5ede74, 0xbc51f07b }, { 0x3bb50766, 0xbc78673d }, { 0xbc74e0f0, 0x3c201d60 },
    { 0x3ca5064a, 0x3c1b7476 }, { 0x3c36ad66, 0x3b5c787e }, { 0xbc108736, 0x3b33d218 },
    { 0xba24674a, 0xbbff350b }, { 0xbc06e5a1, 0xbbb0b549 }, { 0x3b52802b, 0x3c691621 },
    { 0x3abf223f, 0x3b8fa1b5 }, { 0xbb4d8317, 0xbafd82af }, { 0x3a8fff14, 0xbb27446c },
    { 0xbb0684d5, 0x3b41a46f }, { 0x3a912093, 0xbab44a75 }, { 0x3a7e9bde, 0xb9e5e3bf },
    { 0xba30d105, 0x3af11e1d }, { 0x3bb73d53, 0x3d76a4ae }, { 0xbbddfdac, 0xbd64fc0b },
    { 0x3c25fb9e, 0xbaa16195 }, { 0x3c94ae9f, 0x3b9f3ea0 }, { 0xbc6753e6, 0x3b97a100 },
    { 0xbbd7989c, 0x39c7292e }, { 0xbcacdd34, 0xbc9507de }, { 0xbac6d280, 0x3cd09146 },
    { 0xb9d66496, 0xbc92a569 }, { 0xba84f9aa, 0x3ba86e74 }, { 0xb7f19f68, 0xbbddfca8 },
    { 0x3be814c0, 0x3bb0cddd }, { 0xb9ec5dd0, 0xbb77a82d }, { 0xbb60c3ea, 0xbc115483 },
    { 0xba569b8d, 0x3b4380bc }, { 0xbb286a27, 0x3ba7fefd }, { 0x3bfb437a, 0xbba6b2a5 },
    { 0x3a1d2c14, 0xbc027034 }, { 0xbbe879c9, 0x3be41094 }, { 0x3bb93a51, 0x3aa022a5 },
    { 0x3b3a8d2b, 0x3a91fbe7 }, { 0xbb9461d4, 0x3b526390 }, { 0x3b0a58ac, 0xbbbb9b68 },
    { 0xbadb2d2d, 0x3a430454 }, { 0xb89f31a0, 0x3b591b59 }, { 0x39d10c96, 0x3aac4836 },
    { 0xba9b43a2, 0xba05467d }, { 0x3b15c04e, 0xbb089718 }, { 0xbb085624, 0x3b1bce55 },
    { 0x39cddc74, 0xba9b42cd }, { 0x3a0bef36, 0xb75c3dd8 }, { 0xb9d2350a, 0x3a3c4e09 },
    { 0xbb32eeee, 0x3c7a9438 }, { 0x3b28877a, 0xbc8cf179 }, { 0x3c0f6322, 0xbb0a1304 },
    { 0x3bb4eb53, 0xb89e7f60 }, { 0xbb0cb9ca, 0x3b6024dc }, { 0xbbe43d29, 0x39ec98a4 },
    { 0xbc3f2dc2, 0xbb6f8e98 }, { 0xba84c809, 0x3c1a664b }, { 0xbaafced7, 0xbb7572a4 },
    { 0xb8d45214, 0x3ada66e9 }, { 0xb9ad5914, 0xbb1226f2 }, { 0x3ba7b1fc, 0x3a68b91b },
    { 0x3b340a1a, 0xbae28f58 }, { 0xba0794d8, 0xbbb00bc7 }, { 0xb90ad24c, 0x3a46c59e },
    { 0xba658e26, 0x3ac53b33 }, { 0x3b87e79c, 0xbb1c6282 }, { 0x399fc738, 0xbb97f686 },
    { 0xbb538f2a, 0x3b4fbdd2 }, { 0x3b0df6e9, 0x38efbd3c }, { 0x3af3baef, 0x3a2268fd },
    { 0xbb3913a8, 0x3b229910 }, { 0x3aa58e1f, 0xbb46cc4e }, { 0xba0741f2, 0x3a8e4d15 },
    { 0xb949150c, 0x3aba36a0 }, { 0x39a1493e, 0x3a48173b }, { 0xba173e05, 0xb9030632 },
    { 0x3b030609, 0xbadbe3b2 }, { 0xba676870, 0x3aa4162e }, { 0x395659b4, 0xba896d0c },
    { 0x39a833be, 0xb81a5596 }, { 0xb9c6e171, 0x3a0b7850 }, { 0xbb12b447, 0x3bc21893 },
    { 0x3af22520, 0xbbf94212 }, { 0x3bdc54e0, 0xbb0b9349 }, { 0x3ad1b5ae, 0xba2c124b },
    { 0x3981b86b, 0x3b26cc65 }, { 0xbb9ba462, 0x3a871534 }, { 0xbbf5f16e, 0xba41777c },
    { 0xba5f7aef, 0x3b5e0789 }, { 0xba5deea6, 0xbaa78e35 }, { 0xb92c80ae, 0x3a55675e },
    { 0xb94a7978, 0xba5ddbb6 }, { 0x3b747d68, 0x3915b266 }, { 0x3b3505aa, 0xba2202ae },
    { 0x3a2189d3, 0xbb0ef8ee }, { 0x38a9c42e, 0x39659ccc }, { 0xba322673, 0x3a4dc0aa },
    { 0x3af81468, 0xba95eafe }, { 0xb95e3726, 0xbaec34da }, { 0xbab97ffd, 0x3ab2e30b },
    { 0x3a58b5fb, 0x393b9489 }, { 0x3a70604a, 0x3995c10f }, { 0xba8f0f2c, 0x3a700904 },
    { 0x3a1d801e, 0xbab63ac6 }, { 0xb98fd6c6, 0x39d80fff }, { 0xb6b3cf80, 0x3a319aa0 },
    { 0x3945331d, 0x39e0b50f }, { 0xb97dff95, 0xb7bfc70e }, { 0x3a788fc7, 0xba446a17 },
    { 0xb9b2dec4, 0x3a0db3b2 }, { 0x392919eb, 0xb9da0999 }, { 0x390f2ac8, 0xb7ca77a0 },
    { 0xb956a0ef, 0x39707ef0 }, { 0xb8f675f0, 0x3b3dcf97 }, { 0xb9b57e43, 0xbb7b3b3e },
    { 0x3b3bb81c, 0xba71d731 }, { 0x399de6d8, 0xb96add22 }, { 0x39bf0665, 0x3aa440e5 },
    { 0xbaf00cca, 0x39ed934e }, { 0xbb72c776, 0xba15ae2b }, { 0xba0b6dc1, 0x3a8d3ad4 },
    { 0xb9eb25fe, 0xba2ec5f9 }, { 0xb926eb53, 0x39ddfe7b }, { 0xb8a2c73b, 0xb9dfe1e6 },
    { 0x3afa76d1, 0x390f00d3 }, { 0x3aa825f5, 0xb9685db8 }, { 0x3a083196, 0xba179a46 },
    { 0x38550e30, 0x38a90713 }, { 0xb99faefa, 0x39cc2ef4 }, { 0x39f7e97e, 0xb9ef5589 },
    { 0xb8d94470, 0xba03a9e2 }, { 0xb9fa4a4f, 0x39de6abb }, { 0x399f92da, 0x392acd98 },
    { 0x39a1e0de, 0x38d003e5 }, { 0xb9852113, 0x3928aef2 }, { 0x399d7a02, 0xb9e7781e },
    { 0xb8d302a2, 0x388bc119 }, { 0x38ed8360, 0x39b7fbab }, { 0x38d61746, 0x39374bf2 },
    { 0xb89a2aea, 0x37185d4b }, { 0x396e8db0, 0xb93028ab }, { 0xb8c3af25, 0x39241278 },
    { 0x37c3cd48, 0xb8c62a74 }, { 0x3823970d, 0xb69a70fb }, { 0xb8af0438, 0x385f3c42 },
    { 0x3a0e5e28, 0x3aa5fd19 }, { 0xba4f284d, 0xbadeae90 }, { 0x3a288c4a, 0xb97ac29e },
    { 0xb8d51720, 0xb8b72cac }, { 0x391551f6, 0x39f4f972 }, { 0xb9c16828, 0x39062327 },
    { 0xbaa14193, 0xb9e923aa }, { 0xb8f267d8, 0x39ace098 }, { 0xb96b2384, 0xb9c3e0d8 },
    { 0xb8372aaf, 0x39191c3a }, { 0xb7ce5958, 0xb945be05 }, { 0x3a1b8a46, 0x39244a6d },
    { 0x39aaba60, 0xb83262a8 }, { 0x391d41c5, 0xb8cf420f }, { 0xb7923619, 0x38264e3a },
    { 0xb8a6e3e8, 0x392cd7b4 }, { 0x38d62b66, 0xb98e181d }, { 0xb8345f17, 0xb9abf60e },
    { 0xb9348d30, 0x38eaa179 }, { 0x3958b8da, 0x38e5a55e }, { 0x394a6137, 0x3837a3db },
    { 0xb8efa34c, 0x384d59a3 }, { 0x390ecbbf, 0xb8cfe540 }, { 0xb8816ad7, 0x37001810 },
    { 0x3905e3a9, 0x399896a8 }, { 0x38a544ff, 0x38ff3d8e }, { 0xb827a5b1, 0x36d43964 },
    { 0x38aa9e51, 0xb83b2452 }, { 0x35dad91a, 0x37e342f1 }, { 0xb745417f, 0xb811d286 },
    { 0x37b93324, 0xb7286287 }, { 0xb882e2a5, 0x37e2dfeb }, { 0x3a20dc2c, 0x3a6a963f },
    { 0xba450d0b, 0xba8d9aab }, { 0x38ffc74c, 0xb8bb9b34 }, { 0xb93428be, 0xb8f410e7 },
    { 0x385f4bdd, 0x3980071e }, { 0xb88d45db, 0x38a67cfb }, { 0xba18930b, 0xb9c17e38 },
    { 0x37968d76, 0x39472928 }, { 0xb93cb81f, 0xb9c581d6 }, { 0xb7667e30, 0x382b4045 },
    { 0xb7b8379a, 0xb8fcd2b0 }, { 0x3980baa0, 0x39194f52 }, { 0x3892ee1f, 0xb5952d0d },
    { 0x383339f6, 0xb710f9c4 }, { 0xb7f008ec, 0x3802eb7c }, { 0xb7a33c92, 0x38e046f3 },
    { 0x38c54270, 0xb991214c }, { 0xb7ac7fc2, 0xb9b2499b }, { 0xb91bd088, 0x38c8d7f0 },
    { 0x39433d0b, 0x3897dabc }, { 0x393a738e, 0x3777fc2b }, { 0xb8d1f9a3, 0x384ef823 },
    { 0x38d605ce, 0xb844b13c }, { 0xb862944b, 0xb5d21622 }, { 0x38ea7a52, 0x398f3ebe },
    { 0x388e9ea5, 0x38d7ccea }, { 0xb810cb50, 0x35a49c44 }, { 0x386560a3, 0xb79407d3 },
    { 0x36fa3a00, 0x37687ef8 }, { 0xb780a4c3, 0xb7a2062b }, { 0x377cdddc, 0xb7706cc8 },
    { 0xb8653218, 0x3804217e }, { 0x3a1da6e1, 0x3a59d16d }, { 0xba3c1d4a, 0xba80fa5b },
    { 0x38b3446c, 0xb895f927 }, { 0xb9286a83, 0xb8da8cd2 }, { 0x383cfac6, 0x396b94e1 },
    { 0xb81e29c5, 0x38b76655 }, { 0xba0313ad, 0xb9b8cf8c }, { 0x38121621, 0x393fac46 },
    { 0xb9384ec1, 0xb9b486f9 }, { 0xb73dcd54, 0x37c88fc5 }, { 0xb807b26a, 0xb8e9cd0a },
    { 0x3948ed40, 0x3913b27d }, { 0x38578317, 0x376b6e6a }, { 0x37f03f1e, 0xb6d49f74 },
    { 0xb7bc44f4, 0x381796d3 }, { 0xb77d3bb1, 0x38c2deb1 }, { 0x38d067b1, 0xb98ef2bc },
    { 0xb6115d78, 0xb9acd5cb }, { 0xb90ea462, 0x38bb0750 }, { 0x3933299f, 0x384c0e89 },
    { 0x392861b9, 0xb6824b37 }, { 0xb8ba26b5, 0x384a618b }, { 0x38ae88d9, 0xb7e755cb },
    { 0xb843bd32, 0xb6647729 }, { 0x38c78b1b, 0x39810f37 }, { 0x3871e5c7, 0x38b35a07 },
    { 0xb7eea5ae, 0x34580b63 }, { 0x382bffb0, 0xb701c415 }, { 0x36b39db8, 0x37241d92 },
    { 0xb77fa683, 0xb74720f2 }, { 0x3744dffb, 0xb75a67e0 }, { 0xb8428c7a, 0x3806e41d },
    { 0x3a14379d, 0x3a49cb93 }, { 0xba304cd2, 0xba6def30 }, { 0x38a11b2f, 0xb866156b },
    { 0xb917108b, 0xb8c3d02a }, { 0x382a9417, 0x395a17f0 }, { 0xb7f2a567, 0x38b2972d },
    { 0xb9ee0483, 0xb9af4e42 }, { 0x38194c9f, 0x393551fb }, { 0xb9300aa8, 0xb9a405c0 },
    { 0xb6d4df1c, 0x3796c27c }, { 0xb8172086, 0xb8d5186e }, { 0x392f2340, 0x390b969f },
    { 0x383b8cf0, 0x379c4709 }, { 0x37c40603, 0xb6b4af03 }, { 0xb79902ae, 0x3810728d },
    { 0xb74e9ac4, 0x38b06299 }, { 0x38d56d05, 0xb98a0da7 }, { 0x370aa79a, 0xb9a45ffb },
    { 0xb903ced6, 0x38ad3c3f }, { 0x39275027, 0x38131f39 }, { 0x3918f35f, 0xb75836f1 },
    { 0xb8a72d29, 0x3842374c }, { 0x38956a0c, 0xb79b866c }, { 0xb82c7b38, 0xb62cc279 },
    { 0x38afc8a6, 0x396a1c13 }, { 0x3851ff25, 0x3899977c }, { 0xb7c764c8, 0x350aeb85 },
    { 0x380c8738, 0xb66d2bdd }, { 0x3661c1be, 0x36eee243 }, { 0xb7782f74, 0xb70b4245 },
    { 0x37287bd3, 0xb7391cfb }, { 0xb825e296, 0x37fe61fe }, { 0x3a0af92d, 0x3a3c50ac },
    { 0xba25832c, 0xba5d2f10 }, { 0x3895da59, 0xb83396d3 }, { 0xb9086af9, 0xb8b2328e },
    { 0x381783be, 0x394a1e60 }, { 0xb7d3618b, 0x38a6fc76 }, { 0xb9dc6a2d, 0xb9a66058 },
    { 0x381337f4, 0x392a688b }, { 0xb927e379, 0xb996c97c }, { 0xb60a491c, 0x377a55ac },
    { 0xb8186b30, 0xb8c3f014 }, { 0x391f8e93, 0x390410a7 }, { 0x3826e629, 0x37a8ba89 },
    { 0x37ac0629, 0xb690a843 }, { 0xb781a8a2, 0x3805e23f }, { 0xb72afac6, 0x38a2c77e },
    { 0x38d559f4, 0xb984c581 }, { 0x376e2729, 0xb99bf539 }, { 0xb8f64688, 0x389fe29d },
    { 0x391dcad3, 0x37e2da5c }, { 0x390c2819, 0xb78c6889 }, { 0xb8988e76, 0x383ab917 },
    { 0x38845cfe, 0xb76cc815 }, { 0xb81b2a99, 0xb5828be4 }, { 0x38a03031, 0x39577002 },
    { 0x383adcf1, 0x38879919 }, { 0xb7abb0e5, 0x359a6d70 }, { 0x37f3c835, 0xb5aed757 },
    { 0x35fe398c, 0x36a7b32f }, { 0xb7731226, 0xb6d82bd0 }, { 0x3716d151, 0xb71e52a0 },
    { 0xb80f2d6c, 0x37e9d0f8 }, { 0x3a02d951, 0x3a314e7d }, { 0xba1c544e, 0xba4f20ce },
    { 0x388dd463, 0xb812d14c }, { 0xb8fa6c7c, 0xb8a51c4d }, { 0x3804567f, 0x393c739f },
    { 0xb7bdeb63, 0x389afffd }, { 0xb9cea562, 0xb99ea1c7 }, { 0x380c3601, 0x3920d1f4 },
    { 0xb920a590, 0xb98c6cd6 }, { 0x358de16d, 0x37556a0c }, { 0xb8139724, 0xb8b65e2a },
    { 0x39148091, 0x38fa77f0 }, { 0x381737ec, 0x37ab71bd }, { 0x379bd200, 0xb6681c9e },
    { 0xb7635c46, 0x37fa4146 }, { 0xb70f680c, 0x3897dc9f }, { 0x38d3198e, 0xb97ff00e },
    { 0x3794227a, 0xb994b63e }, { 0xb8e91893, 0x3893b32b }, { 0x3915eb1d, 0x37b83609 },
    { 0x3901a586, 0xb7991e95 }, { 0xb88dbb33, 0x3834f923 }, { 0x38703c89, 0xb7479b11 },
    { 0xb80e5a01, 0x35637e69 }, { 0x38957f78, 0x39492329 }, { 0x382a7054, 0x3875cc4d },
    { 0xb798e647, 0x35e6d9d4 }, { 0x37dc1f85, 0x346239de }, { 0x3547d191, 0x365dd787 },
    { 0xb7709279, 0xb6b34ea5 }, { 0x3708f8f3, 0xb70ab147 }, { 0xb7fbbf1b, 0x37d69e7a },
    { 0x39f7c5f3, 0x3a285a5d }, { 0xba14f869, 0xba439c18 }, { 0x38876c68, 0xb7f719d9 },
    { 0xb8e8d431, 0xb89b91d8 }, { 0x37e711b2, 0x3930f5fd }, { 0xb7aba8d3, 0x38913efa },
    { 0xb9c3a0f6, 0xb99826a4 }, { 0x3805ad8c, 0x3919064a }, { 0xb91a0def, 0xb98450dc },
    { 0x366e2136, 0x3738a2bf }, { 0xb80caebd, 0xb8ab991d }, { 0x390c0b4c, 0x38ee72bc },
    { 0x380b4372, 0x37aaa6f1 }, { 0x378f33e9, 0xb63deba8 }, { 0xb74d5029, 0x37ec4c07 },
    { 0xb6f54884, 0x388f2814 }, { 0x38d00f1a, 0xb977d8ca }, { 0x37a3b788, 0xb98ef60d },
    { 0xb8df8f40, 0x3889a831 }, { 0x390f9679, 0x379c059e }, { 0x38f266fb, 0xb79c3d1e },
    { 0xb8862c9c, 0x382f59a6 }, { 0x385e0ea9, 0xb72d77fe }, { 0xb8049cdc, 0x3625437e },
    { 0x388dc0e3, 0x393e3747 }, { 0x381f5069, 0x3863e0b4 }, { 0xb78ca4aa, 0x36139a01 },
    { 0x37cc2d59, 0x35a74498 }, { 0xb4688b9e, 0x36107541 }, { 0xb7708eb5, 0xb69e16ad },
    { 0x36f96fb5, 0xb6f93a0a }, { 0xb7e17493, 0x37c6ff7e }, { 0x39ece002, 0x3a2112b9 },
    { 0xba0f1170, 0xba3ab830 }, { 0x3880fad8, 0xb7d2bdc3 }, { 0xb8d9bce3, 0xb8938160 },
    { 0x37d0578d, 0x3927e0f9 }, { 0xb79ff82d, 0x3889bcc0 }, { 0xb9bab836, 0xb992d2c9 },
    { 0x37fd5906, 0x3912e53b }, { 0xb9149f30, 0xb97b0ba8 }, { 0x36bee119, 0x372838cf },
    { 0xb80647af, 0xb8a37c94 }, { 0x3905aab1, 0x38e4b41f }, { 0x3801f4f4, 0x37a896b3 },
    { 0x37844586, 0xb6243a0f }, { 0xb73da677, 0x37e0c498 }, { 0xb6db5fb7, 0x3888923d },
    { 0x38cc73a6, 0xb97155e6 }, { 0x37ac283d, 0xb98a7600 }, { 0xb8d8f7a7, 0x38815127 },
    { 0x390aa62d, 0x37884aaa }, { 0x38e52402, 0xb79a8701 }, { 0xb880c8ba, 0x3829083d },
    { 0x38509180, 0xb7140b17 }, { 0xb7fb112f, 0x3680615b }, { 0x38882c4c, 0x3935d5f9 },
    { 0x3817f2d1, 0x3857089b }, { 0xb784ca3b, 0x362e73c4 }, { 0x37c14071, 0x35ff31de },
    { 0xb592cf23, 0x35d1a1de }, { 0xb771f104, 0xb6930617 }, { 0x36e6a5c7, 0xb6e18592 },
    { 0xb7ccaf63, 0x37bab06a }, { 0x39e4e5f5, 0x3a1b49ed }, { 0xba0a3613, 0xba33f3d9 },
    { 0x3875cb5f, 0xb7b7a004 }, { 0xb8cd8cb5, 0xb88c8b19 }, { 0x37c115d9, 0x39210626 },
    { 0xb79be964, 0x3882ef39 }, { 0xb9b39b75, 0xb98e7a2a }, { 0x37ef55ec, 0x390e2173 },
    { 0xb910f9ad, 0xb96fb858 }, { 0x36f79e95, 0x37208974 }, { 0xb80119f6, 0xb89dcf44 },
    { 0x3900faa2, 0x38dd74d5 }, { 0x37f54890, 0x37a5b35f }, { 0x37761901, 0xb617930b },
    { 0xb73186a7, 0x37d6e47c }, { 0xb6cba7bc, 0x3883bcf4 }, { 0x38c8e976, 0xb96c9a47 },
    { 0x37b36879, 0xb986fffc }, { 0xb8d4d335, 0x3873e248 }, { 0x3906d21e, 0x377326db },
    { 0x38db3f39, 0xb797de7d }, { 0xb8791fa7, 0x3823164c }, { 0x384743a0, 0xb6fc99c0 },
    { 0xb7f2c602, 0x36a380b9 }, { 0x3884ee04, 0x392fbea1 }, { 0x381344d7, 0x384e2b4d },
    { 0xb77e56e9, 0x3643e199 }, { 0x37ba03e3, 0x3624c434 }, { 0xb5fd44f8, 0x35a4060e },
    { 0xb7759262, 0xb68c7ebd }, { 0x36d9d7f7, 0xb6cbd68a }, { 0xb7bc0353, 0x37b07a83 },
    { 0x39deda6e, 0x3a17241a }, { 0xba0690f5, 0xba2ea071 }, { 0x386e3c7f, 0xb7a319e6 },
    { 0xb8c5af2f, 0xb887e211 }, { 0x37b0a45c, 0x391bcfdf }, { 0xb798d73b, 0x3879b6fb },
    { 0xb9ae60fc, 0xb98b2f8d }, { 0x37e413cf, 0x390ac169 }, { 0xb90ef664, 0xb967e16b },
    { 0x37120892, 0x37195568 }, { 0xb7f97c98, 0xb89a1d68 }, { 0x38fb147b, 0x38d85cd7 },
    { 0x37ea5583, 0x37a29386 }, { 0x3768f176, 0xb61106ac }, { 0xb729615b, 0x37cea985 },
    { 0xb6bc2e70, 0x388038bf }, { 0x38c622ff, 0xb9699499 }, { 0x37b9cb64, 0xb9848944 },
    { 0xb8d26d9e, 0x3866a0b9 }, { 0x3903f462, 0x375e7ce1 }, { 0x38d3ec39, 0xb795bd16 },
    { 0xb872c120, 0x381d79ae }, { 0x38413c88, 0xb6e30d0a }, { 0xb7ee8f27, 0x36c1dfb2 },
    { 0x38835f15, 0x392b7b02 }, { 0x3810d11a, 0x384843a6 }, { 0xb775f0da, 0x365277d7 },
    { 0x37b5c1d2, 0x3650a9fb }, { 0xb634886d, 0x357a1737 }, { 0xb77ce285, 0xb687840d },
    { 0x36d05ec8, 0xb6b968be }, { 0xb7aec7dd, 0x37a806b9 }, { 0x39da8d60, 0x3a141585 },
    { 0xba042e6f, 0xba2b0504 }, { 0x38689c2e, 0xb78fa38e }, { 0xb8bfc7d6, 0xb885414b },
    { 0x37a5b635, 0x3918124f }, { 0xb796f25c, 0x3871153b }, { 0xb9aad26f, 0xb9891214 },
    { 0x37dab5eb, 0x3908cd95 }, { 0xb90d99fb, 0xb96234bd }, { 0x3727f06a, 0x37148d62 },
    { 0xb7f2ad6d, 0xb897c0c2 }, { 0x38f66ab3, 0x38d4fbe5 }, { 0x37e28c59, 0x37a04873 },
    { 0x375ff76c, 0xb60a32ce }, { 0xb7249963, 0x37c780a6 }, { 0xb6b360aa, 0x387bb7a2 },
    { 0x38c4c813, 0xb967d84f }, { 0x37bcefd9, 0xb9832edd }, { 0xb8d1b414, 0x385ca55c },
    { 0x3902610c, 0x374e6767 }, { 0x38ce560a, 0xb793c82e }, { 0xb86fc3de, 0x3817ed35 },
    { 0x383d196f, 0xb6cb8580 }, { 0xb7ecf851, 0x36dcc3b5 }, { 0x38828c20, 0x3928a459 },
    { 0x38102518, 0x3844768b }, { 0xb7711d45, 0x3660059b }, { 0x37b3ffa1, 0x3675af2a },
    { 0xb66d48eb, 0x35436eef }, { 0xb78328b0, 0xb6834e25 }, { 0x36c59b4d, 0xb6ad935b },
    { 0xb7a4dd21, 0x37a171b6 }, { 0x39d80990, 0x3a122053 }, { 0xba02ea55, 0xba290f9e },
    { 0x38644325, 0xb78105d2 }, { 0xb8bb78cf, 0xb883feb1 }, { 0x37a13713, 0x3916111b },
    { 0xb796820d, 0x386b1b5c }, { 0xb9a8c2d2, 0xb98812c2 }, { 0x37d3811f, 0x39082f0b },
    { 0xb90d0286, 0xb95e041d }, { 0x373ab2cb, 0x3711190b }, { 0xb7ed68d0, 0xb8967fd5 },
    { 0x38f38e9e, 0x38d2f8cf }, { 0x37dd76cb, 0x379f4614 }, { 0x375a3bdb, 0xb60a38ee },
    { 0xb721c8b4, 0x37c25715 }, { 0xb6b32196, 0x3878b8bb }, { 0x387f66e7, 0xb914b41a },
    { 0x376a8805, 0xb92884af }, { 0xb887758e, 0x3809d3ae }, { 0x38a701c1, 0x36f70160 },
    { 0x3882821b, 0xb73c4072 }, { 0xb81a2cb1, 0x37be4624 }, { 0x37ec8626, 0xb654ae44 },
    { 0xb79889df, 0x36a02220 }, { 0x3826e493, 0x38d71021 }, { 0x37b97876, 0x37f93ba3 },
    { 0xb71af8b6, 0x3617b229 }, { 0x37696eb5, 0x36297341 }, { 0xb638f38c, 0x34b46495 },
    { 0xb72e9657, 0xb6258c1b }, { 0x3672ca56, 0xb65a50cf }, { 0xb74a1dab, 0x3749a517 },
    { 0x39912c6a, 0x39c1b8c5 }, { 0xb9ad5284, 0xb9e2061e }, { 0x381153b4, 0xb727fca6 },
    { 0xb873cc5f, 0xb82c6ffa }, { 0x37656072, 0x38c93e06 }, { 0xb7553cd2, 0x381a4ccc },
    { 0xb96013ac, 0xb9357f49 }, { 0x37876fb3, 0x38b61207 }, { 0xb8be9758, 0xb910cd2e },
    { 0x3704a1c2, 0x36d1ea5b }, { 0xb79d265d, 0xb8492ebc }, { 0x38a235f3, 0x388ce066 },
    { 0x3792133a, 0x3754eea2 }, { 0x370e8b66, 0xb5d302c5 }, { 0xb6d2ee4e, 0x378022cb },
    { 0xb68426fc, 0x38256def } };

static const unsigned int DECMTX_FOURTH[HYBRID_BANDS * NUM_EARS * (SH_ORDER_FOURTH + 1)
    * (SH_ORDER_FOURTH + 1)][2] = { { 0x3f8b6524, 0x00000000 }, { 0x3cef5009, 0x00000000 },
    { 0x3bf3ba37, 0x00000000 }, { 0x3b1c3bd4, 0x00000000 }, { 0x3a02f718, 0x00000000 },
    { 0x3a7f13af, 0x00000000 }, { 0x396c4c9a, 0x00000000 }, { 0xb8fb8dce, 0x00000000 },
    { 0xbad02a88, 0x00000000 }, { 0x3939cb77, 0x00000000 }, { 0xb97ad53d, 0x00000000 },
    { 0xb93d3ef7, 0x00000000 }, { 0xb8b26f1e, 0x00000000 }, { 0xb99e85c3, 0x00000000 },
    { 0x39c2890e, 0x00000000 }, { 0xb91ced2c, 0x00000000 }, { 0xb7791053, 0x00000000 },
    { 0xb82bdde5, 0x00000000 }, { 0xb827f39c, 0x00000000 }, { 0x3854e0bd, 0x00000000 },
    { 0xb86c6a97, 0x00000000 }, { 0x382381e7, 0x00000000 }, { 0xb93ab921, 0x00000000 },
    { 0xb7da02d9, 0x00000000 }, { 0xb897d9b2, 0x00000000 }, { 0x3f8b0f12, 0x00000000 },
    { 0xbd0c7245, 0x00000000 }, { 0x3c044e5d, 0x00000000 }, { 0x3ba3a56a, 0x00000000 },
    { 0xba3bc875, 0x00000000 }, { 0xbabc51c3, 0x00000000 }, { 0x395d5f5b, 0x00000000 },
    { 0x3a120d91, 0x00000000 }, { 0xba131b1a, 0x00000000 }, { 0xb98add63, 0x00000000 },
    { 0x391ec94b, 0x00000000 }, { 0x38771b1e, 0x00000000 }, { 0xb84b70ce, 0x00000000 },
    { 0xb99e859e, 0x00000000 }, { 0x39bcbc46, 0x00000000 }, { 0x383534f9, 0x00000000 },
    { 0x37a44062, 0x00000000 }, { 0x373489d2, 0x00000000 }, { 0xb87b5fac, 0x00000000 },
    { 0xb873afa8, 0x00000000 }, { 0xb8b8292a, 0x00000000 }, { 0x3899b463, 0x00000000 },
    { 0xb9124aec, 0x00000000 }, { 0xb7a88bb7, 0x00000000 }, { 0xb86ab6e6, 0x00000000 },
    { 0x3f876b73, 0xbad11799 }, { 0x3d68576e, 0x3e707c40 }, { 0x3ce34c82, 0x3caab3cc },
    { 0x3bc35157, 0x3caa9c74 }, { 0xba6685ad, 0x3a889ad1 }, { 0x3a8204b0, 0xbb7f127d },
    { 0x3c19bafd, 0xbca07622 }, { 0x3ad1612d, 0xbb2dad3f }, { 0x3bd8da71, 0xbb9d9bf9 },
    { 0x39957c06, 0x39c6d555 }, { 0xb8986fa9, 0xb92a2a6d }, { 0xb9d35039, 0x399387c9 },
    { 0xbb4e1bb5, 0x3b042769 }, { 0xba03e1d3, 0xb91997c5 }, { 0x390ec05a, 0x3a013cf8 },
    { 0xb81c1001, 0xb8f3a0aa }, { 0x375d14a1, 0xb811509f }, { 0xb90b95a5, 0xb7e5eede },
    { 0x36a68da3, 0xb843dabd }, { 0xb88b1fab, 0x394c6b4d }, { 0x38f88268, 0xb65914e6 },
    { 0x38390f1b, 0x383447c9 }, { 0xb99a45e6, 0xb8613db9 }, { 0xb89a005f, 0x378fcbe5 },
    { 0xb8da9c1b, 0x37c21a33 }, { 0x3f862043, 0x3a363c0b }, { 0xbd7c3f50, 0xbe85258b },
    { 0x3ce7fa3b, 0x3cc48d31 }, { 0x3c1bb48a, 0x3cfc9761 }, { 0x3b06a7e2, 0xbb000048 },
    { 0xba81ddb1, 0x3b870153 }, { 0x3c185389, 0xbc9dca01 }, { 0x3b1d1247, 0xbb290c2b },
    { 0x3bf8016d, 0xbb8c235e }, { 0xb9b728e2, 0xb9aed922 }, { 0xb892a0a4, 0x387ab829 },
    { 0x39a2a656, 0xb9de700d }, { 0xbb4a249f, 0x3b11b760 }, { 0xba14df1f, 0xb8cc8914 },
    { 0x387943f7, 0x39a9f9a5 }, { 0x390bf68d, 0x38cb4979 }, { 0xb7b0deb5, 0x3710c43f },
    { 0x3905f973, 0xb8226c10 }, { 0xb89a6631, 0xb70735b5 }, { 0x388c1703, 0xb9495c60 },
    { 0x3862ecf8, 0xb8c85097 }, { 0x386361bd, 0x38d19150 }, { 0xb99b4d9a, 0x37395ca1 },
    { 0xb8676198, 0x36e9ad24 }, { 0xb914c026, 0x3638c72f }, { 0x3f7e8df9, 0x3bfbf8ac },
    { 0x3db9789d, 0x3ed2d775 }, { 0x3d4e5427, 0xbad6678c }, { 0x3c85783b, 0x3d059833 },
    { 0xbbab52b9, 0x3b4a48b5 }, { 0xbb9088da, 0xbc38fd4c }, { 0x3c2bcaa0, 0xbd33f05b },
    { 0x3b419871, 0xbc21b8e7 }, { 0x3cd34a1a, 0xbc14163d }, { 0x3aadc02c, 0x3a914905 },
    { 0x388caf2e, 0xb9c67af5 }, { 0xb908089d, 0x3b6daed0 }, { 0xbbdc7151, 0x3c3ced56 },
    { 0xbb326e30, 0x39cadf28 }, { 0x3aed40ef, 0xb7b28d61 }, { 0x3a0fca17, 0xb8c37e07 },
    { 0xb7ae8b41, 0xb7323ec2 }, { 0xb6908ec7, 0xb9797dbd }, { 0xb89a8662, 0xb8aa39b2 },
    { 0x3a31f4b5, 0xba184c47 }, { 0x3b31804d, 0xbae00eb1 }, { 0x398c9774, 0x39947599 },
    { 0xb9c35194, 0xba0bb5b6 }, { 0xb83e4734, 0xb8dd104e }, { 0x38a64a57, 0xb83a09e2 },
    { 0x3f7b6849, 0x3c638f82 }, { 0xbdba6bcb, 0xbedd942b }, { 0x3d52c98e, 0x3b93ead3 },
    { 0x3cb039a1, 0x3d4ae53a }, { 0x3be773ed, 0xbb8564fb }, { 0x3bbb5e1c, 0x3c2ce862 },
    { 0x3c31546b, 0xbd305fe9 }, { 0x3b4414b7, 0xbc27c655 }, { 0x3cdb807a, 0xbc03ccf1 },
    { 0xbab24553, 0xba8590e0 }, { 0xb88cf5e0, 0x38f4533f }, { 0x3784fbcc, 0xbb82b21a },
    { 0xbbd00b43, 0x3c3d75c4 }, { 0xbb4ee0ca, 0x3a26a683 }, { 0x3ad7b4c3, 0xb9bc978f },
    { 0x3a19b10c, 0x39757010 }, { 0x389dcfad, 0xb82b8588 }, { 0xb88aec59, 0x392c6318 },
    { 0x37828616, 0x3721c10d }, { 0xba3b4802, 0x3a24e1d1 }, { 0x3b2f0c00, 0xbaf6febe },
    { 0x39cde672, 0x39b014f4 }, { 0xb9aa8673, 0xb9d83f6a }, { 0x36c1c557, 0xb908b610 },
    { 0x384bf25b, 0xb909cac1 }, { 0x3f6cb4f8, 0x3cc85d6b }, { 0x3dec091b, 0x3f044619 },
    { 0x3d42c81e, 0xbcdedb34 }, { 0x3cbacb85, 0x3d087a04 }, { 0xbbff3b3a, 0x3b93bb87 },
    { 0xbc4396fe, 0xbc3b8ade }, { 0x3c198a25, 0xbd611222 }, { 0x3a04f766, 0xbc852719 },
    { 0x3d2bc807, 0xbc3ed2cf }, { 0x3ac243b7, 0x3b0aac43 }, { 0x3a054e3a, 0xba14146d },
    { 0x3b490459, 0x3bf3cd7a }, { 0xbb9f0904, 0x3c933380 }, { 0xbb8a8c8a, 0x3b22cace },
    { 0x3af6fe66, 0xba1e81e8 }, { 0x3a6d7aaa, 0xb9718c3a }, { 0x3782bcfb, 0xb59bd26e },
    { 0xb9b04ec0, 0xb9af44b7 }, { 0xb80393c4, 0xb8f28d23 }, { 0x38268627, 0xbad87b24 },
    { 0x3b21130a, 0xbb980450 }, { 0x3a4a0302, 0x39e44bf3 }, { 0xba839e3e, 0xba4975c5 },
    { 0xb98de512, 0xb978edc1 }, { 0x390a62be, 0xb84ac2fb }, { 0x3f6a4786, 0x3cfd8940 },
    { 0xbde5af35, 0xbf07e310 }, { 0x3d4bf0fb, 0xbc9eac39 }, { 0x3cee074f, 0x3d5b9d20 },
    { 0x3c3bd071, 0xbbb89fd6 }, { 0x3c543c76, 0x3c1d558d }, { 0x3c256d8f, 0xbd5d7234 },
    { 0xba020783, 0xbc8889df }, { 0x3d2f3ed2, 0xbc26093e }, { 0xbab97929, 0xbafa4183 },
    { 0xba34383c, 0x38d94862 }, { 0xbb50fc59, 0xbbfb388b }, { 0xbb9b157b, 0x3c926d9a },
    { 0xbb9f723f, 0x3b4a5a7d }, { 0x3abbdbed, 0xba855c85 }, { 0x3a59aa62, 0x3a180f3a },
    { 0x38892807, 0xb83db11c }, { 0x39a20f0e, 0x3977ae52 }, { 0x38063e74, 0x386192e6 },
    { 0xb8c5daba, 0x3ad9d7f1 }, { 0x3b1b9b74, 0xbb9b98c3 }, { 0x3a60cec4, 0x39f03f84 },
    { 0xba829518, 0xba0a15c9 }, { 0xb972ac15, 0xb98a8d19 }, { 0xb80d77f4, 0xb9280d7d },
    { 0x3f508a7b, 0x3dad470a }, { 0x3e1718b9, 0x3f278221 }, { 0x3c4a935d, 0xbd647fd2 },
    { 0x3cbe1619, 0x3cefda0e }, { 0xbc721949, 0x3bd9eeb6 }, { 0xbc80423a, 0xbb5424f1 },
    { 0x3ba6a27d, 0xbd7ea9bb }, { 0xbc1fcd97, 0xbcb4655f }, { 0x3da0914d, 0xbc5db660 },
    { 0x3b1a1964, 0x3bb4d154 }, { 0x3a832f74, 0xbae15df9 }, { 0x3c4531bc, 0x3bfc29fb },
    { 0xbb080423, 0x3cd739c9 }, { 0xbb91d929, 0x3beffa3e }, { 0x3b5964eb, 0xbb4ccb2c },
    { 0x3ad15de3, 0x37251971 }, { 0xb823263d, 0x37eb52c0 }, { 0xb9a699e0, 0x39106c1c },
    { 0xb96e1239, 0xb9f008cb }, { 0xbaceda01, 0xbb3ece14 }, { 0x398207a1, 0xbbb3e6da },
    { 0x3b00ef84, 0xb90178e8 }, { 0xbb0b79ae, 0xba1eead1 }, { 0xba3ee87f, 0xb95445b3 },
    { 0x3a203e0c, 0xb906fc8f }, { 0x3f4ef562, 0x3db9d3b4 }, { 0xbe103dc4, 0xbf2937c7 },
    { 0x3c890fb1, 0xbd421db7 }, { 0x3cf6dfde, 0x3d5e7dac }, { 0x3c9d1d42, 0xbc0e3c0e },
    { 0x3c832641, 0x3abff02c }, { 0x3bce13c3, 0xbd7d66b7 }, { 0xbc4c2d47, 0xbcae1484 },
    { 0x3da39001, 0xbc334807 }, { 0xbafb4d01, 0xbbabd30e }, { 0xbad5bb5a, 0x3ad76a65 },
    { 0xbc3cb43d, 0xbbff3ba9 }, { 0xbb0ec2c3, 0x3cdada3b }, { 0xbbace244, 0x3c0b3f62 },
    { 0x3b1da8ae, 0xbb47f49e }, { 0x3ac109f9, 0x3a5719c7 }, { 0x39984610, 0xb8151140 },
    { 0x39827925, 0xb9a1c7da }, { 0x39b1dd0f, 0x3a0b9be6 }, { 0x3ab4c487, 0x3b44c00e },
    { 0x3a03dd5e, 0xbbb3a549 }, { 0x3b0a380f, 0x37ab3f33 }, { 0xbaedd5ef, 0xb8f5262d },
    { 0xba196003, 0xb8ca0457 }, { 0x39c5d799, 0xb914eb7e }, { 0x3f3e350e, 0x3dfd1108 },
    { 0x3e35b69a, 0x3f387b0e }, { 0xbcaafde7, 0xbd63e148 }, { 0x3c97b27f, 0x3ce6a97d },
    { 0xbc981a86, 0x3c20a7dc }, { 0xbc394aa6, 0xbb1ceaa2 }, { 0x3bdee94e, 0xbd5cf143 },
    { 0xbc882548, 0xbca88130 }, { 0x3dda6b7d, 0xbc95b76a }, { 0x3b2eab78, 0x3c06b180 },
    { 0x3a1c283b, 0xbb13a9c2 }, { 0x3c6a1311, 0x3ba472e4 }, { 0x3b085eef, 0x3d082c12 },
    { 0xbb47ee44, 0x3c2b39ed }, { 0x3ab3fda8, 0xbbc464ef }, { 0x3b16b7f4, 0xb9a3e12d },
    { 0xb582ee8f, 0x39095be9 }, { 0xb93c79d0, 0x38f497bd }, { 0xba1f1821, 0xba056d20 },
    { 0xbb70045b, 0xbb67d522 }, { 0x3a8c838d, 0xbbb34a3f }, { 0x3b196037, 0xba85ed30 },
    { 0xbb4d5ea2, 0xb5e233e2 }, { 0xba930523, 0xb878c200 }, { 0x3a6839bf, 0xb9b5abac },
    { 0x3f3cba28, 0x3e057535 }, { 0xbe2e5a3b, 0xbf39bc46 }, { 0xbc8468cb, 0xbd43747f },
    { 0x3cd9ebc9, 0x3d60604c }, { 0x3cc3d886, 0xbc234ca2 }, { 0x3c3e6de3, 0x3a8b4ee8 },
    { 0x3bff29e6, 0xbd5cdc71 }, { 0xbca0a85c, 0xbc9d8189 }, { 0x3dde0f14, 0xbc7768b4 },
    { 0xbb0316ff, 0xbc0283e0 }, { 0xbab9d469, 0x3b36bb40 }, { 0xbc5c3de1, 0xbbb0a014 },
    { 0x3b0218ed, 0x3d0a992f }, { 0xbb857561, 0x3c4514f8 }, { 0x39d44d84, 0xbbb4af83 },
    { 0x3a79e50f, 0x3aa54e81 }, { 0x39de227c, 0xb94c6339 }, { 0x390abf30, 0xb98ebfbd },
    { 0x3a91c2a0, 0x3a4cb85e }, { 0x3b672e12, 0x3b750f6b }, { 0x3ac6e397, 0xbbb8bf21 },
    { 0x3b29407e, 0xba66e7e1 }, { 0xbb2a3327, 0x39cb73a5 }, { 0xba5334e9, 0xb78e09ac },
    { 0x3a17dda8, 0xb9d4942c }, { 0x3f1f3d32, 0x3e615f7a }, { 0x3e3f7c60, 0x3f45c525 },
    { 0xbd7d2529, 0xbcdccf09 }, { 0x3be90b8d, 0x3d01cd82 }, { 0xbcc7a9e9, 0x3c2d26d1 },
    { 0xbc02a0e3, 0xbc32ac8a }, { 0x3d0ae5d6, 0xbd0eaf92 }, { 0xbcbcce70, 0xbc906721 },
    { 0x3e1fe93b, 0xbc970f9d }, { 0x3b06a9bc, 0x3c791ae8 }, { 0x3aad6b2e, 0xbb10d554 },
    { 0x3c63c5ec, 0x3b85d5c8 }, { 0x3c494fea, 0x3d2961c9 }, { 0xb881048f, 0x3c734a79 },
    { 0xbb2f2c50, 0xbbed76bd }, { 0x3ab9294f, 0xb9d55370 }, { 0x3873109f, 0x3932e93f },
    { 0x38ef7845, 0x3a22c508 }, { 0xba8ba49a, 0xba0eb30c }, { 0xbbe641e0, 0xbb4a4a6b },
    { 0x3b0f6573, 0xbc12d25c }, { 0x3b1d64e1, 0xbaf33f4f }, { 0xbb8420fe, 0x3af7802b },
    { 0xbade508b, 0x3a2a3855 }, { 0x3ad277a5, 0xba143cdb }, { 0x3f1d3636, 0x3e67fba1 },
    { 0xbe37dc15, 0xbf467a93 }, { 0xbd6995e7, 0xbc9e4c55 }, { 0x3c3aaf82, 0x3d6b1592 },
    { 0x3d0c75d7, 0xbc0c086d }, { 0x3c0df0b9, 0x3c409eb7 }, { 0x3d0df597, 0xbd0c2a5f },
    { 0xbcea7151, 0xbc810787 }, { 0x3e2214c2, 0xbc5a93cb }, { 0xba4df952, 0xbc783d5f },
    { 0xbacf1f27, 0x3ba1304b }, { 0xbc4f5270, 0xbb900056 }, { 0x3c3b4a2b, 0x3d2d29fe },
    { 0xbad69235, 0x3c8f90b1 }, { 0xbb804ba9, 0xbbc4941a }, { 0x3a33d46f, 0x3b80a3c2 },
    { 0x3a01bb98, 0xb9b3719f }, { 0xb91a12ca, 0xba69eca4 }, { 0x3b2bfed6, 0x397c8946 },
    { 0x3be75826, 0x3b55e9d1 }, { 0x3b330c09, 0xbc151402 }, { 0x3b35d388, 0xbad7bbfd },
    { 0xbb59cd20, 0x3b124bc0 }, { 0xbab96966, 0x3a145045 }, { 0x3a8eec4a, 0xb9efeeb3 },
    { 0x3f14a7e7, 0x3e9d41c0 }, { 0x3e3d41f5, 0x3f5179c6 }, { 0xbd96d967, 0x3af6383a },
    { 0x3886073e, 0x3d1e5bf5 }, { 0xbd005b38, 0x3c4cf62d }, { 0xbc1d40f2, 0xbcaf5ead },
    { 0x3d88841e, 0xbce07464 }, { 0xbcf35f7a, 0xbc78df7c }, { 0x3e52ef63, 0xbcacc8b5 },
    { 0x3aec8a1f, 0x3cb4ba8d }, { 0x3b17c0ef, 0xbb8e4087 }, { 0x3c2c4a64, 0x3b578ee2 },
    { 0x3cbb75da, 0x3d40a93a }, { 0x3b5b241a, 0x3c98b93e }, { 0xbbfbb6e8, 0xbc114f5c },
    { 0x3a653569, 0x3ab8608e }, { 0x3867a7a8, 0x3964b5ed }, { 0x3a8c58f3, 0x39d0be47 },
    { 0xbaea700d, 0xba51f778 }, { 0xbc27abbb, 0xbb300d90 }, { 0x3a7d730e, 0xbc3bf267 },
    { 0x3b45fe18, 0xbb1e44d0 }, { 0xbb9d2ad6, 0x3b797dce }, { 0xbaff9934, 0x3ab37004 },
    { 0x3b118ebf, 0xba8385fb }, { 0x3f11e432, 0x3ea0b418 }, { 0xbe33fa39, 0xbf519e80 },
    { 0xbd8d11db, 0x3c08ad0b }, { 0xb9efdc26, 0x3d8d53f0 }, { 0x3d3868db, 0xbc0df452 },
    { 0x3c491c9a, 0x3cc62e1c }, { 0x3d89e6f7, 0xbcdaee10 }, { 0xbd168a22, 0xbc238092 },
    { 0x3e55bc9f, 0xbc7092a9 }, { 0xb95cda51, 0xbcb79d14 }, { 0xb9bc691a, 0x3c058d1a },
    { 0xbc08416b, 0xbb6aa02b }, { 0x3caeb746, 0x3d487dc4 }, { 0x3af11f50, 0x3cbab709 },
    { 0xbc106b1c, 0xbbdabdc5 }, { 0x3a184ee0, 0x3bb27059 }, { 0x3a0f4be8, 0xb987e6c6 },
    { 0xba97c875, 0xba2804f5 }, { 0x3b6507d6, 0xb9f51311 }, { 0x3c2a97ae, 0x3b39f4ec },
    { 0x3aee562d, 0xbc3cbb20 }, { 0x3b7269d2, 0xbb0dff96 }, { 0xbb7c32e6, 0x3b843dd5 },
    { 0xbad3346e, 0x3aacb32a }, { 0x3ae27e99, 0xba51536a }, { 0x3f0b5466, 0x3ebe7d47 },
    { 0x3e658f00, 0x3f51e5df }, { 0xbd85627f, 0x3d214eff }, { 0xbbe1e22c, 0x3d48678c },
    { 0xbd17e948, 0x3c94737a }, { 0xbcf13275, 0xbd196764 }, { 0x3e02cfb8, 0xbd1da355 },
    { 0xbd0f5d0c, 0x39837de1 }, { 0x3e8e0e69, 0xbd5b3a5f }, { 0x3b613a60, 0x3d0e4478 },
    { 0xbae8e902, 0xbbf34d03 }, { 0xbb7932ce, 0x3c60803f }, { 0x3d3e4b02, 0x3d205219 },
    { 0x3c5e60dd, 0x3cae9be4 }, { 0xbc9c0563, 0xba6da7d6 }, { 0x3ac2932a, 0x3b89a418 },
    { 0x3901d68e, 0x38fbc262 }, { 0x3ab35c2c, 0xbaa29cf0 }, { 0xbb7b648b, 0x39368244 },
    { 0xbc7c61d7, 0x3b4b2775 }, { 0xbadf7de3, 0xbc628486 }, { 0x3b6dd04c, 0xbba17e33 },
    { 0xbb48f700, 0x3c1fbea3 }, { 0xbabdd1c1, 0x3b3ceadd }, { 0x3b464c08, 0xbac3a48d },
    { 0x3f07eab3, 0x3ec32e12 }, { 0xbe5837a0, 0xbf512677 }, { 0xbd815f2e, 0x3d33959a },
    { 0xbb3d6078, 0x3daf9f3d }, { 0x3d72aa27, 0xbc5b937f }, { 0x3d150e5f, 0x3d2573e8 },
    { 0x3e0191ee, 0xbd176663 }, { 0xbd1dfd19, 0x3c16ae68 }, { 0x3e8fe35b, 0xbd36f69a },
    { 0xbac72af7, 0xbd11b1fe }, { 0x3bdb4fa3, 0x3c21102d }, { 0x3bfb2ceb, 0xbc7a029b },
    { 0x3d382a6a, 0x3d31648d }, { 0x3c677ed8, 0x3cdbf05b }, { 0xbc9cf5a6, 0x3ae581b5 },
    { 0xbab2f299, 0x3c27603b }, { 0x3a987d39, 0x38f57f07 }, { 0xbabbded2, 0x3a8d1d54 },
    { 0x3b9bc33a, 0xbb14c2e0 }, { 0x3c815518, 0xbb5a5a4d }, { 0xb972359c, 0xbc665272 },
    { 0x3ba01e66, 0xbbae241a }, { 0xbb0a017c, 0x3c1cd62b }, { 0xbaa48284, 0x3b2a5f39 },
    { 0x3b1b4e01, 0xbaa2e8d0 }, { 0x3edc138d, 0x3ee062a8 }, { 0x3e08840c, 0x3f4279d6 },
    { 0xbd3764eb, 0x3d4b72c1 }, { 0xbc77b3a1, 0x3d7e7442 }, { 0xbd3a84ac, 0x3c9d4252 },
    { 0xbd6bd8ba, 0xbce5898b }, { 0x3e31c075, 0xbd985d43 }, { 0xbca8d6fe, 0x3bb1739d },
    { 0x3eaab363, 0xbd928873 }, { 0x3ad43337, 0x3d498902 }, { 0xbb8295ae, 0xbb81a3c0 },
    { 0xbc02fa5f, 0x3d433c41 }, { 0x3d3a03b3, 0x3c9c32c8 }, { 0x3cb083b4, 0x3c5e7725 },
    { 0xbc9d92d2, 0x3c687644 }, { 0x3aa91339, 0x3c17af4e }, { 0xb9b031f5, 0xb9cdba00 },
    { 0x3880bc82, 0xbb4e3c7e }, { 0xbb847e75, 0x3b43ba1b }, { 0xbc595440, 0x3c27368c },
    { 0xbbb045cc, 0xbc67d19d }, { 0x3aabfb7f, 0xbbf9c6f2 }, { 0x3b9bb301, 0x3c4e4ba9 },
    { 0xb96f6a20, 0x3b4c8b21 }, { 0x3b86ed43, 0xbab8dc04 }, { 0x3ed38e12, 0x3ee3dc4d },
    { 0xbdec6c93, 0xbf40a757 }, { 0xbd3ecc72, 0x3d5d542a }, { 0xbc520290, 0x3dbd6fad },
    { 0x3d98f37b, 0xbc70ef3c }, { 0x3d875505, 0x3d019799 }, { 0x3e2f4987, 0xbd8ae495 },
    { 0xbca9a849, 0x3c4cc52d }, { 0x3ead2387, 0xbd73b944 }, { 0x3a3d5571, 0xbd4e39ca },
    { 0x3c1f0c02, 0x3b95d59e }, { 0x3c502622, 0xbd4ea1ab }, { 0x3d35398f, 0x3cd11b19 },
    { 0x3cbd1278, 0x3c91996f }, { 0xbca90b8c, 0x3c8ab3a0 }, { 0xbac1ec78, 0x3c9bdeaa },
    { 0x3b18c761, 0x39d32079 }, { 0x38c470a5, 0x3b5d8ebe }, { 0x3b850fc0, 0xbba4aef5 },
    { 0x3c5f6864, 0xbc2bb7e5 }, { 0xbb68fa95, 0xbc70fa18 }, { 0x3b03d42b, 0xbc15b8a9 },
    { 0x3bb3d483, 0x3c4d6650 }, { 0xb9a808a9, 0x3b57d401 }, { 0x3b5cef80, 0xba59a23c },
    { 0x3e98a0e2, 0x3f055f65 }, { 0xbc9434b1, 0x3f42f818 }, { 0xbcec84df, 0x3d4a1729 },
    { 0xbc90acf2, 0x3d9cf2b1 }, { 0xbd65f087, 0x3ccb8523 }, { 0xbd88f44a, 0x3b672a6e },
    { 0x3e54f2fa, 0xbde2aebd }, { 0xbc91887f, 0xbb179208 }, { 0x3ed89f41, 0xbdc04279 },
    { 0xbbcf0d8c, 0x3daee68c }, { 0xbae5f508, 0xba339e6d }, { 0x3ca48a49, 0x3dcfef0a },
    { 0x3d173164, 0x3be1a6cb }, { 0x3ca3a918, 0x3b9ebb65 }, { 0xbbe59e52, 0x3cfcc2a1 },
    { 0x3b63eb5b, 0x3c9753d5 }, { 0xbb1b2e66, 0xba70dbaf }, { 0xbb9724e5, 0xbb7c1dcd },
    { 0xbaebbb68, 0x3bc26414 }, { 0xbbd651c1, 0x3c745d62 }, { 0xbbe1b988, 0xbc111128 },
    { 0xbb2c10b4, 0xbbf54dc6 }, { 0x3c8bdf35, 0x3c3b04c1 }, { 0x39ec591b, 0x3b640c6c },
    { 0x3bfce491, 0xb836b401 }, { 0x3e8abbcd, 0x3f073e06 }, { 0x3d42edf4, 0xbf3f88bb },
    { 0xbd16bc50, 0x3d6524eb }, { 0xbcaea19b, 0x3dd11e5d }, { 0x3dc35eda, 0xbcafcb10 },
    { 0x3da8f027, 0x3b6b005e }, { 0x3e561c1b, 0xbdc39f78 }, { 0xbc9bd966, 0xbb0dcab2 },
    { 0x3edbcc8e, 0xbd99ab15 }, { 0x3c2e23c9, 0xbdb321ac }, { 0x3bc0d863, 0x39b0d0ab },
    { 0xbc2d49b4, 0xbddc3b2c }, { 0x3d1ef528, 0x3c999891 }, { 0x3ca11c4e, 0x3c0e85dd },
    { 0xbc21a49d, 0x3d1b67d4 }, { 0xbaad6688, 0x3d0a1364 }, { 0x3bab56b8, 0x3a871a95 },
    { 0x3bc1f667, 0x3b814740 }, { 0x3a8f288f, 0xbbd17d9e }, { 0x3c050ff0, 0xbc83cdeb },
    { 0xbb7a0a9c, 0xbc1954c3 }, { 0xbb6b99d5, 0xbc180e4f }, { 0x3c962c57, 0x3c456d4b },
    { 0x3a3f9a30, 0x3b817ce1 }, { 0x3be80c14, 0x3a610978 }, { 0x3e1da2d5, 0x3f09e543 },
    { 0xbe117068, 0x3f382fc0 }, { 0xbc9e2ee4, 0x3ce95617 }, { 0xbc8eb982, 0x3d9a9d63 },
    { 0xbd6e6ce8, 0x3c9b52e9 }, { 0xbd1aeb77, 0x3b2b65c2 }, { 0x3e55f7c2, 0xbde5771a },
    { 0xbca4425c, 0xbbb9fcfa }, { 0x3eeb2782, 0xbdd0ea2e }, { 0xbc4a9d86, 0x3e0abf0e },
    { 0x3bad3569, 0xbba10b84 }, { 0x3d81b84e, 0x3de84771 }, { 0x3cb328ad, 0x3bb7fe15 },
    { 0x3c6d34d6, 0x3b9f7673 }, { 0x3ba61c64, 0x3cf0df3f }, { 0x3b99ac56, 0x3ce284f3 },
    { 0xbbb492be, 0xba52691d }, { 0xbc09dd73, 0xb9c148e8 }, { 0x3961e261, 0x3b8eb22f },
    { 0xbae652ae, 0x3c109d57 }, { 0x3a5ccbdf, 0xbbb4f265 }, { 0xbb69ca94, 0xbbae2708 },
    { 0x3ce90370, 0x3bbff4ef }, { 0x3acf25f2, 0x3b67d6f8 }, { 0x3c6c8d24, 0x3b44d0ef },
    { 0x3dfb3847, 0x3f0c062a }, { 0x3e3cab6f, 0xbf33a1f0 }, { 0xbceffb93, 0x3d28b2b0 },
    { 0xbd096f13, 0x3dbec263 }, { 0x3dcb4521, 0xbc7f94a8 }, { 0x3d7a26ed, 0xb98900b6 },
    { 0x3e6099b1, 0xbdbdc4d6 }, { 0xbce5b115, 0xbbbc3461 }, { 0x3ef1bc8f, 0xbd9ad195 },
    { 0x3ca03ac1, 0xbe0fb036 }, { 0xbaecc4e9, 0x3bbe2c7f }, { 0xbd5adce5, 0xbe04050d },
    { 0x3cfc18bd, 0x3c8e2ce7 }, { 0x3c52b3f1, 0x3c38f40f }, { 0x3bb00b34, 0x3d252dba },
    { 0xbaab2c44, 0x3d4bc299 }, { 0x3c1df332, 0x3ac7bbd2 }, { 0x3c280047, 0xb9ccdccf },
    { 0x393e1738, 0xbb593acf }, { 0x3b440d38, 0xbc445925 }, { 0x3bbedaf8, 0xbbf51972 },
    { 0xbbc2127e, 0xbbbf8442 }, { 0x3cff0386, 0x3bd27228 }, { 0x3b006c5d, 0x3b577cfc },
    { 0x3c6534f0, 0x3b92598c }, { 0x3c2e7251, 0x3f0819bd }, { 0xbe90e70e, 0x3f254e31 },
    { 0xbd10fa5f, 0x39e810e2 }, { 0xbcbdaa15, 0x3d87dc20 }, { 0xbd9065bf, 0x3b617cd1 },
    { 0xbd164211, 0xbd2128f2 }, { 0x3e594999, 0xbda0323e }, { 0xbcea8ad3, 0xbbf037e2 },
    { 0x3ef853c3, 0xbd711c0b }, { 0xbc7e1c05, 0x3e4dddbd }, { 0x3b300c79, 0xbc8d1f17 },
    { 0x3d867479, 0x3de45e91 }, { 0x3c0c9dcf, 0x3c7ae980 }, { 0x3c54119c, 0x3c2c1ab5 },
    { 0x3b3b0b2a, 0x3cdb97f6 }, { 0x3bc368dd, 0x3d260c43 }, { 0xbc2c00ab, 0x39cce46f },
    { 0xbc189af5, 0x3b648fa9 }, { 0xbb182753, 0x3b784862 }, { 0xbc17ced2, 0x3b3f56f4 },
    { 0x3bc50b43, 0xbbb9ef0b }, { 0xbb7a12b0, 0xbb96b8dc }, { 0x3d1c3e9f, 0xba3a2b9f },
    { 0x3af19dca, 0x3b41ba03 }, { 0x3cd3d775, 0x3c0c8582 }, { 0xbcd136e9, 0x3f0a35dd },
    { 0x3eab98b6, 0xbf20b492 }, { 0xbd16becb, 0x3c4f4f0e }, { 0xbd6074f5, 0x3da48880 },
    { 0x3de75a6d, 0x3c337a53 }, { 0x3d675851, 0x3d1ae863 }, { 0x3e6a4dcc, 0xbd7ec2fc },
    { 0xbd24b22c, 0xbbfa0c2e }, { 0x3f004621, 0xbcfa5be5 }, { 0x3cc36d8b, 0xbe56a937 },
    { 0xbab4d161, 0x3ca5bab0 }, { 0xbd78ac0c, 0xbe07ffc9 }, { 0x3c926dc9, 0x3cb57492 },
    { 0x3c0f35d0, 0x3ca664f0 }, { 0x3b68d439, 0x3d254868 }, { 0xbbcf26a6, 0x3d8f492b },
    { 0x3c829e19, 0x3b3d601a }, { 0x3c3daa81, 0xbb8854e3 }, { 0x3b9d9db9, 0xb88b79b6 },
    { 0x3c159cdf, 0xbbea2402 }, { 0x3c43c058, 0xbc305976 }, { 0xbbc8c2d6, 0xbb39e91e },
    { 0x3d2e8e9f, 0xb9621bea }, { 0x3a59fd0a, 0x3ad2fff7 }, { 0x3cd49221, 0x3c2f76e1 },
    { 0x3d05c259, 0x3f039fbe }, { 0xbe8e9e70, 0x3f249883 }, { 0xbd2de154, 0x3a826441 },
    { 0xbcac5f0e, 0x3d8c08a2 }, { 0xbd93c6ad, 0x3b68d23e }, { 0xbd383f7e, 0xbce4f0ba },
    { 0x3e5628c6, 0xbd904a74 }, { 0xbce721c7, 0xbb31d6a5 }, { 0x3ef0a1ff, 0xbd30f0a2 },
    { 0xbc78412e, 0x3e53478e }, { 0xba024bf6, 0xbc2ad5f2 }, { 0x3d706adb, 0x3dec9607 },
    { 0x3c97551a, 0x3c25ac29 }, { 0x3c85aaba, 0x3c07d5a4 }, { 0x3b2384b0, 0x3ca82238 },
    { 0x3bbb299d, 0x3d27a4dd }, { 0xbc371aa8, 0x3a94b264 }, { 0xbc09c164, 0x3b5fe8ca },
    { 0xbb24d3db, 0x3b6d45af }, { 0xbc026f4b, 0x3b0a8be4 }, { 0x3c39d4a3, 0xbb792f24 },
    { 0xbb43100d, 0xbb9afd18 }, { 0x3d161e20, 0xbbb4aa4d }, { 0x3b5f1d3e, 0x39f504e7 },
    { 0x3cceaf13, 0x3c45544c }, { 0xbb882502, 0x3f07876a }, { 0x3eac2d32, 0xbf216702 },
    { 0xbd4aa102, 0x3b9be268 }, { 0xbd50a29d, 0x3da04c98 }, { 0x3debfecc, 0x3c54f24a },
    { 0x3d8eae56, 0x3ceab012 }, { 0x3e6389d4, 0xbd6c5edb }, { 0xbd27fd34, 0xba343e41 },
    { 0x3efa9bb2, 0xbc51f8eb }, { 0x3cb31332, 0xbe5d92ed }, { 0x3aea1477, 0x3c80e097 },
    { 0xbd5f8ee2, 0xbe080bae }, { 0x3caf42a7, 0x3c3518dc }, { 0x3c8d47c8, 0x3ca42d91 },
    { 0x3c2c72fb, 0x3d129b35 }, { 0xbbe62689, 0x3d93e57a }, { 0x3c86dd41, 0x3b3e1a4c },
    { 0x3c32eb95, 0xbbaaa65f }, { 0x3bb10f8b, 0xba7412d9 }, { 0x3bc95cc0, 0xbb0a6f75 },
    { 0x3c673df3, 0xbc2222f4 }, { 0xbadff6c2, 0xbb184c21 }, { 0x3d2a9e6d, 0xbb9dade5 },
    { 0x3a8cab6e, 0xba3f5804 }, { 0x3cd31957, 0x3c626a04 }, { 0x3d296cab, 0x3f016050 },
    { 0xbe91002d, 0x3f22aa8f }, { 0xbd39b755, 0x3bc77145 }, { 0xbc8a97dd, 0x3d978769 },
    { 0xbd9a9e33, 0x3c5141c7 }, { 0xbd3efd23, 0xbcac0799 }, { 0x3e5a3c03, 0xbd7244e8 },
    { 0xbcc2ba56, 0x3b2d8fbd }, { 0x3ee59382, 0xbd0c2157 }, { 0xbb8b1e0f, 0x3e4b4c81 },
    { 0xbb1bfd76, 0xba82572c }, { 0x3d64f10e, 0x3df2b5d3 }, { 0x3ce5252c, 0x3c4f5250 },
    { 0x3caedbe6, 0x3bad84e4 }, { 0xbb0c0b8d, 0x3c919f63 }, { 0x3c27cd2a, 0x3d22e9e1 },
    { 0xbc22e39c, 0x3b1871f2 }, { 0xbba27fe8, 0x3a48c004 }, { 0xbaccb9d0, 0x3b3bda7c },
    { 0xbba17f64, 0x3be2d48a }, { 0x3c76ee6d, 0xbb25bb0f }, { 0xbadf8086, 0xbb6866b7 },
    { 0x3d0657d3, 0xbc23fe5f }, { 0x3bb1d8df, 0xbacd72dd }, { 0x3cbb9437, 0x3c79d663 },
    { 0x3b97ce32, 0x3f04652d }, { 0x3eaef959, 0xbf1f8959 }, { 0xbd688c99, 0xbb625ffa },
    { 0xbd432a92, 0x3da92b49 }, { 0x3debc5d3, 0x3c15d8e8 }, { 0x3d905118, 0x3cd7dd30 },
    { 0x3e645a8b, 0xbd4ad559 }, { 0xbcf04981, 0x3c14223d }, { 0x3ef20194, 0xb9160d04 },
    { 0x3c250d07, 0xbe574b13 }, { 0x3b8d5645, 0x3ba76123 }, { 0xbd66a687, 0xbe02d120 },
    { 0x3ce9bb31, 0x3c5c90c3 }, { 0x3ce179d5, 0x3c8a5787 }, { 0x3bf649de, 0x3d05dbfc },
    { 0xbb13ef2a, 0x3d938864 }, { 0x3c7ed56e, 0x3b09bc7e }, { 0x3c189e6b, 0xbb2f41a2 },
    { 0x3ba2289f, 0xbb237118 }, { 0x3b21dbe2, 0xbb9e03cf }, { 0x3c811e3c, 0xbbc19049 },
    { 0x39f2d3f0, 0xbb36b77c }, { 0x3d0df6a4, 0xbc0acdd7 }, { 0x3b5c72b5, 0xbadea160 },
    { 0x3cc495b7, 0x3c8ac22a }, { 0x3d80805f, 0x3f04e654 }, { 0xbe911d42, 0x3f247d61 },
    { 0xbce1c887, 0x3d0cd9dd }, { 0xbc96c23c, 0x3da79857 }, { 0xbda0e5d6, 0x3c977a56 },
    { 0xbd651e47, 0x3ca30863 }, { 0x3e6cabc4, 0xbd3c0d44 }, { 0xbc727b9a, 0x3c7d46b1 },
    { 0x3ee7b34d, 0xbc9570e0 }, { 0xba105f51, 0x3e497e57 }, { 0xbbe1fb78, 0x3c29efb5 },
    { 0x3d4bffe3, 0x3e0b675a }, { 0x3d2b4dfc, 0x3bfdd685 }, { 0x3cbd058a, 0x3b8b88d6 },
    { 0x3ca96e92, 0x3cb8e5cb }, { 0x3c6576fc, 0x3d293eac }, { 0xbc1678b1, 0x3b249630 },
    { 0xbb96a525, 0x3bb1a1bd }, { 0xbad30b5c, 0x3b1eaf7a }, { 0xba4263f2, 0x3c28eff9 },
    { 0x3c934d7b, 0xbb804435 }, { 0xbae57855, 0xbb532d4c }, { 0x3d17bac3, 0xbc3c3fba },
    { 0x3c1425f7, 0xbaaec26b }, { 0x3cc8cb5e, 0x3c93b653 }, { 0x3cb6cfb6, 0x3f085b3a },
    { 0x3eb28f09, 0xbf22e428 }, { 0xbd353a9d, 0x3cb33b43 }, { 0xbd4685e7, 0x3db8b9ea },
    { 0x3defa795, 0x3c1e9b89 }, { 0x3da58bed, 0xbc7a169e }, { 0x3e79d1ec, 0xbd088b5c },
    { 0xbcd525c5, 0x3c80aa85 }, { 0x3ef7b176, 0x3c8abfde }, { 0x3bc3ced2, 0xbe555d4a },
    { 0x3c14c715, 0x3b5f5335 }, { 0xbd5e5a1d, 0xbe1105ec }, { 0x3d40dbda, 0x3c3b92f5 },
    { 0x3cd3fe68, 0x3c2e16e2 }, { 0x3cf42194, 0x3d158476 }, { 0x3af8babc, 0x3d9c2984 },
    { 0x3c824fe6, 0x3ad57ed9 }, { 0x3c138cce, 0xbbe8f13f }, { 0x3b9b8a01, 0xb95a8cbb },
    { 0xbb1cfc55, 0xbc1666f7 }, { 0x3ca3ac6e, 0xbb995ee6 }, { 0xbb41b05e, 0xbb730643 },
    { 0x3d144c89, 0xbc2669d1 }, { 0x3b68d814, 0x3a0304e2 }, { 0x3cccebd2, 0x3ca9b54e },
    { 0x3d8d4bfb, 0x3f05a501 }, { 0xbe8a6a74, 0x3f1ee847 }, { 0xbd100614, 0x3ceb5700 },
    { 0xbcafb9e8, 0x3dc15fc8 }, { 0xbda7476e, 0x3cfac159 }, { 0xbd4c10f4, 0x3c02a103 },
    { 0x3e5f7f6e, 0xbd11b319 }, { 0xbc42ab65, 0x3c9c995c }, { 0x3ee0049f, 0xba6394fc },
    { 0x3b1bab10, 0x3e41535f }, { 0xbc0329f5, 0x3c8342ea }, { 0x3d498d85, 0x3e0a5735 },
    { 0x3d0aa842, 0x3c219909 }, { 0x3c9f2bb3, 0x3a74e3ac }, { 0x3c8fc510, 0x3cc7f0bd },
    { 0x3cb511b5, 0x3d1e9785 }, { 0xbbe4700b, 0x3b2971e4 }, { 0xbb91f2c2, 0x3b5f697c },
    { 0x3a5aaa90, 0x3aea28ae }, { 0x3a7ab903, 0x3c2aec69 }, { 0x3c59e07f, 0xbbd7b75f },
    { 0xbb59d30b, 0xbb0b69e6 }, { 0x3d0c7d89, 0xbc8a1751 }, { 0x3c23299c, 0xbb6b4bd5 },
    { 0x3ce87cc5, 0x3c8bedc9 }, { 0x3d05e99c, 0x3f08a795 }, { 0x3eaa60d0, 0xbf1e098f },
    { 0xbd50043e, 0x3bdec8a2 }, { 0xbd4dba2e, 0x3dcd3715 }, { 0x3df4a4c0, 0x3b36c26d },
    { 0x3d8475da, 0x3c2f0db0 }, { 0x3e706f65, 0xbcb810f2 }, { 0xbca37faa, 0x3c8e8afb },
    { 0x3ef10886, 0x3d05b91a }, { 0x3b879881, 0xbe4d637b }, { 0x3c088954, 0xbb8ea770 },
    { 0xbd6c6883, 0xbe0bc4e6 }, { 0x3d1fecf0, 0x3c8e4968 }, { 0x3cbb7509, 0x3bd2baa1 },
    { 0x3c8a4e61, 0x3d2264ca }, { 0x3c28cf4e, 0x3d966c88 }, { 0x3c70acbf, 0x3ac291d8 },
    { 0x3c1af496, 0xbb87e303 }, { 0x3b1c2725, 0xba566711 }, { 0xbadc5ec0, 0xbc34347a },
    { 0x3c661f03, 0xbbbca6e0 }, { 0xbbadab0d, 0xbb02c699 }, { 0x3d0129ac, 0xbc7f08e5 },
    { 0x3b9774ff, 0xbaddd77e }, { 0x3cef1f8b, 0x3ca6dac1 }, { 0x3d91acac, 0x3f07fd1f },
    { 0xbe884ae0, 0x3f1e8fab }, { 0xbd2b986b, 0x3cdd46fc }, { 0xbcd7ed46, 0x3dd95008 },
    { 0xbdb8fea4, 0x3d256717 }, { 0xbd5b49eb, 0x3c77d3e0 }, { 0x3e54cae5, 0xbd0e5ddc },
    { 0xbc5749f6, 0x3c9c303c }, { 0x3ee093e4, 0x3c67f818 }, { 0x3aac2020, 0x3e42ce04 },
    { 0xbc0d7210, 0x3c8f42e6 }, { 0x3d4448fa, 0x3e0be060 }, { 0x3d00c653, 0x3bb63fac },
    { 0x3c89a8d5, 0xbab8871a }, { 0x3cbbebaa, 0x3ca7aaf6 }, { 0x3cfbf672, 0x3d08fd97 },
    { 0xbb9503ac, 0x3aad9dea }, { 0xbbb53d3e, 0x3b3900f5 }, { 0x3b446d13, 0x3a179e7e },
    { 0x3a203f65, 0x3c0ea4be }, { 0x3c354f79, 0xbc26b30f }, { 0xbb30289d, 0xbab9f029 },
    { 0x3d029a31, 0xbca7d052 }, { 0x3c117686, 0xbb8f6490 }, { 0x3d05cc35, 0x3c8151d4 },
    { 0x3d2543da, 0x3f0acbed }, { 0x3ea5ef45, 0xbf1f34e2 }, { 0xbd6a5d70, 0x3b8e14ca },
    { 0xbd65f5df, 0x3de809ba }, { 0x3e063724, 0xbc031dc4 }, { 0x3d81f85d, 0x3c5066b8 },
    { 0x3e697960, 0xbc8bc0fa }, { 0xbc895524, 0x3cb7259a }, { 0x3ef23b41, 0x3d4e9ed3 },
    { 0x3c17fa80, 0xbe5176f1 }, { 0x3c26fa5c, 0xbc272990 }, { 0xbd65a92f, 0xbe10d221 },
    { 0x3d0eb861, 0x3c7094af }, { 0x3cbf12fc, 0x3bc8e79e }, { 0x3c8a9e59, 0x3d1edc74 },
    { 0x3c9f2065, 0x3d8e1bd7 }, { 0x3c4e2f77, 0x3b3d43d0 }, { 0x3c32b51c, 0xbb7dc370 },
    { 0x3ab5cf04, 0xbb0597a7 }, { 0x3a5f7e31, 0xbc3503d9 }, { 0x3c1e1029, 0xbc162b3f },
    { 0xbb68d460, 0x383c2a55 }, { 0x3cff0b3e, 0xbc9fa13c }, { 0x3ba42875, 0xbb688d1d },
    { 0x3d0d55b7, 0x3ca28f13 }, { 0x3d8f2243, 0x3f02de4f }, { 0xbe839d0c, 0x3f199816 },
    { 0xbd3c7aa9, 0x3cc0241b }, { 0xbcee1e86, 0x3dd4feb8 }, { 0xbdc16bd6, 0x3d2f3c67 },
    { 0xbd658d0a, 0x3cb43f25 }, { 0x3e445f0f, 0xbd120f5d }, { 0xbc30cffb, 0x3c9112a2 },
    { 0x3ed4f112, 0x3cb6e588 }, { 0xbaeea88e, 0x3e3fe050 }, { 0xbc0edfb8, 0x3c8aa712 },
    { 0x3d3bf2e2, 0x3e047dbb }, { 0x3cf72021, 0xb9abc294 }, { 0x3c844d1f, 0xbb18dadc },
    { 0x3cc5c566, 0x3c804f73 }, { 0x3d076aaa, 0x3cdafdce }, { 0xbb3afa36, 0xb6eb7300 },
    { 0xbbcfb01e, 0x3b3f5f19 }, { 0x3b416c5a, 0x39d96f79 }, { 0xb911b704, 0x3bc0f1b3 },
    { 0x3c39ee78, 0xbc3fd04b }, { 0xbab3ccfb, 0xbb11b93b }, { 0x3ce1cc2c, 0xbca9b796 },
    { 0x3c023cc7, 0xbb712a86 }, { 0x3d0e94ea, 0x3c39bff7 }, { 0x3d316866, 0x3f0705b8 },
    { 0x3ea05dd5, 0xbf1d12b2 }, { 0xbd6e38e2, 0x3c5bcbd5 }, { 0xbd6812bc, 0x3df89513 },
    { 0x3e0fd229, 0xbcb4b7ba }, { 0x3d8c00cc, 0xba919eaf }, { 0x3e5e82b1, 0xbc40fcc1 },
    { 0xbc2a4faf, 0x3cc9b47c }, { 0x3ee7a149, 0x3d803cae }, { 0x3c898eb1, 0xbe529205 },
    { 0x3c4d1e8a, 0xbc49fc35 }, { 0xbd527401, 0xbe1188cf }, { 0x3d0d2bdb, 0x3c0d48fc },
    { 0x3cc8d7b5, 0x3baf5c7d }, { 0x3cb2c692, 0x3d054847 }, { 0x3ce85474, 0x3d80ded8 },
    { 0x3c283a4a, 0x3b55f6bf }, { 0x3c32353b, 0xbb76b0e7 }, { 0x3a59c813, 0xbb66bde4 },
    { 0x3b1a6d26, 0xbc20b859 }, { 0x3c25c04a, 0xbc2656ef }, { 0xbb014a68, 0x3a3fd701 },
    { 0x3cedac9b, 0xbcafbf5c }, { 0x3ba36611, 0xbb356bbb }, { 0x3d1ad079, 0x3c899f9b },
    { 0x3d9848e3, 0x3efdd0db }, { 0xbe7c14b7, 0x3f16eacb }, { 0xbd293f71, 0x3c4c5e49 },
    { 0xbcd85ef1, 0x3dd7ca54 }, { 0xbdc7d1b4, 0x3d43be1d }, { 0xbd564314, 0x3c9dc3b2 },
    { 0x3e3d992b, 0xbd16f0e4 }, { 0xbc064094, 0x3c78201a }, { 0x3ecb5f4e, 0x3cf203e6 },
    { 0xbc0788c2, 0x3e41acfd }, { 0xbc0aa909, 0x3c76b0e5 }, { 0x3d34c7c1, 0x3dfe56da },
    { 0x3d011db7, 0xb90f964b }, { 0x3c81c729, 0xbb297612 }, { 0x3cb8310d, 0x3c901a58 },
    { 0x3d0efb45, 0x3cc0546f }, { 0xbb2b70bd, 0x39c8a943 }, { 0xbc05c95f, 0x3b6f74eb },
    { 0x3b27f8e1, 0x3a544b00 }, { 0xbabe6c98, 0x3ba7723c }, { 0x3c4b7db7, 0xbc4243cd },
    { 0xba939ae9, 0xbb2df608 }, { 0x3cd10783, 0xbc98fd45 }, { 0x3be4f7fa, 0xbb1c432e },
    { 0x3d162e97, 0x3beabd90 }, { 0x3d4b0b6d, 0x3f06f282 }, { 0x3e9e855b, 0xbf1e7e79 },
    { 0xbd4ffc07, 0x3c95652d }, { 0xbd698d4f, 0x3e034fd6 }, { 0x3e17d859, 0xbcf94ce2 },
    { 0x3d8d75cf, 0xbc2f648b }, { 0x3e5ceb9d, 0xbc278f64 }, { 0xbbef6101, 0x3cabd555 },
    { 0x3ee155b1, 0x3d919dd3 }, { 0x3ccfd2fe, 0xbe5a2679 }, { 0x3c4af497, 0xbc1b1e76 },
    { 0xbd46bb0a, 0xbe134197 }, { 0x3d18e9a4, 0x3c12955f }, { 0x3cb7c3e6, 0x3ba28516 },
    { 0x3cca9dc4, 0x3cf442d8 }, { 0x3d088bdc, 0x3d71944c }, { 0x3c1a2c89, 0x3b311965 },
    { 0x3c3d56cd, 0xbb6d03b1 }, { 0x391ff17c, 0xbb8c05b0 }, { 0x3b80fd47, 0xbc2cd0ff },
    { 0x3c4f538c, 0xbc241e2e }, { 0xbb513005, 0x3ad955c0 }, { 0x3cdd28fe, 0xbcae4f1f },
    { 0x3b4a4fcf, 0xba80f900 }, { 0x3d299f63, 0x3c5370e6 }, { 0x3da59fd3, 0x3f005f0d },
    { 0xbe7414f4, 0x3f15edb4 }, { 0xbd0ff607, 0x3c61df02 }, { 0xbcb1bf4b, 0x3df00ec5 },
    { 0xbdce23f2, 0x3d7219d5 }, { 0xbd4db3f4, 0x3ca9e0b4 }, { 0x3e3cb7ea, 0xbd006f1b },
    { 0xbbc2c130, 0x3c7d9505 }, { 0x3ec92389, 0x3d177ee7 }, { 0xbc5ad2ab, 0x3e459e90 },
    { 0xbc02131d, 0x3c70bab6 }, { 0x3d34597f, 0x3dfe338f }, { 0x3d0bf219, 0x3b603afc },
    { 0x3c81f459, 0xbad67eb7 }, { 0x3cb74171, 0x3c9f6179 }, { 0x3d1c9ba7, 0x3cb666bb },
    { 0xbb4fca3f, 0x3b169b06 }, { 0xbc0ef294, 0x3b83d08a }, { 0x3b34e5e4, 0x3aed3d82 },
    { 0xb9e7e289, 0x3bd6f10e }, { 0x3c3cc98f, 0xbc47ef44 }, { 0xba2b60e7, 0xbaff3f14 },
    { 0x3ccf511d, 0xbc8c5d91 }, { 0x3bcadbb4, 0xba9fa75b }, { 0x3d1f8913, 0x3b9ddc32 },
    { 0x3d5bc034, 0x3f0b88a4 }, { 0x3e9f9015, 0xbf205318 }, { 0xbd375ac2, 0x3ccfbb01 },
    { 0xbd6c3827, 0x3e10ec58 }, { 0x3e1f3c12, 0xbd253aac }, { 0x3d8f7a8f, 0xbc8b1713 },
    { 0x3e5de0fa, 0xbc165518 }, { 0xbbd7479f, 0x3caa706d }, { 0x3ee1841f, 0x3da08242 },
    { 0x3d0039d4, 0xbe61f067 }, { 0x3c3f4378, 0xbc0a62fa }, { 0xbd450720, 0xbe142606 },
    { 0x3d224e14, 0x3c3bafd1 }, { 0x3ca23fdd, 0x3bb044b9 }, { 0x3cd3cbb9, 0x3cea05f5 },
    { 0x3d19a1ac, 0x3d679b02 }, { 0x3c215377, 0x3a8b7687 }, { 0x3c3ca187, 0xbb518e65 },
    { 0xb9478c34, 0xbbb10b0c }, { 0x3b82233d, 0xbc49e239 }, { 0x3c58b03d, 0xbc317cbe },
    { 0xbb6efc4c, 0x3b24c3a6 }, { 0x3cd0088e, 0xbca7ca9c }, { 0x3ae8cd84, 0xb8176824 },
    { 0x3d3a265b, 0x3c1fef47 }, { 0x3daf33f7, 0x3f04dba9 }, { 0xbe75f09e, 0x3f185ad4 },
    { 0xbd01fea3, 0x3cbb105a }, { 0xbc9765d1, 0x3e0d009d }, { 0xbdd99e41, 0x3d9f6392 },
    { 0xbd510bcb, 0x3ce5ff84 }, { 0x3e3ec8f5, 0xbcb6713c }, { 0xbb65330d, 0x3c96fc07 },
    { 0x3ecc011f, 0x3d2c05a7 }, { 0xbc8008b4, 0x3e4b00b8 }, { 0xbc00a7f8, 0x3c82a308 },
    { 0x3d37d722, 0x3e06b0a1 }, { 0x3d19bebb, 0x3bda7aae }, { 0x3c869e95, 0xbab90c26 },
    { 0x3cc07714, 0x3c9c6105 }, { 0x3d3033da, 0x3ca3f84f }, { 0xbb73f086, 0x3b954e60 },
    { 0xbc12bb1f, 0x3b7b1b36 }, { 0x3b4e92bb, 0x3b412eaa }, { 0x39f8e3b3, 0x3c1fc9d4 },
    { 0x3c26f0c9, 0xbc645983 }, { 0xb99459f3, 0xbac79012 }, { 0x3ccd78f9, 0xbc89806b },
    { 0x3bb9d36e, 0xb96fce47 }, { 0x3d256df0, 0x3b831886 }, { 0x3d59614d, 0x3f100e97 },
    { 0x3ea1806d, 0xbf223612 }, { 0xbd2035af, 0x3cef1ee2 }, { 0xbd663ed6, 0x3e261907 },
    { 0x3e27bd71, 0xbd714d1f }, { 0x3d91441e, 0xbcabe3c7 }, { 0x3e5f3e02, 0xbbbcedd7 },
    { 0xbb9dd865, 0x3cb06876 }, { 0x3ee35bc4, 0x3dac3356 }, { 0x3d0ba876, 0xbe66af33 },
    { 0x3c2ff03c, 0xbc017c6d }, { 0xbd470b17, 0xbe177562 }, { 0x3d248e38, 0x3c6e0390 },
    { 0x3c9ba756, 0x3b974e0a }, { 0x3ccccc81, 0x3cebfbbd }, { 0x3d30b03f, 0x3d5cf09e },
    { 0x3c300d6e, 0xbabdc073 }, { 0x3c3c2921, 0xbb280d71 }, { 0xb9adc58b, 0xbbc2bf91 },
    { 0x3b961ca9, 0xbc740538 }, { 0x3c51d13c, 0xbc5081f9 }, { 0xbb3f92cf, 0x3b39a258 },
    { 0x3cc5dfd4, 0xbc9bf92d }, { 0x3a0cfa77, 0x3accedb3 }, { 0x3d412304, 0x3c0e3e24 },
    { 0x3db7fdd8, 0x3f09f560 }, { 0xbe80028c, 0x3f1d3771 }, { 0xbcd4298b, 0x3d1a0863 },
    { 0xbc9fa086, 0x3e26a335 }, { 0xbdeb764e, 0x3dcfb8c2 }, { 0xbd6003d6, 0x3d2b97f3 },
    { 0x3e44bcc9, 0xbc580d1a }, { 0xbac7d16f, 0x3cb25b4e }, { 0x3ed11b78, 0x3d3e278c },
    { 0xbc779392, 0x3e513def }, { 0xbc0f156e, 0x3c8d5826 }, { 0x3d3ab9df, 0x3e12a7f1 },
    { 0x3d2f5c69, 0x3bd87b5e }, { 0x3c8ed39d, 0xbb40efad }, { 0x3cd7814e, 0x3c92536f },
    { 0x3d488b1f, 0x3c7620a0 }, { 0xbb63c8c2, 0x3bc8c81b }, { 0xbc1aed23, 0x3b962454 },
    { 0x3b71683f, 0x3b697d52 }, { 0x3822309a, 0x3c59c82a }, { 0x3c268f03, 0xbc8a2bfc },
    { 0xb97cc25e, 0xbaec4d7e }, { 0x3ccaa38f, 0xbc88d72c }, { 0x3bacd253, 0x3a6e7e7e },
    { 0x3d25d328, 0x3b7a23aa }, { 0x3d4ff95f, 0x3f118de2 }, { 0x3ea2d58f, 0xbf2217f7 },
    { 0xbcf43eb3, 0x3d0f8f2b }, { 0xbd5f381a, 0x3e3dd618 }, { 0x3e2fe9e2, 0xbdab7a64 },
    { 0x3d9232f7, 0xbcefcef9 }, { 0x3e5f5a32, 0x3a044526 }, { 0xbb880136, 0x3cb5ab8e },
    { 0x3ee16031, 0x3db52c02 }, { 0x3d0bd354, 0xbe662e33 }, { 0x3c2db7a9, 0xbbb53fe7 },
    { 0xbd453b0f, 0xbe1b55f8 }, { 0x3d23a3ec, 0x3c7dcd61 }, { 0x3ca15d68, 0x3b52c22e },
    { 0x3ccdc166, 0x3cfafba4 }, { 0x3d4db23c, 0x3d48bc02 }, { 0x3c303924, 0xbb86c77f },
    { 0x3c4520f5, 0xbb68d562 }, { 0xba538122, 0xbbc9c387 }, { 0x3bbb2752, 0xbc8d14bc },
    { 0x3c529cf0, 0xbc717ce7 }, { 0xbb16cd48, 0x3b10a35e }, { 0x3cbe20c4, 0xbc8d454b },
    { 0xba11ebcd, 0x3b84c878 }, { 0x3d3cec93, 0x3c0a808d }, { 0x3dc7d587, 0x3f104a6a },
    { 0xbe88687e, 0x3f250ed6 }, { 0xbc8fa1cd, 0x3d4da23e }, { 0xbcd1f64d, 0x3e441d21 },
    { 0xbe040a15, 0x3e046546 }, { 0xbd71b1fa, 0x3d5ce6f6 }, { 0x3e4c3254, 0xbc0754ac },
    { 0x3aa4f63e, 0x3cd00331 }, { 0x3eda7c43, 0x3d61e44d }, { 0xbc5c601f, 0x3e5db92c },
    { 0xbc1cc4bd, 0x3c8eeb10 }, { 0x3d44e936, 0x3e1dc2ad }, { 0x3d3e42d7, 0x3b966054 },
    { 0x3ca468bc, 0xbba39767 }, { 0x3ced66d0, 0x3c9ab6ce }, { 0x3d660d5f, 0x3bf6d412 },
    { 0xbb04ca10, 0x3bd5ad55 }, { 0xbc33ba19, 0x3be1723d }, { 0x3b9e94e0, 0x3b847ce1 },
    { 0xbaa51e54, 0x3c7961c7 }, { 0x3c219379, 0xbca1e37f }, { 0xb911c247, 0xbaf1fee9 },
    { 0x3ccc2d07, 0xbc82a68c }, { 0x3b936255, 0x3b2ef8b4 }, { 0x3d26446d, 0x3b835316 },
    { 0x3d4e98e7, 0x3f1456bb }, { 0x3ea88c94, 0xbf250f8e }, { 0xbcb04e69, 0x3d276ea7 },
    { 0xbd747a3c, 0x3e593a7f }, { 0x3e3e5e60, 0xbde4717a }, { 0x3d931799, 0xbd16dc3b },
    { 0x3e5f71e6, 0x3ba0ed3f }, { 0xbba46d40, 0x3cb52380 }, { 0x3ee322e7, 0x3dc27de6 },
    { 0x3d0c727f, 0xbe6af434 }, { 0x3c370b29, 0xbac38963 }, { 0xbd4a9699, 0xbe2047b3 },
    { 0x3d1b365c, 0x3c7388c0 }, { 0x3ca6170d, 0xb9b4fca5 }, { 0x3cd510e4, 0x3d0d2722 },
    { 0x3d73519a, 0x3d2ef181 }, { 0x3c1a5e16, 0xbbbaec2e }, { 0x3c5efb1c, 0xbbc49162 },
    { 0xbb277d1d, 0xbbab9cec }, { 0x3bd3c975, 0xbc940b7a }, { 0x3c4ab6fc, 0xbc86f8f7 },
    { 0xbb51ce88, 0x3a1bd07c }, { 0x3cbdb88f, 0xbc88aa0f }, { 0xbad1ff70, 0x3bdc88ed },
    { 0x3d39ace4, 0x3c114fc2 }, { 0x3dd000fa, 0x3f1278bd }, { 0xbe8e84dc, 0x3f27ceeb },
    { 0xbc4b1167, 0x3d79cf65 }, { 0xbd0e7476, 0x3e5de6d7 }, { 0xbe103a2a, 0x3e1e85f6 },
    { 0xbd78a5d0, 0x3d847cb7 }, { 0x3e4ac440, 0xbbb3b357 }, { 0x3bbdf099, 0x3cfdb70d },
    { 0x3edec389, 0x3d823e56 }, { 0xbc2bffc8, 0x3e64e794 }, { 0xbc2e83c8, 0x3c9dead5 },
    { 0x3d52d8cd, 0x3e1ff607 }, { 0x3d340b0e, 0x3ab005ab }, { 0x3cc4e581, 0xbb99d6ee },
    { 0x3cf92211, 0x3ca6798b }, { 0x3d7deac2, 0xbb2406c2 }, { 0x3a69ac86, 0x3bb6c4c9 },
    { 0xbc4ba355, 0x3c2352cc }, { 0x3bc50450, 0x3bc0731b }, { 0xbaf1efa0, 0x3c779e6c },
    { 0x3c02ec7b, 0xbcaa4ba9 }, { 0x39f3887e, 0xbaacad44 }, { 0x3cc66607, 0xbc6f766c },
    { 0x3b6f971f, 0x3b8ba955 }, { 0x3d214ac0, 0x3b6d5d1b }, { 0x3d3c0fae, 0x3f149c42 },
    { 0x3ead391c, 0xbf254702 }, { 0xbc7292cc, 0x3d5093fc }, { 0xbd8ace63, 0x3e715ae9 },
    { 0x3e4c8daf, 0xbe0d2c17 }, { 0x3d9259fa, 0xbd3b7f1b }, { 0x3e59d629, 0x3bef084c },
    { 0xbba1ae98, 0x3cc49293 }, { 0x3ee28d6d, 0x3dcc1a35 }, { 0x3d05b918, 0xbe6c3811 },
    { 0x3c53ab71, 0xb935ecf7 }, { 0xbd524c3c, 0xbe205768 }, { 0x3d0c6a08, 0x3c580220 },
    { 0x3cb9ba9f, 0xbb44aa8e }, { 0x3ce67e14, 0x3d1a3c8a }, { 0x3d8d506e, 0x3d09fa61 },
    { 0x3bc76b6b, 0xbbbd7379 }, { 0x3c72160c, 0xbc14b545 }, { 0xbb963ad0, 0xbbaefaaa },
    { 0x3bc59477, 0xbc932f10 }, { 0x3c3a5ee4, 0xbc877487 }, { 0xbb65eb92, 0xb90feffc },
    { 0x3cb5c2a9, 0xbc89b99d }, { 0xbaeb8c64, 0x3c1189bc }, { 0x3d30cd57, 0x3c14f3bd },
    { 0x3dc8696f, 0x3f11d76f }, { 0xbe92569b, 0x3f254e82 }, { 0xbc0d080f, 0x3d87c8d8 },
    { 0xbd356e78, 0x3e71609a }, { 0xbe15de4c, 0x3e3084d0 }, { 0xbd6a2d4b, 0x3d93808f },
    { 0x3e4842d4, 0xbbda1ce0 }, { 0x3c0eac5a, 0x3d10bfae }, { 0x3ee070df, 0x3d8bcdf4 },
    { 0xbbb5dd9a, 0x3e6254d6 }, { 0xbc3325f7, 0x3cac5854 }, { 0x3d62a01c, 0x3e19ef55 },
    { 0x3d207629, 0xba2a3fe0 }, { 0x3cd4a114, 0xbba8a64b }, { 0x3cf30d75, 0x3cb61273 },
    { 0x3d87c621, 0xbc473b2a }, { 0x3b853aa3, 0x3b91fa20 }, { 0xbc632dcc, 0x3c48800c },
    { 0x3bd3d6dc, 0x3be57558 }, { 0xbb57d67c, 0x3c7a87ed }, { 0x3bc69cde, 0xbca3706b },
    { 0x39ba9a2e, 0xba9e61b2 }, { 0x3cb0d873, 0xbc5d7a0a }, { 0x3b3b9030, 0x3bade21b },
    { 0x3d16ecf9, 0x3b2f7e6b }, { 0x3d1b5349, 0x3f143953 }, { 0x3eb06a55, 0xbf220bb7 },
    { 0xbb8a145b, 0x3d7a7784 }, { 0xbd98ffa8, 0x3e82ba09 }, { 0x3e554694, 0xbe218002 },
    { 0x3d8b0343, 0xbd58940b }, { 0x3e551b85, 0x3becac75 }, { 0xbb173b5b, 0x3cf0ea47 },
    { 0x3ee278e6, 0x3dd09a6d }, { 0x3ce57162, 0xbe6713c2 }, { 0x3c732b58, 0xbb051563 },
    { 0xbd5ae641, 0xbe1bcba3 }, { 0x3d02e353, 0x3c57b719 }, { 0x3cdaeefc, 0xbb11e846 },
    { 0x3cf2e4e4, 0x3d2c81da }, { 0x3d9d8032, 0x3cc81168 }, { 0x3b0df8db, 0xbbaed989 },
    { 0x3c84de36, 0xbc4c4e02 }, { 0xbbbf2bfc, 0xbbee7af1 }, { 0x3bde9220, 0xbc9a71ec },
    { 0x3c289b38, 0xbc82fc2f }, { 0xbb0a2163, 0x3a3da06a }, { 0x3ca101b7, 0xbc86a11f },
    { 0xbad4e20d, 0x3c29df0c }, { 0x3d22bb0d, 0x3c120a14 }, { 0x3db28fe9, 0x3f0e909a },
    { 0xbe9717d1, 0x3f20cfcc }, { 0x3a9cd040, 0x3d980d36 }, { 0xbd51c992, 0x3e7ac80e },
    { 0xbe153c0d, 0x3e3b9443 }, { 0xbd4de665, 0x3da51635 }, { 0x3e4934b5, 0xbbd342f0 },
    { 0x3c11c821, 0x3d19ed83 }, { 0x3ede4a21, 0x3d87f20c }, { 0x3ae1d358, 0x3e580dc2 },
    { 0xbc31a5ba, 0x3caf1a00 }, { 0x3d776f49, 0x3e12a4e5 }, { 0x3d160b76, 0x3a3a4662 },
    { 0x3cc75f6b, 0xbbfd1868 }, { 0x3ce6c97b, 0x3cc54e2f }, { 0x3d895561, 0xbca2ba72 },
    { 0x3bcad51f, 0x3b8892df }, { 0xbc7790f1, 0x3c680076 }, { 0x3bbe94d8, 0x3bd70e05 },
    { 0xbbb2f10d, 0x3c8fe34f }, { 0x3bb01223, 0xbc8feebd }, { 0xb94c27db, 0xbaccd112 },
    { 0x3c91dddf, 0xbc53aa40 }, { 0x3b23fb60, 0x3bba2452 }, { 0x3d05e54f, 0x3ae979d2 },
    { 0x3cc8b48b, 0x3f12b11b }, { 0x3eb64837, 0xbf1dde42 }, { 0x3c24c1b2, 0x3d98ef16 },
    { 0xbda3722d, 0x3e88ea6e }, { 0x3e58b4d9, 0xbe309d3e }, { 0x3d82a960, 0xbd811f3e },
    { 0x3e5250bc, 0x3be71a54 }, { 0xbaa1cced, 0x3d1c0340 }, { 0x3ee0712e, 0x3dcabf1e },
    { 0x3ca1cacf, 0xbe5cddab }, { 0x3c8f111a, 0xbbd9721e }, { 0xbd6b88cd, 0xbe1670a6 },
    { 0x3d02e6f3, 0x3c68b0ef }, { 0x3ce6f984, 0xbad789ce }, { 0x3cfda50f, 0x3d3f11d4 },
    { 0x3da8b586, 0x3c86e12b }, { 0xba90b970, 0xbbb9cd94 }, { 0x3c91b66f, 0xbc87a3e3 },
    { 0xbbd2e7d9, 0xbc08c2c3 }, { 0x3c03ef1b, 0xbcabbb76 }, { 0x3c122a9f, 0xbc7f1cef },
    { 0xba096e26, 0x3a4d8f08 }, { 0x3c83c744, 0xbc83a2be }, { 0xba71a16a, 0x3c2808f0 },
    { 0x3d0fc56f, 0x3c022393 }, { 0x3d8e0b95, 0x3f08f7cb }, { 0xbe9d98ab, 0x3f1b7fd4 },
    { 0x3c793666, 0x3db430de }, { 0xbd60d86a, 0x3e7c4665 }, { 0xbe0f44f1, 0x3e41488b },
    { 0xbd2e4e2b, 0x3db7e26f }, { 0x3e497768, 0xbae75ff9 }, { 0x3c16eb97, 0x3d23a49c },
    { 0x3ed827b2, 0x3d69369d }, { 0x3c3109d0, 0x3e47a973 }, { 0xbc43f5a1, 0x3cbb7511 },
    { 0x3d887217, 0x3e0c9442 }, { 0x3d0ee0b2, 0x3b973500 }, { 0x3caca6eb, 0xbc2d82ce },
    { 0x3ce196c3, 0x3cd0e3d8 }, { 0x3d82b25f, 0xbcd1c5b7 }, { 0x3bf44a38, 0x3b9a53fc },
    { 0xbc801af2, 0x3c84af7e }, { 0x3b998b0d, 0x3bb2dd02 }, { 0xbbe631aa, 0x3ca83b20 },
    { 0x3ba60f36, 0xbc7772a6 }, { 0x399d220d, 0xbae6c0d5 }, { 0x3c5f04b1, 0xbc59277f },
    { 0x3b479d82, 0x3baa8871 }, { 0x3cdf115c, 0x3ac1199a }, { 0x3b8cacc5, 0x3f0faacd },
    { 0x3ec02ebd, 0xbf1ab0a2 }, { 0x3cb095ed, 0x3dae4057 }, { 0xbda9df54, 0x3e8b8b03 },
    { 0x3e585a05, 0xbe3c5a5a }, { 0x3d7495ee, 0xbd93c3ea }, { 0x3e4f6cfe, 0x3b7cdd57 },
    { 0xbb16c3dc, 0x3d32e5ac }, { 0x3eddd5dc, 0x3dbd1998 }, { 0x3c188364, 0xbe515f59 },
    { 0x3ca13dae, 0xbc30f772 }, { 0xbd84e2d9, 0xbe0f1c91 }, { 0x3cfd81da, 0x3c6d3fb0 },
    { 0x3cd5f370, 0xbbb43bda }, { 0x3d029587, 0x3d4c1957 }, { 0x3daea36c, 0x3c38867d },
    { 0xbb3ef2a7, 0xbbe9601a }, { 0x3c99d1ae, 0xbca32b4e }, { 0xbbdac725, 0xbbd46c0a },
    { 0x3c11cf2b, 0xbcb6338e }, { 0x3bce7dee, 0xbc802b28 }, { 0x39a77f36, 0xb9daf11c },
    { 0x3c420174, 0xbc85d9e0 }, { 0xb9b92d69, 0x3c1c6a55 }, { 0x3cf76575, 0x3be42588 },
    { 0x3d44cbd6, 0x3f0439a1 }, { 0xbea5b9fb, 0x3f16060a }, { 0x3d042d27, 0x3dd599ca },
    { 0xbd645ced, 0x3e7f06e2 }, { 0xbe071b4f, 0x3e453e13 }, { 0xbd0e9f83, 0x3dc8edeb },
    { 0x3e4bf957, 0x3b38fa2f }, { 0x3c0f2924, 0x3d325ad0 }, { 0x3ed42720, 0x3d381b12 },
    { 0x3ca7c449, 0x3e356ae4 }, { 0xbc653431, 0x3cd27e2b }, { 0x3d960156, 0x3e061b2d },
    { 0x3d07d6bf, 0x3c149c19 }, { 0x3c9a1959, 0xbc5893fa }, { 0x3ce562de, 0x3ce5a048 },
    { 0x3d79fa55, 0xbcf24f6a }, { 0x3c06e167, 0x3bbfbc1a }, { 0xbc7e8f3c, 0x3c968c3f },
    { 0x3b7eede3, 0x3b8171da }, { 0xbc0a2f42, 0x3cc1604e }, { 0x3b874d78, 0xbc5f0e28 },
    { 0x3ab24113, 0xbae4d78f }, { 0x3c19a4ab, 0xbc5b0524 }, { 0x3b7735fa, 0x3b8a34e4 },
    { 0x3cb16f2b, 0x3ad36f25 }, { 0xbc935d81, 0x3f0c78e7 }, { 0x3ecab7e4, 0xbf177958 },
    { 0x3d0bb859, 0x3dc02176 }, { 0xbdaed994, 0x3e8d22a4 }, { 0x3e53d5c2, 0xbe435b67 },
    { 0x3d621ec6, 0xbda2654a }, { 0x3e518db5, 0xba5b42ee }, { 0xbb51c9f7, 0x3d4a4272 },
    { 0x3eddb94b, 0x3dad80e9 }, { 0xbaf2f2e4, 0xbe4442f8 }, { 0x3cb35d0d, 0xbc8350ff },
    { 0xbd9601f5, 0xbe05ffab }, { 0x3cf61e4f, 0x3c6d859d }, { 0x3cbb8eec, 0xbc3d6881 },
    { 0x3d07325f, 0x3d5d6979 }, { 0x3daee61d, 0x3bfd0294 }, { 0xbb7387b8, 0xbc1577da },
    { 0x3ca03cbb, 0xbcb9c823 }, { 0xbbcb5ecc, 0xbb544528 }, { 0x3c252fd5, 0xbcbeaa35 },
    { 0x3b698e9d, 0xbc81189a }, { 0x3a880fdf, 0xbb042142 }, { 0x3bfb8dfe, 0xbc802472 },
    { 0x3a518bfa, 0x3c0e25e7 }, { 0x3cd06836, 0x3bcefa22 }, { 0x3cda05ff, 0x3f02997b },
    { 0xbeb0aeff, 0x3f133e6c }, { 0x3d52b1da, 0x3df5a46d }, { 0xbd6fc7b1, 0x3e81bb2c },
    { 0xbdff199a, 0x3e478b25 }, { 0xbcee18cf, 0x3dd7e8ba }, { 0x3e508bc8, 0x3b79f8f7 },
    { 0x3bf1c343, 0x3d4c9ce7 }, { 0x3ed53ebd, 0x3d09ca18 }, { 0x3cf90ac9, 0x3e267e3c },
    { 0xbc870365, 0x3cf83428 }, { 0x3da33e95, 0x3e003d7a }, { 0x3cfc9e4d, 0x3c3fa271 },
    { 0x3c8a8821, 0xbc81ac5a }, { 0x3cf8af57, 0x3d05f4b8 }, { 0x3d6f3055, 0xbd05d61b },
    { 0x3c0c8bf0, 0x3be1135f }, { 0xbc7f6a1e, 0x3caded02 }, { 0x3b5b8b2d, 0x3b2811f8 },
    { 0xbc1f12a3, 0x3cd37119 }, { 0x3b1dfed9, 0xbc67595b }, { 0x3adab092, 0xbb1e7e61 },
    { 0x3bc29404, 0xbc5c9b50 }, { 0x3b9d9401, 0x3b43175a }, { 0x3c8d527e, 0x3ab28ac9 },
    { 0xbd28325a, 0x3f0aeec3 }, { 0x3ed60e61, 0xbf15189b }, { 0x3d4e81f1, 0x3dde5f95 },
    { 0xbdb24e9f, 0x3e8eb183 }, { 0x3e4c357c, 0xbe478ce8 }, { 0x3d5a0713, 0xbdb628fe },
    { 0x3e5a5792, 0xba7aac2f }, { 0xbb56006f, 0x3d7b4f98 }, { 0x3edf399d, 0x3d99fd99 },
    { 0xbc628037, 0xbe35a49a }, { 0x3cd38610, 0xbcd24c36 }, { 0xbda59e54, 0xbdff34ba },
    { 0x3d01c75f, 0x3c842d18 }, { 0x3ca4e043, 0xbc71dbd1 }, { 0x3d149bd0, 0x3d739d77 },
    { 0x3dac1b2a, 0x3b9ab4d5 }, { 0xbb80409a, 0xbc33fd09 }, { 0x3ca40f70, 0xbcd1232a },
    { 0xbb9c28f2, 0xbabdd434 }, { 0x3c30dba2, 0xbccda270 }, { 0x3b0ef499, 0xbc81dc87 },
    { 0x3b4052a0, 0xbb3bf2fa }, { 0x3b9738c7, 0xbc68d8d7 }, { 0x3b4e83e1, 0x3bd91226 },
    { 0x3ca89ea1, 0x3ba656bd }, { 0xba0febec, 0x3f01955f }, { 0xbebd86e1, 0x3f11cb9f },
    { 0x3d8a63c2, 0x3e0a7abb }, { 0xbd746697, 0x3e820819 }, { 0xbdeaf3a1, 0x3e46a8f4 },
    { 0xbcda7235, 0x3debe630 }, { 0x3e52fcd1, 0x3adce4fd }, { 0x3bc34f6d, 0x3d72a6ef },
    { 0x3ed72de8, 0x3caf8121 }, { 0x3d26e6bc, 0x3e18958c }, { 0xbc9da412, 0x3d19390b },
    { 0x3db1cf9a, 0x3df35351 }, { 0x3ce57f65, 0x3c3b4b8f }, { 0x3c73a355, 0xbc8a1c44 },
    { 0x3d0fc39e, 0x3d12e419 }, { 0x3d5cd66b, 0xbd0b6a9c }, { 0x3c0496d5, 0x3bf91a9d },
    { 0xbc752ba0, 0x3cc10fa3 }, { 0x3b1ff3f6, 0x3b11273a }, { 0xbc1eb7cd, 0x3cde1120 },
    { 0xba04dbd6, 0xbc814859 }, { 0x3b05a869, 0xbb683753 }, { 0x3b30187b, 0xbc5e46f4 },
    { 0x3bc5eeb1, 0x3aa0f076 }, { 0x3c5bd47e, 0x39826014 }, { 0xbd862192, 0x3f09b319 },
    { 0x3ee1e096, 0xbf12e04d }, { 0x3d85b7fa, 0x3e0476d0 }, { 0xbdb3bd39, 0x3e8d97b0 },
    { 0x3e4123ca, 0xbe468a0f }, { 0x3d5cfb25, 0xbdd24c36 }, { 0x3e633313, 0x3b43f500 },
    { 0xbb4614a9, 0x3d9e361b }, { 0x3edf9e15, 0x3d7fd92b }, { 0xbcd6efbf, 0xbe265ed5 },
    { 0x3cf7ef45, 0xbd1dbccc }, { 0xbdb501f7, 0xbdf571b3 }, { 0x3d0f0e56, 0x3ca3408e },
    { 0x3c8b0883, 0xbc7c8bc1 }, { 0x3d2bf1c4, 0x3d7ebd28 }, { 0x3da47c98, 0x3b29e2ed },
    { 0xbb7030fb, 0xbc4b141d }, { 0x3c9f0a95, 0xbcdd4d5a }, { 0xbb4684e3, 0xba4c3385 },
    { 0x3c1df06f, 0xbce6b08f }, { 0x3a670ec6, 0xbc78c8e5 }, { 0x3bb2c2ca, 0xbb5a0f68 },
    { 0x3b05b6b6, 0xbc57c9e0 }, { 0x3bc8a8e8, 0x3b6e10ac }, { 0x3c815f24, 0x3b4c1bdc },
    { 0xbcfcec1a, 0x3efdfb75 }, { 0xbec8eb1f, 0x3f0fd6a1 }, { 0x3da7cfcb, 0x3e14f787 },
    { 0xbd64620a, 0x3e7c2b72 }, { 0xbdcd0009, 0x3e3e1344 }, { 0xbcd7b43f, 0x3e02436a },
    { 0x3e55542b, 0xbb66c08e }, { 0x3bec7ab7, 0x3d935f7b }, { 0x3ed7030b, 0x3c192aa8 },
    { 0x3d4a2a41, 0x3e0a3e97 }, { 0xbcb44caa, 0x3d43d0d7 }, { 0x3dbcdc94, 0x3de3ef86 },
    { 0x3cdc5dc4, 0x3c132ceb }, { 0x3c4bbf25, 0xbc857c63 }, { 0x3d2b1755, 0x3d1e69fd },
    { 0x3d3f4616, 0xbd0271be }, { 0x3bd15885, 0x3c01e023 }, { 0xbc6eb62f, 0x3ccee265 },
    { 0x3a0226f8, 0x3b17fca9 }, { 0xbc1e1cd5, 0x3ce35f4a }, { 0xbb5900de, 0xbc8c5dfb },
    { 0x3b4b4c46, 0xbbaa271d }, { 0xba39311d, 0xbc4df101 }, { 0x3bfe9594, 0xba238e3e },
    { 0x3c22602e, 0xbae10c6d }, { 0xbdb682f0, 0x3f08316d }, { 0x3eec9c3c, 0xbf10c110 },
    { 0x3d9f3ebb, 0x3e18c109 }, { 0xbdae46f6, 0x3e899993 }, { 0x3e3316ce, 0xbe3ed3ce },
    { 0x3d6491eb, 0xbdf358d4 }, { 0x3e69e132, 0x3bbbe4b5 }, { 0xbb22e47b, 0x3dbdfb76 },
    { 0x3edf64a7, 0x3d4c7a20 }, { 0xbd14f23b, 0xbe18a24c }, { 0x3d0bbca1, 0xbd507bfc },
    { 0xbdc2599b, 0xbdebcd04 }, { 0x3d1919a4, 0x3cbdae1b }, { 0x3c53bfe2, 0xbc79f7ca },
    { 0x3d4d7d65, 0x3d81ab17 }, { 0x3d988ffe, 0x3b530f6b }, { 0xbb21d1c8, 0xbc5d6128 },
    { 0x3c996bd8, 0xbce1ce6f }, { 0xba9db705, 0xb8cc635e }, { 0x3bff1ad3, 0xbcffc50d },
    { 0xbac8faf2, 0xbc6c9f33 }, { 0x3bf1aabb, 0xbb9364f3 }, { 0xba0e4939, 0xbc46d7b3 },
    { 0x3c0d3538, 0x3aabf965 }, { 0x3c3fe8c2, 0x3a43d2e7 }, { 0xbd6a7ce3, 0x3ef80d2f },
    { 0xbed22d6f, 0x3f0d6355 }, { 0x3dc6aeab, 0x3e1da683 }, { 0xbd455c3e, 0x3e6e2db8 },
    { 0xbdabb5df, 0x3e2f3e1f }, { 0xbcdcae0b, 0x3e0f563b }, { 0x3e5c5ed9, 0xbc0835b1 },
    { 0x3c2e5166, 0x3db264ed }, { 0x3ed5457a, 0xb9042767 }, { 0x3d638fb9, 0x3dfc2c5a },
    { 0xbcc381ac, 0x3d760005 }, { 0x3dc561dc, 0x3dd2edab }, { 0x3cf3cf7e, 0x3c03fa84 },
    { 0x3c1732ef, 0xbc72774d }, { 0x3d48b80f, 0x3d2b75bb }, { 0x3d1d0893, 0xbcdecc8f },
    { 0x3b8942a6, 0x3bfabf7f }, { 0xbc6a91fc, 0x3cd630a7 }, { 0xbaf985da, 0x3b10246f },
    { 0xbc164f73, 0x3ce93916 }, { 0xbba379c4, 0xbc8769b6 }, { 0x3b8cb697, 0xbbdef8c1 },
    { 0xbb6f11bb, 0xbc24c461 }, { 0x3c20833f, 0xbb1690ca }, { 0x3beca842, 0xbb8cdd34 },
    { 0xbddfd204, 0x3f066c4b }, { 0x3ef5c7af, 0xbf0ea55a }, { 0x3db212e0, 0x3e2bd704 },
    { 0xbda4fe7f, 0x3e836f94 }, { 0x3e243e05, 0xbe31b1c9 }, { 0x3d72e6bd, 0xbe0b489b },
    { 0x3e7055aa, 0x3b9bd63d }, { 0xbaa368bd, 0x3ddfa89f }, { 0x3edebf93, 0x3d224351 },
    { 0xbd33e4ae, 0xbe0df01f }, { 0x3d183693, 0xbd81f5f1 }, { 0xbdcc65a9, 0xbde05534 },
    { 0x3d249ad0, 0x3cc2d7d1 }, { 0x3bfc0155, 0xbc6b890f }, { 0x3d739217, 0x3d814718 },
    { 0x3d8a4912, 0x3bbaf120 }, { 0xba504c47, 0xbc63aa3c }, { 0x3c93cfef, 0xbce27d68 },
    { 0x3a2afc98, 0x3a0ee92f }, { 0x3bc3dc71, 0xbd08ab6f }, { 0xbb929508, 0xbc688b24 },
    { 0x3c03f914, 0xbbd5be84 }, { 0xbb471f50, 0xbc2be723 }, { 0x3c3807b7, 0xba0b0c91 },
    { 0x3c105575, 0xbb0ce66b }, { 0xbd9e740a, 0x3ef42515 }, { 0xbed7e5cd, 0x3f0a8d06 },
    { 0x3dddf2be, 0x3e2abf35 }, { 0xbd1e9060, 0x3e5a8a2c }, { 0xbd8a5780, 0x3e1b0b4f },
    { 0xbceba1c1, 0x3e1c4747 }, { 0x3e63586f, 0xbbcc4443 }, { 0x3c6a623f, 0x3dd0c38d },
    { 0x3ed0e7d0, 0xbc13bbd2 }, { 0x3d7640bd, 0x3de71d13 }, { 0xbcca109b, 0x3d930607 },
    { 0x3dcc03ed, 0x3dc8ca03 }, { 0x3d0a0507, 0x3c267955 }, { 0x3b9fb790, 0xbc47c4cb },
    { 0x3d6414a1, 0x3d2d8e7f }, { 0x3cef40f9, 0xbcaf43d7 }, { 0x3af1da00, 0x3bdf5e01 },
    { 0xbc5776a4, 0x3cd422d7 }, { 0xbb8cfc15, 0x3b195bb0 }, { 0xbbd37b2b, 0x3cef9ee5 },
    { 0xbbb4a92d, 0xbc7d1ce3 }, { 0x3ba6b02a, 0xbc045c0d }, { 0xbba704eb, 0xbc0afee9 },
    { 0x3c3d9a52, 0xbb75c57e }, { 0x3bade923, 0xbbde6545 }, { 0xbdfe534e, 0x3f0490c6 },
    { 0x3efa8a8f, 0xbf0c39d3 }, { 0x3dba8edf, 0x3e3f52fa }, { 0xbd97ac07, 0x3e773532 },
    { 0x3e1527a5, 0xbe2206dd }, { 0x3d858b76, 0xbe1c43a0 }, { 0x3e746059, 0x3b8e9912 },
    { 0x398a2e94, 0x3dff6335 }, { 0x3edb40ed, 0x3d002823 }, { 0xbd493d7f, 0xbe0509eb },
    { 0x3d205fb6, 0xbd9a847c }, { 0xbdd003b5, 0xbdd86f0c }, { 0x3d34c586, 0x3cbb59de },
    { 0x3ace59d3, 0xbc44be6f }, { 0x3d8a4841, 0x3d73d35a }, { 0x3d769d65, 0x3c11045f },
    { 0x3a75adaa, 0xbc5dc19d }, { 0x3c85dafc, 0xbcdb1de9 }, { 0x3b27af98, 0x39b1b2e4 },
    { 0x3b79ce9b, 0xbd0cf1e6 }, { 0xbbc35454, 0xbc7000f6 }, { 0x3bfcac23, 0xbc0f1960 },
    { 0xbb8c0e39, 0xbc1ec658 }, { 0x3c637603, 0xbb0bb8c5 }, { 0x3be92496, 0xbba4f7f3 },
    { 0xbdb4216b, 0x3ef097f5 }, { 0xbed962df, 0x3f07cce3 }, { 0x3ded3efe, 0x3e3d35dd },
    { 0xbce1dc3a, 0x3e447965 }, { 0xbd57306d, 0x3e04cb92 }, { 0xbd0c76fa, 0x3e2e6a93 },
    { 0x3e68c2bb, 0x3a2a2e94 }, { 0x3c8c6a21, 0x3dee4604 }, { 0x3eca79e1, 0xbc729097 },
    { 0x3d7d7762, 0x3dd785e3 }, { 0xbcd1b7d8, 0x3da98946 }, { 0x3dcfa9c8, 0x3dc90f3d },
    { 0x3d1adc89, 0x3c40b65f }, { 0x3a785e42, 0xbc056836 }, { 0x3d8204b2, 0x3d24ddf4 },
    { 0x3ca3a887, 0xbc75c73f }, { 0xba168dba, 0x3bbba200 }, { 0xbc3ab6ac, 0x3cd10fdc },
    { 0xbbcf38bc, 0x3b58aac5 }, { 0xbb34110c, 0x3cf6ad77 }, { 0xbbb73977, 0xbc70940c },
    { 0x3ba75a36, 0xbc19f0fc }, { 0xbbaf4d31, 0xbbf3c0df }, { 0x3c5694ac, 0xbb9c1504 },
    { 0x3b85be3b, 0xbc0d753a }, { 0xbe05882c, 0x3f027378 }, { 0x3efb9568, 0xbf0a26f2 },
    { 0x3dc3543d, 0x3e56b368 }, { 0xbd84d907, 0x3e665b39 }, { 0x3e0632d8, 0xbe11cb26 },
    { 0x3d9c00a2, 0xbe32fa44 }, { 0x3e7a0666, 0x3bdc9ed5 }, { 0x3a20a4da, 0x3e0d5e0a },
    { 0x3ed611fd, 0x3cdc7fae }, { 0xbd52f5ba, 0xbdfcd2e0 }, { 0x3d2ad8a9, 0xbdaf0924 },
    { 0xbdce6a03, 0xbdd7b691 }, { 0x3d508fb2, 0x3caa3317 }, { 0xbb3c61ed, 0xbc08246d },
    { 0x3d9c14e1, 0x3d5fd41d }, { 0x3d570a14, 0x3c4d62b0 }, { 0x3b3d41cc, 0xbc52aaaf },
    { 0x3c64f9aa, 0xbcd64a75 }, { 0x3b92d9fb, 0xba32936a }, { 0x3adcd77e, 0xbd0e98db },
    { 0xbbb35da4, 0xbc6ac9f4 }, { 0x3bdd897a, 0xbc31a359 }, { 0xbb919392, 0xbc117f54 },
    { 0x3c82699d, 0xbb29b62f }, { 0x3bc98aa7, 0xbbf1425b }, { 0xbdba5164, 0x3eecf21a },
    { 0xbed85c8f, 0x3f05940e }, { 0x3df4e6a6, 0x3e4dbdc9 }, { 0xbc82e2c8, 0x3e2e124c },
    { 0xbd1f2728, 0x3dde8604 }, { 0xbd328628, 0x3e414c18 }, { 0x3e6e2289, 0x3bd267a1 },
    { 0x3c8818be, 0x3e0208ea }, { 0x3ec42951, 0xbc8f4fc1 }, { 0x3d7f0cf0, 0x3dcdac24 },
    { 0xbcded20b, 0x3db703eb }, { 0x3dd24fee, 0x3dd00173 }, { 0x3d2a8e48, 0x3c3ae70e },
    { 0xbac29e1e, 0xbb7024de }, { 0x3d9035c6, 0x3d16a39e }, { 0x3c3d0ca0, 0xbc13cf7f },
    { 0xbb328269, 0x3b90c68a }, { 0xbc1d748d, 0x3ccb7ad2 }, { 0xbbeb7501, 0x3baaccb3 },
    { 0xb9fa2efd, 0x3cf80717 }, { 0xbbc10720, 0xbc7817ff }, { 0x3b871ccf, 0xbc2d6bb8 },
    { 0xbb996727, 0xbbda5871 }, { 0x3c5cc4a6, 0xbbab7e9b }, { 0x3b65b97e, 0xbc25739b },
    { 0xbe03dff4, 0x3f00c08a }, { 0x3efa899e, 0xbf0899c1 }, { 0x3dcf6f4d, 0x3e6e7b24 },
    { 0xbd5bfa5b, 0x3e56ec64 }, { 0x3df03641, 0xbe026a1d }, { 0x3db6d392, 0xbe4b0ac3 },
    { 0x3e80f02b, 0x3c37f92e }, { 0x37d7b118, 0x3e196c8a }, { 0x3ed06e5d, 0x3cd7515c },
    { 0xbd56751a, 0xbdf4e1b8 }, { 0x3d3a0d91, 0xbdbe318a }, { 0xbdcc2c18, 0xbddc6b66 },
    { 0x3d74698a, 0x3ca0aae7 }, { 0xbb8b9526, 0xbb2fb8b7 }, { 0x3dab6643, 0x3d5128a5 },
    { 0x3d39d26c, 0x3c836cc8 }, { 0x3b9b95e0, 0xbc42d5dc }, { 0x3c435f53, 0xbcd5dff9 },
    { 0x3bba1a7d, 0xbb3d1310 }, { 0x39c17d12, 0xbd0f3389 }, { 0xbb88ccd5, 0xbc580f11 },
    { 0x3bb74978, 0xbc45de7b }, { 0xbb845842, 0xbbf9ae6c }, { 0x3c8d7cfa, 0xbb06c443 },
    { 0x3bc498ee, 0xbc186719 }, { 0xbdb788f5, 0x3eeb6575 }, { 0xbed6e6bb, 0x3f04e4bd },
    { 0x3df397c6, 0x3e5e1e11 }, { 0xbb9e8c1c, 0x3e1939fd }, { 0xbccfdbe4, 0x3db740bf },
    { 0xbd64c432, 0x3e530128 }, { 0x3e73af42, 0x3c26f1fe }, { 0x3c33ec55, 0x3e09b3de },
    { 0x3ebff375, 0xbc99cef0 }, { 0x3d824e90, 0x3dc9b402 }, { 0xbcf890a3, 0x3dba958a },
    { 0x3dd6e494, 0x3ddc1f4f }, { 0x3d37db4e, 0x3c1caaa3 }, { 0xbb0e3018, 0x3a88615a },
    { 0x3d9de812, 0x3d09f017 }, { 0x3b5c2c38, 0xbb93508b }, { 0xbb8b7e09, 0x3b48cc2e },
    { 0xbc0459d7, 0x3cc5315a }, { 0xbbd9ebba, 0x3c09f6cf }, { 0x3a45fed5, 0x3cefb8a5 },
    { 0xbbdeaf1d, 0xbc959b23 }, { 0x3b113846, 0xbc3d4013 }, { 0xbb36b779, 0xbbde750c },
    { 0x3c52ed2b, 0xbb9e48a3 }, { 0x3b663494, 0xbc3b0eff }, { 0xbdfd41c5, 0x3f00893f },
    { 0x3ef8a7ae, 0xbf0835ef }, { 0x3dd50f57, 0x3e83ce7c }, { 0xbd2dfc09, 0x3e4ae445 },
    { 0x3dd82094, 0xbdeb4193 }, { 0x3dd2bc34, 0xbe60da5c }, { 0x3e83b86b, 0x3c8eca45 },
    { 0xbb02c7ef, 0x3e25f34d }, { 0x3ecbd19f, 0x3ce086f9 }, { 0xbd594561, 0xbdf2d52a },
    { 0x3d50b2de, 0xbdc99b07 }, { 0xbdce587a, 0xbde65867 }, { 0x3d88a5af, 0x3ca35c2c },
    { 0xbb332a0d, 0x3b8e8e77 }, { 0x3db9750d, 0x3d48a858 }, { 0x3d210102, 0x3c970462 },
    { 0x3bc7f9f0, 0xbc2cfbb2 }, { 0x3c28da14, 0xbcd8c4e9 }, { 0x3bbd7c6c, 0xbbd72e0b },
    { 0xbab72ea6, 0xbd0e9894 }, { 0xbb719823, 0xbc54e87e }, { 0x3b93973d, 0xbc47a5ef },
    { 0xbb3268a9, 0xbbef169e }, { 0x3c96b8aa, 0xba8e5d6f }, { 0x3bd9826d, 0xbc2f9a57 },
    { 0xbdad7d3a, 0x3eec4b9d }, { 0xbed3c727, 0x3f054aba }, { 0x3de72b9f, 0x3e68c4d1 },
    { 0x3be984d0, 0x3e05cb24 }, { 0xbc2ebe7c, 0x3d952b8e }, { 0xbd8c26c2, 0x3e602e40 },
    { 0x3e78b0de, 0x3c81179b }, { 0xbafa4530, 0x3e0da50f }, { 0x3ebd1e08, 0xbca0f51d },
    { 0x3d8828c7, 0x3dc8b4be }, { 0xbd121d0c, 0x3db300c4 }, { 0x3dda3e6d, 0x3dec35c8 },
    { 0x3d44b8b0, 0x3ba7122b }, { 0x371fddbe, 0x3bc4678c }, { 0x3da88849, 0x3d03fb8b },
    { 0xbb8fd040, 0xbafb7380 }, { 0xbba532e1, 0x3ae2b1cc }, { 0xbbef767d, 0x3cbca4fa },
    { 0xbb9baab0, 0x3c554d91 }, { 0x3b0c9b55, 0x3ce5cce3 }, { 0xbc096848, 0xbcb57987 },
    { 0xba8a73a2, 0xbc502e80 }, { 0x38ec3d58, 0xbc02020b }, { 0x3c3dbcbb, 0xbb5e1520 },
    { 0x3b76e783, 0xbc531079 }, { 0xbdee016b, 0x3f003e3b }, { 0x3ef2b5f5, 0xbf0737c1 },
    { 0x3dcd246a, 0x3e8bdaca }, { 0xbcfd98ea, 0x3e3c5262 }, { 0x3dbd2e5d, 0xbdd00c3b },
    { 0x3de84aa6, 0xbe70123a }, { 0x3e839e24, 0x3cdce293 }, { 0xbbe53c6a, 0x3e2f7755 },
    { 0x3ec5f562, 0x3ce200b5 }, { 0xbd5b1ac8, 0xbdefca51 }, { 0x3d6a479f, 0xbdcc7122 },
    { 0xbdcecf6a, 0xbdf3a4f3 }, { 0x3d8f41c8, 0x3c92acf6 }, { 0x3ad6fa6e, 0x3c383509 },
    { 0x3dc49194, 0x3d444128 }, { 0x3d038901, 0x3ca0b616 }, { 0x3be7f304, 0xbc0fb809 },
    { 0x3c174e14, 0xbcda2e51 }, { 0x3ba6aec5, 0xbc324631 }, { 0xbb818a4b, 0xbd0d7cc9 },
    { 0xbb97a685, 0xbc546e83 }, { 0x3b313805, 0xbc4336b3 }, { 0xbaa77d40, 0xbc0a44c8 },
    { 0x3c9c5b57, 0x39eef60a }, { 0x3bee1b9c, 0xbc408ab3 }, { 0xbd910194, 0x3ef17e33 },
    { 0xbed04b00, 0x3f090dd6 }, { 0x3dd409af, 0x3e6be83b }, { 0x3ccad08e, 0x3ded46eb },
    { 0x3be08af6, 0x3d7f5877 }, { 0xbda9d753, 0x3e644a47 }, { 0x3e830bb3, 0x3cbeac1d },
    { 0xbcaf4d78, 0x3e1137c5 }, { 0x3ebe188c, 0xbca3d753 }, { 0x3d9139ea, 0x3dcc3c5f },
    { 0xbd396246, 0x3da3149a }, { 0x3ddff764, 0x3e044111 }, { 0x3d547c8f, 0x3b761cfd },
    { 0x3bf14248, 0x3c4eeba9 }, { 0x3dade616, 0x3d16a5f1 }, { 0xbc37ea9a, 0xb835a5f0 },
    { 0xbbbdbd59, 0x3a153979 }, { 0xbc0bc6f5, 0x3cb38db6 }, { 0xbb0176ae, 0x3ca2dbc2 },
    { 0x3b2885a6, 0x3cdb9036 }, { 0xbc167ff5, 0xbcdc0010 }, { 0xbb99a074, 0xbc68998b },
    { 0x3b9d673c, 0xbc1a33c0 }, { 0x3c23bd0d, 0xba33c31b }, { 0x3b8374f3, 0xbc6f7cde },
    { 0xbdd893cd, 0x3eff44da }, { 0x3eeb7b6b, 0xbf06f7e3 }, { 0x3dbe78ac, 0x3e8e0c59 },
    { 0xbcafcc35, 0x3e2c624d }, { 0x3d9fdc76, 0xbdb42708 }, { 0x3dfc98c6, 0xbe747e1c },
    { 0x3e85149d, 0x3d05fb3b }, { 0xbc968ad8, 0x3e32e4b9 }, { 0x3ec1565c, 0x3cd53b6a },
    { 0xbd5feceb, 0xbdebeff9 }, { 0x3d83ff7a, 0xbdc3b49f }, { 0xbdd29544, 0xbe0237f3 },
    { 0x3d8fbe81, 0x3c858e68 }, { 0x3bbfc9f2, 0x3c708fce }, { 0x3dcdb3c0, 0x3d4ea3e7 },
    { 0x3cc64c09, 0x3ca0afdf }, { 0x3bfa4ca2, 0xbbde4856 }, { 0x3c1916ed, 0xbce0a158 },
    { 0x3b4631a1, 0xbc672f07 }, { 0xbb984c2e, 0xbd060354 }, { 0xbbbba2ad, 0xbc6a2210 },
    { 0xb940e9da, 0xbc4acf2d }, { 0xb88020d4, 0xbc3101a4 }, { 0x3c9b2a8e, 0x3b1632ef },
    { 0x3bf2b6e7, 0xbc4ea8a9 }, { 0xbd3a4a85, 0x3efcb69a }, { 0xbecd6e0c, 0x3f10d609 },
    { 0x3dc08218, 0x3e6f6a11 }, { 0x3d3e5572, 0x3dd92250 }, { 0x3cf22ee7, 0x3d6483ae },
    { 0xbdcfc636, 0x3e6480a0 }, { 0x3e8f0b2e, 0x3d1d68ac }, { 0xbd3f4990, 0x3e107685 },
    { 0x3ec188c8, 0xbcafec5d }, { 0x3d9d880f, 0x3dd29a2d }, { 0xbd6e1b8b, 0x3d8b3b1c },
    { 0x3de8bcdb, 0x3e1c9c73 }, { 0x3d7a2028, 0x3bfb8bb1 }, { 0x3c898cd4, 0x3cbc36f3 },
    { 0x3db3e98b, 0x3d35f44e }, { 0xbc9e28d0, 0x3a967d6c }, { 0xbbeaaa6f, 0xba83e863 },
    { 0xbc260fa4, 0x3cadef8b }, { 0x39aee73c, 0x3ce9cff1 }, { 0x3b986206, 0x3cdee487 },
    { 0xbc07e522, 0xbcfc50b9 }, { 0xbbf3e056, 0xbc83a33b }, { 0x3c276b6c, 0xbc3a6023 },
    { 0x3c041020, 0x3b336b8b }, { 0x3b720ab4, 0xbc8a6d46 }, { 0xbdba1738, 0x3f006442 },
    { 0x3ee59eae, 0xbf08ff70 }, { 0x3daa0053, 0x3e8e6baa }, { 0xbc5673a6, 0x3e226db3 },
    { 0x3d858976, 0xbda21153 }, { 0x3e0c5867, 0xbe73b76f }, { 0x3e8a413b, 0x3d1d3278 },
    { 0xbd0fcb97, 0x3e323bf4 }, { 0x3ebee87d, 0x3cc80624 }, { 0xbd686e21, 0xbde930a1 },
    { 0x3d96b321, 0xbdb481f0 }, { 0xbddcb8ff, 0xbe0e1813 }, { 0x3d9270a7, 0x3c7cbe2f },
    { 0x3c1f91f5, 0x3c86a784 }, { 0x3dd90716, 0x3d663eb1 }, { 0x3c95ce5a, 0x3c95bac9 },
    { 0x3bfd1d22, 0xbb9d004a }, { 0x3c1ed969, 0xbcf183df }, { 0xb9086689, 0xbc8af047 },
    { 0xbbac248e, 0xbcf5571d }, { 0xbbcc54b1, 0xbc8572a5 }, { 0xbb529b95, 0xbc607cc3 },
    { 0x3aa6ae37, 0xbc63b5e2 }, { 0x3c994138, 0x3b9065e6 }, { 0x3bf3584e, 0xbc59a4ec },
    { 0xbc2c3a6d, 0x3f06786e }, { 0xbec88607, 0x3f1b52b0 }, { 0x3dad2c3c, 0x3e6c0071 },
    { 0x3d928683, 0x3dd6d335 }, { 0x3d5f0c3e, 0x3d629645 }, { 0xbdf9bc5d, 0x3e5769ed },
    { 0x3e9bbf41, 0x3d74b5fd }, { 0xbd9cc75a, 0x3e068901 }, { 0x3ec43ef1, 0xbcd6ded4 },
    { 0x3dabe151, 0x3dda0a76 }, { 0xbd94eaed, 0x3d550d89 }, { 0x3df243df, 0x3e3c30a6 },
    { 0x3d97bbec, 0x3c899143 }, { 0x3cc74e17, 0x3d10714b }, { 0x3db8b2f2, 0x3d67f435 },
    { 0xbcdd5e8d, 0xb81a6bfb }, { 0xbc0b7838, 0xbb15ced2 }, { 0xbc49bc34, 0x3cb2dec6 },
    { 0x3b1ef5a6, 0x3d132b46 }, { 0x3c091986, 0x3cf063c2 }, { 0xbbd19237, 0xbd0ef170 },
    { 0xbbfd53e1, 0xbc8d346b }, { 0x3c7a9c74, 0xbc7827e1 }, { 0x3bcee877, 0x3beea441 },
    { 0x3b326fc8, 0xbca30dba }, { 0xbd8e916e, 0x3f0391e5 }, { 0x3edf9b9b, 0xbf0d91f3 },
    { 0x3d9633ea, 0x3e8cb38c }, { 0xbb8f5996, 0x3e1c94e4 }, { 0x3d52efcf, 0xbd9763fb },
    { 0x3e1e5712, 0xbe6c2779 }, { 0x3e92a087, 0x3d4ba7dc }, { 0xbd5e3e6a, 0x3e301fb6 },
    { 0x3ebd1710, 0x3cb0175e }, { 0xbd743319, 0xbde4d16f }, { 0x3dad07f3, 0xbda3f35b },
    { 0xbde9c7c4, 0xbe20a35a }, { 0x3d9c7258, 0x3c9120fe }, { 0x3c47cc17, 0x3c96da80 },
    { 0x3de530d3, 0x3d86a677 }, { 0x3c4fc7db, 0x3c873929 }, { 0x3c034946, 0xbb366ff9 },
    { 0x3c275db7, 0xbd05aaa6 }, { 0xbb597179, 0xbca21a1e }, { 0xbbca5933, 0xbce518a3 },
    { 0xbbb35238, 0xbc9d2fa4 }, { 0xbbb797d3, 0xbc7ec535 }, { 0x3b4e5808, 0xbc905b4b },
    { 0x3c9bae07, 0x3bd38fb9 }, { 0x3bed4643, 0xbc630a76 }, { 0x3cecc417, 0x3f0d4020 },
    { 0xbebcee4d, 0x3f245d82 }, { 0x3d8e68e3, 0x3e592dde }, { 0x3dc06412, 0x3ddba6c8 },
    { 0x3da10055, 0x3d7b09e3 }, { 0xbe12e4b8, 0x3e395fe5 }, { 0x3ea1a24b, 0x3da45e07 },
    { 0xbdd92515, 0x3de90e6a }, { 0x3ec1b35d, 0xbd10bf25 }, { 0x3db6a0e6, 0x3dde6de9 },
    { 0xbdb1afcf, 0x3d012017 }, { 0x3df50486, 0x3e5aa935 }, { 0x3dadd72e, 0x3cdf8f54 },
    { 0x3cdcdf66, 0x3d3c8894 }, { 0x3db9a2ed, 0x3d92cf5d }, { 0xbd092d4f, 0xbba66ae4 },
    { 0xbc15d253, 0xbb59edd7 }, { 0xbc676415, 0x3cc12ed5 }, { 0x3b859a8c, 0x3d252d1f },
    { 0x3c63b4a9, 0x3d01c35b }, { 0xbbb9b7f4, 0xbd283926 }, { 0xbbc28628, 0xbc8b010c },
    { 0x3ca710ca, 0xbca8280f }, { 0x3b9e49ac, 0x3c49962f }, { 0x3af39f9a, 0xbcbd25a4 },
    { 0xbd28c961, 0x3f0927cf }, { 0x3ed7b3aa, 0xbf144a87 }, { 0x3d89ffe2, 0x3e8a099f },
    { 0x3bd0f83c, 0x3e1ac9e8 }, { 0x3d12203b, 0xbd95b67a }, { 0x3e34cd75, 0xbe5e9982 },
    { 0x3e9d4906, 0x3d8f3423 }, { 0xbd9447af, 0x3e2d76e3 }, { 0x3eba3ed5, 0x3c8adf78 },
    { 0xbd811502, 0xbdde6ba7 }, { 0x3dc66757, 0xbd93a0cc }, { 0xbdf695e0, 0xbe3b3dfd },
    { 0x3db434d7, 0x3cd126da }, { 0x3c59ca8a, 0x3cb68e60 }, { 0x3df0891d, 0x3da10b05 },
    { 0x3be93b29, 0x3c6c76e8 }, { 0x3c0c6c7e, 0xba3b93c8 }, { 0x3c2df33a, 0xbd146197 },
    { 0xbbc14257, 0xbcbd27cd }, { 0xbc050227, 0xbce98a89 }, { 0xbb46997c, 0xbcb4e92d },
    { 0xbbccb69d, 0xbc86bcc2 }, { 0x3ba538d3, 0xbcb47716 }, { 0x3ca20e89, 0x3c094f15 },
    { 0x3be0a142, 0xbc6c7f20 }, { 0x3d87b5d4, 0x3f0db942 }, { 0xbea6639b, 0x3f270d71 },
    { 0x3d2acdfc, 0x3e2aa04d }, { 0x3de40252, 0x3de196be }, { 0x3dca7925, 0x3d92b3eb },
    { 0xbe2482bf, 0x3e04d4a0 }, { 0x3e9b1e51, 0x3db30ee8 }, { 0xbe03063b, 0x3dbe3952 },
    { 0x3eb82a25, 0xbd31e87d }, { 0x3db746e9, 0x3dd89185 }, { 0xbdc7550e, 0x3c1f9c7e },
    { 0x3de75ae4, 0x3e6cb4fd }, { 0x3db1436c, 0x3d0ea3ef }, { 0x3cc8f4c4, 0x3d518f09 },
    { 0x3db1657f, 0x3db648be }, { 0xbd154584, 0xbc3e9d6a }, { 0xbc0b5415, 0xbb7bf3fb },
    { 0xbc7e35a6, 0x3ccc7fe6 }, { 0x3bac29f2, 0x3d24f266 }, { 0x3c9b656e, 0x3d000f6b },
    { 0xbbe6edaf, 0xbd476ceb }, { 0xbb18c852, 0xbc7a7680 }, { 0x3ccbc340, 0xbcd4d360 },
    { 0x3b7edeef, 0x3c879666 }, { 0x3ae5f9ad, 0xbccdbb13 }, { 0xbc11622e, 0x3f0f4fc6 },
    { 0x3ecc1d62, 0xbf1b0258 }, { 0x3d7d3e80, 0x3e832e27 }, { 0x3c974367, 0x3e1aeda4 },
    { 0x3c90a9b1, 0xbd97865d }, { 0x3e4cb408, 0xbe4413b0 }, { 0x3ea746a8, 0x3dbd9a13 },
    { 0xbdb3d960, 0x3e2a2f9a }, { 0x3eb65cf4, 0x3c2eb7ee }, { 0xbd862c62, 0xbdd65739 },
    { 0x3ddfb26e, 0xbd823dab }, { 0xbe014524, 0xbe5796fe }, { 0x3dcf5024, 0x3d1547ca },
    { 0x3c577565, 0x3cda88f4 }, { 0x3df9ef3b, 0x3dc34013 }, { 0x3a0a5212, 0x3c4343f7 },
    { 0x3c17e2ae, 0x3ab1fd12 }, { 0x3c392899, 0xbd2361a3 }, { 0xbc02615c, 0xbcd06050 },
    { 0xbc3b62e4, 0xbcf6b1fd }, { 0xbae63bdc, 0xbcd27f7a }, { 0xbb963833, 0xbc82b773 },
    { 0x3be56538, 0xbcd8ff5d }, { 0x3ca9503a, 0x3c2e1cd2 }, { 0x3bcfef0e, 0xbc759a4b },
    { 0x3dc7144f, 0x3f07b168 }, { 0xbe88bb99, 0x3f226d03 }, { 0x3c1492f2, 0x3dda4b20 },
    { 0x3df745aa, 0x3de501f6 }, { 0x3de2814c, 0x3daa83ae }, { 0xbe2cd7cd, 0x3d902000 },
    { 0x3e8d3dbb, 0x3dacf6a6 }, { 0xbe09c6f8, 0x3d992cba }, { 0x3ea83c29, 0xbd3fa455 },
    { 0x3dad2eeb, 0x3dc6c746 }, { 0xbdcf617e, 0xbbb858b9 }, { 0x3dcc8b92, 0x3e6f70ab },
    { 0x3daa7c4c, 0x3d21b68c }, { 0x3c8c69c7, 0x3d4fca61 }, { 0x3da21a0d, 0x3dd8a287 },
    { 0xbd0f9eec, 0xbc8eaafe }, { 0xbbe2e800, 0xbb72687a }, { 0xbc8287f4, 0x3cd32cf8 },
    { 0x3bba7856, 0x3d135781 }, { 0x3cb625ae, 0x3cec4474 }, { 0xbbe7ea20, 0xbd5b5d48 },
    { 0x3b3a63a9, 0xbc43716e }, { 0x3ce52475, 0xbcecd921 }, { 0x3b77b1b3, 0x3c99abb7 },
    { 0x3afede05, 0xbcd401a8 }, { 0x3cccdbce, 0x3f14958b }, { 0x3ebceca2, 0xbf1fc6bb },
    { 0x3d4c869c, 0x3e6e3ab7 }, { 0x3ceadc2a, 0x3e1b53e1 }, { 0xba7aa02f, 0xbd9924bc },
    { 0x3e61a1c1, 0xbe1f95dc }, { 0x3eac5c89, 0x3de330e4 }, { 0xbdcd2d3c, 0x3e269577 },
    { 0x3eb0d492, 0x3b07c6fb }, { 0xbd857eb9, 0xbdcc3628 }, { 0x3df41102, 0xbd60356e },
    { 0xbe047d43, 0xbe713670 }, { 0x3ddfabec, 0x3d3a05ed }, { 0x3c15d915, 0x3cf5634c },
    { 0x3e01bb1d, 0x3dea25b7 }, { 0xbbfb639a, 0x3c13eefe }, { 0x3c227737, 0x3b49841b },
    { 0x3c4541be, 0xbd33e044 }, { 0xbc122420, 0xbcd35e68 }, { 0xbc8547fe, 0xbd021a36 },
    { 0xbb8d5bdd, 0xbd03684a }, { 0xba9ba046, 0xbc6db294 }, { 0x3c295974, 0xbcf9ccbc },
    { 0x3cb1b8d2, 0x3c4e70b8 }, { 0x3bbee1bd, 0xbc7e8f20 }, { 0x3df5f0a4, 0x3eff7a51 },
    { 0xbe5b365c, 0x3f1a278d }, { 0xbc909e15, 0x3d5384b2 }, { 0x3df4081a, 0x3ddfef37 },
    { 0x3debb0bf, 0x3dbc3a2a }, { 0xbe2f3ccc, 0x3c9eb75c }, { 0x3e80ab5f, 0x3da518d4 },
    { 0xbe034c98, 0x3d82b905 }, { 0x3e9726b6, 0xbd44086a }, { 0x3d9f83ba, 0x3db25f61 },
    { 0xbdcacd02, 0xbc4f9bce }, { 0x3db1ea4a, 0x3e687aaa }, { 0x3da69550, 0x3d315b7c },
    { 0x3bbc2cda, 0x3d3f435c }, { 0x3d92e29b, 0x3df11116 }, { 0xbd0578ae, 0xbcb77101 },
    { 0xbba4a90d, 0xbb6a95c2 }, { 0xbc788b14, 0x3cd98016 }, { 0x3ba87357, 0x3cf384a1 },
    { 0x3ccb1afc, 0x3cda95ca }, { 0xbb9665bf, 0xbd5e05f8 }, { 0x3c02f7e7, 0xbbf19e67 },
    { 0x3cf62201, 0xbceea88e }, { 0x3b8c2660, 0x3c97a15b }, { 0x3b0dd4d8, 0xbcd24145 },
    { 0x3d716476, 0x3f179447 }, { 0x3eab75b3, 0xbf21e67c }, { 0x3ce46687, 0x3e49130b },
    { 0x3d0d1914, 0x3e1bfef9 }, { 0xbc980303, 0xbd9e9f2e }, { 0x3e70c0e1, 0xbdeaf72a },
    { 0x3eaa6f92, 0x3df2869f }, { 0xbdd94dd7, 0x3e2582b1 }, { 0x3ea96415, 0xbbc5daa1 },
    { 0xbd7ba454, 0xbdbf3d70 }, { 0x3e014e2b, 0xbd4499e6 }, { 0xbe019f84, 0xbe80e559 },
    { 0x3de3852f, 0x3d4fa04d }, { 0xb979e756, 0x3d029479 }, { 0x3e0559aa, 0x3e08b602 },
    { 0xbc841ede, 0x3ba657fc }, { 0x3c222a29, 0x3b90091f }, { 0x3c4cd3ab, 0xbd436574 },
    { 0xbc0f8db6, 0xbcce202e }, { 0xbcae8263, 0xbd06929b }, { 0xbc1abad0, 0xbd2754fd },
    { 0x3b39bc01, 0xbc51d6ae }, { 0x3c7bcfbd, 0xbd0733cb }, { 0x3cc014b5, 0x3c5b90e2 },
    { 0x3bb45f45, 0xbc81270c }, { 0x3e0a5f1a, 0x3ef321ad }, { 0xbe327b1e, 0x3f124dc2 },
    { 0xbd15aaea, 0x3c2cd4b1 }, { 0x3dde40bd, 0x3dd1334a }, { 0x3ded880b, 0x3dc43b4d },
    { 0xbe2feb9b, 0xbca277c6 }, { 0x3e6d25d5, 0x3da637b4 }, { 0xbdef71d4, 0x3d750595 },
    { 0x3e8867b4, 0xbd52a679 }, { 0x3d93f5b7, 0x3d9eb545 }, { 0xbdbf04ee, 0xbc649790 },
    { 0x3d9e6306, 0x3e5fdf01 }, { 0x3da6817e, 0x3d472f82 }, { 0xbbf4760e, 0x3d240fc8 },
    { 0x3d876db2, 0x3dfb6008 }, { 0xbd01c0d0, 0xbcdda0b8 }, { 0xbb5bbdfa, 0xbb85c495 },
    { 0xbc5fe8aa, 0x3cdf4e56 }, { 0x3b76c83b, 0x3cbe6dfe }, { 0x3ce4f999, 0x3cdfa00d },
    { 0xbaa94d02, 0xbd568b95 }, { 0x3c39572b, 0xbb30b45a }, { 0x3d01c4ac, 0xbcefdbdb },
    { 0x3ba2be63, 0x3c8505a7 }, { 0x3b2064e2, 0xbcc76536 }, { 0x3db602de, 0x3f188d5b },
    { 0x3e987455, 0xbf230e83 }, { 0x3aa48ac5, 0x3e1d3b50 }, { 0x3d1b9468, 0x3e19da67 },
    { 0xbd1371fe, 0xbda63a86 }, { 0x3e7be511, 0xbd93aef1 }, { 0x3ea33b91, 0x3df79c5e },
    { 0xbdd80d7f, 0x3e278ffe }, { 0x3e9f943f, 0xbc7f0a55 }, { 0xbd6c5285, 0xbdaa91e5 },
    { 0x3e0506fc, 0xbd3d2816 }, { 0xbdf21f7b, 0xbe85a974 }, { 0x3de64351, 0x3d6918f2 },
    { 0xbc3eecfc, 0x3d065fd3 }, { 0x3e06ccff, 0x3e17bd04 }, { 0xbcc53ea6, 0xb9abf620 },
    { 0x3c19e528, 0x3bbcec45 }, { 0x3c44b6d4, 0xbd4b39ac }, { 0xbbea46f0, 0xbccb7d00 },
    { 0xbcd33ae3, 0xbd13deb5 }, { 0xbc410a9b, 0xbd488afd }, { 0x3bd7875d, 0xbc290731 },
    { 0x3ca8ad2c, 0xbd0eebac }, { 0x3cd05ff6, 0x3c4a2f23 }, { 0x3b9fcef2, 0xbc75f9fb },
    { 0x3e14ccfb, 0x3eeb5e02 }, { 0xbe13d0c4, 0x3f0cdab1 }, { 0xbd4b49eb, 0xbca8f66e },
    { 0x3dc323c0, 0x3dbf0dad }, { 0x3dec609c, 0x3dc5ddc7 }, { 0xbe305b4d, 0xbd534c94 },
    { 0x3e5bdb8a, 0x3dac7da8 }, { 0xbdd8188f, 0x3d7571c8 }, { 0x3e79a180, 0xbd6ac23d },
    { 0x3d8acba8, 0x3d8b2b35 }, { 0xbdb2770a, 0xbc40bc6e }, { 0x3d906e46, 0x3e59c704 },
    { 0x3da8d45c, 0x3d688067 }, { 0xbc96db72, 0x3d034266 }, { 0x3d7e63d2, 0x3dfe06ec },
    { 0xbd06238e, 0xbcfe721b }, { 0xbaf8719c, 0xbbaae5a6 }, { 0xbc4c97ee, 0x3ce10764 },
    { 0x3aff8685, 0x3c8f6491 }, { 0x3cfeef1a, 0x3d00d72b }, { 0x3a8e88b9, 0xbd4b3642 },
    { 0x3c52b5fc, 0x3a86d7c0 }, { 0x3d06288c, 0xbcf3c956 }, { 0x3bbe45dd, 0x3c56d661 },
    { 0x3b2300a6, 0xbcb71437 }, { 0x3def9666, 0x3f18b431 }, { 0x3e83bd5a, 0xbf246512 },
    { 0xbc8810cb, 0x3de40f3f }, { 0x3d2859a4, 0x3e139b1e }, { 0xbd59bc46, 0xbda93a7f },
    { 0x3e831005, 0xbcf6f303 }, { 0x3e9c086f, 0x3e017604 }, { 0xbdcb97bc, 0x3e2bdf2b },
    { 0x3e943bab, 0xbce05cf5 }, { 0xbd621f91, 0xbd8f6cbf }, { 0x3e0548f8, 0xbd4a745c },
    { 0xbddaf6fd, 0xbe8a1d16 }, { 0x3df67963, 0x3d8e6580 }, { 0xbca2e9a6, 0x3d0901af },
    { 0x3e05ecac, 0x3e226ac9 }, { 0xbd05cdb7, 0xbbc3e66b }, { 0x3c124c6e, 0x3bf1cc1e },
    { 0x3c332453, 0xbd4bbef3 }, { 0xbb81fc39, 0xbccad36d }, { 0xbceca842, 0xbd316460 },
    { 0xbc089e92, 0xbd5c042b }, { 0x3c2ac32d, 0xbbdcbcd4 }, { 0x3cc9fed6, 0xbd12fa12 },
    { 0x3cdee36c, 0x3c27fbe6 }, { 0x3b77d8b5, 0xbc5c6389 }, { 0x3e1bd755, 0x3ee871c5 },
    { 0xbdf95954, 0x3f0ab59e }, { 0xbd7746dd, 0xbd42f174 }, { 0x3dac3ae5, 0x3dafc28f },
    { 0x3de987e4, 0x3dc3696b }, { 0xbe320dc1, 0xbda475b3 }, { 0x3e4d451c, 0x3db2c8b6 },
    { 0xbdbd34c8, 0x3d851017 }, { 0x3e683304, 0xbd851c34 }, { 0x3d837d45, 0x3d6f3be5 },
    { 0xbda848e9, 0xbbaba0d1 }, { 0x3d83e0cf, 0x3e56e4fc }, { 0x3dad8fcf, 0x3d885411 },
    { 0xbcc9ac35, 0x3ccc4d7c }, { 0x3d746c27, 0x3e014f43 }, { 0xbd0e5ba2, 0xbd09c071 },
    { 0xba6efd1a, 0xbbd94c54 }, { 0xbc3f9a75, 0x3ce215fd }, { 0xb8072174, 0x3c557bfe },
    { 0x3d079443, 0x3d1ac674 }, { 0x3b1cb73b, 0xbd45b3f9 }, { 0x3c6b9dd3, 0x3b843a41 },
    { 0x3d08ecff, 0xbcf74240 }, { 0x3bef46d9, 0x3c1fc4f9 }, { 0x3b0d3ee5, 0xbca54418 },
    { 0x3e1379b8, 0x3f1b028b }, { 0x3e63f4dd, 0xbf279672 }, { 0xbcc14886, 0x3d978ed4 },
    { 0x3d21344c, 0x3e0a8439 }, { 0xbd8ceff7, 0xbda35dc4 }, { 0x3e88dfd3, 0x3c260c36 },
    { 0x3e98712d, 0x3e096800 }, { 0xbdb94c3e, 0x3e33dd71 }, { 0x3e8bf662, 0xbd253683 },
    { 0xbd59f96e, 0xbd6f5043 }, { 0x3e03a183, 0xbd6388f2 }, { 0xbdc4166a, 0xbe8e5995 },
    { 0x3e0aafc6, 0x3db28809 }, { 0xbcda0b5d, 0x3d074e62 }, { 0x3e063096, 0x3e2c38f7 },
    { 0xbd34f37a, 0xbc34c34e }, { 0x3c13b230, 0x3c18f285 }, { 0x3c19762a, 0xbd4f3561 },
    { 0xb91860c2, 0xbcbf4f60 }, { 0xbd023622, 0xbd58074c }, { 0xbb184881, 0xbd6912ee },
    { 0x3c68f94e, 0xbb4a91c6 }, { 0x3ce70d52, 0xbd11ac9c }, { 0x3cefbbd0, 0x3c03291c },
    { 0x3b4a6393, 0xbc3ff793 }, { 0x3e1ef535, 0x3ee6b0d6 }, { 0xbdd26223, 0x3f09eff3 },
    { 0xbd9258c3, 0xbd95c62e }, { 0x3d95eacd, 0x3d9f1c21 }, { 0x3de599cb, 0x3db9b0bf },
    { 0xbe344339, 0xbddbc372 }, { 0x3e3e4cbd, 0x3db39da9 }, { 0xbda0099d, 0x3d936270 },
    { 0x3e5a0da1, 0xbd98057e }, { 0x3d792337, 0x3d491b72 }, { 0xbd9d4cec, 0x3b65ef03 },
    { 0x3d6a77bc, 0x3e51cc20 }, { 0x3db0e96b, 0x3d9b27ae }, { 0xbce504a1, 0x3c9064e7 },
    { 0x3d6c5afd, 0x3e03e89b }, { 0xbd1916b0, 0xbd0d9ab6 }, { 0xb9e8e4d5, 0xbc024795 },
    { 0xbc3262d5, 0x3cdee34c }, { 0xbad25083, 0x3c0cb63a }, { 0x3d0990e6, 0x3d32fdcb },
    { 0x3b4ad0a2, 0xbd45d0a0 }, { 0x3c80c559, 0x3bd33ef3 }, { 0x3d0c0a88, 0xbcf3cfad },
    { 0x3c10e240, 0x3bcfce12 }, { 0x3ac23640, 0xbc91f5ce }, { 0x3e28c579, 0x3f1d781b },
    { 0x3e44d186, 0xbf29c6c4 }, { 0xbcf665bf, 0x3d298f4e }, { 0x3cfd3a62, 0x3dfdeeb1 },
    { 0xbda7492a, 0xbd953123 }, { 0x3e8c42ac, 0x3d42ab5b }, { 0x3e918a7d, 0x3e0c6c4d },
    { 0xbda3c451, 0x3e3d54be }, { 0x3e857963, 0xbd5c1d64 }, { 0xbd4b7a22, 0xbd4ab331 },
    { 0x3dfd6711, 0xbd7fd346 }, { 0xbdaac7a5, 0xbe8dc2f6 }, { 0x3e16e531, 0x3dd4512a },
    { 0xbd0e23fc, 0x3cf8e3ab }, { 0x3e06824f, 0x3e313544 }, { 0xbd6a82cc, 0xbc7a0482 },
    { 0x3c17f9ae, 0x3c35fb9c }, { 0x3be7add4, 0xbd528f8d }, { 0x3b4d74e0, 0xbca41288 },
    { 0xbd0f7c14, 0xbd7bfbe4 }, { 0x3b0aa742, 0xbd7409f9 }, { 0x3c824217, 0xb9afd93a },
    { 0x3d02cd05, 0xbd0a305b }, { 0x3d011cde, 0x3bb5bed1 }, { 0x3b43f115, 0xbc1ee588 },
    { 0x3e206846, 0x3eea2f28 }, { 0xbdb50ed7, 0x3f0c8de7 }, { 0xbdaa3027, 0xbdca7683 },
    { 0x3d7d2890, 0x3d8b6973 }, { 0x3de53592, 0x3da660c8 }, { 0xbe388d1a, 0xbe0a7d38 },
    { 0x3e3119d9, 0x3db283c7 }, { 0xbd85f2db, 0x3da4ecba }, { 0x3e51fe9f, 0xbdb5acfe },
    { 0x3d6b6798, 0x3d228b68 }, { 0xbd913d35, 0x3c69f7b4 }, { 0x3d4e5710, 0x3e4cc150 },
    { 0x3db4b7b7, 0x3db10221 }, { 0xbd03331f, 0x3c238521 }, { 0x3d6f9bee, 0x3e09c74c },
    { 0xbd2d609e, 0xbd0d69e0 }, { 0xba73e93f, 0xbc16b830 }, { 0xbc1ea398, 0x3ce00f42 },
    { 0xbb3ac2f7, 0x3b7b160b }, { 0x3d0a1933, 0x3d4cbb98 }, { 0x3b74e233, 0xbd4ccb02 },
    { 0x3c84e838, 0x3c086453 }, { 0x3d121458, 0xbcea8315 }, { 0x3c2e056a, 0x3b3978aa },
    { 0x3a2abaaf, 0xbc7d0b91 }, { 0x3e3713b7, 0x3f21ec80 }, { 0x3e2afdc6, 0xbf2dde14 },
    { 0xbd348f99, 0x3c499941 }, { 0x3ca731b8, 0x3de19cda }, { 0xbdbea63c, 0xbd7bd911 },
    { 0x3e8db5a9, 0x3da64531 }, { 0x3e856d82, 0x3e0b8ad4 }, { 0xbd9310ea, 0x3e4843d1 },
    { 0x3e819200, 0xbd95cb3e }, { 0xbd390e7a, 0xbd21b5fb }, { 0x3df12b17, 0xbd934273 },
    { 0xbd917227, 0xbe8b7169 }, { 0x3e1bdb51, 0x3df5c461 }, { 0xbd36a51f, 0x3cd4eca7 },
    { 0x3e08e9c7, 0x3e336fa1 }, { 0xbd91ee4a, 0xbc97134e }, { 0x3c24c4a8, 0x3c51eaf0 },
    { 0x3b8459ab, 0xbd55dc14 }, { 0x3bd0a3e1, 0xbc83cb61 }, { 0xbd1d08f0, 0xbd92d4a3 },
    { 0x3b5e5137, 0xbd80448d }, { 0x3c7aa8b7, 0x3a2b6a77 }, { 0x3d123630, 0xbd04a13e },
    { 0x3d09f54b, 0x3b0c97ac }, { 0x3b3910bc, 0xbbf36481 }, { 0x3e2249fa, 0x3ef1e7b1 },
    { 0xbd9ea71a, 0x3f11faed }, { 0xbdc03832, 0xbdfcec6e }, { 0x3d51798c, 0x3d5a3f8f },
    { 0x3de85aee, 0x3d86d4c0 }, { 0xbe3c8ba0, 0xbe283ffc }, { 0x3e245729, 0x3dacd7fa },
    { 0xbd56aa68, 0x3db96f47 }, { 0x3e4edae7, 0xbde114b9 }, { 0x3d5b0ea3, 0x3cfb09f7 },
    { 0xbd82c5fe, 0x3ce6e0f5 }, { 0x3d2d1518, 0x3e4528a6 }, { 0x3db8eccd, 0x3dcbdddb },
    { 0xbd21906d, 0x3a8a9055 }, { 0x3d7d135f, 0x3e116c69 }, { 0xbd44927c, 0xbd063694 },
    { 0xbaf11588, 0xbc1e88a8 }, { 0xbbfbc0b6, 0x3ce2c077 }, { 0xbb931eb9, 0xbb0f94e5 },
    { 0x3d094c0f, 0x3d6b52fe }, { 0x3bb3988c, 0xbd53cb70 }, { 0x3c7e1892, 0x3c1ba59b },
    { 0x3d190ff5, 0xbcda8fa3 }, { 0x3c4ffb00, 0xbad6064f }, { 0x39b74151, 0xbc568aae },
    { 0x3e44ce25, 0x3f286add }, { 0x3e12db84, 0xbf357e3d }, { 0xbd7598a6, 0xbc85781b },
    { 0x3c6a2ffb, 0x3dbe4980 }, { 0xbdd62f30, 0xbd3be2d7 }, { 0x3e8dd4c2, 0x3de81299 },
    { 0x3e6d1523, 0x3e0482e1 }, { 0xbd82bc4e, 0x3e54b7b3 }, { 0x3e7e9b78, 0xbdceaf1c },
    { 0xbd25efd2, 0xbce4d857 }, { 0x3de5c110, 0xbdaebc83 }, { 0xbd64eddd, 0xbe878f38 },
    { 0x3e1f85a0, 0x3e0f9e9a }, { 0xbd58a191, 0x3caa190c }, { 0x3e0bb0e7, 0x3e34ae10 },
    { 0xbdad2b40, 0xbca78c6b }, { 0x3c36bb1d, 0x3c67787c }, { 0x3a20b542, 0xbd549a42 },
    { 0x3c2ed08b, 0xbc3c643e }, { 0xbd21fbbe, 0xbdaddead }, { 0x3bb8d6b0, 0xbd81ee2d },
    { 0x3c7e3203, 0x3a486de1 }, { 0x3d1d2e6f, 0xbcff49d7 }, { 0x3d1212f2, 0xbb3b9d7b },
    { 0x3b1e42f5, 0xbbb78fca }, { 0x3e2a076a, 0x3efe47c6 }, { 0xbd8b272f, 0x3f1ad92d },
    { 0xbdd2644a, 0xbe13893b }, { 0x3d3874f9, 0x3d0a22f1 }, { 0x3def6ece, 0x3d444ec3 },
    { 0xbe4001a8, 0xbe47476d }, { 0x3e16d01a, 0x3da17284 }, { 0xbd1fc0b2, 0x3dd03908 },
    { 0x3e518e0e, 0xbe0d1f5f }, { 0x3d4d12be, 0x3cc7d283 }, { 0xbd664e62, 0x3d383247 },
    { 0x3d058192, 0x3e3a2d66 }, { 0x3dbec4dd, 0x3deeefed }, { 0xbd4d12fd, 0xbc195196 },
    { 0x3d88cefe, 0x3e190091 }, { 0xbd532478, 0xbcfb8e35 }, { 0xbb05d336, 0xbc166cc0 },
    { 0xbba61b70, 0x3ce4c7af }, { 0xbbda2ba7, 0xbc1e6eee }, { 0x3d07e20d, 0x3d88eddd },
    { 0x3c1a82ca, 0xbd526de1 }, { 0x3c5bfd72, 0x3c261def }, { 0x3d1d4feb, 0xbcc7d3fa },
    { 0x3c78b6af, 0xbbe40dd1 }, { 0x3a83a79f, 0xbc34b2e0 }, { 0x3e582669, 0x3f302f9a },
    { 0x3df8a7f3, 0xbf3fbc0d }, { 0xbd9132ff, 0xbd221846 }, { 0x3c6a64ff, 0x3d9263b8 },
    { 0xbdefc1ed, 0xbcd1388e }, { 0x3e8cb5a4, 0x3e13990c }, { 0x3e4c918e, 0x3def26fa },
    { 0xbd5c8fd9, 0x3e62f487 }, { 0x3e800163, 0xbe094ed1 }, { 0xbd1678a5, 0xbc9ab937 },
    { 0x3dd9f73b, 0xbdceeac6 }, { 0xbd1c1308, 0xbe80077f }, { 0x3e25ecbc, 0x3e28dc04 },
    { 0xbd754975, 0x3c864750 }, { 0x3e0debf0, 0x3e34f1b5 }, { 0xbdc54540, 0xbcae5090 },
    { 0x3c3ed133, 0x3c76c87a }, { 0xbb74cc7a, 0xbd4f614b }, { 0x3c7ec828, 0xbbc71087 },
    { 0xbd1f1a45, 0xbdcba494 }, { 0x3c415a4a, 0xbd77a037 }, { 0x3c8c53a9, 0x3abb5884 },
    { 0x3d2263f8, 0xbce5a7bf }, { 0x3d1830bc, 0xbc0995aa }, { 0x3b0e929c, 0xbb88da05 },
    { 0x3e3dff9c, 0x3f07d331 }, { 0xbd6c1211, 0x3f27ad98 }, { 0xbddd43a1, 0xbe25fcac },
    { 0x3d3a2013, 0x3c19106d }, { 0x3dfdc33c, 0x3cea68ea }, { 0xbe412d87, 0xbe6ac4d1 },
    { 0x3e05d2d8, 0x3d89199a }, { 0xbcd5c63c, 0x3de717e4 }, { 0x3e5b320f, 0xbe31d38a },
    { 0x3d457995, 0x3cb8c65b }, { 0xbd44c345, 0x3d8476a0 }, { 0x3cb82b14, 0x3e2a49f5 },
    { 0x3dc2f311, 0x3e0d9712 }, { 0xbd825852, 0xbcb82dc2 }, { 0x3d92e73d, 0x3e204629 },
    { 0xbd5589bb, 0xbceff577 }, { 0xbaa49561, 0xbc030e96 }, { 0xbb1c4c7d, 0x3cec75ea },
    { 0xbc202d64, 0xbc9ce8ac }, { 0x3d03aa29, 0x3da020d7 }, { 0x3c827db4, 0xbd41d927 },
    { 0x3c211157, 0x3c298c36 }, { 0x3d196e9b, 0xbcb26547 }, { 0x3c925610, 0xbc59fc1b },
    { 0x3b5ccdba, 0xbc1a3aa5 }, { 0x3e7668a1, 0x3f389cce }, { 0x3dce89d1, 0xbf4bdbb0 },
    { 0xbda27a62, 0xbd620b48 }, { 0x3ce6fc1e, 0x3d3bcf31 }, { 0xbe03c9e4, 0xbb6f0010 },
    { 0x3e892d7e, 0x3e32d8a1 }, { 0x3e21b3f5, 0x3dc73d00 }, { 0xbd3ab5e9, 0x3e72cd79 },
    { 0x3e8597ae, 0xbe3007f3 }, { 0xbd008e89, 0xbc791962 }, { 0x3dcc9c96, 0xbdf230ed },
    { 0xbca8eb23, 0xbe654512 }, { 0x3e2cf385, 0x3e42b429 }, { 0xbd8f0a76, 0x3c62ccb3 },
    { 0x3e0ad1bc, 0x3e353e44 }, { 0xbdd4047d, 0xbcb2b063 }, { 0x3c4d359e, 0x3c7b296a },
    { 0xbc187285, 0xbd4b56cd }, { 0x3ca6e847, 0xba06c331 }, { 0xbd163519, 0xbde71522 },
    { 0x3ca8ed9a, 0xbd5f102b }, { 0x3ca20fe9, 0x3b16e761 }, { 0x3d1cb7ed, 0xbcb39d37 },
    { 0x3d19b851, 0xbc5e4f2e }, { 0x3b76b55d, 0xbb4497c5 }, { 0x3e588d6b, 0x3f0e5dd4 },
    { 0xbd4e3dd8, 0x3f328248 }, { 0xbdd753ae, 0xbe1d71ca }, { 0x3d675168, 0xbc0b376a },
    { 0x3e04b868, 0x3c805b32 }, { 0xbe3eb194, 0xbe7303c8 }, { 0x3ddd5b50, 0x3d2f78d9 },
    { 0xbc35699d, 0x3e00de48 }, { 0x3e6c8346, 0xbe51dd0e }, { 0x3d4abcf7, 0x3ce6a03e },
    { 0xbd241da8, 0x3db40db6 }, { 0x3c13b46e, 0x3e0efd1d }, { 0x3dbfbc06, 0x3e1dc2b3 },
    { 0xbd9a3802, 0xbd08ea9a }, { 0x3d9df3b5, 0x3e1df54b }, { 0xbd36e89c, 0xbcfcc79d },
    { 0x3ad908c9, 0xbbce8c52 }, { 0x3a808ae6, 0x3cf43aac }, { 0xbc729009, 0xbcdf2ca7 },
    { 0x3cf34ee0, 0x3db61649 }, { 0x3cdae6da, 0xbd1450b8 }, { 0x3bb00119, 0x3c39c3eb },
    { 0x3d0ee816, 0xbc7766fd }, { 0x3cafc74c, 0xbca3a99e }, { 0x3bf7b4f7, 0xbc0efdd6 },
    { 0x3e8c08fa, 0x3f3c2139 }, { 0x3db2bd05, 0xbf54df4f }, { 0xbd9a1345, 0xbd454452 },
    { 0x3d297701, 0x3c848e68 }, { 0xbe101157, 0x3c9642f7 }, { 0x3e823572, 0x3e36ab71 },
    { 0x3de263ca, 0x3d8a98b9 }, { 0xbd3874ca, 0x3e7939ca }, { 0x3e8cbe48, 0xbe523ec2 },
    { 0xbceb51a1, 0xbc972590 }, { 0x3dbc1085, 0xbe06cbe5 }, { 0xb93ccf20, 0xbe3e26dd },
    { 0x3e313fc1, 0x3e55361b }, { 0xbdb018e6, 0x3c13a3d9 }, { 0x3e03f746, 0x3e297751 },
    { 0xbdd8cfb0, 0xbcc025e8 }, { 0x3c35f30f, 0x3c7aeb63 }, { 0xbc6f055c, 0xbd40c5ca },
    { 0x3cd7be9c, 0x3bbf1eda }, { 0xbd06bd9e, 0xbdfecf5b }, { 0x3d02fc41, 0xbd2e25d7 },
    { 0x3ca3afec, 0x3ae37677 }, { 0x3d14de4e, 0xbc4a190d }, { 0x3d0b4b05, 0xbca4e895 },
    { 0x3c0505f3, 0xbb32a5ec }, { 0x3e6d8b9e, 0x3f0c5afc }, { 0xbd04f407, 0x3f33b7e2 },
    { 0xbde6e8cd, 0xbe14f37a }, { 0x3d89197e, 0xbcec01f2 }, { 0x3e0797b8, 0x3b090741 },
    { 0xbe2acf88, 0xbe74041b }, { 0x3d8a3e61, 0xbb7f2980 }, { 0x3bc04518, 0x3e07cb6e },
    { 0x3e715e9f, 0xbe65484f }, { 0x3d567f79, 0x3d0d9f2d }, { 0xbd06ec00, 0x3ddc97ca },
    { 0xbb324cf7, 0x3db1be92 }, { 0x3d9cb8e8, 0x3e2103aa }, { 0xbda54a6e, 0xbd3d8924 },
    { 0x3d84cd01, 0x3e0d579c }, { 0xbd0f1bed, 0xbcfb8e15 }, { 0x3bcb1d60, 0xbbbe3225 },
    { 0x3b8549fb, 0x3cd34198 }, { 0xbca4898b, 0xbd0a1926 }, { 0x3cbddc10, 0x3db6ad76 },
    { 0x3d0b3301, 0xbcae14b8 }, { 0x3a56e4f4, 0x3c470673 }, { 0x3cd83d1a, 0xbc0545b8 },
    { 0x3cc83ff4, 0xbccbc665 }, { 0x3c406e24, 0xbc2012e8 }, { 0x3e95e09b, 0x3f332839 },
    { 0x3d633f58, 0xbf50bc08 }, { 0xbd992a62, 0xbd5663ad }, { 0x3d77adf2, 0xbc75393a },
    { 0xbe1a9385, 0x3d125d0b }, { 0x3e60fe5e, 0x3e3ab256 }, { 0x3d345c91, 0x3c256c73 },
    { 0xbd32a09c, 0x3e6743ac }, { 0x3e87dde9, 0xbe69f861 }, { 0xbcf676d9, 0xbcb228ac },
    { 0x3dae3ab2, 0xbe097646 }, { 0x3c7b16b6, 0xbdeff140 }, { 0x3e22c416, 0x3e55a40f },
    { 0xbdc6d710, 0xba114469 }, { 0x3dd1c283, 0x3e133d6a }, { 0xbdcb2b63, 0xbcdc6e2d },
    { 0x3bd418c5, 0x3c74f850 }, { 0xbc81fbbd, 0xbd22b61b }, { 0x3cff9594, 0x3c3600ae },
    { 0xbcd9d45e, 0xbdf95e41 }, { 0x3d23665d, 0xbcdaab27 }, { 0x3ca3114c, 0x3a1d13ea },
    { 0x3cd55b9b, 0xbb413c84 }, { 0x3cfcf722, 0xbcc636e9 }, { 0x3c44a249, 0xbba9ffbb },
    { 0x3e6ce7f7, 0x3f022d59 }, { 0xbc8b2c5a, 0x3f29e529 }, { 0xbde5ab07, 0xbdf03733 },
    { 0x3d8de9ee, 0xbd26083b }, { 0x3e042b34, 0xbb7841f0 }, { 0xbe112657, 0xbe57ec56 },
    { 0x3cf9a9ba, 0xbd57365d }, { 0x3c553d36, 0x3e0631e3 }, { 0x3e65625a, 0xbe64728c },
    { 0x3d5ab80d, 0x3d107128 }, { 0xbcd7b662, 0x3deb75a7 }, { 0xbc2db276, 0x3d0bbc10 },
    { 0x3d5a8275, 0x3e17b888 }, { 0xbd9dc651, 0xbd56b8dc }, { 0x3d5cdcc0, 0x3decf12b },
    { 0xbcd0bc5b, 0xbcea102b }, { 0x3c1d6714, 0xbbb545eb }, { 0x3bc0f7ff, 0x3cb6a6ac },
    { 0xbcc2eddc, 0xbd0e3e65 }, { 0x3c6986db, 0x3da9f4ae }, { 0x3d19dfac, 0xbbd791ce },
    { 0xbb87ec1c, 0x3c51e625 }, { 0x3c8bca90, 0xbb1ab172 }, { 0x3cc901ce, 0xbce11eef },
    { 0x3c5c3f13, 0xbc2bd528 }, { 0x3e9323e5, 0x3f225231 }, { 0x3ccf5af8, 0xbf41b94e },
    { 0xbd723415, 0xbd078cc3 }, { 0x3d9d18a9, 0xbccddf01 }, { 0xbe17e554, 0x3d1a9b9b },
    { 0x3e39016c, 0x3e22803a }, { 0xbc31ad9b, 0xbd2b126e }, { 0xbd2b6d83, 0x3e4e4ce2 },
    { 0x3e76fd23, 0xbe6a6924 }, { 0xbd01cc81, 0xbcc3e1a1 }, { 0x3da05fa5, 0xbe0578b6 },
    { 0x3cda5372, 0xbd5acda1 }, { 0x3e0be0ef, 0x3e473160 }, { 0xbdc7cc8e, 0xbaa80068 },
    { 0x3da2de77, 0x3df610ae }, { 0xbda9ba53, 0xbcdfe8a7 }, { 0x3b010091, 0x3c5a20a4 },
    { 0xbc57c146, 0xbd09684a }, { 0x3d0dad26, 0x3c3f8a79 }, { 0xbca2d1eb, 0xbde37494 },
    { 0x3d364421, 0xbc23320c }, { 0x3ca41834, 0x3adc267e }, { 0x3c752a4b, 0x3bc9e59a },
    { 0x3ce49565, 0xbcd23ef2 }, { 0x3c5e93d4, 0xbc034ca4 }, { 0x3e6397cf, 0x3eef3b99 },
    { 0xbbe8644b, 0x3f1f5da2 }, { 0xbdd6fa70, 0xbd969225 }, { 0x3d919417, 0xbd2881a0 },
    { 0x3e01d9b1, 0x3ae34791 }, { 0xbdfbb791, 0xbe2a1d14 }, { 0xb880f1f2, 0xbdc33693 },
    { 0x3c7d873c, 0x3e0175e4 }, { 0x3e596060, 0xbe5a5b8b }, { 0x3d62f1a6, 0x3d17c0b5 },
    { 0xbcc3db5f, 0x3deac4c9 }, { 0xbc8a44f2, 0xbc413709 }, { 0x3d160957, 0x3e0ac6bf },
    { 0xbd8f1428, 0xbd4b3fa9 }, { 0x3d428b53, 0x3dbe8726 }, { 0xbc8cbe30, 0xbce822c9 },
    { 0x3c4b4e50, 0xbbb95b6b }, { 0x3be8c49f, 0x3c99ff62 }, { 0xbcd9c9bc, 0xbcfed5b1 },
    { 0x3bbc15f8, 0x3d9f22ce }, { 0x3d1ec411, 0x3bc375c9 }, { 0xbc0b39ec, 0x3c52113e },
    { 0x3c1b414a, 0x3b84f730 }, { 0x3cc95a1c, 0xbcdf8f42 }, { 0x3c5d3d47, 0xbc4219e8 },
    { 0x3e8be4fc, 0x3f150138 }, { 0x3bbee321, 0xbf34eb18 }, { 0xbd3296db, 0xba977dd2 },
    { 0x3dafb54f, 0xbcbcab46 }, { 0xbe147f80, 0x3d011d65 }, { 0x3e1a90b0, 0x3df96c04 },
    { 0xbd5a236a, 0xbda74fda }, { 0xbd263eec, 0x3e39e33e }, { 0x3e64a013, 0xbe619a5d },
    { 0xbd0c42e7, 0xbce3d04c }, { 0x3d964ced, 0xbe01e391 }, { 0x3d0e3a05, 0xbb61d82b },
    { 0x3dedb42c, 0x3e35c9d5 }, { 0xbdc06680, 0x3b9d4bc8 }, { 0x3d84ad8c, 0x3dc719da },
    { 0xbd8c4cb2, 0xbcd7cd86 }, { 0xbabba169, 0x3c40d127 }, { 0xbc28c6bd, 0xbce9f285 },
    { 0x3d18bcba, 0x3c1195cc }, { 0xbc80c93b, 0xbdd00dfc }, { 0x3d37e8dd, 0x3b66e003 },
    { 0x3c97d424, 0x3b2f2334 }, { 0x3be1dc88, 0x3c6abb43 }, { 0x3cdc6f1f, 0xbcd34200 },
    { 0x3c6550ab, 0xbc2f9fed }, { 0x3e5668f6, 0x3ee198b3 }, { 0xbbbdf848, 0x3f189e01 },
    { 0xbdc43ab6, 0xbcee30cf }, { 0x3d903c14, 0xbd258f40 }, { 0x3e034f40, 0x3c11ef3c },
    { 0xbde86f9b, 0xbdf949dd }, { 0xbccb9f0d, 0xbe03ec44 }, { 0x3c9e0459, 0x3dfa9375 },
    { 0x3e55ab88, 0xbe4fc5b2 }, { 0x3d6ede57, 0x3d283515 }, { 0xbcba6ca8, 0x3de6a775 },
    { 0xbcb91d85, 0xbd4511dc }, { 0x3cf1a11a, 0x3dfe77af }, { 0xbd7fd130, 0xbd25fa1d },
    { 0x3d3ba9fa, 0x3d962a4c }, { 0xbc4e7b0f, 0xbceda11d }, { 0x3c68435d, 0xbbd15cd1 },
    { 0x3c09581f, 0x3c72b1cc }, { 0xbce7bded, 0xbccd1ae8 }, { 0xb9a09a4c, 0x3d982463 },
    { 0x3d1a46e9, 0x3c8206cd }, { 0xbc4a891a, 0x3c33f7e4 }, { 0x3b986beb, 0x3c3385da },
    { 0x3ccb3cba, 0xbcd2bd18 }, { 0x3c5d5303, 0xbc5d9131 }, { 0x3e848598, 0x3f0cc0e9 },
    { 0xbb4ee96c, 0xbf2cc8da }, { 0xbd149c85, 0x3cf744b3 }, { 0x3dc2d890, 0xbc4ba416 },
    { 0xbe150f05, 0x3c920756 }, { 0x3e09f077, 0x3da8d686 }, { 0xbdaf6010, 0xbde49a43 },
    { 0xbd2e48b1, 0x3e27f074 }, { 0x3e5cc4b4, 0xbe5abd1b }, { 0xbd1ee16d, 0xbcfce599 },
    { 0x3d8e9ab4, 0xbdfa3b9b }, { 0x3d2eeebb, 0x3d06b2e5 }, { 0x3dceaac8, 0x3e232311 },
    { 0xbdb8d421, 0x3c598af1 }, { 0x3d6e6830, 0x3d9cf01b }, { 0xbd70725f, 0xbce00e4c },
    { 0xbb572cae, 0x3c2db23d }, { 0xbc07c353, 0xbcc67a12 }, { 0x3d1f0e45, 0x3b8598e5 },
    { 0xbc62f3f3, 0xbdc07c6d }, { 0x3d329538, 0x3c5f2970 }, { 0x3c8127cb, 0x3b29973f },
    { 0x3aee3383, 0x3ca88f2e }, { 0x3cd7f567, 0xbccea3b8 }, { 0x3c5a2c9e, 0xbc528ea0 },
    { 0x3e481ce4, 0x3edc399a }, { 0xbc3ccd0a, 0x3f167945 }, { 0xbdb5713f, 0x3c0bc78d },
    { 0x3d92b62a, 0xbd2b1be2 }, { 0x3e0894c7, 0x3c874ef4 }, { 0xbde25f10, 0xbdb03061 },
    { 0xbd3ab8b6, 0xbe1d97f5 }, { 0x3cc05a69, 0x3df5fa06 }, { 0x3e58c654, 0xbe4b1a3f },
    { 0x3d7f2ac0, 0x3d352c72 }, { 0xbcad8e87, 0x3de06fe8 }, { 0xbce7c8fe, 0xbd9b5dbd },
    { 0x3ceccac7, 0x3de96967 }, { 0xbd66c34c, 0xbcf17f62 }, { 0x3d3f6c72, 0x3d7146b1 },
    { 0xbc31e467, 0xbcf99123 }, { 0x3c761ff0, 0xbbea33a5 }, { 0x3c1bc8e6, 0x3c3a315c },
    { 0xbcee87ca, 0xbc93f199 }, { 0xbb3e3f20, 0x3d9212d7 }, { 0x3d0fd2d3, 0x3cc51cca },
    { 0xbc74aadd, 0x3bf78db2 }, { 0x3acac2d4, 0x3c8cb030 }, { 0x3cc52212, 0xbcbf6018 },
    { 0x3c64f9c8, 0xbc76054e }, { 0x3e7cb358, 0x3f081836 }, { 0xbb0824b0, 0xbf27be1c },
    { 0xbd0c6ecf, 0x3d5ae893 }, { 0x3dd43ea6, 0xba24f445 }, { 0xbe18d2b2, 0x3b698974 },
    { 0x3e050b0a, 0x3d4948ff }, { 0xbdd60db7, 0xbe072ccf }, { 0xbd2f1181, 0x3e184aa5 },
    { 0x3e5bf6f8, 0xbe567061 }, { 0xbd31f629, 0xbd03458e }, { 0x3d849595, 0xbdf0b125 },
    { 0x3d4da54c, 0x3d6c8e6c }, { 0x3dbbcc03, 0x3e115d77 }, { 0xbdaf6b56, 0x3caae096 },
    { 0x3d6ae50a, 0x3d760b43 }, { 0xbd603f15, 0xbcece50a }, { 0xbb488a41, 0x3c1f6be9 },
    { 0xbbed65f0, 0xbca86d62 }, { 0x3d200fc4, 0xbac60376 }, { 0xbc53d174, 0xbdb00586 },
    { 0x3d3042a3, 0x3cb44666 }, { 0x3c4f48aa, 0x3aaea3b0 }, { 0xba9d6fea, 0x3ccadcad },
    { 0x3ccc4119, 0xbcc610b6 }, { 0x3c4842a7, 0xbc68367f }, { 0x3e3ad9e4, 0x3edc0747 },
    { 0xbca9bb44, 0x3f17c723 }, { 0xbdaff6a3, 0x3d132411 }, { 0x3d95c5ef, 0xbd50579c },
    { 0x3e0f20aa, 0x3c972f26 }, { 0xbde1ab3b, 0xbd805e19 }, { 0xbd7c9cec, 0xbe319295 },
    { 0x3cd3f23f, 0x3df725d2 }, { 0x3e5f74ec, 0xbe4e80d6 }, { 0x3d85db26, 0x3d374850 },
    { 0xbc9a3a27, 0x3dd75153 }, { 0xbd0534ab, 0xbdc68559 }, { 0x3cfe2a03, 0x3dd41d2a },
    { 0xbd50ef21, 0xbc9d79f4 }, { 0x3d3e57c3, 0x3d4dc93e }, { 0xbc2eb630, 0xbcf51517 },
    { 0x3c77ea8d, 0xbbf16c2d }, { 0x3c2a13fa, 0x3c0787f2 }, { 0xbcedf04f, 0xbc3a3801 },
    { 0xbb4557ae, 0x3d8b487e }, { 0x3d01eec7, 0x3cfb660a }, { 0xbc80770d, 0x3b457b07 },
    { 0xba21e552, 0x3cb42e4a }, { 0x3cb2ba1e, 0xbca8b80d }, { 0x3c76f6c1, 0xbc7f9301 },
    { 0x3e7564cc, 0x3f067aab }, { 0x3b769164, 0xbf258d9f }, { 0xbd10c307, 0x3d90faa8 },
    { 0x3de53b41, 0x3c082037 }, { 0xbe1e7e9c, 0xbbccfa50 }, { 0x3e064c81, 0x3ccd5662 },
    { 0xbde6ef9a, 0xbe164ac7 }, { 0xbd2b1971, 0x3e09bac7 }, { 0x3e5dcfd2, 0xbe576869 },
    { 0xbd434d1e, 0xbcf4143b }, { 0x3d705398, 0xbde3ea27 }, { 0x3d63b086, 0x3d9ce888 },
    { 0x3db200f1, 0x3e0377a9 }, { 0xbda6756f, 0x3cd2e961 }, { 0x3d72b325, 0x3d45093a },
    { 0xbd61b53a, 0xbcee33d5 }, { 0xbaaa247a, 0x3c106276 }, { 0xbbf1b5f2, 0xbc930da6 },
    { 0x3d1ceb9f, 0xbbb98bd1 }, { 0xbc4ab112, 0xbd9ebcd2 }, { 0x3d315f6e, 0x3cee153c },
    { 0x3c2c002d, 0xb914d576 }, { 0xbb38f7eb, 0x3ce36d4b }, { 0x3cb9741c, 0xbcb64728 },
    { 0x3c31fcb8, 0xbc6fd6c5 }, { 0x3e33ac54, 0x3edcb280 }, { 0xbce50b47, 0x3f1a99b8 },
    { 0xbdb77648, 0x3d5c83aa }, { 0x3da2bb2e, 0xbd8b2b6f }, { 0x3e165c61, 0x3c7a8db5 },
    { 0xbde313fb, 0xbd4daba0 }, { 0xbd970e9a, 0xbe438c21 }, { 0x3cb2705f, 0x3dfc5776 },
    { 0x3e697e1a, 0xbe5932f3 }, { 0x3d89de6b, 0x3d2eb959 }, { 0xbc86d708, 0x3dc80954 },
    { 0xbd0c300e, 0xbdeb9df8 }, { 0x3d0bedd0, 0x3dbdc40a }, { 0xbd40e04f, 0xbc4ab048 },
    { 0x3d2e60ab, 0x3d40edad }, { 0xbc17f0ee, 0xbce7a6c4 }, { 0x3c7791b5, 0xbbdecfc0 },
    { 0x3c2959da, 0x3bb4dbdd }, { 0xbce6af6a, 0xbbd8a5e6 }, { 0xbade10c1, 0x3d84a091 },
    { 0x3ce52731, 0x3d117296 }, { 0xbc603ccf, 0xbae2a075 }, { 0xbb27796e, 0x3ccf84cd },
    { 0x3c90fed9, 0xbc8a645d }, { 0x3c8bd6fc, 0xbc7d03f0 }, { 0x3e71088b, 0x3f079bb0 },
    { 0x3c493a00, 0xbf269447 }, { 0xbd2cea2c, 0x3da6f177 }, { 0x3df3dab9, 0x3c1cbe62 },
    { 0xbe25f059, 0xbbe19296 }, { 0x3e0905c8, 0x3c4300f8 }, { 0xbdf27777, 0xbe25d192 },
    { 0xbd21c4f5, 0x3dfe2970 }, { 0x3e60bbfb, 0xbe5e6281 }, { 0xbd4e4e04, 0xbcd0577c },
    { 0x3d530dd5, 0xbdd8300a }, { 0x3d6de134, 0x3dc13c01 }, { 0x3dab5e9a, 0x3df37ffc },
    { 0xbd9c6616, 0x3cf0de17 }, { 0x3d77b6e7, 0x3d230019 }, { 0xbd6e182d, 0xbccead2e },
    { 0x3a84e0b0, 0x3bfb29bd }, { 0xbc01ef66, 0xbc83271f }, { 0x3d172904, 0xbc0f39d3 },
    { 0xbc499429, 0xbd90723b }, { 0x3d301690, 0x3d0b5077 }, { 0x3c1838da, 0xbaf14755 },
    { 0xbb567948, 0x3cf71bce }, { 0x3ca39d82, 0xbca646fe }, { 0x3c28c72a, 0xbc6f3b86 },
    { 0x3e34fa8a, 0x3edb5ecf }, { 0xbd018392, 0x3f1d74b3 }, { 0xbdcae0f5, 0x3d8948fb },
    { 0x3dc2185c, 0xbdb9dae3 }, { 0x3e1e46f5, 0x3c084110 }, { 0xbdeb24fe, 0xbd2430d2 },
    { 0xbda7aa20, 0xbe52e311 }, { 0x3c213564, 0x3e013d87 }, { 0x3e78e1e6, 0xbe67cc38 },
    { 0x3d8debbb, 0x3d1da3b8 }, { 0xbc7ac12f, 0x3db6f7fb }, { 0xbd0a4398, 0xbe0768d5 },
    { 0x3d1c9f6a, 0x3da69172 }, { 0xbd3bb3ba, 0xbc052067 }, { 0x3d11e124, 0x3d404dc4 },
    { 0xbb7784d2, 0xbcd8102a }, { 0x3c7fd6f2, 0xbbb60cdb }, { 0x3c10e87d, 0x3b6ed0ed },
    { 0xbcdb4bca, 0xbb8c1026 }, { 0xb98456cf, 0x3d7d535e }, { 0x3cc798b4, 0x3d209f3f },
    { 0xbc0f9f94, 0xbbc23559 }, { 0xbb8abeef, 0x3ce8d955 }, { 0x3c3fbe80, 0xbc4f9405 },
    { 0x3ca684d6, 0xbc73f9e9 }, { 0x3e6c486d, 0x3f08fa51 }, { 0x3cc6a989, 0xbf29098f },
    { 0xbd53a6ec, 0x3dba794f }, { 0x3dfcb554, 0x3bb36064 }, { 0xbe2b61ee, 0xbaa2ae6c },
    { 0x3e0ab9da, 0x3a3b60ec }, { 0xbdfc5d25, 0xbe348918 }, { 0xbd15b7bd, 0x3df13573 },
    { 0x3e640105, 0xbe6754b1 }, { 0xbd503b25, 0xbca53c4d }, { 0x3d33e61e, 0xbdceff3b },
    { 0x3d6e864c, 0x3de14b18 }, { 0x3da2b75d, 0x3de1a825 }, { 0xbd907209, 0x3d07e38a },
    { 0x3d786737, 0x3d06265e }, { 0xbd7766ef, 0xbc95d592 }, { 0x3b33e1f1, 0x3bcd5502 },
    { 0xbc085ce7, 0xbc6f55c8 }, { 0x3d123ebd, 0xbc3f8dc3 }, { 0xbc47c202, 0xbd85e3d9 },
    { 0x3d2868ae, 0x3d17d602 }, { 0x3c0bf8a9, 0xbb793cc1 }, { 0xbb0fc816, 0x3d03eba5 },
    { 0x3c8cce5b, 0xbc9a9c75 }, { 0x3c31d8d5, 0xbc61086b }, { 0x3e40a718, 0x3ed99ece },
    { 0xbd06c84b, 0x3f220dcd }, { 0xbdec4aef, 0x3daaedd6 }, { 0x3dfa0890, 0xbdf0738b },
    { 0x3e29d934, 0xba0cebae }, { 0xbe003eb6, 0xbcd26e6d }, { 0xbdb47751, 0xbe61902c },
    { 0xbc21a879, 0x3e03d2a3 }, { 0x3e887020, 0xbe7a2733 }, { 0x3d9793af, 0x3d0739b0 },
    { 0xbc89927c, 0x3da86ecb }, { 0xbd0412aa, 0xbe1bdcc1 }, { 0x3d33e2c0, 0x3d8f6361 },
    { 0xbd442259, 0xbb956383 }, { 0x3cddffa6, 0x3d3f9acd }, { 0x3bde228a, 0xbcc9973d },
    { 0x3c8f4ead, 0xbb8bcb3e }, { 0x3bc4aa7b, 0x3b326f32 }, { 0xbcd142ac, 0xbb578f85 },
    { 0x3a2b86d4, 0x3d7421ba }, { 0x3caec480, 0x3d339cce }, { 0xbaf60cd8, 0xbc1e8bcd },
    { 0xbbc622a5, 0x3d064c56 }, { 0x3b997173, 0xbc107244 }, { 0x3cc8d037, 0xbc6905f9 },
    { 0x3e699b04, 0x3f09fd42 }, { 0x3d1cbb48, 0xbf2cf0a2 }, { 0xbd74963f, 0x3dd495e4 },
    { 0x3e01b0d9, 0xbac23b42 }, { 0xbe2edff5, 0x3c0c017c }, { 0x3e0b407f, 0xbc718df0 },
    { 0xbe00c3ca, 0xbe41d13e }, { 0xbd130c57, 0x3de955a2 }, { 0x3e690dec, 0xbe708784 },
    { 0xbd4d308e, 0xbc6d6884 }, { 0x3d1727d6, 0xbdc69647 }, { 0x3d6c39e9, 0x3e00460c },
    { 0x3d9b28b0, 0x3dd166f5 }, { 0xbd83f783, 0x3d1ab3d7 }, { 0x3d6e7cc8, 0x3cd4880c },
    { 0xbd77d84b, 0xbc259553 }, { 0x3b6c907b, 0x3ba9ebe8 }, { 0xbc09e3e7, 0xbc5ec3ba },
    { 0x3d0f7b58, 0xbc6cc6fd }, { 0xbc3e62a4, 0xbd7c7b97 }, { 0x3d1c302f, 0x3d25ad37 },
    { 0x3c05557e, 0xbbb6e752 }, { 0x39fccb6c, 0x3d0e242f }, { 0x3c651dfa, 0xbc921ff3 },
    { 0x3c46691a, 0xbc40a3b1 }, { 0x3e57c750, 0x3ed8988b }, { 0xbd00d83e, 0x3f28c003 },
    { 0xbe10a4e8, 0x3ddb5539 }, { 0x3e2567fd, 0xbe18a9f3 }, { 0x3e3c31b4, 0xbc4c77de },
    { 0xbe147c8b, 0xbb5cd16a }, { 0xbdc41c9c, 0xbe70bb33 }, { 0xbd1356bb, 0x3e05f802 },
    { 0x3e9a74cb, 0xbe874308 }, { 0x3daa7d9d, 0x3ce804a4 }, { 0xbcb799d6, 0x3d9f6f2a },
    { 0xbcf34fb4, 0xbe3470c7 }, { 0x3d518f7b, 0x3d71b920 }, { 0xbd5a6275, 0xb97fb2f4 },
    { 0x3c9613e9, 0x3d352b7b }, { 0x3cb5aa36, 0xbcb84b49 }, { 0x3cb052da, 0xbb516e4b },
    { 0x3af5c40c, 0x3b024009 }, { 0xbcc5bf50, 0xbb304170 }, { 0x3a860b44, 0x3d6d8232 },
    { 0x3c9868c1, 0x3d4c6742 }, { 0x3bd00652, 0xbc5c01d5 }, { 0xbc0cf884, 0x3d1e1131 },
    { 0xbb0e9adf, 0xbbc9b482 }, { 0x3cf16af4, 0xbc5edd0d }, { 0x3e6e2936, 0x3f0ce110 },
    { 0x3d59e053, 0xbf344238 }, { 0xbd8cf9bd, 0x3df96c19 }, { 0x3e081b5d, 0xbc32e3e2 },
    { 0xbe349e3f, 0x3cb51351 }, { 0x3e0e84b7, 0xbd109258 }, { 0xbe01f582, 0xbe50e38d },
    { 0xbd2b6b26, 0x3de60c4e }, { 0x3e73dc42, 0xbe7cefe7 }, { 0xbd4fbcd8, 0xbc14b3a2 },
    { 0x3d04a221, 0xbdbfec42 }, { 0x3d69f2f9, 0x3e130099 }, { 0x3d993ad9, 0x3dc36ed5 },
    { 0xbd6dae4f, 0x3d3170de }, { 0x3d5a0b43, 0x3c9edc40 }, { 0xbd73fc74, 0xbb0fdc8d },
    { 0x3b6c2b08, 0x3ba0a598 }, { 0xbc007f36, 0xbc515462 }, { 0x3d0c09e4, 0xbc8d4953 },
    { 0xbc3028a4, 0xbd700231 }, { 0x3d0e9b84, 0x3d38e56e }, { 0x3c07999c, 0xbbee63db },
    { 0x3b9acab4, 0x3d1add1b }, { 0x3c251bd5, 0xbc8f04cd }, { 0x3c61d7a2, 0xbc15272a },
    { 0x3e782b3c, 0x3ed2fc05 }, { 0xbcc331bf, 0x3f2e5c9a }, { 0xbe35a2c7, 0x3e0bb9e0 },
    { 0x3e5857c9, 0xbe3c76ed }, { 0x3e550f14, 0xbce30056 }, { 0xbe318a5f, 0x3cefcaa5 },
    { 0xbdd55c1b, 0xbe7c9efe }, { 0xbd886c3c, 0x3e04cdda }, { 0x3eb08c2a, 0xbe8ea11c },
    { 0x3dc61f6a, 0x3ccef0ff }, { 0xbd060cfd, 0x3d976fed }, { 0xbcd41a48, 0xbe4e6ad3 },
    { 0x3d72d405, 0x3d3ff8ff }, { 0xbd79a03f, 0x3ba169e3 }, { 0x3c296868, 0x3d1a8483 },
    { 0x3d299198, 0xbca45566 }, { 0x3ce482f6, 0xbb1ba16e }, { 0xbb7ccf19, 0x3a30c65b },
    { 0xbcb2e494, 0xbb19417a }, { 0x3a8cec13, 0x3d641f87 }, { 0x3c7973ec, 0x3d674121 },
    { 0x3c840798, 0xbc8a3f27 }, { 0xbc4e5ee3, 0x3d385dce }, { 0xbbfe4b84, 0xbb94608e },
    { 0x3d0cc0c4, 0xbc515a99 }, { 0x3e77e192, 0x3f119339 }, { 0x3d8de5a1, 0xbf3ee518 },
    { 0xbda578f7, 0x3e14dafb }, { 0x3e11924f, 0xbcc649a2 }, { 0xbe3f1997, 0x3d24e905 },
    { 0x3e16e9e5, 0xbd7f6ebf }, { 0xbe035524, 0xbe6383b4 }, { 0xbd5d8a1c, 0x3de21a68 },
    { 0x3e8206a4, 0xbe8689d5 }, { 0xbd5f1110, 0xbb87928d }, { 0x3d03bca5, 0xbdb93b27 },
    { 0x3d645a6b, 0x3e2a73a0 }, { 0x3d9aa08d, 0x3db20c3a }, { 0xbd51faa1, 0x3d4810d5 },
    { 0x3d3ede3b, 0x3c3b0875 }, { 0xbd702335, 0x3ba8ca12 }, { 0x3b1d5642, 0x3bb3c231 },
    { 0xbbb8f95e, 0xbc3b40e2 }, { 0x3d02f6c1, 0xbca1e4d9 }, { 0xbc24c98f, 0xbd631af4 },
    { 0x3d00ca60, 0x3d4e2ba6 }, { 0x3c0efc7b, 0xbc1ee3dd }, { 0x3c2c5665, 0x3d28aa6a },
    { 0x3bc263fa, 0xbc93c13c }, { 0x3c7fb893, 0xbbc9d806 }, { 0x3e8cee73, 0x3ec190be },
    { 0xbc1ca726, 0x3f2d5420 }, { 0xbe5eddbb, 0x3e28ddb8 }, { 0x3e86c618, 0xbe5cb094 },
    { 0x3e6dbd86, 0xbd365fa1 }, { 0xbe50e165, 0x3d914425 }, { 0xbde05c37, 0xbe7dc56a },
    { 0xbdc34e50, 0x3df8e0e8 }, { 0x3ec3eb53, 0xbe8dedf2 }, { 0x3de4eda9, 0x3cc6587a },
    { 0xbd3ad67e, 0x3d8c1a61 }, { 0xbca983fd, 0xbe6370a9 }, { 0x3d870f70, 0x3d01fc8c },
    { 0xbd8d87ce, 0x3c2e9d6c }, { 0x3b990ffb, 0x3cd6d135 }, { 0x3d7c4377, 0xbc8a39a7 },
    { 0x3d1145f1, 0xbacaa6e4 }, { 0xbc2976f7, 0xbac4acb5 }, { 0xbc95e02f, 0xbb05cc52 },
    { 0x3a78c84c, 0x3d4d55ec }, { 0x3c2f70a2, 0x3d7abf1f }, { 0x3cd7646f, 0xbc9bf814 },
    { 0xbc92b9ad, 0x3d4bab30 }, { 0xbc34e734, 0xbb783598 }, { 0x3d1a13df, 0xbc41493a },
    { 0x3e7f9436, 0x3f144aec }, { 0x3dae938b, 0xbf47c828 }, { 0xbdbf7e12, 0x3e32c656 },
    { 0x3e1b76a3, 0xbd2a13c6 }, { 0xbe4b1d08, 0x3d808313 }, { 0x3e21e40f, 0xbdcbdfd2 },
    { 0xbe04c272, 0xbe74e810 }, { 0xbd918e5a, 0x3dd25d36 }, { 0x3e8ac10d, 0xbe8c85b7 },
    { 0xbd78bc9a, 0xba91dacb }, { 0x3d14fc0b, 0xbdac45e1 }, { 0x3d58644d, 0x3e42c483 },
    { 0x3d99bf0e, 0x3d94e65b }, { 0xbd35e50c, 0x3d54b2b4 }, { 0x3d1b0e1c, 0xb7dbff78 },
    { 0xbd682646, 0x3c38108c }, { 0xb8becc9d, 0x3be2b713 }, { 0xbaa1fe8c, 0xbc18f101 },
    { 0x3cddf09a, 0xbcadf082 }, { 0xbc1fa5e8, 0xbd50dfaa }, { 0x3ce7a97b, 0x3d5fc25a },
    { 0x3c14e938, 0xbc5aee98 }, { 0x3c8aa208, 0x3d34d61c }, { 0x3b11f881, 0xbc9cf42d },
    { 0x3c8b7ea9, 0xbb487262 }, { 0x3e993c21, 0x3ea3adb6 }, { 0x3c11e92d, 0x3f2305d4 },
    { 0xbe811e4b, 0x3e3bda93 }, { 0x3e9b46ce, 0xbe6fb7ce }, { 0x3e7e1951, 0xbd6fb7b0 },
    { 0xbe6a329d, 0x3de77e57 }, { 0xbde027cb, 0xbe701824 }, { 0xbde71af0, 0x3dd8b5eb },
    { 0x3ecca3d9, 0xbe83530d }, { 0x3dfe918d, 0x3cca40e5 }, { 0xbd6c22f1, 0x3d78d4c0 },
    { 0xbc66a2a4, 0xbe6cf35c }, { 0x3d8c62b2, 0x3c78fec0 }, { 0xbd9d00b6, 0x3c80bffb },
    { 0x3b2ab9c4, 0x3c4963b9 }, { 0x3d9f6724, 0xbc5d5b46 }, { 0x3d2d5cda, 0xba4c216c },
    { 0xbc86ba81, 0xbb6ed29e }, { 0xbc667611, 0xbac8df8e }, { 0x3a74e4a4, 0x3d2880d1 },
    { 0x3baf824d, 0x3d7abbc9 }, { 0x3d0eafd9, 0xbc9c1e3a }, { 0xbcbeee2c, 0x3d4e7598 },
    { 0xbc3976bb, 0xbb789fa3 }, { 0x3d1aa3da, 0xbc3192af }, { 0x3e809e2f, 0x3f10d393 },
    { 0x3dc6f415, 0xbf48a220 }, { 0xbdcf1c6e, 0x3e547e5e }, { 0x3e251c22, 0xbd71fd5f },
    { 0xbe53c6b7, 0x3db07c2b }, { 0x3e2a5909, 0xbe13176b }, { 0xbe02eeee, 0xbe7d9c09 },
    { 0xbdb937e3, 0x3db0382e }, { 0x3e913fdc, 0xbe8be871 }, { 0xbd8a0a09, 0x39f61310 },
    { 0x3d380970, 0xbd9358ba }, { 0x3d497b2c, 0x3e58c4c3 }, { 0x3d969401, 0x3d5c2a8f },
    { 0xbd164c6a, 0x3d549423 }, { 0x3cce7d01, 0xbc5e93d0 }, { 0xbd59f765, 0x3c7fa189 },
    { 0xbb6d5295, 0x3c12c59d }, { 0x3ba89ca3, 0xbbd02a7b }, { 0x3c9b0a55, 0xbcb0d990 },
    { 0xbc18c296, 0xbd358a52 }, { 0x3ccf2afc, 0x3d6ec942 }, { 0x3c24ce92, 0xbc90521a },
    { 0x3cb898f4, 0x3d3ece00 }, { 0xb9892fa4, 0xbc9efa3b }, { 0x3c90a624, 0x3a046dd6 },
    { 0x3e9f9e42, 0x3e7ec8d6 }, { 0x3cf18984, 0x3f123b88 }, { 0xbe8c8a26, 0x3e3fbc46 },
    { 0x3ea7d6d2, 0xbe7237a5 }, { 0x3e8219a0, 0xbd8567a4 }, { 0xbe7b986b, 0x3e171cd4 },
    { 0xbdd77bf6, 0xbe56ca40 }, { 0xbdefc1a1, 0x3db269fb }, { 0x3ec9c451, 0xbe651bbb },
    { 0x3e08bd1e, 0x3cd43482 }, { 0xbd8ab1de, 0x3d53ec8c }, { 0xbbfc782c, 0xbe6a15ef },
    { 0x3d8d12dd, 0xba8da7a0 }, { 0xbdab3871, 0x3c9c9302 }, { 0x3b705c33, 0x3942033a },
    { 0x3db457b3, 0xbc42951f }, { 0x3d42ad92, 0xb9d68aef }, { 0xbcaf86c1, 0xbba959a5 },
    { 0xbc265fd8, 0xba931b98 }, { 0x3ae23ac6, 0x3cf8e251 }, { 0x39411bf0, 0x3d66dd43 },
    { 0x3d283536, 0xbc8c3f6d }, { 0xbce4868d, 0x3d401980 }, { 0xbc155b3e, 0xbb8677c1 },
    { 0x3d0f3b29, 0xbc2499fc }, { 0x3e78c13e, 0x3f05b137 }, { 0x3dd4e1d7, 0xbf3e93c4 },
    { 0xbdd07010, 0x3e75cda4 }, { 0x3e2c270a, 0xbd90f119 }, { 0xbe554cd2, 0x3dd7f794 },
    { 0x3e2c76d0, 0xbe4206b6 }, { 0xbdfa39f5, 0xbe7b535d }, { 0xbddb93e6, 0x3d806035 },
    { 0x3e92ffef, 0xbe837858 }, { 0xbd9447cd, 0x3acc6572 }, { 0x3d6a0e71, 0xbd636fd5 },
    { 0x3d39812a, 0x3e69542e }, { 0x3d8ec284, 0x3cfed5b3 }, { 0xbcd927ac, 0x3d53265e },
    { 0x3c254ddd, 0xbce59b43 }, { 0xbd49f382, 0x3c92afd9 }, { 0xbc014fdd, 0x3c392279 },
    { 0x3c451236, 0xbb2daae6 }, { 0x3c08f777, 0xbcb37ead }, { 0xbc1139d2, 0xbd11f764 },
    { 0x3cb6bdba, 0x3d7c3a07 }, { 0x3c3f0b00, 0xbcaf3b7c }, { 0x3cdc4c7b, 0x3d44d722 },
    { 0xba121244, 0xbc94b3a4 }, { 0x3c8be50d, 0x3b8bd90a }, { 0x3ea2761a, 0x3e3b6751 },
    { 0x3d52e8e4, 0x3f0001e4 }, { 0xbe9241fb, 0x3e3930b4 }, { 0x3ead778a, 0xbe6a7e40 },
    { 0x3e828b6c, 0xbd873fe5 }, { 0xbe83ab06, 0x3e30ab22 }, { 0xbdcd5533, 0xbe399451 },
    { 0xbde47150, 0x3d90eb29 }, { 0x3ec03056, 0xbe40dd48 }, { 0x3e10025d, 0x3ce3cf16 },
    { 0xbd9c2cac, 0x3d326c58 }, { 0xbb1c5b9f, 0xbe5fbf66 }, { 0x3d906a28, 0xbc6c4bd2 },
    { 0xbdb78025, 0x3cad0864 }, { 0x3beaf71d, 0xbc022d0e }, { 0x3dbcc026, 0xbc40b861 },
    { 0x3d5154d4, 0xb9ce243a }, { 0xbccc0f24, 0xbbc5bdd7 }, { 0xbbe7ea09, 0xba1d1fa4 },
    { 0x3b6adce9, 0x3c9e72ca }, { 0xbb959890, 0x3d4c2956 }, { 0x3d37a59a, 0xbc66f286 },
    { 0xbd008296, 0x3d28336e }, { 0xbbb5a5a9, 0xbb8e54fc }, { 0x3cf9bd96, 0xbc18b54f },
    { 0x3e67e80f, 0x3ee9ef95 }, { 0x3dd21181, 0xbf2bd93d }, { 0xbdcc4ee7, 0x3e879bc0 },
    { 0x3e32b2f8, 0xbd94f6f1 }, { 0xbe4f7e79, 0x3de85dc7 }, { 0x3e28551d, 0xbe6b6aac },
    { 0xbdecd762, 0xbe6f3576 }, { 0xbdf8f92e, 0x3d22bb3a }, { 0x3e8f7bac, 0xbe6bbd0c },
    { 0xbd9b0b67, 0x3b06ebdd }, { 0x3d919c29, 0xbd249a25 }, { 0x3d23a3b5, 0x3e6eb4ee },
    { 0x3d81a542, 0x3bb18a02 }, { 0xbc89b896, 0x3d53a6c7 }, { 0xbb88d4c0, 0xbd24350b },
    { 0xbd359024, 0x3c8b3122 }, { 0xbc49a9a4, 0x3c5f610c }, { 0x3c91a805, 0xb82442d0 },
    { 0xbb2ae0f1, 0xbcb7c993 }, { 0xbc0e3134, 0xbcd3a262 }, { 0x3c9c8009, 0x3d814217 },
    { 0x3c5e36ad, 0xbcbee997 }, { 0x3ceb2d97, 0x3d444551 }, { 0x3a7ade72, 0xbc84485b },
    { 0x3c818b4c, 0x3be76ed2 }, { 0x3ea399c3, 0x3e067c8d }, { 0x3d9965e6, 0x3edf308b },
    { 0xbe958437, 0x3e2f689a }, { 0x3eaec771, 0xbe5ef954 }, { 0x3e82bf67, 0xbd82dc4b },
    { 0xbe888d7f, 0x3e432451 }, { 0xbdca96c9, 0xbe1e1c92 }, { 0xbdcf98c3, 0x3d71ab20 },
    { 0x3eb4586f, 0xbe1fedae }, { 0x3e15cfc8, 0x3cf82a42 }, { 0xbdabfb21, 0x3d1cf855 },
    { 0x3a9afbd8, 0xbe51aa05 }, { 0x3d987bfb, 0xbcc5ac74 }, { 0xbdc0a1a0, 0x3cb3e047 },
    { 0x3c554365, 0xbc4aa1d8 }, { 0x3dbcc4f8, 0xbc48530c }, { 0x3d5a335b, 0xb9ade85c },
    { 0xbcde0e89, 0xbbbf49b6 }, { 0xbba70fcf, 0x39e62f2e }, { 0x3bcdcc90, 0x3c1528ee },
    { 0xbc1b6259, 0x3d33a4c5 }, { 0x3d3cf7a5, 0xbc30af84 }, { 0xbd092a74, 0x3d0e39cc },
    { 0xbabdfaf1, 0xbb90ae2d }, { 0x3cce67fc, 0xbc0db0ef }, { 0x3e541135, 0x3ec68adb },
    { 0x3dbcac21, 0xbf16193d }, { 0xbdc58d71, 0x3e90ba54 }, { 0x3e39fe92, 0xbd88ce1b },
    { 0xbe461176, 0x3de2917e }, { 0x3e24eb1d, 0xbe855510 }, { 0xbddbf4fd, 0xbe5ab71a },
    { 0xbe0866df, 0x3cb49bf7 }, { 0x3e88d91f, 0xbe4e927f }, { 0xbd9f8529, 0x3ae4ce24 },
    { 0x3dac6ec3, 0xbced2bd0 }, { 0x3d0dfb6c, 0x3e691cb5 }, { 0x3d6a632a, 0xbca1d8b1 },
    { 0xbc160248, 0x3d5505c3 }, { 0xbc73a7ff, 0xbd3eeba2 }, { 0xbd252d26, 0x3c658282 },
    { 0xbc85eae8, 0x3c7b03ac }, { 0x3cb422fa, 0x392e5900 }, { 0xbc420f57, 0xbcb76368 },
    { 0xbc0bc1af, 0xbc7f3c3e }, { 0x3c817c97, 0x3d8057bb }, { 0x3c84f800, 0xbcbcd420 },
    { 0x3ce5fa9d, 0x3d407c69 }, { 0x3b565962, 0xbc6513ac }, { 0x3c6efe5a, 0x3c0458de },
    { 0x3ea0ed8f, 0x3dc7a438 }, { 0x3dc21f65, 0x3ec23941 }, { 0xbe96ce45, 0x3e2589f7 },
    { 0x3ea8c2ae, 0xbe50cd38 }, { 0x3e814212, 0xbd7ab4e1 }, { 0xbe8d2cb2, 0x3e50163a },
    { 0xbdce8469, 0xbe07c84e }, { 0xbdae237b, 0x3d481278 }, { 0x3ea5cad2, 0xbe025bf4 },
    { 0x3e176cfd, 0x3d07a00e }, { 0xbdb5caf4, 0x3d12fdbc }, { 0x3ae44960, 0xbe3fbc38 },
    { 0x3d9ee159, 0xbcf8cbdc }, { 0xbdc3fd6c, 0x3cbf9ea9 }, { 0x3cbe8c39, 0xbc73190c },
    { 0x3db1efa9, 0xbc3f586e }, { 0x3d5b8662, 0xb9327689 }, { 0xbcdef75d, 0xbba2b989 },
    { 0xbba5e5cf, 0x3b04a01d }, { 0x3c11ce03, 0xb5b55000 }, { 0xbc651e0c, 0x3d1de83c },
    { 0x3d364c9c, 0xbbeccf9a }, { 0xbd0ad1d9, 0x3cead0db }, { 0x3b572098, 0xbb92f094 },
    { 0x3c9cd031, 0xbc043fd7 }, { 0x3e4016e2, 0x3ea58d0e }, { 0x3d9a898f, 0xbf0056bc },
    { 0xbdbf2173, 0x3e966d86 }, { 0x3e45eb62, 0xbd61d671 }, { 0xbe3a06ec, 0x3dcb9126 },
    { 0x3e24d9d9, 0xbe900179 }, { 0xbdc7b3a6, 0xbe3e360c }, { 0xbe1180ab, 0x3c57dbe6 },
    { 0x3e80dcc9, 0xbe327b4a }, { 0xbda20f7f, 0x3a5b7890 }, { 0x3dc3d24a, 0xbcc7792e },
    { 0x3cff3025, 0x3e59b374 }, { 0x3d5ac6ca, 0xbd2eb0b7 }, { 0xbb917bc9, 0x3d4c6a6e },
    { 0xbcadc078, 0xbd4ae8e9 }, { 0xbd17096b, 0x3c246fab }, { 0xbc9ed99a, 0x3c83464c },
    { 0x3cc90ad4, 0xb984aee6 }, { 0xbc95d72a, 0xbca8800c }, { 0xbc0333fa, 0xbba79019 },
    { 0x3c50e5dd, 0x3d7471aa }, { 0x3ca11998, 0xbcaecaba }, { 0x3cd431c4, 0x3d3ae1ea },
    { 0x3bc7d6f8, 0xbc4d6226 }, { 0x3c5b2a2c, 0x3be745a9 }, { 0x3ea2a456, 0x3d92c40b },
    { 0x3dee89d1, 0x3eac5bb3 }, { 0xbe99f2a4, 0x3e202d4f }, { 0x3ea90a92, 0xbe4493f9 },
    { 0x3e83615a, 0xbd59934c }, { 0xbe93d471, 0x3e5a4ca5 }, { 0xbde434f3, 0xbde9853f },
    { 0xbd97e8d8, 0x3d384d7e }, { 0x3e9c4228, 0xbddb8012 }, { 0x3e1c09dd, 0x3d16f1a0 },
    { 0xbdc29684, 0x3d123248 }, { 0xbaf1a558, 0xbe2df76b }, { 0x3dab94d6, 0xbd145a83 },
    { 0xbdcb978c, 0x3cc1734b }, { 0x3d047517, 0xbc6085a1 }, { 0x3dad3de7, 0xbc55acd4 },
    { 0x3d5d7127, 0x3a03cc50 }, { 0xbcdd6198, 0xbb82584a }, { 0xbbe10553, 0x3b367fd0 },
    { 0x3c44d3c4, 0xbbfea092 }, { 0xbc8b8889, 0x3d0aabb7 }, { 0x3d2fbf14, 0xbb8430e2 },
    { 0xbd0b2f7c, 0x3cbf857c }, { 0x3bd8f5a3, 0xbb8de78c }, { 0x3c6271d9, 0xbbf7ef5e },
    { 0x3e2cd81a, 0x3e8b4e9d }, { 0x3d78a6d3, 0xbedbc95f }, { 0xbdbd1506, 0x3e9b6608 },
    { 0x3e4a6b42, 0xbd315534 }, { 0xbe3322e1, 0x3db0557a }, { 0x3e268c35, 0xbe98792e },
    { 0xbdb698a1, 0xbe23f282 }, { 0xbe1713cb, 0x3c1d56a2 }, { 0x3e6fc1d5, 0xbe1b3495 },
    { 0xbda08d52, 0xba95bd24 }, { 0x3ddb6a1e, 0xbccd6301 }, { 0x3cece6df, 0x3e461992 },
    { 0x3d4c8152, 0xbd802680 }, { 0xbaac5147, 0x3d4a3f4e }, { 0xbcbcf0d4, 0xbd5309bb },
    { 0xbd134502, 0x3be7953d }, { 0xbca5c569, 0x3c85b4fa }, { 0x3ccd7e9f, 0xba388e9a },
    { 0xbcb247f6, 0xbc9c9d8c }, { 0xbbfb3b8f, 0x3b79fd47 }, { 0x3c2685af, 0x3d6563b7 },
    { 0x3cb9fdba, 0xbc9c1a3d }, { 0x3cbf57e9, 0x3d362c95 }, { 0x3c336eff, 0xbc4402ce },
    { 0x3c4640b4, 0x3b9a7b1e }, { 0x3eaa65d3, 0x3d5c6127 }, { 0x3e1404c7, 0x3e9c616b },
    { 0xbea00da1, 0x3e207ee6 }, { 0x3eafaee6, 0xbe3b15b5 }, { 0x3e8a59c7, 0xbd2f7741 },
    { 0xbe9d4f90, 0x3e63a170 }, { 0xbe0353f8, 0xbdccaea0 }, { 0xbd8bbafc, 0x3d40c388 },
    { 0x3e96491a, 0xbdc0a55a }, { 0x3e23e7ab, 0x3d2ab9c2 }, { 0xbdd355b6, 0x3d1a32a6 },
    { 0xbc05b3f6, 0xbe1fa146 }, { 0x3dbe370f, 0xbd2bcbed }, { 0xbdd6dbed, 0x3cbffaa4 },
    { 0x3d259e00, 0xbc2684c7 }, { 0x3da8d2e5, 0xbc743016 }, { 0x3d6039e8, 0x3ae6f5b5 },
    { 0xbcdba0b7, 0xbb3acdd8 }, { 0xbc2745d5, 0x3b456fee }, { 0x3c85b3ec, 0xbc6e5ab3 },
    { 0xbc9c60a0, 0x3cf76888 }, { 0x3d2b22b3, 0xbaa047b7 }, { 0xbd0c841e, 0x3c9efea2 },
    { 0x3c1930e3, 0xbb847396 }, { 0x3c0a50fa, 0xbbf22f35 }, { 0x3e1e8abf, 0x3e6e3b03 },
    { 0x3d3bfa1f, 0xbebde5ed }, { 0xbdbd687b, 0x3ea1e543 }, { 0x3e4c9f05, 0xbcfbb440 },
    { 0xbe3407c6, 0x3d946efd }, { 0x3e2a8911, 0xbea0deae }, { 0xbdadae6f, 0xbe0df3e7 },
    { 0xbe1c7bd9, 0x3c027b76 }, { 0x3e5e592e, 0xbe08ba36 }, { 0xbd9cb18e, 0xbb52f19a },
    { 0x3df488e0, 0xbce59662 }, { 0x3ced046e, 0x3e34f643 }, { 0x3d3fb16b, 0xbda29c40 },
    { 0xb9a02dfe, 0x3d5029cb }, { 0xbcad9300, 0xbd5b62df }, { 0xbd1817d0, 0x3b8972fc },
    { 0xbc9e05e8, 0x3c85f520 }, { 0x3cc85d06, 0xba9b525c }, { 0xbcbaca83, 0xbc9768db },
    { 0xbbfe6e9c, 0x3c3f939a }, { 0x3c06e085, 0x3d5b718a }, { 0x3cd1638e, 0xbc88b770 },
    { 0x3ca6d804, 0x3d3529a7 }, { 0x3c8be781, 0xbc3f86dd }, { 0x3c2ffdf6, 0x3b04cd64 },
    { 0x3eb43f05, 0x3d393ca6 }, { 0x3e36c3e5, 0x3e8e5279 }, { 0xbea6f83d, 0x3e23c457 },
    { 0x3eb429f9, 0xbe2f5c46 }, { 0x3e91fd08, 0xbd04ef2a }, { 0xbea87f0b, 0x3e6b5344 },
    { 0xbe15f0e7, 0xbdba7bf8 }, { 0xbd70295f, 0x3d55d26f }, { 0x3e8e5d7a, 0xbda8ebe0 },
    { 0x3e2a574c, 0x3d4208e2 }, { 0xbddf8852, 0x3d2b8804 }, { 0xbc7b837a, 0xbe138e1b },
    { 0x3dced610, 0xbd3fc1ab }, { 0xbde1a360, 0x3cca0086 }, { 0x3d4d9d0f, 0xbbb9e86d },
    { 0x3d9c4fa2, 0xbc835f92 }, { 0x3d5f13d4, 0x3b5a8c9f }, { 0xbccf2621, 0xbada928c },
    { 0xbc7b0b16, 0x3b66c581 }, { 0x3cafb004, 0xbca7be74 }, { 0xbcaaf1cf, 0x3cdf4a65 },
    { 0x3d213c58, 0x3a950583 }, { 0xbd0b40a8, 0x3c8786b4 }, { 0x3c4e2aaa, 0xbb837099 },
    { 0x3b21a3f7, 0xbc02c42d }, { 0x3e19ccb6, 0x3e48c980 }, { 0x3cd22163, 0xbea0dc64 },
    { 0xbdc0de93, 0x3ea99408 }, { 0x3e540d33, 0xbc827110 }, { 0xbe3a0591, 0x3d6db8dd },
    { 0x3e32aa0b, 0xbea87073 }, { 0xbdab6b91, 0xbde8c5bf }, { 0xbe241351, 0x3c06c85e },
    { 0x3e4d1dff, 0xbdecb3cf }, { 0xbd988643, 0xbb9001f8 }, { 0x3e06b9d1, 0xbd01e9e3 },
    { 0x3cffc47b, 0x3e25eeb5 }, { 0x3d3cfec8, 0xbdbc8d73 }, { 0x35b44200, 0x3d56f54a },
    { 0xbc91de58, 0xbd624e6f }, { 0xbd1c6c66, 0x3a8b8307 }, { 0xbc8f16f1, 0x3c81a8df },
    { 0x3cc0c686, 0xbac9a568 }, { 0xbcb37b53, 0xbc8be7c7 }, { 0xbc06374c, 0x3ca208ba },
    { 0x3be34351, 0x3d554b1f }, { 0x3ceccee4, 0xbc6038a5 }, { 0x3c8ef7a9, 0x3d35708b },
    { 0x3cb948c4, 0xbc331d0d }, { 0x3c10dddb, 0xb8332082 }, { 0x3ec404b9, 0x3d31e40c },
    { 0x3e645740, 0x3e8313e0 }, { 0xbeb1bdaf, 0x3e2b9de5 }, { 0x3ebaf35f, 0xbe232d4b },
    { 0x3e9c2d64, 0xbcad25ea }, { 0xbeb7a91c, 0x3e7470e7 }, { 0xbe2ea5a3, 0xbdb23327 },
    { 0xbd475b72, 0x3d7c3392 }, { 0x3e86c742, 0xbd972cb1 }, { 0x3e326148, 0x3d5dd878 },
    { 0xbdea4199, 0x3d46fb97 }, { 0xbccba2ad, 0xbe09bf28 }, { 0x3de3a86c, 0xbd5a3524 },
    { 0xbdef4fad, 0x3cd7acae }, { 0x3d7c2f37, 0x394317d8 }, { 0x3d8ab589, 0xbc8f1faa },
    { 0x3d5d776b, 0x3bb16f7a }, { 0xbcbc5937, 0xba1401e2 }, { 0xbcb239dd, 0x3b83caf5 },
    { 0x3ce5c5d9, 0xbcd21457 }, { 0xbcb72fc2, 0x3ccc0309 }, { 0x3d16aed6, 0x3b4732e5 },
    { 0xbd087a66, 0x3c731fb2 }, { 0x3c82f7f8, 0xbb8a2884 }, { 0xbb85741f, 0xbc1812a7 },
    { 0x3e1a9ed2, 0x3e27084d }, { 0x3ac67b7a, 0xbe84b0cc }, { 0xbdc94a48, 0x3eb4e2b1 },
    { 0x3e5d70fd, 0x3b1b7fb0 }, { 0xbe42402b, 0x3d308952 }, { 0x3e3e05ef, 0xbeb158b9 },
    { 0xbdadeef1, 0xbdb03036 }, { 0xbe2c4799, 0x3c3877c9 }, { 0x3e3badeb, 0xbdc6821c },
    { 0xbd93091a, 0xbbbb60a8 }, { 0x3e13a55b, 0xbd178a72 }, { 0x3d11c22f, 0x3e189397 },
    { 0x3d400300, 0xbdd16e00 }, { 0xb9574ee8, 0x3d69b308 }, { 0xbc503684, 0xbd6c1086 },
    { 0xbd23a77f, 0xbadea2d8 }, { 0xbc76cfb3, 0x3c743230 }, { 0x3cb478ea, 0xbab8e1c4 },
    { 0xbca2c571, 0xbc8542e4 }, { 0xbc17f672, 0x3cdeeda1 }, { 0x3bc8db50, 0x3d52ecc0 },
    { 0x3d03c509, 0xbc24691e }, { 0x3c76f5f0, 0x3d38c4bc }, { 0x3ce753c6, 0xbc2807a1 },
    { 0x3bdf7ac0, 0xbabf0441 }, { 0x3edae276, 0x3d4ceb6a }, { 0x3e9022f3, 0x3e781a22 },
    { 0xbec0d3a1, 0x3e389307 }, { 0x3ec32fa1, 0xbe14dc8d }, { 0x3ea85de8, 0xbc090590 },
    { 0xbecb18b3, 0x3e7fc494 }, { 0xbe4f7bef, 0xbdb3baa4 }, { 0xbd0c112e, 0x3d9ae74b },
    { 0x3e7df627, 0xbd8b3c36 }, { 0x3e3be7c1, 0x3d80e018 }, { 0xbdf01afb, 0x3d6f6027 },
    { 0xbd1a8dd8, 0xbe022f7b }, { 0x3dfe6d55, 0xbd7c2d86 }, { 0xbe0087cb, 0x3cf32fb3 },
    { 0x3d9cf80c, 0x3be56a8f }, { 0x3d6902e7, 0xbc9e8c47 }, { 0x3d5ba4c5, 0x3c0253af },
    { 0xbc9fd5bc, 0x3a677e92 }, { 0xbcf67daa, 0x3ba2ab56 }, { 0x3d156860, 0xbcf88129 },
    { 0xbcbf24e9, 0x3cbfae68 }, { 0x3d06f9db, 0x3b9b8873 }, { 0xbd035b95, 0x3c6b49c4 },
    { 0x3ca2bb0d, 0xbb9fc019 }, { 0xbc36ac27, 0xbc38de9d }, { 0x3e212d21, 0x3e06bba6 },
    { 0xbcdad186, 0xbe53a841 }, { 0xbdd77ab6, 0x3ec3509b }, { 0x3e6b6eec, 0x3cb34c6e },
    { 0xbe4f4561, 0x3cf05d63 }, { 0x3e4b57a3, 0xbebcecba }, { 0xbdb7449c, 0xbd6f6926 },
    { 0xbe381c3f, 0x3c7a140e }, { 0x3e2c2acd, 0xbd9cb7e8 }, { 0xbd8df8a0, 0xbc0ba825 },
    { 0x3e217175, 0xbd329b08 }, { 0x3d281118, 0x3e0c11ee }, { 0x3d45d51a, 0xbde948a0 },
    { 0xbb239b56, 0x3d83007f }, { 0xbbf1af36, 0xbd78e597 }, { 0xbd328927, 0xbb8ad7be },
    { 0xbc4d5f25, 0x3c669642 }, { 0x3ca598a8, 0xba90680c }, { 0xbc8d9f85, 0xbc849d84 },
    { 0xbc39d4b2, 0x3d0ac794 }, { 0x3bb4f638, 0x3d51179e }, { 0x3d140016, 0xbbcefda6 },
    { 0x3c4c018c, 0x3d3fad71 }, { 0x3d0bd574, 0xbc239a07 }, { 0x3ba78aee, 0xbb2eb05b },
    { 0x3efc1003, 0x3d84564d }, { 0x3eb86882, 0x3e721438 }, { 0xbed4e384, 0x3e4a950d },
    { 0x3ecd54f5, 0xbe037183 }, { 0x3eb77678, 0x3bdf8f44 }, { 0xbee32e61, 0x3e86434b },
    { 0xbe7d220c, 0xbdbe8508 }, { 0xbc5def6b, 0x3dc297ca }, { 0x3e6aefe8, 0xbd8669e4 },
    { 0x3e4630a8, 0x3d982749 }, { 0xbdef0f4a, 0x3d9274b1 }, { 0xbd665e62, 0xbdf97c55 },
    { 0x3e10f748, 0xbd92bca7 }, { 0xbe0bf9cd, 0x3d0d81f4 }, { 0x3dc4ff40, 0x3c7ad071 },
    { 0x3d31502c, 0xbcb6061d }, { 0x3d58e30b, 0x3c36390a }, { 0xbc70ca15, 0x3b351fa9 },
    { 0xbd254ed3, 0x3bc920d8 }, { 0x3d421c03, 0xbd0f738d }, { 0xbcbeb9c1, 0x3cb8626d },
    { 0x3ce3be43, 0x3bd4c9ac }, { 0xbcf69084, 0x3c78431a }, { 0x3cc4b400, 0xbbc9b0cf },
    { 0xbc9b824b, 0xbc62c008 }, { 0x3e2ab9fb, 0x3dc64358 }, { 0xbd6b1c26, 0xbe1b38d9 },
    { 0xbdeca38e, 0x3ed75f97 }, { 0x3e80bc04, 0x3d381811 }, { 0xbe66c18c, 0x3c866e61 },
    { 0x3e5a457b, 0xbecdd7f6 }, { 0xbdc80e47, 0xbcf2ca71 }, { 0xbe48ab3f, 0x3c8d3a42 },
    { 0x3e1f5157, 0xbd54e8ec }, { 0xbd885337, 0xbc705484 }, { 0x3e32f555, 0xbd4f4d1a },
    { 0x3d46105f, 0x3dff48c0 }, { 0x3d4b913e, 0xbe06a2f5 }, { 0xbbe75304, 0x3d95fa3a },
    { 0xbad329f5, 0xbd87d9b1 }, { 0xbd551e05, 0xbbc335fd }, { 0xbc2792b0, 0x3c62e34b },
    { 0x3c8d9b92, 0x389eea1e }, { 0xbc6cab27, 0xbc8c8ed2 }, { 0xbc5e5505, 0x3d294a06 },
    { 0x3ba96b32, 0x3d5126b7 }, { 0x3d2a1438, 0xbb2fae63 }, { 0x3c19260b, 0x3d475455 },
    { 0x3d2bfb3a, 0xbc226bf4 }, { 0x3b86bac6, 0xbb8a059c }, { 0x3f13b8f6, 0x3dafde75 },
    { 0x3eeb4dfa, 0x3e71edd9 }, { 0xbee9e2ae, 0x3e5d9473 }, { 0x3ed6cf07, 0xbdd8d896 },
    { 0x3ec88fc0, 0x3cdcc0a8 }, { 0xbefcb576, 0x3e8b1ef4 }, { 0xbe9cec3e, 0xbdd00f02 },
    { 0x3c87c8ab, 0x3df419f7 }, { 0x3e4f540e, 0xbd873d97 }, { 0x3e4d9461, 0x3db4d8ae },
    { 0xbde3e4e6, 0x3db32176 }, { 0xbda9a2b6, 0xbdef8eff }, { 0x3e251802, 0xbda8e76b },
    { 0xbe1986fc, 0x3d27f5a9 }, { 0x3df45003, 0x3cd2232b }, { 0x3cdad22f, 0xbcd8186b },
    { 0x3d522a92, 0x3c7529f7 }, { 0xbc0486ae, 0x3bb00055 }, { 0xbd57c17c, 0x3bf0397f },
    { 0x3d77a39c, 0xbd227a1d }, { 0xbcabb7ae, 0x3caf3b9a }, { 0x3ca59ee3, 0x3c0c22da },
    { 0xbcd995e3, 0x3c88d1d3 }, { 0x3ce868a1, 0xbc055077 }, { 0xbce00d39, 0xbc89eced },
    { 0x3e361c80, 0x3d4cc938 }, { 0xbdb60be0, 0xbdac4440 }, { 0xbe04e8b2, 0x3ef41e04 },
    { 0x3e94a6e0, 0x3da3b144 }, { 0xbe88e568, 0x3a8a553c }, { 0x3e6aae2b, 0xbee6b720 },
    { 0xbde36085, 0x3bde07ea }, { 0xbe608335, 0x3c70bbd4 }, { 0x3e168d36, 0xbca25f32 },
    { 0xbd7b2f0a, 0xbcd58c68 }, { 0x3e4caf41, 0xbd6b146f }, { 0x3d6d2b6b, 0x3de18039 },
    { 0x3d4900d5, 0xbe237d21 }, { 0xbc7ef92d, 0x3da8767a }, { 0x3bce8007, 0xbd988e4b },
    { 0xbd8d89c6, 0xbbb773f0 }, { 0xbc09809c, 0x3c612be1 }, { 0x3c46d480, 0x3afe4c03 },
    { 0xbc27deee, 0xbc9f4664 }, { 0xbc706c48, 0x3d52e74f }, { 0x3ba9581f, 0x3d52eb91 },
    { 0x3d49753c, 0x3ac06ffb }, { 0x3baa1e2c, 0x3d4f3cf4 }, { 0x3d5c8e6f, 0xbc244a15 },
    { 0x3ba359b8, 0xbbc89289 }, { 0x3f2ab386, 0x3de3b9b7 }, { 0x3f11007b, 0x3e71b36f },
    { 0xbef5cae6, 0x3e6b5088 }, { 0x3ed899b9, 0xbd989b4b }, { 0x3ed579f4, 0x3d5c7185 },
    { 0xbf074729, 0x3e8a62ac }, { 0xbebebf32, 0xbde4010e }, { 0x3d74910d, 0x3e15272e },
    { 0x3e2609ea, 0xbd89a339 }, { 0x3e4b214f, 0x3dd4e723 }, { 0xbdc67238, 0x3dd58491 },
    { 0xbdecb351, 0xbde0a100 }, { 0x3e345771, 0xbdbb261a }, { 0xbe256b35, 0x3d460a74 },
    { 0x3e11bee8, 0x3d193244 }, { 0x3c03e6a3, 0xbcfdc86f }, { 0x3d422d40, 0x3c9c4bec },
    { 0x3a3315eb, 0x3c13e491 }, { 0xbd86bdae, 0x3c082088 }, { 0x3d964261, 0xbd31c2a0 },
    { 0xbc7cdf1a, 0x3c9b1882 }, { 0x3c05e61a, 0x3c321b69 }, { 0xbca53709, 0x3c938e37 },
    { 0x3d051036, 0xbc2d6a61 }, { 0xbd0ece58, 0xbca1ab22 }, { 0x3e45ef8f, 0xbcd10cab },
    { 0xbdf5a6f7, 0x3c8861a6 }, { 0xbe12ca15, 0x3f0cb9bb }, { 0x3eb90d68, 0x3e0fb056 },
    { 0xbeae15b9, 0xbcc46d86 }, { 0x3e794e7b, 0xbf0415e4 }, { 0xbe08ba67, 0x3d829f56 },
    { 0xbe7f7f0b, 0x3b2adead }, { 0x3e15148f, 0x3cf6b9a2 }, { 0xbd49f857, 0xbd466ed3 },
    { 0x3e71c5d1, 0xbd7cea53 }, { 0x3d8cfd67, 0x3db260c8 }, { 0x3d2a5082, 0xbe4f0c56 },
    { 0xbd0be992, 0x3dae96f4 }, { 0x3c9be207, 0xbdab5a8a }, { 0xbdcb64b2, 0xbb33c4d9 },
    { 0xbbd97e40, 0x3c589544 }, { 0x3b5d8672, 0x3b880a04 }, { 0xbafe62bc, 0xbcb7dc75 },
    { 0xbc5de789, 0x3d8a9da6 }, { 0x3bd26b62, 0x3d52fccb }, { 0x3d728bf6, 0x3bf16397 },
    { 0xbb0daf57, 0x3d54c549 }, { 0x3d92f536, 0xbc277418 }, { 0x3c188728, 0xbc22fc96 },
    { 0x3f38c600, 0x3e06d249 }, { 0x3f243a4e, 0x3e67bde4 }, { 0xbee99428, 0x3e6b3498 },
    { 0x3ec88807, 0xbd166fbe }, { 0x3ed225a9, 0x3da9a9de }, { 0xbf05131a, 0x3e7eb4c5 },
    { 0xbed658cc, 0xbdf1d3f4 }, { 0x3de28daf, 0x3e2b1dad }, { 0x3dddfcaa, 0xbd85aa32 },
    { 0x3e35b8fa, 0x3dee3ec8 }, { 0xbd8dc073, 0x3dec1bf8 }, { 0xbe13a7ac, 0xbdc60182 },
    { 0x3e33c26f, 0xbdc050ce }, { 0xbe261393, 0x3d562f4b }, { 0x3e2065e3, 0x3d46130d },
    { 0xbc20ebf1, 0xbd0a26d8 }, { 0x3d208022, 0x3cb6efe4 }, { 0x3c2f6779, 0x3c5c5ffa },
    { 0xbd98f942, 0x3c04fefc }, { 0x3da5d26b, 0xbd335dc4 }, { 0xbbe6c04d, 0x3c6ecf39 },
    { 0xbc0eddb6, 0x3c570c50 }, { 0xbc2c5478, 0x3c8fd8c0 }, { 0x3d0d5941, 0xbc4a6e9a },
    { 0xbd201366, 0xbcb18717 }, { 0x3e500567, 0xbe07cc8e }, { 0xbe10a828, 0x3e2015f2 },
    { 0xbe0d1f89, 0x3f14b8e6 }, { 0x3ee46668, 0x3e63fd96 }, { 0xbed81b10, 0xbd811be6 },
    { 0x3e706b00, 0xbf0c56ff }, { 0xbe20ab47, 0x3e14ee7a }, { 0xbe867569, 0xbcce9210 },
    { 0x3e13f026, 0x3dcf2f9a }, { 0xbccd8df0, 0xbdaa1e9a }, { 0x3e852f81, 0xbd6d6887 },
    { 0x3d994b18, 0x3d399b72 }, { 0x3c986c63, 0xbe7688d5 }, { 0xbd86f6f9, 0x3d8c600b },
    { 0x3d0ec964, 0xbdad56b3 }, { 0xbe084324, 0x3b3402a7 }, { 0xbb7eb39e, 0x3c2a5f2a },
    { 0xbc233ebc, 0x3bade3bf }, { 0x3c580a6e, 0xbcb4c344 }, { 0xbc0b45b1, 0x3db13869 },
    { 0x3c2159e2, 0x3d370e53 }, { 0x3d863eeb, 0x3c69667b }, { 0xbc5a43a9, 0x3d41ba37 },
    { 0x3db4c984, 0xbc1f4f8f }, { 0x3c8a5c00, 0xbc862e00 }, { 0x3f37597f, 0x3e0ad708 },
    { 0x3f27aa79, 0x3e50d074 }, { 0xbec3517f, 0x3e5e2bcc }, { 0x3eab2833, 0xbba82086 },
    { 0x3ebcb014, 0x3dd64973 }, { 0xbeea8b61, 0x3e5763c9 }, { 0xbed9a31a, 0xbdf2b182 },
    { 0x3e1a7607, 0x3e36e8b5 }, { 0x3d626b27, 0xbd7227c2 }, { 0x3e10afbc, 0x3df6e027 },
    { 0xbd0f8e38, 0x3dec937a }, { 0xbe223d3a, 0xbda3bd45 }, { 0x3e21a2d5, 0xbdb5460c },
    { 0xbe186a6a, 0x3d407ae0 }, { 0x3e202021, 0x3d6b205b }, { 0xbcb8f904, 0xbd0c114a },
    { 0x3cdf3636, 0x3cc34b25 }, { 0x3c9bc9e0, 0x3c911f84 }, { 0xbd98a104, 0x3bb07333 },
    { 0x3da37ba2, 0xbd206ac6 }, { 0x3b04b0b9, 0x3c2058ae }, { 0xbcd27888, 0x3c6d3c86 },
    { 0xba10c70f, 0x3c7063bd }, { 0x3d08eb41, 0xbc3e1a77 }, { 0xbd1d5c74, 0xbcb79e21 },
    { 0x3e3fec92, 0xbe5a69be }, { 0xbe0abe65, 0x3e879ec5 }, { 0xbdd383d5, 0x3ef750d5 },
    { 0x3eeeddb1, 0x3e8b52ec }, { 0xbee0ea6d, 0xbdc6ffc2 }, { 0x3e38cc0f, 0xbef25d22 },
    { 0xbe1df2a7, 0x3e5713f1 }, { 0xbe645c32, 0xbd7cb992 }, { 0x3e073f16, 0x3e2113b4 },
    { 0x3b6006dc, 0xbde5ca8b }, { 0x3e6bfa63, 0xbd290316 }, { 0x3d832880, 0xbbb18c49 },
    { 0xbc812468, 0xbe730e7d }, { 0xbdbe59d7, 0x3cfd1cce }, { 0x3d29e710, 0xbd8fd75c },
    { 0xbe0ffba7, 0x3c0fbef2 }, { 0x38801e46, 0x3b80bfae }, { 0xbcb79e1f, 0x3b8249ce },
    { 0x3ce43f73, 0xbc741991 }, { 0x3a366918, 0x3dbc4112 }, { 0x3c62c3fe, 0x3ce005b3 },
    { 0x3d712ff6, 0x3c88df4f }, { 0xbcb915e6, 0x3d043850 }, { 0x3dae20e1, 0xbbde5a7d },
    { 0x3cb9c8fd, 0xbcb3b754 }, { 0x3f2c4abf, 0x3dfbed33 }, { 0x3f1f5131, 0x3e36b0f3 },
    { 0xbe94f627, 0x3e51f65f }, { 0x3e8dcee6, 0x3c00d398 }, { 0x3ea1acb4, 0x3de757d3 },
    { 0xbec05375, 0x3e31c29e }, { 0xbece3b0e, 0xbdeda649 }, { 0x3e31df1d, 0x3e3cceb4 },
    { 0x3c83cf60, 0xbd55e9ae }, { 0x3dd5f3b6, 0x3df1b634 }, { 0xbbc9f959, 0x3dde0c0f },
    { 0xbe22243e, 0xbd872bcd }, { 0x3e0978b4, 0xbda4ccde }, { 0xbe03d860, 0x3d051f8c },
    { 0x3e15e7f3, 0x3d89f41b }, { 0xbce4e5d5, 0xbd0f98cb }, { 0x3c7974e1, 0x3cc22e95 },
    { 0x3cc3bbbe, 0x3cb1f00b }, { 0xbd8942da, 0x3a2ff244 }, { 0x3d956fde, 0xbd02f461 },
    { 0x3c1b63e1, 0x3bee80da }, { 0xbd1c0981, 0x3c6a4f4d }, { 0x3bdf9a2b, 0x3c243c1b },
    { 0x3cf5c9da, 0xbbf16920 }, { 0xbd0aa32b, 0xbcbc5e5b }, { 0x3e2c69cb, 0xbe6486be },
    { 0xbdecf149, 0x3e91df4c }, { 0xbd96f789, 0x3ea94fe1 }, { 0x3edd4dd6, 0x3e8b918e },
    { 0xbece33ad, 0xbde2364d }, { 0x3df59fd2, 0xbeb83064 }, { 0xbe04155d, 0x3e6f831c },
    { 0xbe2744e1, 0xbdb5d953 }, { 0x3df69dac, 0x3e2e622c }, { 0x3c9e3706, 0xbdf8f50f },
    { 0x3e326da8, 0xbcbbfdf4 }, { 0x3d2d6de1, 0xbd24bcef }, { 0xbd26e6c6, 0xbe58b353 },
    { 0xbdd8e7bd, 0xba8ba3d6 }, { 0x3d14dcb6, 0xbd665916 }, { 0xbdffa139, 0x3c7e5e6a },
    { 0x3b6a9047, 0xbb87c43f }, { 0xbce31536, 0x3a4c3096 }, { 0x3d0d2c66, 0xbbdab8d2 },
    { 0x3c1239f8, 0x3db04708 }, { 0x3c8adcbf, 0x3c11042a }, { 0x3d440f41, 0x3c620418 },
    { 0xbcd7f0b3, 0x3c950d9e }, { 0x3d881b39, 0xbb308446 }, { 0x3cc0a9f8, 0xbcc70afd },
    { 0x3f201bec, 0x3dcd50f9 }, { 0x3f13373c, 0x3e1dfdb8 }, { 0xbe5ed051, 0x3e4c9aad },
    { 0x3e6e5a95, 0xbb2455d0 }, { 0x3e8b082b, 0x3dd97716 }, { 0xbe9bc7a6, 0x3e1707c3 },
    { 0xbebd3430, 0xbde6d938 }, { 0x3e3a0d1b, 0x3e402151 }, { 0xbbf27b7a, 0xbd4e4bc5 },
    { 0x3d9e1a26, 0x3de2591a }, { 0x3c5072a6, 0x3dcba49a }, { 0xbe1940bd, 0xbd6dfea1 },
    { 0x3ded91b5, 0xbd9dfa52 }, { 0xbddfa9c3, 0x3c3d036f }, { 0x3e07767d, 0x3da3400e },
    { 0xbce53d72, 0xbd199ec4 }, { 0x3bbddd0e, 0x3cb10ec8 }, { 0x3ccd0244, 0x3cd32fb0 },
    { 0xbd69e7e9, 0xbbb4e914 }, { 0x3d85e8ad, 0xbcca9db1 }, { 0x3c7aea97, 0x3c1d2612 },
    { 0xbd3424cd, 0x3c43a328 }, { 0x3c290a00, 0x3b9c6bfc }, { 0x3ccf2157, 0x38fbac55 },
    { 0xbce150ed, 0xbcc48603 }, { 0x3e28848d, 0xbe5234c0 }, { 0xbdd06877, 0x3e883651 },
    { 0xbd79120d, 0x3e667c14 }, { 0x3ecdce6e, 0x3e88dd67 }, { 0xbebd2ed8, 0xbdee31e7 },
    { 0x3da4d59d, 0xbe90610e }, { 0xbddf3cf2, 0x3e743f71 }, { 0xbdf9a556, 0xbdcd4833 },
    { 0x3deaf8be, 0x3e2fa4a9 }, { 0x3cc2a47b, 0xbdfe08cb }, { 0x3e05e6a8, 0xbc75d3b2 },
    { 0x3cd70304, 0xbd82474c }, { 0xbd453809, 0xbe3e588c }, { 0xbde5976d, 0xbc75d814 },
    { 0x3cdcd37b, 0xbd58edec }, { 0xbde07632, 0x3ca263bb }, { 0x3bc6cc96, 0xbc1b1034 },
    { 0xbcdebffc, 0xbaefaf00 }, { 0x3d19b0fd, 0xba2e77db }, { 0x3c54e4cb, 0x3da388e1 },
    { 0x3c92383f, 0xbc24a000 }, { 0x3d256f3f, 0x3c3f66ef }, { 0xbcd5d192, 0x3c28a6b6 },
    { 0x3d4634f7, 0xbb2f76a0 }, { 0x3caf1174, 0xbcd1254a }, { 0x3f176c80, 0x3d9450c5 },
    { 0x3f08ecd6, 0x3e077e85 }, { 0xbe35a962, 0x3e50de9a }, { 0x3e53b513, 0xbd0aa213 },
    { 0x3e7831b3, 0x3dad3255 }, { 0xbe844662, 0x3e08d8e2 }, { 0xbeae0f0e, 0xbde04c1a },
    { 0x3e387831, 0x3e46a6de }, { 0xbcab7daa, 0xbd66136e }, { 0x3d7c91f8, 0x3dc8ac28 },
    { 0x3cae741d, 0x3dbedb92 }, { 0xbe0cc565, 0xbd6f3598 }, { 0x3de0c43c, 0xbda853d3 },
    { 0xbdbf684c, 0xbc4c4ade }, { 0x3df546a1, 0x3dc204a6 }, { 0xbcd54872, 0xbd28ce9d },
    { 0xba396697, 0x3c926fbf }, { 0x3cc30cee, 0x3cf87052 }, { 0xbd421c7f, 0xbc55d1d8 },
    { 0x3d79cc14, 0xbc9aa08b }, { 0x3ca7f6ec, 0x3c87b618 }, { 0xbd33e10a, 0x3c083674 },
    { 0x3c2bde01, 0xb95eeea3 }, { 0x3ca7d89e, 0x3c1e1a97 }, { 0xbcab6740, 0xbccde933 },
    { 0x3e31482e, 0xbe436778 }, { 0xbdc2ac15, 0x3e7d4603 }, { 0xbd604822, 0x3e366641 },
    { 0x3ec71840, 0x3e8cc1c5 }, { 0xbeb4c5a4, 0xbdfb0c0c }, { 0x3d73335d, 0xbe797c47 },
    { 0xbdcea708, 0x3e73fa48 }, { 0xbdcf5566, 0xbdd7f311 }, { 0x3de0a2a7, 0x3e39847d },
    { 0x3cc536ab, 0xbe02174a }, { 0x3dddd2f5, 0xbc487e39 }, { 0x3c84cc3a, 0xbd9eea6f },
    { 0xbd39a353, 0xbe26e825 }, { 0xbde95782, 0xbc3b819e }, { 0x3c9425ba, 0xbd75e2e8 },
    { 0xbdd11ea9, 0x3cbf5da0 }, { 0x3c065ad6, 0xbc538fb6 }, { 0xbcc5f06a, 0xbaa8f3a9 },
    { 0x3d1d1899, 0x3b18f5bc }, { 0x3c7272f0, 0x3d983e8b }, { 0x3c81ac0d, 0xbce3bc1b },
    { 0x3d0dd76b, 0x3c592676 }, { 0xbcc2e0c7, 0x3c08aefd }, { 0x3d14969d, 0xbbbd7bef },
    { 0x3c959368, 0xbcd07b9d }, { 0x3f127d64, 0x3d2a1478 }, { 0x3f019482, 0x3de82ab1 },
    { 0xbe2f28fc, 0x3e626a7e }, { 0x3e4aecdd, 0xbda7cf50 }, { 0x3e6adfc8, 0x3d48d86c },
    { 0xbe72a010, 0x3e079f02 }, { 0xbea49efa, 0xbddd4a31 }, { 0x3e2e8473, 0x3e568655 },
    { 0xbce6e37c, 0xbd8f913d }, { 0x3d6b9b32, 0x3da34d41 }, { 0x3ca078ea, 0x3dbecc2c },
    { 0xbe019ed8, 0xbd86a4e0 }, { 0x3deb0e67, 0xbdc0f8d4 }, { 0xbdaae5ca, 0xbd0fb6d0 },
    { 0x3de2632a, 0x3de54390 }, { 0xbcc38fa1, 0xbd3d3451 }, { 0xbb8a677a, 0x3c4e8580 },
    { 0x3cac8bfd, 0x3d13defb }, { 0xbd1e9245, 0xbcb416ae }, { 0x3d730bc9, 0xbc748152 },
    { 0x3cd7870a, 0x3cd97440 }, { 0xbd206e9a, 0x3b9b57b0 }, { 0x3c23fe0d, 0xbb8c9816 },
    { 0x3c84f67b, 0x3c9f061b }, { 0xbc700a11, 0xbcd3d933 }, { 0x3e45ce75, 0xbe3d17be },
    { 0xbdc06770, 0x3e73ceec }, { 0xbd643042, 0x3e260bfc }, { 0x3ec59eb7, 0x3e94f1dc },
    { 0xbeb35d8e, 0xbe07ebf1 }, { 0x3d500329, 0xbe65edbf }, { 0xbdca0a59, 0x3e794898 },
    { 0xbdbcbb88, 0xbddeecb9 }, { 0x3dcf882c, 0x3e4ba7f3 }, { 0x3cbdfc35, 0xbe07da90 },
    { 0x3dd2a837, 0xbbf9a2b2 }, { 0x3befd97d, 0xbdaf60d3 }, { 0xbd2c5ece, 0xbe16fef7 },
    { 0xbdea774f, 0x3b2d3f26 }, { 0x3c3b10fd, 0xbd94cf98 }, { 0xbdcef092, 0x3ce0a8d8 },
    { 0x3c20dbf5, 0xbc806bad }, { 0xbca42407, 0x3b37b770 }, { 0x3d163bf5, 0x3af88b1c },
    { 0x3c8d3c7b, 0x3d8eec39 }, { 0x3c4ec838, 0xbd22dc8f }, { 0x3cf1ca87, 0x3c87c7ce },
    { 0xbcaed11c, 0x3c20a6e6 }, { 0x3cf5069f, 0xbc134a24 }, { 0x3c722d67, 0xbccbb738 },
    { 0x3f10aa21, 0x3bf5b2c4 }, { 0x3efa3a31, 0x3dc7477c }, { 0xbe4e60d1, 0x3e82dcc7 },
    { 0x3e4f56b0, 0xbe1865bf }, { 0x3e6c9a5a, 0xbaf56f10 }, { 0xbe77fa3d, 0x3e15f027 },
    { 0xbea2bf22, 0xbddeec9e }, { 0x3e18cc5a, 0x3e765da5 }, { 0xbd00531c, 0xbdc2b066 },
    { 0x3d849adc, 0x3d6185de }, { 0x3bc16c5b, 0x3dd3ee0d }, { 0xbdfa3352, 0xbda4a0fa },
    { 0x3e043a23, 0xbde7e4d6 }, { 0xbda834a5, 0xbd50f97c }, { 0x3dd7a803, 0x3e053f88 },
    { 0xbcaf4671, 0xbd58f88e }, { 0xbb9d465c, 0x3bb316d8 }, { 0x3c85fec3, 0x3d361130 },
    { 0xbd04cb16, 0xbd0578a4 }, { 0x3d6bec10, 0xbc5712a0 }, { 0x3d06d9af, 0x3d1d26f8 },
    { 0xbd00cf03, 0x3b2eafa2 }, { 0x3c3d9dcc, 0xbbec3955 }, { 0x3c57aa12, 0x3ce1ec00 },
    { 0xbc15edea, 0xbcd4feac }, { 0x3e6473a5, 0xbe41d0b0 }, { 0xbdc7dec9, 0x3e75614e },
    { 0xbd852072, 0x3e2882f5 }, { 0x3ec65487, 0x3e9e29eb }, { 0xbeb71031, 0xbe14f87a },
    { 0x3d5c4c7a, 0xbe5af3a4 }, { 0xbdc8c553, 0x3e811e94 }, { 0xbdb778e7, 0xbdde6474 },
    { 0x3db6e0db, 0x3e62c97c }, { 0x3cac3438, 0xbe103183 }, { 0x3de0ec1b, 0x3b0c0348 },
    { 0xbb4869b2, 0xbdb3fc77 }, { 0xbd20a76a, 0xbe0dc007 }, { 0xbdee186b, 0x3cb2d52f },
    { 0x3bf1c0f0, 0xbdb2cf61 }, { 0xbdd6cad5, 0x3cfdff86 }, { 0x3c27778e, 0xbc9789c4 },
    { 0xbc6ca4c3, 0x3c20b8dd }, { 0x3d06bf54, 0xbae35254 }, { 0x3caa1fb2, 0x3d875887 },
    { 0x3c0d0dfc, 0xbd3ca6eb }, { 0x3cd57e98, 0x3ca46af6 }, { 0xbca0479d, 0x3c4e082d },
    { 0x3ce921a1, 0xbc2af20c }, { 0x3c358ef6, 0xbcc6f06f }, { 0x3f11ef62, 0xbd03615c },
    { 0x3ef574ca, 0x3dab6ad7 }, { 0xbe862dbc, 0x3e9e3c55 }, { 0x3e607679, 0xbe7749e2 },
    { 0x3e7b7972, 0xbd975314 }, { 0xbe8b09bf, 0x3e3825a1 }, { 0xbea38e56, 0xbde719a1 },
    { 0x3de3dd50, 0x3e9416fb }, { 0xbd0a608c, 0xbe0beee3 }, { 0x3da860b1, 0x3cb8bbfb },
    { 0xbcb1dbfb, 0x3e0025ca }, { 0xbdf9e4be, 0xbdd838b8 }, { 0x3e1dd3f9, 0xbe10804f },
    { 0xbdb89867, 0xbd6b25a0 }, { 0x3dd39d8d, 0x3e16e2bd }, { 0xbc975eaa, 0xbd7e6680 },
    { 0xbb3f79b2, 0xbb571728 }, { 0x3c12c220, 0x3d66dea1 }, { 0xbce1b7b3, 0xbd3ab777 },
    { 0x3d61a378, 0xbc6f4ebc }, { 0x3d2991b2, 0x3d4e7887 }, { 0xbcaa6276, 0x3abd56f4 },
    { 0x3c70890e, 0xbbe1742a }, { 0x3c302450, 0x3d08626c }, { 0xbb887962, 0xbcccdda2 },
    { 0x3e83f231, 0xbe5736b0 }, { 0xbdd5b232, 0x3e83ad86 }, { 0xbdbc8481, 0x3e3d0d9a },
    { 0x3ec771be, 0x3ea789a7 }, { 0xbec027bd, 0xbe23c7c0 }, { 0x3d9b36fa, 0xbe549972 },
    { 0xbdbd64d0, 0x3e845302 }, { 0xbdbc12c6, 0xbddbef6a }, { 0x3d9d19df, 0x3e7f397a },
    { 0x3c89f4a6, 0xbe1a7d7f }, { 0x3dfd537b, 0x3ca5ed52 }, { 0xbca0d7c9, 0xbda98057 },
    { 0xbd06940a, 0xbe07eb27 }, { 0xbdf9a10a, 0x3d3d6097 }, { 0x3bb6537d, 0xbdcf859e },
    { 0xbdec770f, 0x3d07d2dd }, { 0x3c1f95ce, 0xbcaf7b56 }, { 0xbbd35e05, 0x3c9819be },
    { 0x3ce7851b, 0xbc157660 }, { 0x3cbd8a0c, 0x3d7bc2d8 }, { 0x3b29a6cf, 0xbd443825 },
    { 0x3cd77b83, 0x3cb3db4e }, { 0xbc9059b9, 0x3c7d608a }, { 0x3cfa3464, 0xbc1f3322 },
    { 0x3bf7b02a, 0xbcc35dd3 }, { 0x3f10532e, 0xbd9a23ae }, { 0x3eea24bf, 0x3d963a68 },
    { 0xbeabe10c, 0x3eba6424 }, { 0x3e76f4aa, 0xbeb45766 }, { 0x3e85fbcf, 0xbe2781c3 },
    { 0xbea0be40, 0x3e6bd59b }, { 0xbe9ec40f, 0xbdef57f5 }, { 0x3d660b2f, 0x3ead56aa },
    { 0xbd099c28, 0xbe468246 }, { 0x3dd54eda, 0xbc8d9cee }, { 0xbd7bb390, 0x3e1965a0 },
    { 0xbdf505a4, 0xbe0e3a1c }, { 0x3e3894f6, 0xbe2f6c8f }, { 0xbdd3f5b2, 0xbd5359ac },
    { 0x3dce635b, 0x3e1f33f0 }, { 0xbc57c2ba, 0xbd90d984 }, { 0x3a807c9a, 0xbc419dce },
    { 0xba8fe9f0, 0x3d8b4c6b }, { 0xbcbaf502, 0xbd6dc835 }, { 0x3d4b1137, 0xbca95e18 },
    { 0x3d453554, 0x3d732169 }, { 0xbbe02cc3, 0xbab43034 }, { 0x3c8ac3f3, 0xba18498e },
    { 0x3c054acd, 0x3d0fe488 }, { 0x39fd44e8, 0xbca9903a }, { 0x3e908e28, 0xbe765eaf },
    { 0xbddc573d, 0x3e950596 }, { 0xbe0f6efa, 0x3e5d982f }, { 0x3ec5ca84, 0x3eab646d },
    { 0xbeccadcf, 0xbe2dd70a }, { 0x3dfa75f2, 0xbe4c7589 }, { 0xbd9ead60, 0x3e828569 },
    { 0xbdc7d35e, 0xbddcbc49 }, { 0x3d8c4226, 0x3e8ef6a9 }, { 0x3c1d126c, 0xbe24bdd2 },
    { 0x3e0a4632, 0x3d3ba895 }, { 0xbd2edfad, 0xbd92aac8 }, { 0xbc8232b3, 0xbdf9d018 },
    { 0xbe033a4a, 0x3d924ae8 }, { 0x3bbd97ac, 0xbdddbf64 }, { 0xbe088102, 0x3d0c669c },
    { 0x3c321396, 0xbcb968b7 }, { 0x3b6564a7, 0x3cd7274f }, { 0x3cc750d0, 0xbc90bf0d },
    { 0x3ca38b5c, 0x3d55f4b4 }, { 0xbbd09413, 0xbd3f7023 }, { 0x3cf18d96, 0x3ca3399b },
    { 0xbc761472, 0x3c8bb50f }, { 0x3d03c8ad, 0xbbf89201 }, { 0x3ba1edd0, 0xbcc5a7e9 },
    { 0x3f041d32, 0xbde06d8b }, { 0x3ecf66b0, 0x3d896c22 }, { 0xbec48f3a, 0x3ec4fe1a },
    { 0x3e80f41b, 0xbedf7b7c }, { 0x3e847783, 0xbe74179e }, { 0xbeb01c7d, 0x3e8bb0b3 },
    { 0xbe8eec8b, 0xbdf19c5c }, { 0x39828140, 0x3eb59eaf }, { 0xbccd3dfe, 0xbe7a3f7b },
    { 0x3df0b191, 0xbd54d8e4 }, { 0xbdc80607, 0x3e21fa77 }, { 0xbdd83eb4, 0xbe2aa3ac },
    { 0x3e41a000, 0xbe42b083 }, { 0xbde89046, 0xbd07c699 }, { 0x3dbefb7b, 0x3e13ef7e },
    { 0xbb325c40, 0xbd92e650 }, { 0x3bb0e254, 0xbc872cad }, { 0xbc2ae7f1, 0x3d906031 },
    { 0xbca3190e, 0xbd7bbb76 }, { 0x3d235cd2, 0xbcf3c624 }, { 0x3d431081, 0x3d749bd1 },
    { 0x3ba273fc, 0xbbef586c }, { 0x3c750e79, 0x3c361ec9 }, { 0x3bc2f1b4, 0x3cffc4c2 },
    { 0x3ba008e6, 0xbc451786 }, { 0x3e90e449, 0xbe827b37 }, { 0xbdd20a37, 0x3ea15a94 },
    { 0xbe338210, 0x3e6f7013 }, { 0x3ebed08b, 0x3e9f352e }, { 0xbed320aa, 0xbe246f73 },
    { 0x3e2bb2f3, 0xbe3967e8 }, { 0xbd6a056c, 0x3e752c50 }, { 0xbdcbe04e, 0xbdd6cefa },
    { 0x3d82ab9e, 0x3e96cb4f }, { 0x3bb6093e, 0xbe26e834 }, { 0x3e04cebb, 0x3d8a542d },
    { 0xbd83dd04, 0xbd8180fb }, { 0x3bb6e050, 0xbdd32320 }, { 0xbe04918f, 0x3da49c8d },
    { 0x3bf68ed0, 0xbdcf839c }, { 0xbe181d69, 0x3d121d42 }, { 0x3c7ce5d0, 0xbca7e35e },
    { 0x3c4a9e12, 0x3ce8cb20 }, { 0x3cc0f7f6, 0xbc9e2352 }, { 0x3c35ca58, 0x3d1ac5f2 },
    { 0xbc7c2603, 0xbd3637e8 }, { 0x3cead280, 0x3c7982fb }, { 0xbc65678d, 0x3c60d40c },
    { 0x3ce4b344, 0xbb807b6a }, { 0x3ba77fa4, 0xbcd17c8d }, { 0x3ee369fc, 0xbdfc596a },
    { 0x3eae93da, 0x3d87b47e }, { 0xbec4a1fe, 0x3eba1a6d }, { 0x3e798dbd, 0xbee71fce },
    { 0x3e6fb397, 0xbe87a2b2 }, { 0xbeae9150, 0x3e9002ce }, { 0xbe75a796, 0xbdf190b0 },
    { 0xbd00cff0, 0x3eaad78a }, { 0xbbdc6730, 0xbe8625c6 }, { 0x3de998ef, 0xbd887dfc },
    { 0xbde38a7a, 0x3e12b735 }, { 0xbdab5d0e, 0xbe34ddf3 }, { 0x3e338a09, 0xbe462587 },
    { 0xbdeada46, 0xbc248e84 }, { 0x3daa44a6, 0x3df99fbc }, { 0x3c4919fc, 0xbd80e310 },
    { 0x3c0e689b, 0xbc82f2f0 }, { 0xbc60054d, 0x3d7c800a }, { 0xbca39557, 0xbd592c12 },
    { 0x3cfa25e0, 0xbd15adfb }, { 0x3d269844, 0x3d52ef12 }, { 0x3bd8b579, 0xbc736896 },
    { 0x3c18a94a, 0x3cbb26e9 }, { 0x3bce0ef4, 0x3cc58156 }, { 0x3c188e08, 0xbb2af4d4 },
    { 0x3e851aef, 0xbe789635 }, { 0xbda669fe, 0x3e9ca0f6 }, { 0xbe2a39ff, 0x3e6ba3fc },
    { 0x3eb6ae5d, 0x3e8d61c4 }, { 0xbed037fb, 0xbe0eeefb }, { 0x3e393a07, 0xbe26ac05 },
    { 0xbd1be304, 0x3e60c455 }, { 0xbda681ad, 0xbdc55026 }, { 0x3d87b78e, 0x3e909c55 },
    { 0x3c1d9758, 0xbe1b9e31 }, { 0x3dcc2009, 0x3d98bbdf }, { 0xbd9e6763, 0xbd811068 },
    { 0x3c66d60c, 0xbdb4ffa7 }, { 0xbe028e5e, 0x3d88c6b3 }, { 0x3c547978, 0xbda88ea0 },
    { 0xbe1c7c1b, 0x3d143d14 }, { 0x3cadf781, 0xbc7f05cc }, { 0x3c6ff3c2, 0x3cb60de0 },
    { 0x3cce4366, 0xbc641dc6 }, { 0x3b4b8dc0, 0x3cc1fc2a }, { 0xbc938d1a, 0xbd2ce443 },
    { 0x3ca22dc5, 0x3c23668a }, { 0xbc7f96da, 0x3ba9840b }, { 0x3c848cc5, 0x3a30b1bd },
    { 0x3c015655, 0xbcd4ec58 }, { 0x3ec63401, 0xbdeefec4 }, { 0x3e969cd5, 0x3d940d65 },
    { 0xbeb7084a, 0x3ea64f9d }, { 0x3e66b57a, 0xbed74f30 }, { 0x3e4d1d96, 0xbe8132b1 },
    { 0xbea29664, 0x3e869673 }, { 0xbe5a4690, 0xbdf82135 }, { 0xbd1696c0, 0x3e9ab7e5 },
    { 0x3c2db6d0, 0xbe814e23 }, { 0x3dd2009c, 0xbd88abf4 }, { 0xbdd43823, 0x3df70805 },
    { 0xbd897eca, 0xbe3205f4 }, { 0x3e1eb4df, 0xbe3fbe4d }, { 0xbde5feb0, 0x3c3ae8d6 },
    { 0x3d97fc3e, 0x3dcccdff }, { 0x3cd7d974, 0xbd54e9a6 }, { 0x3c2cd786, 0xbc5965ed },
    { 0xbc3baab6, 0x3d4a8a5d }, { 0xbcac5092, 0xbd23f48b }, { 0x3cccf2ad, 0xbd1fa76f },
    { 0x3d07b908, 0x3d2789b2 }, { 0x3a1efc0f, 0xbca68124 }, { 0x3b5de1f9, 0x3cfc8db8 },
    { 0x3c028b5c, 0x3c8f18b7 }, { 0x3c54387d, 0x3b2811f8 }, { 0x3e7281b8, 0xbe6c70d6 },
    { 0xbd5b431a, 0x3e95bb64 }, { 0xbe0b4483, 0x3e64daa0 }, { 0x3eb1f395, 0x3e84f6a2 },
    { 0xbecc4d06, 0xbdf9187d }, { 0x3e2fd431, 0xbe1ccb86 }, { 0xbccfacbc, 0x3e5745f0 },
    { 0xbd59db5a, 0xbdbdfcfc }, { 0x3d97d986, 0x3e89fd0f }, { 0x3c7144b0, 0xbe104740 },
    { 0x3d81114f, 0x3d9c190e }, { 0xbda90d84, 0xbd8aca86 }, { 0x3c5ae904, 0xbdabe8a8 },
    { 0xbe01050e, 0x3d3c8bc5 }, { 0x3c9b6e1a, 0xbd809b34 }, { 0xbe1c44e6, 0x3d185535 },
    { 0x3ccc57f7, 0xbc2996fc }, { 0x3c369590, 0x3c5ffd90 }, { 0x3cdb7954, 0xbbec95a0 },
    { 0xb9d30a20, 0x3c6816bf }, { 0xbc77aa08, 0xbd24b21f }, { 0x3c2ab572, 0x3b9a4a1b },
    { 0xbc8e01ed, 0xbb25f887 }, { 0x3b64dcd2, 0x3badcc64 }, { 0x3c26632c, 0xbcd4b37d },
    { 0x3eb73791, 0xbdc43ae2 }, { 0x3e89d43b, 0x3da992d1 }, { 0xbea6cb22, 0x3e94dded },
    { 0x3e56ddfc, 0xbec2d59c }, { 0x3e2f016f, 0xbe6880bf }, { 0xbe94d78d, 0x3e73e99e },
    { 0xbe4ecc92, 0xbe012f8d }, { 0xbce5efc7, 0x3e8f1b70 }, { 0x3cc1096a, 0xbe71b5fc },
    { 0x3dbdbec6, 0xbd80cb51 }, { 0xbdb62d46, 0x3dd420b4 }, { 0xbd71e432, 0xbe2a6658 },
    { 0x3e0c3375, 0xbe347702 }, { 0xbde4bc94, 0x3ce285be }, { 0x3d8e013a, 0x3dad5277 },
    { 0x3d1fdfe4, 0xbd3890d9 }, { 0x3c4c7fe8, 0xbc3537ed }, { 0xbbf4186c, 0x3d211887 },
    { 0xbcb39d61, 0xbce87424 }, { 0x3cb7e147, 0xbd1ce0cb }, { 0x3ce7a8db, 0x3d04fd0f },
    { 0xbbf8cd63, 0xbcc09e0d }, { 0xbaac447c, 0x3d10c6eb }, { 0x3c21d731, 0x3c5b5a04 },
    { 0x3c85b4c0, 0x3b8358de }, { 0x3e6386d9, 0xbe6c53de }, { 0xbd024622, 0x3e96c352 },
    { 0xbdd88c58, 0x3e5ea99d }, { 0x3eb24c1c, 0x3e86e72e }, { 0xbecc58fe, 0xbde6e04a },
    { 0x3e1ed95d, 0xbe17f710 }, { 0xbcb3e2db, 0x3e5800b3 }, { 0xbce33bd9, 0xbdbfd590 },
    { 0x3da75562, 0x3e89e100 }, { 0x3c838cc1, 0xbe0b691d }, { 0x3d0a744b, 0x3d9ecf21 },
    { 0xbda779ec, 0xbd95aced }, { 0x3c20a158, 0xbdb3bca6 }, { 0xbe0068c0, 0x3d0050a3 },
    { 0x3cada16a, 0xbd4dc413 }, { 0xbe1c28fa, 0x3d1de5da }, { 0x3cda6a0a, 0xbbe1ca94 },
    { 0x3bc47a25, 0x3c028882 }, { 0x3ce9a793, 0xbb2fa7f3 }, { 0xbaa5f632, 0x3c27a6ea },
    { 0xbc4ae582, 0xbd1ef388 }, { 0x3b969f3e, 0x3aabdd10 }, { 0xbc95ce6a, 0xbbedf64c },
    { 0xbbd50136, 0x3c1ab657 }, { 0x3c3a3994, 0xbcd30ea6 }, { 0x3eb1e4d7, 0xbd82737c },
    { 0x3e83b628, 0x3dca1d90 }, { 0xbe979d04, 0x3e88a789 }, { 0x3e4c87f6, 0xbeb080c3 },
    { 0x3e1a6f80, 0xbe4da775 }, { 0xbe883922, 0x3e5f09a0 }, { 0xbe4f251f, 0xbe057aeb },
    { 0xbc5c499e, 0x3e88816e }, { 0x3d107ff8, 0xbe636c28 }, { 0x3db26280, 0xbd70d442 },
    { 0xbd96f4d8, 0x3dbef85c }, { 0xbd666a45, 0xbe2137e0 }, { 0x3df6c3b5, 0xbe270b94 },
    { 0xbde81f65, 0x3d1ef8e9 }, { 0x3d8a2a7c, 0x3d9b6e1b }, { 0x3d52ff33, 0xbd2dd316 },
    { 0x3c7dbe96, 0xbc26b8fe }, { 0xbb4edaef, 0x3d03969f }, { 0xbcbab688, 0xbc9c8ba8 },
    { 0x3caedf31, 0xbd15dc9e }, { 0x3cd4655c, 0x3cddd480 }, { 0xbc7d1412, 0xbcd2b275 },
    { 0xbb93249e, 0x3d1c7efd }, { 0x3c40aca7, 0x3c3ece79 }, { 0x3ca068e5, 0x3b6cc798 },
    { 0x3e578dab, 0xbe7215c4 }, { 0xbc6a6282, 0x3e9cf9ae }, { 0xbda5e3b6, 0x3e5ab6d8 },
    { 0x3eb6936c, 0x3e8fa6da }, { 0xbecec116, 0xbde485b9 }, { 0x3e0cf32c, 0xbe15558b },
    { 0xbcd1ba24, 0x3e604c57 }, { 0xbc204476, 0xbdc51ad0 }, { 0x3db87af5, 0x3e8e4539 },
    { 0x3c784980, 0xbe0bdc2c }, { 0x3c5a6a62, 0x3da3d00f }, { 0xbd9f57d7, 0xbda52a65 },
    { 0x3bb17960, 0xbdbead4f }, { 0xbe0136d8, 0x3cb9e4c6 }, { 0x3c9fc010, 0xbd2fc109 },
    { 0xbe1c4d54, 0x3d27c934 }, { 0x3cd89aa3, 0xbba843aa }, { 0x3af9492a, 0x3bad57cb },
    { 0x3cfd21ca, 0xb99b6e88 }, { 0xbb407376, 0x3c1cb108 }, { 0xbc4021e6, 0xbd1c5e87 },
    { 0x3a8ea7e8, 0x3a12e9ec }, { 0xbc96464f, 0xbc250294 }, { 0xbc6b0846, 0x3c57c2f8 },
    { 0x3c49f505, 0xbccc5ab6 }, { 0x3eb217d6, 0xbccbf5da }, { 0x3e8062b0, 0x3df6d885 },
    { 0xbe890884, 0x3e814164 }, { 0x3e488b19, 0xbea0933d }, { 0x3e0fd81c, 0xbe337e90 },
    { 0xbe79bbd4, 0x3e512e82 }, { 0xbe566805, 0xbe08a3aa }, { 0x3b55e20a, 0x3e863754 },
    { 0x3d4895a8, 0xbe59f8cb }, { 0x3db263c6, 0xbd615e0c }, { 0xbd734498, 0x3db58120 },
    { 0xbd68dfd4, 0xbe179b1b }, { 0x3dd523ca, 0xbe1aea28 }, { 0xbdef7fab, 0x3d3ea3e2 },
    { 0x3d8943b0, 0x3d94c6e7 }, { 0x3d843927, 0xbd320dc9 }, { 0x3ca2f5f9, 0xbc309467 },
    { 0x3a814116, 0x3ce11c98 }, { 0xbcc48e91, 0xbc3f18c4 }, { 0x3ca68bb4, 0xbd0e16e2 },
    { 0x3ccea563, 0x3cc31708 }, { 0xbcb465cb, 0xbce4cfab }, { 0xbbd817e4, 0x3d259032 },
    { 0x3c61bcf3, 0x3c3aeda7 }, { 0x3cb668d2, 0x3b25dcb0 }, { 0x3e4cd2d1, 0xbe7a4c16 },
    { 0x3bac0520, 0x3ea38ec4 }, { 0xbd7d784e, 0x3e57cf7a }, { 0x3ebcf6c1, 0x3e9cfafe },
    { 0xbed21593, 0xbdeedd89 }, { 0x3dfd0c26, 0xbe1325f9 }, { 0xbcf85b46, 0x3e6ccd3e },
    { 0x3aa84ba0, 0xbdd05966 }, { 0x3dd0386e, 0x3e94bd9b }, { 0x3c5b042a, 0xbe0f5315 },
    { 0xba80ed40, 0x3dad3d40 }, { 0xbd988183, 0xbdb77aee }, { 0x3aa95970, 0xbdc692c4 },
    { 0xbe04004b, 0x3c87f246 }, { 0x3c7b1ee6, 0xbd193ee8 }, { 0xbe1ad563, 0x3d35a9c0 },
    { 0x3cc70ed9, 0xbb8ac5ca }, { 0xb9ac8530, 0x3b88a748 }, { 0x3d07d9e6, 0x3a9d4258 },
    { 0xbbaa462e, 0x3c21d546 }, { 0xbc44f7d6, 0xbd1ed67e }, { 0xbad60492, 0x3a93dea7 },
    { 0xbc92098a, 0xbc457658 }, { 0xbca97a35, 0x3c876c70 }, { 0x3c63c1d6, 0xbcc028c0 },
    { 0x3eb5a92c, 0x3c7a5761 }, { 0x3e7ed2e5, 0x3e14a748 }, { 0xbe77192f, 0x3e7d16bd },
    { 0x3e4cc161, 0xbe9214c0 }, { 0x3e1139b4, 0xbe1b0267 }, { 0xbe658a47, 0x3e4bc1ec },
    { 0xbe617a94, 0xbe0beee2 }, { 0x3c9e071e, 0x3e87d777 }, { 0x3d84b42a, 0xbe55e02a },
    { 0x3dbe9ec8, 0xbd55ac72 }, { 0xbd422437, 0x3db8aa16 }, { 0xbd732af3, 0xbe0f1270 },
    { 0x3db5f681, 0xbe13bf9e }, { 0xbdf8185f, 0x3d5080aa }, { 0x3d8ded4c, 0x3d92f38a },
    { 0x3d9bbaf7, 0xbd412a7f }, { 0x3cd0110a, 0xbc52758e }, { 0x3b97bc73, 0x3ccf810b },
    { 0xbcd24b67, 0xbbc315b8 }, { 0x3c996348, 0xbd0938a2 }, { 0x3cd267c8, 0x3cb24814 },
    { 0xbcd8a95b, 0xbcfb587d }, { 0xbbf51700, 0x3d2ccd5a }, { 0x3c8546c9, 0x3c35857a },
    { 0x3cbca285, 0x3adb25e3 }, { 0x3e432434, 0xbe812382 }, { 0x3ce9fa31, 0x3ea81455 },
    { 0xbd4205f2, 0x3e561442 }, { 0x3ec63a60, 0x3eae9ea1 }, { 0xbed7532b, 0xbe03da22 },
    { 0x3de9b73d, 0xbe113537 }, { 0xbd0a1eaf, 0x3e7d104b }, { 0x3bfdc768, 0xbde1a1b6 },
    { 0x3df3fc45, 0x3e9c28f1 }, { 0x3c2612cc, 0xbe152414 }, { 0xbc2c0702, 0x3dbb2c4f },
    { 0xbd955b42, 0xbdccb9f8 }, { 0xbaf22de8, 0xbdcb54ae }, { 0xbe08fd85, 0x3c26fc86 },
    { 0x3c2bd2ea, 0xbd064cd4 }, { 0xbe17c9ec, 0x3d466d9b }, { 0x3ca4959c, 0xbb78d146 },
    { 0xba2d3038, 0x3b7fe993 }, { 0x3d10d8b5, 0x3b2d7a98 }, { 0xbbefdbda, 0x3c2f6faa },
    { 0xbc4a28b7, 0xbd2716e3 }, { 0xbb8984cc, 0x3b02ab2a }, { 0xbc8f2de5, 0xbc6ae660 },
    { 0xbcd35479, 0x3ca35346 }, { 0x3c839a02, 0xbcada45b }, { 0x3ebaba80, 0x3d5b8188 },
    { 0x3e814fbd, 0x3e2deec6 }, { 0xbe5fe170, 0x3e7cc710 }, { 0x3e5730b8, 0xbe83c97d },
    { 0x3e1f19cf, 0xbe040eb4 }, { 0xbe554fcc, 0x3e4e2fe4 }, { 0xbe6dad6c, 0xbe105594 },
    { 0x3d094b30, 0x3e8aaa2d }, { 0x3da26fcf, 0xbe54e8b3 }, { 0x3dd47f4a, 0xbd4e7d46 },
    { 0xbd1bf964, 0x3dc49d4b }, { 0xbd80ae8e, 0xbe07f705 }, { 0x3d9ad257, 0xbe127c80 },
    { 0xbdff97bc, 0x3d579c9e }, { 0x3d98a7c3, 0x3d8c35c1 }, { 0x3da88164, 0xbd53919e },
    { 0x3cfb9086, 0xbc803ac7 }, { 0x3c0472a3, 0x3cc755b9 }, { 0xbce4d211, 0xbaf7981e },
    { 0x3c89b6da, 0xbd0ba6e3 }, { 0x3cd8d616, 0x3ca60dd1 }, { 0xbce7ed79, 0xbd0befde },
    { 0xbbec8d9d, 0x3d3375cb }, { 0x3c9ea363, 0x3c136f88 }, { 0x3ca96545, 0x3aaec7b6 },
    { 0x3e3b8eb2, 0xbe8466d4 }, { 0x3d640476, 0x3ea9909d }, { 0xbd0fcc4a, 0x3e536938 },
    { 0x3ed49e53, 0x3ec4d11d }, { 0xbee057b2, 0xbe191e47 }, { 0x3ddf8184, 0xbe0dcd34 },
    { 0xbd17ab5e, 0x3e885d08 }, { 0x3c29d112, 0xbdf5d074 }, { 0x3e1444b0, 0x3ea3ef87 },
    { 0x3b6d2152, 0xbe1ca607 }, { 0xbc84861a, 0x3dcba95f }, { 0xbd946d66, 0xbde5a24a },
    { 0xbb6652c0, 0xbdccfbaf }, { 0xbe10e94b, 0x3a65b930 }, { 0x3ba368d2, 0xbce5b382 },
    { 0xbe13f4a7, 0x3d5b05cd }, { 0x3c647582, 0xbb7199b9 }, { 0x392d7900, 0x3b73815e },
    { 0x3d1cecfc, 0x3b9b7ea6 }, { 0xbc1aac74, 0x3c43d37e }, { 0xbc4673b2, 0xbd362c42 },
    { 0xbbde2666, 0x3b457714 }, { 0xbc92625e, 0xbc93c29b }, { 0xbcf605f9, 0x3cc043d1 },
    { 0x3c9613d1, 0xbc93fa04 }, { 0x3ebf9674, 0x3dacc338 }, { 0x3e86f807, 0x3e432c08 },
    { 0xbe4eae63, 0x3e7c4836 }, { 0x3e62c678, 0xbe6c0443 }, { 0x3e3489fa, 0xbddee5d4 },
    { 0xbe4bb796, 0x3e5594de }, { 0xbe757e84, 0xbe15dd40 }, { 0x3d3383fe, 0x3e8a6018 },
    { 0x3dad8a0e, 0xbe545d20 }, { 0x3de983a6, 0xbd4c66ae }, { 0xbd0026f3, 0x3dd0d1ab },
    { 0xbd875584, 0xbe0283d1 }, { 0x3d871089, 0xbe143bff }, { 0xbe01b25f, 0x3d520a74 },
    { 0x3da69f34, 0x3d72e4e4 }, { 0x3da34511, 0xbd5f2642 }, { 0x3d0aad1d, 0xbc95ad3c },
    { 0x3c3fc7da, 0x3cbc98b4 }, { 0xbcf7f7e0, 0x396cf730 }, { 0x3c7bbcf9, 0xbd12ac5a },
    { 0x3cd6db8e, 0x3c9fb178 }, { 0xbcdf5b76, 0xbd1889f8 }, { 0xbbd2e0c1, 0x3d392164 },
    { 0x3cb4bc84, 0x3b9c9863 }, { 0x3c7b82d6, 0x3ab1294a }, { 0x3e376c24, 0xbe88998b },
    { 0x3da4196e, 0x3eaa7724 }, { 0xbcc60ae7, 0x3e50a1af }, { 0x3ee87e63, 0x3edeacbd },
    { 0xbeee2ab0, 0xbe378c06 }, { 0x3ddb1453, 0xbe0ae71e }, { 0xbd2e786d, 0x3e9284c3 },
    { 0x3c243578, 0xbe02c381 }, { 0x3e35621d, 0x3eac7eab }, { 0xbc0d5ebc, 0xbe254fa7 },
    { 0xbc948aec, 0x3ddcc286 }, { 0xbd93fdeb, 0xbe011ed0 }, { 0xbb9ea5c8, 0xbdcee7a3 },
    { 0xbe1c1cca, 0xbc431d53 }, { 0xb9b50960, 0xbcbc71c5 }, { 0xbe117cf4, 0x3d6d046e },
    { 0x3be306fc, 0xbb7096c1 }, { 0x3a3d71e4, 0x3b65e492 }, { 0x3d2f2a3d, 0x3bedc1a6 },
    { 0xbc365c74, 0x3c5fcbf7 }, { 0xbc3a2615, 0xbd49a4ab }, { 0xbc193f44, 0x3b8a8c49 },
    { 0xbca0de6c, 0xbcc15251 }, { 0xbd051cf6, 0x3ce3791f }, { 0x3c9b81d0, 0xbc7101bc },
    { 0x3ec283d5, 0x3dd2f657 }, { 0x3e8f1c8f, 0x3e509cae }, { 0xbe436911, 0x3e772926 },
    { 0x3e6a3e07, 0xbe549d03 }, { 0x3e4720d5, 0xbdbebf73 }, { 0xbe470186, 0x3e5ad4b0 },
    { 0xbe74354b, 0xbe19da12 }, { 0x3d47ba76, 0x3e842de0 }, { 0x3da035f9, 0xbe536666 },
    { 0x3df1919d, 0xbd4cf041 }, { 0xbcd9171a, 0x3dd31f3a }, { 0xbd8ac484, 0xbdfde1e8 },
    { 0x3d7a4954, 0xbe14107b }, { 0xbe019ae9, 0x3d3e0258 }, { 0x3db1571b, 0x3d3af80f },
    { 0x3d8dd1ee, 0xbd5fc230 }, { 0x3d08df3b, 0xbca3523f }, { 0x3c77cc1a, 0x3ca738e6 },
    { 0xbd029ea4, 0x3a0623dc }, { 0x3c766847, 0xbd186c9a }, { 0x3cca24b6, 0x3c9d5ebc },
    { 0xbcc3800f, 0xbd1c1cd7 }, { 0xbbbf8de4, 0x3d3b67b1 }, { 0x3cbd329e, 0x39b6a7f0 },
    { 0x3c17d546, 0x3aae560d }, { 0x3e37b539, 0xbe90fbfb }, { 0x3dbb049a, 0x3eaed5d5 },
    { 0xbc5d40ae, 0x3e500ade }, { 0x3efe98a3, 0x3ef7e6b6 }, { 0xbeffc3ca, 0xbe59a5bc },
    { 0x3dd3cac0, 0xbe0bcbcd }, { 0xbd579ec2, 0x3e9b28dc }, { 0x3c158b5a, 0xbe03fb9d },
    { 0x3e55255f, 0x3eb58ea8 }, { 0xbcda2a41, 0xbe2de05e }, { 0xbc89d6f2, 0x3dea40fe },
    { 0xbd90eaef, 0xbe102b1f }, { 0xbbfd1db0, 0xbdd42051 }, { 0xbe288120, 0xbcd50988 },
    { 0xbb6e4340, 0xbc94603e }, { 0xbe1440cb, 0x3d7377c9 }, { 0x3ac87850, 0xbb7641ea },
    { 0xba036dbc, 0x3b5df272 }, { 0x3d47a0a0, 0x3c124ebe }, { 0xbc3ce132, 0x3c7f5560 },
    { 0xbc2e6805, 0xbd5b37af }, { 0xbc455070, 0x3bc203b9 }, { 0xbcba3c1a, 0xbcfbb2bd },
    { 0xbd0252d2, 0x3d06e3ae }, { 0x3c7e989e, 0xbc50129d }, { 0x3ec3f2e4, 0x3de46003 },
    { 0x3e976a6c, 0x3e564b16 }, { 0xbe3c774e, 0x3e6d0528 }, { 0x3e6c50e1, 0xbe435a56 },
    { 0x3e4fef93, 0xbdaa5d66 }, { 0xbe44362c, 0x3e59a6a1 }, { 0xbe6c4302, 0xbe1a023b },
    { 0x3d4dfbf8, 0x3e740449 }, { 0x3d8608aa, 0xbe517624 }, { 0x3dea03a0, 0xbd4b5a21 },
    { 0xbcb87d9c, 0x3dc96b22 }, { 0xbd8a8c02, 0xbdf9a7b7 }, { 0x3d75d752, 0xbe0f5d81 },
    { 0xbe016d23, 0x3d2329e3 }, { 0x3db6a4cd, 0x3d037614 }, { 0x3d688c82, 0xbd570e03 },
    { 0x3cf5fb66, 0xbca7eed9 }, { 0x3c920f16, 0x3c8acc29 }, { 0xbd05d5ca, 0xb91adca0 },
    { 0x3c81f1cb, 0xbd1934bc }, { 0x3cb80896, 0x3c9a84d7 }, { 0xbca4376a, 0xbd1486fe },
    { 0xbbc4890e, 0x3d3aeb8d }, { 0x3cba9ec6, 0xbb0caf94 }, { 0x3ba42dad, 0x3a9d8a13 },
    { 0x3e3ab585, 0xbea1bbf4 }, { 0x3dac9602, 0x3ebaee86 }, { 0xbb4e7360, 0x3e53495b },
    { 0x3f08d17e, 0x3f05411c }, { 0xbf08fab6, 0xbe758328 }, { 0x3dc27bdc, 0xbe13238d },
    { 0xbd87589c, 0x3ea1905f }, { 0x3c0b6550, 0xbdfbc806 }, { 0x3e6975e6, 0x3ebe6233 },
    { 0xbd38ab26, 0xbe354428 }, { 0xbc5fc592, 0x3defa36e }, { 0xbd886b69, 0xbe1e41cc },
    { 0xbc50de96, 0xbddb74bf }, { 0xbe32c40c, 0xbd1db8a0 }, { 0xbb8fe64f, 0xbc80b922 },
    { 0xbe1f5eaa, 0x3d6bb46f }, { 0x3a194d4c, 0xbb80d90b }, { 0xbb75b348, 0x3b64dd7a },
    { 0x3d61b62f, 0x3c116da3 }, { 0xbc2b1778, 0x3c8fb27d }, { 0xbc2acea8, 0xbd64398c },
    { 0xbc713194, 0x3c0f0a7b }, { 0xbcd8177b, 0xbd1cf414 }, { 0xbce4898f, 0x3d1a329f },
    { 0x3bf5aa10, 0xbc5fb52c }, { 0x3ec4ebd8, 0x3deecc17 }, { 0x3e9dbc50, 0x3e581a5f },
    { 0xbe3807b4, 0x3e60dd70 }, { 0x3e6b76b4, 0xbe378584 }, { 0x3e4fad48, 0xbd9fa24a },
    { 0xbe4275e9, 0x3e5418c2 }, { 0xbe63f5ef, 0xbe178be1 }, { 0x3d553ed4, 0x3e5f721b },
    { 0x3d5d174c, 0xbe4e9955 }, { 0x3dd96190, 0xbd47c4fe }, { 0xbc956b7a, 0x3db95c84 },
    { 0xbd8965da, 0xbdf6f8ba }, { 0x3d76c6a9, 0xbe083e02 }, { 0xbe02c4b1, 0x3d0a0723 },
    { 0x3db966e5, 0x3cb33ab6 }, { 0x3d430f68, 0xbd4acaf3 }, { 0x3cd29674, 0xbca8306d },
    { 0x3ca2f798, 0x3c630186 }, { 0xbd0795a5, 0xba9033c0 }, { 0x3c8b56fb, 0xbd165716 },
    { 0x3ca78530, 0x3c91b9f8 }, { 0xbc8fccca, 0xbd0594f8 }, { 0xbbdabc1a, 0x3d390b17 },
    { 0x3cb5cbcc, 0xbb19457d }, { 0x3b65370e, 0x3a9037c5 }, { 0x3e3d89cf, 0xbebb3b94 },
    { 0x3d842192, 0x3ecfa1c6 }, { 0x3ba37b4c, 0x3e5b47fb }, { 0x3f0f86ef, 0x3f0a748d },
    { 0xbf10d591, 0xbe825f44 }, { 0x3da94600, 0xbe2141fa }, { 0xbda26a42, 0x3ea6a70a },
    { 0x3c0c2152, 0xbde4cedc }, { 0x3e6f575e, 0x3ec6da7f }, { 0xbd6b9972, 0xbe3aedff },
    { 0xbc385358, 0x3deb08c6 }, { 0xbd7792d6, 0xbe2934b0 }, { 0xbca5e12b, 0xbddfe82d },
    { 0xbe39ff77, 0xbd428547 }, { 0xbb925ed2, 0xbc8da1c6 }, { 0xbe31a1bb, 0x3d5edc8c },
    { 0x3b8b3be3, 0xbb872e56 }, { 0xbbfada1c, 0x3b591b9a }, { 0x3d7833d3, 0x3bfd0ffd },
    { 0xbc014150, 0x3c9d1484 }, { 0xbc2bc1c3, 0xbd644fbd }, { 0xbc8b68c5, 0x3c518187 },
    { 0xbcf63797, 0xbd3853c4 }, { 0xbcbada66, 0x3d264cc1 }, { 0xbb12973e, 0xbc8e0337 },
    { 0x3ec4f331, 0x3df575d1 }, { 0x3ea0adc4, 0x3e575ffa }, { 0xbe348109, 0x3e555a29 },
    { 0x3e6ad8c8, 0xbe2f0b97 }, { 0x3e4a273c, 0xbd9a34cb }, { 0xbe410e82, 0x3e4daa79 },
    { 0xbe5df52b, 0xbe143598 }, { 0x3d5dd8cf, 0x3e4e629c }, { 0x3d3fdb0c, 0xbe4b84b3 },
    { 0x3dc63a8f, 0xbd475302 }, { 0xbc60a32a, 0x3da9ced4 }, { 0xbd888fac, 0xbdf4e515 },
    { 0x3d752761, 0xbe0106ae }, { 0xbe05573e, 0x3ce43975 }, { 0x3dbbfb65, 0x3c7b7236 },
    { 0x3d2f9d13, 0xbd3de6c8 }, { 0x3cb31114, 0xbca94863 }, { 0x3cb09456, 0x3c42c6dd },
    { 0xbd08d5ea, 0xbb216be9 }, { 0x3c907b4b, 0xbd11a812 }, { 0x3c9c0426, 0x3c81b2f2 },
    { 0xbc876aaa, 0xbce49fa2 }, { 0xbbfd5d12, 0x3d35928f }, { 0x3cb1f20c, 0xba99eb72 },
    { 0x3b8374ae, 0x3aa2d397 }, { 0x3e3ab67c, 0xbed9bc7d }, { 0x3d3576dc, 0x3eeb379a },
    { 0x3c164f1c, 0x3e68529e }, { 0x3f127c75, 0x3f0d0289 }, { 0xbf164d07, 0xbe842a5c },
    { 0x3d8d38b6, 0xbe354906 }, { 0xbdb4c78e, 0x3eab3c09 }, { 0x3c3d051b, 0xbdcaec42 },
    { 0x3e6781c7, 0x3ece53ba }, { 0xbd7c0851, 0xbe3dcd0e }, { 0xbc376d49, 0x3dde4c55 },
    { 0xbd660cf9, 0xbe2fa1c5 }, { 0xbcfdde3a, 0xbde0d4b3 }, { 0xbe3ea403, 0xbd526912 },
    { 0xbbb7675b, 0xbcaaeede }, { 0xbe45e118, 0x3d520c22 }, { 0x3c329a48, 0xbb700e14 },
    { 0xbc36c85a, 0x3b0ec038 }, { 0x3d84d6d1, 0x3bd49bc0 }, { 0xbb6c46c4, 0x3ca35bde },
    { 0xbc2cc6ce, 0xbd5daf87 }, { 0xbc9ab1f7, 0x3c8afdd3 }, { 0xbd0806e4, 0xbd48812c },
    { 0xbc97924c, 0x3d2a5366 }, { 0xbc1bc841, 0xbcb22c39 }, { 0x3ec49069, 0x3dfbcf64 },
    { 0x3ea0eea1, 0x3e563be6 }, { 0xbe326f29, 0x3e4ca067 }, { 0x3e6be7f6, 0xbe28cb4f },
    { 0x3e42ee9a, 0xbd975dce }, { 0xbe4026b7, 0x3e49082d }, { 0xbe5bd772, 0xbe11d1d6 },
    { 0x3d6a3347, 0x3e42b3a3 }, { 0x3d396aec, 0xbe4956a1 }, { 0x3db61b26, 0xbd4d2bcf },
    { 0xbc0cc168, 0x3d9ee79f }, { 0xbd882dc2, 0xbdf35689 }, { 0x3d6c5e3e, 0xbdf73543 },
    { 0xbe097907, 0x3cb81686 }, { 0x3dc002e3, 0x3c3aec87 }, { 0x3d2cb897, 0xbd33126d },
    { 0x3c9f1f1b, 0xbcae4db4 }, { 0x3cbc0e6d, 0x3c33f7d9 }, { 0xbd0a36b1, 0xbb8968ef },
    { 0x3c8fe6a8, 0xbd0dc2ec }, { 0x3c95a6a3, 0x3c57295d }, { 0xbc89f660, 0xbcbcda24 },
    { 0xbc140be3, 0x3d3122fc }, { 0x3cafa8ba, 0x3a038ed0 }, { 0x3bbd221f, 0x3aeb28b4 },
    { 0x3e30badc, 0xbef67dbc }, { 0x3d011353, 0x3f03ff40 }, { 0x3c2eff67, 0x3e760697 },
    { 0x3f1265cf, 0x3f0e975c }, { 0xbf191b3b, 0xbe8263a8 }, { 0x3d622cb2, 0xbe4a0dcb },
    { 0xbdbe9e08, 0x3eaff934 }, { 0x3c8f7f21, 0xbdb5a48c }, { 0x3e57b282, 0x3ed4835a },
    { 0xbd6d2ed0, 0xbe3d4e76 }, { 0xbc66445f, 0x3dcd70b6 }, { 0xbd5f4e5c, 0xbe323cb5 },
    { 0xbd2ffd65, 0xbdddb981 }, { 0xbe42ccaa, 0xbd4d082d }, { 0xbc0e54c1, 0xbccd6125 },
    { 0xbe56183b, 0x3d4967ba }, { 0x3c920a3b, 0xbb404092 }, { 0xbc5c40ce, 0x39ec5370 },
    { 0x3d8c74f1, 0x3bb4f9e2 }, { 0x3acd5dcc, 0x3c9fc244 }, { 0xbc2bb9a1, 0xbd520e1d },
    { 0xbca5ce4d, 0x3c9e605a }, { 0xbd12271f, 0xbd4b6aff }, { 0xbc838fe6, 0x3d2753b9 },
    { 0xbc4ac7d0, 0xbcc94a5f }, { 0x3ec3c847, 0x3e02f193 }, { 0x3e9f1817, 0x3e575ede },
    { 0xbe31a02e, 0x3e4640d7 }, { 0x3e6d1789, 0xbe240394 }, { 0x3e3a7ceb, 0xbd96277e },
    { 0xbe3fc144, 0x3e46784e }, { 0xbe5cf5cc, 0xbe1284b8 }, { 0x3d7ebc9e, 0x3e3ba9db },
    { 0x3d474750, 0xbe4865ce }, { 0x3dab669e, 0xbd58f077 }, { 0xbb13d9e6, 0x3d98d498 },
    { 0xbd89101c, 0xbdf1ead4 }, { 0x3d5a8912, 0xbdf20bc7 }, { 0xbe0eac0f, 0x3c9133ac },
    { 0x3dc5bc7a, 0x3c0b46b1 }, { 0x3d380b60, 0xbd292690 }, { 0x3c99a833, 0xbcb787c0 },
    { 0x3cc6a798, 0x3c2f2814 }, { 0xbd0c3ae9, 0xbbbc7299 }, { 0x3c89257a, 0xbd0c0256 },
    { 0x3c92fcf8, 0x3c221d71 }, { 0xbc969ddd, 0xbc96e128 }, { 0xbc27fccd, 0x3d2bf468 },
    { 0x3cacc7d8, 0x3b013ccf }, { 0x3c0434d4, 0x3b40cf9c }, { 0x3e23466f, 0xbf06fada },
    { 0x3cd1dce4, 0x3f10fab5 }, { 0x3c461461, 0x3e806a70 }, { 0x3f121d01, 0x3f10ec7c },
    { 0xbf1aecfb, 0xbe800899 }, { 0x3d31b592, 0xbe59bd58 }, { 0xbdc73970, 0x3eb5f2c4 },
    { 0x3cd5aa96, 0xbda47310 }, { 0x3e476ec1, 0x3edba6f4 }, { 0xbd51ee88, 0xbe3b63d6 },
    { 0xbca10446, 0x3dbd9146 }, { 0xbd58be8c, 0xbe346652 }, { 0xbd5e7b32, 0xbdd47a2c },
    { 0xbe4a16dd, 0xbd35dabd }, { 0xbc596177, 0xbcea681a }, { 0xbe612793, 0x3d4c1a4d },
    { 0x3cbae5f3, 0xbb68aede }, { 0xbc6aaee6, 0xbabd3b8a }, { 0x3d959108, 0x3b92e00c },
    { 0x3bc57ee9, 0x3c94b210 }, { 0xbc23c70a, 0xbd462e30 }, { 0xbcaf86a3, 0x3c9a46b6 },
    { 0xbd1a0b57, 0xbd48c1e8 }, { 0xbc83a9a9, 0x3d224427 }, { 0xbc414b15, 0xbcce51fb },
    { 0x3ec2fbeb, 0x3e0a8c05 }, { 0x3e9bc0bb, 0x3e5caad5 }, { 0xbe31d4b5, 0x3e432083 },
    { 0x3e6fbb06, 0xbe2123ef }, { 0x3e3232b4, 0xbd958b1c }, { 0xbe4081b4, 0x3e4704c0 },
    { 0xbe615dcc, 0xbe16f235 }, { 0x3d8e04c2, 0x3e38f3fb }, { 0x3d69e7d6, 0xbe4a1e5c },
    { 0x3da762d7, 0xbd6a8d18 }, { 0x3b9f6225, 0x3d9766fa }, { 0xbd8d0e24, 0xbdf0726c },
    { 0x3d3fe97f, 0xbdf55405 }, { 0xbe154867, 0x3c5c9941 }, { 0x3dcd9fed, 0x3bc50c5f },
    { 0x3d4ebad3, 0xbd20dc50 }, { 0x3ca0979d, 0xbcc4c43b }, { 0x3cd1fd0f, 0x3c2f6c24 },
    { 0xbd0f34d4, 0xbbe9eb5f }, { 0x3c7766f7, 0xbd0d4c31 }, { 0x3c954bc3, 0x3bc98b47 },
    { 0xbcac4e99, 0xbc67fdce }, { 0xbc38a9a8, 0x3d264b8d }, { 0x3caa6695, 0x3b45c1cd },
    { 0x3c2d19f1, 0x3b9f103c }, { 0x3e128c06, 0xbf119749 }, { 0x3cd18861, 0x3f1d7b98 },
    { 0x3c6f8d05, 0x3e84b126 }, { 0x3f13969b, 0x3f154ac9 }, { 0xbf1d931b, 0xbe80d178 },
    { 0x3d0ac63a, 0xbe63215f }, { 0xbdcccb3b, 0x3ebe18cf }, { 0x3d1852c7, 0xbd9609f4 },
    { 0x3e38c521, 0x3ee5dc1f }, { 0xbd36b679, 0xbe39aa91 }, { 0xbce1de52, 0x3db4382a },
    { 0xbd51ff1f, 0xbe3a29a7 }, { 0xbd86c0c5, 0xbdc6bbaa }, { 0xbe55df2a, 0xbd0ed393 },
    { 0xbc9892e3, 0xbcedef5c }, { 0xbe69f969, 0x3d53fe93 }, { 0x3cd3f41e, 0xbbc81878 },
    { 0xbc68c43c, 0xbb777355 }, { 0x3da0e942, 0x3b49160a }, { 0x3c19589d, 0x3c85c406 },
    { 0xbc1eddde, 0xbd3d52f4 }, { 0xbcbe79c7, 0x3c812f3d }, { 0xbd206568, 0xbd4ada5d },
    { 0xbc94a346, 0x3d21cfbe }, { 0xbc18d909, 0xbcc797cb }, { 0x3ebde2be, 0x3e110f24 },
    { 0x3e93bf6d, 0x3e60b09a }, { 0xbe2f7f76, 0x3e408d95 }, { 0x3e6e3b2e, 0xbe1d0f9a },
    { 0x3e26b584, 0xbd92c139 }, { 0xbe3e825e, 0x3e469459 }, { 0xbe62a0c6, 0xbe19c819 },
    { 0x3d9bfd54, 0x3e36069a }, { 0x3d8cac91, 0xbe4a7cf6 }, { 0x3da6881f, 0xbd7b454b },
    { 0x3c4611b2, 0x3d9739f4 }, { 0xbd8fe5ec, 0xbde89a9b }, { 0x3d1c69bf, 0xbdfbc237 },
    { 0xbe19c02a, 0x3c1bbca1 }, { 0x3dd2ec7a, 0x3b69a147 }, { 0x3d69891e, 0xbd177aa4 },
    { 0x3cac895c, 0xbccf82d6 }, { 0x3cda4a3b, 0x3c2ae133 }, { 0xbd0ef4db, 0xbc05c137 },
    { 0x3c4e0c61, 0xbd0db752 }, { 0x3c99555e, 0x3b09c681 }, { 0xbcc3005b, 0xbc2491de },
    { 0xbc425176, 0x3d1c2092 }, { 0x3ca4f60f, 0x3b7b31be }, { 0x3c53c6d2, 0x3bef7f64 },
    { 0x3df9836b, 0xbf188d43 }, { 0x3cee2ce3, 0x3f268a29 }, { 0x3c9299ac, 0x3e853c5b },
    { 0x3f147bc5, 0x3f188300 }, { 0xbf1df2c4, 0xbe83b49b }, { 0x3cdb2e95, 0xbe622a1b },
    { 0xbdc9bf9f, 0x3ec3a500 }, { 0x3d49930e, 0xbd8644f6 }, { 0x3e27e1b9, 0x3eeef5e5 },
    { 0xbd1f2eaa, 0xbe34d929 }, { 0xbd13bdec, 0x3dafe003 }, { 0xbd4a6c1a, 0xbe406d7a },
    { 0xbd9d193e, 0xbdb3f722 }, { 0xbe60567a, 0xbca9d53c }, { 0xbcbcb035, 0xbcca4421 },
    { 0xbe6caec6, 0x3d54f97f }, { 0x3cdd0a33, 0xbc290672 }, { 0xbc5b2a27, 0xbbd0add2 },
    { 0x3da9a99f, 0x3a9523f5 }, { 0x3c3edc72, 0x3c63406c }, { 0xbc25ad6d, 0xbd32cae5 },
    { 0xbcd07605, 0x3c29b30a }, { 0xbd218641, 0xbd51bf12 }, { 0xbcab59ec, 0x3d2664c0 },
    { 0xbbc25b5c, 0xbcb5e4ef }, { 0x3eb9605a, 0x3e143da7 }, { 0x3e8a8969, 0x3e61cbd8 },
    { 0xbe2e5f4c, 0x3e441cc4 }, { 0x3e6c00ed, 0xbe1d7f1e }, { 0x3e1c07ba, 0xbd92e929 },
    { 0xbe3d8bcc, 0x3e477b0c }, { 0xbe630f95, 0xbe1a47a5 }, { 0x3da94acc, 0x3e363650 },
    { 0x3daad7b4, 0xbe4cbfbf }, { 0x3dab0c6c, 0xbd86c318 }, { 0x3c963518, 0x3d9c69ba },
    { 0xbd8fc21a, 0xbdde6552 }, { 0x3cfaaca6, 0xbe03339c }, { 0xbe1e2672, 0x3b996acf },
    { 0x3dd7a753, 0x3adc1735 }, { 0x3d843285, 0xbd10f1d0 }, { 0x3cbdc1f7, 0xbcda1a13 },
    { 0x3cdf8489, 0x3c27e4b6 }, { 0xbd0d5c8f, 0xbc1ad2e7 }, { 0x3c269ade, 0xbd0c84a5 },
    { 0x3ca09189, 0xbaa1cf1d }, { 0xbcd4528f, 0xbbd60db6 }, { 0xbc515a07, 0x3d0f0d53 },
    { 0x3c9cef0b, 0x3ba10878 }, { 0x3c786eac, 0x3c20a50d }, { 0x3dc643fb, 0xbf1de34a },
    { 0x3d155ba4, 0x3f2ee35f }, { 0x3cb8682b, 0x3e84a115 }, { 0x3f1774c4, 0x3f1c0705 },
    { 0xbf1dd059, 0xbe8bd7f8 }, { 0x3cc7b90e, 0xbe5ccb35 }, { 0xbdc09377, 0x3ec75b30 },
    { 0x3d7d16e6, 0xbd6f17f1 }, { 0x3e168d76, 0x3efb921b }, { 0xbd13f0fc, 0xbe2eff8d },
    { 0xbd342f82, 0x3db65a06 }, { 0xbd493871, 0xbe475fc4 }, { 0xbdb5dfd2, 0xbda231cc },
    { 0xbe6c164f, 0xba938a10 }, { 0xbcc7a0e3, 0xbc9656da }, { 0xbe6ca82d, 0x3d438321 },
    { 0x3cdf208a, 0xbc831f02 }, { 0xbc49b9df, 0xbc1c0901 }, { 0x3db097e1, 0xba34b924 },
    { 0x3c58e02b, 0x3c3abf25 }, { 0xbc3e9b5e, 0xbd2367e4 }, { 0xbce49b3c, 0x3b53dd5f },
    { 0xbd1f7e6f, 0xbd5f5118 }, { 0xbcc1a788, 0x3d358ff3 }, { 0xbaed2da1, 0xbc955bea },
    { 0x3eb592e4, 0x3e11dfd3 }, { 0x3e8114e3, 0x3e6013e9 }, { 0xbe2eea83, 0x3e4a61e2 },
    { 0x3e66f714, 0xbe246c4c }, { 0x3e107bc1, 0xbd99948b }, { 0xbe3ec408, 0x3e48dee2 },
    { 0xbe60c69b, 0xbe17c154 }, { 0x3db2849d, 0x3e38437f }, { 0x3dc94bdb, 0xbe4f8e96 },
    { 0x3db23c6a, 0xbd908d39 }, { 0x3cbf2d8a, 0x3da3e649 }, { 0xbd8d37e3, 0xbdd2c5ae },
    { 0x3cda050b, 0xbe09362e }, { 0xbe20ddf7, 0xba938890 }, { 0x3dd8f0b3, 0xb92bc83a },
    { 0x3d91c7a1, 0xbd0cf1c6 }, { 0x3ccf2ac2, 0xbce1237b }, { 0x3cdece40, 0x3c27a093 },
    { 0xbd0a4e3f, 0xbc3300d4 }, { 0x3c0b08cd, 0xbd0be9bf }, { 0x3ca7cf1b, 0xbb6c418d },
    { 0xbcda7432, 0xbb84f914 }, { 0xbc6038a8, 0x3cfddc49 }, { 0x3c8e8c62, 0x3bb7f2db },
    { 0x3c890fe7, 0x3c4362a5 }, { 0x3d9e3df1, 0xbf220a66 }, { 0x3d303a4a, 0x3f36946f },
    { 0x3cebb7df, 0x3e846d81 }, { 0x3f1c73c8, 0x3f2184c8 }, { 0xbf1daab7, 0xbe94fdfa },
    { 0x3cc9c46d, 0xbe53e7cc }, { 0xbdc053b7, 0x3eca982e }, { 0x3d9c6a93, 0xbd55287f },
    { 0x3e0a7c86, 0x3f05a550 }, { 0xbd1ab494, 0xbe30471e }, { 0xbd507ec8, 0x3dc4d616 },
    { 0xbd48d7ec, 0xbe4e0fce }, { 0xbdd1f3b4, 0xbd958379 }, { 0xbe789f71, 0x3ca7fe46 },
    { 0xbcb3e132, 0xbc184065 }, { 0xbe6c9b86, 0x3d33097a }, { 0x3cda236c, 0xbcacef1a },
    { 0xbc40c71b, 0xbc48f44c }, { 0x3db5bf34, 0xbb540975 }, { 0x3c6de641, 0x3c118880 },
    { 0xbc5090e0, 0xbd10857e }, { 0xbd0246f3, 0xbb7164d6 }, { 0xbd214d3c, 0xbd70a70a },
    { 0xbcd565aa, 0x3d4c32e3 }, { 0x3b1f01be, 0xbc6518c2 }, { 0x3eb0dcaa, 0x3e054157 },
    { 0x3e6e972c, 0x3e5807fe }, { 0xbe2f5afa, 0x3e4dc2b8 }, { 0x3e5eda5c, 0xbe2f743a },
    { 0x3e049502, 0xbda454c4 }, { 0xbe3ff2c0, 0x3e47b8f6 }, { 0xbe5abb50, 0xbe10cd2c },
    { 0x3db0c37e, 0x3e3919fc }, { 0x3de1ced8, 0xbe51102c }, { 0x3db79c64, 0xbd9a6f82 },
    { 0x3cd06cc4, 0x3daad4e3 }, { 0xbd891b0f, 0xbdc56226 }, { 0x3cdb571f, 0xbe0d701c },
    { 0xbe200889, 0xbc036a1c }, { 0x3dd3b573, 0xbb0a07f1 }, { 0x3d985689, 0xbd0bfd23 },
    { 0x3cd8f158, 0xbce1cc42 }, { 0x3cd4d648, 0x3c2992b9 }, { 0xbd04c9a3, 0xbc507171 },
    { 0x3bfb72c4, 0xbd0be90e }, { 0x3cadc274, 0xbb9e4c41 }, { 0xbccd5166, 0xbb4b3587 },
    { 0xbc6cb088, 0x3cd7855b }, { 0x3c7058ec, 0x3badc927 }, { 0x3c8dcd55, 0x3c5c2d6a },
    { 0x3d8199aa, 0xbf24b11f }, { 0x3d3cb7dd, 0x3f3c0a96 }, { 0x3d16b9a8, 0x3e83fbc6 },
    { 0x3f2053db, 0x3f273b75 }, { 0xbf1bf480, 0xbe9b79f5 }, { 0x3cc6be86, 0xbe46fb88 },
    { 0xbdc873f7, 0x3ecc3618 }, { 0x3dc00011, 0xbd4a06b2 }, { 0x3e043fe6, 0x3f0c7e6f },
    { 0xbd321933, 0xbe39b71d }, { 0xbd65b47f, 0x3dd91b8a }, { 0xbd41c960, 0xbe50e144 },
    { 0xbdec68a3, 0xbd8e1c24 }, { 0xbe80233f, 0x3d2619f6 }, { 0xbc7ab89d, 0x3aa9d180 },
    { 0xbe6d3fc3, 0x3d2264be }, { 0x3cd4115a, 0xbcc1419a }, { 0xbc419660, 0xbc6ecce8 },
    { 0x3db62882, 0xbbeed941 }, { 0x3c84a43d, 0x3bccb74e }, { 0xbc3e2407, 0xbcf1e8b7 },
    { 0xbd18b121, 0xbc0df0e2 }, { 0xbd27aeac, 0xbd80096f }, { 0xbce5d50e, 0x3d66e7a6 },
    { 0x3bd4006c, 0xbc34045c }, { 0x3eac6243, 0x3dd92180 }, { 0x3e5ea25c, 0x3e479520 },
    { 0xbe302de0, 0x3e4aee4e }, { 0x3e55b485, 0xbe3d01fa }, { 0x3df3fd5d, 0xbdb20b33 },
    { 0xbe412cf7, 0x3e42746e }, { 0xbe52160a, 0xbe06f011 }, { 0x3da3556a, 0x3e36bbea },
    { 0x3deec9c7, 0xbe508eb8 }, { 0x3db81c54, 0xbda3cf35 }, { 0x3cc6ff61, 0x3db0a217 },
    { 0xbd833b63, 0xbdb936c3 }, { 0x3cff6554, 0xbe0e9da3 }, { 0xbe1bd8f0, 0xbc824671 },
    { 0x3dc8bf41, 0xbb863de4 }, { 0x3d9603a8, 0xbd0c7a63 }, { 0x3cd7c8a3, 0xbcdd4c30 },
    { 0x3cc384ad, 0x3c2ce638 }, { 0xbcfa9c3a, 0xbc763959 }, { 0x3c02f8a4, 0xbd0adc8a },
    { 0x3cb0148d, 0xbb990dd9 }, { 0xbcac7844, 0xbb6fec54 }, { 0xbc7bfb75, 0x3cb25192 },
    { 0x3c355c66, 0x3b80daa0 }, { 0x3c8d5c1c, 0x3c69252a }, { 0x3d60ccb9, 0xbf2603be },
    { 0x3d32a01e, 0x3f4036a1 }, { 0x3d40aa45, 0x3e84e7d3 }, { 0x3f223f95, 0x3f2afb5b },
    { 0xbf18638d, 0xbe9fe7bf }, { 0x3cb37455, 0xbe394f5a }, { 0xbdd6fa81, 0x3eca91e1 },
    { 0x3de5431c, 0xbd58a12c }, { 0x3e03e5a8, 0x3f12a04f }, { 0xbd5bbf29, 0xbe48b6c7 },
    { 0xbd74a901, 0x3df46174 }, { 0xbd2ec3f8, 0xbe4e7ae3 }, { 0xbe010fc1, 0xbd8c4d13 },
    { 0xbe80bbd3, 0x3d6f2219 }, { 0xbbc31202, 0x3c2d4dcf }, { 0xbe6f4e96, 0x3d088785 },
    { 0x3cdb7889, 0xbcbc4d77 }, { 0xbc459950, 0xbc867e6e }, { 0x3db02144, 0xbc5b1c44 },
    { 0x3c976458, 0x3b8c6343 }, { 0xbbf710b4, 0xbcb64558 }, { 0xbd321b33, 0xbc35fe79 },
    { 0xbd327761, 0xbd854337 }, { 0xbcf207b8, 0x3d82db8f }, { 0x3c1a98ad, 0xbc2053ef },
    { 0x3ea7410a, 0x3d99da61 }, { 0x3e52741b, 0x3e301efd }, { 0xbe309fc7, 0x3e3fd459 },
    { 0x3e49bb9d, 0xbe4904c2 }, { 0x3ddf76c2, 0xbdbfb889 }, { 0xbe4124ea, 0x3e379294 },
    { 0xbe462f72, 0xbdf679f2 }, { 0x3d8c372d, 0x3e2dcc68 }, { 0x3deb0ee5, 0xbe4bd514 },
    { 0x3dafd73e, 0xbdaa14eb }, { 0x3ca91407, 0x3db1fde7 }, { 0xbd75a8e7, 0xbdae34bc },
    { 0x3d1f5851, 0xbe0b370e }, { 0xbe13c26b, 0xbcbd7fe8 }, { 0x3db805e6, 0xbbcd8137 },
    { 0x3d8ab7b0, 0xbd09c3b7 }, { 0x3cc93641, 0xbcd343ad }, { 0x3cac385e, 0x3c2b4747 },
    { 0xbce709b7, 0xbc8d685e }, { 0x3c185f37, 0xbd06a80f }, { 0x3caca503, 0xbb7017cd },
    { 0xbc7fe98b, 0xbba11e78 }, { 0xbc84e7e9, 0x3c9661fe }, { 0x3be0fd98, 0x3b014cb6 },
    { 0x3c8b9759, 0x3c6a58e5 }, { 0x3d616f3a, 0xbf249869 }, { 0x3d0c472c, 0x3f42c8f6 },
    { 0x3d777492, 0x3e8621a4 }, { 0x3f21b6f7, 0x3f2a39fc }, { 0xbf1357b1, 0xbea27a95 },
    { 0x3c8c2f55, 0xbe2bb7c2 }, { 0xbdecdb0d, 0x3ec4af06 }, { 0x3e036801, 0xbd762136 },
    { 0x3e05b416, 0x3f17cacb }, { 0xbd890c6a, 0xbe584671 }, { 0xbd82fe22, 0x3e0818e2 },
    { 0xbd10637c, 0xbe47b6cd }, { 0xbe083ee5, 0xbd8d5e5f }, { 0xbe7bb79e, 0x3d955346 },
    { 0x3b0f4f5a, 0x3c8b7411 }, { 0xbe6fed16, 0x3cdf5536 }, { 0x3cf357b2, 0xbca7286f },
    { 0xbc3fe1bb, 0xbc8dec60 }, { 0x3da3809b, 0xbca9a75d }, { 0x3ca7ee1c, 0x3b32e95c },
    { 0xbacdd679, 0xbc676104 }, { 0xbd4b888f, 0xbc40a348 }, { 0xbd3eb29e, 0xbd86e298 },
    { 0xbcf8157b, 0x3d933eb9 }, { 0x3c20317b, 0xbc32017e }, { 0x3ea03322, 0x3d3ac428 },
    { 0x3e48334f, 0x3e1546c8 }, { 0xbe2e84a7, 0x3e2e220c }, { 0x3e3a4535, 0xbe4dc56d },
    { 0x3dc989f6, 0xbdc7bfa6 }, { 0xbe3dccf9, 0x3e27043e }, { 0xbe381739, 0xbddc9f96 },
    { 0x3d5f62f0, 0x3e1eb40b }, { 0x3dd7c86e, 0xbe415870 }, { 0x3d9da7a5, 0xbdaaabe3 },
    { 0x3c811221, 0x3dad2943 }, { 0xbd60414e, 0xbda3a182 }, { 0x3d40aef1, 0xbe0265ea },
    { 0xbe08e8b5, 0xbce23413 }, { 0x3da3c22b, 0xbbfd7aa4 }, { 0x3d73e65d, 0xbd010542 },
    { 0x3caff041, 0xbcc42634 }, { 0x3c914dc7, 0x3c24ccb2 }, { 0xbcd08a92, 0xbc97ad24 },
    { 0x3c3383e2, 0xbcfc1d1d }, { 0x3ca49255, 0xbb2a56cf }, { 0xbc32216f, 0xbbbdd94d },
    { 0xbc8a04ca, 0x3c87fc9b }, { 0x3b42ee42, 0x372c8c00 }, { 0x3c8d1986, 0x3c607fb9 },
    { 0x3d79f584, 0xbf1fd72e }, { 0x3ca902b7, 0x3f423101 }, { 0x3d96a8d2, 0x3e85bf64 },
    { 0x3f1e0939, 0x3f2447a0 }, { 0xbf0d3645, 0xbea2365b }, { 0x3c210d44, 0xbe201b95 },
    { 0xbe021ba8, 0x3ebb7311 }, { 0x3e0fba14, 0xbd8c401d }, { 0x3e044102, 0x3f1a1ff0 },
    { 0xbda0929f, 0xbe61cef5 }, { 0xbd8d5145, 0x3e12955b }, { 0xbcd8e352, 0xbe3e34f3 },
    { 0xbe0ab66d, 0xbd8e6c05 }, { 0xbe6f4f74, 0x3da83ed5 }, { 0x3be7bd22, 0x3ca6eaaa },
    { 0xbe6bac89, 0x3cc05036 }, { 0x3d05c4d6, 0xbc925b3b }, { 0xbc2c878a, 0xbc8e6444 },
    { 0x3d92c6de, 0xbce2cbba }, { 0x3cb1ed0b, 0x3ac73bea }, { 0x3b954781, 0xbbcfb79c },
    { 0xbd60ce03, 0xbc316049 }, { 0xbd45fee5, 0xbd84869a }, { 0xbcf54118, 0x3da0c334 },
    { 0x3beba484, 0xbc5bf222 }, { 0x3e95395b, 0x3cabeea8 }, { 0x3e3c1fbe, 0x3df06da0 },
    { 0xbe26ca7d, 0x3e18774f }, { 0x3e265848, 0xbe479057 }, { 0x3dafdff9, 0xbdc6909a },
    { 0xbe34d355, 0x3e11aed4 }, { 0xbe25c94d, 0xbdbee6a0 }, { 0x3d24c8ad, 0x3e0b800e },
    { 0x3db63dc7, 0xbe2fc3b7 }, { 0x3d83372c, 0xbda3eb74 }, { 0x3c315a65, 0x3da21225 },
    { 0xbd44d902, 0xbd9754f0 }, { 0x3d58fa78, 0xbde7348b }, { 0xbdf4ccb6, 0xbcee488a },
    { 0x3d8de23c, 0xbbf82e07 }, { 0x3d4bb952, 0xbce01b3c }, { 0x3c908e42, 0xbcaff3ce },
    { 0x3c685a97, 0x3c200f11 }, { 0xbcb63538, 0xbc9795a2 }, { 0x3c49ee68, 0xbcdf63b3 },
    { 0x3c970960, 0xbac96198 }, { 0xbbeb9600, 0xbbba85e1 }, { 0xbc8924e8, 0x3c829696 },
    { 0xb8558620, 0xbab534dd }, { 0x3c8f8d19, 0x3c4c44c3 }, { 0x3d8b7e66, 0xbf15ff37 },
    { 0x3bb8dae8, 0x3f3ba668 }, { 0x3da68a28, 0x3e823723 }, { 0x3f14bf80, 0x3f17c8e3 },
    { 0xbf039558, 0xbe9aba42 }, { 0x3a903690, 0xbe14e573 }, { 0xbe09dac3, 0x3ead87ab },
    { 0x3e15f67f, 0xbd99fb69 }, { 0x3dfc293f, 0x3f17d63c }, { 0xbdadce76, 0xbe63f424 },
    { 0xbd96ce7d, 0x3e157cf7 }, { 0xbc8f14fc, 0xbe301359 }, { 0xbe066cc0, 0xbd8af4f7 },
    { 0xbe5ade35, 0x3db0ba40 }, { 0x3c10a492, 0x3ca84a76 }, { 0xbe5ee7e0, 0x3caa9736 },
    { 0x3d0e9799, 0xbc709d74 }, { 0xbc056145, 0xbc83a954 }, { 0x3d7d0028, 0xbd0ad501 },
    { 0x3cb4c820, 0x3a33abae }, { 0x3c1f0df2, 0x39ffd268 }, { 0xbd6ee893, 0xbc21d98d },
    { 0xbd440224, 0xbd7bac46 }, { 0xbce3cdd8, 0x3da720e0 }, { 0x3b38e863, 0xbc875a38 },
    { 0x3e82524d, 0x3b73b8a4 }, { 0x3e2681d1, 0x3db37b1f }, { 0xbe14e9cd, 0x3dfa5610 },
    { 0x3e0c4943, 0xbe316463 }, { 0x3d9185a3, 0xbdb6495f }, { 0xbe214115, 0x3dedf405 },
    { 0xbe0c5abb, 0xbd9b2c8d }, { 0x3cde291e, 0x3de67de0 }, { 0x3d8c2bbb, 0xbe14fb6c },
    { 0x3d49c86e, 0xbd92fb9d }, { 0x3bdbbf2a, 0x3d8d690a }, { 0xbd235ae9, 0xbd84499a },
    { 0x3d58625d, 0xbdbd4d8b }, { 0xbdcd4a02, 0xbcdf3182 }, { 0x3d6a7888, 0xbbcdeaae },
    { 0x3d1ec857, 0xbcb18f6b }, { 0x3c5e47a9, 0xbc96446d }, { 0x3c2be9ad, 0x3c1824af },
    { 0xbc962366, 0xbc895044 }, { 0x3c4835a5, 0xbcb86e87 }, { 0x3c82f64a, 0xba8684d4 },
    { 0xbb90a0b4, 0xbb9a381c }, { 0xbc757097, 0x3c79caa5 }, { 0xbae36cb1, 0xbb07101b },
    { 0x3c894b89, 0x3c2b8dcb }, { 0x3d9043a2, 0xbf0183aa }, { 0xbbfaafcc, 0x3f283821 },
    { 0x3da077e1, 0x3e6d1189 }, { 0x3f011849, 0x3f00fabf }, { 0xbee37377, 0xbe8631a0 },
    { 0xbbcddf48, 0xbe00f1b9 }, { 0xbe050430, 0x3e967e17 }, { 0x3e112bf2, 0xbd99e3d5 },
    { 0x3de0255e, 0x3f0bac4d }, { 0xbdaab6d0, 0xbe582a9c }, { 0xbd98e88f, 0x3e09ef88 },
    { 0xbc138194, 0xbe17fb7f }, { 0xbdee49af, 0xbd6d36e0 }, { 0xbe397b85, 0x3dac7912 },
    { 0x3c05bf88, 0x3c9f3738 }, { 0xbe42c4a6, 0x3c969f60 }, { 0x3d0ccd0e, 0xbc26e377 },
    { 0xbb9a64e2, 0xbc5c5625 }, { 0x3d49458f, 0xbd199c15 }, { 0x3ca8f862, 0xb9d94428 },
    { 0x3c4f045e, 0x3bbbb793 }, { 0xbd6ca4b2, 0xbc1e55a5 }, { 0xbd324561, 0xbd61deda },
    { 0xbcc51252, 0x3d9d29bb }, { 0xbb03aed5, 0xbca0c8b6 }, { 0x3e4b26ae, 0xbbb1f2d0 },
    { 0x3e0354bc, 0x3d709227 }, { 0xbdedf3b7, 0x3db866d4 }, { 0x3dd348be, 0xbe0a9a30 },
    { 0x3d5623e8, 0xbd931f93 }, { 0xbe00a83c, 0x3dadff22 }, { 0xbdd460be, 0xbd6655b4 },
    { 0x3c9031a9, 0x3dac6d36 }, { 0x3d3f7eb7, 0xbde11699 }, { 0x3d0bc9cb, 0xbd69fd41 },
    { 0x3b8c1050, 0x3d5b6116 }, { 0xbcf28938, 0xbd510baa }, { 0x3d34a2e9, 0xbd88e276 },
    { 0xbd9aee84, 0xbcbbfe4c }, { 0x3d326320, 0xbb97baf9 }, { 0x3ce28e25, 0xbc7b7fbe },
    { 0x3c1c0af1, 0xbc6a245d }, { 0x3be065b2, 0x3c014d64 }, { 0xbc603d6c, 0xbc5af1bd },
    { 0x3c25e03a, 0xbc8769d2 }, { 0x3c4be542, 0xba9d783e }, { 0xbb2a2c40, 0xbb416ef2 },
    { 0xbc3d43c4, 0x3c585b38 }, { 0xbb06b56c, 0xbb0a54ee }, { 0x3c68e4ef, 0x3bfdb291 },
    { 0x3d80912a, 0xbec47220 }, { 0xbc68d2b9, 0x3f050fa9 }, { 0x3d81762c, 0x3e3d1e86 },
    { 0x3ec6a324, 0x3ec26047 }, { 0xbeae86ac, 0xbe494807 }, { 0xbc23897f, 0xbdc1846c },
    { 0xbddefe29, 0x3e67a2a8 }, { 0x3dfd473c, 0xbd833040 }, { 0x3db2406b, 0x3ee4b62c },
    { 0xbd91a2ca, 0xbe382cd6 }, { 0xbd8c2ab0, 0x3ddb432e }, { 0xbb607dea, 0xbdebe414 },
    { 0xbdb9877c, 0xbd27e482 }, { 0xbe0ce66a, 0x3d9896f9 }, { 0x3bc25f8b, 0x3c8c0460 },
    { 0xbe1622ac, 0x3c84aafc }, { 0x3ced7da1, 0xbbc32de2 }, { 0xba857876, 0xbc181073 },
    { 0x3d115776, 0xbd111c1e }, { 0x3c8668f0, 0xbb3815f4 }, { 0x3c4eaa51, 0x3bfd3d2a },
    { 0xbd4f0fdf, 0xbc2014cb }, { 0xbd0df478, 0xbd35f10e }, { 0xbc9da689, 0x3d7db05f },
    { 0xbba31ce6, 0xbcab9e41 }, { 0x3e01faa1, 0xbc0c94df }, { 0x3da89ce2, 0x3d06b6d2 },
    { 0xbd9d5f9c, 0x3d677dce }, { 0x3d833ead, 0xbdb24c5d }, { 0x3d008786, 0xbd40ecce },
    { 0xbda9989d, 0x3d555c41 }, { 0xbd834d5b, 0xbd15dd81 }, { 0x3c2b41a4, 0x3d5c02f6 },
    { 0x3cdc2adf, 0xbd8d3661 }, { 0x3ca56c5a, 0xbd19da0f }, { 0x3b36e7ed, 0x3d0ceb97 },
    { 0xbc938df2, 0xbd0b972e }, { 0x3ce7c95c, 0xbd206bf3 }, { 0xbd44702a, 0xbc8b82d6 },
    { 0x3ce3a069, 0xbb410e16 }, { 0x3c894963, 0xbc182d35 }, { 0x3bb9b833, 0xbc1a5f00 },
    { 0x3b6469bc, 0x3bb4ce61 }, { 0xbc0cc022, 0xbc125c8d }, { 0x3bce4a77, 0xbc1ecc80 },
    { 0x3c09803e, 0xbadb9e98 }, { 0xba8f513a, 0xba4c0b96 }, { 0xbbee7ec4, 0x3c16bc71 },
    { 0xbacc55b8, 0xbad73812 }, { 0x3c1eb3e4, 0x3b982559 }, { 0x3d3bfb74, 0xbe71b54a },
    { 0xbc5292ac, 0x3eabda09 }, { 0x3d219aae, 0x3df3ee0a }, { 0x3e7a115c, 0x3e71c043 },
    { 0xbe5b7341, 0xbdf33278 }, { 0xbc1064fc, 0xbd680872 }, { 0xbd9494ce, 0x3e116305 },
    { 0x3db4aab0, 0xbd3afee1 }, { 0x3d6941a3, 0x3e987cd2 }, { 0xbd4763f4, 0xbdffc8ea },
    { 0xbd51db5d, 0x3d8d86cb }, { 0xbacda128, 0xbd98a9af }, { 0xbd6d4dfc, 0xbcbaa61c },
    { 0xbdb10656, 0x3d65ac47 }, { 0x3b7a03d2, 0x3c62c714 }, { 0xbdbd7066, 0x3c45d3b8 },
    { 0x3c9e5cc3, 0xbb553b54 }, { 0x3a7f9232, 0xbbb47adf }, { 0x3cb10bab, 0xbcda56d2 },
    { 0x3c334ea3, 0xbb9eecde }, { 0x3c1c236a, 0x3bd66c45 }, { 0xbd120b22, 0xbc143c92 },
    { 0xbcb80d5b, 0xbcf18f76 }, { 0xbc5a3796, 0x3d22bcdd }, { 0xbba47da0, 0xbc900c33 },
    { 0x3d6ea3f5, 0xbc05b545 }, { 0x3d182476, 0x3c55589e }, { 0xbd19dda9, 0x3ce9e1fb },
    { 0x3ce6b74e, 0xbd25a998 }, { 0x3c57dffd, 0xbcb31ccc }, { 0xbd21007b, 0x3cc56560 },
    { 0xbcdaf49c, 0xbca1802f }, { 0x3bacc93e, 0x3cd6a41b }, { 0x3c3d6d8d, 0xbcfe22a8 },
    { 0x3c0fe412, 0xbc911ac4 }, { 0x3ab6eea8, 0x3c85c57d }, { 0xbbeb7e01, 0xbc8e4c82 },
    { 0x3c3b2be6, 0xbc726de0 }, { 0xbcb9b853, 0xbc2b2164 }, { 0x3c503aff, 0xbad94755 },
    { 0x3bf0a119, 0xbb855e3c }, { 0x3b1cd411, 0xbb9325bc }, { 0x3a8f2269, 0x3b30a3b9 },
    { 0xbb8079ba, 0xbb990012 }, { 0x3b0d81d1, 0xbb5d7015 }, { 0x3b938f75, 0xbaed6457 },
    { 0x39952248, 0x3a9374e8 }, { 0xbb5dcad4, 0x3b9512b6 }, { 0xba4e8040, 0xba8413b9 },
    { 0x3b90e1d9, 0x3b01dbf2 }, { 0x3cc8d06f, 0xbdcfb9db }, { 0xbbdaa01c, 0x3e1cb863 },
    { 0x3c6b58e0, 0x3d59cb6c }, { 0x3ddd7648, 0x3dd82a9d }, { 0xbdc15fb7, 0xbd519220 },
    { 0xbb86dfb8, 0xbcc4e763 }, { 0xbd01115a, 0x3d7ff108 }, { 0x3d2f4689, 0xbcd5bafe },
    { 0x3cd98247, 0x3e0cc6d3 }, { 0xbcb71f7b, 0xbd7444ef }, { 0xbcda77a6, 0x3d04c5a7 },
    { 0xbb071956, 0xbd0be7c4 }, { 0xbcd91ac5, 0xbc0fd1ad }, { 0xbd1c4bf6, 0x3d04e953 },
    { 0x3b17dc6e, 0x3c067067 }, { 0xbd290c28, 0x3bc57059 }, { 0x3c141c46, 0xbabdd3f8 },
    { 0x3a7cb4c8, 0xbb263223 }, { 0x3c1d6978, 0xbc6816c7 }, { 0x3bc306b6, 0xbb898cca },
    { 0x3ba7f5cc, 0x3b6c66a8 }, { 0xbc8d994d, 0xbbf6dbfb }, { 0xbc2b84f9, 0xbc601f52 },
    { 0xbbde1800, 0x3c90177e }, { 0xbb3546c5, 0xbc1b1a1d }, { 0x3c9de692, 0xbbcd7edf },
    { 0x3c385ff4, 0x3b56395e }, { 0xbc701518, 0x3c5d833e }, { 0x3bf6db29, 0xbc517a7a },
    { 0x3b5657ee, 0xbbe1a29d }, { 0xbc5738c1, 0x3c113cab }, { 0xbba59a95, 0xbc2c96fe },
    { 0x3b2b71f0, 0x3c203b47 }, { 0x3b4ae740, 0xbc14d139 }, { 0x3b18a106, 0xbbb597cf },
    { 0x39f74df2, 0x3bb4450b }, { 0xba7f1059, 0xbbf3adfb }, { 0x3aba604b, 0xba9cab53 },
    { 0xbc01e9d7, 0xbbb6c2b7 }, { 0x3b83d1be, 0xba8532ca }, { 0x3b05e7e8, 0xba79efda },
    { 0x3a0d6829, 0xbaa70ea0 }, { 0x3937aeee, 0x3a45e9f7 }, { 0xba9d93ca, 0xbb032926 },
    { 0xb8e3c504, 0x3978eb7b }, { 0x3b0bda57, 0xbad9497a }, { 0x3a686d5a, 0x3af1d270 },
    { 0xba91148a, 0x3adc2eaf }, { 0xb990f662, 0xba07818b }, { 0x3aa04357, 0x3a1a54f0 },
    { 0x3c31bb3a, 0xbcde6a20 }, { 0xbb299c2b, 0x3d37f79e }, { 0xba8eb70e, 0x3c6ff262 },
    { 0x3cf93056, 0x3d0188ba }, { 0xbcd60ce3, 0xbc6ae91c }, { 0x39811d86, 0xbbe05bd5 },
    { 0xbbb0edaf, 0x3c8be34a }, { 0x3c453e2e, 0xbc4ff1a5 }, { 0x3c0203dd, 0x3d2357eb },
    { 0xbbbfe266, 0xbc8fa5ca }, { 0xbc0d4cfb, 0x3c297828 }, { 0xbb369489, 0xbc1fcd2f },
    { 0xbc19d70b, 0xbaf1ea83 }, { 0xbc2832d7, 0x3c7e0cee }, { 0x3abb8f14, 0x3b3a7225 },
    { 0xbc400c57, 0x3aeff361 }, { 0x3b32c141, 0xba0a5f31 }, { 0x39596433, 0xba5250bc },
    { 0x3b3ddb0b, 0xbba805fd }, { 0x3b4c7af9, 0xbb0a623a }, { 0x3b1ea212, 0x3a885af2 },
    { 0xbbaf3673, 0xbbc0ff69 }, { 0xbb61af4d, 0xbb7ea8a7 }, { 0xbb0cd4f6, 0x3b9e9f76 },
    { 0xba492f22, 0xbb3bceef }, { 0x3be50739, 0xbb8dee7f }, { 0x3b30d277, 0x380a1fd8 },
    { 0xbbe083e1, 0x3c06088e }, { 0x39eb50d8, 0xbb4e0748 }, { 0x3a744926, 0xbafc6d20 },
    { 0xbb8066b1, 0x3b8abe8e }, { 0x3ae533c4, 0xbbf97912 }, { 0x3ae6d66e, 0x3b73f7e7 },
    { 0xb9dd976b, 0xbb1e425f }, { 0x39eef7f7, 0xbaa8de20 }, { 0xb6d90aa0, 0x3ab4d4d0 },
    { 0x3a7d5ac6, 0xbb8cd01e }, { 0xbaea2c7a, 0x3b4396af }, { 0xbb4465ff, 0xbb53dbff },
    { 0x3a932db2, 0xba3782a5 }, { 0x39e02b8d, 0xb90550a4 }, { 0xb7c25dc6, 0xb8bdbce9 },
    { 0x390b9804, 0x38a5ea11 }, { 0xb947a663, 0xba4c576c }, { 0xba30529f, 0x3ad34beb },
    { 0x3aab09dc, 0xbabb9ae8 }, { 0x3a8cda82, 0x3ad29b01 }, { 0xb9172276, 0x3a2d6732 },
    { 0xb864585e, 0xb9b43b92 }, { 0x398e3051, 0x396d58d4 }, { 0x3bcb4389, 0xbbf59ff2 },
    { 0xbae28d9d, 0x3c359dc2 }, { 0xbbdeb572, 0x3b804559 }, { 0x3bc7b0bc, 0x3c1bb28a },
    { 0xbbd9f9dd, 0xbb65c660 }, { 0x3b86b9d6, 0xbad503c0 }, { 0x3baf2ca7, 0x3b633b61 },
    { 0x3b109ead, 0xbc1d575a }, { 0x3a99ff68, 0x3c2bb0ab }, { 0xba43d1e7, 0xbb87d8e5 },
    { 0xbae50a46, 0x3b39ea1b }, { 0xbba0f116, 0xbadb2cf3 }, { 0xbbcd5c16, 0x3a25fa25 },
    { 0xbaf803fd, 0x3c39e3af }, { 0x3a2f5700, 0x3a0823ae }, { 0xbb49d37b, 0xb919ced5 },
    { 0x3a26fadc, 0xb754e2f2 }, { 0xb8d62743, 0xb9cf2688 }, { 0x3a5d9296, 0xbac632ab },
    { 0x3b45b12b, 0xba8bbb3a }, { 0x3aff4309, 0xb99326cd }, { 0xba9df0f6, 0xbbc0c29d },
    { 0xba92b225, 0xba8c7b73 }, { 0xba013d50, 0x3a8a5847 }, { 0x3954825a, 0xba234283 },
    { 0x3b602a08, 0xbb03715d }, { 0x3a8cf150, 0xb9c1a42d }, { 0xbb537a22, 0x3b8c092c },
    { 0x38fc9b24, 0xba964706 }, { 0x3a7ee471, 0xba71772a }, { 0xbae5a7e1, 0x3b2f1ac8 },
    { 0x3a8078da, 0xbb87484f }, { 0x3a3ebc26, 0x3af17625 }, { 0xba10b8ab, 0xbac24103 },
    { 0x39cafe62, 0xb9de2951 }, { 0xb96eeadb, 0x3a0f3e2a }, { 0x3a73c134, 0xbb3e1de2 },
    { 0xba85a4ba, 0x3b044efc }, { 0xbacc8f28, 0xbb082df5 }, { 0x39b835f3, 0xb9f9f636 },
    { 0x397b6197, 0xb7c78568 }, { 0xb729405c, 0xb83e8f9e }, { 0x383e9bb5, 0xb8594b64 },
    { 0xb8d9a5e9, 0xb9b05b5c }, { 0xba2e58af, 0x3ab8b5e3 }, { 0x3a2ef36b, 0xba310914 },
    { 0x3a416dba, 0x3a93f88c }, { 0x3800d39c, 0x39b6095d }, { 0x381f851b, 0xb98a035b },
    { 0xb809adb9, 0x3942c3df }, { 0x3b49f132, 0xbb81e1be }, { 0xba13b3b8, 0x3b772cee },
    { 0xbba6eb3a, 0x3afd966a }, { 0x3acadf2e, 0x3b1b39e1 }, { 0xbb5261e0, 0xba13ee6a },
    { 0x3b5c5cb4, 0xba955411 }, { 0x3bbc73a8, 0x3a1ad65e }, { 0x3a4ec182, 0xbb9afa6b },
    { 0xb72df280, 0x3b872bac }, { 0x38df50dc, 0xbac04c94 }, { 0xb8f7cad8, 0x3a269cae },
    { 0xbb8be307, 0x39b6d6f4 }, { 0xbb8d6723, 0x3a250c6c }, { 0xba9401f5, 0x3bd01c6a },
    { 0xb7bf85c8, 0xb92364b8 }, { 0xbab78fff, 0xba23644e }, { 0x39347632, 0x399668d7 },
    { 0xb9262fe1, 0x384b67fd }, { 0x39e19f30, 0xb9c235da }, { 0x3b1de38c, 0xba1fa2a2 },
    { 0x3aafdc86, 0xb9f40ad6 }, { 0x39652007, 0xbb6581c7 }, { 0xb99c1ff2, 0xba044675 },
    { 0xb975dcea, 0x39a31d86 }, { 0x39ae18c1, 0xb980f844 }, { 0x3ad9b7c2, 0xba13bd87 },
    { 0x3a0703e2, 0x389ef247 }, { 0xbaade705, 0x3af30056 }, { 0x397c99a0, 0xb9434fbd },
    { 0x3a2dae5a, 0xb9dafa90 }, { 0xba2727e1, 0x3a932332 }, { 0x3927e33e, 0xbaf44be8 },
    { 0x38461224, 0x3a1d6ad0 }, { 0xb9c10a7a, 0xba520143 }, { 0x39895bb4, 0xb937ae9a },
    { 0xb92ec2dc, 0x3956579c }, { 0x39d4f815, 0xbab0fb77 }, { 0xb9c87dd8, 0x3a6cd8ea },
    { 0xba06b8f1, 0xba6e277b }, { 0x390cbd50, 0xb99def25 }, { 0x38ce5c70, 0xb836a040 },
    { 0x37554cb8, 0xb75b8f44 }, { 0x37528ecc, 0xb8b69dc0 }, { 0xb862a936, 0xb917a9b3 },
    { 0xb9bc5b6d, 0x3a3c97a1 }, { 0x398a2c58, 0xb979401a }, { 0x396ff698, 0x39f8165c },
    { 0x37598356, 0x3931a72f }, { 0x38653486, 0xb9052046 }, { 0xb86ac696, 0x390a4ba4 },
    { 0x3a92255a, 0xbb19e0b5 }, { 0x39697258, 0x3af15c5f }, { 0xbb0bd1a2, 0x3a6f030d },
    { 0x3a79e957, 0x3970ba46 }, { 0xbb02762c, 0xb853151c }, { 0x3a8fb7e1, 0xba20fb64 },
    { 0x3b463796, 0x39f66c99 }, { 0x3a00b388, 0xbaad49f4 }, { 0x38d2714c, 0x3b0f3861 },
    { 0x37d921d0, 0xba530df3 }, { 0xb82c26ac, 0x390a12a0 }, { 0xbb05fbc9, 0x39453bbb },
    { 0xbb123970, 0x39a9746e }, { 0xba5d10ee, 0x3b1b78d3 }, { 0xb9820afb, 0xb83b9a83 },
    { 0xba5c91e6, 0xb97b29af }, { 0x38d95e0c, 0x391f74b8 }, { 0xb900c27d, 0x38673d83 },
    { 0x39974878, 0xb956c478 }, { 0x3aa75e02, 0xb9aa514e }, { 0x3a16d571, 0xb994d56a },
    { 0x39880fbc, 0xbaa27579 }, { 0xb8549b2e, 0xb988de7d }, { 0xb9059c25, 0x38a5c888 },
    { 0x3976b2a6, 0xb93b5647 }, { 0x3a1b1d8d, 0x36ae27df }, { 0x39a1f3d5, 0x39986602 },
    { 0xb9ce783a, 0x3a131846 }, { 0x3948e4b5, 0x35a49be0 }, { 0x39822985, 0xb89b107e },
    { 0xb91e5637, 0x39887e78 }, { 0xb7c3a012, 0xba238196 }, { 0xb8839eeb, 0x38a457e7 },
    { 0xb8d549ee, 0xb9b14cd9 }, { 0x38b7dd84, 0xb8e82dab }, { 0xb8aae330, 0x386948db },
    { 0x382951a2, 0xb9b5059f }, { 0xb8f2b13e, 0x3995d522 }, { 0xb8e9e481, 0xb943a2b2 },
    { 0x37e2fec5, 0xb8f1b49d }, { 0x378012ee, 0xb732f7c2 }, { 0x379db796, 0x362a44db },
    { 0xb68541bc, 0xb8224516 }, { 0xb7dabcff, 0xb8638a41 }, { 0xb8b96683, 0x39318487 },
    { 0x3882938a, 0xb8421fc5 }, { 0x38177f03, 0x38ba5df7 }, { 0xb66b8c28, 0x3861b6a9 },
    { 0x37d65627, 0xb82697ac }, { 0xb7aa6d54, 0x385b303c }, { 0x383d00f0, 0xba8c3732 },
    { 0x39e89bac, 0x3a82946e }, { 0xb9c9a12f, 0x39857bdb }, { 0x3a3c17c1, 0xb95107d4 },
    { 0xba8df858, 0x389a3873 }, { 0xb87f800a, 0xb946e032 }, { 0x3a7afb72, 0x39bc46b2 },
    { 0x38ca26ea, 0xb9107797 }, { 0x392944d8, 0x3a912fe7 }, { 0x38064337, 0xb9dc0b94 },
    { 0xb7341ce4, 0x37ec50fa }, { 0xba12b981, 0xb902a3ed }, { 0xba4fcc88, 0x38b1ede2 },
    { 0xb9c0ab51, 0x3a1d4c0b }, { 0xb913901c, 0xb78eab3c }, { 0xb9fbea1d, 0xb89ccffe },
    { 0x3887f407, 0x387e6e6c }, { 0xb82c68c3, 0x37aaf1a7 }, { 0x392ccf58, 0xb8f7f430 },
    { 0x39d337fc, 0xb8b50e85 }, { 0x39064bab, 0xb8cd3384 }, { 0x3878b3d8, 0xb98aa794 },
    { 0xb81cc500, 0xb9041376 }, { 0xb80ff42a, 0x3801bcbd }, { 0x38e3e5f2, 0xb8df500e },
    { 0x39978f70, 0x3934f531 }, { 0x39880b07, 0x399d2e3c }, { 0xb91469c6, 0x39278f6d },
    { 0x3918607e, 0xb6bad5bd }, { 0x390056ce, 0xb400dcc0 }, { 0xb8ab7fca, 0x38c7ac87 },
    { 0xb8a68e15, 0xb97871d2 }, { 0xb8577701, 0x375e65fb }, { 0xb83214ad, 0xb9654586 },
    { 0x38066b5e, 0xb8c347a6 }, { 0xb8655437, 0x37c6fd11 }, { 0xb79a2c17, 0xb9141c9e },
    { 0xb7a2b5b5, 0x38a7cfd9 }, { 0xb86ab989, 0xb8443c56 }, { 0x3735240a, 0xb8617b88 },
    { 0xb699245e, 0x3696daf2 }, { 0x3768c181, 0x36833ad8 }, { 0xb684537f, 0xb794ab93 },
    { 0xb791fd56, 0xb7d3958c }, { 0xb7b05cff, 0x384bdae9 }, { 0x36dbca3e, 0x37301e1d },
    { 0x3787dcd6, 0x37a27587 }, { 0xb70ca9f3, 0x37dca94b }, { 0x378d29d7, 0xb79b2424 },
    { 0xb714506d, 0x37f04d72 }, { 0xb98a2d71, 0xba1dfae2 }, { 0x39dcb912, 0x3a6119b2 },
    { 0x38c23f2f, 0x38919d20 }, { 0x3a21845c, 0xb940a6a1 }, { 0xba4cdfaa, 0x38eff5c6 },
    { 0xb9891b1b, 0xb89aa6c8 }, { 0x39a8d623, 0x399c6f58 }, { 0xb7ac2509, 0x37ef1700 },
    { 0x39503a01, 0x3a4770a7 }, { 0x38652edb, 0xb9a41e55 }, { 0x372e7d5d, 0x375f57b0 },
    { 0xb9540db3, 0xb95d2ee8 }, { 0xb9b43f02, 0x3779e30c }, { 0xb95ba91e, 0x3966de2c },
    { 0xb8a9a770, 0xb7b33661 }, { 0xb9bafb70, 0xb8171775 }, { 0x385a8878, 0x381f0f46 },
    { 0xb7a9e867, 0x3691b1c0 }, { 0x38e1a1a5, 0xb8aee248 }, { 0x392e1543, 0xb7c45830 },
    { 0xb61de413, 0xb82edf5b }, { 0x36213b52, 0xb88a6d37 }, { 0xb825d695, 0xb8ae1934 },
    { 0x3557b5be, 0x37c57511 }, { 0x38827fa2, 0xb89e405a }, { 0x398feb8a, 0x393a60fa },
    { 0x3984dcdb, 0x3994ab67 }, { 0xb90edd6b, 0x39041fe7 }, { 0x390c0ee8, 0xb729d4ae },
    { 0x38e33c12, 0xb6ac469c }, { 0xb8c5ce0e, 0x389fd050 }, { 0xb892f11a, 0xb951fbf5 },
    { 0xb83c7e86, 0x3789f0b0 }, { 0xb8398434, 0xb951fd90 }, { 0x37c1a160, 0xb8aec7d3 },
    { 0xb85ee532, 0x37ca4727 }, { 0xb6c7019b, 0xb8f758c3 }, { 0xb62508c8, 0x3888b962 },
    { 0xb8679ad8, 0xb817fa32 }, { 0x3789c06a, 0xb81f11f4 }, { 0x3484aa47, 0x36cfbe8d },
    { 0x3755aa93, 0x364fe095 }, { 0xb5e7f8bf, 0xb73e14cc }, { 0xb77dd363, 0xb79667a2 },
    { 0xb73f2752, 0x38263a89 }, { 0xb56d794f, 0x3702ef94 }, { 0x378dc62b, 0x37505e46 },
    { 0xb72b97e2, 0x37a00835 }, { 0x3780bdfe, 0xb782b12e }, { 0xb69cff64, 0x37ca7d49 },
    { 0xb9875e59, 0xba0e7b44 }, { 0x39d5138d, 0x3a52c5cf }, { 0x39020566, 0x3843c6d6 },
    { 0x3a16f328, 0xb9312cf8 }, { 0xba40c6e2, 0x38f8d054 }, { 0xb98303f3, 0xb87d1e92 },
    { 0x3982c1b8, 0x39999fcc }, { 0xb7bd2414, 0x3750abc4 }, { 0x395bffde, 0x3a36cc0c },
    { 0x3862755c, 0xb992dfe9 }, { 0x381a15a2, 0x37b67f3b }, { 0xb92e21f5, 0xb95d1861 },
    { 0xb99706f4, 0x370dcf52 }, { 0xb943563f, 0x394a5151 }, { 0xb88d111d, 0xb794c551 },
    { 0xb9aa0250, 0xb7e33028 }, { 0x382b902e, 0x3800092d }, { 0xb7ddfc9d, 0x3580dbd7 },
    { 0x38c1b217, 0xb88e75c1 }, { 0x390d8395, 0xb7839ccd }, { 0x35e2dd4e, 0xb825d087 },
    { 0x3514bb6a, 0xb856e4a4 }, { 0xb802a43c, 0xb899edc3 }, { 0x377140ed, 0x37d520d2 },
    { 0x38662ecc, 0xb884f9be }, { 0x398821a5, 0x392f90c7 }, { 0x397a553c, 0x39899ced },
    { 0xb907fb6b, 0x38ee92b6 }, { 0x39015db8, 0xb7608811 }, { 0x38cc40c2, 0xb6f6e45d },
    { 0xb8cbafa4, 0x388c69ea }, { 0xb880bda9, 0xb93c3f94 }, { 0xb826a8e2, 0x37928c8b },
    { 0xb830a22b, 0xb940e6d9 }, { 0x3792718f, 0xb89f2549 }, { 0xb8516b1c, 0x37c5d7f2 },
    { 0x35e693e3, 0xb8d61f8e }, { 0x3620b67c, 0x387472e6 }, { 0xb862302d, 0xb7fee67f },
    { 0x379b4837, 0xb7f7422e }, { 0x36720f77, 0x369bdbff }, { 0x37485121, 0x35dee0f0 },
    { 0xb531f03d, 0xb709910f }, { 0xb7655ce8, 0xb7714cb7 }, { 0xb70a66d7, 0x380fb103 },
    { 0xb62e6b93, 0x36aa97e1 }, { 0x37843947, 0x3722af50 }, { 0xb735b2b4, 0x3774df31 },
    { 0x376fa871, 0xb76073ec }, { 0xb606fb7a, 0x37b387e4 }, { 0xb977c11a, 0xba044e0e },
    { 0x39c78e27, 0x3a44d62c }, { 0x38f98281, 0x381086dc }, { 0x3a0b4cad, 0xb91db4d5 },
    { 0xba32e9e7, 0x38ed2108 }, { 0xb96e275f, 0xb841cd3e }, { 0x39669a28, 0x39966b3f },
    { 0xb79ef1b5, 0xb6345f15 }, { 0x3959d471, 0x3a28dfa8 }, { 0x384f5d31, 0xb9870318 },
    { 0x38444a6a, 0x37e4befe }, { 0xb91bc2d2, 0xb9573cb6 }, { 0xb98684e4, 0x36ef221a },
    { 0xb93397ff, 0x39377af6 }, { 0xb86e5b1c, 0xb727559d }, { 0xb99b58f8, 0xb7adbfb0 },
    { 0x38115252, 0x37dc37ef }, { 0xb7e480ee, 0xb5584c77 }, { 0x38ab57d4, 0xb8734323 },
    { 0x38f7d404, 0xb77198b3 }, { 0x366a3663, 0xb81ff488 }, { 0x35b7dd39, 0xb839786e },
    { 0xb7df5fa4, 0xb88d37bc }, { 0x37a213fe, 0x37d4a952 }, { 0x385124c8, 0xb86f4c85 },
    { 0x39806e15, 0x3923aa04 }, { 0x396a1c5f, 0x397fe898 }, { 0xb90049d6, 0x38ded2b8 },
    { 0x38f3465a, 0xb781bc80 }, { 0x38bb1f11, 0xb7090107 }, { 0xb8c5a3b4, 0x387e312a },
    { 0xb868903e, 0xb92cc5e0 }, { 0xb81a08cb, 0x379201b7 }, { 0xb821d31c, 0xb9335b76 },
    { 0x376aa2a5, 0xb89401ee }, { 0xb84546f9, 0x37bb3d76 }, { 0x36a7c6c1, 0xb8beb8d0 },
    { 0x36697489, 0x385fae79 }, { 0xb857f45d, 0xb7ddfab1 }, { 0x379c2d76, 0xb7cae365 },
    { 0x36b81ed3, 0x364ce47a }, { 0x373fde1f, 0x3508af3f }, { 0xb4a04d75, 0xb6d7d5ad },
    { 0xb753c080, 0xb74cf4b6 }, { 0xb6e8188f, 0x37fe726d }, { 0xb62b72e2, 0x367a9962 },
    { 0x376ee0f4, 0x370804d6 }, { 0xb7338155, 0x374cc081 }, { 0x37619c81, 0xb7437f3c },
    { 0xb4f76c34, 0x37a3deae }, { 0xb9643e22, 0xb9f81afb }, { 0x39ba5349, 0x3a38c3a6 },
    { 0x38e72d63, 0x37e089c3 }, { 0x3a015c8a, 0xb90dd205 }, { 0xba2629cf, 0x38df3f54 },
    { 0xb9581696, 0xb8178e27 }, { 0x3953d19f, 0x3992fd63 }, { 0xb789c518, 0xb74f1a9d },
    { 0x39541a92, 0x3a1d542a }, { 0x383878e1, 0xb97b5cf8 }, { 0x385391a2, 0x380380c7 },
    { 0xb90f7ddf, 0xb95025e6 }, { 0xb9755d16, 0x36d31a32 }, { 0xb9267074, 0x3927a804 },
    { 0xb84c1f67, 0xb68d923e }, { 0xb98ee0a6, 0xb78c5268 }, { 0x37fddb26, 0x37c57f05 },
    { 0xb7dbccbd, 0xb5d9b10d }, { 0x389ae011, 0xb857ceea }, { 0x38df5ca2, 0xb768418c },
    { 0x365c97c9, 0xb8197775 }, { 0x360f604f, 0xb8224b80 }, { 0xb7c8a6ab, 0xb883e81f },
    { 0x37b17fb5, 0x37d24dc6 }, { 0x383f5f6b, 0xb85d9b60 }, { 0x397360ca, 0x39191c1e },
    { 0x395b92de, 0x396f9de3 }, { 0xb8f37b67, 0x38d2b569 }, { 0x38e74214, 0xb78db38f },
    { 0x38ae33cb, 0xb712045b }, { 0xb8bcb7c3, 0x3868eb21 }, { 0xb856783c, 0xb920e52b },
    { 0xb8121a91, 0x378f5e8f }, { 0xb8146058, 0xb928bb7d }, { 0x3745ea68, 0xb88bad50 },
    { 0xb83b6bf5, 0x37af55fc }, { 0x36d4cc79, 0xb8adaadb }, { 0x36641e31, 0x3850f1ad },
    { 0xb84ca6e3, 0xb7c7141b }, { 0x3796e1f7, 0xb7abf836 }, { 0x36dc170b, 0x35f6ed62 },
    { 0x373984e3, 0xb4d5dd2c }, { 0xb426a036, 0xb6afa06a }, { 0xb746f393, 0xb734425f },
    { 0xb6d0e464, 0x37e80c80 }, { 0xb61172dc, 0x36467562 }, { 0x375715fe, 0x36e9ba62 },
    { 0xb72ccda1, 0x37354f04 }, { 0x3755ee93, 0xb72d0734 }, { 0x350255dc, 0x37987476 },
    { 0xb95526b3, 0xb9ea8f4e }, { 0x39aec37f, 0x3a2e6720 }, { 0x38d6a864, 0x37b1ed2c },
    { 0x39f28460, 0xb901a689 }, { 0xba1b69f9, 0x38d1f575 }, { 0xb9452106, 0xb7f7aced },
    { 0x394634bd, 0x398f93bc }, { 0xb7790b62, 0xb79b185e }, { 0x394dc509, 0x3a13e3e8 },
    { 0x3822d9e2, 0xb96b9a1e }, { 0x385890c1, 0x3810db3d }, { 0xb9065e50, 0xb948ed08 },
    { 0xb9630ef8, 0x36b9567f }, { 0xb91adc64, 0x391ad3f9 }, { 0xb8310105, 0xb552bbe6 },
    { 0xb984698c, 0xb7729284 }, { 0x37e0434f, 0x37b5b366 }, { 0xb7cfaedb, 0xb601f0ad },
    { 0x388dfdbd, 0xb844c28d }, { 0x38ccb5a2, 0xb75f01bd }, { 0x36325c36, 0xb81320c9 },
    { 0x362f10de, 0xb80efaca }, { 0xb7b9d47c, 0xb878cd05 }, { 0x37b6abbd, 0x37d0c62f },
    { 0x38301411, 0xb84fe854 }, { 0x39681f8a, 0x391079d4 }, { 0x394f934d, 0x3962494d },
    { 0xb8e9215e, 0x38c8b108 }, { 0x38ddd658, 0xb797bda2 }, { 0x38a453e4, 0xb71a1227 },
    { 0xb8b40d97, 0x3856a9f9 }, { 0xb8494f85, 0xb917b9b8 }, { 0xb80c3a4c, 0x378c0890 },
    { 0xb809b5de, 0xb92078e8 }, { 0x372ce4e3, 0xb8858370 }, { 0xb833c932, 0x37a4569a },
    { 0x36e5ed41, 0xb8a0e2b0 }, { 0x364c7400, 0x384607db }, { 0xb842790f, 0xb7b665b3 },
    { 0x378fc56b, 0xb7962c9a }, { 0x36efbda3, 0x355696df }, { 0x3734b627, 0xb58d36a8 },
    { 0xb42411a9, 0xb69215cd }, { 0xb73d2156, 0xb7224271 }, { 0xb6c32a41, 0x37d8eade },
    { 0xb5f647d7, 0x362641f6 }, { 0x37436471, 0x36cc03c5 }, { 0xb72536fb, 0x3726f60c },
    { 0x374cf225, 0xb71b271c }, { 0x359071d4, 0x3790b3be }, { 0xb94862b9, 0xb9dff419 },
    { 0x39a591ad, 0x3a25c331 }, { 0x38c8553e, 0x3793678f }, { 0x39e5948e, 0xb8f0aa55 },
    { 0xba129ad0, 0x38c56f46 }, { 0xb9353300, 0xb7d0a3f8 }, { 0x393b3384, 0x398c4ed4 },
    { 0xb76a3ecd, 0xb7bd4879 }, { 0x39475371, 0x3a0c3551 }, { 0x380edc29, 0xb95e986e },
    { 0x385a7736, 0x381c08bd }, { 0xb8ff3045, 0xb94293b2 }, { 0xb9542bc5, 0x36a38abc },
    { 0xb911003d, 0x3910cb4c }, { 0xb81b0aaa, 0x3581e2a2 }, { 0xb9778fad, 0xb75ef4ff },
    { 0x37c8714e, 0x37a94eb6 }, { 0xb7c3f635, 0xb605d6d3 }, { 0x388343d5, 0xb836cd7c },
    { 0x38bdf3d0, 0xb7552730 }, { 0x360278ae, 0xb80d68a5 }, { 0x3648bec6, 0xb7fe3780 },
    { 0xb7af8329, 0xb86c52e7 }, { 0x37b7f81c, 0x37cf7544 }, { 0x38231c7f, 0xb8451150 },
    { 0x395efede, 0x3909b45a }, { 0x3946580f, 0x3957e6af }, { 0xb8e0e498, 0x38c04abc },
    { 0x38d650a7, 0xb7a15a39 }, { 0x389ce3bd, 0xb71f28b0 }, { 0xb8ac93a5, 0x38480374 },
    { 0xb83f80eb, 0xb910dc54 }, { 0xb8077649, 0x37891751 }, { 0xb8004154, 0xb91a123a },
    { 0x371a3157, 0xb88157fd }, { 0xb82dce6e, 0x379b3490 }, { 0x36e8981b, 0xb8976531 },
    { 0x362bce67, 0x383dbe80 }, { 0xb83a0c7a, 0xb7a8cbb6 }, { 0x3787b99c, 0xb786c0c2 },
    { 0x36f9d568, 0xb3896198 }, { 0x3731d625, 0xb5c35bd7 }, { 0xb49259fa, 0xb67bcdf6 },
    { 0xb7357073, 0xb714d40e }, { 0xb6ba961a, 0x37cdf04e }, { 0xb5d35f4b, 0x360fac99 },
    { 0x373456ac, 0x36b37260 }, { 0xb71f7089, 0x371e3128 }, { 0x37463f24, 0xb70c951c },
    { 0x35c2a708, 0x378c2823 }, { 0xb93c96ad, 0xb9d79136 }, { 0x399e865a, 0x3a1f1ae6 },
    { 0x38babbe8, 0x3780ffc4 }, { 0x39dbe20b, 0xb8e20750 }, { 0xba0b96ab, 0x38ba3165 },
    { 0xb927eb29, 0xb7b2db09 }, { 0x393211ba, 0x39892d61 }, { 0xb76ae715, 0xb7d742ef },
    { 0x3941a61e, 0x3a05f254 }, { 0x37f9ec92, 0xb95481ed }, { 0x385c87ca, 0x38262278 },
    { 0xb8f56db5, 0xb93d9982 }, { 0xb947ba85, 0x36999ec8 }, { 0xb908fca9, 0x39090426 },
    { 0xb808e422, 0x35fa4d5c }, { 0xb969bfe4, 0xb7565f64 }, { 0x37b59f46, 0x379f59be },
    { 0xb7b9a171, 0xb605c602 }, { 0x38740ab2, 0xb82cb46e }, { 0x38b1f91e, 0xb74be25e },
    { 0x359bbaee, 0xb808fe7c }, { 0x3666e235, 0xb7e4161d }, { 0xb7a8d331, 0xb86240ae },
    { 0x37b9ad13, 0x37ceeba3 }, { 0x3817fbfb, 0xb83cdd42 }, { 0x3957e036, 0x390432d0 },
    { 0x393f0f6c, 0x395000c6 }, { 0xb8d9d22c, 0x38b9dcba }, { 0x38d041b1, 0xb7a92bd4 },
    { 0x38974b89, 0xb721bab3 }, { 0xb8a64588, 0x383d2185 }, { 0xb837a00b, 0xb90ba0cf },
    { 0xb80436fc, 0x3786e439 }, { 0xb7f012da, 0xb9153dd2 }, { 0x370ee699, 0xb87d3edb },
    { 0xb828c34a, 0x379402aa }, { 0x36e38f88, 0xb8907a9c }, { 0x3606d785, 0x38370a11 },
    { 0xb832c19f, 0xb79da64a }, { 0x377d7a20, 0xb7772bce }, { 0x36ff0e58, 0xb5278633 },
    { 0x37305346, 0xb5eaea42 }, { 0xb50646f9, 0xb665db2f }, { 0xb72ff2de, 0xb70a88ea },
    { 0xb6b6fd54, 0x37c5251c }, { 0xb5b3985d, 0x35f338da }, { 0x3728d520, 0x369fb920 },
    { 0xb71b8278, 0x3718a52b }, { 0x3741b427, 0xb702315a }, { 0x35e328b6, 0x37897bcf },
    { 0xb931f7b3, 0xb9d09a7b }, { 0x399813fe, 0x3a1a1537 }, { 0x38acbf49, 0x37618c5a },
    { 0x39d52547, 0xb8d52ecf }, { 0xba065843, 0x38b01ce8 }, { 0xb91bde67, 0xb799f492 },
    { 0x392b12c9, 0x39867e32 }, { 0xb781f329, 0xb7f0e6f6 }, { 0x393d774d, 0x3a0101d1 },
    { 0x37d92b26, 0xb94ce8e1 }, { 0x3862b184, 0x38304434 }, { 0xb8eea5bf, 0xb9397223 },
    { 0xb93cd188, 0x36a60b9c }, { 0xb9024504, 0x39030776 }, { 0xb7f220b3, 0x362ec977 },
    { 0xb95f51b0, 0xb7540ade }, { 0x37a60c63, 0x379812e5 }, { 0xb7af340d, 0xb5fab1a1 },
    { 0x3863d472, 0xb8259c3a }, { 0x38a7e5ab, 0xb746ccb4 }, { 0x34141fa7, 0xb8064a0e },
    { 0x3688aa80, 0xb7cd7d15 }, { 0xb7a4d6bf, 0xb85ae914 }, { 0x37bedcac, 0x37d0b87d },
    { 0x380d9e41, 0xb8378526 }, { 0x3952c5bd, 0x38fff9b6 }, { 0x39391ab7, 0x394a1153 },
    { 0xb8d40488, 0x38b566f2 }, { 0x38cbadc0, 0xb7af951b }, { 0x38938c90, 0xb7253d96 },
    { 0xb8a12a7c, 0x3834c715 }, { 0xb8322cfb, 0xb907d918 }, { 0xb801dcac, 0x3785db35 },
    { 0xb7e501a6, 0xb9120620 }, { 0x370b1cce, 0xb87a6f11 }, { 0xb8257451, 0x378ec72c },
    { 0x36dea4c0, 0xb88b3ff0 }, { 0x35be546c, 0x3831bfbe }, { 0xb82cbade, 0xb7957967 },
    { 0x376ab884, 0xb7676d4c }, { 0x37034ea1, 0xb58ad581 }, { 0x372fe38f, 0xb606faa1 },
    { 0xb55028c0, 0xb65a7d9e }, { 0xb72d47a2, 0xb702cf72 }, { 0xb6b703f6, 0x37bee1b6 },
    { 0xb59e8bcf, 0x35cc0f34 }, { 0x371ffef5, 0x36905b2e }, { 0xb71790b4, 0x37160c16 },
    { 0x373e329c, 0xb6f7e6d5 }, { 0x35f68211, 0x37888ce9 }, { 0xb928b738, 0xb9cb900f },
    { 0x39916e90, 0x3a1618cc }, { 0x389f7ff1, 0x3741ba9f }, { 0x39d1046a, 0xb8c9d414 },
    { 0xba02ee3e, 0x38a6d0a7 }, { 0xb90ffd3e, 0xb7883c25 }, { 0x3925b341, 0x39849251 },
    { 0xb79b4a1b, 0xb8063b05 }, { 0x393b2caa, 0x39fb34b8 }, { 0x37b3eb86, 0xb9478077 },
    { 0x38704e29, 0x383a3f44 }, { 0xb8ea108a, 0xb9359622 }, { 0xb932ba42, 0x36bc9bc6 },
    { 0xb8f90bbe, 0x38fcedc1 }, { 0xb7d95972, 0x3640d5a4 }, { 0xb957dc6b, 0xb750c920 },
    { 0x3796335e, 0x37914e83 }, { 0xb7a188a0, 0xb5c8456e }, { 0x38560ae7, 0xb81fb567 },
    { 0x389f2e1b, 0xb7495a6c }, { 0xb5914be3, 0xb80472c3 }, { 0x36aa4a85, 0xb7b94f1d },
    { 0xb7a1f8cb, 0xb855cd03 }, { 0x37c6825a, 0x37d34fc5 }, { 0x38030958, 0xb83542bd },
    { 0x394f3847, 0x38fa2f98 }, { 0x39349541, 0x3945debf }, { 0xb8cfb17a, 0x38b22825 },
    { 0x38c885d1, 0xb7b5a085 }, { 0x3891167d, 0xb72c552e }, { 0xb89d264d, 0x382f3c16 },
    { 0xb82f83c6, 0xb9052c8c }, { 0xb7fe8c8f, 0x3784e0b8 }, { 0xb7dd3d35, 0xb9101f70 },
    { 0x370a9c2c, 0xb87a3f09 }, { 0xb824069d, 0x378b7534 }, { 0x36dbea90, 0xb8879416 },
    { 0x352036e4, 0x382dc983 }, { 0xb8288463, 0xb78fcba2 }, { 0x3758d92a, 0xb75ac7cd },
    { 0x3706f164, 0xb5c6bc78 }, { 0x3730d76a, 0xb61649c4 }, { 0xb58e3cb6, 0xb657f48e },
    { 0xb72c9cdf, 0xb6f9e1ca }, { 0xb6b87512, 0x37bbd3ac }, { 0xb5968cb2, 0x35ac648f },
    { 0x37190c0f, 0x3683e8fe }, { 0xb7144c0f, 0x37151adf }, { 0x373b8d91, 0xb6f110d2 },
    { 0x3600a2dc, 0x378968f4 }, { 0xb91fe860, 0xb9c8098c }, { 0x398c3c99, 0x3a132c74 },
    { 0x3893a8b0, 0x37301888 }, { 0x39cf2af7, 0xb8bfd35b }, { 0xba00e657, 0x389dbbcd },
    { 0xb9056fb8, 0xb774f978 }, { 0x39215a31, 0x3982cfde }, { 0xb7b8bee0, 0xb8134c0b },
    { 0x393a4d25, 0x39f6fe33 }, { 0x378e61cd, 0xb9447b80 }, { 0x387fff22, 0x3844dee0 },
    { 0xb8e7a6d4, 0xb93281d0 }, { 0xb92a367a, 0x36e3f8fd }, { 0xb8f09273, 0x38f5eb79 },
    { 0xb7c793fa, 0x362a2788 }, { 0xb9523bf6, 0xb74d5fcf }, { 0x37861bdf, 0x378902ff },
    { 0xb794a972, 0xb57486f2 }, { 0x384b98f6, 0xb819e36b }, { 0x38980a5a, 0xb75253ff },
    { 0xb6138a5e, 0xb80284c6 }, { 0x36d5c9f9, 0xb7a68bb5 }, { 0xb79fbf7d, 0xb851ebc1 },
    { 0x37ccacba, 0x37d52c42 }, { 0x37f46727, 0xb834ff85 }, { 0x394cfef4, 0x38f6a89a },
    { 0x3931ed49, 0x39432663 }, { 0xb8ccf00d, 0x38b00c7a }, { 0x38c6d6ed, 0xb7ba5461 },
    { 0x388fb863, 0xb737eb53 }, { 0xb89a1735, 0x382bbfb2 }, { 0xb82e28dd, 0xb903991c },
    { 0xb7fac277, 0x3784dac1 }, { 0xb7d5e35e, 0xb90f63d9 }, { 0x370b33c4, 0xb87bc8b8 },
    { 0xb8237105, 0x3789b56e }, { 0x36dae42f, 0xb8855b79 }, { 0xb49b48cd, 0x382aeebc },
    { 0xb82654a7, 0xb78c6479 }, { 0x3749bff4, 0xb750cd26 }, { 0x37082d30, 0xb5fd6ad4 },
    { 0x373370f6, 0xb6280092 }, { 0xb5b570ee, 0xb65a01ad }, { 0xb72bdec6, 0xb6ef88db },
    { 0xb6bb78b3, 0x37baf0a9 }, { 0xb598153a, 0x35913304 }, { 0x3714474f, 0x3670df9d },
    { 0xb712e7fa, 0x37155ba0 }, { 0x373a3a25, 0xb6ec28c0 }, { 0x36015173, 0x378b8956 },
    { 0xb9185beb, 0xb9c5b80e }, { 0x39894e26, 0x3a117ec5 }, { 0x388a1156, 0x37349fc3 },
    { 0x39cf08bf, 0xb8b793c3 }, { 0xb9ffce1c, 0x3895d686 }, { 0xb8fb0658, 0xb75e9fab },
    { 0x391e7711, 0x39812b00 }, { 0xb7d1a66f, 0xb81e96dd }, { 0x393a6255, 0x39f4ef0b },
    { 0x376031d5, 0xb9435046 }, { 0x38868384, 0x384f6d37 }, { 0xb8e76215, 0xb9306082 },
    { 0xb9241918, 0x370b4f9d }, { 0xb8eb99ad, 0x38f0796f }, { 0xb7b878f8, 0x35eefe1f },
    { 0xb94e0d00, 0xb74a1d67 }, { 0x37717540, 0x377eadb5 }, { 0xb78c9369, 0xb4b7f46d },
    { 0x38449129, 0xb8148fdb }, { 0x3892ac6d, 0xb75ca896 }, { 0xb64a4389, 0xb8001539 },
    { 0x36ff1da6, 0xb795ce33 }, { 0xb79de5c0, 0xb84f0e47 }, { 0x37d13926, 0x37d5d44a },
    { 0x37e886ae, 0xb8354029 }, { 0x390a9a33, 0x38a3e66d }, { 0x38f60b3c, 0x39074991 },
    { 0xb88aaa7e, 0x386f3709 }, { 0x388be258, 0xb78849fb }, { 0x383a4585, 0xb6f4d340 },
    { 0xb852cc7d, 0x37e803de }, { 0xb7e506b8, 0xb8b10c4d }, { 0xb7acc46a, 0x37356454 },
    { 0xb783b00d, 0xb8bfe094 }, { 0x36bd0e53, 0xb83270e8 }, { 0xb7dc43fb, 0x373f3605 },
    { 0x368046c7, 0xb83816e9 }, { 0xb5bad026, 0x37e964dd }, { 0xb7e63594, 0xb732d83e },
    { 0x3701d0fc, 0xb7081275 }, { 0x369897b3, 0xb5b67840 }, { 0x36fb5882, 0xb5fd1e84 },
    { 0xb5a08e90, 0xb615602e }, { 0xb6e37d50, 0xb6a474fb }, { 0xb670d763, 0x377dc372 },
    { 0xb5606c3e, 0x35073091 }, { 0x36c7cf2b, 0x360f70e0 }, { 0xb6cd9836, 0x36c5b487 },
    { 0x3701dbfd, 0xb69ba923 }, { 0x35b794f9, 0x373d4704 }, { 0xb8a3baaa, 0xb96f48a1 },
    { 0x393675a8, 0x39bfc2f4 }, { 0x3807c8e1, 0x3747f4f7 }, { 0x3987ac00, 0xb8633a8f },
    { 0xb99fe50b, 0x38369837 }, { 0xb8a3baeb, 0xb6ceebab }, { 0x38c5e6f7, 0x3919966e },
    { 0xb7a244f7, 0xb7d03710 }, { 0x38ee2502, 0x399697d1 }, { 0x370ab45b, 0xb90036c3 },
    { 0x3825967b, 0x380c6ca5 }, { 0xb89148be, 0xb8e70aff }, { 0xb8cd15d7, 0x3713a007 },
    { 0xb89974d6, 0x38931ec2 }, { 0xb74a20a6, 0xb39667b2 }, { 0xb900c96e, 0xb6fe785d },
    { 0x3719fc5f, 0x37151b55 }, { 0xb72ff052, 0xb412b58d }, { 0x37efe159, 0xb7bc430c },
    { 0x383331da, 0xb6f53837 }, { 0xb61e2027, 0xb79eee5c }, { 0x36c9564f, 0xb7278283 },
    { 0xb7530df9, 0xb8008e5f }, { 0x378e5522, 0x3785dd8c }, { 0x378ea5e8, 0xb7dce3bd }

};

#endif // MPEGCORE_DECMTX_H
