# This software module was originally developed by
#
# Fraunhofer IIS
#
# in the course of development of ISO/IEC 23090-4 for reference purposes
# and its performance may not have been optimized. This software module
# is an implementation of one or more tools as specified by the ISO/IEC
# 23090-4 standard. ISO/IEC gives you a royalty-free, worldwide,
# non-exclusive, copyright license to copy, distribute, and make
# derivative works of this software module or modifications thereof for
# use in implementations or products claiming conformance to ISO/IEC
# standards incorporating ISO/IEC 23090-4 reference software and which
# satisfy any specified conformance criteria of that standard.
#
# Those intending to use this software module in products are advised that
# its use may infringe existing patents and that the license in the
# previous paragraph grants no licenses under such patents. ISO/IEC and
# the developers of this software module have no liability for use of this
# software module or modifications thereof.
#
# Copyright is not released for products that do not conform to an ISO/IEC
# standard.
#
# Fraunhofer IIS retains full right to modify and use the code for its own
# purpose, assign or donate the code to a third party without consent of
# and without accounting to third parties, and to inhibit third parties
# from using the code for products that do not conform to MPEG-related
# ISO/IEC International Standards.
#
# This copyright notice must be included in all copies or derivative
# works.
#
# Copyright (c) ISO/IEC 2022.
"""Helper methods to serialize payloads."""

from ._airflowgenerator import serialize_airflow_generators as serialize_airflow_generators
from ._airflowgenerator import write_airflow_generators as write_airflow_generators
from ._anchors import serialize_anchors as serialize_anchors
from ._anchors import write_anchors as write_anchors
from ._channelsources import serialize_channel_sources as serialize_channel_sources
from ._channelsources import write_channel_sources as write_channel_sources
from ._directivities import serialize_direcitvities as serialize_direcitvities
from ._directivities import write_directivities as write_directivities
from ._environments import serialize_environments as serialize_environments
from ._environments import write_environments as write_environments
from ._granularsound import serialize_granular_sound as serialize_granular_sound
from ._granularsound import write_granular_sounds as write_granular_sounds
from ._hoagroups import serialize_hoa_groups as serialize_hoa_groups
from ._hoagroups import write_hoa_groups as write_hoa_groups
from ._hoasources import serialize_hoa_sources as serialize_hoa_sources
from ._hoasources import write_hoa_sources as write_hoa_sources
from ._materials import serialize_materials as serialize_materials
from ._materials import write_materials as write_materials
from ._meshes import serialize_meshes as serialize_meshes
from ._meshes import write_meshes as write_meshes
from ._objectsource import serialize_object_sources as serialize_object_sources
from ._objectsource import write_object_sources as write_object_sources
from ._primitives import serialize_primitives as serialize_primitives
from ._primitives import write_primitives as write_primitives
from ._streams import serialize_audio_streams as serialize_audio_streams
from ._streams import write_audio_streams as write_audio_streams
from ._transforms import serialize_transforms as serialize_transforms
from ._transforms import write_transforms as write_transforms
